#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 10
#define STATE_COUNT 2631
#define SYMBOL_COUNT 157
#define ALIAS_COUNT 1
#define TOKEN_COUNT 97
#define EXTERNAL_TOKEN_COUNT 15
#define FIELD_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 10

enum {
  sym_word = 1,
  anon_sym_LF = 2,
  anon_sym_for = 3,
  anon_sym_in = 4,
  anon_sym_LPAREN_LPAREN = 5,
  anon_sym_RPAREN_RPAREN = 6,
  anon_sym_SEMI = 7,
  anon_sym_while = 8,
  anon_sym_do = 9,
  anon_sym_done = 10,
  anon_sym_if = 11,
  anon_sym_then = 12,
  anon_sym_fi = 13,
  anon_sym_elif = 14,
  anon_sym_else = 15,
  anon_sym_case = 16,
  anon_sym_esac = 17,
  anon_sym_PIPE = 18,
  anon_sym_RPAREN = 19,
  anon_sym_SEMI_SEMI = 20,
  anon_sym_function = 21,
  anon_sym_LPAREN = 22,
  anon_sym_LBRACE = 23,
  anon_sym_RBRACE = 24,
  anon_sym_PIPE_AMP = 25,
  anon_sym_AMP_AMP = 26,
  anon_sym_PIPE_PIPE = 27,
  anon_sym_BANG = 28,
  anon_sym_LBRACK = 29,
  anon_sym_RBRACK = 30,
  anon_sym_LBRACK_LBRACK = 31,
  anon_sym_RBRACK_RBRACK = 32,
  anon_sym_declare = 33,
  anon_sym_typeset = 34,
  anon_sym_export = 35,
  anon_sym_readonly = 36,
  anon_sym_local = 37,
  anon_sym_unset = 38,
  anon_sym_unsetenv = 39,
  anon_sym_EQ_TILDE = 40,
  anon_sym_EQ_EQ = 41,
  anon_sym_EQ = 42,
  anon_sym_PLUS_EQ = 43,
  anon_sym_LT = 44,
  anon_sym_GT = 45,
  anon_sym_GT_GT = 46,
  anon_sym_AMP_GT = 47,
  anon_sym_AMP_GT_GT = 48,
  anon_sym_LT_AMP = 49,
  anon_sym_GT_AMP = 50,
  anon_sym_LT_LT = 51,
  anon_sym_LT_LT_DASH = 52,
  anon_sym_LT_LT_LT = 53,
  anon_sym_BANG_EQ = 54,
  anon_sym_PLUS = 55,
  anon_sym_DASH = 56,
  anon_sym_DASH_EQ = 57,
  anon_sym_LT_EQ = 58,
  anon_sym_GT_EQ = 59,
  anon_sym_PLUS_PLUS = 60,
  anon_sym_DASH_DASH = 61,
  anon_sym_DOLLAR = 62,
  sym__special_character = 63,
  anon_sym_DQUOTE = 64,
  sym__string_content = 65,
  sym_raw_string = 66,
  anon_sym_POUND = 67,
  anon_sym_DOLLAR_LBRACE = 68,
  anon_sym_SLASH = 69,
  anon_sym_COLON = 70,
  anon_sym_COLON_QMARK = 71,
  anon_sym_COLON_DASH = 72,
  anon_sym_PERCENT = 73,
  anon_sym_DOLLAR_LPAREN = 74,
  anon_sym_BQUOTE = 75,
  anon_sym_LT_LPAREN = 76,
  anon_sym_GT_LPAREN = 77,
  sym_comment = 78,
  aux_sym__simple_variable_name_token1 = 79,
  anon_sym_STAR = 80,
  anon_sym_AT = 81,
  anon_sym_QMARK = 82,
  anon_sym_0 = 83,
  anon_sym__ = 84,
  sym_test_operator = 85,
  anon_sym_AMP = 86,
  sym_heredoc_start = 87,
  sym__simple_heredoc_body = 88,
  sym__heredoc_body_beginning = 89,
  sym__heredoc_body_middle = 90,
  sym__heredoc_body_end = 91,
  sym_file_descriptor = 92,
  sym__empty_value = 93,
  sym__concat = 94,
  sym_variable_name = 95,
  sym_regex = 96,
  sym_program = 97,
  sym__statements = 98,
  aux_sym__statements2 = 99,
  sym__terminated_statement = 100,
  sym_redirected_statement = 101,
  sym_for_statement = 102,
  sym_c_style_for_statement = 103,
  sym_while_statement = 104,
  sym_do_group = 105,
  sym_if_statement = 106,
  sym_elif_clause = 107,
  sym_else_clause = 108,
  sym_case_statement = 109,
  sym_case_item = 110,
  sym_last_case_item = 111,
  sym_function_definition = 112,
  sym_compound_statement = 113,
  sym_subshell = 114,
  sym_pipeline = 115,
  sym_list = 116,
  sym_negated_command = 117,
  sym_test_command = 118,
  sym_declaration_command = 119,
  sym_unset_command = 120,
  sym_command = 121,
  sym_command_name = 122,
  sym_variable_assignment = 123,
  sym_subscript = 124,
  sym_file_redirect = 125,
  sym_heredoc_redirect = 126,
  sym_heredoc_body = 127,
  sym_herestring_redirect = 128,
  sym__expression = 129,
  sym_binary_expression = 130,
  sym_unary_expression = 131,
  sym_postfix_expression = 132,
  sym_parenthesized_expression = 133,
  sym_concatenation = 134,
  sym_string = 135,
  sym_array = 136,
  sym_simple_expansion = 137,
  sym_string_expansion = 138,
  sym_expansion = 139,
  sym_command_substitution = 140,
  sym_process_substitution = 141,
  aux_sym__statements_repeat1 = 142,
  aux_sym_redirected_statement_repeat1 = 143,
  aux_sym_for_statement_repeat1 = 144,
  aux_sym_if_statement_repeat1 = 145,
  aux_sym_case_statement_repeat1 = 146,
  aux_sym_case_item_repeat1 = 147,
  aux_sym_declaration_command_repeat1 = 148,
  aux_sym_unset_command_repeat1 = 149,
  aux_sym_command_repeat1 = 150,
  aux_sym_command_repeat2 = 151,
  aux_sym_heredoc_body_repeat1 = 152,
  aux_sym__literal_repeat1 = 153,
  aux_sym_concatenation_repeat1 = 154,
  aux_sym_string_repeat1 = 155,
  aux_sym_expansion_repeat1 = 156,
  alias_sym_special_variable_name = 157,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym_word] = "word",
  [anon_sym_LF] = "\n",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_LPAREN_LPAREN] = "((",
  [anon_sym_RPAREN_RPAREN] = "))",
  [anon_sym_SEMI] = ";",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_BANG] = "!",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACK_LBRACK] = "[[",
  [anon_sym_RBRACK_RBRACK] = "]]",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_unset] = "unset",
  [anon_sym_unsetenv] = "unsetenv",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_DOLLAR] = "$",
  [sym__special_character] = "_special_character",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_SLASH] = "/",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym__simple_variable_name_token1] = "variable_name",
  [anon_sym_STAR] = "special_variable_name",
  [anon_sym_AT] = "special_variable_name",
  [anon_sym_QMARK] = "special_variable_name",
  [anon_sym_0] = "special_variable_name",
  [anon_sym__] = "special_variable_name",
  [sym_test_operator] = "test_operator",
  [anon_sym_AMP] = "&",
  [sym_heredoc_start] = "heredoc_start",
  [sym__simple_heredoc_body] = "_simple_heredoc_body",
  [sym__heredoc_body_beginning] = "_heredoc_body_beginning",
  [sym__heredoc_body_middle] = "_heredoc_body_middle",
  [sym__heredoc_body_end] = "_heredoc_body_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [sym_regex] = "regex",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [aux_sym__statements2] = "_statements2",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_redirected_statement] = "redirected_statement",
  [sym_for_statement] = "for_statement",
  [sym_c_style_for_statement] = "c_style_for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_negated_command] = "negated_command",
  [sym_test_command] = "test_command",
  [sym_declaration_command] = "declaration_command",
  [sym_unset_command] = "unset_command",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc_body] = "heredoc_body",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_postfix_expression] = "postfix_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_string_expansion] = "string_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_redirected_statement_repeat1] = "redirected_statement_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_unset_command_repeat1] = "unset_command_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_command_repeat2] = "command_repeat2",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_repeat1] = "_literal_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_special_variable_name] = "special_variable_name",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsetenv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [sym__special_character] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__simple_variable_name_token1] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = true,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [sym_test_operator] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_heredoc_start] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_heredoc_body] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements2] = {
    .visible = false,
    .named = false,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_redirected_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_c_style_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_command] = {
    .visible = true,
    .named = true,
  },
  [sym_test_command] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym_unset_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_string_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_redirected_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_unset_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[8][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = sym_word,
  },
  [2] = {
    [1] = sym_word,
  },
  [3] = {
    [1] = alias_sym_special_variable_name,
  },
  [4] = {
    [2] = sym_word,
  },
  [5] = {
    [2] = alias_sym_special_variable_name,
  },
  [6] = {
    [3] = sym_word,
  },
  [7] = {
    [4] = sym_word,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(34);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(36);
      if (lookahead == '{')
        ADVANCE(37);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 8:
      if (lookahead == '\'')
        ADVANCE(40);
      if (lookahead != 0)
        ADVANCE(8);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(43);
      if (lookahead == '=')
        ADVANCE(44);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(46);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(48);
      if (lookahead == '?')
        ADVANCE(49);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(59);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      if (lookahead == '[')
        ADVANCE(61);
      END_STATE();
    case 24:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'n')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(66);
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 35:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(33);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(68);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_LPAREN_LPAREN);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_RPAREN_RPAREN);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(sym_test_operator);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(69);
      if (lookahead == '<')
        ADVANCE(70);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LBRACK_LBRACK);
      END_STATE();
    case 62:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(12);
      if (lookahead == '-')
        ADVANCE(13);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == '0')
        ADVANCE(15);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      if (lookahead == '>')
        ADVANCE(20);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(24);
      if (lookahead == ']')
        ADVANCE(25);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == 'i')
        ADVANCE(29);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(62);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_RBRACK_RBRACK);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 73:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(73);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(75);
      END_STATE();
    case 76:
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 78:
      if (lookahead == ';')
        ADVANCE(50);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '(')
        ADVANCE(58);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 81:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym__special_character);
      END_STATE();
    case 83:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(81);
      if (lookahead == ']' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(83);
      if (lookahead != 0 &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 84:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(86);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(87);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0 &&
          lookahead != ';')
        ADVANCE(33);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 86:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(84);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 88:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(88);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '\\')
        ADVANCE(91);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '(')
        ADVANCE(52);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 91:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 93:
      if (lookahead == '\n')
        ADVANCE(89);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(91);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(93);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 94:
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(107);
      if (lookahead == ']')
        ADVANCE(108);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(112);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 97:
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+')
        ADVANCE(113);
      if (lookahead == '=')
        ADVANCE(114);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-')
        ADVANCE(115);
      if (lookahead == '=')
        ADVANCE(116);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(117);
      if (lookahead == '~')
        ADVANCE(118);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(59);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 107:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(94);
      END_STATE();
    case 108:
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 119:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(119);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '\\')
        ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == '~')
        ADVANCE(56);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          (lookahead < ';' || '>' < lookahead) &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 122:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        ADVANCE(120);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(122);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(123);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 124:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(125);
      if (lookahead == ']')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 125:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(124);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 126:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ')')
        ADVANCE(127);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(131);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0 &&
          lookahead != '&' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 127:
      if (lookahead == ')')
        ADVANCE(42);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(47);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 129:
      if (lookahead == '(')
        ADVANCE(52);
      END_STATE();
    case 130:
      if (lookahead == '(')
        ADVANCE(58);
      END_STATE();
    case 131:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(126);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 132:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(133);
      if (lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 133:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(132);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 134:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '+')
        ADVANCE(135);
      if (lookahead == '=')
        ADVANCE(136);
      if (lookahead == '[')
        ADVANCE(137);
      if (lookahead == '\\')
        SKIP(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 135:
      if (lookahead == '=')
        ADVANCE(114);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 138:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(134);
      END_STATE();
    case 139:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '(')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(141);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(143);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 140:
      if (lookahead == '(')
        ADVANCE(41);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(60);
      END_STATE();
    case 143:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      END_STATE();
    case 144:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(145);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead == '\\')
        ADVANCE(149);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(145);
      END_STATE();
    case 146:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(145);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(146);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(147);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(150);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '\n')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(145);
      END_STATE();
    case 150:
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 151:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(154);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(152);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(53);
      END_STATE();
    case 154:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(151);
      END_STATE();
    case 155:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(155);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '\\')
        ADVANCE(157);
      END_STATE();
    case 157:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        ADVANCE(156);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(157);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(158);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 159:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '/')
        ADVANCE(14);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(162);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          (lookahead < '{' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 162:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 163:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '[' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(165);
      if (lookahead == ']')
        ADVANCE(166);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 164:
      if (lookahead == '=')
        ADVANCE(112);
      END_STATE();
    case 165:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym__special_character);
      if (lookahead == ']')
        ADVANCE(63);
      END_STATE();
    case 167:
      if (lookahead == '|')
        ADVANCE(67);
      END_STATE();
    case 168:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '\\')
        SKIP(169);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      END_STATE();
    case 169:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      END_STATE();
    case 170:
      if (lookahead == 's')
        ADVANCE(171);
      END_STATE();
    case 171:
      if (lookahead == 'a')
        ADVANCE(172);
      END_STATE();
    case 172:
      if (lookahead == 'c')
        ADVANCE(173);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 174:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(176);
      if (lookahead == 'i')
        ADVANCE(177);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 176:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      END_STATE();
    case 177:
      if (lookahead == 'n')
        ADVANCE(178);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 179:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(127);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '\\')
        SKIP(180);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      END_STATE();
    case 180:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      END_STATE();
    case 181:
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 184:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (lookahead != 0)
        ADVANCE(148);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        ADVANCE(184);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(185);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '`')
        ADVANCE(148);
      END_STATE();
    case 186:
      if (lookahead == '\n')
        ADVANCE(187);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(188);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(187);
      if (lookahead == '-')
        ADVANCE(128);
      if (lookahead == '\\')
        ADVANCE(188);
      END_STATE();
    case 188:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(186);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 189:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(190);
      if (lookahead == ']')
        ADVANCE(191);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(189);
      END_STATE();
    case 190:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(189);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 192:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == ']')
        ADVANCE(108);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      END_STATE();
    case 193:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(195);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 195:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 196:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(197);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 197:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(196);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 198:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '\\')
        SKIP(199);
      if (lookahead == 'i')
        ADVANCE(177);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      END_STATE();
    case 199:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(198);
      END_STATE();
    case 200:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      END_STATE();
    case 201:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(200);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        ADVANCE(203);
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(205);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(203);
      if (lookahead == '-')
        ADVANCE(100);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(38);
      END_STATE();
    case 205:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(202);
      END_STATE();
    case 206:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(206);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '\\')
        ADVANCE(209);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_0);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 209:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        ADVANCE(207);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(209);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 212:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(213);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 213:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(212);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 214:
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(215);
      if (lookahead == ']')
        ADVANCE(191);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 215:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(214);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        ADVANCE(217);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(218);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(217);
      if (lookahead == '\\')
        ADVANCE(218);
      END_STATE();
    case 218:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 219:
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == ';')
        ADVANCE(220);
      if (lookahead == '\\')
        ADVANCE(221);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          lookahead != '`' &&
          lookahead != '|' &&
          lookahead != '}')
        ADVANCE(33);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 221:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 222:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(78);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[')
        ADVANCE(23);
      if (lookahead == '\\')
        ADVANCE(223);
      if (lookahead == ']' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '{')
        ADVANCE(30);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (lookahead != 0 &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 223:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(222);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(225);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      END_STATE();
    case 225:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(224);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      END_STATE();
    case 227:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(226);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        ADVANCE(229);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(85);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(230);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (lookahead != 0 &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(229);
      if (lookahead == '\\')
        ADVANCE(230);
      END_STATE();
    case 230:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(228);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(232);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 232:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(231);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        ADVANCE(234);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(235);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(234);
      if (lookahead == '\\')
        ADVANCE(235);
      END_STATE();
    case 235:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(233);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 's')
        ADVANCE(237);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'a')
        ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == '\\')
        ADVANCE(35);
      if (lookahead == 'c')
        ADVANCE(239);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '"' || '$' < lookahead) &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || ']' < lookahead) &&
          (lookahead < '`' || '}' < lookahead))
        ADVANCE(33);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '\\')
        SKIP(241);
      if (lookahead == 'e')
        ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      END_STATE();
    case 241:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      END_STATE();
    case 242:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(76);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == '<')
        ADVANCE(79);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 243:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(246);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(28);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(245);
      if (lookahead == '\\')
        ADVANCE(246);
      END_STATE();
    case 246:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(248);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(249);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(248);
      if (lookahead == '\\')
        ADVANCE(249);
      END_STATE();
    case 249:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        ADVANCE(248);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(249);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(')
        ADVANCE(33);
      END_STATE();
    case 251:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == 'i')
        ADVANCE(253);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 252:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(251);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'n')
        ADVANCE(254);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(anon_sym_in);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 255:
      if (lookahead == '!')
        ADVANCE(164);
      if (lookahead == '#')
        ADVANCE(75);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == ')')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '[' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        SKIP(256);
      if (lookahead == ']')
        ADVANCE(166);
      if (lookahead == '|')
        ADVANCE(110);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      END_STATE();
    case 256:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      END_STATE();
    case 257:
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(97);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == ']')
        ADVANCE(191);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 258:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ':')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '=')
        ADVANCE(161);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(260);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < '&' || ')' < lookahead) &&
          lookahead != ';' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 260:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        ADVANCE(203);
      if (lookahead == '!')
        ADVANCE(95);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(204);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '+')
        ADVANCE(99);
      if (lookahead == '-')
        ADVANCE(100);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(102);
      if (lookahead == '=')
        ADVANCE(103);
      if (lookahead == '>')
        ADVANCE(104);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(262);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '|')
        ADVANCE(167);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 262:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      END_STATE();
    case 263:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == ')')
        ADVANCE(77);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      END_STATE();
    case 265:
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(266);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == '}')
        ADVANCE(32);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 266:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(265);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        ADVANCE(268);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(129);
      if (lookahead == '>')
        ADVANCE(130);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(269);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(267);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')' &&
          lookahead != '|')
        ADVANCE(33);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(268);
      if (lookahead == '\\')
        ADVANCE(269);
      END_STATE();
    case 269:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(267);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        ADVANCE(271);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(272);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(271);
      if (lookahead == '\\')
        ADVANCE(272);
      END_STATE();
    case 272:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(270);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '!')
        ADVANCE(74);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(160);
      if (lookahead == '0')
        ADVANCE(208);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(90);
      if (lookahead == '>')
        ADVANCE(80);
      if (lookahead == '?')
        ADVANCE(21);
      if (lookahead == '@')
        ADVANCE(22);
      if (lookahead == '[' ||
          lookahead == ']' ||
          lookahead == '{' ||
          lookahead == '}')
        ADVANCE(82);
      if (lookahead == '\\')
        ADVANCE(275);
      if (lookahead == '_')
        ADVANCE(210);
      if (lookahead == '`')
        ADVANCE(27);
      if (lookahead == 'e')
        ADVANCE(236);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          lookahead != '(' &&
          lookahead != ')')
        ADVANCE(33);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(anon_sym_LF);
      if (lookahead == '\n')
        ADVANCE(274);
      if (lookahead == '\\')
        ADVANCE(275);
      END_STATE();
    case 275:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      if (lookahead != 0)
        ADVANCE(33);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '!')
        ADVANCE(182);
      if (lookahead == '"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(96);
      if (lookahead == '&')
        ADVANCE(7);
      if (lookahead == '\'')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(98);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '0')
        ADVANCE(101);
      if (lookahead == ';')
        ADVANCE(17);
      if (lookahead == '<')
        ADVANCE(153);
      if (lookahead == '>')
        ADVANCE(142);
      if (lookahead == '?')
        ADVANCE(105);
      if (lookahead == '@')
        ADVANCE(106);
      if (lookahead == '\\')
        SKIP(277);
      if (lookahead == '_')
        ADVANCE(109);
      if (lookahead == 'e')
        ADVANCE(278);
      if (lookahead == '|')
        ADVANCE(31);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 277:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(276);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 's')
        ADVANCE(279);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'a')
        ADVANCE(280);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym__simple_variable_name_token1);
      if (lookahead == 'c')
        ADVANCE(281);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_esac);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(111);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '\\')
        SKIP(1);
      if (lookahead == 'c')
        ADVANCE(2);
      if (lookahead == 'd')
        ADVANCE(3);
      if (lookahead == 'e')
        ADVANCE(4);
      if (lookahead == 'f')
        ADVANCE(5);
      if (lookahead == 'i')
        ADVANCE(6);
      if (lookahead == 'l')
        ADVANCE(7);
      if (lookahead == 'r')
        ADVANCE(8);
      if (lookahead == 't')
        ADVANCE(9);
      if (lookahead == 'u')
        ADVANCE(10);
      if (lookahead == 'w')
        ADVANCE(11);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 1:
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      END_STATE();
    case 2:
      if (lookahead == 'a')
        ADVANCE(12);
      END_STATE();
    case 3:
      if (lookahead == 'e')
        ADVANCE(13);
      if (lookahead == 'o')
        ADVANCE(14);
      END_STATE();
    case 4:
      if (lookahead == 'l')
        ADVANCE(15);
      if (lookahead == 'x')
        ADVANCE(16);
      END_STATE();
    case 5:
      if (lookahead == 'i')
        ADVANCE(17);
      if (lookahead == 'o')
        ADVANCE(18);
      if (lookahead == 'u')
        ADVANCE(19);
      END_STATE();
    case 6:
      if (lookahead == 'f')
        ADVANCE(20);
      END_STATE();
    case 7:
      if (lookahead == 'o')
        ADVANCE(21);
      END_STATE();
    case 8:
      if (lookahead == 'e')
        ADVANCE(22);
      END_STATE();
    case 9:
      if (lookahead == 'h')
        ADVANCE(23);
      if (lookahead == 'y')
        ADVANCE(24);
      END_STATE();
    case 10:
      if (lookahead == 'n')
        ADVANCE(25);
      END_STATE();
    case 11:
      if (lookahead == 'h')
        ADVANCE(26);
      END_STATE();
    case 12:
      if (lookahead == 's')
        ADVANCE(27);
      END_STATE();
    case 13:
      if (lookahead == 'c')
        ADVANCE(28);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'n')
        ADVANCE(29);
      END_STATE();
    case 15:
      if (lookahead == 'i')
        ADVANCE(30);
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 16:
      if (lookahead == 'p')
        ADVANCE(32);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 18:
      if (lookahead == 'r')
        ADVANCE(33);
      END_STATE();
    case 19:
      if (lookahead == 'n')
        ADVANCE(34);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 21:
      if (lookahead == 'c')
        ADVANCE(35);
      END_STATE();
    case 22:
      if (lookahead == 'a')
        ADVANCE(36);
      END_STATE();
    case 23:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 24:
      if (lookahead == 'p')
        ADVANCE(38);
      END_STATE();
    case 25:
      if (lookahead == 's')
        ADVANCE(39);
      END_STATE();
    case 26:
      if (lookahead == 'i')
        ADVANCE(40);
      END_STATE();
    case 27:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 28:
      if (lookahead == 'l')
        ADVANCE(42);
      END_STATE();
    case 29:
      if (lookahead == 'e')
        ADVANCE(43);
      END_STATE();
    case 30:
      if (lookahead == 'f')
        ADVANCE(44);
      END_STATE();
    case 31:
      if (lookahead == 'e')
        ADVANCE(45);
      END_STATE();
    case 32:
      if (lookahead == 'o')
        ADVANCE(46);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 34:
      if (lookahead == 'c')
        ADVANCE(47);
      END_STATE();
    case 35:
      if (lookahead == 'a')
        ADVANCE(48);
      END_STATE();
    case 36:
      if (lookahead == 'd')
        ADVANCE(49);
      END_STATE();
    case 37:
      if (lookahead == 'n')
        ADVANCE(50);
      END_STATE();
    case 38:
      if (lookahead == 'e')
        ADVANCE(51);
      END_STATE();
    case 39:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 40:
      if (lookahead == 'l')
        ADVANCE(53);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 42:
      if (lookahead == 'a')
        ADVANCE(54);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_done);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 46:
      if (lookahead == 'r')
        ADVANCE(55);
      END_STATE();
    case 47:
      if (lookahead == 't')
        ADVANCE(56);
      END_STATE();
    case 48:
      if (lookahead == 'l')
        ADVANCE(57);
      END_STATE();
    case 49:
      if (lookahead == 'o')
        ADVANCE(58);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 51:
      if (lookahead == 's')
        ADVANCE(59);
      END_STATE();
    case 52:
      if (lookahead == 't')
        ADVANCE(60);
      END_STATE();
    case 53:
      if (lookahead == 'e')
        ADVANCE(61);
      END_STATE();
    case 54:
      if (lookahead == 'r')
        ADVANCE(62);
      END_STATE();
    case 55:
      if (lookahead == 't')
        ADVANCE(63);
      END_STATE();
    case 56:
      if (lookahead == 'i')
        ADVANCE(64);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_local);
      END_STATE();
    case 58:
      if (lookahead == 'n')
        ADVANCE(65);
      END_STATE();
    case 59:
      if (lookahead == 'e')
        ADVANCE(66);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_unset);
      if (lookahead == 'e')
        ADVANCE(67);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 62:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_export);
      END_STATE();
    case 64:
      if (lookahead == 'o')
        ADVANCE(69);
      END_STATE();
    case 65:
      if (lookahead == 'l')
        ADVANCE(70);
      END_STATE();
    case 66:
      if (lookahead == 't')
        ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'n')
        ADVANCE(72);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_declare);
      END_STATE();
    case 69:
      if (lookahead == 'n')
        ADVANCE(73);
      END_STATE();
    case 70:
      if (lookahead == 'y')
        ADVANCE(74);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_typeset);
      END_STATE();
    case 72:
      if (lookahead == 'v')
        ADVANCE(75);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_function);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_unsetenv);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 73, .external_lex_state = 2},
  [2] = {.lex_state = 73, .external_lex_state = 2},
  [3] = {.lex_state = 84},
  [4] = {.lex_state = 88, .external_lex_state = 3},
  [5] = {.lex_state = 88, .external_lex_state = 4},
  [6] = {.lex_state = 94},
  [7] = {.lex_state = 73, .external_lex_state = 2},
  [8] = {.lex_state = 73, .external_lex_state = 2},
  [9] = {.lex_state = 94, .external_lex_state = 5},
  [10] = {.lex_state = 84},
  [11] = {.lex_state = 119, .external_lex_state = 6},
  [12] = {.lex_state = 124, .external_lex_state = 7},
  [13] = {.lex_state = 119, .external_lex_state = 6},
  [14] = {.lex_state = 73, .external_lex_state = 2},
  [15] = {.lex_state = 84},
  [16] = {.lex_state = 126},
  [17] = {.lex_state = 119, .external_lex_state = 6},
  [18] = {.lex_state = 73, .external_lex_state = 2},
  [19] = {.lex_state = 132, .external_lex_state = 2},
  [20] = {.lex_state = 134},
  [21] = {.lex_state = 139},
  [22] = {.lex_state = 144},
  [23] = {.lex_state = 139},
  [24] = {.lex_state = 73, .external_lex_state = 2},
  [25] = {.lex_state = 126},
  [26] = {.lex_state = 126},
  [27] = {.lex_state = 119, .external_lex_state = 4},
  [28] = {.lex_state = 151, .external_lex_state = 4},
  [29] = {.lex_state = 155, .external_lex_state = 3},
  [30] = {.lex_state = 134},
  [31] = {.lex_state = 119, .external_lex_state = 4},
  [32] = {.lex_state = 73, .external_lex_state = 2},
  [33] = {.lex_state = 73},
  [34] = {.lex_state = 84, .external_lex_state = 2},
  [35] = {.lex_state = 73},
  [36] = {.lex_state = 119, .external_lex_state = 4},
  [37] = {.lex_state = 73},
  [38] = {.lex_state = 84, .external_lex_state = 8},
  [39] = {.lex_state = 84, .external_lex_state = 2},
  [40] = {.lex_state = 84, .external_lex_state = 2},
  [41] = {.lex_state = 88, .external_lex_state = 9},
  [42] = {.lex_state = 88, .external_lex_state = 3},
  [43] = {.lex_state = 88, .external_lex_state = 3},
  [44] = {.lex_state = 88, .external_lex_state = 6},
  [45] = {.lex_state = 88, .external_lex_state = 4},
  [46] = {.lex_state = 88, .external_lex_state = 4},
  [47] = {.lex_state = 119, .external_lex_state = 6},
  [48] = {.lex_state = 119, .external_lex_state = 6},
  [49] = {.lex_state = 119, .external_lex_state = 6},
  [50] = {.lex_state = 73},
  [51] = {.lex_state = 84, .external_lex_state = 2},
  [52] = {.lex_state = 73},
  [53] = {.lex_state = 159, .external_lex_state = 10},
  [54] = {.lex_state = 163, .external_lex_state = 5},
  [55] = {.lex_state = 134},
  [56] = {.lex_state = 159, .external_lex_state = 10},
  [57] = {.lex_state = 168},
  [58] = {.lex_state = 73},
  [59] = {.lex_state = 84},
  [60] = {.lex_state = 119, .external_lex_state = 6},
  [61] = {.lex_state = 151, .external_lex_state = 4},
  [62] = {.lex_state = 151, .external_lex_state = 4},
  [63] = {.lex_state = 155, .external_lex_state = 3},
  [64] = {.lex_state = 124, .external_lex_state = 7},
  [65] = {.lex_state = 84},
  [66] = {.lex_state = 151, .external_lex_state = 4},
  [67] = {.lex_state = 155, .external_lex_state = 3},
  [68] = {.lex_state = 174, .external_lex_state = 11},
  [69] = {.lex_state = 174, .external_lex_state = 12},
  [70] = {.lex_state = 174, .external_lex_state = 12},
  [71] = {.lex_state = 126},
  [72] = {.lex_state = 126},
  [73] = {.lex_state = 163, .external_lex_state = 13},
  [74] = {.lex_state = 163},
  [75] = {.lex_state = 179},
  [76] = {.lex_state = 73},
  [77] = {.lex_state = 151, .external_lex_state = 4},
  [78] = {.lex_state = 84, .external_lex_state = 14},
  [79] = {.lex_state = 84},
  [80] = {.lex_state = 84},
  [81] = {.lex_state = 181},
  [82] = {.lex_state = 119, .external_lex_state = 6},
  [83] = {.lex_state = 144, .external_lex_state = 13},
  [84] = {.lex_state = 144},
  [85] = {.lex_state = 174, .external_lex_state = 12},
  [86] = {.lex_state = 186, .external_lex_state = 12},
  [87] = {.lex_state = 84},
  [88] = {.lex_state = 189, .external_lex_state = 15},
  [89] = {.lex_state = 192},
  [90] = {.lex_state = 119, .external_lex_state = 4},
  [91] = {.lex_state = 119, .external_lex_state = 4},
  [92] = {.lex_state = 73, .external_lex_state = 2},
  [93] = {.lex_state = 73, .external_lex_state = 16},
  [94] = {.lex_state = 73, .external_lex_state = 2},
  [95] = {.lex_state = 73, .external_lex_state = 17},
  [96] = {.lex_state = 73, .external_lex_state = 2},
  [97] = {.lex_state = 84},
  [98] = {.lex_state = 151, .external_lex_state = 4},
  [99] = {.lex_state = 151, .external_lex_state = 4},
  [100] = {.lex_state = 155, .external_lex_state = 3},
  [101] = {.lex_state = 73, .external_lex_state = 2},
  [102] = {.lex_state = 119, .external_lex_state = 4},
  [103] = {.lex_state = 84, .external_lex_state = 2},
  [104] = {.lex_state = 119, .external_lex_state = 6},
  [105] = {.lex_state = 84, .external_lex_state = 18},
  [106] = {.lex_state = 119, .external_lex_state = 4},
  [107] = {.lex_state = 119, .external_lex_state = 4},
  [108] = {.lex_state = 151, .external_lex_state = 4},
  [109] = {.lex_state = 88, .external_lex_state = 3},
  [110] = {.lex_state = 88, .external_lex_state = 4},
  [111] = {.lex_state = 119, .external_lex_state = 6},
  [112] = {.lex_state = 119, .external_lex_state = 6},
  [113] = {.lex_state = 194, .external_lex_state = 19},
  [114] = {.lex_state = 194, .external_lex_state = 20},
  [115] = {.lex_state = 119, .external_lex_state = 6},
  [116] = {.lex_state = 194, .external_lex_state = 10},
  [117] = {.lex_state = 194, .external_lex_state = 10},
  [118] = {.lex_state = 159, .external_lex_state = 10},
  [119] = {.lex_state = 134},
  [120] = {.lex_state = 159, .external_lex_state = 10},
  [121] = {.lex_state = 196, .external_lex_state = 10},
  [122] = {.lex_state = 194, .external_lex_state = 19},
  [123] = {.lex_state = 119, .external_lex_state = 6},
  [124] = {.lex_state = 194, .external_lex_state = 10},
  [125] = {.lex_state = 73},
  [126] = {.lex_state = 151, .external_lex_state = 4},
  [127] = {.lex_state = 73},
  [128] = {.lex_state = 119, .external_lex_state = 6},
  [129] = {.lex_state = 84},
  [130] = {.lex_state = 119, .external_lex_state = 6},
  [131] = {.lex_state = 124, .external_lex_state = 7},
  [132] = {.lex_state = 124, .external_lex_state = 21},
  [133] = {.lex_state = 151, .external_lex_state = 4},
  [134] = {.lex_state = 73, .external_lex_state = 2},
  [135] = {.lex_state = 84},
  [136] = {.lex_state = 198},
  [137] = {.lex_state = 174, .external_lex_state = 12},
  [138] = {.lex_state = 198},
  [139] = {.lex_state = 174, .external_lex_state = 12},
  [140] = {.lex_state = 163},
  [141] = {.lex_state = 200},
  [142] = {.lex_state = 126},
  [143] = {.lex_state = 163},
  [144] = {.lex_state = 126, .external_lex_state = 18},
  [145] = {.lex_state = 151, .external_lex_state = 4},
  [146] = {.lex_state = 119, .external_lex_state = 6},
  [147] = {.lex_state = 84},
  [148] = {.lex_state = 155, .external_lex_state = 9},
  [149] = {.lex_state = 155, .external_lex_state = 3},
  [150] = {.lex_state = 155, .external_lex_state = 3},
  [151] = {.lex_state = 189, .external_lex_state = 22},
  [152] = {.lex_state = 189, .external_lex_state = 22},
  [153] = {.lex_state = 189, .external_lex_state = 22},
  [154] = {.lex_state = 84, .external_lex_state = 8},
  [155] = {.lex_state = 84, .external_lex_state = 2},
  [156] = {.lex_state = 84, .external_lex_state = 2},
  [157] = {.lex_state = 119, .external_lex_state = 6},
  [158] = {.lex_state = 144, .external_lex_state = 13},
  [159] = {.lex_state = 144},
  [160] = {.lex_state = 181},
  [161] = {.lex_state = 144},
  [162] = {.lex_state = 84},
  [163] = {.lex_state = 84},
  [164] = {.lex_state = 186, .external_lex_state = 12},
  [165] = {.lex_state = 202, .external_lex_state = 12},
  [166] = {.lex_state = 73, .external_lex_state = 2},
  [167] = {.lex_state = 151, .external_lex_state = 4},
  [168] = {.lex_state = 151, .external_lex_state = 4},
  [169] = {.lex_state = 155, .external_lex_state = 3},
  [170] = {.lex_state = 174, .external_lex_state = 12},
  [171] = {.lex_state = 73, .external_lex_state = 23},
  [172] = {.lex_state = 174, .external_lex_state = 12},
  [173] = {.lex_state = 151, .external_lex_state = 4},
  [174] = {.lex_state = 151, .external_lex_state = 4},
  [175] = {.lex_state = 155, .external_lex_state = 3},
  [176] = {.lex_state = 151, .external_lex_state = 6},
  [177] = {.lex_state = 151, .external_lex_state = 4},
  [178] = {.lex_state = 151, .external_lex_state = 4},
  [179] = {.lex_state = 151, .external_lex_state = 4},
  [180] = {.lex_state = 73, .external_lex_state = 2},
  [181] = {.lex_state = 73, .external_lex_state = 16},
  [182] = {.lex_state = 119, .external_lex_state = 4},
  [183] = {.lex_state = 119, .external_lex_state = 6},
  [184] = {.lex_state = 119, .external_lex_state = 4},
  [185] = {.lex_state = 119, .external_lex_state = 4},
  [186] = {.lex_state = 119, .external_lex_state = 4},
  [187] = {.lex_state = 119, .external_lex_state = 6},
  [188] = {.lex_state = 194, .external_lex_state = 10},
  [189] = {.lex_state = 194, .external_lex_state = 10},
  [190] = {.lex_state = 194, .external_lex_state = 10},
  [191] = {.lex_state = 194, .external_lex_state = 19},
  [192] = {.lex_state = 196, .external_lex_state = 10},
  [193] = {.lex_state = 194, .external_lex_state = 19},
  [194] = {.lex_state = 119, .external_lex_state = 6},
  [195] = {.lex_state = 194, .external_lex_state = 10},
  [196] = {.lex_state = 124, .external_lex_state = 20},
  [197] = {.lex_state = 139, .external_lex_state = 10},
  [198] = {.lex_state = 124, .external_lex_state = 10},
  [199] = {.lex_state = 119, .external_lex_state = 6},
  [200] = {.lex_state = 194, .external_lex_state = 10},
  [201] = {.lex_state = 194, .external_lex_state = 10},
  [202] = {.lex_state = 73},
  [203] = {.lex_state = 151, .external_lex_state = 4},
  [204] = {.lex_state = 206, .external_lex_state = 4},
  [205] = {.lex_state = 174, .external_lex_state = 12},
  [206] = {.lex_state = 73, .external_lex_state = 2},
  [207] = {.lex_state = 151, .external_lex_state = 4},
  [208] = {.lex_state = 73, .external_lex_state = 2},
  [209] = {.lex_state = 151, .external_lex_state = 4},
  [210] = {.lex_state = 155, .external_lex_state = 3},
  [211] = {.lex_state = 84},
  [212] = {.lex_state = 84},
  [213] = {.lex_state = 73, .external_lex_state = 2},
  [214] = {.lex_state = 174, .external_lex_state = 12},
  [215] = {.lex_state = 212},
  [216] = {.lex_state = 174, .external_lex_state = 12},
  [217] = {.lex_state = 212},
  [218] = {.lex_state = 163},
  [219] = {.lex_state = 163},
  [220] = {.lex_state = 163},
  [221] = {.lex_state = 84, .external_lex_state = 13},
  [222] = {.lex_state = 155, .external_lex_state = 3},
  [223] = {.lex_state = 84},
  [224] = {.lex_state = 84},
  [225] = {.lex_state = 134, .external_lex_state = 13},
  [226] = {.lex_state = 214, .external_lex_state = 15},
  [227] = {.lex_state = 134, .external_lex_state = 13},
  [228] = {.lex_state = 189, .external_lex_state = 15},
  [229] = {.lex_state = 189, .external_lex_state = 15},
  [230] = {.lex_state = 144},
  [231] = {.lex_state = 119, .external_lex_state = 6},
  [232] = {.lex_state = 181},
  [233] = {.lex_state = 216, .external_lex_state = 12},
  [234] = {.lex_state = 151, .external_lex_state = 4},
  [235] = {.lex_state = 126},
  [236] = {.lex_state = 202, .external_lex_state = 12},
  [237] = {.lex_state = 186, .external_lex_state = 12},
  [238] = {.lex_state = 151, .external_lex_state = 4},
  [239] = {.lex_state = 73, .external_lex_state = 2},
  [240] = {.lex_state = 94},
  [241] = {.lex_state = 174, .external_lex_state = 12},
  [242] = {.lex_state = 73, .external_lex_state = 23},
  [243] = {.lex_state = 73, .external_lex_state = 2},
  [244] = {.lex_state = 174, .external_lex_state = 12},
  [245] = {.lex_state = 119, .external_lex_state = 6},
  [246] = {.lex_state = 194, .external_lex_state = 10},
  [247] = {.lex_state = 194, .external_lex_state = 10},
  [248] = {.lex_state = 124, .external_lex_state = 20},
  [249] = {.lex_state = 139, .external_lex_state = 10},
  [250] = {.lex_state = 124, .external_lex_state = 10},
  [251] = {.lex_state = 119, .external_lex_state = 6},
  [252] = {.lex_state = 194, .external_lex_state = 10},
  [253] = {.lex_state = 194, .external_lex_state = 10},
  [254] = {.lex_state = 119, .external_lex_state = 6},
  [255] = {.lex_state = 119, .external_lex_state = 6},
  [256] = {.lex_state = 194, .external_lex_state = 10},
  [257] = {.lex_state = 151, .external_lex_state = 4},
  [258] = {.lex_state = 124, .external_lex_state = 7},
  [259] = {.lex_state = 73, .external_lex_state = 2},
  [260] = {.lex_state = 84},
  [261] = {.lex_state = 73, .external_lex_state = 16},
  [262] = {.lex_state = 73, .external_lex_state = 2},
  [263] = {.lex_state = 151, .external_lex_state = 4},
  [264] = {.lex_state = 84},
  [265] = {.lex_state = 84},
  [266] = {.lex_state = 84},
  [267] = {.lex_state = 73, .external_lex_state = 2},
  [268] = {.lex_state = 212},
  [269] = {.lex_state = 84, .external_lex_state = 13},
  [270] = {.lex_state = 151, .external_lex_state = 4},
  [271] = {.lex_state = 84},
  [272] = {.lex_state = 168},
  [273] = {.lex_state = 84},
  [274] = {.lex_state = 84},
  [275] = {.lex_state = 212},
  [276] = {.lex_state = 151, .external_lex_state = 4},
  [277] = {.lex_state = 168},
  [278] = {.lex_state = 84},
  [279] = {.lex_state = 155, .external_lex_state = 3},
  [280] = {.lex_state = 84},
  [281] = {.lex_state = 134},
  [282] = {.lex_state = 134, .external_lex_state = 13},
  [283] = {.lex_state = 134},
  [284] = {.lex_state = 134, .external_lex_state = 13},
  [285] = {.lex_state = 84},
  [286] = {.lex_state = 219},
  [287] = {.lex_state = 179},
  [288] = {.lex_state = 126},
  [289] = {.lex_state = 202, .external_lex_state = 12},
  [290] = {.lex_state = 151, .external_lex_state = 4},
  [291] = {.lex_state = 174, .external_lex_state = 12},
  [292] = {.lex_state = 73, .external_lex_state = 23},
  [293] = {.lex_state = 73, .external_lex_state = 2},
  [294] = {.lex_state = 119, .external_lex_state = 6},
  [295] = {.lex_state = 194, .external_lex_state = 10},
  [296] = {.lex_state = 119, .external_lex_state = 6},
  [297] = {.lex_state = 119, .external_lex_state = 6},
  [298] = {.lex_state = 194, .external_lex_state = 10},
  [299] = {.lex_state = 119, .external_lex_state = 6},
  [300] = {.lex_state = 73, .external_lex_state = 2},
  [301] = {.lex_state = 174, .external_lex_state = 12},
  [302] = {.lex_state = 151, .external_lex_state = 4},
  [303] = {.lex_state = 84},
  [304] = {.lex_state = 151, .external_lex_state = 4},
  [305] = {.lex_state = 168},
  [306] = {.lex_state = 84},
  [307] = {.lex_state = 84},
  [308] = {.lex_state = 222, .external_lex_state = 2},
  [309] = {.lex_state = 84},
  [310] = {.lex_state = 222, .external_lex_state = 2},
  [311] = {.lex_state = 84},
  [312] = {.lex_state = 84},
  [313] = {.lex_state = 151, .external_lex_state = 4},
  [314] = {.lex_state = 168},
  [315] = {.lex_state = 84},
  [316] = {.lex_state = 134},
  [317] = {.lex_state = 134},
  [318] = {.lex_state = 151, .external_lex_state = 4},
  [319] = {.lex_state = 219},
  [320] = {.lex_state = 151, .external_lex_state = 4},
  [321] = {.lex_state = 219},
  [322] = {.lex_state = 179},
  [323] = {.lex_state = 126},
  [324] = {.lex_state = 119, .external_lex_state = 6},
  [325] = {.lex_state = 119, .external_lex_state = 6},
  [326] = {.lex_state = 73, .external_lex_state = 2},
  [327] = {.lex_state = 73, .external_lex_state = 2},
  [328] = {.lex_state = 151, .external_lex_state = 4},
  [329] = {.lex_state = 151, .external_lex_state = 4},
  [330] = {.lex_state = 168},
  [331] = {.lex_state = 84, .external_lex_state = 13},
  [332] = {.lex_state = 84},
  [333] = {.lex_state = 84},
  [334] = {.lex_state = 212},
  [335] = {.lex_state = 168},
  [336] = {.lex_state = 222, .external_lex_state = 2},
  [337] = {.lex_state = 84},
  [338] = {.lex_state = 212},
  [339] = {.lex_state = 168},
  [340] = {.lex_state = 222, .external_lex_state = 2},
  [341] = {.lex_state = 84, .external_lex_state = 13},
  [342] = {.lex_state = 84},
  [343] = {.lex_state = 84},
  [344] = {.lex_state = 151, .external_lex_state = 4},
  [345] = {.lex_state = 168},
  [346] = {.lex_state = 151, .external_lex_state = 4},
  [347] = {.lex_state = 219},
  [348] = {.lex_state = 219},
  [349] = {.lex_state = 179},
  [350] = {.lex_state = 151, .external_lex_state = 4},
  [351] = {.lex_state = 212},
  [352] = {.lex_state = 168},
  [353] = {.lex_state = 212},
  [354] = {.lex_state = 168},
  [355] = {.lex_state = 73, .external_lex_state = 2},
  [356] = {.lex_state = 84},
  [357] = {.lex_state = 73, .external_lex_state = 2},
  [358] = {.lex_state = 84},
  [359] = {.lex_state = 151, .external_lex_state = 4},
  [360] = {.lex_state = 151, .external_lex_state = 4},
  [361] = {.lex_state = 219},
  [362] = {.lex_state = 219},
  [363] = {.lex_state = 212},
  [364] = {.lex_state = 212},
  [365] = {.lex_state = 84},
  [366] = {.lex_state = 73},
  [367] = {.lex_state = 73, .external_lex_state = 2},
  [368] = {.lex_state = 84},
  [369] = {.lex_state = 73},
  [370] = {.lex_state = 73, .external_lex_state = 2},
  [371] = {.lex_state = 151, .external_lex_state = 4},
  [372] = {.lex_state = 219},
  [373] = {.lex_state = 84},
  [374] = {.lex_state = 73},
  [375] = {.lex_state = 84},
  [376] = {.lex_state = 73},
  [377] = {.lex_state = 151, .external_lex_state = 4},
  [378] = {.lex_state = 84},
  [379] = {.lex_state = 84},
  [380] = {.lex_state = 88, .external_lex_state = 3},
  [381] = {.lex_state = 88, .external_lex_state = 4},
  [382] = {.lex_state = 119, .external_lex_state = 6},
  [383] = {.lex_state = 119, .external_lex_state = 6},
  [384] = {.lex_state = 119, .external_lex_state = 6},
  [385] = {.lex_state = 132, .external_lex_state = 2},
  [386] = {.lex_state = 119, .external_lex_state = 4},
  [387] = {.lex_state = 151, .external_lex_state = 4},
  [388] = {.lex_state = 155, .external_lex_state = 3},
  [389] = {.lex_state = 119, .external_lex_state = 4},
  [390] = {.lex_state = 73, .external_lex_state = 2},
  [391] = {.lex_state = 84, .external_lex_state = 2},
  [392] = {.lex_state = 119, .external_lex_state = 4},
  [393] = {.lex_state = 151, .external_lex_state = 6},
  [394] = {.lex_state = 151, .external_lex_state = 4},
  [395] = {.lex_state = 151, .external_lex_state = 4},
  [396] = {.lex_state = 88, .external_lex_state = 9},
  [397] = {.lex_state = 88, .external_lex_state = 3},
  [398] = {.lex_state = 88, .external_lex_state = 3},
  [399] = {.lex_state = 88, .external_lex_state = 6},
  [400] = {.lex_state = 88, .external_lex_state = 4},
  [401] = {.lex_state = 88, .external_lex_state = 4},
  [402] = {.lex_state = 119, .external_lex_state = 6},
  [403] = {.lex_state = 119, .external_lex_state = 6},
  [404] = {.lex_state = 119, .external_lex_state = 6},
  [405] = {.lex_state = 119, .external_lex_state = 6},
  [406] = {.lex_state = 224, .external_lex_state = 4},
  [407] = {.lex_state = 189, .external_lex_state = 22},
  [408] = {.lex_state = 189, .external_lex_state = 15},
  [409] = {.lex_state = 224, .external_lex_state = 4},
  [410] = {.lex_state = 119, .external_lex_state = 6},
  [411] = {.lex_state = 119, .external_lex_state = 4},
  [412] = {.lex_state = 119, .external_lex_state = 4},
  [413] = {.lex_state = 73, .external_lex_state = 2},
  [414] = {.lex_state = 73, .external_lex_state = 16},
  [415] = {.lex_state = 73, .external_lex_state = 2},
  [416] = {.lex_state = 73, .external_lex_state = 2},
  [417] = {.lex_state = 151, .external_lex_state = 4},
  [418] = {.lex_state = 151, .external_lex_state = 4},
  [419] = {.lex_state = 155, .external_lex_state = 3},
  [420] = {.lex_state = 124, .external_lex_state = 7},
  [421] = {.lex_state = 119, .external_lex_state = 4},
  [422] = {.lex_state = 119, .external_lex_state = 6},
  [423] = {.lex_state = 84, .external_lex_state = 18},
  [424] = {.lex_state = 119, .external_lex_state = 4},
  [425] = {.lex_state = 119, .external_lex_state = 4},
  [426] = {.lex_state = 224, .external_lex_state = 4},
  [427] = {.lex_state = 88, .external_lex_state = 3},
  [428] = {.lex_state = 88, .external_lex_state = 4},
  [429] = {.lex_state = 119, .external_lex_state = 6},
  [430] = {.lex_state = 119, .external_lex_state = 6},
  [431] = {.lex_state = 119, .external_lex_state = 6},
  [432] = {.lex_state = 119, .external_lex_state = 6},
  [433] = {.lex_state = 224, .external_lex_state = 4},
  [434] = {.lex_state = 119, .external_lex_state = 6},
  [435] = {.lex_state = 84},
  [436] = {.lex_state = 119, .external_lex_state = 6},
  [437] = {.lex_state = 73, .external_lex_state = 2},
  [438] = {.lex_state = 73, .external_lex_state = 16},
  [439] = {.lex_state = 224, .external_lex_state = 4},
  [440] = {.lex_state = 189, .external_lex_state = 15},
  [441] = {.lex_state = 126},
  [442] = {.lex_state = 189, .external_lex_state = 15},
  [443] = {.lex_state = 126, .external_lex_state = 18},
  [444] = {.lex_state = 224, .external_lex_state = 4},
  [445] = {.lex_state = 119, .external_lex_state = 6},
  [446] = {.lex_state = 155, .external_lex_state = 9},
  [447] = {.lex_state = 155, .external_lex_state = 3},
  [448] = {.lex_state = 155, .external_lex_state = 3},
  [449] = {.lex_state = 151, .external_lex_state = 6},
  [450] = {.lex_state = 151, .external_lex_state = 4},
  [451] = {.lex_state = 151, .external_lex_state = 4},
  [452] = {.lex_state = 119, .external_lex_state = 6},
  [453] = {.lex_state = 224, .external_lex_state = 4},
  [454] = {.lex_state = 151, .external_lex_state = 4},
  [455] = {.lex_state = 155, .external_lex_state = 3},
  [456] = {.lex_state = 226, .external_lex_state = 12},
  [457] = {.lex_state = 216, .external_lex_state = 12},
  [458] = {.lex_state = 224, .external_lex_state = 4},
  [459] = {.lex_state = 151, .external_lex_state = 4},
  [460] = {.lex_state = 155, .external_lex_state = 3},
  [461] = {.lex_state = 151, .external_lex_state = 6},
  [462] = {.lex_state = 224, .external_lex_state = 4},
  [463] = {.lex_state = 224, .external_lex_state = 4},
  [464] = {.lex_state = 151, .external_lex_state = 4},
  [465] = {.lex_state = 73, .external_lex_state = 2},
  [466] = {.lex_state = 73, .external_lex_state = 16},
  [467] = {.lex_state = 119, .external_lex_state = 4},
  [468] = {.lex_state = 119, .external_lex_state = 6},
  [469] = {.lex_state = 119, .external_lex_state = 4},
  [470] = {.lex_state = 119, .external_lex_state = 4},
  [471] = {.lex_state = 119, .external_lex_state = 4},
  [472] = {.lex_state = 119, .external_lex_state = 6},
  [473] = {.lex_state = 119, .external_lex_state = 6},
  [474] = {.lex_state = 119, .external_lex_state = 6},
  [475] = {.lex_state = 224, .external_lex_state = 4},
  [476] = {.lex_state = 206, .external_lex_state = 4},
  [477] = {.lex_state = 224, .external_lex_state = 4},
  [478] = {.lex_state = 189, .external_lex_state = 15},
  [479] = {.lex_state = 189, .external_lex_state = 15},
  [480] = {.lex_state = 189, .external_lex_state = 15},
  [481] = {.lex_state = 216, .external_lex_state = 11},
  [482] = {.lex_state = 155, .external_lex_state = 3},
  [483] = {.lex_state = 216, .external_lex_state = 12},
  [484] = {.lex_state = 159, .external_lex_state = 20},
  [485] = {.lex_state = 159, .external_lex_state = 20},
  [486] = {.lex_state = 119, .external_lex_state = 6},
  [487] = {.lex_state = 224, .external_lex_state = 4},
  [488] = {.lex_state = 224, .external_lex_state = 4},
  [489] = {.lex_state = 226, .external_lex_state = 12},
  [490] = {.lex_state = 73, .external_lex_state = 2},
  [491] = {.lex_state = 216, .external_lex_state = 12},
  [492] = {.lex_state = 119, .external_lex_state = 6},
  [493] = {.lex_state = 119, .external_lex_state = 6},
  [494] = {.lex_state = 119, .external_lex_state = 6},
  [495] = {.lex_state = 119, .external_lex_state = 6},
  [496] = {.lex_state = 224, .external_lex_state = 4},
  [497] = {.lex_state = 73, .external_lex_state = 2},
  [498] = {.lex_state = 224, .external_lex_state = 4},
  [499] = {.lex_state = 224, .external_lex_state = 4},
  [500] = {.lex_state = 224, .external_lex_state = 4},
  [501] = {.lex_state = 155, .external_lex_state = 3},
  [502] = {.lex_state = 216, .external_lex_state = 12},
  [503] = {.lex_state = 159, .external_lex_state = 10},
  [504] = {.lex_state = 159, .external_lex_state = 20},
  [505] = {.lex_state = 159, .external_lex_state = 10},
  [506] = {.lex_state = 159, .external_lex_state = 20},
  [507] = {.lex_state = 224, .external_lex_state = 4},
  [508] = {.lex_state = 226, .external_lex_state = 12},
  [509] = {.lex_state = 73, .external_lex_state = 2},
  [510] = {.lex_state = 119, .external_lex_state = 6},
  [511] = {.lex_state = 119, .external_lex_state = 6},
  [512] = {.lex_state = 119, .external_lex_state = 6},
  [513] = {.lex_state = 119, .external_lex_state = 6},
  [514] = {.lex_state = 224, .external_lex_state = 4},
  [515] = {.lex_state = 224, .external_lex_state = 4},
  [516] = {.lex_state = 224, .external_lex_state = 4},
  [517] = {.lex_state = 159, .external_lex_state = 10},
  [518] = {.lex_state = 159, .external_lex_state = 10},
  [519] = {.lex_state = 224, .external_lex_state = 4},
  [520] = {.lex_state = 224, .external_lex_state = 4},
  [521] = {.lex_state = 119, .external_lex_state = 6},
  [522] = {.lex_state = 119, .external_lex_state = 6},
  [523] = {.lex_state = 224, .external_lex_state = 4},
  [524] = {.lex_state = 224, .external_lex_state = 4},
  [525] = {.lex_state = 224, .external_lex_state = 4},
  [526] = {.lex_state = 224, .external_lex_state = 4},
  [527] = {.lex_state = 224, .external_lex_state = 4},
  [528] = {.lex_state = 224, .external_lex_state = 4},
  [529] = {.lex_state = 224, .external_lex_state = 4},
  [530] = {.lex_state = 224, .external_lex_state = 4},
  [531] = {.lex_state = 224, .external_lex_state = 4},
  [532] = {.lex_state = 88, .external_lex_state = 3},
  [533] = {.lex_state = 88, .external_lex_state = 4},
  [534] = {.lex_state = 228, .external_lex_state = 6},
  [535] = {.lex_state = 84, .external_lex_state = 8},
  [536] = {.lex_state = 228, .external_lex_state = 6},
  [537] = {.lex_state = 132, .external_lex_state = 2},
  [538] = {.lex_state = 228, .external_lex_state = 4},
  [539] = {.lex_state = 231, .external_lex_state = 4},
  [540] = {.lex_state = 155, .external_lex_state = 3},
  [541] = {.lex_state = 228, .external_lex_state = 4},
  [542] = {.lex_state = 73, .external_lex_state = 2},
  [543] = {.lex_state = 84, .external_lex_state = 2},
  [544] = {.lex_state = 119, .external_lex_state = 4},
  [545] = {.lex_state = 151, .external_lex_state = 6},
  [546] = {.lex_state = 224, .external_lex_state = 4},
  [547] = {.lex_state = 224, .external_lex_state = 4},
  [548] = {.lex_state = 233, .external_lex_state = 9},
  [549] = {.lex_state = 233, .external_lex_state = 3},
  [550] = {.lex_state = 88, .external_lex_state = 3},
  [551] = {.lex_state = 233, .external_lex_state = 6},
  [552] = {.lex_state = 233, .external_lex_state = 4},
  [553] = {.lex_state = 88, .external_lex_state = 4},
  [554] = {.lex_state = 84, .external_lex_state = 8},
  [555] = {.lex_state = 84, .external_lex_state = 8},
  [556] = {.lex_state = 84, .external_lex_state = 8},
  [557] = {.lex_state = 84, .external_lex_state = 8},
  [558] = {.lex_state = 202, .external_lex_state = 11},
  [559] = {.lex_state = 202, .external_lex_state = 12},
  [560] = {.lex_state = 84, .external_lex_state = 8},
  [561] = {.lex_state = 84, .external_lex_state = 2},
  [562] = {.lex_state = 84, .external_lex_state = 2},
  [563] = {.lex_state = 73, .external_lex_state = 2},
  [564] = {.lex_state = 73, .external_lex_state = 16},
  [565] = {.lex_state = 73, .external_lex_state = 2},
  [566] = {.lex_state = 73, .external_lex_state = 2},
  [567] = {.lex_state = 151, .external_lex_state = 4},
  [568] = {.lex_state = 155, .external_lex_state = 3},
  [569] = {.lex_state = 119, .external_lex_state = 4},
  [570] = {.lex_state = 228, .external_lex_state = 6},
  [571] = {.lex_state = 84, .external_lex_state = 18},
  [572] = {.lex_state = 228, .external_lex_state = 4},
  [573] = {.lex_state = 119, .external_lex_state = 4},
  [574] = {.lex_state = 233, .external_lex_state = 3},
  [575] = {.lex_state = 233, .external_lex_state = 4},
  [576] = {.lex_state = 84, .external_lex_state = 8},
  [577] = {.lex_state = 84, .external_lex_state = 8},
  [578] = {.lex_state = 84, .external_lex_state = 8},
  [579] = {.lex_state = 84, .external_lex_state = 8},
  [580] = {.lex_state = 84, .external_lex_state = 8},
  [581] = {.lex_state = 84},
  [582] = {.lex_state = 84, .external_lex_state = 8},
  [583] = {.lex_state = 202, .external_lex_state = 12},
  [584] = {.lex_state = 126},
  [585] = {.lex_state = 202, .external_lex_state = 12},
  [586] = {.lex_state = 126, .external_lex_state = 18},
  [587] = {.lex_state = 84, .external_lex_state = 8},
  [588] = {.lex_state = 88, .external_lex_state = 9},
  [589] = {.lex_state = 88, .external_lex_state = 3},
  [590] = {.lex_state = 88, .external_lex_state = 3},
  [591] = {.lex_state = 151, .external_lex_state = 6},
  [592] = {.lex_state = 224, .external_lex_state = 4},
  [593] = {.lex_state = 224, .external_lex_state = 4},
  [594] = {.lex_state = 84, .external_lex_state = 8},
  [595] = {.lex_state = 155, .external_lex_state = 3},
  [596] = {.lex_state = 240, .external_lex_state = 12},
  [597] = {.lex_state = 151, .external_lex_state = 4},
  [598] = {.lex_state = 155, .external_lex_state = 3},
  [599] = {.lex_state = 73, .external_lex_state = 2},
  [600] = {.lex_state = 73, .external_lex_state = 16},
  [601] = {.lex_state = 119, .external_lex_state = 4},
  [602] = {.lex_state = 228, .external_lex_state = 6},
  [603] = {.lex_state = 228, .external_lex_state = 4},
  [604] = {.lex_state = 228, .external_lex_state = 4},
  [605] = {.lex_state = 228, .external_lex_state = 4},
  [606] = {.lex_state = 84, .external_lex_state = 8},
  [607] = {.lex_state = 84, .external_lex_state = 8},
  [608] = {.lex_state = 84, .external_lex_state = 8},
  [609] = {.lex_state = 242, .external_lex_state = 2},
  [610] = {.lex_state = 202, .external_lex_state = 12},
  [611] = {.lex_state = 202, .external_lex_state = 12},
  [612] = {.lex_state = 202, .external_lex_state = 12},
  [613] = {.lex_state = 88, .external_lex_state = 3},
  [614] = {.lex_state = 84, .external_lex_state = 8},
  [615] = {.lex_state = 73, .external_lex_state = 2},
  [616] = {.lex_state = 240, .external_lex_state = 12},
  [617] = {.lex_state = 84, .external_lex_state = 8},
  [618] = {.lex_state = 84, .external_lex_state = 8},
  [619] = {.lex_state = 84, .external_lex_state = 8},
  [620] = {.lex_state = 84, .external_lex_state = 8},
  [621] = {.lex_state = 88, .external_lex_state = 3},
  [622] = {.lex_state = 73, .external_lex_state = 2},
  [623] = {.lex_state = 84, .external_lex_state = 8},
  [624] = {.lex_state = 84, .external_lex_state = 8},
  [625] = {.lex_state = 84, .external_lex_state = 8},
  [626] = {.lex_state = 84, .external_lex_state = 8},
  [627] = {.lex_state = 84, .external_lex_state = 8},
  [628] = {.lex_state = 84, .external_lex_state = 8},
  [629] = {.lex_state = 233, .external_lex_state = 3},
  [630] = {.lex_state = 233, .external_lex_state = 4},
  [631] = {.lex_state = 88, .external_lex_state = 9},
  [632] = {.lex_state = 151, .external_lex_state = 4},
  [633] = {.lex_state = 244, .external_lex_state = 3},
  [634] = {.lex_state = 73, .external_lex_state = 2},
  [635] = {.lex_state = 228, .external_lex_state = 4},
  [636] = {.lex_state = 233, .external_lex_state = 3},
  [637] = {.lex_state = 233, .external_lex_state = 4},
  [638] = {.lex_state = 88, .external_lex_state = 9},
  [639] = {.lex_state = 88, .external_lex_state = 9},
  [640] = {.lex_state = 88, .external_lex_state = 9},
  [641] = {.lex_state = 88, .external_lex_state = 9},
  [642] = {.lex_state = 88, .external_lex_state = 9},
  [643] = {.lex_state = 88, .external_lex_state = 3},
  [644] = {.lex_state = 88, .external_lex_state = 3},
  [645] = {.lex_state = 73, .external_lex_state = 2},
  [646] = {.lex_state = 222, .external_lex_state = 16},
  [647] = {.lex_state = 222, .external_lex_state = 2},
  [648] = {.lex_state = 73, .external_lex_state = 2},
  [649] = {.lex_state = 231, .external_lex_state = 4},
  [650] = {.lex_state = 244, .external_lex_state = 3},
  [651] = {.lex_state = 228, .external_lex_state = 4},
  [652] = {.lex_state = 228, .external_lex_state = 4},
  [653] = {.lex_state = 88, .external_lex_state = 9},
  [654] = {.lex_state = 88, .external_lex_state = 9},
  [655] = {.lex_state = 88, .external_lex_state = 9},
  [656] = {.lex_state = 88, .external_lex_state = 9},
  [657] = {.lex_state = 88, .external_lex_state = 9},
  [658] = {.lex_state = 84},
  [659] = {.lex_state = 88, .external_lex_state = 9},
  [660] = {.lex_state = 88, .external_lex_state = 9},
  [661] = {.lex_state = 84, .external_lex_state = 8},
  [662] = {.lex_state = 84, .external_lex_state = 2},
  [663] = {.lex_state = 84, .external_lex_state = 2},
  [664] = {.lex_state = 88, .external_lex_state = 9},
  [665] = {.lex_state = 244, .external_lex_state = 3},
  [666] = {.lex_state = 174, .external_lex_state = 12},
  [667] = {.lex_state = 231, .external_lex_state = 4},
  [668] = {.lex_state = 244, .external_lex_state = 3},
  [669] = {.lex_state = 222, .external_lex_state = 2},
  [670] = {.lex_state = 222, .external_lex_state = 16},
  [671] = {.lex_state = 228, .external_lex_state = 4},
  [672] = {.lex_state = 88, .external_lex_state = 9},
  [673] = {.lex_state = 88, .external_lex_state = 9},
  [674] = {.lex_state = 88, .external_lex_state = 9},
  [675] = {.lex_state = 247, .external_lex_state = 3},
  [676] = {.lex_state = 84, .external_lex_state = 2},
  [677] = {.lex_state = 88, .external_lex_state = 9},
  [678] = {.lex_state = 222, .external_lex_state = 2},
  [679] = {.lex_state = 174, .external_lex_state = 12},
  [680] = {.lex_state = 88, .external_lex_state = 9},
  [681] = {.lex_state = 88, .external_lex_state = 9},
  [682] = {.lex_state = 88, .external_lex_state = 9},
  [683] = {.lex_state = 88, .external_lex_state = 9},
  [684] = {.lex_state = 84, .external_lex_state = 2},
  [685] = {.lex_state = 222, .external_lex_state = 2},
  [686] = {.lex_state = 88, .external_lex_state = 9},
  [687] = {.lex_state = 88, .external_lex_state = 9},
  [688] = {.lex_state = 88, .external_lex_state = 9},
  [689] = {.lex_state = 88, .external_lex_state = 9},
  [690] = {.lex_state = 88, .external_lex_state = 9},
  [691] = {.lex_state = 88, .external_lex_state = 9},
  [692] = {.lex_state = 88, .external_lex_state = 6},
  [693] = {.lex_state = 155, .external_lex_state = 3},
  [694] = {.lex_state = 88, .external_lex_state = 6},
  [695] = {.lex_state = 88, .external_lex_state = 6},
  [696] = {.lex_state = 88, .external_lex_state = 6},
  [697] = {.lex_state = 88, .external_lex_state = 6},
  [698] = {.lex_state = 88, .external_lex_state = 6},
  [699] = {.lex_state = 88, .external_lex_state = 4},
  [700] = {.lex_state = 88, .external_lex_state = 4},
  [701] = {.lex_state = 151, .external_lex_state = 4},
  [702] = {.lex_state = 155, .external_lex_state = 3},
  [703] = {.lex_state = 88, .external_lex_state = 6},
  [704] = {.lex_state = 88, .external_lex_state = 6},
  [705] = {.lex_state = 88, .external_lex_state = 6},
  [706] = {.lex_state = 88, .external_lex_state = 6},
  [707] = {.lex_state = 88, .external_lex_state = 6},
  [708] = {.lex_state = 84},
  [709] = {.lex_state = 88, .external_lex_state = 6},
  [710] = {.lex_state = 88, .external_lex_state = 6},
  [711] = {.lex_state = 88, .external_lex_state = 9},
  [712] = {.lex_state = 88, .external_lex_state = 3},
  [713] = {.lex_state = 88, .external_lex_state = 3},
  [714] = {.lex_state = 88, .external_lex_state = 6},
  [715] = {.lex_state = 88, .external_lex_state = 6},
  [716] = {.lex_state = 88, .external_lex_state = 6},
  [717] = {.lex_state = 88, .external_lex_state = 6},
  [718] = {.lex_state = 247, .external_lex_state = 4},
  [719] = {.lex_state = 88, .external_lex_state = 3},
  [720] = {.lex_state = 88, .external_lex_state = 6},
  [721] = {.lex_state = 88, .external_lex_state = 6},
  [722] = {.lex_state = 88, .external_lex_state = 6},
  [723] = {.lex_state = 88, .external_lex_state = 6},
  [724] = {.lex_state = 88, .external_lex_state = 6},
  [725] = {.lex_state = 88, .external_lex_state = 3},
  [726] = {.lex_state = 88, .external_lex_state = 6},
  [727] = {.lex_state = 88, .external_lex_state = 6},
  [728] = {.lex_state = 88, .external_lex_state = 6},
  [729] = {.lex_state = 88, .external_lex_state = 6},
  [730] = {.lex_state = 88, .external_lex_state = 6},
  [731] = {.lex_state = 88, .external_lex_state = 6},
  [732] = {.lex_state = 174, .external_lex_state = 11},
  [733] = {.lex_state = 174, .external_lex_state = 11},
  [734] = {.lex_state = 174, .external_lex_state = 11},
  [735] = {.lex_state = 174, .external_lex_state = 11},
  [736] = {.lex_state = 174, .external_lex_state = 11},
  [737] = {.lex_state = 174, .external_lex_state = 11},
  [738] = {.lex_state = 174, .external_lex_state = 12},
  [739] = {.lex_state = 174, .external_lex_state = 12},
  [740] = {.lex_state = 174, .external_lex_state = 11},
  [741] = {.lex_state = 174, .external_lex_state = 11},
  [742] = {.lex_state = 174, .external_lex_state = 11},
  [743] = {.lex_state = 174, .external_lex_state = 11},
  [744] = {.lex_state = 174, .external_lex_state = 11},
  [745] = {.lex_state = 84},
  [746] = {.lex_state = 174, .external_lex_state = 11},
  [747] = {.lex_state = 174, .external_lex_state = 11},
  [748] = {.lex_state = 244, .external_lex_state = 9},
  [749] = {.lex_state = 244, .external_lex_state = 3},
  [750] = {.lex_state = 244, .external_lex_state = 3},
  [751] = {.lex_state = 174, .external_lex_state = 11},
  [752] = {.lex_state = 174, .external_lex_state = 11},
  [753] = {.lex_state = 174, .external_lex_state = 11},
  [754] = {.lex_state = 174, .external_lex_state = 11},
  [755] = {.lex_state = 251, .external_lex_state = 12},
  [756] = {.lex_state = 244, .external_lex_state = 3},
  [757] = {.lex_state = 174, .external_lex_state = 11},
  [758] = {.lex_state = 174, .external_lex_state = 11},
  [759] = {.lex_state = 174, .external_lex_state = 11},
  [760] = {.lex_state = 174, .external_lex_state = 11},
  [761] = {.lex_state = 174, .external_lex_state = 11},
  [762] = {.lex_state = 244, .external_lex_state = 3},
  [763] = {.lex_state = 174, .external_lex_state = 11},
  [764] = {.lex_state = 174, .external_lex_state = 11},
  [765] = {.lex_state = 174, .external_lex_state = 11},
  [766] = {.lex_state = 174, .external_lex_state = 11},
  [767] = {.lex_state = 174, .external_lex_state = 11},
  [768] = {.lex_state = 174, .external_lex_state = 11},
  [769] = {.lex_state = 255, .external_lex_state = 13},
  [770] = {.lex_state = 255, .external_lex_state = 13},
  [771] = {.lex_state = 255, .external_lex_state = 13},
  [772] = {.lex_state = 255, .external_lex_state = 13},
  [773] = {.lex_state = 255, .external_lex_state = 13},
  [774] = {.lex_state = 255, .external_lex_state = 13},
  [775] = {.lex_state = 255},
  [776] = {.lex_state = 255},
  [777] = {.lex_state = 255, .external_lex_state = 13},
  [778] = {.lex_state = 255, .external_lex_state = 13},
  [779] = {.lex_state = 255, .external_lex_state = 13},
  [780] = {.lex_state = 255, .external_lex_state = 13},
  [781] = {.lex_state = 255, .external_lex_state = 13},
  [782] = {.lex_state = 84},
  [783] = {.lex_state = 255, .external_lex_state = 13},
  [784] = {.lex_state = 255, .external_lex_state = 13},
  [785] = {.lex_state = 233, .external_lex_state = 9},
  [786] = {.lex_state = 233, .external_lex_state = 3},
  [787] = {.lex_state = 233, .external_lex_state = 3},
  [788] = {.lex_state = 255, .external_lex_state = 13},
  [789] = {.lex_state = 255, .external_lex_state = 13},
  [790] = {.lex_state = 255, .external_lex_state = 13},
  [791] = {.lex_state = 255, .external_lex_state = 13},
  [792] = {.lex_state = 94},
  [793] = {.lex_state = 233, .external_lex_state = 3},
  [794] = {.lex_state = 255, .external_lex_state = 13},
  [795] = {.lex_state = 255, .external_lex_state = 13},
  [796] = {.lex_state = 255, .external_lex_state = 13},
  [797] = {.lex_state = 255, .external_lex_state = 13},
  [798] = {.lex_state = 255, .external_lex_state = 13},
  [799] = {.lex_state = 233, .external_lex_state = 3},
  [800] = {.lex_state = 255, .external_lex_state = 13},
  [801] = {.lex_state = 255, .external_lex_state = 13},
  [802] = {.lex_state = 255, .external_lex_state = 13},
  [803] = {.lex_state = 255, .external_lex_state = 13},
  [804] = {.lex_state = 255, .external_lex_state = 13},
  [805] = {.lex_state = 255, .external_lex_state = 13},
  [806] = {.lex_state = 189, .external_lex_state = 22},
  [807] = {.lex_state = 144, .external_lex_state = 13},
  [808] = {.lex_state = 189, .external_lex_state = 22},
  [809] = {.lex_state = 144, .external_lex_state = 13},
  [810] = {.lex_state = 189, .external_lex_state = 22},
  [811] = {.lex_state = 189, .external_lex_state = 22},
  [812] = {.lex_state = 189, .external_lex_state = 15},
  [813] = {.lex_state = 189, .external_lex_state = 15},
  [814] = {.lex_state = 189, .external_lex_state = 22},
  [815] = {.lex_state = 144, .external_lex_state = 13},
  [816] = {.lex_state = 144, .external_lex_state = 13},
  [817] = {.lex_state = 144, .external_lex_state = 13},
  [818] = {.lex_state = 189, .external_lex_state = 22},
  [819] = {.lex_state = 84},
  [820] = {.lex_state = 189, .external_lex_state = 22},
  [821] = {.lex_state = 144, .external_lex_state = 13},
  [822] = {.lex_state = 189, .external_lex_state = 22},
  [823] = {.lex_state = 144, .external_lex_state = 13},
  [824] = {.lex_state = 144, .external_lex_state = 13},
  [825] = {.lex_state = 144, .external_lex_state = 13},
  [826] = {.lex_state = 257, .external_lex_state = 15},
  [827] = {.lex_state = 189, .external_lex_state = 22},
  [828] = {.lex_state = 144, .external_lex_state = 13},
  [829] = {.lex_state = 144, .external_lex_state = 13},
  [830] = {.lex_state = 144, .external_lex_state = 13},
  [831] = {.lex_state = 144, .external_lex_state = 13},
  [832] = {.lex_state = 144, .external_lex_state = 13},
  [833] = {.lex_state = 144, .external_lex_state = 13},
  [834] = {.lex_state = 144, .external_lex_state = 13},
  [835] = {.lex_state = 144, .external_lex_state = 13},
  [836] = {.lex_state = 144, .external_lex_state = 13},
  [837] = {.lex_state = 144, .external_lex_state = 13},
  [838] = {.lex_state = 88, .external_lex_state = 9},
  [839] = {.lex_state = 189, .external_lex_state = 22},
  [840] = {.lex_state = 88, .external_lex_state = 9},
  [841] = {.lex_state = 189, .external_lex_state = 22},
  [842] = {.lex_state = 88, .external_lex_state = 9},
  [843] = {.lex_state = 88, .external_lex_state = 9},
  [844] = {.lex_state = 88, .external_lex_state = 3},
  [845] = {.lex_state = 88, .external_lex_state = 3},
  [846] = {.lex_state = 88, .external_lex_state = 9},
  [847] = {.lex_state = 189, .external_lex_state = 22},
  [848] = {.lex_state = 189, .external_lex_state = 22},
  [849] = {.lex_state = 189, .external_lex_state = 22},
  [850] = {.lex_state = 88, .external_lex_state = 9},
  [851] = {.lex_state = 84},
  [852] = {.lex_state = 88, .external_lex_state = 9},
  [853] = {.lex_state = 189, .external_lex_state = 22},
  [854] = {.lex_state = 88, .external_lex_state = 9},
  [855] = {.lex_state = 189, .external_lex_state = 22},
  [856] = {.lex_state = 189, .external_lex_state = 22},
  [857] = {.lex_state = 189, .external_lex_state = 22},
  [858] = {.lex_state = 247, .external_lex_state = 3},
  [859] = {.lex_state = 88, .external_lex_state = 9},
  [860] = {.lex_state = 189, .external_lex_state = 22},
  [861] = {.lex_state = 189, .external_lex_state = 22},
  [862] = {.lex_state = 189, .external_lex_state = 22},
  [863] = {.lex_state = 189, .external_lex_state = 22},
  [864] = {.lex_state = 189, .external_lex_state = 22},
  [865] = {.lex_state = 189, .external_lex_state = 22},
  [866] = {.lex_state = 189, .external_lex_state = 22},
  [867] = {.lex_state = 189, .external_lex_state = 22},
  [868] = {.lex_state = 189, .external_lex_state = 22},
  [869] = {.lex_state = 189, .external_lex_state = 22},
  [870] = {.lex_state = 88, .external_lex_state = 6},
  [871] = {.lex_state = 88, .external_lex_state = 9},
  [872] = {.lex_state = 88, .external_lex_state = 6},
  [873] = {.lex_state = 88, .external_lex_state = 9},
  [874] = {.lex_state = 88, .external_lex_state = 6},
  [875] = {.lex_state = 88, .external_lex_state = 6},
  [876] = {.lex_state = 88, .external_lex_state = 4},
  [877] = {.lex_state = 88, .external_lex_state = 4},
  [878] = {.lex_state = 88, .external_lex_state = 6},
  [879] = {.lex_state = 88, .external_lex_state = 9},
  [880] = {.lex_state = 88, .external_lex_state = 9},
  [881] = {.lex_state = 88, .external_lex_state = 9},
  [882] = {.lex_state = 88, .external_lex_state = 6},
  [883] = {.lex_state = 84},
  [884] = {.lex_state = 88, .external_lex_state = 6},
  [885] = {.lex_state = 88, .external_lex_state = 9},
  [886] = {.lex_state = 88, .external_lex_state = 6},
  [887] = {.lex_state = 88, .external_lex_state = 9},
  [888] = {.lex_state = 88, .external_lex_state = 9},
  [889] = {.lex_state = 88, .external_lex_state = 9},
  [890] = {.lex_state = 247, .external_lex_state = 4},
  [891] = {.lex_state = 88, .external_lex_state = 6},
  [892] = {.lex_state = 88, .external_lex_state = 9},
  [893] = {.lex_state = 88, .external_lex_state = 9},
  [894] = {.lex_state = 88, .external_lex_state = 9},
  [895] = {.lex_state = 88, .external_lex_state = 9},
  [896] = {.lex_state = 88, .external_lex_state = 9},
  [897] = {.lex_state = 88, .external_lex_state = 9},
  [898] = {.lex_state = 88, .external_lex_state = 9},
  [899] = {.lex_state = 88, .external_lex_state = 9},
  [900] = {.lex_state = 88, .external_lex_state = 9},
  [901] = {.lex_state = 88, .external_lex_state = 9},
  [902] = {.lex_state = 194, .external_lex_state = 20},
  [903] = {.lex_state = 88, .external_lex_state = 6},
  [904] = {.lex_state = 194, .external_lex_state = 20},
  [905] = {.lex_state = 88, .external_lex_state = 6},
  [906] = {.lex_state = 194, .external_lex_state = 20},
  [907] = {.lex_state = 194, .external_lex_state = 20},
  [908] = {.lex_state = 194, .external_lex_state = 10},
  [909] = {.lex_state = 194, .external_lex_state = 10},
  [910] = {.lex_state = 194, .external_lex_state = 20},
  [911] = {.lex_state = 88, .external_lex_state = 6},
  [912] = {.lex_state = 88, .external_lex_state = 6},
  [913] = {.lex_state = 88, .external_lex_state = 6},
  [914] = {.lex_state = 194, .external_lex_state = 20},
  [915] = {.lex_state = 84},
  [916] = {.lex_state = 194, .external_lex_state = 20},
  [917] = {.lex_state = 88, .external_lex_state = 6},
  [918] = {.lex_state = 194, .external_lex_state = 20},
  [919] = {.lex_state = 88, .external_lex_state = 6},
  [920] = {.lex_state = 88, .external_lex_state = 6},
  [921] = {.lex_state = 88, .external_lex_state = 6},
  [922] = {.lex_state = 259, .external_lex_state = 10},
  [923] = {.lex_state = 194, .external_lex_state = 20},
  [924] = {.lex_state = 88, .external_lex_state = 6},
  [925] = {.lex_state = 88, .external_lex_state = 6},
  [926] = {.lex_state = 88, .external_lex_state = 6},
  [927] = {.lex_state = 88, .external_lex_state = 6},
  [928] = {.lex_state = 88, .external_lex_state = 6},
  [929] = {.lex_state = 88, .external_lex_state = 6},
  [930] = {.lex_state = 88, .external_lex_state = 6},
  [931] = {.lex_state = 88, .external_lex_state = 6},
  [932] = {.lex_state = 88, .external_lex_state = 6},
  [933] = {.lex_state = 88, .external_lex_state = 6},
  [934] = {.lex_state = 155, .external_lex_state = 9},
  [935] = {.lex_state = 194, .external_lex_state = 20},
  [936] = {.lex_state = 155, .external_lex_state = 9},
  [937] = {.lex_state = 194, .external_lex_state = 20},
  [938] = {.lex_state = 155, .external_lex_state = 9},
  [939] = {.lex_state = 155, .external_lex_state = 9},
  [940] = {.lex_state = 155, .external_lex_state = 3},
  [941] = {.lex_state = 155, .external_lex_state = 3},
  [942] = {.lex_state = 155, .external_lex_state = 9},
  [943] = {.lex_state = 194, .external_lex_state = 20},
  [944] = {.lex_state = 194, .external_lex_state = 20},
  [945] = {.lex_state = 194, .external_lex_state = 20},
  [946] = {.lex_state = 155, .external_lex_state = 9},
  [947] = {.lex_state = 84},
  [948] = {.lex_state = 155, .external_lex_state = 9},
  [949] = {.lex_state = 194, .external_lex_state = 20},
  [950] = {.lex_state = 155, .external_lex_state = 9},
  [951] = {.lex_state = 194, .external_lex_state = 20},
  [952] = {.lex_state = 194, .external_lex_state = 20},
  [953] = {.lex_state = 194, .external_lex_state = 20},
  [954] = {.lex_state = 247, .external_lex_state = 3},
  [955] = {.lex_state = 155, .external_lex_state = 9},
  [956] = {.lex_state = 194, .external_lex_state = 20},
  [957] = {.lex_state = 194, .external_lex_state = 20},
  [958] = {.lex_state = 194, .external_lex_state = 20},
  [959] = {.lex_state = 194, .external_lex_state = 20},
  [960] = {.lex_state = 194, .external_lex_state = 20},
  [961] = {.lex_state = 194, .external_lex_state = 20},
  [962] = {.lex_state = 194, .external_lex_state = 20},
  [963] = {.lex_state = 194, .external_lex_state = 20},
  [964] = {.lex_state = 194, .external_lex_state = 20},
  [965] = {.lex_state = 194, .external_lex_state = 20},
  [966] = {.lex_state = 189, .external_lex_state = 22},
  [967] = {.lex_state = 155, .external_lex_state = 9},
  [968] = {.lex_state = 202, .external_lex_state = 11},
  [969] = {.lex_state = 155, .external_lex_state = 9},
  [970] = {.lex_state = 202, .external_lex_state = 11},
  [971] = {.lex_state = 202, .external_lex_state = 11},
  [972] = {.lex_state = 189, .external_lex_state = 22},
  [973] = {.lex_state = 189, .external_lex_state = 22},
  [974] = {.lex_state = 202, .external_lex_state = 11},
  [975] = {.lex_state = 155, .external_lex_state = 9},
  [976] = {.lex_state = 155, .external_lex_state = 9},
  [977] = {.lex_state = 155, .external_lex_state = 9},
  [978] = {.lex_state = 202, .external_lex_state = 11},
  [979] = {.lex_state = 84},
  [980] = {.lex_state = 202, .external_lex_state = 11},
  [981] = {.lex_state = 155, .external_lex_state = 9},
  [982] = {.lex_state = 202, .external_lex_state = 11},
  [983] = {.lex_state = 155, .external_lex_state = 9},
  [984] = {.lex_state = 155, .external_lex_state = 9},
  [985] = {.lex_state = 155, .external_lex_state = 9},
  [986] = {.lex_state = 257, .external_lex_state = 22},
  [987] = {.lex_state = 202, .external_lex_state = 11},
  [988] = {.lex_state = 155, .external_lex_state = 9},
  [989] = {.lex_state = 155, .external_lex_state = 9},
  [990] = {.lex_state = 155, .external_lex_state = 9},
  [991] = {.lex_state = 155, .external_lex_state = 9},
  [992] = {.lex_state = 155, .external_lex_state = 9},
  [993] = {.lex_state = 155, .external_lex_state = 9},
  [994] = {.lex_state = 155, .external_lex_state = 9},
  [995] = {.lex_state = 155, .external_lex_state = 9},
  [996] = {.lex_state = 155, .external_lex_state = 9},
  [997] = {.lex_state = 155, .external_lex_state = 9},
  [998] = {.lex_state = 202, .external_lex_state = 11},
  [999] = {.lex_state = 202, .external_lex_state = 11},
  [1000] = {.lex_state = 151, .external_lex_state = 6},
  [1001] = {.lex_state = 202, .external_lex_state = 11},
  [1002] = {.lex_state = 151, .external_lex_state = 6},
  [1003] = {.lex_state = 151, .external_lex_state = 6},
  [1004] = {.lex_state = 202, .external_lex_state = 12},
  [1005] = {.lex_state = 202, .external_lex_state = 12},
  [1006] = {.lex_state = 151, .external_lex_state = 6},
  [1007] = {.lex_state = 202, .external_lex_state = 11},
  [1008] = {.lex_state = 202, .external_lex_state = 11},
  [1009] = {.lex_state = 202, .external_lex_state = 11},
  [1010] = {.lex_state = 151, .external_lex_state = 6},
  [1011] = {.lex_state = 84},
  [1012] = {.lex_state = 151, .external_lex_state = 6},
  [1013] = {.lex_state = 202, .external_lex_state = 11},
  [1014] = {.lex_state = 151, .external_lex_state = 6},
  [1015] = {.lex_state = 202, .external_lex_state = 11},
  [1016] = {.lex_state = 202, .external_lex_state = 11},
  [1017] = {.lex_state = 202, .external_lex_state = 11},
  [1018] = {.lex_state = 261, .external_lex_state = 12},
  [1019] = {.lex_state = 151, .external_lex_state = 6},
  [1020] = {.lex_state = 202, .external_lex_state = 11},
  [1021] = {.lex_state = 202, .external_lex_state = 11},
  [1022] = {.lex_state = 202, .external_lex_state = 11},
  [1023] = {.lex_state = 202, .external_lex_state = 11},
  [1024] = {.lex_state = 202, .external_lex_state = 11},
  [1025] = {.lex_state = 202, .external_lex_state = 11},
  [1026] = {.lex_state = 202, .external_lex_state = 11},
  [1027] = {.lex_state = 202, .external_lex_state = 11},
  [1028] = {.lex_state = 202, .external_lex_state = 11},
  [1029] = {.lex_state = 202, .external_lex_state = 11},
  [1030] = {.lex_state = 151, .external_lex_state = 6},
  [1031] = {.lex_state = 151, .external_lex_state = 6},
  [1032] = {.lex_state = 155, .external_lex_state = 9},
  [1033] = {.lex_state = 151, .external_lex_state = 6},
  [1034] = {.lex_state = 155, .external_lex_state = 9},
  [1035] = {.lex_state = 155, .external_lex_state = 9},
  [1036] = {.lex_state = 151, .external_lex_state = 4},
  [1037] = {.lex_state = 151, .external_lex_state = 4},
  [1038] = {.lex_state = 155, .external_lex_state = 9},
  [1039] = {.lex_state = 151, .external_lex_state = 6},
  [1040] = {.lex_state = 151, .external_lex_state = 6},
  [1041] = {.lex_state = 151, .external_lex_state = 6},
  [1042] = {.lex_state = 155, .external_lex_state = 9},
  [1043] = {.lex_state = 84},
  [1044] = {.lex_state = 155, .external_lex_state = 9},
  [1045] = {.lex_state = 151, .external_lex_state = 6},
  [1046] = {.lex_state = 155, .external_lex_state = 9},
  [1047] = {.lex_state = 151, .external_lex_state = 6},
  [1048] = {.lex_state = 151, .external_lex_state = 6},
  [1049] = {.lex_state = 151, .external_lex_state = 6},
  [1050] = {.lex_state = 263, .external_lex_state = 4},
  [1051] = {.lex_state = 155, .external_lex_state = 9},
  [1052] = {.lex_state = 151, .external_lex_state = 6},
  [1053] = {.lex_state = 151, .external_lex_state = 6},
  [1054] = {.lex_state = 151, .external_lex_state = 6},
  [1055] = {.lex_state = 151, .external_lex_state = 6},
  [1056] = {.lex_state = 151, .external_lex_state = 6},
  [1057] = {.lex_state = 151, .external_lex_state = 6},
  [1058] = {.lex_state = 151, .external_lex_state = 6},
  [1059] = {.lex_state = 151, .external_lex_state = 6},
  [1060] = {.lex_state = 151, .external_lex_state = 6},
  [1061] = {.lex_state = 151, .external_lex_state = 6},
  [1062] = {.lex_state = 155, .external_lex_state = 9},
  [1063] = {.lex_state = 155, .external_lex_state = 9},
  [1064] = {.lex_state = 224, .external_lex_state = 6},
  [1065] = {.lex_state = 155, .external_lex_state = 9},
  [1066] = {.lex_state = 151, .external_lex_state = 6},
  [1067] = {.lex_state = 224, .external_lex_state = 6},
  [1068] = {.lex_state = 155, .external_lex_state = 3},
  [1069] = {.lex_state = 155, .external_lex_state = 3},
  [1070] = {.lex_state = 224, .external_lex_state = 6},
  [1071] = {.lex_state = 155, .external_lex_state = 9},
  [1072] = {.lex_state = 155, .external_lex_state = 9},
  [1073] = {.lex_state = 155, .external_lex_state = 9},
  [1074] = {.lex_state = 224, .external_lex_state = 6},
  [1075] = {.lex_state = 84},
  [1076] = {.lex_state = 224, .external_lex_state = 6},
  [1077] = {.lex_state = 155, .external_lex_state = 9},
  [1078] = {.lex_state = 224, .external_lex_state = 6},
  [1079] = {.lex_state = 155, .external_lex_state = 9},
  [1080] = {.lex_state = 155, .external_lex_state = 9},
  [1081] = {.lex_state = 155, .external_lex_state = 9},
  [1082] = {.lex_state = 247, .external_lex_state = 3},
  [1083] = {.lex_state = 224, .external_lex_state = 6},
  [1084] = {.lex_state = 155, .external_lex_state = 9},
  [1085] = {.lex_state = 155, .external_lex_state = 9},
  [1086] = {.lex_state = 155, .external_lex_state = 9},
  [1087] = {.lex_state = 155, .external_lex_state = 9},
  [1088] = {.lex_state = 155, .external_lex_state = 9},
  [1089] = {.lex_state = 155, .external_lex_state = 9},
  [1090] = {.lex_state = 155, .external_lex_state = 9},
  [1091] = {.lex_state = 155, .external_lex_state = 9},
  [1092] = {.lex_state = 155, .external_lex_state = 9},
  [1093] = {.lex_state = 155, .external_lex_state = 9},
  [1094] = {.lex_state = 151, .external_lex_state = 6},
  [1095] = {.lex_state = 224, .external_lex_state = 6},
  [1096] = {.lex_state = 124, .external_lex_state = 20},
  [1097] = {.lex_state = 224, .external_lex_state = 6},
  [1098] = {.lex_state = 124, .external_lex_state = 20},
  [1099] = {.lex_state = 124, .external_lex_state = 20},
  [1100] = {.lex_state = 224, .external_lex_state = 4},
  [1101] = {.lex_state = 224, .external_lex_state = 4},
  [1102] = {.lex_state = 124, .external_lex_state = 20},
  [1103] = {.lex_state = 224, .external_lex_state = 6},
  [1104] = {.lex_state = 224, .external_lex_state = 6},
  [1105] = {.lex_state = 224, .external_lex_state = 6},
  [1106] = {.lex_state = 124, .external_lex_state = 20},
  [1107] = {.lex_state = 84},
  [1108] = {.lex_state = 124, .external_lex_state = 20},
  [1109] = {.lex_state = 224, .external_lex_state = 6},
  [1110] = {.lex_state = 124, .external_lex_state = 20},
  [1111] = {.lex_state = 224, .external_lex_state = 6},
  [1112] = {.lex_state = 224, .external_lex_state = 6},
  [1113] = {.lex_state = 224, .external_lex_state = 6},
  [1114] = {.lex_state = 263, .external_lex_state = 4},
  [1115] = {.lex_state = 124, .external_lex_state = 20},
  [1116] = {.lex_state = 224, .external_lex_state = 6},
  [1117] = {.lex_state = 224, .external_lex_state = 6},
  [1118] = {.lex_state = 224, .external_lex_state = 6},
  [1119] = {.lex_state = 224, .external_lex_state = 6},
  [1120] = {.lex_state = 224, .external_lex_state = 6},
  [1121] = {.lex_state = 224, .external_lex_state = 6},
  [1122] = {.lex_state = 224, .external_lex_state = 6},
  [1123] = {.lex_state = 224, .external_lex_state = 6},
  [1124] = {.lex_state = 224, .external_lex_state = 6},
  [1125] = {.lex_state = 224, .external_lex_state = 6},
  [1126] = {.lex_state = 139, .external_lex_state = 20},
  [1127] = {.lex_state = 124, .external_lex_state = 20},
  [1128] = {.lex_state = 84, .external_lex_state = 13},
  [1129] = {.lex_state = 124, .external_lex_state = 20},
  [1130] = {.lex_state = 84, .external_lex_state = 13},
  [1131] = {.lex_state = 84, .external_lex_state = 13},
  [1132] = {.lex_state = 139, .external_lex_state = 10},
  [1133] = {.lex_state = 139, .external_lex_state = 10},
  [1134] = {.lex_state = 84, .external_lex_state = 13},
  [1135] = {.lex_state = 124, .external_lex_state = 20},
  [1136] = {.lex_state = 124, .external_lex_state = 20},
  [1137] = {.lex_state = 124, .external_lex_state = 20},
  [1138] = {.lex_state = 84, .external_lex_state = 13},
  [1139] = {.lex_state = 84},
  [1140] = {.lex_state = 84, .external_lex_state = 13},
  [1141] = {.lex_state = 124, .external_lex_state = 20},
  [1142] = {.lex_state = 84, .external_lex_state = 13},
  [1143] = {.lex_state = 124, .external_lex_state = 20},
  [1144] = {.lex_state = 124, .external_lex_state = 20},
  [1145] = {.lex_state = 124, .external_lex_state = 20},
  [1146] = {.lex_state = 265, .external_lex_state = 10},
  [1147] = {.lex_state = 84, .external_lex_state = 13},
  [1148] = {.lex_state = 124, .external_lex_state = 20},
  [1149] = {.lex_state = 124, .external_lex_state = 20},
  [1150] = {.lex_state = 124, .external_lex_state = 20},
  [1151] = {.lex_state = 124, .external_lex_state = 20},
  [1152] = {.lex_state = 124, .external_lex_state = 20},
  [1153] = {.lex_state = 124, .external_lex_state = 20},
  [1154] = {.lex_state = 124, .external_lex_state = 20},
  [1155] = {.lex_state = 124, .external_lex_state = 20},
  [1156] = {.lex_state = 124, .external_lex_state = 20},
  [1157] = {.lex_state = 124, .external_lex_state = 20},
  [1158] = {.lex_state = 84, .external_lex_state = 13},
  [1159] = {.lex_state = 84, .external_lex_state = 13},
  [1160] = {.lex_state = 216, .external_lex_state = 11},
  [1161] = {.lex_state = 84, .external_lex_state = 13},
  [1162] = {.lex_state = 216, .external_lex_state = 11},
  [1163] = {.lex_state = 216, .external_lex_state = 11},
  [1164] = {.lex_state = 84},
  [1165] = {.lex_state = 84},
  [1166] = {.lex_state = 216, .external_lex_state = 11},
  [1167] = {.lex_state = 84, .external_lex_state = 13},
  [1168] = {.lex_state = 84, .external_lex_state = 13},
  [1169] = {.lex_state = 84, .external_lex_state = 13},
  [1170] = {.lex_state = 216, .external_lex_state = 11},
  [1171] = {.lex_state = 84},
  [1172] = {.lex_state = 216, .external_lex_state = 11},
  [1173] = {.lex_state = 84, .external_lex_state = 13},
  [1174] = {.lex_state = 216, .external_lex_state = 11},
  [1175] = {.lex_state = 84, .external_lex_state = 13},
  [1176] = {.lex_state = 84, .external_lex_state = 13},
  [1177] = {.lex_state = 84, .external_lex_state = 13},
  [1178] = {.lex_state = 242},
  [1179] = {.lex_state = 216, .external_lex_state = 11},
  [1180] = {.lex_state = 84, .external_lex_state = 13},
  [1181] = {.lex_state = 84, .external_lex_state = 13},
  [1182] = {.lex_state = 84, .external_lex_state = 13},
  [1183] = {.lex_state = 84, .external_lex_state = 13},
  [1184] = {.lex_state = 84, .external_lex_state = 13},
  [1185] = {.lex_state = 84, .external_lex_state = 13},
  [1186] = {.lex_state = 84, .external_lex_state = 13},
  [1187] = {.lex_state = 84, .external_lex_state = 13},
  [1188] = {.lex_state = 84, .external_lex_state = 13},
  [1189] = {.lex_state = 84, .external_lex_state = 13},
  [1190] = {.lex_state = 216, .external_lex_state = 11},
  [1191] = {.lex_state = 216, .external_lex_state = 11},
  [1192] = {.lex_state = 228, .external_lex_state = 6},
  [1193] = {.lex_state = 216, .external_lex_state = 11},
  [1194] = {.lex_state = 228, .external_lex_state = 6},
  [1195] = {.lex_state = 228, .external_lex_state = 6},
  [1196] = {.lex_state = 216, .external_lex_state = 12},
  [1197] = {.lex_state = 216, .external_lex_state = 12},
  [1198] = {.lex_state = 228, .external_lex_state = 6},
  [1199] = {.lex_state = 216, .external_lex_state = 11},
  [1200] = {.lex_state = 216, .external_lex_state = 11},
  [1201] = {.lex_state = 216, .external_lex_state = 11},
  [1202] = {.lex_state = 228, .external_lex_state = 6},
  [1203] = {.lex_state = 84},
  [1204] = {.lex_state = 228, .external_lex_state = 6},
  [1205] = {.lex_state = 216, .external_lex_state = 11},
  [1206] = {.lex_state = 228, .external_lex_state = 6},
  [1207] = {.lex_state = 216, .external_lex_state = 11},
  [1208] = {.lex_state = 216, .external_lex_state = 11},
  [1209] = {.lex_state = 216, .external_lex_state = 11},
  [1210] = {.lex_state = 267, .external_lex_state = 12},
  [1211] = {.lex_state = 228, .external_lex_state = 6},
  [1212] = {.lex_state = 216, .external_lex_state = 11},
  [1213] = {.lex_state = 216, .external_lex_state = 11},
  [1214] = {.lex_state = 216, .external_lex_state = 11},
  [1215] = {.lex_state = 216, .external_lex_state = 11},
  [1216] = {.lex_state = 216, .external_lex_state = 11},
  [1217] = {.lex_state = 216, .external_lex_state = 11},
  [1218] = {.lex_state = 216, .external_lex_state = 11},
  [1219] = {.lex_state = 216, .external_lex_state = 11},
  [1220] = {.lex_state = 216, .external_lex_state = 11},
  [1221] = {.lex_state = 216, .external_lex_state = 11},
  [1222] = {.lex_state = 228, .external_lex_state = 6},
  [1223] = {.lex_state = 73, .external_lex_state = 23},
  [1224] = {.lex_state = 233, .external_lex_state = 9},
  [1225] = {.lex_state = 73, .external_lex_state = 23},
  [1226] = {.lex_state = 233, .external_lex_state = 9},
  [1227] = {.lex_state = 233, .external_lex_state = 9},
  [1228] = {.lex_state = 228, .external_lex_state = 4},
  [1229] = {.lex_state = 228, .external_lex_state = 4},
  [1230] = {.lex_state = 233, .external_lex_state = 9},
  [1231] = {.lex_state = 73, .external_lex_state = 23},
  [1232] = {.lex_state = 73, .external_lex_state = 23},
  [1233] = {.lex_state = 73, .external_lex_state = 23},
  [1234] = {.lex_state = 233, .external_lex_state = 9},
  [1235] = {.lex_state = 84},
  [1236] = {.lex_state = 233, .external_lex_state = 9},
  [1237] = {.lex_state = 73, .external_lex_state = 23},
  [1238] = {.lex_state = 233, .external_lex_state = 9},
  [1239] = {.lex_state = 73, .external_lex_state = 23},
  [1240] = {.lex_state = 73, .external_lex_state = 23},
  [1241] = {.lex_state = 73, .external_lex_state = 23},
  [1242] = {.lex_state = 270, .external_lex_state = 4},
  [1243] = {.lex_state = 233, .external_lex_state = 9},
  [1244] = {.lex_state = 73, .external_lex_state = 23},
  [1245] = {.lex_state = 73, .external_lex_state = 23},
  [1246] = {.lex_state = 73, .external_lex_state = 23},
  [1247] = {.lex_state = 73, .external_lex_state = 23},
  [1248] = {.lex_state = 73, .external_lex_state = 23},
  [1249] = {.lex_state = 73, .external_lex_state = 23},
  [1250] = {.lex_state = 73, .external_lex_state = 23},
  [1251] = {.lex_state = 73, .external_lex_state = 23},
  [1252] = {.lex_state = 73, .external_lex_state = 23},
  [1253] = {.lex_state = 73, .external_lex_state = 23},
  [1254] = {.lex_state = 233, .external_lex_state = 9},
  [1255] = {.lex_state = 228, .external_lex_state = 6},
  [1256] = {.lex_state = 233, .external_lex_state = 6},
  [1257] = {.lex_state = 228, .external_lex_state = 6},
  [1258] = {.lex_state = 233, .external_lex_state = 6},
  [1259] = {.lex_state = 233, .external_lex_state = 6},
  [1260] = {.lex_state = 233, .external_lex_state = 3},
  [1261] = {.lex_state = 233, .external_lex_state = 3},
  [1262] = {.lex_state = 233, .external_lex_state = 6},
  [1263] = {.lex_state = 228, .external_lex_state = 6},
  [1264] = {.lex_state = 228, .external_lex_state = 6},
  [1265] = {.lex_state = 228, .external_lex_state = 6},
  [1266] = {.lex_state = 233, .external_lex_state = 6},
  [1267] = {.lex_state = 84},
  [1268] = {.lex_state = 233, .external_lex_state = 6},
  [1269] = {.lex_state = 228, .external_lex_state = 6},
  [1270] = {.lex_state = 233, .external_lex_state = 6},
  [1271] = {.lex_state = 228, .external_lex_state = 6},
  [1272] = {.lex_state = 228, .external_lex_state = 6},
  [1273] = {.lex_state = 228, .external_lex_state = 6},
  [1274] = {.lex_state = 273, .external_lex_state = 3},
  [1275] = {.lex_state = 233, .external_lex_state = 6},
  [1276] = {.lex_state = 228, .external_lex_state = 6},
  [1277] = {.lex_state = 228, .external_lex_state = 6},
  [1278] = {.lex_state = 228, .external_lex_state = 6},
  [1279] = {.lex_state = 228, .external_lex_state = 6},
  [1280] = {.lex_state = 228, .external_lex_state = 6},
  [1281] = {.lex_state = 228, .external_lex_state = 6},
  [1282] = {.lex_state = 228, .external_lex_state = 6},
  [1283] = {.lex_state = 228, .external_lex_state = 6},
  [1284] = {.lex_state = 228, .external_lex_state = 6},
  [1285] = {.lex_state = 228, .external_lex_state = 6},
  [1286] = {.lex_state = 233, .external_lex_state = 6},
  [1287] = {.lex_state = 233, .external_lex_state = 9},
  [1288] = {.lex_state = 244, .external_lex_state = 9},
  [1289] = {.lex_state = 233, .external_lex_state = 9},
  [1290] = {.lex_state = 244, .external_lex_state = 9},
  [1291] = {.lex_state = 244, .external_lex_state = 9},
  [1292] = {.lex_state = 233, .external_lex_state = 4},
  [1293] = {.lex_state = 233, .external_lex_state = 4},
  [1294] = {.lex_state = 244, .external_lex_state = 9},
  [1295] = {.lex_state = 233, .external_lex_state = 9},
  [1296] = {.lex_state = 233, .external_lex_state = 9},
  [1297] = {.lex_state = 233, .external_lex_state = 9},
  [1298] = {.lex_state = 244, .external_lex_state = 9},
  [1299] = {.lex_state = 84},
  [1300] = {.lex_state = 244, .external_lex_state = 9},
  [1301] = {.lex_state = 233, .external_lex_state = 9},
  [1302] = {.lex_state = 244, .external_lex_state = 9},
  [1303] = {.lex_state = 233, .external_lex_state = 9},
  [1304] = {.lex_state = 233, .external_lex_state = 9},
  [1305] = {.lex_state = 233, .external_lex_state = 9},
  [1306] = {.lex_state = 273, .external_lex_state = 4},
  [1307] = {.lex_state = 244, .external_lex_state = 9},
  [1308] = {.lex_state = 233, .external_lex_state = 9},
  [1309] = {.lex_state = 233, .external_lex_state = 9},
  [1310] = {.lex_state = 233, .external_lex_state = 9},
  [1311] = {.lex_state = 233, .external_lex_state = 9},
  [1312] = {.lex_state = 233, .external_lex_state = 9},
  [1313] = {.lex_state = 233, .external_lex_state = 9},
  [1314] = {.lex_state = 233, .external_lex_state = 9},
  [1315] = {.lex_state = 233, .external_lex_state = 9},
  [1316] = {.lex_state = 233, .external_lex_state = 9},
  [1317] = {.lex_state = 233, .external_lex_state = 9},
  [1318] = {.lex_state = 244, .external_lex_state = 9},
  [1319] = {.lex_state = 233, .external_lex_state = 6},
  [1320] = {.lex_state = 233, .external_lex_state = 6},
  [1321] = {.lex_state = 244, .external_lex_state = 3},
  [1322] = {.lex_state = 244, .external_lex_state = 3},
  [1323] = {.lex_state = 233, .external_lex_state = 6},
  [1324] = {.lex_state = 233, .external_lex_state = 6},
  [1325] = {.lex_state = 233, .external_lex_state = 6},
  [1326] = {.lex_state = 233, .external_lex_state = 6},
  [1327] = {.lex_state = 233, .external_lex_state = 6},
  [1328] = {.lex_state = 233, .external_lex_state = 6},
  [1329] = {.lex_state = 233, .external_lex_state = 6},
  [1330] = {.lex_state = 273, .external_lex_state = 3},
  [1331] = {.lex_state = 233, .external_lex_state = 6},
  [1332] = {.lex_state = 233, .external_lex_state = 6},
  [1333] = {.lex_state = 233, .external_lex_state = 6},
  [1334] = {.lex_state = 233, .external_lex_state = 6},
  [1335] = {.lex_state = 233, .external_lex_state = 6},
  [1336] = {.lex_state = 233, .external_lex_state = 6},
  [1337] = {.lex_state = 233, .external_lex_state = 6},
  [1338] = {.lex_state = 233, .external_lex_state = 6},
  [1339] = {.lex_state = 233, .external_lex_state = 6},
  [1340] = {.lex_state = 233, .external_lex_state = 6},
  [1341] = {.lex_state = 244, .external_lex_state = 9},
  [1342] = {.lex_state = 244, .external_lex_state = 9},
  [1343] = {.lex_state = 244, .external_lex_state = 9},
  [1344] = {.lex_state = 244, .external_lex_state = 9},
  [1345] = {.lex_state = 244, .external_lex_state = 9},
  [1346] = {.lex_state = 244, .external_lex_state = 9},
  [1347] = {.lex_state = 244, .external_lex_state = 9},
  [1348] = {.lex_state = 244, .external_lex_state = 9},
  [1349] = {.lex_state = 244, .external_lex_state = 9},
  [1350] = {.lex_state = 276, .external_lex_state = 4},
  [1351] = {.lex_state = 244, .external_lex_state = 9},
  [1352] = {.lex_state = 244, .external_lex_state = 9},
  [1353] = {.lex_state = 244, .external_lex_state = 9},
  [1354] = {.lex_state = 244, .external_lex_state = 9},
  [1355] = {.lex_state = 244, .external_lex_state = 9},
  [1356] = {.lex_state = 244, .external_lex_state = 9},
  [1357] = {.lex_state = 244, .external_lex_state = 9},
  [1358] = {.lex_state = 244, .external_lex_state = 9},
  [1359] = {.lex_state = 244, .external_lex_state = 9},
  [1360] = {.lex_state = 244, .external_lex_state = 9},
  [1361] = {.lex_state = 84},
  [1362] = {.lex_state = 94},
  [1363] = {.lex_state = 124, .external_lex_state = 7},
  [1364] = {.lex_state = 144},
  [1365] = {.lex_state = 73},
  [1366] = {.lex_state = 73},
  [1367] = {.lex_state = 84, .external_lex_state = 2},
  [1368] = {.lex_state = 73},
  [1369] = {.lex_state = 159, .external_lex_state = 10},
  [1370] = {.lex_state = 159, .external_lex_state = 10},
  [1371] = {.lex_state = 168},
  [1372] = {.lex_state = 84},
  [1373] = {.lex_state = 151, .external_lex_state = 4},
  [1374] = {.lex_state = 155, .external_lex_state = 3},
  [1375] = {.lex_state = 124, .external_lex_state = 7},
  [1376] = {.lex_state = 126},
  [1377] = {.lex_state = 179},
  [1378] = {.lex_state = 73},
  [1379] = {.lex_state = 84, .external_lex_state = 14},
  [1380] = {.lex_state = 84},
  [1381] = {.lex_state = 181},
  [1382] = {.lex_state = 144},
  [1383] = {.lex_state = 84},
  [1384] = {.lex_state = 189, .external_lex_state = 15},
  [1385] = {.lex_state = 192},
  [1386] = {.lex_state = 73, .external_lex_state = 17},
  [1387] = {.lex_state = 84},
  [1388] = {.lex_state = 194, .external_lex_state = 19},
  [1389] = {.lex_state = 194, .external_lex_state = 10},
  [1390] = {.lex_state = 159, .external_lex_state = 10},
  [1391] = {.lex_state = 159, .external_lex_state = 10},
  [1392] = {.lex_state = 196, .external_lex_state = 10},
  [1393] = {.lex_state = 194, .external_lex_state = 19},
  [1394] = {.lex_state = 194, .external_lex_state = 10},
  [1395] = {.lex_state = 73},
  [1396] = {.lex_state = 73, .external_lex_state = 2},
  [1397] = {.lex_state = 200},
  [1398] = {.lex_state = 84},
  [1399] = {.lex_state = 189, .external_lex_state = 22},
  [1400] = {.lex_state = 189, .external_lex_state = 22},
  [1401] = {.lex_state = 189, .external_lex_state = 22},
  [1402] = {.lex_state = 181},
  [1403] = {.lex_state = 84},
  [1404] = {.lex_state = 73, .external_lex_state = 2},
  [1405] = {.lex_state = 73, .external_lex_state = 23},
  [1406] = {.lex_state = 194, .external_lex_state = 10},
  [1407] = {.lex_state = 194, .external_lex_state = 10},
  [1408] = {.lex_state = 194, .external_lex_state = 19},
  [1409] = {.lex_state = 196, .external_lex_state = 10},
  [1410] = {.lex_state = 194, .external_lex_state = 19},
  [1411] = {.lex_state = 194, .external_lex_state = 10},
  [1412] = {.lex_state = 124, .external_lex_state = 20},
  [1413] = {.lex_state = 139, .external_lex_state = 10},
  [1414] = {.lex_state = 124, .external_lex_state = 10},
  [1415] = {.lex_state = 194, .external_lex_state = 10},
  [1416] = {.lex_state = 194, .external_lex_state = 10},
  [1417] = {.lex_state = 73},
  [1418] = {.lex_state = 174, .external_lex_state = 12},
  [1419] = {.lex_state = 84},
  [1420] = {.lex_state = 84},
  [1421] = {.lex_state = 73, .external_lex_state = 2},
  [1422] = {.lex_state = 212},
  [1423] = {.lex_state = 212},
  [1424] = {.lex_state = 84},
  [1425] = {.lex_state = 214, .external_lex_state = 15},
  [1426] = {.lex_state = 189, .external_lex_state = 15},
  [1427] = {.lex_state = 189, .external_lex_state = 15},
  [1428] = {.lex_state = 73, .external_lex_state = 2},
  [1429] = {.lex_state = 73, .external_lex_state = 23},
  [1430] = {.lex_state = 194, .external_lex_state = 10},
  [1431] = {.lex_state = 194, .external_lex_state = 10},
  [1432] = {.lex_state = 124, .external_lex_state = 20},
  [1433] = {.lex_state = 139, .external_lex_state = 10},
  [1434] = {.lex_state = 124, .external_lex_state = 10},
  [1435] = {.lex_state = 194, .external_lex_state = 10},
  [1436] = {.lex_state = 194, .external_lex_state = 10},
  [1437] = {.lex_state = 194, .external_lex_state = 10},
  [1438] = {.lex_state = 84},
  [1439] = {.lex_state = 84},
  [1440] = {.lex_state = 212},
  [1441] = {.lex_state = 168},
  [1442] = {.lex_state = 212},
  [1443] = {.lex_state = 168},
  [1444] = {.lex_state = 84},
  [1445] = {.lex_state = 219},
  [1446] = {.lex_state = 194, .external_lex_state = 10},
  [1447] = {.lex_state = 194, .external_lex_state = 10},
  [1448] = {.lex_state = 84},
  [1449] = {.lex_state = 168},
  [1450] = {.lex_state = 168},
  [1451] = {.lex_state = 219},
  [1452] = {.lex_state = 219},
  [1453] = {.lex_state = 168},
  [1454] = {.lex_state = 168},
  [1455] = {.lex_state = 219},
  [1456] = {.lex_state = 219},
  [1457] = {.lex_state = 219},
  [1458] = {.lex_state = 219},
  [1459] = {.lex_state = 219},
  [1460] = {.lex_state = 132, .external_lex_state = 2},
  [1461] = {.lex_state = 151, .external_lex_state = 4},
  [1462] = {.lex_state = 73, .external_lex_state = 2},
  [1463] = {.lex_state = 84, .external_lex_state = 2},
  [1464] = {.lex_state = 73, .external_lex_state = 16},
  [1465] = {.lex_state = 216, .external_lex_state = 12},
  [1466] = {.lex_state = 73, .external_lex_state = 16},
  [1467] = {.lex_state = 216, .external_lex_state = 12},
  [1468] = {.lex_state = 84},
  [1469] = {.lex_state = 84},
  [1470] = {.lex_state = 84},
  [1471] = {.lex_state = 94},
  [1472] = {.lex_state = 144},
  [1473] = {.lex_state = 73},
  [1474] = {.lex_state = 84, .external_lex_state = 2},
  [1475] = {.lex_state = 73},
  [1476] = {.lex_state = 159, .external_lex_state = 10},
  [1477] = {.lex_state = 159, .external_lex_state = 10},
  [1478] = {.lex_state = 84},
  [1479] = {.lex_state = 126},
  [1480] = {.lex_state = 73},
  [1481] = {.lex_state = 84, .external_lex_state = 14},
  [1482] = {.lex_state = 84},
  [1483] = {.lex_state = 181},
  [1484] = {.lex_state = 144},
  [1485] = {.lex_state = 194, .external_lex_state = 19},
  [1486] = {.lex_state = 194, .external_lex_state = 10},
  [1487] = {.lex_state = 159, .external_lex_state = 10},
  [1488] = {.lex_state = 159, .external_lex_state = 10},
  [1489] = {.lex_state = 196, .external_lex_state = 10},
  [1490] = {.lex_state = 194, .external_lex_state = 19},
  [1491] = {.lex_state = 194, .external_lex_state = 10},
  [1492] = {.lex_state = 200},
  [1493] = {.lex_state = 84},
  [1494] = {.lex_state = 181},
  [1495] = {.lex_state = 194, .external_lex_state = 10},
  [1496] = {.lex_state = 194, .external_lex_state = 10},
  [1497] = {.lex_state = 194, .external_lex_state = 19},
  [1498] = {.lex_state = 196, .external_lex_state = 10},
  [1499] = {.lex_state = 194, .external_lex_state = 19},
  [1500] = {.lex_state = 194, .external_lex_state = 10},
  [1501] = {.lex_state = 124, .external_lex_state = 20},
  [1502] = {.lex_state = 139, .external_lex_state = 10},
  [1503] = {.lex_state = 124, .external_lex_state = 10},
  [1504] = {.lex_state = 194, .external_lex_state = 10},
  [1505] = {.lex_state = 194, .external_lex_state = 10},
  [1506] = {.lex_state = 84},
  [1507] = {.lex_state = 194, .external_lex_state = 10},
  [1508] = {.lex_state = 194, .external_lex_state = 10},
  [1509] = {.lex_state = 124, .external_lex_state = 20},
  [1510] = {.lex_state = 139, .external_lex_state = 10},
  [1511] = {.lex_state = 124, .external_lex_state = 10},
  [1512] = {.lex_state = 194, .external_lex_state = 10},
  [1513] = {.lex_state = 194, .external_lex_state = 10},
  [1514] = {.lex_state = 194, .external_lex_state = 10},
  [1515] = {.lex_state = 194, .external_lex_state = 10},
  [1516] = {.lex_state = 194, .external_lex_state = 10},
  [1517] = {.lex_state = 94},
  [1518] = {.lex_state = 144},
  [1519] = {.lex_state = 73},
  [1520] = {.lex_state = 84, .external_lex_state = 2},
  [1521] = {.lex_state = 73},
  [1522] = {.lex_state = 159, .external_lex_state = 10},
  [1523] = {.lex_state = 159, .external_lex_state = 10},
  [1524] = {.lex_state = 84},
  [1525] = {.lex_state = 73},
  [1526] = {.lex_state = 84, .external_lex_state = 14},
  [1527] = {.lex_state = 181},
  [1528] = {.lex_state = 144},
  [1529] = {.lex_state = 194, .external_lex_state = 19},
  [1530] = {.lex_state = 194, .external_lex_state = 10},
  [1531] = {.lex_state = 159, .external_lex_state = 10},
  [1532] = {.lex_state = 159, .external_lex_state = 10},
  [1533] = {.lex_state = 196, .external_lex_state = 10},
  [1534] = {.lex_state = 194, .external_lex_state = 19},
  [1535] = {.lex_state = 194, .external_lex_state = 10},
  [1536] = {.lex_state = 84},
  [1537] = {.lex_state = 181},
  [1538] = {.lex_state = 194, .external_lex_state = 10},
  [1539] = {.lex_state = 194, .external_lex_state = 10},
  [1540] = {.lex_state = 194, .external_lex_state = 19},
  [1541] = {.lex_state = 196, .external_lex_state = 10},
  [1542] = {.lex_state = 194, .external_lex_state = 19},
  [1543] = {.lex_state = 194, .external_lex_state = 10},
  [1544] = {.lex_state = 124, .external_lex_state = 20},
  [1545] = {.lex_state = 139, .external_lex_state = 10},
  [1546] = {.lex_state = 124, .external_lex_state = 10},
  [1547] = {.lex_state = 194, .external_lex_state = 10},
  [1548] = {.lex_state = 194, .external_lex_state = 10},
  [1549] = {.lex_state = 84},
  [1550] = {.lex_state = 194, .external_lex_state = 10},
  [1551] = {.lex_state = 194, .external_lex_state = 10},
  [1552] = {.lex_state = 124, .external_lex_state = 20},
  [1553] = {.lex_state = 139, .external_lex_state = 10},
  [1554] = {.lex_state = 124, .external_lex_state = 10},
  [1555] = {.lex_state = 194, .external_lex_state = 10},
  [1556] = {.lex_state = 194, .external_lex_state = 10},
  [1557] = {.lex_state = 194, .external_lex_state = 10},
  [1558] = {.lex_state = 194, .external_lex_state = 10},
  [1559] = {.lex_state = 194, .external_lex_state = 10},
  [1560] = {.lex_state = 94},
  [1561] = {.lex_state = 144},
  [1562] = {.lex_state = 73},
  [1563] = {.lex_state = 84, .external_lex_state = 2},
  [1564] = {.lex_state = 73},
  [1565] = {.lex_state = 159, .external_lex_state = 10},
  [1566] = {.lex_state = 159, .external_lex_state = 10},
  [1567] = {.lex_state = 84},
  [1568] = {.lex_state = 73},
  [1569] = {.lex_state = 84, .external_lex_state = 14},
  [1570] = {.lex_state = 181},
  [1571] = {.lex_state = 144},
  [1572] = {.lex_state = 194, .external_lex_state = 19},
  [1573] = {.lex_state = 194, .external_lex_state = 10},
  [1574] = {.lex_state = 159, .external_lex_state = 10},
  [1575] = {.lex_state = 159, .external_lex_state = 10},
  [1576] = {.lex_state = 196, .external_lex_state = 10},
  [1577] = {.lex_state = 194, .external_lex_state = 19},
  [1578] = {.lex_state = 194, .external_lex_state = 10},
  [1579] = {.lex_state = 84},
  [1580] = {.lex_state = 181},
  [1581] = {.lex_state = 194, .external_lex_state = 10},
  [1582] = {.lex_state = 194, .external_lex_state = 10},
  [1583] = {.lex_state = 194, .external_lex_state = 19},
  [1584] = {.lex_state = 196, .external_lex_state = 10},
  [1585] = {.lex_state = 194, .external_lex_state = 19},
  [1586] = {.lex_state = 194, .external_lex_state = 10},
  [1587] = {.lex_state = 124, .external_lex_state = 20},
  [1588] = {.lex_state = 139, .external_lex_state = 10},
  [1589] = {.lex_state = 124, .external_lex_state = 10},
  [1590] = {.lex_state = 194, .external_lex_state = 10},
  [1591] = {.lex_state = 194, .external_lex_state = 10},
  [1592] = {.lex_state = 84},
  [1593] = {.lex_state = 194, .external_lex_state = 10},
  [1594] = {.lex_state = 194, .external_lex_state = 10},
  [1595] = {.lex_state = 124, .external_lex_state = 20},
  [1596] = {.lex_state = 139, .external_lex_state = 10},
  [1597] = {.lex_state = 124, .external_lex_state = 10},
  [1598] = {.lex_state = 194, .external_lex_state = 10},
  [1599] = {.lex_state = 194, .external_lex_state = 10},
  [1600] = {.lex_state = 194, .external_lex_state = 10},
  [1601] = {.lex_state = 194, .external_lex_state = 10},
  [1602] = {.lex_state = 194, .external_lex_state = 10},
  [1603] = {.lex_state = 94},
  [1604] = {.lex_state = 144},
  [1605] = {.lex_state = 73},
  [1606] = {.lex_state = 84, .external_lex_state = 2},
  [1607] = {.lex_state = 73},
  [1608] = {.lex_state = 159, .external_lex_state = 10},
  [1609] = {.lex_state = 159, .external_lex_state = 10},
  [1610] = {.lex_state = 84},
  [1611] = {.lex_state = 73},
  [1612] = {.lex_state = 84, .external_lex_state = 14},
  [1613] = {.lex_state = 181},
  [1614] = {.lex_state = 144},
  [1615] = {.lex_state = 194, .external_lex_state = 19},
  [1616] = {.lex_state = 194, .external_lex_state = 10},
  [1617] = {.lex_state = 159, .external_lex_state = 10},
  [1618] = {.lex_state = 159, .external_lex_state = 10},
  [1619] = {.lex_state = 196, .external_lex_state = 10},
  [1620] = {.lex_state = 194, .external_lex_state = 19},
  [1621] = {.lex_state = 194, .external_lex_state = 10},
  [1622] = {.lex_state = 84},
  [1623] = {.lex_state = 181},
  [1624] = {.lex_state = 194, .external_lex_state = 10},
  [1625] = {.lex_state = 194, .external_lex_state = 10},
  [1626] = {.lex_state = 194, .external_lex_state = 19},
  [1627] = {.lex_state = 196, .external_lex_state = 10},
  [1628] = {.lex_state = 194, .external_lex_state = 19},
  [1629] = {.lex_state = 194, .external_lex_state = 10},
  [1630] = {.lex_state = 124, .external_lex_state = 20},
  [1631] = {.lex_state = 139, .external_lex_state = 10},
  [1632] = {.lex_state = 124, .external_lex_state = 10},
  [1633] = {.lex_state = 194, .external_lex_state = 10},
  [1634] = {.lex_state = 194, .external_lex_state = 10},
  [1635] = {.lex_state = 84},
  [1636] = {.lex_state = 194, .external_lex_state = 10},
  [1637] = {.lex_state = 194, .external_lex_state = 10},
  [1638] = {.lex_state = 124, .external_lex_state = 20},
  [1639] = {.lex_state = 139, .external_lex_state = 10},
  [1640] = {.lex_state = 124, .external_lex_state = 10},
  [1641] = {.lex_state = 194, .external_lex_state = 10},
  [1642] = {.lex_state = 194, .external_lex_state = 10},
  [1643] = {.lex_state = 194, .external_lex_state = 10},
  [1644] = {.lex_state = 194, .external_lex_state = 10},
  [1645] = {.lex_state = 194, .external_lex_state = 10},
  [1646] = {.lex_state = 94},
  [1647] = {.lex_state = 144},
  [1648] = {.lex_state = 73},
  [1649] = {.lex_state = 84, .external_lex_state = 2},
  [1650] = {.lex_state = 73},
  [1651] = {.lex_state = 159, .external_lex_state = 10},
  [1652] = {.lex_state = 159, .external_lex_state = 10},
  [1653] = {.lex_state = 84},
  [1654] = {.lex_state = 73},
  [1655] = {.lex_state = 84, .external_lex_state = 14},
  [1656] = {.lex_state = 181},
  [1657] = {.lex_state = 144},
  [1658] = {.lex_state = 194, .external_lex_state = 19},
  [1659] = {.lex_state = 194, .external_lex_state = 10},
  [1660] = {.lex_state = 159, .external_lex_state = 10},
  [1661] = {.lex_state = 159, .external_lex_state = 10},
  [1662] = {.lex_state = 196, .external_lex_state = 10},
  [1663] = {.lex_state = 194, .external_lex_state = 19},
  [1664] = {.lex_state = 194, .external_lex_state = 10},
  [1665] = {.lex_state = 84},
  [1666] = {.lex_state = 181},
  [1667] = {.lex_state = 194, .external_lex_state = 10},
  [1668] = {.lex_state = 194, .external_lex_state = 10},
  [1669] = {.lex_state = 194, .external_lex_state = 19},
  [1670] = {.lex_state = 196, .external_lex_state = 10},
  [1671] = {.lex_state = 194, .external_lex_state = 19},
  [1672] = {.lex_state = 194, .external_lex_state = 10},
  [1673] = {.lex_state = 124, .external_lex_state = 20},
  [1674] = {.lex_state = 139, .external_lex_state = 10},
  [1675] = {.lex_state = 124, .external_lex_state = 10},
  [1676] = {.lex_state = 194, .external_lex_state = 10},
  [1677] = {.lex_state = 194, .external_lex_state = 10},
  [1678] = {.lex_state = 84},
  [1679] = {.lex_state = 194, .external_lex_state = 10},
  [1680] = {.lex_state = 194, .external_lex_state = 10},
  [1681] = {.lex_state = 124, .external_lex_state = 20},
  [1682] = {.lex_state = 139, .external_lex_state = 10},
  [1683] = {.lex_state = 124, .external_lex_state = 10},
  [1684] = {.lex_state = 194, .external_lex_state = 10},
  [1685] = {.lex_state = 194, .external_lex_state = 10},
  [1686] = {.lex_state = 194, .external_lex_state = 10},
  [1687] = {.lex_state = 194, .external_lex_state = 10},
  [1688] = {.lex_state = 194, .external_lex_state = 10},
  [1689] = {.lex_state = 94},
  [1690] = {.lex_state = 144},
  [1691] = {.lex_state = 73},
  [1692] = {.lex_state = 84, .external_lex_state = 2},
  [1693] = {.lex_state = 73},
  [1694] = {.lex_state = 159, .external_lex_state = 10},
  [1695] = {.lex_state = 159, .external_lex_state = 10},
  [1696] = {.lex_state = 84},
  [1697] = {.lex_state = 73},
  [1698] = {.lex_state = 181},
  [1699] = {.lex_state = 144},
  [1700] = {.lex_state = 194, .external_lex_state = 19},
  [1701] = {.lex_state = 194, .external_lex_state = 10},
  [1702] = {.lex_state = 159, .external_lex_state = 10},
  [1703] = {.lex_state = 159, .external_lex_state = 10},
  [1704] = {.lex_state = 196, .external_lex_state = 10},
  [1705] = {.lex_state = 194, .external_lex_state = 19},
  [1706] = {.lex_state = 194, .external_lex_state = 10},
  [1707] = {.lex_state = 181},
  [1708] = {.lex_state = 194, .external_lex_state = 10},
  [1709] = {.lex_state = 194, .external_lex_state = 10},
  [1710] = {.lex_state = 194, .external_lex_state = 19},
  [1711] = {.lex_state = 196, .external_lex_state = 10},
  [1712] = {.lex_state = 194, .external_lex_state = 19},
  [1713] = {.lex_state = 194, .external_lex_state = 10},
  [1714] = {.lex_state = 124, .external_lex_state = 20},
  [1715] = {.lex_state = 139, .external_lex_state = 10},
  [1716] = {.lex_state = 124, .external_lex_state = 10},
  [1717] = {.lex_state = 194, .external_lex_state = 10},
  [1718] = {.lex_state = 194, .external_lex_state = 10},
  [1719] = {.lex_state = 194, .external_lex_state = 10},
  [1720] = {.lex_state = 194, .external_lex_state = 10},
  [1721] = {.lex_state = 124, .external_lex_state = 20},
  [1722] = {.lex_state = 139, .external_lex_state = 10},
  [1723] = {.lex_state = 124, .external_lex_state = 10},
  [1724] = {.lex_state = 194, .external_lex_state = 10},
  [1725] = {.lex_state = 194, .external_lex_state = 10},
  [1726] = {.lex_state = 194, .external_lex_state = 10},
  [1727] = {.lex_state = 194, .external_lex_state = 10},
  [1728] = {.lex_state = 194, .external_lex_state = 10},
  [1729] = {.lex_state = 94},
  [1730] = {.lex_state = 144},
  [1731] = {.lex_state = 73},
  [1732] = {.lex_state = 84, .external_lex_state = 2},
  [1733] = {.lex_state = 73},
  [1734] = {.lex_state = 159, .external_lex_state = 10},
  [1735] = {.lex_state = 159, .external_lex_state = 10},
  [1736] = {.lex_state = 84},
  [1737] = {.lex_state = 73},
  [1738] = {.lex_state = 181},
  [1739] = {.lex_state = 144},
  [1740] = {.lex_state = 194, .external_lex_state = 19},
  [1741] = {.lex_state = 194, .external_lex_state = 10},
  [1742] = {.lex_state = 159, .external_lex_state = 10},
  [1743] = {.lex_state = 159, .external_lex_state = 10},
  [1744] = {.lex_state = 196, .external_lex_state = 10},
  [1745] = {.lex_state = 194, .external_lex_state = 19},
  [1746] = {.lex_state = 194, .external_lex_state = 10},
  [1747] = {.lex_state = 181},
  [1748] = {.lex_state = 194, .external_lex_state = 10},
  [1749] = {.lex_state = 194, .external_lex_state = 10},
  [1750] = {.lex_state = 194, .external_lex_state = 19},
  [1751] = {.lex_state = 196, .external_lex_state = 10},
  [1752] = {.lex_state = 194, .external_lex_state = 19},
  [1753] = {.lex_state = 194, .external_lex_state = 10},
  [1754] = {.lex_state = 124, .external_lex_state = 20},
  [1755] = {.lex_state = 139, .external_lex_state = 10},
  [1756] = {.lex_state = 124, .external_lex_state = 10},
  [1757] = {.lex_state = 194, .external_lex_state = 10},
  [1758] = {.lex_state = 194, .external_lex_state = 10},
  [1759] = {.lex_state = 194, .external_lex_state = 10},
  [1760] = {.lex_state = 194, .external_lex_state = 10},
  [1761] = {.lex_state = 124, .external_lex_state = 20},
  [1762] = {.lex_state = 139, .external_lex_state = 10},
  [1763] = {.lex_state = 124, .external_lex_state = 10},
  [1764] = {.lex_state = 194, .external_lex_state = 10},
  [1765] = {.lex_state = 194, .external_lex_state = 10},
  [1766] = {.lex_state = 194, .external_lex_state = 10},
  [1767] = {.lex_state = 194, .external_lex_state = 10},
  [1768] = {.lex_state = 194, .external_lex_state = 10},
  [1769] = {.lex_state = 94},
  [1770] = {.lex_state = 144},
  [1771] = {.lex_state = 73},
  [1772] = {.lex_state = 84, .external_lex_state = 2},
  [1773] = {.lex_state = 73},
  [1774] = {.lex_state = 159, .external_lex_state = 10},
  [1775] = {.lex_state = 159, .external_lex_state = 10},
  [1776] = {.lex_state = 84},
  [1777] = {.lex_state = 73},
  [1778] = {.lex_state = 181},
  [1779] = {.lex_state = 144},
  [1780] = {.lex_state = 194, .external_lex_state = 19},
  [1781] = {.lex_state = 194, .external_lex_state = 10},
  [1782] = {.lex_state = 159, .external_lex_state = 10},
  [1783] = {.lex_state = 159, .external_lex_state = 10},
  [1784] = {.lex_state = 196, .external_lex_state = 10},
  [1785] = {.lex_state = 194, .external_lex_state = 19},
  [1786] = {.lex_state = 194, .external_lex_state = 10},
  [1787] = {.lex_state = 181},
  [1788] = {.lex_state = 194, .external_lex_state = 10},
  [1789] = {.lex_state = 194, .external_lex_state = 10},
  [1790] = {.lex_state = 194, .external_lex_state = 19},
  [1791] = {.lex_state = 196, .external_lex_state = 10},
  [1792] = {.lex_state = 194, .external_lex_state = 19},
  [1793] = {.lex_state = 194, .external_lex_state = 10},
  [1794] = {.lex_state = 124, .external_lex_state = 20},
  [1795] = {.lex_state = 139, .external_lex_state = 10},
  [1796] = {.lex_state = 124, .external_lex_state = 10},
  [1797] = {.lex_state = 194, .external_lex_state = 10},
  [1798] = {.lex_state = 194, .external_lex_state = 10},
  [1799] = {.lex_state = 194, .external_lex_state = 10},
  [1800] = {.lex_state = 194, .external_lex_state = 10},
  [1801] = {.lex_state = 124, .external_lex_state = 20},
  [1802] = {.lex_state = 139, .external_lex_state = 10},
  [1803] = {.lex_state = 124, .external_lex_state = 10},
  [1804] = {.lex_state = 194, .external_lex_state = 10},
  [1805] = {.lex_state = 194, .external_lex_state = 10},
  [1806] = {.lex_state = 194, .external_lex_state = 10},
  [1807] = {.lex_state = 194, .external_lex_state = 10},
  [1808] = {.lex_state = 194, .external_lex_state = 10},
  [1809] = {.lex_state = 94},
  [1810] = {.lex_state = 144},
  [1811] = {.lex_state = 73},
  [1812] = {.lex_state = 84, .external_lex_state = 2},
  [1813] = {.lex_state = 73},
  [1814] = {.lex_state = 159, .external_lex_state = 10},
  [1815] = {.lex_state = 159, .external_lex_state = 10},
  [1816] = {.lex_state = 84},
  [1817] = {.lex_state = 73},
  [1818] = {.lex_state = 181},
  [1819] = {.lex_state = 144},
  [1820] = {.lex_state = 194, .external_lex_state = 19},
  [1821] = {.lex_state = 194, .external_lex_state = 10},
  [1822] = {.lex_state = 159, .external_lex_state = 10},
  [1823] = {.lex_state = 159, .external_lex_state = 10},
  [1824] = {.lex_state = 196, .external_lex_state = 10},
  [1825] = {.lex_state = 194, .external_lex_state = 19},
  [1826] = {.lex_state = 194, .external_lex_state = 10},
  [1827] = {.lex_state = 181},
  [1828] = {.lex_state = 194, .external_lex_state = 10},
  [1829] = {.lex_state = 194, .external_lex_state = 10},
  [1830] = {.lex_state = 194, .external_lex_state = 19},
  [1831] = {.lex_state = 196, .external_lex_state = 10},
  [1832] = {.lex_state = 194, .external_lex_state = 19},
  [1833] = {.lex_state = 194, .external_lex_state = 10},
  [1834] = {.lex_state = 124, .external_lex_state = 20},
  [1835] = {.lex_state = 139, .external_lex_state = 10},
  [1836] = {.lex_state = 124, .external_lex_state = 10},
  [1837] = {.lex_state = 194, .external_lex_state = 10},
  [1838] = {.lex_state = 194, .external_lex_state = 10},
  [1839] = {.lex_state = 194, .external_lex_state = 10},
  [1840] = {.lex_state = 194, .external_lex_state = 10},
  [1841] = {.lex_state = 124, .external_lex_state = 20},
  [1842] = {.lex_state = 139, .external_lex_state = 10},
  [1843] = {.lex_state = 124, .external_lex_state = 10},
  [1844] = {.lex_state = 194, .external_lex_state = 10},
  [1845] = {.lex_state = 194, .external_lex_state = 10},
  [1846] = {.lex_state = 194, .external_lex_state = 10},
  [1847] = {.lex_state = 194, .external_lex_state = 10},
  [1848] = {.lex_state = 194, .external_lex_state = 10},
  [1849] = {.lex_state = 94},
  [1850] = {.lex_state = 144},
  [1851] = {.lex_state = 73},
  [1852] = {.lex_state = 84, .external_lex_state = 2},
  [1853] = {.lex_state = 73},
  [1854] = {.lex_state = 159, .external_lex_state = 10},
  [1855] = {.lex_state = 159, .external_lex_state = 10},
  [1856] = {.lex_state = 84},
  [1857] = {.lex_state = 73},
  [1858] = {.lex_state = 181},
  [1859] = {.lex_state = 144},
  [1860] = {.lex_state = 194, .external_lex_state = 19},
  [1861] = {.lex_state = 194, .external_lex_state = 10},
  [1862] = {.lex_state = 159, .external_lex_state = 10},
  [1863] = {.lex_state = 159, .external_lex_state = 10},
  [1864] = {.lex_state = 196, .external_lex_state = 10},
  [1865] = {.lex_state = 194, .external_lex_state = 19},
  [1866] = {.lex_state = 194, .external_lex_state = 10},
  [1867] = {.lex_state = 181},
  [1868] = {.lex_state = 194, .external_lex_state = 10},
  [1869] = {.lex_state = 194, .external_lex_state = 10},
  [1870] = {.lex_state = 194, .external_lex_state = 19},
  [1871] = {.lex_state = 196, .external_lex_state = 10},
  [1872] = {.lex_state = 194, .external_lex_state = 19},
  [1873] = {.lex_state = 194, .external_lex_state = 10},
  [1874] = {.lex_state = 124, .external_lex_state = 20},
  [1875] = {.lex_state = 139, .external_lex_state = 10},
  [1876] = {.lex_state = 124, .external_lex_state = 10},
  [1877] = {.lex_state = 194, .external_lex_state = 10},
  [1878] = {.lex_state = 194, .external_lex_state = 10},
  [1879] = {.lex_state = 194, .external_lex_state = 10},
  [1880] = {.lex_state = 194, .external_lex_state = 10},
  [1881] = {.lex_state = 124, .external_lex_state = 20},
  [1882] = {.lex_state = 139, .external_lex_state = 10},
  [1883] = {.lex_state = 124, .external_lex_state = 10},
  [1884] = {.lex_state = 194, .external_lex_state = 10},
  [1885] = {.lex_state = 194, .external_lex_state = 10},
  [1886] = {.lex_state = 194, .external_lex_state = 10},
  [1887] = {.lex_state = 194, .external_lex_state = 10},
  [1888] = {.lex_state = 194, .external_lex_state = 10},
  [1889] = {.lex_state = 94},
  [1890] = {.lex_state = 144},
  [1891] = {.lex_state = 73},
  [1892] = {.lex_state = 84, .external_lex_state = 2},
  [1893] = {.lex_state = 73},
  [1894] = {.lex_state = 159, .external_lex_state = 10},
  [1895] = {.lex_state = 159, .external_lex_state = 10},
  [1896] = {.lex_state = 84},
  [1897] = {.lex_state = 73},
  [1898] = {.lex_state = 181},
  [1899] = {.lex_state = 144},
  [1900] = {.lex_state = 194, .external_lex_state = 19},
  [1901] = {.lex_state = 194, .external_lex_state = 10},
  [1902] = {.lex_state = 159, .external_lex_state = 10},
  [1903] = {.lex_state = 159, .external_lex_state = 10},
  [1904] = {.lex_state = 196, .external_lex_state = 10},
  [1905] = {.lex_state = 194, .external_lex_state = 19},
  [1906] = {.lex_state = 194, .external_lex_state = 10},
  [1907] = {.lex_state = 181},
  [1908] = {.lex_state = 194, .external_lex_state = 10},
  [1909] = {.lex_state = 194, .external_lex_state = 10},
  [1910] = {.lex_state = 194, .external_lex_state = 19},
  [1911] = {.lex_state = 196, .external_lex_state = 10},
  [1912] = {.lex_state = 194, .external_lex_state = 19},
  [1913] = {.lex_state = 194, .external_lex_state = 10},
  [1914] = {.lex_state = 124, .external_lex_state = 20},
  [1915] = {.lex_state = 139, .external_lex_state = 10},
  [1916] = {.lex_state = 124, .external_lex_state = 10},
  [1917] = {.lex_state = 194, .external_lex_state = 10},
  [1918] = {.lex_state = 194, .external_lex_state = 10},
  [1919] = {.lex_state = 194, .external_lex_state = 10},
  [1920] = {.lex_state = 194, .external_lex_state = 10},
  [1921] = {.lex_state = 124, .external_lex_state = 20},
  [1922] = {.lex_state = 139, .external_lex_state = 10},
  [1923] = {.lex_state = 124, .external_lex_state = 10},
  [1924] = {.lex_state = 194, .external_lex_state = 10},
  [1925] = {.lex_state = 194, .external_lex_state = 10},
  [1926] = {.lex_state = 194, .external_lex_state = 10},
  [1927] = {.lex_state = 194, .external_lex_state = 10},
  [1928] = {.lex_state = 194, .external_lex_state = 10},
  [1929] = {.lex_state = 94},
  [1930] = {.lex_state = 144},
  [1931] = {.lex_state = 73},
  [1932] = {.lex_state = 84, .external_lex_state = 2},
  [1933] = {.lex_state = 73},
  [1934] = {.lex_state = 159, .external_lex_state = 10},
  [1935] = {.lex_state = 159, .external_lex_state = 10},
  [1936] = {.lex_state = 84},
  [1937] = {.lex_state = 73},
  [1938] = {.lex_state = 181},
  [1939] = {.lex_state = 144},
  [1940] = {.lex_state = 194, .external_lex_state = 19},
  [1941] = {.lex_state = 194, .external_lex_state = 10},
  [1942] = {.lex_state = 159, .external_lex_state = 10},
  [1943] = {.lex_state = 159, .external_lex_state = 10},
  [1944] = {.lex_state = 196, .external_lex_state = 10},
  [1945] = {.lex_state = 194, .external_lex_state = 19},
  [1946] = {.lex_state = 194, .external_lex_state = 10},
  [1947] = {.lex_state = 181},
  [1948] = {.lex_state = 194, .external_lex_state = 10},
  [1949] = {.lex_state = 194, .external_lex_state = 10},
  [1950] = {.lex_state = 194, .external_lex_state = 19},
  [1951] = {.lex_state = 196, .external_lex_state = 10},
  [1952] = {.lex_state = 194, .external_lex_state = 19},
  [1953] = {.lex_state = 194, .external_lex_state = 10},
  [1954] = {.lex_state = 124, .external_lex_state = 20},
  [1955] = {.lex_state = 139, .external_lex_state = 10},
  [1956] = {.lex_state = 124, .external_lex_state = 10},
  [1957] = {.lex_state = 194, .external_lex_state = 10},
  [1958] = {.lex_state = 194, .external_lex_state = 10},
  [1959] = {.lex_state = 194, .external_lex_state = 10},
  [1960] = {.lex_state = 194, .external_lex_state = 10},
  [1961] = {.lex_state = 124, .external_lex_state = 20},
  [1962] = {.lex_state = 139, .external_lex_state = 10},
  [1963] = {.lex_state = 124, .external_lex_state = 10},
  [1964] = {.lex_state = 194, .external_lex_state = 10},
  [1965] = {.lex_state = 194, .external_lex_state = 10},
  [1966] = {.lex_state = 194, .external_lex_state = 10},
  [1967] = {.lex_state = 194, .external_lex_state = 10},
  [1968] = {.lex_state = 194, .external_lex_state = 10},
  [1969] = {.lex_state = 94},
  [1970] = {.lex_state = 144},
  [1971] = {.lex_state = 73},
  [1972] = {.lex_state = 84, .external_lex_state = 2},
  [1973] = {.lex_state = 73},
  [1974] = {.lex_state = 159, .external_lex_state = 10},
  [1975] = {.lex_state = 159, .external_lex_state = 10},
  [1976] = {.lex_state = 84},
  [1977] = {.lex_state = 73},
  [1978] = {.lex_state = 181},
  [1979] = {.lex_state = 144},
  [1980] = {.lex_state = 194, .external_lex_state = 19},
  [1981] = {.lex_state = 194, .external_lex_state = 10},
  [1982] = {.lex_state = 159, .external_lex_state = 10},
  [1983] = {.lex_state = 159, .external_lex_state = 10},
  [1984] = {.lex_state = 196, .external_lex_state = 10},
  [1985] = {.lex_state = 194, .external_lex_state = 19},
  [1986] = {.lex_state = 194, .external_lex_state = 10},
  [1987] = {.lex_state = 181},
  [1988] = {.lex_state = 194, .external_lex_state = 10},
  [1989] = {.lex_state = 194, .external_lex_state = 10},
  [1990] = {.lex_state = 194, .external_lex_state = 19},
  [1991] = {.lex_state = 196, .external_lex_state = 10},
  [1992] = {.lex_state = 194, .external_lex_state = 19},
  [1993] = {.lex_state = 194, .external_lex_state = 10},
  [1994] = {.lex_state = 124, .external_lex_state = 20},
  [1995] = {.lex_state = 139, .external_lex_state = 10},
  [1996] = {.lex_state = 124, .external_lex_state = 10},
  [1997] = {.lex_state = 194, .external_lex_state = 10},
  [1998] = {.lex_state = 194, .external_lex_state = 10},
  [1999] = {.lex_state = 194, .external_lex_state = 10},
  [2000] = {.lex_state = 194, .external_lex_state = 10},
  [2001] = {.lex_state = 124, .external_lex_state = 20},
  [2002] = {.lex_state = 139, .external_lex_state = 10},
  [2003] = {.lex_state = 124, .external_lex_state = 10},
  [2004] = {.lex_state = 194, .external_lex_state = 10},
  [2005] = {.lex_state = 194, .external_lex_state = 10},
  [2006] = {.lex_state = 194, .external_lex_state = 10},
  [2007] = {.lex_state = 194, .external_lex_state = 10},
  [2008] = {.lex_state = 194, .external_lex_state = 10},
  [2009] = {.lex_state = 94},
  [2010] = {.lex_state = 144},
  [2011] = {.lex_state = 73},
  [2012] = {.lex_state = 84, .external_lex_state = 2},
  [2013] = {.lex_state = 73},
  [2014] = {.lex_state = 159, .external_lex_state = 10},
  [2015] = {.lex_state = 159, .external_lex_state = 10},
  [2016] = {.lex_state = 84},
  [2017] = {.lex_state = 73},
  [2018] = {.lex_state = 181},
  [2019] = {.lex_state = 144},
  [2020] = {.lex_state = 194, .external_lex_state = 19},
  [2021] = {.lex_state = 194, .external_lex_state = 10},
  [2022] = {.lex_state = 159, .external_lex_state = 10},
  [2023] = {.lex_state = 159, .external_lex_state = 10},
  [2024] = {.lex_state = 196, .external_lex_state = 10},
  [2025] = {.lex_state = 194, .external_lex_state = 19},
  [2026] = {.lex_state = 194, .external_lex_state = 10},
  [2027] = {.lex_state = 181},
  [2028] = {.lex_state = 194, .external_lex_state = 10},
  [2029] = {.lex_state = 194, .external_lex_state = 10},
  [2030] = {.lex_state = 194, .external_lex_state = 19},
  [2031] = {.lex_state = 196, .external_lex_state = 10},
  [2032] = {.lex_state = 194, .external_lex_state = 19},
  [2033] = {.lex_state = 194, .external_lex_state = 10},
  [2034] = {.lex_state = 124, .external_lex_state = 20},
  [2035] = {.lex_state = 139, .external_lex_state = 10},
  [2036] = {.lex_state = 124, .external_lex_state = 10},
  [2037] = {.lex_state = 194, .external_lex_state = 10},
  [2038] = {.lex_state = 194, .external_lex_state = 10},
  [2039] = {.lex_state = 194, .external_lex_state = 10},
  [2040] = {.lex_state = 194, .external_lex_state = 10},
  [2041] = {.lex_state = 124, .external_lex_state = 20},
  [2042] = {.lex_state = 139, .external_lex_state = 10},
  [2043] = {.lex_state = 124, .external_lex_state = 10},
  [2044] = {.lex_state = 194, .external_lex_state = 10},
  [2045] = {.lex_state = 194, .external_lex_state = 10},
  [2046] = {.lex_state = 194, .external_lex_state = 10},
  [2047] = {.lex_state = 194, .external_lex_state = 10},
  [2048] = {.lex_state = 194, .external_lex_state = 10},
  [2049] = {.lex_state = 94},
  [2050] = {.lex_state = 144},
  [2051] = {.lex_state = 73},
  [2052] = {.lex_state = 84, .external_lex_state = 2},
  [2053] = {.lex_state = 73},
  [2054] = {.lex_state = 159, .external_lex_state = 10},
  [2055] = {.lex_state = 159, .external_lex_state = 10},
  [2056] = {.lex_state = 84},
  [2057] = {.lex_state = 73},
  [2058] = {.lex_state = 181},
  [2059] = {.lex_state = 144},
  [2060] = {.lex_state = 194, .external_lex_state = 19},
  [2061] = {.lex_state = 194, .external_lex_state = 10},
  [2062] = {.lex_state = 159, .external_lex_state = 10},
  [2063] = {.lex_state = 159, .external_lex_state = 10},
  [2064] = {.lex_state = 196, .external_lex_state = 10},
  [2065] = {.lex_state = 194, .external_lex_state = 19},
  [2066] = {.lex_state = 194, .external_lex_state = 10},
  [2067] = {.lex_state = 181},
  [2068] = {.lex_state = 194, .external_lex_state = 10},
  [2069] = {.lex_state = 194, .external_lex_state = 10},
  [2070] = {.lex_state = 194, .external_lex_state = 19},
  [2071] = {.lex_state = 196, .external_lex_state = 10},
  [2072] = {.lex_state = 194, .external_lex_state = 19},
  [2073] = {.lex_state = 194, .external_lex_state = 10},
  [2074] = {.lex_state = 124, .external_lex_state = 20},
  [2075] = {.lex_state = 139, .external_lex_state = 10},
  [2076] = {.lex_state = 124, .external_lex_state = 10},
  [2077] = {.lex_state = 194, .external_lex_state = 10},
  [2078] = {.lex_state = 194, .external_lex_state = 10},
  [2079] = {.lex_state = 194, .external_lex_state = 10},
  [2080] = {.lex_state = 194, .external_lex_state = 10},
  [2081] = {.lex_state = 124, .external_lex_state = 20},
  [2082] = {.lex_state = 139, .external_lex_state = 10},
  [2083] = {.lex_state = 124, .external_lex_state = 10},
  [2084] = {.lex_state = 194, .external_lex_state = 10},
  [2085] = {.lex_state = 194, .external_lex_state = 10},
  [2086] = {.lex_state = 194, .external_lex_state = 10},
  [2087] = {.lex_state = 194, .external_lex_state = 10},
  [2088] = {.lex_state = 194, .external_lex_state = 10},
  [2089] = {.lex_state = 94},
  [2090] = {.lex_state = 144},
  [2091] = {.lex_state = 73},
  [2092] = {.lex_state = 84, .external_lex_state = 2},
  [2093] = {.lex_state = 73},
  [2094] = {.lex_state = 159, .external_lex_state = 10},
  [2095] = {.lex_state = 159, .external_lex_state = 10},
  [2096] = {.lex_state = 84},
  [2097] = {.lex_state = 73},
  [2098] = {.lex_state = 181},
  [2099] = {.lex_state = 144},
  [2100] = {.lex_state = 194, .external_lex_state = 19},
  [2101] = {.lex_state = 194, .external_lex_state = 10},
  [2102] = {.lex_state = 159, .external_lex_state = 10},
  [2103] = {.lex_state = 159, .external_lex_state = 10},
  [2104] = {.lex_state = 196, .external_lex_state = 10},
  [2105] = {.lex_state = 194, .external_lex_state = 19},
  [2106] = {.lex_state = 194, .external_lex_state = 10},
  [2107] = {.lex_state = 181},
  [2108] = {.lex_state = 194, .external_lex_state = 10},
  [2109] = {.lex_state = 194, .external_lex_state = 10},
  [2110] = {.lex_state = 194, .external_lex_state = 19},
  [2111] = {.lex_state = 196, .external_lex_state = 10},
  [2112] = {.lex_state = 194, .external_lex_state = 19},
  [2113] = {.lex_state = 194, .external_lex_state = 10},
  [2114] = {.lex_state = 124, .external_lex_state = 20},
  [2115] = {.lex_state = 139, .external_lex_state = 10},
  [2116] = {.lex_state = 124, .external_lex_state = 10},
  [2117] = {.lex_state = 194, .external_lex_state = 10},
  [2118] = {.lex_state = 194, .external_lex_state = 10},
  [2119] = {.lex_state = 194, .external_lex_state = 10},
  [2120] = {.lex_state = 194, .external_lex_state = 10},
  [2121] = {.lex_state = 124, .external_lex_state = 20},
  [2122] = {.lex_state = 139, .external_lex_state = 10},
  [2123] = {.lex_state = 124, .external_lex_state = 10},
  [2124] = {.lex_state = 194, .external_lex_state = 10},
  [2125] = {.lex_state = 194, .external_lex_state = 10},
  [2126] = {.lex_state = 194, .external_lex_state = 10},
  [2127] = {.lex_state = 194, .external_lex_state = 10},
  [2128] = {.lex_state = 194, .external_lex_state = 10},
  [2129] = {.lex_state = 94},
  [2130] = {.lex_state = 144},
  [2131] = {.lex_state = 73},
  [2132] = {.lex_state = 84, .external_lex_state = 2},
  [2133] = {.lex_state = 73},
  [2134] = {.lex_state = 159, .external_lex_state = 10},
  [2135] = {.lex_state = 159, .external_lex_state = 10},
  [2136] = {.lex_state = 84},
  [2137] = {.lex_state = 73},
  [2138] = {.lex_state = 181},
  [2139] = {.lex_state = 144},
  [2140] = {.lex_state = 194, .external_lex_state = 19},
  [2141] = {.lex_state = 194, .external_lex_state = 10},
  [2142] = {.lex_state = 159, .external_lex_state = 10},
  [2143] = {.lex_state = 159, .external_lex_state = 10},
  [2144] = {.lex_state = 196, .external_lex_state = 10},
  [2145] = {.lex_state = 194, .external_lex_state = 19},
  [2146] = {.lex_state = 194, .external_lex_state = 10},
  [2147] = {.lex_state = 181},
  [2148] = {.lex_state = 194, .external_lex_state = 10},
  [2149] = {.lex_state = 194, .external_lex_state = 10},
  [2150] = {.lex_state = 194, .external_lex_state = 19},
  [2151] = {.lex_state = 196, .external_lex_state = 10},
  [2152] = {.lex_state = 194, .external_lex_state = 19},
  [2153] = {.lex_state = 194, .external_lex_state = 10},
  [2154] = {.lex_state = 124, .external_lex_state = 20},
  [2155] = {.lex_state = 139, .external_lex_state = 10},
  [2156] = {.lex_state = 124, .external_lex_state = 10},
  [2157] = {.lex_state = 194, .external_lex_state = 10},
  [2158] = {.lex_state = 194, .external_lex_state = 10},
  [2159] = {.lex_state = 194, .external_lex_state = 10},
  [2160] = {.lex_state = 194, .external_lex_state = 10},
  [2161] = {.lex_state = 124, .external_lex_state = 20},
  [2162] = {.lex_state = 139, .external_lex_state = 10},
  [2163] = {.lex_state = 124, .external_lex_state = 10},
  [2164] = {.lex_state = 194, .external_lex_state = 10},
  [2165] = {.lex_state = 194, .external_lex_state = 10},
  [2166] = {.lex_state = 194, .external_lex_state = 10},
  [2167] = {.lex_state = 194, .external_lex_state = 10},
  [2168] = {.lex_state = 194, .external_lex_state = 10},
  [2169] = {.lex_state = 94},
  [2170] = {.lex_state = 144},
  [2171] = {.lex_state = 73},
  [2172] = {.lex_state = 84, .external_lex_state = 2},
  [2173] = {.lex_state = 73},
  [2174] = {.lex_state = 159, .external_lex_state = 10},
  [2175] = {.lex_state = 159, .external_lex_state = 10},
  [2176] = {.lex_state = 84},
  [2177] = {.lex_state = 73},
  [2178] = {.lex_state = 181},
  [2179] = {.lex_state = 144},
  [2180] = {.lex_state = 194, .external_lex_state = 19},
  [2181] = {.lex_state = 194, .external_lex_state = 10},
  [2182] = {.lex_state = 159, .external_lex_state = 10},
  [2183] = {.lex_state = 159, .external_lex_state = 10},
  [2184] = {.lex_state = 196, .external_lex_state = 10},
  [2185] = {.lex_state = 194, .external_lex_state = 19},
  [2186] = {.lex_state = 194, .external_lex_state = 10},
  [2187] = {.lex_state = 181},
  [2188] = {.lex_state = 194, .external_lex_state = 10},
  [2189] = {.lex_state = 194, .external_lex_state = 10},
  [2190] = {.lex_state = 194, .external_lex_state = 19},
  [2191] = {.lex_state = 196, .external_lex_state = 10},
  [2192] = {.lex_state = 194, .external_lex_state = 19},
  [2193] = {.lex_state = 194, .external_lex_state = 10},
  [2194] = {.lex_state = 124, .external_lex_state = 20},
  [2195] = {.lex_state = 139, .external_lex_state = 10},
  [2196] = {.lex_state = 124, .external_lex_state = 10},
  [2197] = {.lex_state = 194, .external_lex_state = 10},
  [2198] = {.lex_state = 194, .external_lex_state = 10},
  [2199] = {.lex_state = 194, .external_lex_state = 10},
  [2200] = {.lex_state = 194, .external_lex_state = 10},
  [2201] = {.lex_state = 124, .external_lex_state = 20},
  [2202] = {.lex_state = 139, .external_lex_state = 10},
  [2203] = {.lex_state = 124, .external_lex_state = 10},
  [2204] = {.lex_state = 194, .external_lex_state = 10},
  [2205] = {.lex_state = 194, .external_lex_state = 10},
  [2206] = {.lex_state = 194, .external_lex_state = 10},
  [2207] = {.lex_state = 194, .external_lex_state = 10},
  [2208] = {.lex_state = 194, .external_lex_state = 10},
  [2209] = {.lex_state = 94},
  [2210] = {.lex_state = 144},
  [2211] = {.lex_state = 73},
  [2212] = {.lex_state = 84, .external_lex_state = 2},
  [2213] = {.lex_state = 73},
  [2214] = {.lex_state = 159, .external_lex_state = 10},
  [2215] = {.lex_state = 159, .external_lex_state = 10},
  [2216] = {.lex_state = 84},
  [2217] = {.lex_state = 73},
  [2218] = {.lex_state = 181},
  [2219] = {.lex_state = 144},
  [2220] = {.lex_state = 194, .external_lex_state = 19},
  [2221] = {.lex_state = 194, .external_lex_state = 10},
  [2222] = {.lex_state = 159, .external_lex_state = 10},
  [2223] = {.lex_state = 159, .external_lex_state = 10},
  [2224] = {.lex_state = 196, .external_lex_state = 10},
  [2225] = {.lex_state = 194, .external_lex_state = 19},
  [2226] = {.lex_state = 194, .external_lex_state = 10},
  [2227] = {.lex_state = 181},
  [2228] = {.lex_state = 194, .external_lex_state = 10},
  [2229] = {.lex_state = 194, .external_lex_state = 10},
  [2230] = {.lex_state = 194, .external_lex_state = 19},
  [2231] = {.lex_state = 196, .external_lex_state = 10},
  [2232] = {.lex_state = 194, .external_lex_state = 19},
  [2233] = {.lex_state = 194, .external_lex_state = 10},
  [2234] = {.lex_state = 124, .external_lex_state = 20},
  [2235] = {.lex_state = 139, .external_lex_state = 10},
  [2236] = {.lex_state = 124, .external_lex_state = 10},
  [2237] = {.lex_state = 194, .external_lex_state = 10},
  [2238] = {.lex_state = 194, .external_lex_state = 10},
  [2239] = {.lex_state = 194, .external_lex_state = 10},
  [2240] = {.lex_state = 194, .external_lex_state = 10},
  [2241] = {.lex_state = 124, .external_lex_state = 20},
  [2242] = {.lex_state = 139, .external_lex_state = 10},
  [2243] = {.lex_state = 124, .external_lex_state = 10},
  [2244] = {.lex_state = 194, .external_lex_state = 10},
  [2245] = {.lex_state = 194, .external_lex_state = 10},
  [2246] = {.lex_state = 194, .external_lex_state = 10},
  [2247] = {.lex_state = 194, .external_lex_state = 10},
  [2248] = {.lex_state = 194, .external_lex_state = 10},
  [2249] = {.lex_state = 94},
  [2250] = {.lex_state = 144},
  [2251] = {.lex_state = 73},
  [2252] = {.lex_state = 84, .external_lex_state = 2},
  [2253] = {.lex_state = 73},
  [2254] = {.lex_state = 159, .external_lex_state = 10},
  [2255] = {.lex_state = 159, .external_lex_state = 10},
  [2256] = {.lex_state = 84},
  [2257] = {.lex_state = 73},
  [2258] = {.lex_state = 181},
  [2259] = {.lex_state = 144},
  [2260] = {.lex_state = 194, .external_lex_state = 19},
  [2261] = {.lex_state = 194, .external_lex_state = 10},
  [2262] = {.lex_state = 159, .external_lex_state = 10},
  [2263] = {.lex_state = 159, .external_lex_state = 10},
  [2264] = {.lex_state = 196, .external_lex_state = 10},
  [2265] = {.lex_state = 194, .external_lex_state = 19},
  [2266] = {.lex_state = 194, .external_lex_state = 10},
  [2267] = {.lex_state = 181},
  [2268] = {.lex_state = 194, .external_lex_state = 10},
  [2269] = {.lex_state = 194, .external_lex_state = 10},
  [2270] = {.lex_state = 194, .external_lex_state = 19},
  [2271] = {.lex_state = 196, .external_lex_state = 10},
  [2272] = {.lex_state = 194, .external_lex_state = 19},
  [2273] = {.lex_state = 194, .external_lex_state = 10},
  [2274] = {.lex_state = 124, .external_lex_state = 20},
  [2275] = {.lex_state = 139, .external_lex_state = 10},
  [2276] = {.lex_state = 124, .external_lex_state = 10},
  [2277] = {.lex_state = 194, .external_lex_state = 10},
  [2278] = {.lex_state = 194, .external_lex_state = 10},
  [2279] = {.lex_state = 194, .external_lex_state = 10},
  [2280] = {.lex_state = 194, .external_lex_state = 10},
  [2281] = {.lex_state = 124, .external_lex_state = 20},
  [2282] = {.lex_state = 139, .external_lex_state = 10},
  [2283] = {.lex_state = 124, .external_lex_state = 10},
  [2284] = {.lex_state = 194, .external_lex_state = 10},
  [2285] = {.lex_state = 194, .external_lex_state = 10},
  [2286] = {.lex_state = 194, .external_lex_state = 10},
  [2287] = {.lex_state = 194, .external_lex_state = 10},
  [2288] = {.lex_state = 194, .external_lex_state = 10},
  [2289] = {.lex_state = 94},
  [2290] = {.lex_state = 144},
  [2291] = {.lex_state = 73},
  [2292] = {.lex_state = 84, .external_lex_state = 2},
  [2293] = {.lex_state = 73},
  [2294] = {.lex_state = 159, .external_lex_state = 10},
  [2295] = {.lex_state = 159, .external_lex_state = 10},
  [2296] = {.lex_state = 84},
  [2297] = {.lex_state = 73},
  [2298] = {.lex_state = 181},
  [2299] = {.lex_state = 144},
  [2300] = {.lex_state = 194, .external_lex_state = 19},
  [2301] = {.lex_state = 194, .external_lex_state = 10},
  [2302] = {.lex_state = 159, .external_lex_state = 10},
  [2303] = {.lex_state = 159, .external_lex_state = 10},
  [2304] = {.lex_state = 196, .external_lex_state = 10},
  [2305] = {.lex_state = 194, .external_lex_state = 19},
  [2306] = {.lex_state = 194, .external_lex_state = 10},
  [2307] = {.lex_state = 181},
  [2308] = {.lex_state = 194, .external_lex_state = 10},
  [2309] = {.lex_state = 194, .external_lex_state = 10},
  [2310] = {.lex_state = 194, .external_lex_state = 19},
  [2311] = {.lex_state = 196, .external_lex_state = 10},
  [2312] = {.lex_state = 194, .external_lex_state = 19},
  [2313] = {.lex_state = 194, .external_lex_state = 10},
  [2314] = {.lex_state = 124, .external_lex_state = 20},
  [2315] = {.lex_state = 139, .external_lex_state = 10},
  [2316] = {.lex_state = 124, .external_lex_state = 10},
  [2317] = {.lex_state = 194, .external_lex_state = 10},
  [2318] = {.lex_state = 194, .external_lex_state = 10},
  [2319] = {.lex_state = 194, .external_lex_state = 10},
  [2320] = {.lex_state = 194, .external_lex_state = 10},
  [2321] = {.lex_state = 124, .external_lex_state = 20},
  [2322] = {.lex_state = 139, .external_lex_state = 10},
  [2323] = {.lex_state = 124, .external_lex_state = 10},
  [2324] = {.lex_state = 194, .external_lex_state = 10},
  [2325] = {.lex_state = 194, .external_lex_state = 10},
  [2326] = {.lex_state = 194, .external_lex_state = 10},
  [2327] = {.lex_state = 194, .external_lex_state = 10},
  [2328] = {.lex_state = 194, .external_lex_state = 10},
  [2329] = {.lex_state = 84, .external_lex_state = 2},
  [2330] = {.lex_state = 73},
  [2331] = {.lex_state = 159, .external_lex_state = 10},
  [2332] = {.lex_state = 159, .external_lex_state = 10},
  [2333] = {.lex_state = 73},
  [2334] = {.lex_state = 194, .external_lex_state = 19},
  [2335] = {.lex_state = 194, .external_lex_state = 10},
  [2336] = {.lex_state = 159, .external_lex_state = 10},
  [2337] = {.lex_state = 159, .external_lex_state = 10},
  [2338] = {.lex_state = 196, .external_lex_state = 10},
  [2339] = {.lex_state = 194, .external_lex_state = 19},
  [2340] = {.lex_state = 194, .external_lex_state = 10},
  [2341] = {.lex_state = 194, .external_lex_state = 10},
  [2342] = {.lex_state = 194, .external_lex_state = 10},
  [2343] = {.lex_state = 194, .external_lex_state = 19},
  [2344] = {.lex_state = 196, .external_lex_state = 10},
  [2345] = {.lex_state = 194, .external_lex_state = 19},
  [2346] = {.lex_state = 194, .external_lex_state = 10},
  [2347] = {.lex_state = 124, .external_lex_state = 20},
  [2348] = {.lex_state = 139, .external_lex_state = 10},
  [2349] = {.lex_state = 124, .external_lex_state = 10},
  [2350] = {.lex_state = 194, .external_lex_state = 10},
  [2351] = {.lex_state = 194, .external_lex_state = 10},
  [2352] = {.lex_state = 194, .external_lex_state = 10},
  [2353] = {.lex_state = 194, .external_lex_state = 10},
  [2354] = {.lex_state = 124, .external_lex_state = 20},
  [2355] = {.lex_state = 139, .external_lex_state = 10},
  [2356] = {.lex_state = 124, .external_lex_state = 10},
  [2357] = {.lex_state = 194, .external_lex_state = 10},
  [2358] = {.lex_state = 194, .external_lex_state = 10},
  [2359] = {.lex_state = 194, .external_lex_state = 10},
  [2360] = {.lex_state = 194, .external_lex_state = 10},
  [2361] = {.lex_state = 194, .external_lex_state = 10},
  [2362] = {.lex_state = 84, .external_lex_state = 2},
  [2363] = {.lex_state = 73},
  [2364] = {.lex_state = 159, .external_lex_state = 10},
  [2365] = {.lex_state = 159, .external_lex_state = 10},
  [2366] = {.lex_state = 73},
  [2367] = {.lex_state = 194, .external_lex_state = 19},
  [2368] = {.lex_state = 194, .external_lex_state = 10},
  [2369] = {.lex_state = 159, .external_lex_state = 10},
  [2370] = {.lex_state = 159, .external_lex_state = 10},
  [2371] = {.lex_state = 196, .external_lex_state = 10},
  [2372] = {.lex_state = 194, .external_lex_state = 19},
  [2373] = {.lex_state = 194, .external_lex_state = 10},
  [2374] = {.lex_state = 194, .external_lex_state = 10},
  [2375] = {.lex_state = 194, .external_lex_state = 10},
  [2376] = {.lex_state = 194, .external_lex_state = 19},
  [2377] = {.lex_state = 196, .external_lex_state = 10},
  [2378] = {.lex_state = 194, .external_lex_state = 19},
  [2379] = {.lex_state = 194, .external_lex_state = 10},
  [2380] = {.lex_state = 124, .external_lex_state = 20},
  [2381] = {.lex_state = 139, .external_lex_state = 10},
  [2382] = {.lex_state = 124, .external_lex_state = 10},
  [2383] = {.lex_state = 194, .external_lex_state = 10},
  [2384] = {.lex_state = 194, .external_lex_state = 10},
  [2385] = {.lex_state = 194, .external_lex_state = 10},
  [2386] = {.lex_state = 194, .external_lex_state = 10},
  [2387] = {.lex_state = 124, .external_lex_state = 20},
  [2388] = {.lex_state = 139, .external_lex_state = 10},
  [2389] = {.lex_state = 124, .external_lex_state = 10},
  [2390] = {.lex_state = 194, .external_lex_state = 10},
  [2391] = {.lex_state = 194, .external_lex_state = 10},
  [2392] = {.lex_state = 194, .external_lex_state = 10},
  [2393] = {.lex_state = 194, .external_lex_state = 10},
  [2394] = {.lex_state = 194, .external_lex_state = 10},
  [2395] = {.lex_state = 73, .external_lex_state = 2},
  [2396] = {.lex_state = 73, .external_lex_state = 2},
  [2397] = {.lex_state = 73, .external_lex_state = 2},
  [2398] = {.lex_state = 94, .external_lex_state = 5},
  [2399] = {.lex_state = 84},
  [2400] = {.lex_state = 126},
  [2401] = {.lex_state = 73, .external_lex_state = 2},
  [2402] = {.lex_state = 134},
  [2403] = {.lex_state = 139},
  [2404] = {.lex_state = 73, .external_lex_state = 2},
  [2405] = {.lex_state = 126},
  [2406] = {.lex_state = 126},
  [2407] = {.lex_state = 134},
  [2408] = {.lex_state = 163, .external_lex_state = 5},
  [2409] = {.lex_state = 134},
  [2410] = {.lex_state = 73},
  [2411] = {.lex_state = 84},
  [2412] = {.lex_state = 126},
  [2413] = {.lex_state = 84},
  [2414] = {.lex_state = 174, .external_lex_state = 12},
  [2415] = {.lex_state = 134},
  [2416] = {.lex_state = 73},
  [2417] = {.lex_state = 174, .external_lex_state = 12},
  [2418] = {.lex_state = 174, .external_lex_state = 12},
  [2419] = {.lex_state = 174, .external_lex_state = 12},
  [2420] = {.lex_state = 174, .external_lex_state = 12},
  [2421] = {.lex_state = 216, .external_lex_state = 12},
  [2422] = {.lex_state = 126},
  [2423] = {.lex_state = 84},
  [2424] = {.lex_state = 84},
  [2425] = {.lex_state = 179},
  [2426] = {.lex_state = 126},
  [2427] = {.lex_state = 84},
  [2428] = {.lex_state = 84},
  [2429] = {.lex_state = 179},
  [2430] = {.lex_state = 126},
  [2431] = {.lex_state = 179},
  [2432] = {.lex_state = 189, .external_lex_state = 22},
  [2433] = {.lex_state = 231, .external_lex_state = 6},
  [2434] = {.lex_state = 231, .external_lex_state = 6},
  [2435] = {.lex_state = 84},
  [2436] = {.lex_state = 84},
  [2437] = {.lex_state = 84},
  [2438] = {.lex_state = 73, .external_lex_state = 2},
  [2439] = {.lex_state = 73, .external_lex_state = 2},
  [2440] = {.lex_state = 94, .external_lex_state = 5},
  [2441] = {.lex_state = 73, .external_lex_state = 2},
  [2442] = {.lex_state = 134},
  [2443] = {.lex_state = 139},
  [2444] = {.lex_state = 134},
  [2445] = {.lex_state = 163, .external_lex_state = 5},
  [2446] = {.lex_state = 134},
  [2447] = {.lex_state = 126},
  [2448] = {.lex_state = 134},
  [2449] = {.lex_state = 73, .external_lex_state = 2},
  [2450] = {.lex_state = 73, .external_lex_state = 2},
  [2451] = {.lex_state = 94, .external_lex_state = 5},
  [2452] = {.lex_state = 73, .external_lex_state = 2},
  [2453] = {.lex_state = 134},
  [2454] = {.lex_state = 139},
  [2455] = {.lex_state = 134},
  [2456] = {.lex_state = 163, .external_lex_state = 5},
  [2457] = {.lex_state = 134},
  [2458] = {.lex_state = 134},
  [2459] = {.lex_state = 73, .external_lex_state = 2},
  [2460] = {.lex_state = 73, .external_lex_state = 2},
  [2461] = {.lex_state = 94, .external_lex_state = 5},
  [2462] = {.lex_state = 73, .external_lex_state = 2},
  [2463] = {.lex_state = 134},
  [2464] = {.lex_state = 134},
  [2465] = {.lex_state = 163, .external_lex_state = 5},
  [2466] = {.lex_state = 134},
  [2467] = {.lex_state = 134},
  [2468] = {.lex_state = 73, .external_lex_state = 2},
  [2469] = {.lex_state = 73, .external_lex_state = 2},
  [2470] = {.lex_state = 94, .external_lex_state = 5},
  [2471] = {.lex_state = 73, .external_lex_state = 2},
  [2472] = {.lex_state = 134},
  [2473] = {.lex_state = 134},
  [2474] = {.lex_state = 163, .external_lex_state = 5},
  [2475] = {.lex_state = 134},
  [2476] = {.lex_state = 134},
  [2477] = {.lex_state = 73, .external_lex_state = 2},
  [2478] = {.lex_state = 73, .external_lex_state = 2},
  [2479] = {.lex_state = 94, .external_lex_state = 5},
  [2480] = {.lex_state = 73, .external_lex_state = 2},
  [2481] = {.lex_state = 134},
  [2482] = {.lex_state = 134},
  [2483] = {.lex_state = 163, .external_lex_state = 5},
  [2484] = {.lex_state = 134},
  [2485] = {.lex_state = 134},
  [2486] = {.lex_state = 73, .external_lex_state = 2},
  [2487] = {.lex_state = 73, .external_lex_state = 2},
  [2488] = {.lex_state = 94, .external_lex_state = 5},
  [2489] = {.lex_state = 73, .external_lex_state = 2},
  [2490] = {.lex_state = 163, .external_lex_state = 5},
  [2491] = {.lex_state = 134},
  [2492] = {.lex_state = 134},
  [2493] = {.lex_state = 73, .external_lex_state = 2},
  [2494] = {.lex_state = 73, .external_lex_state = 2},
  [2495] = {.lex_state = 94, .external_lex_state = 5},
  [2496] = {.lex_state = 73, .external_lex_state = 2},
  [2497] = {.lex_state = 163, .external_lex_state = 5},
  [2498] = {.lex_state = 134},
  [2499] = {.lex_state = 134},
  [2500] = {.lex_state = 73, .external_lex_state = 2},
  [2501] = {.lex_state = 73, .external_lex_state = 2},
  [2502] = {.lex_state = 94, .external_lex_state = 5},
  [2503] = {.lex_state = 73, .external_lex_state = 2},
  [2504] = {.lex_state = 163, .external_lex_state = 5},
  [2505] = {.lex_state = 134},
  [2506] = {.lex_state = 134},
  [2507] = {.lex_state = 73, .external_lex_state = 2},
  [2508] = {.lex_state = 73, .external_lex_state = 2},
  [2509] = {.lex_state = 94, .external_lex_state = 5},
  [2510] = {.lex_state = 73, .external_lex_state = 2},
  [2511] = {.lex_state = 163, .external_lex_state = 5},
  [2512] = {.lex_state = 134},
  [2513] = {.lex_state = 134},
  [2514] = {.lex_state = 73, .external_lex_state = 2},
  [2515] = {.lex_state = 73, .external_lex_state = 2},
  [2516] = {.lex_state = 94, .external_lex_state = 5},
  [2517] = {.lex_state = 73, .external_lex_state = 2},
  [2518] = {.lex_state = 163, .external_lex_state = 5},
  [2519] = {.lex_state = 134},
  [2520] = {.lex_state = 134},
  [2521] = {.lex_state = 73, .external_lex_state = 2},
  [2522] = {.lex_state = 73, .external_lex_state = 2},
  [2523] = {.lex_state = 94, .external_lex_state = 5},
  [2524] = {.lex_state = 73, .external_lex_state = 2},
  [2525] = {.lex_state = 163, .external_lex_state = 5},
  [2526] = {.lex_state = 134},
  [2527] = {.lex_state = 134},
  [2528] = {.lex_state = 73, .external_lex_state = 2},
  [2529] = {.lex_state = 73, .external_lex_state = 2},
  [2530] = {.lex_state = 94, .external_lex_state = 5},
  [2531] = {.lex_state = 73, .external_lex_state = 2},
  [2532] = {.lex_state = 163, .external_lex_state = 5},
  [2533] = {.lex_state = 134},
  [2534] = {.lex_state = 134},
  [2535] = {.lex_state = 73, .external_lex_state = 2},
  [2536] = {.lex_state = 73, .external_lex_state = 2},
  [2537] = {.lex_state = 94, .external_lex_state = 5},
  [2538] = {.lex_state = 73, .external_lex_state = 2},
  [2539] = {.lex_state = 163, .external_lex_state = 5},
  [2540] = {.lex_state = 134},
  [2541] = {.lex_state = 134},
  [2542] = {.lex_state = 73, .external_lex_state = 2},
  [2543] = {.lex_state = 73, .external_lex_state = 2},
  [2544] = {.lex_state = 94, .external_lex_state = 5},
  [2545] = {.lex_state = 73, .external_lex_state = 2},
  [2546] = {.lex_state = 163, .external_lex_state = 5},
  [2547] = {.lex_state = 134},
  [2548] = {.lex_state = 134},
  [2549] = {.lex_state = 73, .external_lex_state = 2},
  [2550] = {.lex_state = 73, .external_lex_state = 2},
  [2551] = {.lex_state = 94, .external_lex_state = 5},
  [2552] = {.lex_state = 73, .external_lex_state = 2},
  [2553] = {.lex_state = 163, .external_lex_state = 5},
  [2554] = {.lex_state = 134},
  [2555] = {.lex_state = 134},
  [2556] = {.lex_state = 73, .external_lex_state = 2},
  [2557] = {.lex_state = 73, .external_lex_state = 2},
  [2558] = {.lex_state = 94, .external_lex_state = 5},
  [2559] = {.lex_state = 73, .external_lex_state = 2},
  [2560] = {.lex_state = 163, .external_lex_state = 5},
  [2561] = {.lex_state = 134},
  [2562] = {.lex_state = 134},
  [2563] = {.lex_state = 73, .external_lex_state = 2},
  [2564] = {.lex_state = 73, .external_lex_state = 2},
  [2565] = {.lex_state = 94, .external_lex_state = 5},
  [2566] = {.lex_state = 73, .external_lex_state = 2},
  [2567] = {.lex_state = 163, .external_lex_state = 5},
  [2568] = {.lex_state = 134},
  [2569] = {.lex_state = 134},
  [2570] = {.lex_state = 73, .external_lex_state = 2},
  [2571] = {.lex_state = 73, .external_lex_state = 2},
  [2572] = {.lex_state = 94, .external_lex_state = 5},
  [2573] = {.lex_state = 73, .external_lex_state = 2},
  [2574] = {.lex_state = 163, .external_lex_state = 5},
  [2575] = {.lex_state = 134},
  [2576] = {.lex_state = 134},
  [2577] = {.lex_state = 73, .external_lex_state = 2},
  [2578] = {.lex_state = 73, .external_lex_state = 2},
  [2579] = {.lex_state = 94, .external_lex_state = 5},
  [2580] = {.lex_state = 73, .external_lex_state = 2},
  [2581] = {.lex_state = 163, .external_lex_state = 5},
  [2582] = {.lex_state = 134},
  [2583] = {.lex_state = 134},
  [2584] = {.lex_state = 73, .external_lex_state = 2},
  [2585] = {.lex_state = 73, .external_lex_state = 2},
  [2586] = {.lex_state = 94, .external_lex_state = 5},
  [2587] = {.lex_state = 73, .external_lex_state = 2},
  [2588] = {.lex_state = 163, .external_lex_state = 5},
  [2589] = {.lex_state = 134},
  [2590] = {.lex_state = 134},
  [2591] = {.lex_state = 73, .external_lex_state = 2},
  [2592] = {.lex_state = 73, .external_lex_state = 2},
  [2593] = {.lex_state = 94, .external_lex_state = 5},
  [2594] = {.lex_state = 73, .external_lex_state = 2},
  [2595] = {.lex_state = 163, .external_lex_state = 5},
  [2596] = {.lex_state = 134},
  [2597] = {.lex_state = 134},
  [2598] = {.lex_state = 73, .external_lex_state = 2},
  [2599] = {.lex_state = 94, .external_lex_state = 5},
  [2600] = {.lex_state = 73, .external_lex_state = 2},
  [2601] = {.lex_state = 163, .external_lex_state = 5},
  [2602] = {.lex_state = 134},
  [2603] = {.lex_state = 134},
  [2604] = {.lex_state = 73, .external_lex_state = 2},
  [2605] = {.lex_state = 94, .external_lex_state = 5},
  [2606] = {.lex_state = 73, .external_lex_state = 2},
  [2607] = {.lex_state = 163, .external_lex_state = 5},
  [2608] = {.lex_state = 134},
  [2609] = {.lex_state = 134},
  [2610] = {.lex_state = 73, .external_lex_state = 2},
  [2611] = {.lex_state = 139},
  [2612] = {.lex_state = 174, .external_lex_state = 11},
  [2613] = {.lex_state = 174, .external_lex_state = 12},
  [2614] = {.lex_state = 174, .external_lex_state = 12},
  [2615] = {.lex_state = 198},
  [2616] = {.lex_state = 198},
  [2617] = {.lex_state = 84},
  [2618] = {.lex_state = 186, .external_lex_state = 12},
  [2619] = {.lex_state = 202, .external_lex_state = 12},
  [2620] = {.lex_state = 186, .external_lex_state = 12},
  [2621] = {.lex_state = 202, .external_lex_state = 12},
  [2622] = {.lex_state = 231, .external_lex_state = 4},
  [2623] = {.lex_state = 231, .external_lex_state = 4},
  [2624] = {.lex_state = 231, .external_lex_state = 6},
  [2625] = {.lex_state = 231, .external_lex_state = 4},
  [2626] = {.lex_state = 231, .external_lex_state = 6},
  [2627] = {.lex_state = 231, .external_lex_state = 6},
  [2628] = {.lex_state = 84},
  [2629] = {.lex_state = 186, .external_lex_state = 12},
  [2630] = {.lex_state = 202, .external_lex_state = 12},
};

enum {
  ts_external_token_heredoc_start = 0,
  ts_external_token__simple_heredoc_body = 1,
  ts_external_token__heredoc_body_beginning = 2,
  ts_external_token__heredoc_body_middle = 3,
  ts_external_token__heredoc_body_end = 4,
  ts_external_token_file_descriptor = 5,
  ts_external_token__empty_value = 6,
  ts_external_token__concat = 7,
  ts_external_token_variable_name = 8,
  ts_external_token_regex = 9,
  ts_external_token_RBRACE = 10,
  ts_external_token_RBRACK = 11,
  ts_external_token_LT_LT = 12,
  ts_external_token_LT_LT_DASH = 13,
  ts_external_token_LF = 14,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token_heredoc_start] = sym_heredoc_start,
  [ts_external_token__simple_heredoc_body] = sym__simple_heredoc_body,
  [ts_external_token__heredoc_body_beginning] = sym__heredoc_body_beginning,
  [ts_external_token__heredoc_body_middle] = sym__heredoc_body_middle,
  [ts_external_token__heredoc_body_end] = sym__heredoc_body_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_regex] = sym_regex,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LT_LT] = anon_sym_LT_LT,
  [ts_external_token_LT_LT_DASH] = anon_sym_LT_LT_DASH,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[24][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token_heredoc_start] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__simple_heredoc_body] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_regex] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
  [2] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_variable_name] = true,
  },
  [6] = {
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
  },
  [8] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [9] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LT_LT_DASH] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LT_LT] = true,
    [ts_external_token_LF] = true,
  },
  [10] = {
    [ts_external_token_RBRACE] = true,
  },
  [11] = {
    [ts_external_token_LF] = true,
    [ts_external_token__concat] = true,
  },
  [12] = {
    [ts_external_token_LF] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token__empty_value] = true,
  },
  [15] = {
    [ts_external_token_RBRACK] = true,
  },
  [16] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [17] = {
    [ts_external_token_heredoc_start] = true,
  },
  [18] = {
    [ts_external_token_regex] = true,
  },
  [19] = {
    [ts_external_token_regex] = true,
    [ts_external_token_RBRACE] = true,
  },
  [20] = {
    [ts_external_token_RBRACE] = true,
    [ts_external_token__concat] = true,
  },
  [21] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token__heredoc_body_beginning] = true,
    [ts_external_token__simple_heredoc_body] = true,
  },
  [22] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [23] = {
    [ts_external_token__heredoc_body_end] = true,
    [ts_external_token__heredoc_body_middle] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_test_operator] = ACTIONS(1),
    [sym_heredoc_start] = ACTIONS(1),
    [anon_sym_AMP_GT_GT] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [anon_sym_typeset] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DOLLAR] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_GT_LPAREN] = ACTIONS(1),
    [anon_sym_done] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1),
    [sym_word] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym__simple_heredoc_body] = ACTIONS(1),
    [anon_sym_LT_AMP] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [anon_sym_export] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [sym__special_character] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1),
    [sym_raw_string] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_declare] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym__heredoc_body_beginning] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_unset] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_GT_AMP] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [sym_regex] = ACTIONS(1),
    [anon_sym_SEMI_SEMI] = ACTIONS(1),
    [sym__heredoc_body_middle] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_local] = ACTIONS(1),
    [anon_sym_unsetenv] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_fi] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_function] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [sym__heredoc_body_end] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_DASH] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_COLON_QMARK] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_0] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [anon_sym_AMP_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_LT_LT_LT] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_LT_LPAREN] = ACTIONS(1),
    [anon_sym_esac] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_COLON_DASH] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_PIPE_AMP] = ACTIONS(1),
  },
  [1] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(28),
    [sym_function_definition] = STATE(28),
    [sym_negated_command] = STATE(28),
    [sym_test_command] = STATE(28),
    [sym_variable_assignment] = STATE(29),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(32),
    [sym_program] = STATE(33),
    [sym_redirected_statement] = STATE(28),
    [sym_for_statement] = STATE(28),
    [sym_compound_statement] = STATE(28),
    [sym_subshell] = STATE(28),
    [sym_declaration_command] = STATE(28),
    [sym_unset_command] = STATE(28),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym__statements] = STATE(35),
    [sym_c_style_for_statement] = STATE(28),
    [sym_while_statement] = STATE(28),
    [sym_case_statement] = STATE(28),
    [sym_pipeline] = STATE(28),
    [sym_list] = STATE(28),
    [sym_command] = STATE(28),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [ts_builtin_sym_end] = ACTIONS(47),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [2] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(37),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [3] = {
    [sym_command_substitution] = STATE(38),
    [aux_sym__literal_repeat1] = STATE(39),
    [sym_string] = STATE(38),
    [sym_process_substitution] = STATE(38),
    [sym_simple_expansion] = STATE(38),
    [sym_string_expansion] = STATE(38),
    [sym_concatenation] = STATE(40),
    [sym_expansion] = STATE(38),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [sym_raw_string] = ACTIONS(109),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_GT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_word] = ACTIONS(109),
    [anon_sym_LT_LPAREN] = ACTIONS(113),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(121),
  },
  [4] = {
    [sym_command_substitution] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(42),
    [sym_string] = STATE(41),
    [aux_sym_declaration_command_repeat1] = STATE(43),
    [sym_process_substitution] = STATE(41),
    [sym_simple_expansion] = STATE(41),
    [sym_subscript] = STATE(2444),
    [sym_string_expansion] = STATE(41),
    [sym_variable_assignment] = STATE(43),
    [sym_concatenation] = STATE(43),
    [sym_expansion] = STATE(41),
    [anon_sym_AMP_GT_GT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(131),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [sym_word] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_AMP] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym__special_character] = ACTIONS(137),
    [anon_sym_LT_LT_DASH] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(139),
    [anon_sym_LF] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(123),
    [sym_raw_string] = ACTIONS(135),
    [sym_variable_name] = ACTIONS(143),
    [sym_file_descriptor] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_AMP_GT] = ACTIONS(123),
    [ts_builtin_sym_end] = ACTIONS(141),
    [anon_sym_LT_LT_LT] = ACTIONS(123),
    [anon_sym_GT_AMP] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(123),
    [anon_sym_SEMI_SEMI] = ACTIONS(123),
    [anon_sym_PIPE_AMP] = ACTIONS(123),
  },
  [5] = {
    [sym_command_substitution] = STATE(44),
    [aux_sym__literal_repeat1] = STATE(45),
    [sym_string] = STATE(44),
    [aux_sym_unset_command_repeat1] = STATE(46),
    [sym_process_substitution] = STATE(44),
    [sym_simple_expansion] = STATE(44),
    [sym_string_expansion] = STATE(44),
    [sym_concatenation] = STATE(46),
    [sym_expansion] = STATE(44),
    [anon_sym_AMP_GT_GT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(147),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [aux_sym__simple_variable_name_token1] = ACTIONS(155),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [sym_word] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(147),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym__special_character] = ACTIONS(161),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(159),
    [sym_file_descriptor] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [ts_builtin_sym_end] = ACTIONS(165),
    [anon_sym_LT_LT_LT] = ACTIONS(147),
    [anon_sym_GT_AMP] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_SEMI_SEMI] = ACTIONS(147),
    [anon_sym_PIPE_AMP] = ACTIONS(147),
  },
  [6] = {
    [sym_string] = STATE(48),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_QMARK] = ACTIONS(169),
    [sym_raw_string] = ACTIONS(171),
    [anon_sym_BANG] = ACTIONS(173),
    [anon_sym_AT] = ACTIONS(169),
    [anon_sym_DOLLAR] = ACTIONS(173),
    [anon_sym_POUND] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_0] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(175),
    [anon_sym__] = ACTIONS(175),
  },
  [7] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(50),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [8] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(51),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(52),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [9] = {
    [sym_subscript] = STATE(53),
    [anon_sym_STAR] = ACTIONS(177),
    [anon_sym_QMARK] = ACTIONS(177),
    [anon_sym_BANG] = ACTIONS(179),
    [anon_sym_AT] = ACTIONS(177),
    [sym_variable_name] = ACTIONS(181),
    [anon_sym_DOLLAR] = ACTIONS(183),
    [anon_sym_DASH] = ACTIONS(183),
    [anon_sym_0] = ACTIONS(185),
    [anon_sym_POUND] = ACTIONS(179),
    [aux_sym__simple_variable_name_token1] = ACTIONS(185),
    [anon_sym__] = ACTIONS(185),
    [sym_comment] = ACTIONS(3),
  },
  [10] = {
    [sym_comment] = ACTIONS(51),
    [sym_word] = ACTIONS(187),
  },
  [11] = {
    [aux_sym_concatenation_repeat1] = STATE(60),
    [anon_sym_LPAREN] = ACTIONS(189),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(193),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [ts_builtin_sym_end] = ACTIONS(195),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [12] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_negated_command] = STATE(62),
    [sym_test_command] = STATE(62),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(64),
    [sym_redirected_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_subshell] = STATE(62),
    [sym_declaration_command] = STATE(62),
    [sym_unset_command] = STATE(62),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_pipeline] = STATE(62),
    [sym_list] = STATE(62),
    [sym_command] = STATE(62),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(197),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [13] = {
    [aux_sym_concatenation_repeat1] = STATE(60),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(193),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [14] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym__terminated_statement] = STATE(65),
    [sym_if_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_negated_command] = STATE(66),
    [sym_test_command] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_compound_statement] = STATE(66),
    [sym_subshell] = STATE(66),
    [sym_declaration_command] = STATE(66),
    [sym_unset_command] = STATE(66),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_pipeline] = STATE(66),
    [sym_list] = STATE(66),
    [sym_command] = STATE(66),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [15] = {
    [sym_command_substitution] = STATE(68),
    [aux_sym__literal_repeat1] = STATE(69),
    [sym_string] = STATE(68),
    [sym_process_substitution] = STATE(68),
    [sym_simple_expansion] = STATE(68),
    [sym_string_expansion] = STATE(68),
    [sym_concatenation] = STATE(70),
    [sym_expansion] = STATE(68),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [sym_word] = ACTIONS(207),
    [sym_raw_string] = ACTIONS(207),
    [anon_sym_LT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(213),
    [sym__special_character] = ACTIONS(215),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
  },
  [16] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(75),
    [sym_postfix_expression] = STATE(75),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(75),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(75),
    [sym_binary_expression] = STATE(75),
    [sym_concatenation] = STATE(75),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [17] = {
    [aux_sym_concatenation_repeat1] = STATE(60),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(193),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [ts_builtin_sym_end] = ACTIONS(195),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [18] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(76),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [19] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [sym_test_command] = STATE(77),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(34),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_command] = STATE(77),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [sym_subshell] = STATE(77),
    [sym_file_redirect] = STATE(34),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
    [sym__special_character] = ACTIONS(29),
  },
  [20] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(251),
  },
  [21] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(255),
    [anon_sym_GT_AMP] = ACTIONS(255),
    [anon_sym_LT] = ACTIONS(257),
    [anon_sym_LT_AMP] = ACTIONS(255),
    [anon_sym_GT_GT] = ACTIONS(255),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(257),
    [anon_sym_AMP_GT] = ACTIONS(257),
  },
  [22] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(84),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(259),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [23] = {
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(271),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(273),
  },
  [24] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym__terminated_statement] = STATE(87),
    [sym_if_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_negated_command] = STATE(66),
    [sym_test_command] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_compound_statement] = STATE(66),
    [sym_subshell] = STATE(66),
    [sym_declaration_command] = STATE(66),
    [sym_unset_command] = STATE(66),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_pipeline] = STATE(66),
    [sym_list] = STATE(66),
    [sym_command] = STATE(66),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [25] = {
    [sym_command_substitution] = STATE(407),
    [sym_unary_expression] = STATE(88),
    [sym_postfix_expression] = STATE(88),
    [sym_string] = STATE(407),
    [aux_sym__literal_repeat1] = STATE(408),
    [sym_process_substitution] = STATE(407),
    [sym_parenthesized_expression] = STATE(88),
    [sym_simple_expansion] = STATE(407),
    [sym_string_expansion] = STATE(407),
    [sym__expression] = STATE(88),
    [sym_binary_expression] = STATE(88),
    [sym_concatenation] = STATE(88),
    [sym_expansion] = STATE(407),
    [sym_test_operator] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(281),
    [sym_raw_string] = ACTIONS(283),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [26] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(89),
    [sym_postfix_expression] = STATE(89),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(89),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(89),
    [sym_binary_expression] = STATE(89),
    [sym_concatenation] = STATE(89),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [27] = {
    [aux_sym__literal_repeat1] = STATE(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [sym_word] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [sym__special_character] = ACTIONS(301),
    [anon_sym_LT_LT_DASH] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LF] = ACTIONS(303),
    [anon_sym_SEMI] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [anon_sym_LT_LT_LT] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [ts_builtin_sym_end] = ACTIONS(303),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_SEMI_SEMI] = ACTIONS(299),
    [anon_sym_PIPE_AMP] = ACTIONS(299),
  },
  [28] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_AMP_GT_GT] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(305),
    [sym_file_descriptor] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_GT] = ACTIONS(307),
    [anon_sym_AMP_GT] = ACTIONS(307),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [ts_builtin_sym_end] = ACTIONS(317),
    [anon_sym_LT_LT_LT] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(307),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_LT] = ACTIONS(307),
    [anon_sym_LT_AMP] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(307),
    [anon_sym_PIPE] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_LT_LT_DASH] = ACTIONS(313),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
  },
  [29] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(305),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(309),
    [anon_sym_SEMI] = ACTIONS(305),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [ts_builtin_sym_end] = ACTIONS(317),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(319),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_SEMI_SEMI] = ACTIONS(305),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
  },
  [30] = {
    [anon_sym_EQ] = ACTIONS(251),
    [anon_sym_PLUS_EQ] = ACTIONS(251),
    [sym_comment] = ACTIONS(51),
  },
  [31] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [ts_builtin_sym_end] = ACTIONS(195),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [32] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(99),
    [sym_function_definition] = STATE(99),
    [sym_negated_command] = STATE(99),
    [sym_test_command] = STATE(99),
    [sym_variable_assignment] = STATE(100),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(99),
    [sym_for_statement] = STATE(99),
    [sym_compound_statement] = STATE(99),
    [sym_subshell] = STATE(99),
    [sym_declaration_command] = STATE(99),
    [sym_unset_command] = STATE(99),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(99),
    [sym_while_statement] = STATE(99),
    [sym_case_statement] = STATE(99),
    [sym_pipeline] = STATE(99),
    [sym_list] = STATE(99),
    [sym_command] = STATE(99),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [33] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(327),
  },
  [34] = {
    [sym_command_substitution] = STATE(17),
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_expansion] = STATE(17),
    [sym_string] = STATE(17),
    [sym_command_name] = STATE(102),
    [sym_process_substitution] = STATE(17),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(103),
    [aux_sym_command_repeat1] = STATE(103),
    [sym_concatenation] = STATE(31),
    [sym_file_redirect] = STATE(103),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(37),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(37),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(329),
  },
  [35] = {
    [sym_comment] = ACTIONS(51),
    [ts_builtin_sym_end] = ACTIONS(331),
  },
  [36] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(106),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [aux_sym_command_repeat2] = STATE(107),
    [sym_concatenation] = STATE(107),
    [sym_expansion] = STATE(104),
    [anon_sym_AMP_GT_GT] = ACTIONS(333),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_word] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_LT_AMP] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(343),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(333),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(341),
    [sym_file_descriptor] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [ts_builtin_sym_end] = ACTIONS(347),
    [anon_sym_LT_LT_LT] = ACTIONS(333),
    [anon_sym_GT_AMP] = ACTIONS(333),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_SEMI_SEMI] = ACTIONS(333),
    [anon_sym_PIPE_AMP] = ACTIONS(333),
  },
  [37] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(351),
  },
  [38] = {
    [aux_sym_concatenation_repeat1] = STATE(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [sym_word] = ACTIONS(353),
    [sym__concat] = ACTIONS(357),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_GT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [sym_variable_name] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(51),
  },
  [39] = {
    [aux_sym__literal_repeat1] = STATE(562),
    [anon_sym_AMP_GT_GT] = ACTIONS(359),
    [anon_sym_DOLLAR] = ACTIONS(361),
    [anon_sym_GT_LPAREN] = ACTIONS(359),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(359),
    [sym_word] = ACTIONS(359),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_AMP] = ACTIONS(359),
    [anon_sym_GT_GT] = ACTIONS(359),
    [sym__special_character] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(359),
    [sym_raw_string] = ACTIONS(359),
    [sym_variable_name] = ACTIONS(359),
    [sym_file_descriptor] = ACTIONS(359),
    [anon_sym_RPAREN] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_AMP_GT] = ACTIONS(361),
    [anon_sym_DQUOTE] = ACTIONS(359),
    [anon_sym_GT_AMP] = ACTIONS(359),
    [anon_sym_LT_LPAREN] = ACTIONS(359),
    [sym_comment] = ACTIONS(51),
  },
  [40] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(353),
    [anon_sym_DOLLAR] = ACTIONS(355),
    [anon_sym_GT_LPAREN] = ACTIONS(353),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(353),
    [sym_word] = ACTIONS(353),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(353),
    [anon_sym_GT_GT] = ACTIONS(353),
    [sym__special_character] = ACTIONS(353),
    [anon_sym_BQUOTE] = ACTIONS(353),
    [sym_raw_string] = ACTIONS(353),
    [sym_variable_name] = ACTIONS(353),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_RPAREN] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_DQUOTE] = ACTIONS(353),
    [anon_sym_GT_AMP] = ACTIONS(353),
    [anon_sym_LT_LPAREN] = ACTIONS(353),
    [sym_comment] = ACTIONS(51),
  },
  [41] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_DOLLAR] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(365),
    [aux_sym__simple_variable_name_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [sym_word] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [sym__concat] = ACTIONS(367),
    [sym__special_character] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(369),
    [anon_sym_SEMI] = ACTIONS(365),
    [sym_raw_string] = ACTIONS(365),
    [sym_variable_name] = ACTIONS(369),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_DQUOTE] = ACTIONS(365),
    [anon_sym_LT_LT_LT] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [ts_builtin_sym_end] = ACTIONS(369),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
  },
  [42] = {
    [aux_sym__literal_repeat1] = STATE(644),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [anon_sym_LT_LT] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [aux_sym__simple_variable_name_token1] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [sym_word] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [sym__special_character] = ACTIONS(373),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LF] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [sym_variable_name] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_LT_LT_LT] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [ts_builtin_sym_end] = ACTIONS(375),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(371),
    [anon_sym_PIPE_AMP] = ACTIONS(371),
  },
  [43] = {
    [sym_command_substitution] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(42),
    [sym_string] = STATE(41),
    [aux_sym_declaration_command_repeat1] = STATE(109),
    [sym_process_substitution] = STATE(41),
    [sym_simple_expansion] = STATE(41),
    [sym_subscript] = STATE(2444),
    [sym_string_expansion] = STATE(41),
    [sym_variable_assignment] = STATE(109),
    [sym_concatenation] = STATE(109),
    [sym_expansion] = STATE(41),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_LPAREN] = ACTIONS(127),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(129),
    [aux_sym__simple_variable_name_token1] = ACTIONS(379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(133),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [sym_word] = ACTIONS(135),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [sym__special_character] = ACTIONS(137),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(139),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(135),
    [sym_variable_name] = ACTIONS(143),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [ts_builtin_sym_end] = ACTIONS(381),
    [anon_sym_LT_LT_LT] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_LT_LPAREN] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
  },
  [44] = {
    [aux_sym_concatenation_repeat1] = STATE(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_GT_LPAREN] = ACTIONS(383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(383),
    [aux_sym__simple_variable_name_token1] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [sym_word] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(383),
    [anon_sym_LT_AMP] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(383),
    [sym__concat] = ACTIONS(385),
    [sym__special_character] = ACTIONS(383),
    [anon_sym_LT_LT_DASH] = ACTIONS(383),
    [anon_sym_BQUOTE] = ACTIONS(383),
    [anon_sym_LF] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [sym_raw_string] = ACTIONS(383),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(383),
    [anon_sym_AMP_GT] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(383),
    [anon_sym_GT_AMP] = ACTIONS(383),
    [ts_builtin_sym_end] = ACTIONS(387),
    [anon_sym_LT_LPAREN] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_SEMI_SEMI] = ACTIONS(383),
    [anon_sym_PIPE_AMP] = ACTIONS(383),
  },
  [45] = {
    [aux_sym__literal_repeat1] = STATE(700),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [aux_sym__simple_variable_name_token1] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [sym__special_character] = ACTIONS(391),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [ts_builtin_sym_end] = ACTIONS(393),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [46] = {
    [sym_command_substitution] = STATE(44),
    [aux_sym__literal_repeat1] = STATE(45),
    [sym_string] = STATE(44),
    [aux_sym_unset_command_repeat1] = STATE(110),
    [sym_process_substitution] = STATE(44),
    [sym_simple_expansion] = STATE(44),
    [sym_string_expansion] = STATE(44),
    [sym_concatenation] = STATE(110),
    [sym_expansion] = STATE(44),
    [anon_sym_AMP_GT_GT] = ACTIONS(395),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [anon_sym_LT_LT] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(151),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(153),
    [aux_sym__simple_variable_name_token1] = ACTIONS(397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(157),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [sym_word] = ACTIONS(159),
    [anon_sym_PIPE] = ACTIONS(395),
    [anon_sym_AMP] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_LT_AMP] = ACTIONS(395),
    [anon_sym_GT_GT] = ACTIONS(395),
    [sym__special_character] = ACTIONS(161),
    [anon_sym_LT_LT_DASH] = ACTIONS(395),
    [anon_sym_BQUOTE] = ACTIONS(163),
    [anon_sym_LF] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(159),
    [sym_file_descriptor] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(395),
    [anon_sym_AMP_GT] = ACTIONS(395),
    [ts_builtin_sym_end] = ACTIONS(399),
    [anon_sym_LT_LT_LT] = ACTIONS(395),
    [anon_sym_GT_AMP] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_LT_LPAREN] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_SEMI_SEMI] = ACTIONS(395),
    [anon_sym_PIPE_AMP] = ACTIONS(395),
  },
  [47] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_EQ_TILDE] = ACTIONS(401),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [ts_builtin_sym_end] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [48] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_EQ_TILDE] = ACTIONS(405),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [ts_builtin_sym_end] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [49] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(409),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [ts_builtin_sym_end] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [50] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(413),
  },
  [51] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [52] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(415),
  },
  [53] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(117),
    [sym_concatenation] = STATE(117),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(419),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(423),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(427),
    [anon_sym_DASH] = ACTIONS(423),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(439),
    [anon_sym_COLON_DASH] = ACTIONS(423),
    [sym__special_character] = ACTIONS(441),
  },
  [54] = {
    [sym_subscript] = STATE(118),
    [anon_sym_STAR] = ACTIONS(443),
    [anon_sym_QMARK] = ACTIONS(443),
    [anon_sym_AT] = ACTIONS(443),
    [sym_variable_name] = ACTIONS(445),
    [anon_sym_DOLLAR] = ACTIONS(447),
    [anon_sym_DASH] = ACTIONS(447),
    [anon_sym_0] = ACTIONS(449),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(449),
    [anon_sym__] = ACTIONS(449),
  },
  [55] = {
    [anon_sym_EQ] = ACTIONS(451),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [56] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(124),
    [sym_concatenation] = STATE(124),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(455),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(457),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(457),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(457),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(457),
    [anon_sym_PERCENT] = ACTIONS(457),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(461),
    [anon_sym_COLON_DASH] = ACTIONS(457),
    [sym__special_character] = ACTIONS(441),
  },
  [57] = {
    [sym_compound_statement] = STATE(126),
    [anon_sym_LPAREN] = ACTIONS(463),
    [anon_sym_LBRACE] = ACTIONS(25),
    [sym_comment] = ACTIONS(51),
  },
  [58] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(465),
  },
  [59] = {
    [sym_command_substitution] = STATE(128),
    [sym_simple_expansion] = STATE(128),
    [sym_string_expansion] = STATE(128),
    [sym_string] = STATE(128),
    [sym_process_substitution] = STATE(128),
    [sym_expansion] = STATE(128),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [60] = {
    [aux_sym_concatenation_repeat1] = STATE(130),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(471),
    [anon_sym_EQ_TILDE] = ACTIONS(469),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [61] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(475),
    [anon_sym_AMP_GT_GT] = ACTIONS(475),
    [anon_sym_LF] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(475),
    [sym_file_descriptor] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_AMP_GT] = ACTIONS(475),
    [anon_sym_PIPE_PIPE] = ACTIONS(475),
    [ts_builtin_sym_end] = ACTIONS(477),
    [anon_sym_LT_LT_LT] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(475),
    [anon_sym_GT_AMP] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_AMP] = ACTIONS(475),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(475),
    [anon_sym_PIPE_AMP] = ACTIONS(475),
  },
  [62] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(485),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(485),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(485),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [63] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(485),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(483),
    [anon_sym_SEMI] = ACTIONS(485),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(485),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [64] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_negated_command] = STATE(62),
    [sym_test_command] = STATE(62),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(420),
    [sym_redirected_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_subshell] = STATE(62),
    [sym_declaration_command] = STATE(62),
    [sym_unset_command] = STATE(62),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_pipeline] = STATE(62),
    [sym_list] = STATE(62),
    [sym_command] = STATE(62),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(495),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [65] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(497),
  },
  [66] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [67] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(499),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(501),
    [anon_sym_SEMI] = ACTIONS(499),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(499),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [68] = {
    [aux_sym_concatenation_repeat1] = STATE(736),
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(509),
  },
  [69] = {
    [aux_sym__literal_repeat1] = STATE(739),
    [anon_sym_in] = ACTIONS(511),
    [anon_sym_SEMI] = ACTIONS(513),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(515),
    [anon_sym_AMP] = ACTIONS(513),
    [anon_sym_SEMI_SEMI] = ACTIONS(513),
    [sym__special_character] = ACTIONS(517),
  },
  [70] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(503),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(507),
    [anon_sym_AMP] = ACTIONS(503),
    [anon_sym_SEMI] = ACTIONS(503),
    [anon_sym_in] = ACTIONS(509),
  },
  [71] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(140),
    [sym_postfix_expression] = STATE(140),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(140),
    [sym_binary_expression] = STATE(140),
    [sym_concatenation] = STATE(140),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(140),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [72] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(141),
    [sym_postfix_expression] = STATE(141),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(141),
    [sym_binary_expression] = STATE(141),
    [sym_concatenation] = STATE(141),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(141),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [73] = {
    [aux_sym_concatenation_repeat1] = STATE(773),
    [sym_test_operator] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(519),
    [sym__concat] = ACTIONS(523),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_EQ_TILDE] = ACTIONS(519),
    [anon_sym_DASH_DASH] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(519),
    [anon_sym_DASH_EQ] = ACTIONS(519),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_RPAREN] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(519),
    [anon_sym_PLUS] = ACTIONS(521),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(519),
  },
  [74] = {
    [aux_sym__literal_repeat1] = STATE(776),
    [sym_test_operator] = ACTIONS(525),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(525),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_EQ_TILDE] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [sym__special_character] = ACTIONS(529),
    [anon_sym_DASH_EQ] = ACTIONS(525),
    [anon_sym_BANG_EQ] = ACTIONS(525),
    [anon_sym_RPAREN] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_PLUS] = ACTIONS(527),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(525),
  },
  [75] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(539),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [76] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(541),
  },
  [77] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(543),
    [anon_sym_AMP_GT_GT] = ACTIONS(543),
    [anon_sym_LF] = ACTIONS(545),
    [anon_sym_SEMI] = ACTIONS(543),
    [anon_sym_LT_LT] = ACTIONS(543),
    [sym_file_descriptor] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_AMP_GT] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [ts_builtin_sym_end] = ACTIONS(545),
    [anon_sym_LT_LT_LT] = ACTIONS(543),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_GT_AMP] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_AMP] = ACTIONS(543),
    [anon_sym_GT_GT] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_SEMI_SEMI] = ACTIONS(543),
    [anon_sym_PIPE_AMP] = ACTIONS(543),
  },
  [78] = {
    [sym_command_substitution] = STATE(148),
    [aux_sym__literal_repeat1] = STATE(150),
    [sym_string] = STATE(148),
    [sym_array] = STATE(149),
    [sym_process_substitution] = STATE(148),
    [sym_simple_expansion] = STATE(148),
    [sym_string_expansion] = STATE(148),
    [sym_concatenation] = STATE(149),
    [sym_expansion] = STATE(148),
    [anon_sym_LPAREN] = ACTIONS(547),
    [anon_sym_BQUOTE] = ACTIONS(549),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(553),
    [sym_raw_string] = ACTIONS(553),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(557),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [sym__special_character] = ACTIONS(561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
    [sym__empty_value] = ACTIONS(565),
  },
  [79] = {
    [sym_command_substitution] = STATE(151),
    [aux_sym__literal_repeat1] = STATE(152),
    [sym_string] = STATE(151),
    [sym_process_substitution] = STATE(151),
    [sym_simple_expansion] = STATE(151),
    [sym_string_expansion] = STATE(151),
    [sym_concatenation] = STATE(153),
    [sym_expansion] = STATE(151),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(567),
    [sym_raw_string] = ACTIONS(567),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [80] = {
    [sym_command_substitution] = STATE(154),
    [aux_sym__literal_repeat1] = STATE(155),
    [sym_string] = STATE(154),
    [sym_process_substitution] = STATE(154),
    [sym_simple_expansion] = STATE(154),
    [sym_string_expansion] = STATE(154),
    [sym_concatenation] = STATE(156),
    [sym_expansion] = STATE(154),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [sym_raw_string] = ACTIONS(571),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_GT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_word] = ACTIONS(571),
    [anon_sym_LT_LPAREN] = ACTIONS(113),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(121),
  },
  [81] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [82] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(583),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [83] = {
    [anon_sym_BQUOTE] = ACTIONS(587),
    [anon_sym_DQUOTE] = ACTIONS(587),
    [sym__concat] = ACTIONS(589),
    [sym__string_content] = ACTIONS(591),
    [anon_sym_DOLLAR] = ACTIONS(591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(587),
  },
  [84] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(593),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [85] = {
    [anon_sym_AMP] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(597),
    [anon_sym_SEMI] = ACTIONS(595),
    [anon_sym_in] = ACTIONS(599),
    [anon_sym_SEMI_SEMI] = ACTIONS(595),
  },
  [86] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(165),
    [sym_postfix_expression] = STATE(165),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(165),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(165),
    [sym_binary_expression] = STATE(165),
    [sym_concatenation] = STATE(165),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(609),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(609),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(609),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(609),
  },
  [87] = {
    [sym_do_group] = STATE(167),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(625),
  },
  [88] = {
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_PLUS_EQ] = ACTIONS(627),
    [sym_test_operator] = ACTIONS(627),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(539),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_EQ] = ACTIONS(631),
    [anon_sym_EQ_EQ] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_DASH_EQ] = ACTIONS(627),
  },
  [89] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(539),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [90] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [91] = {
    [aux_sym__literal_repeat1] = STATE(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_EQ_TILDE] = ACTIONS(635),
    [sym__special_character] = ACTIONS(637),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [92] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(168),
    [sym_function_definition] = STATE(168),
    [sym_negated_command] = STATE(168),
    [sym_test_command] = STATE(168),
    [sym_variable_assignment] = STATE(169),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_redirected_statement] = STATE(168),
    [sym_for_statement] = STATE(168),
    [sym_compound_statement] = STATE(168),
    [sym_subshell] = STATE(168),
    [sym_declaration_command] = STATE(168),
    [sym_unset_command] = STATE(168),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(168),
    [sym_while_statement] = STATE(168),
    [sym_case_statement] = STATE(168),
    [sym_pipeline] = STATE(168),
    [sym_list] = STATE(168),
    [sym_command] = STATE(168),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [93] = {
    [sym_heredoc_body] = STATE(172),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(646),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [ts_builtin_sym_end] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [94] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [ts_builtin_sym_end] = ACTIONS(650),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [95] = {
    [sym_heredoc_start] = ACTIONS(652),
    [sym_comment] = ACTIONS(51),
  },
  [96] = {
    [aux_sym__literal_repeat1] = STATE(27),
    [sym_if_statement] = STATE(174),
    [sym_function_definition] = STATE(174),
    [sym_negated_command] = STATE(174),
    [sym_test_command] = STATE(174),
    [sym_variable_assignment] = STATE(175),
    [sym_subscript] = STATE(30),
    [sym_concatenation] = STATE(31),
    [sym_expansion] = STATE(17),
    [sym_command_substitution] = STATE(17),
    [sym_redirected_statement] = STATE(174),
    [sym_for_statement] = STATE(174),
    [sym_compound_statement] = STATE(174),
    [sym_subshell] = STATE(174),
    [sym_declaration_command] = STATE(174),
    [sym_unset_command] = STATE(174),
    [sym_file_redirect] = STATE(34),
    [sym_string] = STATE(17),
    [sym_process_substitution] = STATE(17),
    [aux_sym_command_repeat1] = STATE(34),
    [sym_c_style_for_statement] = STATE(174),
    [sym_while_statement] = STATE(174),
    [sym_case_statement] = STATE(174),
    [sym_pipeline] = STATE(174),
    [sym_list] = STATE(174),
    [sym_command] = STATE(174),
    [sym_command_name] = STATE(36),
    [sym_simple_expansion] = STATE(17),
    [sym_string_expansion] = STATE(17),
    [anon_sym_LPAREN] = ACTIONS(5),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(9),
    [anon_sym_typeset] = ACTIONS(9),
    [anon_sym_unsetenv] = ACTIONS(11),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [anon_sym_function] = ACTIONS(21),
    [sym_word] = ACTIONS(23),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(9),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_case] = ACTIONS(33),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(35),
    [sym_raw_string] = ACTIONS(37),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_BANG] = ACTIONS(41),
    [anon_sym_declare] = ACTIONS(9),
    [sym_variable_name] = ACTIONS(43),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(9),
    [anon_sym_unset] = ACTIONS(11),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(53),
    [anon_sym_while] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(57),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(59),
  },
  [97] = {
    [sym_command_substitution] = STATE(176),
    [aux_sym__literal_repeat1] = STATE(177),
    [sym_string] = STATE(176),
    [sym_process_substitution] = STATE(176),
    [sym_simple_expansion] = STATE(176),
    [sym_string_expansion] = STATE(176),
    [sym_concatenation] = STATE(178),
    [sym_expansion] = STATE(176),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_word] = ACTIONS(658),
    [sym_raw_string] = ACTIONS(658),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(664),
    [sym__special_character] = ACTIONS(666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(668),
  },
  [98] = {
    [sym_heredoc_redirect] = STATE(179),
    [aux_sym_redirected_statement_repeat1] = STATE(179),
    [sym_herestring_redirect] = STATE(179),
    [sym_file_redirect] = STATE(179),
    [anon_sym_LT_LT_DASH] = ACTIONS(313),
    [anon_sym_AMP_GT_GT] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(313),
    [sym_file_descriptor] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(307),
    [anon_sym_AMP_GT] = ACTIONS(307),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [ts_builtin_sym_end] = ACTIONS(670),
    [anon_sym_LT_LT_LT] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(307),
    [anon_sym_LT] = ACTIONS(307),
    [anon_sym_LT_AMP] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(307),
    [anon_sym_AMP] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_SEMI_SEMI] = ACTIONS(672),
    [anon_sym_PIPE_AMP] = ACTIONS(672),
  },
  [99] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
    [anon_sym_AMP_GT_GT] = ACTIONS(307),
    [anon_sym_LF] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(676),
    [sym_file_descriptor] = ACTIONS(311),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_GT] = ACTIONS(307),
    [anon_sym_AMP_GT] = ACTIONS(307),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [ts_builtin_sym_end] = ACTIONS(650),
    [anon_sym_LT_LT_LT] = ACTIONS(319),
    [anon_sym_GT_AMP] = ACTIONS(307),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_LT] = ACTIONS(307),
    [anon_sym_LT_AMP] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(307),
    [anon_sym_AMP] = ACTIONS(676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_SEMI_SEMI] = ACTIONS(676),
    [anon_sym_LT_LT_DASH] = ACTIONS(313),
  },
  [100] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(313),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(315),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(676),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(313),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(674),
    [anon_sym_SEMI] = ACTIONS(676),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [ts_builtin_sym_end] = ACTIONS(650),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(319),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(315),
    [anon_sym_SEMI_SEMI] = ACTIONS(676),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
  },
  [101] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1373),
    [sym_function_definition] = STATE(1373),
    [sym_negated_command] = STATE(1373),
    [sym_test_command] = STATE(1373),
    [sym_variable_assignment] = STATE(1374),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(1373),
    [sym_for_statement] = STATE(1373),
    [sym_compound_statement] = STATE(1373),
    [sym_subshell] = STATE(1373),
    [sym_declaration_command] = STATE(1373),
    [sym_unset_command] = STATE(1373),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(1373),
    [sym_while_statement] = STATE(1373),
    [sym_case_statement] = STATE(1373),
    [sym_pipeline] = STATE(1373),
    [sym_list] = STATE(1373),
    [sym_command] = STATE(1373),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_local] = ACTIONS(684),
    [anon_sym_typeset] = ACTIONS(684),
    [anon_sym_unsetenv] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(702),
    [sym_word] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_export] = ACTIONS(684),
    [sym__special_character] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(720),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(723),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_declare] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(738),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_unset] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(750),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(753),
  },
  [102] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(106),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [aux_sym_command_repeat2] = STATE(182),
    [sym_concatenation] = STATE(182),
    [sym_expansion] = STATE(104),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(343),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(341),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [ts_builtin_sym_end] = ACTIONS(758),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [103] = {
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(2455),
    [aux_sym_command_repeat1] = STATE(103),
    [sym_file_redirect] = STATE(103),
    [anon_sym_BQUOTE] = ACTIONS(760),
    [anon_sym_AMP_GT_GT] = ACTIONS(762),
    [sym_raw_string] = ACTIONS(760),
    [anon_sym_DOLLAR] = ACTIONS(765),
    [sym_file_descriptor] = ACTIONS(767),
    [sym_variable_name] = ACTIONS(770),
    [anon_sym_GT] = ACTIONS(773),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(760),
    [anon_sym_AMP_GT] = ACTIONS(773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(760),
    [anon_sym_GT_LPAREN] = ACTIONS(760),
    [anon_sym_DQUOTE] = ACTIONS(760),
    [sym_word] = ACTIONS(760),
    [anon_sym_GT_AMP] = ACTIONS(762),
    [anon_sym_LT] = ACTIONS(773),
    [anon_sym_LT_AMP] = ACTIONS(762),
    [anon_sym_GT_GT] = ACTIONS(762),
    [anon_sym_LT_LPAREN] = ACTIONS(760),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(760),
  },
  [104] = {
    [aux_sym_concatenation_repeat1] = STATE(60),
    [anon_sym_AMP_GT_GT] = ACTIONS(776),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_GT_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(776),
    [anon_sym_PIPE_PIPE] = ACTIONS(776),
    [sym_word] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_LT_AMP] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(776),
    [sym__concat] = ACTIONS(193),
    [anon_sym_EQ_TILDE] = ACTIONS(776),
    [sym__special_character] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(776),
    [anon_sym_LF] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_raw_string] = ACTIONS(776),
    [sym_file_descriptor] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(776),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_GT_AMP] = ACTIONS(776),
    [ts_builtin_sym_end] = ACTIONS(778),
    [anon_sym_LT_LPAREN] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(776),
    [anon_sym_SEMI_SEMI] = ACTIONS(776),
    [anon_sym_PIPE_AMP] = ACTIONS(776),
  },
  [105] = {
    [sym_command_substitution] = STATE(183),
    [aux_sym__literal_repeat1] = STATE(185),
    [sym_string] = STATE(183),
    [sym_process_substitution] = STATE(183),
    [sym_simple_expansion] = STATE(183),
    [sym_string_expansion] = STATE(183),
    [sym_concatenation] = STATE(184),
    [sym_expansion] = STATE(183),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(780),
    [sym_raw_string] = ACTIONS(780),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(329),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
    [sym_regex] = ACTIONS(782),
  },
  [106] = {
    [aux_sym__literal_repeat1] = STATE(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(784),
    [anon_sym_DOLLAR] = ACTIONS(784),
    [anon_sym_LT_LT] = ACTIONS(784),
    [anon_sym_GT_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(784),
    [anon_sym_PIPE_PIPE] = ACTIONS(784),
    [sym_word] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_LT_AMP] = ACTIONS(784),
    [anon_sym_GT_GT] = ACTIONS(784),
    [anon_sym_EQ_TILDE] = ACTIONS(784),
    [sym__special_character] = ACTIONS(301),
    [anon_sym_LT_LT_DASH] = ACTIONS(784),
    [anon_sym_BQUOTE] = ACTIONS(784),
    [anon_sym_LF] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_raw_string] = ACTIONS(784),
    [sym_file_descriptor] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(784),
    [anon_sym_AMP_GT] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(784),
    [anon_sym_LT_LT_LT] = ACTIONS(784),
    [anon_sym_GT_AMP] = ACTIONS(784),
    [ts_builtin_sym_end] = ACTIONS(786),
    [anon_sym_LT_LPAREN] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(784),
    [anon_sym_SEMI_SEMI] = ACTIONS(784),
    [anon_sym_PIPE_AMP] = ACTIONS(784),
  },
  [107] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(106),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [aux_sym_command_repeat2] = STATE(186),
    [sym_concatenation] = STATE(186),
    [sym_expansion] = STATE(104),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(343),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(341),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [ts_builtin_sym_end] = ACTIONS(758),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [108] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(788),
    [anon_sym_AMP_GT_GT] = ACTIONS(788),
    [anon_sym_LF] = ACTIONS(790),
    [anon_sym_SEMI] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(788),
    [sym_file_descriptor] = ACTIONS(790),
    [anon_sym_GT] = ACTIONS(788),
    [anon_sym_AMP_GT] = ACTIONS(788),
    [anon_sym_PIPE_PIPE] = ACTIONS(788),
    [ts_builtin_sym_end] = ACTIONS(790),
    [anon_sym_LT_LT_LT] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_GT_AMP] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(788),
    [anon_sym_LT_AMP] = ACTIONS(788),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(788),
    [anon_sym_SEMI_SEMI] = ACTIONS(788),
    [anon_sym_PIPE_AMP] = ACTIONS(788),
  },
  [109] = {
    [sym_command_substitution] = STATE(41),
    [aux_sym__literal_repeat1] = STATE(42),
    [sym_string] = STATE(41),
    [aux_sym_declaration_command_repeat1] = STATE(109),
    [sym_process_substitution] = STATE(41),
    [sym_simple_expansion] = STATE(41),
    [sym_subscript] = STATE(2444),
    [sym_string_expansion] = STATE(41),
    [sym_variable_assignment] = STATE(109),
    [sym_concatenation] = STATE(109),
    [sym_expansion] = STATE(41),
    [anon_sym_AMP_GT_GT] = ACTIONS(792),
    [anon_sym_DOLLAR] = ACTIONS(794),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_GT_LPAREN] = ACTIONS(797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(800),
    [aux_sym__simple_variable_name_token1] = ACTIONS(803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(806),
    [anon_sym_PIPE_PIPE] = ACTIONS(792),
    [sym_word] = ACTIONS(809),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_LT_AMP] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(792),
    [sym__special_character] = ACTIONS(812),
    [anon_sym_LT_LT_DASH] = ACTIONS(792),
    [anon_sym_BQUOTE] = ACTIONS(815),
    [anon_sym_LF] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(792),
    [sym_raw_string] = ACTIONS(809),
    [sym_variable_name] = ACTIONS(820),
    [sym_file_descriptor] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(823),
    [anon_sym_LT_LT_LT] = ACTIONS(792),
    [anon_sym_GT_AMP] = ACTIONS(792),
    [ts_builtin_sym_end] = ACTIONS(818),
    [anon_sym_LT_LPAREN] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(792),
    [anon_sym_SEMI_SEMI] = ACTIONS(792),
    [anon_sym_PIPE_AMP] = ACTIONS(792),
  },
  [110] = {
    [sym_command_substitution] = STATE(44),
    [aux_sym__literal_repeat1] = STATE(45),
    [sym_string] = STATE(44),
    [aux_sym_unset_command_repeat1] = STATE(110),
    [sym_process_substitution] = STATE(44),
    [sym_simple_expansion] = STATE(44),
    [sym_string_expansion] = STATE(44),
    [sym_concatenation] = STATE(110),
    [sym_expansion] = STATE(44),
    [anon_sym_AMP_GT_GT] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(828),
    [anon_sym_LT_LT] = ACTIONS(826),
    [anon_sym_GT_LPAREN] = ACTIONS(831),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [aux_sym__simple_variable_name_token1] = ACTIONS(837),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [sym_word] = ACTIONS(843),
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(826),
    [anon_sym_LT_AMP] = ACTIONS(826),
    [anon_sym_GT_GT] = ACTIONS(826),
    [sym__special_character] = ACTIONS(846),
    [anon_sym_LT_LT_DASH] = ACTIONS(826),
    [anon_sym_BQUOTE] = ACTIONS(849),
    [anon_sym_LF] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(826),
    [sym_raw_string] = ACTIONS(843),
    [sym_file_descriptor] = ACTIONS(852),
    [anon_sym_GT] = ACTIONS(826),
    [anon_sym_AMP_GT] = ACTIONS(826),
    [anon_sym_DQUOTE] = ACTIONS(854),
    [anon_sym_LT_LT_LT] = ACTIONS(826),
    [anon_sym_GT_AMP] = ACTIONS(826),
    [ts_builtin_sym_end] = ACTIONS(852),
    [anon_sym_LT_LPAREN] = ACTIONS(831),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(826),
    [anon_sym_SEMI_SEMI] = ACTIONS(826),
    [anon_sym_PIPE_AMP] = ACTIONS(826),
  },
  [111] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_EQ_TILDE] = ACTIONS(857),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [112] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [113] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(189),
    [sym_concatenation] = STATE(189),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(869),
    [anon_sym_COLON_DASH] = ACTIONS(865),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(871),
  },
  [114] = {
    [aux_sym_concatenation_repeat1] = STATE(906),
    [anon_sym_BQUOTE] = ACTIONS(873),
    [sym_raw_string] = ACTIONS(873),
    [anon_sym_COLON_QMARK] = ACTIONS(875),
    [anon_sym_DOLLAR] = ACTIONS(875),
    [anon_sym_RBRACE] = ACTIONS(873),
    [anon_sym_DASH] = ACTIONS(875),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(875),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(873),
    [anon_sym_PERCENT] = ACTIONS(875),
    [anon_sym_COLON] = ACTIONS(875),
    [anon_sym_GT_LPAREN] = ACTIONS(873),
    [anon_sym_DQUOTE] = ACTIONS(873),
    [sym_word] = ACTIONS(875),
    [sym__concat] = ACTIONS(877),
    [anon_sym_LT_LPAREN] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(873),
    [anon_sym_COLON_DASH] = ACTIONS(875),
    [sym__special_character] = ACTIONS(875),
  },
  [115] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(879),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [116] = {
    [aux_sym__literal_repeat1] = STATE(909),
    [anon_sym_BQUOTE] = ACTIONS(883),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_COLON_QMARK] = ACTIONS(885),
    [anon_sym_DOLLAR] = ACTIONS(885),
    [anon_sym_RBRACE] = ACTIONS(883),
    [anon_sym_DASH] = ACTIONS(885),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(885),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(883),
    [anon_sym_PERCENT] = ACTIONS(885),
    [anon_sym_COLON] = ACTIONS(885),
    [anon_sym_GT_LPAREN] = ACTIONS(883),
    [anon_sym_DQUOTE] = ACTIONS(883),
    [sym_word] = ACTIONS(885),
    [anon_sym_LT_LPAREN] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(883),
    [anon_sym_COLON_DASH] = ACTIONS(885),
    [sym__special_character] = ACTIONS(887),
  },
  [117] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [118] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(189),
    [sym_concatenation] = STATE(189),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(893),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(865),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_DASH] = ACTIONS(865),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(865),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(869),
    [anon_sym_COLON_DASH] = ACTIONS(865),
    [sym__special_character] = ACTIONS(441),
  },
  [119] = {
    [anon_sym_EQ] = ACTIONS(895),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [120] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(195),
    [sym_concatenation] = STATE(195),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(897),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(899),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(901),
    [anon_sym_DASH] = ACTIONS(899),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(903),
    [anon_sym_COLON_DASH] = ACTIONS(899),
    [sym__special_character] = ACTIONS(441),
  },
  [121] = {
    [sym_command_substitution] = STATE(196),
    [aux_sym__literal_repeat1] = STATE(197),
    [sym_string] = STATE(196),
    [sym_process_substitution] = STATE(196),
    [sym_simple_expansion] = STATE(196),
    [sym_string_expansion] = STATE(196),
    [sym_concatenation] = STATE(198),
    [sym_expansion] = STATE(196),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(909),
    [sym_raw_string] = ACTIONS(909),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(867),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [122] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(201),
    [sym_concatenation] = STATE(201),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(921),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(921),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(921),
    [anon_sym_PERCENT] = ACTIONS(921),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(925),
    [anon_sym_COLON_DASH] = ACTIONS(921),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(927),
  },
  [123] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_EQ_TILDE] = ACTIONS(929),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [ts_builtin_sym_end] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [124] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(923),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [125] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(933),
  },
  [126] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(935),
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LF] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [sym_file_descriptor] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [ts_builtin_sym_end] = ACTIONS(937),
    [anon_sym_LT_LT_LT] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_SEMI_SEMI] = ACTIONS(935),
    [anon_sym_PIPE_AMP] = ACTIONS(935),
  },
  [127] = {
    [sym_compound_statement] = STATE(203),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [128] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [129] = {
    [sym_command_substitution] = STATE(128),
    [sym_simple_expansion] = STATE(128),
    [sym_string_expansion] = STATE(128),
    [sym_string] = STATE(128),
    [sym_process_substitution] = STATE(128),
    [sym_expansion] = STATE(128),
    [anon_sym_BQUOTE] = ACTIONS(39),
    [anon_sym_DQUOTE] = ACTIONS(49),
    [sym_word] = ACTIONS(467),
    [sym_raw_string] = ACTIONS(467),
    [anon_sym_LT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR] = ACTIONS(943),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(15),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(17),
    [sym__special_character] = ACTIONS(467),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(19),
  },
  [130] = {
    [aux_sym_concatenation_repeat1] = STATE(130),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(945),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [131] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [132] = {
    [sym_heredoc_body] = STATE(205),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [133] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(952),
    [anon_sym_AMP_GT_GT] = ACTIONS(952),
    [anon_sym_LF] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(952),
    [sym_file_descriptor] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [ts_builtin_sym_end] = ACTIONS(954),
    [anon_sym_LT_LT_LT] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(952),
    [anon_sym_GT_AMP] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_LT_AMP] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(952),
    [anon_sym_PIPE_AMP] = ACTIONS(952),
  },
  [134] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_elif_clause] = STATE(212),
    [sym_else_clause] = STATE(211),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_if_statement_repeat1] = STATE(212),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(213),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_fi] = ACTIONS(958),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [anon_sym_elif] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [135] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(962),
    [anon_sym_do] = ACTIONS(962),
  },
  [136] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(964),
  },
  [137] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(966),
    [anon_sym_SEMI] = ACTIONS(968),
    [anon_sym_SEMI_SEMI] = ACTIONS(968),
    [anon_sym_AMP] = ACTIONS(968),
  },
  [138] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(970),
  },
  [139] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(972),
    [anon_sym_SEMI] = ACTIONS(974),
    [anon_sym_SEMI_SEMI] = ACTIONS(974),
    [anon_sym_AMP] = ACTIONS(974),
  },
  [140] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(976),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(976),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_RPAREN] = ACTIONS(978),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [141] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_RPAREN] = ACTIONS(980),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [142] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(219),
    [sym_postfix_expression] = STATE(219),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(219),
    [sym_binary_expression] = STATE(219),
    [sym_concatenation] = STATE(219),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(219),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [143] = {
    [sym_test_operator] = ACTIONS(982),
    [anon_sym_PLUS_EQ] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(982),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_EQ_TILDE] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_DASH_EQ] = ACTIONS(982),
    [anon_sym_BANG_EQ] = ACTIONS(982),
    [anon_sym_RPAREN] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(984),
    [anon_sym_EQ_EQ] = ACTIONS(982),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(982),
  },
  [144] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(219),
    [sym_postfix_expression] = STATE(219),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(219),
    [sym_binary_expression] = STATE(219),
    [sym_concatenation] = STATE(219),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(219),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
    [sym_regex] = ACTIONS(986),
  },
  [145] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(988),
    [anon_sym_AMP_GT_GT] = ACTIONS(988),
    [anon_sym_LF] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(988),
    [anon_sym_LT_LT] = ACTIONS(988),
    [sym_file_descriptor] = ACTIONS(990),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_AMP_GT] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [ts_builtin_sym_end] = ACTIONS(990),
    [anon_sym_LT_LT_LT] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_GT_AMP] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_LT_AMP] = ACTIONS(988),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_SEMI_SEMI] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
  },
  [146] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [147] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(224),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(224),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(1002),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [148] = {
    [aux_sym_concatenation_repeat1] = STATE(938),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(1012),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [ts_builtin_sym_end] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [149] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [ts_builtin_sym_end] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [150] = {
    [aux_sym__literal_repeat1] = STATE(941),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(1018),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [ts_builtin_sym_end] = ACTIONS(1020),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [151] = {
    [aux_sym_concatenation_repeat1] = STATE(2432),
    [anon_sym_RBRACK] = ACTIONS(1022),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1024),
  },
  [152] = {
    [aux_sym__literal_repeat1] = STATE(973),
    [anon_sym_RBRACK] = ACTIONS(1026),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1028),
    [sym__special_character] = ACTIONS(1030),
  },
  [153] = {
    [anon_sym_RBRACK] = ACTIONS(1022),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(1032),
  },
  [154] = {
    [aux_sym_concatenation_repeat1] = STATE(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(1034),
    [anon_sym_DOLLAR] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1034),
    [sym_word] = ACTIONS(1034),
    [sym__concat] = ACTIONS(357),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [sym__special_character] = ACTIONS(1034),
    [anon_sym_BQUOTE] = ACTIONS(1034),
    [sym_raw_string] = ACTIONS(1034),
    [sym_variable_name] = ACTIONS(1034),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_GT_AMP] = ACTIONS(1034),
    [anon_sym_LT_LPAREN] = ACTIONS(1034),
    [sym_comment] = ACTIONS(51),
  },
  [155] = {
    [aux_sym__literal_repeat1] = STATE(562),
    [anon_sym_AMP_GT_GT] = ACTIONS(1038),
    [anon_sym_DOLLAR] = ACTIONS(1040),
    [anon_sym_GT_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1038),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1038),
    [sym_word] = ACTIONS(1038),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_LT_AMP] = ACTIONS(1038),
    [anon_sym_GT_GT] = ACTIONS(1038),
    [sym__special_character] = ACTIONS(363),
    [anon_sym_BQUOTE] = ACTIONS(1038),
    [sym_raw_string] = ACTIONS(1038),
    [sym_variable_name] = ACTIONS(1038),
    [sym_file_descriptor] = ACTIONS(1038),
    [anon_sym_RPAREN] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_DQUOTE] = ACTIONS(1038),
    [anon_sym_GT_AMP] = ACTIONS(1038),
    [anon_sym_LT_LPAREN] = ACTIONS(1038),
    [sym_comment] = ACTIONS(51),
  },
  [156] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1034),
    [anon_sym_DOLLAR] = ACTIONS(1036),
    [anon_sym_GT_LPAREN] = ACTIONS(1034),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1034),
    [sym_word] = ACTIONS(1034),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1034),
    [anon_sym_GT_GT] = ACTIONS(1034),
    [sym__special_character] = ACTIONS(1034),
    [anon_sym_BQUOTE] = ACTIONS(1034),
    [sym_raw_string] = ACTIONS(1034),
    [sym_variable_name] = ACTIONS(1034),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_RPAREN] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_DQUOTE] = ACTIONS(1034),
    [anon_sym_GT_AMP] = ACTIONS(1034),
    [anon_sym_LT_LPAREN] = ACTIONS(1034),
    [sym_comment] = ACTIONS(51),
  },
  [157] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_EQ_TILDE] = ACTIONS(1042),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [ts_builtin_sym_end] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [158] = {
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym__concat] = ACTIONS(1048),
    [sym__string_content] = ACTIONS(1050),
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
  },
  [159] = {
    [anon_sym_DOLLAR] = ACTIONS(1050),
    [anon_sym_BQUOTE] = ACTIONS(1046),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1046),
    [sym__string_content] = ACTIONS(1050),
  },
  [160] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(1052),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [161] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(1054),
    [anon_sym_BQUOTE] = ACTIONS(1057),
    [anon_sym_DQUOTE] = ACTIONS(1046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1060),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1063),
    [sym__string_content] = ACTIONS(1066),
  },
  [162] = {
    [sym_command_substitution] = STATE(481),
    [aux_sym__literal_repeat1] = STATE(483),
    [sym_string] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(233),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_concatenation] = STATE(233),
    [sym_expansion] = STATE(481),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_word] = ACTIONS(1073),
    [sym_raw_string] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [sym__special_character] = ACTIONS(1081),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
  },
  [163] = {
    [sym_do_group] = STATE(234),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(625),
  },
  [164] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(236),
    [sym_postfix_expression] = STATE(236),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(236),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(236),
    [sym_binary_expression] = STATE(236),
    [sym_concatenation] = STATE(236),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(1085),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(1085),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(1085),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(1085),
  },
  [165] = {
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1091),
    [anon_sym_SEMI] = ACTIONS(1091),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1091),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
  },
  [166] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(239),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(1097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [167] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1099),
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [sym_file_descriptor] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [ts_builtin_sym_end] = ACTIONS(1101),
    [anon_sym_LT_LT_LT] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
  },
  [168] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [169] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [ts_builtin_sym_end] = ACTIONS(1105),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [170] = {
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1107),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1109),
  },
  [171] = {
    [sym_command_substitution] = STATE(242),
    [sym_simple_expansion] = STATE(242),
    [sym_expansion] = STATE(242),
    [aux_sym_heredoc_body_repeat1] = STATE(242),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1115),
    [sym__heredoc_body_end] = ACTIONS(1117),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [sym__heredoc_body_middle] = ACTIONS(1121),
  },
  [172] = {
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1123),
    [anon_sym_LF] = ACTIONS(1125),
    [anon_sym_SEMI] = ACTIONS(1127),
    [anon_sym_SEMI_SEMI] = ACTIONS(1127),
    [anon_sym_AMP] = ACTIONS(1127),
  },
  [173] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1129),
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LF] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [sym_file_descriptor] = ACTIONS(1131),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [ts_builtin_sym_end] = ACTIONS(1131),
    [anon_sym_LT_LT_LT] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_SEMI_SEMI] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
  },
  [174] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [sym_file_descriptor] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [ts_builtin_sym_end] = ACTIONS(1135),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
  },
  [175] = {
    [sym_heredoc_redirect] = STATE(98),
    [aux_sym_redirected_statement_repeat1] = STATE(98),
    [sym_herestring_redirect] = STATE(98),
    [sym_file_redirect] = STATE(98),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [ts_builtin_sym_end] = ACTIONS(1135),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(321),
  },
  [176] = {
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(1137),
    [anon_sym_AMP_GT_GT] = ACTIONS(1137),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [sym_file_descriptor] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_AMP_GT] = ACTIONS(1137),
    [anon_sym_PIPE_PIPE] = ACTIONS(1137),
    [ts_builtin_sym_end] = ACTIONS(1139),
    [anon_sym_LT_LT_LT] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_GT_AMP] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_AMP] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [sym__concat] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_PIPE_AMP] = ACTIONS(1137),
  },
  [177] = {
    [aux_sym__literal_repeat1] = STATE(1037),
    [anon_sym_LT_LT_DASH] = ACTIONS(1143),
    [anon_sym_AMP_GT_GT] = ACTIONS(1143),
    [anon_sym_LF] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym_LT_LT] = ACTIONS(1143),
    [sym_file_descriptor] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_AMP_GT] = ACTIONS(1143),
    [anon_sym_PIPE_PIPE] = ACTIONS(1143),
    [ts_builtin_sym_end] = ACTIONS(1145),
    [anon_sym_LT_LT_LT] = ACTIONS(1143),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_GT_AMP] = ACTIONS(1143),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_LT_AMP] = ACTIONS(1143),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1143),
    [sym__special_character] = ACTIONS(1147),
    [anon_sym_SEMI_SEMI] = ACTIONS(1143),
    [anon_sym_PIPE_AMP] = ACTIONS(1143),
  },
  [178] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1137),
    [anon_sym_AMP_GT_GT] = ACTIONS(1137),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [sym_file_descriptor] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_AMP_GT] = ACTIONS(1137),
    [anon_sym_PIPE_PIPE] = ACTIONS(1137),
    [ts_builtin_sym_end] = ACTIONS(1139),
    [anon_sym_LT_LT_LT] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_GT_AMP] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_AMP] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_PIPE_AMP] = ACTIONS(1137),
  },
  [179] = {
    [sym_heredoc_redirect] = STATE(179),
    [aux_sym_redirected_statement_repeat1] = STATE(179),
    [sym_herestring_redirect] = STATE(179),
    [sym_file_redirect] = STATE(179),
    [anon_sym_LT_LT_DASH] = ACTIONS(1149),
    [anon_sym_AMP_GT_GT] = ACTIONS(1152),
    [anon_sym_LF] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(1149),
    [sym_file_descriptor] = ACTIONS(1159),
    [anon_sym_GT] = ACTIONS(1152),
    [anon_sym_AMP_GT] = ACTIONS(1152),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [ts_builtin_sym_end] = ACTIONS(1155),
    [anon_sym_LT_LT_LT] = ACTIONS(1162),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_GT_AMP] = ACTIONS(1152),
    [anon_sym_LT] = ACTIONS(1152),
    [anon_sym_LT_AMP] = ACTIONS(1152),
    [anon_sym_GT_GT] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_SEMI_SEMI] = ACTIONS(1157),
    [anon_sym_PIPE_AMP] = ACTIONS(1157),
  },
  [180] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [ts_builtin_sym_end] = ACTIONS(1123),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [181] = {
    [sym_heredoc_body] = STATE(244),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(646),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(648),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [ts_builtin_sym_end] = ACTIONS(1123),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [182] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(106),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [aux_sym_command_repeat2] = STATE(186),
    [sym_concatenation] = STATE(186),
    [sym_expansion] = STATE(104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(13),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_LPAREN] = ACTIONS(335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(339),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [sym_word] = ACTIONS(341),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_LT_AMP] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_EQ_TILDE] = ACTIONS(343),
    [sym__special_character] = ACTIONS(29),
    [anon_sym_LT_LT_DASH] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(345),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1165),
    [sym_raw_string] = ACTIONS(341),
    [sym_file_descriptor] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP_GT] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(343),
    [ts_builtin_sym_end] = ACTIONS(1167),
    [anon_sym_LT_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_AMP] = ACTIONS(1165),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_LT_LPAREN] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
  },
  [183] = {
    [aux_sym_concatenation_repeat1] = STATE(60),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [sym__concat] = ACTIONS(193),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [ts_builtin_sym_end] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [184] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [ts_builtin_sym_end] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [185] = {
    [aux_sym__literal_repeat1] = STATE(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(1173),
    [anon_sym_DOLLAR] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [sym_word] = ACTIONS(1173),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_LT_AMP] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_EQ_TILDE] = ACTIONS(1173),
    [sym__special_character] = ACTIONS(301),
    [anon_sym_LT_LT_DASH] = ACTIONS(1173),
    [anon_sym_BQUOTE] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1173),
    [sym_raw_string] = ACTIONS(1173),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT] = ACTIONS(1173),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_LT_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_AMP] = ACTIONS(1173),
    [ts_builtin_sym_end] = ACTIONS(1175),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
  },
  [186] = {
    [sym_command_substitution] = STATE(104),
    [aux_sym__literal_repeat1] = STATE(106),
    [sym_string] = STATE(104),
    [sym_process_substitution] = STATE(104),
    [sym_simple_expansion] = STATE(104),
    [sym_string_expansion] = STATE(104),
    [aux_sym_command_repeat2] = STATE(186),
    [sym_concatenation] = STATE(186),
    [sym_expansion] = STATE(104),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1177),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1180),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1183),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1186),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1189),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(1192),
    [sym__special_character] = ACTIONS(1195),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1198),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1189),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(1201),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [ts_builtin_sym_end] = ACTIONS(1171),
    [anon_sym_LT_LPAREN] = ACTIONS(1180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [187] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_EQ_TILDE] = ACTIONS(1204),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [188] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(246),
    [sym_concatenation] = STATE(246),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1208),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1212),
    [anon_sym_COLON_DASH] = ACTIONS(1208),
    [sym__special_character] = ACTIONS(441),
  },
  [189] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [190] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(1214),
    [sym_raw_string] = ACTIONS(1217),
    [anon_sym_COLON_QMARK] = ACTIONS(1220),
    [anon_sym_DOLLAR] = ACTIONS(1223),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [anon_sym_DASH] = ACTIONS(1220),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1228),
    [anon_sym_EQ] = ACTIONS(1220),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1231),
    [anon_sym_PERCENT] = ACTIONS(1220),
    [anon_sym_COLON] = ACTIONS(1220),
    [anon_sym_GT_LPAREN] = ACTIONS(1234),
    [anon_sym_DQUOTE] = ACTIONS(1237),
    [sym_word] = ACTIONS(1240),
    [anon_sym_LT_LPAREN] = ACTIONS(1234),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1243),
    [anon_sym_COLON_DASH] = ACTIONS(1220),
    [sym__special_character] = ACTIONS(1246),
  },
  [191] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(246),
    [sym_concatenation] = STATE(246),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1208),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_DASH] = ACTIONS(1208),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1208),
    [anon_sym_PERCENT] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1212),
    [anon_sym_COLON_DASH] = ACTIONS(1208),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(1249),
  },
  [192] = {
    [sym_command_substitution] = STATE(248),
    [aux_sym__literal_repeat1] = STATE(249),
    [sym_string] = STATE(248),
    [sym_process_substitution] = STATE(248),
    [sym_simple_expansion] = STATE(248),
    [sym_string_expansion] = STATE(248),
    [sym_concatenation] = STATE(250),
    [sym_expansion] = STATE(248),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(1251),
    [sym_raw_string] = ACTIONS(1251),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [193] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(253),
    [sym_concatenation] = STATE(253),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1253),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(1253),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1253),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1253),
    [anon_sym_PERCENT] = ACTIONS(1253),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1257),
    [anon_sym_COLON_DASH] = ACTIONS(1253),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(1259),
  },
  [194] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [195] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1255),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [196] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1210),
    [sym__concat] = ACTIONS(1265),
  },
  [197] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1269),
  },
  [198] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1210),
  },
  [199] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [200] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(256),
    [sym_concatenation] = STATE(256),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1275),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1279),
    [anon_sym_COLON_DASH] = ACTIONS(1275),
    [sym__special_character] = ACTIONS(441),
  },
  [201] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [202] = {
    [sym_compound_statement] = STATE(257),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
  },
  [203] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1281),
    [anon_sym_AMP_GT_GT] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [sym_file_descriptor] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [ts_builtin_sym_end] = ACTIONS(1283),
    [anon_sym_LT_LT_LT] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_GT_AMP] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_LT_AMP] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1281),
  },
  [204] = {
    [sym_string] = STATE(48),
    [anon_sym__] = ACTIONS(175),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(1287),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(1287),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(175),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(175),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(1291),
    [anon_sym_BANG] = ACTIONS(1287),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(175),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(349),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1287),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [205] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1293),
    [anon_sym_SEMI] = ACTIONS(1295),
    [anon_sym_SEMI_SEMI] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1295),
  },
  [206] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(259),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_fi] = ACTIONS(1297),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [207] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1299),
    [anon_sym_AMP_GT_GT] = ACTIONS(1299),
    [anon_sym_LF] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [sym_file_descriptor] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_AMP_GT] = ACTIONS(1299),
    [anon_sym_PIPE_PIPE] = ACTIONS(1299),
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym_LT_LT_LT] = ACTIONS(1299),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_GT_AMP] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_LT_AMP] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1299),
    [anon_sym_SEMI_SEMI] = ACTIONS(1299),
    [anon_sym_PIPE_AMP] = ACTIONS(1299),
  },
  [208] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym__terminated_statement] = STATE(260),
    [sym_if_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_negated_command] = STATE(66),
    [sym_test_command] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_compound_statement] = STATE(66),
    [sym_subshell] = STATE(66),
    [sym_declaration_command] = STATE(66),
    [sym_unset_command] = STATE(66),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_pipeline] = STATE(66),
    [sym_list] = STATE(66),
    [sym_command] = STATE(66),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [209] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_LF] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1303),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [210] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1305),
    [anon_sym_SEMI] = ACTIONS(1303),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1303),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [211] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1307),
  },
  [212] = {
    [aux_sym_if_statement_repeat1] = STATE(264),
    [sym_elif_clause] = STATE(264),
    [sym_else_clause] = STATE(265),
    [anon_sym_elif] = ACTIONS(1309),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1307),
    [anon_sym_else] = ACTIONS(1311),
  },
  [213] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_elif_clause] = STATE(266),
    [sym_else_clause] = STATE(265),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_if_statement_repeat1] = STATE(266),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_fi] = ACTIONS(1313),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [anon_sym_elif] = ACTIONS(960),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [214] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1315),
    [anon_sym_SEMI] = ACTIONS(1317),
    [anon_sym_SEMI_SEMI] = ACTIONS(1317),
    [anon_sym_AMP] = ACTIONS(1317),
  },
  [215] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(273),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(272),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(273),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(1323),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [216] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(1325),
    [anon_sym_SEMI] = ACTIONS(1327),
    [anon_sym_SEMI_SEMI] = ACTIONS(1327),
    [anon_sym_AMP] = ACTIONS(1327),
  },
  [217] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(278),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(277),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(278),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(1329),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [218] = {
    [sym_test_operator] = ACTIONS(1331),
    [anon_sym_PLUS_EQ] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1331),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1331),
    [anon_sym_LT] = ACTIONS(1333),
    [anon_sym_EQ_TILDE] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1331),
    [anon_sym_DASH_EQ] = ACTIONS(1331),
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1331),
  },
  [219] = {
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_PLUS_EQ] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_EQ_TILDE] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1335),
    [anon_sym_DASH_EQ] = ACTIONS(1335),
    [anon_sym_BANG_EQ] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1335),
    [anon_sym_GT_EQ] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1337),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
  },
  [220] = {
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_PLUS_EQ] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_EQ_TILDE] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1335),
    [anon_sym_DASH_EQ] = ACTIONS(1335),
    [anon_sym_BANG_EQ] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1335),
    [anon_sym_GT_EQ] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1337),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
  },
  [221] = {
    [aux_sym_concatenation_repeat1] = STATE(1130),
    [anon_sym_BQUOTE] = ACTIONS(1339),
    [anon_sym_DQUOTE] = ACTIONS(1339),
    [sym_word] = ACTIONS(1339),
    [sym_raw_string] = ACTIONS(1339),
    [sym__concat] = ACTIONS(1341),
    [anon_sym_LT_LPAREN] = ACTIONS(1339),
    [anon_sym_DOLLAR] = ACTIONS(1343),
    [anon_sym_RPAREN] = ACTIONS(1339),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1339),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1339),
    [sym__special_character] = ACTIONS(1339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1339),
  },
  [222] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [ts_builtin_sym_end] = ACTIONS(1347),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [223] = {
    [aux_sym__literal_repeat1] = STATE(1165),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [anon_sym_DQUOTE] = ACTIONS(1349),
    [sym_word] = ACTIONS(1349),
    [sym_raw_string] = ACTIONS(1349),
    [anon_sym_LT_LPAREN] = ACTIONS(1349),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_RPAREN] = ACTIONS(1349),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1349),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1349),
    [sym__special_character] = ACTIONS(1353),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1349),
  },
  [224] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(1355),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [225] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1357),
    [sym__concat] = ACTIONS(1359),
    [anon_sym_EQ] = ACTIONS(1357),
  },
  [226] = {
    [sym_command_substitution] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_string_expansion] = STATE(818),
    [sym_string] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [sym_expansion] = STATE(818),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(1361),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_RBRACK] = ACTIONS(1363),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(1365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [227] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1367),
    [sym__concat] = ACTIONS(1369),
    [anon_sym_EQ] = ACTIONS(1367),
  },
  [228] = {
    [anon_sym_RBRACK] = ACTIONS(1371),
    [sym_comment] = ACTIONS(51),
  },
  [229] = {
    [anon_sym_RBRACK] = ACTIONS(1363),
    [sym_comment] = ACTIONS(51),
  },
  [230] = {
    [anon_sym_DOLLAR] = ACTIONS(1373),
    [anon_sym_BQUOTE] = ACTIONS(1375),
    [anon_sym_DQUOTE] = ACTIONS(1375),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1375),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1375),
    [sym__string_content] = ACTIONS(1373),
  },
  [231] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_EQ_TILDE] = ACTIONS(1377),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [232] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [233] = {
    [sym_command_substitution] = STATE(481),
    [aux_sym__literal_repeat1] = STATE(483),
    [sym_string] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(502),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_concatenation] = STATE(502),
    [sym_expansion] = STATE(481),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_raw_string] = ACTIONS(1383),
    [anon_sym_LF] = ACTIONS(1385),
    [anon_sym_SEMI] = ACTIONS(1387),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [anon_sym_GT_LPAREN] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_word] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(1387),
    [anon_sym_LT_LPAREN] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1397),
    [anon_sym_SEMI_SEMI] = ACTIONS(1387),
  },
  [234] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1399),
    [anon_sym_AMP_GT_GT] = ACTIONS(1399),
    [anon_sym_LF] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [sym_file_descriptor] = ACTIONS(1401),
    [anon_sym_GT] = ACTIONS(1399),
    [anon_sym_AMP_GT] = ACTIONS(1399),
    [anon_sym_PIPE_PIPE] = ACTIONS(1399),
    [ts_builtin_sym_end] = ACTIONS(1401),
    [anon_sym_LT_LT_LT] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_GT_AMP] = ACTIONS(1399),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_LT_AMP] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_SEMI_SEMI] = ACTIONS(1399),
    [anon_sym_PIPE_AMP] = ACTIONS(1399),
  },
  [235] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(287),
    [sym_postfix_expression] = STATE(287),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(287),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(287),
    [sym_binary_expression] = STATE(287),
    [sym_concatenation] = STATE(287),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1403),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [236] = {
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
  },
  [237] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(289),
    [sym_postfix_expression] = STATE(289),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(289),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(289),
    [sym_binary_expression] = STATE(289),
    [sym_concatenation] = STATE(289),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(1405),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(1405),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(1405),
  },
  [238] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [ts_builtin_sym_end] = ACTIONS(1409),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
  },
  [239] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_done] = ACTIONS(1411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [240] = {
    [anon_sym_STAR] = ACTIONS(1413),
    [anon_sym_QMARK] = ACTIONS(1413),
    [anon_sym_BANG] = ACTIONS(1415),
    [anon_sym_AT] = ACTIONS(1413),
    [anon_sym_DOLLAR] = ACTIONS(1415),
    [anon_sym_POUND] = ACTIONS(1415),
    [anon_sym_DASH] = ACTIONS(1415),
    [anon_sym_0] = ACTIONS(1417),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1417),
    [anon_sym__] = ACTIONS(1417),
  },
  [241] = {
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1419),
    [anon_sym_LF] = ACTIONS(1419),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_SEMI_SEMI] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1421),
  },
  [242] = {
    [sym_command_substitution] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [aux_sym_heredoc_body_repeat1] = STATE(292),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1115),
    [sym__heredoc_body_end] = ACTIONS(1423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [sym__heredoc_body_middle] = ACTIONS(1425),
  },
  [243] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [ts_builtin_sym_end] = ACTIONS(1431),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [244] = {
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1431),
    [anon_sym_LF] = ACTIONS(1433),
    [anon_sym_SEMI] = ACTIONS(1435),
    [anon_sym_SEMI_SEMI] = ACTIONS(1435),
    [anon_sym_AMP] = ACTIONS(1435),
  },
  [245] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [246] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [247] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(295),
    [sym_concatenation] = STATE(295),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1443),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1443),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1443),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1443),
    [anon_sym_PERCENT] = ACTIONS(1443),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1445),
    [anon_sym_COLON_DASH] = ACTIONS(1443),
    [sym__special_character] = ACTIONS(441),
  },
  [248] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1441),
    [sym__concat] = ACTIONS(1265),
  },
  [249] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(1447),
  },
  [250] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1441),
  },
  [251] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [252] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(298),
    [sym_concatenation] = STATE(298),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(1453),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(1453),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(1453),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(1453),
    [anon_sym_PERCENT] = ACTIONS(1453),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1457),
    [anon_sym_COLON_DASH] = ACTIONS(1453),
    [sym__special_character] = ACTIONS(441),
  },
  [253] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1455),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [254] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1459),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [255] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_EQ_TILDE] = ACTIONS(1463),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [256] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1467),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [257] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1469),
    [anon_sym_AMP_GT_GT] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_LT_LT] = ACTIONS(1469),
    [sym_file_descriptor] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1469),
    [anon_sym_AMP_GT] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [ts_builtin_sym_end] = ACTIONS(1471),
    [anon_sym_LT_LT_LT] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_GT_AMP] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(1469),
    [anon_sym_LT_AMP] = ACTIONS(1469),
    [anon_sym_GT_GT] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(1469),
  },
  [258] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_RBRACE] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [259] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_fi] = ACTIONS(1473),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [260] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(1475),
  },
  [261] = {
    [sym_heredoc_body] = STATE(301),
    [anon_sym_AMP_GT_GT] = ACTIONS(1477),
    [anon_sym_typeset] = ACTIONS(1479),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [anon_sym_GT_LPAREN] = ACTIONS(1477),
    [anon_sym_done] = ACTIONS(1479),
    [sym_word] = ACTIONS(1479),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [anon_sym_LT_AMP] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1479),
    [sym__special_character] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1477),
    [sym_raw_string] = ACTIONS(1477),
    [anon_sym_declare] = ACTIONS(1479),
    [sym_variable_name] = ACTIONS(1477),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_readonly] = ACTIONS(1479),
    [anon_sym_unset] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_GT_AMP] = ACTIONS(1477),
    [anon_sym_elif] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_local] = ACTIONS(1479),
    [anon_sym_unsetenv] = ACTIONS(1479),
    [anon_sym_fi] = ACTIONS(1479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1477),
    [anon_sym_BQUOTE] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [sym_file_descriptor] = ACTIONS(1477),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_AMP_GT] = ACTIONS(1479),
    [anon_sym_LT_LPAREN] = ACTIONS(1477),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1477),
  },
  [262] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1477),
    [anon_sym_typeset] = ACTIONS(1479),
    [anon_sym_DOLLAR] = ACTIONS(1479),
    [anon_sym_GT_LPAREN] = ACTIONS(1477),
    [anon_sym_done] = ACTIONS(1479),
    [sym_word] = ACTIONS(1479),
    [anon_sym_LT_AMP] = ACTIONS(1477),
    [anon_sym_export] = ACTIONS(1479),
    [sym__special_character] = ACTIONS(1479),
    [anon_sym_if] = ACTIONS(1479),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1477),
    [sym_raw_string] = ACTIONS(1477),
    [anon_sym_declare] = ACTIONS(1479),
    [sym_variable_name] = ACTIONS(1477),
    [anon_sym_readonly] = ACTIONS(1479),
    [anon_sym_unset] = ACTIONS(1479),
    [anon_sym_DQUOTE] = ACTIONS(1477),
    [anon_sym_GT_AMP] = ACTIONS(1477),
    [anon_sym_elif] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1479),
    [anon_sym_LPAREN] = ACTIONS(1479),
    [anon_sym_local] = ACTIONS(1479),
    [anon_sym_unsetenv] = ACTIONS(1479),
    [anon_sym_fi] = ACTIONS(1479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1477),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1477),
    [anon_sym_function] = ACTIONS(1479),
    [anon_sym_LBRACE] = ACTIONS(1477),
    [anon_sym_LT] = ACTIONS(1479),
    [anon_sym_GT_GT] = ACTIONS(1477),
    [anon_sym_BQUOTE] = ACTIONS(1477),
    [anon_sym_case] = ACTIONS(1479),
    [anon_sym_BANG] = ACTIONS(1479),
    [sym_file_descriptor] = ACTIONS(1477),
    [anon_sym_GT] = ACTIONS(1479),
    [anon_sym_AMP_GT] = ACTIONS(1479),
    [anon_sym_LT_LPAREN] = ACTIONS(1477),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1479),
    [anon_sym_LBRACK] = ACTIONS(1479),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1477),
  },
  [263] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1481),
    [anon_sym_AMP_GT_GT] = ACTIONS(1481),
    [anon_sym_LF] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [sym_file_descriptor] = ACTIONS(1483),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_AMP_GT] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [ts_builtin_sym_end] = ACTIONS(1483),
    [anon_sym_LT_LT_LT] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_GT_AMP] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_LT_AMP] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(1481),
  },
  [264] = {
    [aux_sym_if_statement_repeat1] = STATE(264),
    [sym_elif_clause] = STATE(264),
    [anon_sym_elif] = ACTIONS(1485),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1488),
    [anon_sym_else] = ACTIONS(1488),
  },
  [265] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1490),
  },
  [266] = {
    [aux_sym_if_statement_repeat1] = STATE(264),
    [sym_elif_clause] = STATE(264),
    [sym_else_clause] = STATE(303),
    [anon_sym_elif] = ACTIONS(1309),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1490),
    [anon_sym_else] = ACTIONS(1311),
  },
  [267] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(1492),
    [anon_sym_typeset] = ACTIONS(1495),
    [anon_sym_DOLLAR] = ACTIONS(1498),
    [anon_sym_GT_LPAREN] = ACTIONS(1501),
    [anon_sym_done] = ACTIONS(1479),
    [sym_word] = ACTIONS(1504),
    [anon_sym_LT_AMP] = ACTIONS(1492),
    [anon_sym_export] = ACTIONS(1495),
    [sym__special_character] = ACTIONS(1507),
    [anon_sym_if] = ACTIONS(1510),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1513),
    [sym_raw_string] = ACTIONS(1516),
    [anon_sym_declare] = ACTIONS(1495),
    [sym_variable_name] = ACTIONS(1519),
    [anon_sym_readonly] = ACTIONS(1495),
    [anon_sym_unset] = ACTIONS(1522),
    [anon_sym_DQUOTE] = ACTIONS(1525),
    [anon_sym_GT_AMP] = ACTIONS(1492),
    [anon_sym_elif] = ACTIONS(1479),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_LPAREN] = ACTIONS(1531),
    [anon_sym_local] = ACTIONS(1495),
    [anon_sym_unsetenv] = ACTIONS(1522),
    [anon_sym_fi] = ACTIONS(1479),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1534),
    [anon_sym_else] = ACTIONS(1479),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1537),
    [anon_sym_function] = ACTIONS(1540),
    [anon_sym_LBRACE] = ACTIONS(1543),
    [anon_sym_LT] = ACTIONS(1546),
    [anon_sym_GT_GT] = ACTIONS(1492),
    [anon_sym_BQUOTE] = ACTIONS(1549),
    [anon_sym_case] = ACTIONS(1552),
    [anon_sym_BANG] = ACTIONS(1555),
    [sym_file_descriptor] = ACTIONS(1558),
    [anon_sym_GT] = ACTIONS(1546),
    [anon_sym_AMP_GT] = ACTIONS(1546),
    [anon_sym_LT_LPAREN] = ACTIONS(1501),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1561),
    [anon_sym_LBRACK] = ACTIONS(1564),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1567),
  },
  [268] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(306),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(305),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(306),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(1570),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [269] = {
    [aux_sym_concatenation_repeat1] = STATE(773),
    [aux_sym_case_item_repeat1] = STATE(309),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [sym__concat] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1574),
  },
  [270] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1576),
    [anon_sym_AMP_GT_GT] = ACTIONS(1576),
    [anon_sym_LF] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1576),
    [anon_sym_LT_LT] = ACTIONS(1576),
    [sym_file_descriptor] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_AMP_GT] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [ts_builtin_sym_end] = ACTIONS(1578),
    [anon_sym_LT_LT_LT] = ACTIONS(1576),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_GT_AMP] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_LT_AMP] = ACTIONS(1576),
    [anon_sym_GT_GT] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_SEMI_SEMI] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(1576),
  },
  [271] = {
    [aux_sym__literal_repeat1] = STATE(776),
    [aux_sym_case_item_repeat1] = STATE(311),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1580),
    [anon_sym_PIPE] = ACTIONS(1574),
    [sym__special_character] = ACTIONS(1582),
  },
  [272] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1584),
  },
  [273] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(312),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(305),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [274] = {
    [aux_sym_case_item_repeat1] = STATE(309),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1572),
    [sym_comment] = ACTIONS(51),
  },
  [275] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(315),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(314),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(315),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(1586),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [276] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1588),
    [anon_sym_AMP_GT_GT] = ACTIONS(1588),
    [anon_sym_LF] = ACTIONS(1590),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [sym_file_descriptor] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [ts_builtin_sym_end] = ACTIONS(1590),
    [anon_sym_LT_LT_LT] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_GT_AMP] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_LT_AMP] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_SEMI_SEMI] = ACTIONS(1588),
    [anon_sym_PIPE_AMP] = ACTIONS(1588),
  },
  [277] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1592),
  },
  [278] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(312),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(314),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [279] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [ts_builtin_sym_end] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [280] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(1598),
    [anon_sym_DQUOTE] = ACTIONS(1601),
    [sym_word] = ACTIONS(1604),
    [sym_raw_string] = ACTIONS(1604),
    [anon_sym_LT_LPAREN] = ACTIONS(1607),
    [anon_sym_DOLLAR] = ACTIONS(1610),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1607),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1615),
    [sym__special_character] = ACTIONS(1618),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1621),
  },
  [281] = {
    [anon_sym_EQ] = ACTIONS(1624),
    [anon_sym_PLUS_EQ] = ACTIONS(1624),
    [sym_comment] = ACTIONS(51),
  },
  [282] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1624),
    [sym__concat] = ACTIONS(1626),
    [anon_sym_EQ] = ACTIONS(1624),
  },
  [283] = {
    [anon_sym_EQ] = ACTIONS(1628),
    [anon_sym_PLUS_EQ] = ACTIONS(1628),
    [sym_comment] = ACTIONS(51),
  },
  [284] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(1628),
    [sym__concat] = ACTIONS(1630),
    [anon_sym_EQ] = ACTIONS(1628),
  },
  [285] = {
    [sym_do_group] = STATE(318),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(625),
  },
  [286] = {
    [sym_do_group] = STATE(320),
    [sym_compound_statement] = STATE(320),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1632),
    [anon_sym_do] = ACTIONS(625),
  },
  [287] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1634),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [288] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(322),
    [sym_postfix_expression] = STATE(322),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(322),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(322),
    [sym_binary_expression] = STATE(322),
    [sym_concatenation] = STATE(322),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1634),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [289] = {
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(1636),
    [anon_sym_SEMI] = ACTIONS(1636),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(1636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(1636),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
  },
  [290] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1638),
    [anon_sym_AMP_GT_GT] = ACTIONS(1638),
    [anon_sym_LF] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_LT_LT] = ACTIONS(1638),
    [sym_file_descriptor] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1638),
    [anon_sym_AMP_GT] = ACTIONS(1638),
    [anon_sym_PIPE_PIPE] = ACTIONS(1638),
    [ts_builtin_sym_end] = ACTIONS(1640),
    [anon_sym_LT_LT_LT] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(1638),
    [anon_sym_GT_AMP] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1638),
    [anon_sym_LT_AMP] = ACTIONS(1638),
    [anon_sym_GT_GT] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1638),
    [anon_sym_SEMI_SEMI] = ACTIONS(1638),
    [anon_sym_PIPE_AMP] = ACTIONS(1638),
  },
  [291] = {
    [sym_comment] = ACTIONS(3),
    [ts_builtin_sym_end] = ACTIONS(1642),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
  },
  [292] = {
    [sym_command_substitution] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [aux_sym_heredoc_body_repeat1] = STATE(292),
    [anon_sym_DOLLAR] = ACTIONS(1646),
    [anon_sym_BQUOTE] = ACTIONS(1649),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1652),
    [sym__heredoc_body_end] = ACTIONS(1655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1657),
    [sym__heredoc_body_middle] = ACTIONS(1660),
  },
  [293] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [ts_builtin_sym_end] = ACTIONS(1663),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [294] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [295] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1669),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [296] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [ts_builtin_sym_end] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [297] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1675),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [298] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [299] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [300] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(326),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_fi] = ACTIONS(1685),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_else] = ACTIONS(1685),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [anon_sym_elif] = ACTIONS(1685),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [301] = {
    [anon_sym_LF] = ACTIONS(1687),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_AMP] = ACTIONS(1689),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1689),
  },
  [302] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1691),
    [anon_sym_AMP_GT_GT] = ACTIONS(1691),
    [anon_sym_LF] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1691),
    [sym_file_descriptor] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_AMP_GT] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [ts_builtin_sym_end] = ACTIONS(1693),
    [anon_sym_LT_LT_LT] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_GT_AMP] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_LT_AMP] = ACTIONS(1691),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_SEMI_SEMI] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
  },
  [303] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(1695),
  },
  [304] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1697),
    [anon_sym_AMP_GT_GT] = ACTIONS(1697),
    [anon_sym_LF] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [sym_file_descriptor] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_AMP_GT] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym_LT_LT_LT] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_GT_AMP] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_LT_AMP] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_SEMI_SEMI] = ACTIONS(1697),
    [anon_sym_PIPE_AMP] = ACTIONS(1697),
  },
  [305] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1701),
  },
  [306] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(312),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(330),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [307] = {
    [sym_command_substitution] = STATE(331),
    [aux_sym__literal_repeat1] = STATE(332),
    [sym_string] = STATE(331),
    [sym_process_substitution] = STATE(331),
    [sym_simple_expansion] = STATE(331),
    [sym_string_expansion] = STATE(331),
    [sym_concatenation] = STATE(333),
    [sym_expansion] = STATE(331),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1703),
    [sym_raw_string] = ACTIONS(1703),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [308] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_negated_command] = STATE(539),
    [sym_test_command] = STATE(539),
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [aux_sym__statements_repeat1] = STATE(634),
    [sym_redirected_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_compound_statement] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_declaration_command] = STATE(539),
    [sym_unset_command] = STATE(539),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym__statements] = STATE(335),
    [sym_c_style_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_esac] = ACTIONS(1731),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1733),
  },
  [309] = {
    [aux_sym_case_item_repeat1] = STATE(337),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1735),
    [sym_comment] = ACTIONS(51),
  },
  [310] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_negated_command] = STATE(539),
    [sym_test_command] = STATE(539),
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [aux_sym__statements_repeat1] = STATE(634),
    [sym_redirected_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_compound_statement] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_declaration_command] = STATE(539),
    [sym_unset_command] = STATE(539),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym__statements] = STATE(339),
    [sym_c_style_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_esac] = ACTIONS(1737),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1739),
  },
  [311] = {
    [aux_sym_case_item_repeat1] = STATE(337),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1741),
    [sym_comment] = ACTIONS(51),
  },
  [312] = {
    [sym_command_substitution] = STATE(341),
    [aux_sym__literal_repeat1] = STATE(342),
    [sym_case_item] = STATE(312),
    [sym_string] = STATE(341),
    [sym_process_substitution] = STATE(341),
    [sym_simple_expansion] = STATE(341),
    [sym_string_expansion] = STATE(341),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [sym_concatenation] = STATE(343),
    [sym_expansion] = STATE(341),
    [anon_sym_BQUOTE] = ACTIONS(1743),
    [anon_sym_DQUOTE] = ACTIONS(1746),
    [sym_word] = ACTIONS(1749),
    [sym_raw_string] = ACTIONS(1749),
    [anon_sym_LT_LPAREN] = ACTIONS(1752),
    [anon_sym_DOLLAR] = ACTIONS(1755),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1752),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1758),
    [sym__special_character] = ACTIONS(1761),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1764),
  },
  [313] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1767),
    [anon_sym_AMP_GT_GT] = ACTIONS(1767),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_LT_LT] = ACTIONS(1767),
    [sym_file_descriptor] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_AMP_GT] = ACTIONS(1767),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [ts_builtin_sym_end] = ACTIONS(1769),
    [anon_sym_LT_LT_LT] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1767),
    [anon_sym_GT_AMP] = ACTIONS(1767),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_LT_AMP] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_SEMI_SEMI] = ACTIONS(1767),
    [anon_sym_PIPE_AMP] = ACTIONS(1767),
  },
  [314] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1771),
  },
  [315] = {
    [sym_command_substitution] = STATE(269),
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_case_item] = STATE(312),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(345),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [316] = {
    [anon_sym_EQ] = ACTIONS(1773),
    [anon_sym_PLUS_EQ] = ACTIONS(1773),
    [sym_comment] = ACTIONS(51),
  },
  [317] = {
    [anon_sym_EQ] = ACTIONS(1775),
    [anon_sym_PLUS_EQ] = ACTIONS(1775),
    [sym_comment] = ACTIONS(51),
  },
  [318] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1777),
    [anon_sym_AMP_GT_GT] = ACTIONS(1777),
    [anon_sym_LF] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1777),
    [sym_file_descriptor] = ACTIONS(1779),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_AMP_GT] = ACTIONS(1777),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [ts_builtin_sym_end] = ACTIONS(1779),
    [anon_sym_LT_LT_LT] = ACTIONS(1777),
    [anon_sym_PIPE] = ACTIONS(1777),
    [anon_sym_GT_AMP] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_LT_AMP] = ACTIONS(1777),
    [anon_sym_GT_GT] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(1777),
  },
  [319] = {
    [sym_do_group] = STATE(346),
    [sym_compound_statement] = STATE(346),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(625),
  },
  [320] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1781),
    [anon_sym_AMP_GT_GT] = ACTIONS(1781),
    [anon_sym_LF] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_LT_LT] = ACTIONS(1781),
    [sym_file_descriptor] = ACTIONS(1783),
    [anon_sym_GT] = ACTIONS(1781),
    [anon_sym_AMP_GT] = ACTIONS(1781),
    [anon_sym_PIPE_PIPE] = ACTIONS(1781),
    [ts_builtin_sym_end] = ACTIONS(1783),
    [anon_sym_LT_LT_LT] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1781),
    [anon_sym_GT_AMP] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1781),
    [anon_sym_LT_AMP] = ACTIONS(1781),
    [anon_sym_GT_GT] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_SEMI_SEMI] = ACTIONS(1781),
    [anon_sym_PIPE_AMP] = ACTIONS(1781),
  },
  [321] = {
    [sym_do_group] = STATE(346),
    [sym_compound_statement] = STATE(346),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1785),
    [anon_sym_do] = ACTIONS(625),
  },
  [322] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1787),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [323] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(349),
    [sym_postfix_expression] = STATE(349),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(349),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(349),
    [sym_binary_expression] = STATE(349),
    [sym_concatenation] = STATE(349),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1787),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [324] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_EQ_TILDE] = ACTIONS(1789),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [325] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_EQ_TILDE] = ACTIONS(1793),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [ts_builtin_sym_end] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [326] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_fi] = ACTIONS(1797),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_else] = ACTIONS(1797),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [anon_sym_elif] = ACTIONS(1797),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [327] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1799),
    [anon_sym_typeset] = ACTIONS(1801),
    [anon_sym_DOLLAR] = ACTIONS(1801),
    [anon_sym_GT_LPAREN] = ACTIONS(1799),
    [anon_sym_done] = ACTIONS(1801),
    [sym_word] = ACTIONS(1801),
    [anon_sym_LT_AMP] = ACTIONS(1799),
    [anon_sym_export] = ACTIONS(1801),
    [sym__special_character] = ACTIONS(1801),
    [anon_sym_if] = ACTIONS(1801),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1799),
    [sym_raw_string] = ACTIONS(1799),
    [anon_sym_declare] = ACTIONS(1801),
    [sym_variable_name] = ACTIONS(1799),
    [anon_sym_readonly] = ACTIONS(1801),
    [anon_sym_unset] = ACTIONS(1801),
    [anon_sym_DQUOTE] = ACTIONS(1799),
    [anon_sym_GT_AMP] = ACTIONS(1799),
    [anon_sym_elif] = ACTIONS(1801),
    [anon_sym_while] = ACTIONS(1801),
    [anon_sym_LPAREN] = ACTIONS(1801),
    [anon_sym_local] = ACTIONS(1801),
    [anon_sym_unsetenv] = ACTIONS(1801),
    [anon_sym_fi] = ACTIONS(1801),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1799),
    [anon_sym_else] = ACTIONS(1801),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1799),
    [anon_sym_function] = ACTIONS(1801),
    [anon_sym_LBRACE] = ACTIONS(1799),
    [anon_sym_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1799),
    [anon_sym_BQUOTE] = ACTIONS(1799),
    [anon_sym_case] = ACTIONS(1801),
    [anon_sym_BANG] = ACTIONS(1801),
    [sym_file_descriptor] = ACTIONS(1799),
    [anon_sym_GT] = ACTIONS(1801),
    [anon_sym_AMP_GT] = ACTIONS(1801),
    [anon_sym_LT_LPAREN] = ACTIONS(1799),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1801),
    [anon_sym_LBRACK] = ACTIONS(1801),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1799),
  },
  [328] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1803),
    [anon_sym_AMP_GT_GT] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_LT_LT] = ACTIONS(1803),
    [sym_file_descriptor] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [ts_builtin_sym_end] = ACTIONS(1805),
    [anon_sym_LT_LT_LT] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_GT_AMP] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_LT_AMP] = ACTIONS(1803),
    [anon_sym_GT_GT] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
  },
  [329] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1807),
    [anon_sym_AMP_GT_GT] = ACTIONS(1807),
    [anon_sym_LF] = ACTIONS(1809),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1807),
    [sym_file_descriptor] = ACTIONS(1809),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_AMP_GT] = ACTIONS(1807),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [ts_builtin_sym_end] = ACTIONS(1809),
    [anon_sym_LT_LT_LT] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_GT_AMP] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_LT_AMP] = ACTIONS(1807),
    [anon_sym_GT_GT] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1807),
    [anon_sym_PIPE_AMP] = ACTIONS(1807),
  },
  [330] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1811),
  },
  [331] = {
    [aux_sym_concatenation_repeat1] = STATE(773),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [sym__concat] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1813),
  },
  [332] = {
    [aux_sym__literal_repeat1] = STATE(776),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1815),
    [anon_sym_PIPE] = ACTIONS(1815),
    [sym__special_character] = ACTIONS(1582),
  },
  [333] = {
    [anon_sym_PIPE] = ACTIONS(1813),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [sym_comment] = ACTIONS(51),
  },
  [334] = {
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [anon_sym_DQUOTE] = ACTIONS(1817),
    [sym_word] = ACTIONS(1819),
    [sym_raw_string] = ACTIONS(1817),
    [anon_sym_LT_LPAREN] = ACTIONS(1817),
    [anon_sym_esac] = ACTIONS(1821),
    [anon_sym_DOLLAR] = ACTIONS(1819),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1817),
    [sym__special_character] = ACTIONS(1817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1817),
  },
  [335] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1823),
    [anon_sym_esac] = ACTIONS(1825),
  },
  [336] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_negated_command] = STATE(539),
    [sym_test_command] = STATE(539),
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [aux_sym__statements_repeat1] = STATE(634),
    [sym_redirected_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_compound_statement] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_declaration_command] = STATE(539),
    [sym_unset_command] = STATE(539),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym__statements] = STATE(352),
    [sym_c_style_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_esac] = ACTIONS(1821),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1823),
  },
  [337] = {
    [aux_sym_case_item_repeat1] = STATE(337),
    [anon_sym_PIPE] = ACTIONS(1827),
    [anon_sym_RPAREN] = ACTIONS(1813),
    [sym_comment] = ACTIONS(51),
  },
  [338] = {
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_DQUOTE] = ACTIONS(1830),
    [sym_word] = ACTIONS(1832),
    [sym_raw_string] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1830),
    [anon_sym_esac] = ACTIONS(1834),
    [anon_sym_DOLLAR] = ACTIONS(1832),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1830),
    [sym__special_character] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1830),
  },
  [339] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1836),
    [anon_sym_esac] = ACTIONS(1838),
  },
  [340] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_negated_command] = STATE(539),
    [sym_test_command] = STATE(539),
    [sym_variable_assignment] = STATE(633),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [aux_sym__statements_repeat1] = STATE(634),
    [sym_redirected_statement] = STATE(539),
    [sym_for_statement] = STATE(539),
    [sym_compound_statement] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_declaration_command] = STATE(539),
    [sym_unset_command] = STATE(539),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym__statements] = STATE(354),
    [sym_c_style_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_esac] = ACTIONS(1834),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1836),
  },
  [341] = {
    [aux_sym_concatenation_repeat1] = STATE(773),
    [aux_sym_case_item_repeat1] = STATE(356),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [sym__concat] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1574),
  },
  [342] = {
    [aux_sym__literal_repeat1] = STATE(776),
    [aux_sym_case_item_repeat1] = STATE(358),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_PIPE] = ACTIONS(1574),
    [sym__special_character] = ACTIONS(1582),
  },
  [343] = {
    [aux_sym_case_item_repeat1] = STATE(356),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1840),
    [sym_comment] = ACTIONS(51),
  },
  [344] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1844),
    [anon_sym_AMP_GT_GT] = ACTIONS(1844),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_LT_LT] = ACTIONS(1844),
    [sym_file_descriptor] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1844),
    [anon_sym_AMP_GT] = ACTIONS(1844),
    [anon_sym_PIPE_PIPE] = ACTIONS(1844),
    [ts_builtin_sym_end] = ACTIONS(1846),
    [anon_sym_LT_LT_LT] = ACTIONS(1844),
    [anon_sym_PIPE] = ACTIONS(1844),
    [anon_sym_GT_AMP] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_LT_AMP] = ACTIONS(1844),
    [anon_sym_GT_GT] = ACTIONS(1844),
    [anon_sym_AMP] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1844),
    [anon_sym_SEMI_SEMI] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(1844),
  },
  [345] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(1848),
  },
  [346] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1850),
    [anon_sym_AMP_GT_GT] = ACTIONS(1850),
    [anon_sym_LF] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_LT_LT] = ACTIONS(1850),
    [sym_file_descriptor] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1850),
    [anon_sym_AMP_GT] = ACTIONS(1850),
    [anon_sym_PIPE_PIPE] = ACTIONS(1850),
    [ts_builtin_sym_end] = ACTIONS(1852),
    [anon_sym_LT_LT_LT] = ACTIONS(1850),
    [anon_sym_PIPE] = ACTIONS(1850),
    [anon_sym_GT_AMP] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_LT_AMP] = ACTIONS(1850),
    [anon_sym_GT_GT] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1850),
    [anon_sym_SEMI_SEMI] = ACTIONS(1850),
    [anon_sym_PIPE_AMP] = ACTIONS(1850),
  },
  [347] = {
    [sym_do_group] = STATE(360),
    [sym_compound_statement] = STATE(360),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(625),
  },
  [348] = {
    [sym_do_group] = STATE(360),
    [sym_compound_statement] = STATE(360),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1854),
    [anon_sym_do] = ACTIONS(625),
  },
  [349] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1856),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [350] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1858),
    [anon_sym_AMP_GT_GT] = ACTIONS(1858),
    [anon_sym_LF] = ACTIONS(1860),
    [anon_sym_SEMI] = ACTIONS(1858),
    [anon_sym_LT_LT] = ACTIONS(1858),
    [sym_file_descriptor] = ACTIONS(1860),
    [anon_sym_GT] = ACTIONS(1858),
    [anon_sym_AMP_GT] = ACTIONS(1858),
    [anon_sym_PIPE_PIPE] = ACTIONS(1858),
    [ts_builtin_sym_end] = ACTIONS(1860),
    [anon_sym_LT_LT_LT] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_GT_AMP] = ACTIONS(1858),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_LT_AMP] = ACTIONS(1858),
    [anon_sym_GT_GT] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1858),
    [anon_sym_SEMI_SEMI] = ACTIONS(1858),
    [anon_sym_PIPE_AMP] = ACTIONS(1858),
  },
  [351] = {
    [anon_sym_BQUOTE] = ACTIONS(1862),
    [anon_sym_DQUOTE] = ACTIONS(1862),
    [sym_word] = ACTIONS(1864),
    [sym_raw_string] = ACTIONS(1862),
    [anon_sym_LT_LPAREN] = ACTIONS(1862),
    [anon_sym_esac] = ACTIONS(1866),
    [anon_sym_DOLLAR] = ACTIONS(1864),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1862),
    [sym__special_character] = ACTIONS(1862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1862),
  },
  [352] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1868),
    [anon_sym_esac] = ACTIONS(1870),
  },
  [353] = {
    [anon_sym_BQUOTE] = ACTIONS(1872),
    [anon_sym_DQUOTE] = ACTIONS(1872),
    [sym_word] = ACTIONS(1874),
    [sym_raw_string] = ACTIONS(1872),
    [anon_sym_LT_LPAREN] = ACTIONS(1872),
    [anon_sym_esac] = ACTIONS(1876),
    [anon_sym_DOLLAR] = ACTIONS(1874),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1872),
    [sym__special_character] = ACTIONS(1872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1872),
  },
  [354] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1878),
    [anon_sym_esac] = ACTIONS(1880),
  },
  [355] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_negated_command] = STATE(632),
    [sym_test_command] = STATE(632),
    [sym_variable_assignment] = STATE(693),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(1462),
    [sym_redirected_statement] = STATE(632),
    [sym_for_statement] = STATE(632),
    [sym_compound_statement] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_declaration_command] = STATE(632),
    [sym_unset_command] = STATE(632),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(366),
    [sym_c_style_for_statement] = STATE(632),
    [sym_while_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_list] = STATE(632),
    [sym_command] = STATE(632),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1882),
  },
  [356] = {
    [aux_sym_case_item_repeat1] = STATE(337),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [sym_comment] = ACTIONS(51),
  },
  [357] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_negated_command] = STATE(632),
    [sym_test_command] = STATE(632),
    [sym_variable_assignment] = STATE(693),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(1462),
    [sym_redirected_statement] = STATE(632),
    [sym_for_statement] = STATE(632),
    [sym_compound_statement] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_declaration_command] = STATE(632),
    [sym_unset_command] = STATE(632),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(369),
    [sym_c_style_for_statement] = STATE(632),
    [sym_while_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_list] = STATE(632),
    [sym_command] = STATE(632),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1886),
  },
  [358] = {
    [aux_sym_case_item_repeat1] = STATE(337),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(1888),
    [sym_comment] = ACTIONS(51),
  },
  [359] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [ts_builtin_sym_end] = ACTIONS(1892),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
  },
  [360] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1894),
    [anon_sym_AMP_GT_GT] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_LT_LT] = ACTIONS(1894),
    [sym_file_descriptor] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1894),
    [anon_sym_AMP_GT] = ACTIONS(1894),
    [anon_sym_PIPE_PIPE] = ACTIONS(1894),
    [ts_builtin_sym_end] = ACTIONS(1896),
    [anon_sym_LT_LT_LT] = ACTIONS(1894),
    [anon_sym_PIPE] = ACTIONS(1894),
    [anon_sym_GT_AMP] = ACTIONS(1894),
    [anon_sym_LT] = ACTIONS(1894),
    [anon_sym_LT_AMP] = ACTIONS(1894),
    [anon_sym_GT_GT] = ACTIONS(1894),
    [anon_sym_AMP] = ACTIONS(1894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1894),
    [anon_sym_SEMI_SEMI] = ACTIONS(1894),
    [anon_sym_PIPE_AMP] = ACTIONS(1894),
  },
  [361] = {
    [sym_do_group] = STATE(371),
    [sym_compound_statement] = STATE(371),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(625),
  },
  [362] = {
    [sym_do_group] = STATE(371),
    [sym_compound_statement] = STATE(371),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_SEMI] = ACTIONS(1898),
    [anon_sym_do] = ACTIONS(625),
  },
  [363] = {
    [anon_sym_BQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE] = ACTIONS(1900),
    [sym_word] = ACTIONS(1902),
    [sym_raw_string] = ACTIONS(1900),
    [anon_sym_LT_LPAREN] = ACTIONS(1900),
    [anon_sym_esac] = ACTIONS(1904),
    [anon_sym_DOLLAR] = ACTIONS(1902),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1900),
    [sym__special_character] = ACTIONS(1900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1900),
  },
  [364] = {
    [anon_sym_BQUOTE] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(1906),
    [sym_word] = ACTIONS(1908),
    [sym_raw_string] = ACTIONS(1906),
    [anon_sym_LT_LPAREN] = ACTIONS(1906),
    [anon_sym_esac] = ACTIONS(1910),
    [anon_sym_DOLLAR] = ACTIONS(1908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1906),
    [sym__special_character] = ACTIONS(1906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1906),
  },
  [365] = {
    [anon_sym_BQUOTE] = ACTIONS(1817),
    [anon_sym_DQUOTE] = ACTIONS(1817),
    [sym_word] = ACTIONS(1817),
    [sym_raw_string] = ACTIONS(1817),
    [anon_sym_LT_LPAREN] = ACTIONS(1817),
    [anon_sym_DOLLAR] = ACTIONS(1819),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1817),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1817),
    [sym__special_character] = ACTIONS(1817),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1817),
  },
  [366] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1912),
  },
  [367] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_negated_command] = STATE(632),
    [sym_test_command] = STATE(632),
    [sym_variable_assignment] = STATE(693),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(1462),
    [sym_redirected_statement] = STATE(632),
    [sym_for_statement] = STATE(632),
    [sym_compound_statement] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_declaration_command] = STATE(632),
    [sym_unset_command] = STATE(632),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(374),
    [sym_c_style_for_statement] = STATE(632),
    [sym_while_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_list] = STATE(632),
    [sym_command] = STATE(632),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1912),
  },
  [368] = {
    [anon_sym_BQUOTE] = ACTIONS(1830),
    [anon_sym_DQUOTE] = ACTIONS(1830),
    [sym_word] = ACTIONS(1830),
    [sym_raw_string] = ACTIONS(1830),
    [anon_sym_LT_LPAREN] = ACTIONS(1830),
    [anon_sym_DOLLAR] = ACTIONS(1832),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1830),
    [sym__special_character] = ACTIONS(1830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1830),
  },
  [369] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
  },
  [370] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(632),
    [sym_function_definition] = STATE(632),
    [sym_negated_command] = STATE(632),
    [sym_test_command] = STATE(632),
    [sym_variable_assignment] = STATE(693),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(1462),
    [sym_redirected_statement] = STATE(632),
    [sym_for_statement] = STATE(632),
    [sym_compound_statement] = STATE(632),
    [sym_subshell] = STATE(632),
    [sym_declaration_command] = STATE(632),
    [sym_unset_command] = STATE(632),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(376),
    [sym_c_style_for_statement] = STATE(632),
    [sym_while_statement] = STATE(632),
    [sym_case_statement] = STATE(632),
    [sym_pipeline] = STATE(632),
    [sym_list] = STATE(632),
    [sym_command] = STATE(632),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [anon_sym_SEMI_SEMI] = ACTIONS(1914),
  },
  [371] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_SEMI] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1916),
    [sym_file_descriptor] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [ts_builtin_sym_end] = ACTIONS(1918),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
  },
  [372] = {
    [sym_do_group] = STATE(377),
    [sym_compound_statement] = STATE(377),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(25),
    [anon_sym_do] = ACTIONS(625),
  },
  [373] = {
    [anon_sym_BQUOTE] = ACTIONS(1862),
    [anon_sym_DQUOTE] = ACTIONS(1862),
    [sym_word] = ACTIONS(1862),
    [sym_raw_string] = ACTIONS(1862),
    [anon_sym_LT_LPAREN] = ACTIONS(1862),
    [anon_sym_DOLLAR] = ACTIONS(1864),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1862),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1862),
    [sym__special_character] = ACTIONS(1862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1862),
  },
  [374] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1920),
  },
  [375] = {
    [anon_sym_BQUOTE] = ACTIONS(1872),
    [anon_sym_DQUOTE] = ACTIONS(1872),
    [sym_word] = ACTIONS(1872),
    [sym_raw_string] = ACTIONS(1872),
    [anon_sym_LT_LPAREN] = ACTIONS(1872),
    [anon_sym_DOLLAR] = ACTIONS(1874),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1872),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1872),
    [sym__special_character] = ACTIONS(1872),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1872),
  },
  [376] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_SEMI_SEMI] = ACTIONS(1922),
  },
  [377] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LF] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [ts_builtin_sym_end] = ACTIONS(1926),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
  },
  [378] = {
    [anon_sym_BQUOTE] = ACTIONS(1900),
    [anon_sym_DQUOTE] = ACTIONS(1900),
    [sym_word] = ACTIONS(1900),
    [sym_raw_string] = ACTIONS(1900),
    [anon_sym_LT_LPAREN] = ACTIONS(1900),
    [anon_sym_DOLLAR] = ACTIONS(1902),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1900),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1900),
    [sym__special_character] = ACTIONS(1900),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1900),
  },
  [379] = {
    [anon_sym_BQUOTE] = ACTIONS(1906),
    [anon_sym_DQUOTE] = ACTIONS(1906),
    [sym_word] = ACTIONS(1906),
    [sym_raw_string] = ACTIONS(1906),
    [anon_sym_LT_LPAREN] = ACTIONS(1906),
    [anon_sym_DOLLAR] = ACTIONS(1908),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1906),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1906),
    [sym__special_character] = ACTIONS(1906),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1906),
  },
  [380] = {
    [aux_sym__literal_repeat1] = STATE(397),
    [sym_string] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [sym_variable_assignment] = STATE(398),
    [sym_subscript] = STATE(2464),
    [sym_concatenation] = STATE(398),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [aux_sym_declaration_command_repeat1] = STATE(398),
    [sym_simple_expansion] = STATE(396),
    [sym_string_expansion] = STATE(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_GT_LPAREN] = ACTIONS(1930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1932),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1934),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [sym_word] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_AMP] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym__special_character] = ACTIONS(1940),
    [anon_sym_LT_LT_DASH] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(123),
    [sym_raw_string] = ACTIONS(1938),
    [sym_variable_name] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(123),
    [sym_file_descriptor] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_AMP_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(123),
    [anon_sym_GT_AMP] = ACTIONS(123),
    [anon_sym_LT_LPAREN] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(123),
    [anon_sym_SEMI_SEMI] = ACTIONS(123),
    [anon_sym_PIPE_AMP] = ACTIONS(123),
  },
  [381] = {
    [sym_command_substitution] = STATE(399),
    [aux_sym__literal_repeat1] = STATE(400),
    [sym_string] = STATE(399),
    [aux_sym_unset_command_repeat1] = STATE(401),
    [sym_process_substitution] = STATE(399),
    [sym_simple_expansion] = STATE(399),
    [sym_string_expansion] = STATE(399),
    [sym_concatenation] = STATE(401),
    [sym_expansion] = STATE(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_LT_LT] = ACTIONS(147),
    [anon_sym_GT_LPAREN] = ACTIONS(1950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1954),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [sym_word] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(147),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_RPAREN] = ACTIONS(147),
    [sym_file_descriptor] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(147),
    [anon_sym_GT_AMP] = ACTIONS(147),
    [anon_sym_LT_LPAREN] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_SEMI_SEMI] = ACTIONS(147),
    [anon_sym_PIPE_AMP] = ACTIONS(147),
  },
  [382] = {
    [aux_sym_concatenation_repeat1] = STATE(405),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(1968),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [383] = {
    [aux_sym_concatenation_repeat1] = STATE(405),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(1968),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [384] = {
    [aux_sym_concatenation_repeat1] = STATE(405),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(1968),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [385] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [sym_test_command] = STATE(409),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(391),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_command] = STATE(409),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [sym_subshell] = STATE(409),
    [sym_file_redirect] = STATE(391),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [sym_word] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [386] = {
    [aux_sym__literal_repeat1] = STATE(412),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [sym_word] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [sym__special_character] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LF] = ACTIONS(303),
    [anon_sym_SEMI] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [anon_sym_RPAREN] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [anon_sym_LT_LT_LT] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_SEMI_SEMI] = ACTIONS(299),
    [anon_sym_PIPE_AMP] = ACTIONS(299),
  },
  [387] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [388] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1974),
    [anon_sym_SEMI] = ACTIONS(1972),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(1976),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [389] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [anon_sym_RPAREN] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [390] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(418),
    [sym_function_definition] = STATE(418),
    [sym_negated_command] = STATE(418),
    [sym_test_command] = STATE(418),
    [sym_variable_assignment] = STATE(419),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(418),
    [sym_for_statement] = STATE(418),
    [sym_compound_statement] = STATE(418),
    [sym_subshell] = STATE(418),
    [sym_declaration_command] = STATE(418),
    [sym_unset_command] = STATE(418),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(418),
    [sym_while_statement] = STATE(418),
    [sym_case_statement] = STATE(418),
    [sym_pipeline] = STATE(418),
    [sym_list] = STATE(418),
    [sym_command] = STATE(418),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [391] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [sym_variable_assignment] = STATE(103),
    [sym_subscript] = STATE(2455),
    [aux_sym_command_repeat1] = STATE(103),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_command_name] = STATE(421),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [sym_file_redirect] = STATE(103),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [sym_word] = ACTIONS(89),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [sym__special_character] = ACTIONS(1978),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(89),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
  },
  [392] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(425),
    [sym_concatenation] = STATE(425),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(333),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_LT_AMP] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(333),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(333),
    [sym_file_descriptor] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(333),
    [anon_sym_GT_AMP] = ACTIONS(333),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_SEMI_SEMI] = ACTIONS(333),
    [anon_sym_PIPE_AMP] = ACTIONS(333),
  },
  [393] = {
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_GT_AMP] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
    [sym__concat] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
  },
  [394] = {
    [aux_sym__literal_repeat1] = STATE(1037),
    [anon_sym_LT_LT_DASH] = ACTIONS(361),
    [anon_sym_AMP_GT_GT] = ACTIONS(361),
    [anon_sym_LF] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [sym_file_descriptor] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_AMP_GT] = ACTIONS(361),
    [anon_sym_PIPE_PIPE] = ACTIONS(361),
    [ts_builtin_sym_end] = ACTIONS(359),
    [anon_sym_LT_LT_LT] = ACTIONS(361),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_GT_AMP] = ACTIONS(361),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_AMP] = ACTIONS(361),
    [anon_sym_GT_GT] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(361),
    [sym__special_character] = ACTIONS(1147),
    [anon_sym_SEMI_SEMI] = ACTIONS(361),
    [anon_sym_PIPE_AMP] = ACTIONS(361),
  },
  [395] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [ts_builtin_sym_end] = ACTIONS(353),
    [anon_sym_LT_LT_LT] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_GT_AMP] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
  },
  [396] = {
    [aux_sym_concatenation_repeat1] = STATE(842),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_DOLLAR] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(365),
    [aux_sym__simple_variable_name_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [sym_word] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [sym__concat] = ACTIONS(1994),
    [sym__special_character] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(369),
    [anon_sym_SEMI] = ACTIONS(365),
    [sym_raw_string] = ACTIONS(365),
    [sym_variable_name] = ACTIONS(369),
    [anon_sym_RPAREN] = ACTIONS(365),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_DQUOTE] = ACTIONS(365),
    [anon_sym_LT_LT_LT] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
  },
  [397] = {
    [aux_sym__literal_repeat1] = STATE(845),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [anon_sym_LT_LT] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [aux_sym__simple_variable_name_token1] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [sym_word] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [sym__special_character] = ACTIONS(1996),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LF] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [sym_variable_name] = ACTIONS(375),
    [anon_sym_RPAREN] = ACTIONS(371),
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_LT_LT_LT] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(371),
    [anon_sym_PIPE_AMP] = ACTIONS(371),
  },
  [398] = {
    [aux_sym__literal_repeat1] = STATE(397),
    [sym_string] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [sym_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(2464),
    [sym_concatenation] = STATE(427),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [aux_sym_declaration_command_repeat1] = STATE(427),
    [sym_simple_expansion] = STATE(396),
    [sym_string_expansion] = STATE(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_LPAREN] = ACTIONS(1930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1932),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1998),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [sym_word] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [sym__special_character] = ACTIONS(1940),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(1942),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(1938),
    [sym_variable_name] = ACTIONS(1944),
    [anon_sym_RPAREN] = ACTIONS(377),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LPAREN] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
  },
  [399] = {
    [aux_sym_concatenation_repeat1] = STATE(874),
    [anon_sym_AMP_GT_GT] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_GT_LPAREN] = ACTIONS(383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(383),
    [aux_sym__simple_variable_name_token1] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [sym_word] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(383),
    [anon_sym_LT_AMP] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(383),
    [sym__concat] = ACTIONS(2000),
    [sym__special_character] = ACTIONS(383),
    [anon_sym_LT_LT_DASH] = ACTIONS(383),
    [anon_sym_BQUOTE] = ACTIONS(383),
    [anon_sym_LF] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [sym_raw_string] = ACTIONS(383),
    [anon_sym_RPAREN] = ACTIONS(383),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(383),
    [anon_sym_AMP_GT] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(383),
    [anon_sym_GT_AMP] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_SEMI_SEMI] = ACTIONS(383),
    [anon_sym_PIPE_AMP] = ACTIONS(383),
  },
  [400] = {
    [aux_sym__literal_repeat1] = STATE(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [aux_sym__simple_variable_name_token1] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [sym__special_character] = ACTIONS(2002),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [anon_sym_RPAREN] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [401] = {
    [sym_command_substitution] = STATE(399),
    [aux_sym__literal_repeat1] = STATE(400),
    [sym_string] = STATE(399),
    [aux_sym_unset_command_repeat1] = STATE(428),
    [sym_process_substitution] = STATE(399),
    [sym_simple_expansion] = STATE(399),
    [sym_string_expansion] = STATE(399),
    [sym_concatenation] = STATE(428),
    [sym_expansion] = STATE(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(395),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_LT_LT] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(1950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [sym_word] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(395),
    [anon_sym_AMP] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_LT_AMP] = ACTIONS(395),
    [anon_sym_GT_GT] = ACTIONS(395),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(395),
    [anon_sym_BQUOTE] = ACTIONS(1962),
    [anon_sym_LF] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_RPAREN] = ACTIONS(395),
    [sym_file_descriptor] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(395),
    [anon_sym_AMP_GT] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(395),
    [anon_sym_GT_AMP] = ACTIONS(395),
    [anon_sym_LT_LPAREN] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_SEMI_SEMI] = ACTIONS(395),
    [anon_sym_PIPE_AMP] = ACTIONS(395),
  },
  [402] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_EQ_TILDE] = ACTIONS(401),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [403] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_EQ_TILDE] = ACTIONS(405),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [404] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(409),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [405] = {
    [aux_sym_concatenation_repeat1] = STATE(436),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2006),
    [anon_sym_EQ_TILDE] = ACTIONS(469),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [406] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(475),
    [anon_sym_LT_LT] = ACTIONS(475),
    [anon_sym_PIPE_PIPE] = ACTIONS(475),
    [anon_sym_PIPE] = ACTIONS(475),
    [anon_sym_AMP] = ACTIONS(475),
    [anon_sym_LT] = ACTIONS(475),
    [anon_sym_LT_AMP] = ACTIONS(475),
    [anon_sym_GT_GT] = ACTIONS(475),
    [anon_sym_LT_LT_DASH] = ACTIONS(475),
    [anon_sym_BQUOTE] = ACTIONS(475),
    [anon_sym_LF] = ACTIONS(477),
    [anon_sym_SEMI] = ACTIONS(475),
    [anon_sym_RPAREN] = ACTIONS(475),
    [sym_file_descriptor] = ACTIONS(477),
    [anon_sym_GT] = ACTIONS(475),
    [anon_sym_AMP_GT] = ACTIONS(475),
    [anon_sym_LT_LT_LT] = ACTIONS(475),
    [anon_sym_GT_AMP] = ACTIONS(475),
    [anon_sym_esac] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(475),
    [anon_sym_SEMI_SEMI] = ACTIONS(475),
    [anon_sym_PIPE_AMP] = ACTIONS(475),
  },
  [407] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [anon_sym_BANG_EQ] = ACTIONS(519),
    [anon_sym_PLUS_EQ] = ACTIONS(519),
    [sym_test_operator] = ACTIONS(519),
    [anon_sym_PLUS_PLUS] = ACTIONS(519),
    [anon_sym_RBRACK] = ACTIONS(519),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(519),
    [anon_sym_PIPE_PIPE] = ACTIONS(519),
    [anon_sym_GT_EQ] = ACTIONS(519),
    [sym__concat] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(519),
    [anon_sym_DASH_DASH] = ACTIONS(519),
    [anon_sym_LT_EQ] = ACTIONS(519),
    [anon_sym_AMP_AMP] = ACTIONS(519),
    [anon_sym_DASH_EQ] = ACTIONS(519),
  },
  [408] = {
    [aux_sym__literal_repeat1] = STATE(813),
    [anon_sym_BANG_EQ] = ACTIONS(525),
    [anon_sym_PLUS_EQ] = ACTIONS(525),
    [sym_test_operator] = ACTIONS(525),
    [anon_sym_PLUS_PLUS] = ACTIONS(525),
    [anon_sym_RBRACK] = ACTIONS(525),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(525),
    [anon_sym_PIPE_PIPE] = ACTIONS(525),
    [anon_sym_GT_EQ] = ACTIONS(525),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(527),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(525),
    [anon_sym_DASH_DASH] = ACTIONS(525),
    [anon_sym_LT_EQ] = ACTIONS(525),
    [anon_sym_AMP_AMP] = ACTIONS(525),
    [sym__special_character] = ACTIONS(2010),
    [anon_sym_DASH_EQ] = ACTIONS(525),
  },
  [409] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(543),
    [anon_sym_LT_LT] = ACTIONS(543),
    [anon_sym_PIPE_PIPE] = ACTIONS(543),
    [anon_sym_PIPE] = ACTIONS(543),
    [anon_sym_AMP] = ACTIONS(543),
    [anon_sym_LT] = ACTIONS(543),
    [anon_sym_LT_AMP] = ACTIONS(543),
    [anon_sym_GT_GT] = ACTIONS(543),
    [anon_sym_LT_LT_DASH] = ACTIONS(543),
    [anon_sym_BQUOTE] = ACTIONS(543),
    [anon_sym_LF] = ACTIONS(545),
    [anon_sym_SEMI] = ACTIONS(543),
    [anon_sym_RPAREN] = ACTIONS(543),
    [sym_file_descriptor] = ACTIONS(545),
    [anon_sym_GT] = ACTIONS(543),
    [anon_sym_AMP_GT] = ACTIONS(543),
    [anon_sym_LT_LT_LT] = ACTIONS(543),
    [anon_sym_GT_AMP] = ACTIONS(543),
    [anon_sym_esac] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(543),
    [anon_sym_SEMI_SEMI] = ACTIONS(543),
    [anon_sym_PIPE_AMP] = ACTIONS(543),
  },
  [410] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(583),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [411] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [412] = {
    [aux_sym__literal_repeat1] = STATE(412),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_EQ_TILDE] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2012),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [413] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(454),
    [sym_function_definition] = STATE(454),
    [sym_negated_command] = STATE(454),
    [sym_test_command] = STATE(454),
    [sym_variable_assignment] = STATE(455),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(454),
    [sym_for_statement] = STATE(454),
    [sym_compound_statement] = STATE(454),
    [sym_subshell] = STATE(454),
    [sym_declaration_command] = STATE(454),
    [sym_unset_command] = STATE(454),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(454),
    [sym_while_statement] = STATE(454),
    [sym_case_statement] = STATE(454),
    [sym_pipeline] = STATE(454),
    [sym_list] = STATE(454),
    [sym_command] = STATE(454),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [414] = {
    [sym_heredoc_body] = STATE(457),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(650),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [415] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [sym_word] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(650),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_SEMI_SEMI] = ACTIONS(650),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(642),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [416] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(459),
    [sym_function_definition] = STATE(459),
    [sym_negated_command] = STATE(459),
    [sym_test_command] = STATE(459),
    [sym_variable_assignment] = STATE(460),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(459),
    [sym_for_statement] = STATE(459),
    [sym_compound_statement] = STATE(459),
    [sym_subshell] = STATE(459),
    [sym_declaration_command] = STATE(459),
    [sym_unset_command] = STATE(459),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(459),
    [sym_while_statement] = STATE(459),
    [sym_case_statement] = STATE(459),
    [sym_pipeline] = STATE(459),
    [sym_list] = STATE(459),
    [sym_command] = STATE(459),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [417] = {
    [sym_heredoc_redirect] = STATE(464),
    [aux_sym_redirected_statement_repeat1] = STATE(464),
    [sym_herestring_redirect] = STATE(464),
    [sym_file_redirect] = STATE(464),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_AMP] = ACTIONS(672),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(672),
    [anon_sym_LF] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(672),
    [anon_sym_RPAREN] = ACTIONS(672),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_SEMI_SEMI] = ACTIONS(672),
    [anon_sym_PIPE_AMP] = ACTIONS(672),
  },
  [418] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(2017),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2017),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [419] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2015),
    [anon_sym_SEMI] = ACTIONS(2017),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(2019),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2017),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [420] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_negated_command] = STATE(62),
    [sym_test_command] = STATE(62),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(420),
    [sym_redirected_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_subshell] = STATE(62),
    [sym_declaration_command] = STATE(62),
    [sym_unset_command] = STATE(62),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_pipeline] = STATE(62),
    [sym_list] = STATE(62),
    [sym_command] = STATE(62),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(678),
    [anon_sym_AMP_GT_GT] = ACTIONS(681),
    [anon_sym_local] = ACTIONS(684),
    [anon_sym_typeset] = ACTIONS(684),
    [anon_sym_unsetenv] = ACTIONS(687),
    [anon_sym_DOLLAR] = ACTIONS(690),
    [anon_sym_GT_LPAREN] = ACTIONS(693),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(696),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(699),
    [anon_sym_function] = ACTIONS(702),
    [sym_word] = ACTIONS(705),
    [anon_sym_LBRACE] = ACTIONS(708),
    [anon_sym_LT] = ACTIONS(711),
    [anon_sym_LT_AMP] = ACTIONS(681),
    [anon_sym_GT_GT] = ACTIONS(681),
    [anon_sym_export] = ACTIONS(684),
    [sym__special_character] = ACTIONS(714),
    [anon_sym_if] = ACTIONS(717),
    [anon_sym_case] = ACTIONS(720),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(723),
    [sym_raw_string] = ACTIONS(726),
    [anon_sym_BQUOTE] = ACTIONS(729),
    [anon_sym_BANG] = ACTIONS(732),
    [anon_sym_declare] = ACTIONS(684),
    [sym_variable_name] = ACTIONS(735),
    [sym_file_descriptor] = ACTIONS(738),
    [anon_sym_RBRACE] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(711),
    [anon_sym_AMP_GT] = ACTIONS(711),
    [anon_sym_readonly] = ACTIONS(684),
    [anon_sym_unset] = ACTIONS(687),
    [anon_sym_DQUOTE] = ACTIONS(741),
    [anon_sym_GT_AMP] = ACTIONS(681),
    [anon_sym_LT_LPAREN] = ACTIONS(693),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(744),
    [anon_sym_while] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(750),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(753),
  },
  [421] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(467),
    [sym_concatenation] = STATE(467),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(756),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [422] = {
    [aux_sym_concatenation_repeat1] = STATE(405),
    [anon_sym_AMP_GT_GT] = ACTIONS(776),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_GT_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(776),
    [anon_sym_PIPE_PIPE] = ACTIONS(776),
    [sym_word] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_LT_AMP] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(776),
    [sym__concat] = ACTIONS(1968),
    [anon_sym_EQ_TILDE] = ACTIONS(776),
    [sym__special_character] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(776),
    [anon_sym_LF] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_raw_string] = ACTIONS(776),
    [anon_sym_RPAREN] = ACTIONS(776),
    [sym_file_descriptor] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(776),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_GT_AMP] = ACTIONS(776),
    [anon_sym_LT_LPAREN] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(776),
    [anon_sym_SEMI_SEMI] = ACTIONS(776),
    [anon_sym_PIPE_AMP] = ACTIONS(776),
  },
  [423] = {
    [sym_command_substitution] = STATE(468),
    [aux_sym__literal_repeat1] = STATE(470),
    [sym_string] = STATE(468),
    [sym_process_substitution] = STATE(468),
    [sym_simple_expansion] = STATE(468),
    [sym_string_expansion] = STATE(468),
    [sym_concatenation] = STATE(469),
    [sym_expansion] = STATE(468),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(2021),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_word] = ACTIONS(2021),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1978),
    [sym_regex] = ACTIONS(2023),
  },
  [424] = {
    [aux_sym__literal_repeat1] = STATE(412),
    [anon_sym_AMP_GT_GT] = ACTIONS(784),
    [anon_sym_DOLLAR] = ACTIONS(784),
    [anon_sym_LT_LT] = ACTIONS(784),
    [anon_sym_GT_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(784),
    [anon_sym_PIPE_PIPE] = ACTIONS(784),
    [sym_word] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_LT_AMP] = ACTIONS(784),
    [anon_sym_GT_GT] = ACTIONS(784),
    [anon_sym_EQ_TILDE] = ACTIONS(784),
    [sym__special_character] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(784),
    [anon_sym_BQUOTE] = ACTIONS(784),
    [anon_sym_LF] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_raw_string] = ACTIONS(784),
    [anon_sym_RPAREN] = ACTIONS(784),
    [sym_file_descriptor] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(784),
    [anon_sym_AMP_GT] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(784),
    [anon_sym_LT_LT_LT] = ACTIONS(784),
    [anon_sym_GT_AMP] = ACTIONS(784),
    [anon_sym_LT_LPAREN] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(784),
    [anon_sym_SEMI_SEMI] = ACTIONS(784),
    [anon_sym_PIPE_AMP] = ACTIONS(784),
  },
  [425] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(471),
    [sym_concatenation] = STATE(471),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(756),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [426] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(788),
    [anon_sym_LT_LT] = ACTIONS(788),
    [anon_sym_PIPE_PIPE] = ACTIONS(788),
    [anon_sym_PIPE] = ACTIONS(788),
    [anon_sym_AMP] = ACTIONS(788),
    [anon_sym_LT] = ACTIONS(788),
    [anon_sym_LT_AMP] = ACTIONS(788),
    [anon_sym_GT_GT] = ACTIONS(788),
    [anon_sym_LT_LT_DASH] = ACTIONS(788),
    [anon_sym_BQUOTE] = ACTIONS(788),
    [anon_sym_LF] = ACTIONS(790),
    [anon_sym_SEMI] = ACTIONS(788),
    [anon_sym_RPAREN] = ACTIONS(788),
    [sym_file_descriptor] = ACTIONS(790),
    [anon_sym_GT] = ACTIONS(788),
    [anon_sym_AMP_GT] = ACTIONS(788),
    [anon_sym_LT_LT_LT] = ACTIONS(788),
    [anon_sym_GT_AMP] = ACTIONS(788),
    [anon_sym_esac] = ACTIONS(788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(788),
    [anon_sym_SEMI_SEMI] = ACTIONS(788),
    [anon_sym_PIPE_AMP] = ACTIONS(788),
  },
  [427] = {
    [aux_sym__literal_repeat1] = STATE(397),
    [sym_string] = STATE(396),
    [sym_process_substitution] = STATE(396),
    [sym_variable_assignment] = STATE(427),
    [sym_subscript] = STATE(2464),
    [sym_concatenation] = STATE(427),
    [sym_expansion] = STATE(396),
    [sym_command_substitution] = STATE(396),
    [aux_sym_declaration_command_repeat1] = STATE(427),
    [sym_simple_expansion] = STATE(396),
    [sym_string_expansion] = STATE(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(792),
    [anon_sym_DOLLAR] = ACTIONS(2025),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_GT_LPAREN] = ACTIONS(2028),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2031),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2034),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2037),
    [anon_sym_PIPE_PIPE] = ACTIONS(792),
    [sym_word] = ACTIONS(2040),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_LT_AMP] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(792),
    [sym__special_character] = ACTIONS(2043),
    [anon_sym_LT_LT_DASH] = ACTIONS(792),
    [anon_sym_BQUOTE] = ACTIONS(2046),
    [anon_sym_LF] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(792),
    [sym_raw_string] = ACTIONS(2040),
    [sym_variable_name] = ACTIONS(2049),
    [anon_sym_RPAREN] = ACTIONS(792),
    [sym_file_descriptor] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(2052),
    [anon_sym_LT_LT_LT] = ACTIONS(792),
    [anon_sym_GT_AMP] = ACTIONS(792),
    [anon_sym_LT_LPAREN] = ACTIONS(2028),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(792),
    [anon_sym_SEMI_SEMI] = ACTIONS(792),
    [anon_sym_PIPE_AMP] = ACTIONS(792),
  },
  [428] = {
    [sym_command_substitution] = STATE(399),
    [aux_sym__literal_repeat1] = STATE(400),
    [sym_string] = STATE(399),
    [aux_sym_unset_command_repeat1] = STATE(428),
    [sym_process_substitution] = STATE(399),
    [sym_simple_expansion] = STATE(399),
    [sym_string_expansion] = STATE(399),
    [sym_concatenation] = STATE(428),
    [sym_expansion] = STATE(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(826),
    [anon_sym_GT_LPAREN] = ACTIONS(2058),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2061),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2064),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2067),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [sym_word] = ACTIONS(2070),
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(826),
    [anon_sym_LT_AMP] = ACTIONS(826),
    [anon_sym_GT_GT] = ACTIONS(826),
    [sym__special_character] = ACTIONS(2073),
    [anon_sym_LT_LT_DASH] = ACTIONS(826),
    [anon_sym_BQUOTE] = ACTIONS(2076),
    [anon_sym_LF] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(826),
    [sym_raw_string] = ACTIONS(2070),
    [anon_sym_RPAREN] = ACTIONS(826),
    [sym_file_descriptor] = ACTIONS(852),
    [anon_sym_GT] = ACTIONS(826),
    [anon_sym_AMP_GT] = ACTIONS(826),
    [anon_sym_DQUOTE] = ACTIONS(2079),
    [anon_sym_LT_LT_LT] = ACTIONS(826),
    [anon_sym_GT_AMP] = ACTIONS(826),
    [anon_sym_LT_LPAREN] = ACTIONS(2058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(826),
    [anon_sym_SEMI_SEMI] = ACTIONS(826),
    [anon_sym_PIPE_AMP] = ACTIONS(826),
  },
  [429] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_EQ_TILDE] = ACTIONS(857),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [430] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [431] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(879),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [432] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_EQ_TILDE] = ACTIONS(929),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [433] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(935),
    [anon_sym_LT_LT] = ACTIONS(935),
    [anon_sym_PIPE_PIPE] = ACTIONS(935),
    [anon_sym_PIPE] = ACTIONS(935),
    [anon_sym_AMP] = ACTIONS(935),
    [anon_sym_LT] = ACTIONS(935),
    [anon_sym_LT_AMP] = ACTIONS(935),
    [anon_sym_GT_GT] = ACTIONS(935),
    [anon_sym_LT_LT_DASH] = ACTIONS(935),
    [anon_sym_BQUOTE] = ACTIONS(935),
    [anon_sym_LF] = ACTIONS(937),
    [anon_sym_SEMI] = ACTIONS(935),
    [anon_sym_RPAREN] = ACTIONS(935),
    [sym_file_descriptor] = ACTIONS(937),
    [anon_sym_GT] = ACTIONS(935),
    [anon_sym_AMP_GT] = ACTIONS(935),
    [anon_sym_LT_LT_LT] = ACTIONS(935),
    [anon_sym_GT_AMP] = ACTIONS(935),
    [anon_sym_esac] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(935),
    [anon_sym_SEMI_SEMI] = ACTIONS(935),
    [anon_sym_PIPE_AMP] = ACTIONS(935),
  },
  [434] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [435] = {
    [sym_command_substitution] = STATE(434),
    [sym_string] = STATE(434),
    [sym_process_substitution] = STATE(434),
    [sym_simple_expansion] = STATE(434),
    [sym_string_expansion] = STATE(434),
    [sym_expansion] = STATE(434),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(2082),
    [anon_sym_DOLLAR] = ACTIONS(2084),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_word] = ACTIONS(2082),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2082),
  },
  [436] = {
    [aux_sym_concatenation_repeat1] = STATE(436),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2086),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [437] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [438] = {
    [sym_heredoc_body] = STATE(1418),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [439] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(952),
    [anon_sym_LT_LT] = ACTIONS(952),
    [anon_sym_PIPE_PIPE] = ACTIONS(952),
    [anon_sym_PIPE] = ACTIONS(952),
    [anon_sym_AMP] = ACTIONS(952),
    [anon_sym_LT] = ACTIONS(952),
    [anon_sym_LT_AMP] = ACTIONS(952),
    [anon_sym_GT_GT] = ACTIONS(952),
    [anon_sym_LT_LT_DASH] = ACTIONS(952),
    [anon_sym_BQUOTE] = ACTIONS(952),
    [anon_sym_LF] = ACTIONS(954),
    [anon_sym_SEMI] = ACTIONS(952),
    [anon_sym_RPAREN] = ACTIONS(952),
    [sym_file_descriptor] = ACTIONS(954),
    [anon_sym_GT] = ACTIONS(952),
    [anon_sym_AMP_GT] = ACTIONS(952),
    [anon_sym_LT_LT_LT] = ACTIONS(952),
    [anon_sym_GT_AMP] = ACTIONS(952),
    [anon_sym_esac] = ACTIONS(952),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(952),
    [anon_sym_SEMI_SEMI] = ACTIONS(952),
    [anon_sym_PIPE_AMP] = ACTIONS(952),
  },
  [440] = {
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_PLUS_EQ] = ACTIONS(627),
    [sym_test_operator] = ACTIONS(627),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_RBRACK] = ACTIONS(976),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_EQ] = ACTIONS(631),
    [anon_sym_EQ_EQ] = ACTIONS(633),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(631),
    [anon_sym_LT] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_AMP_AMP] = ACTIONS(627),
    [anon_sym_DASH_EQ] = ACTIONS(627),
  },
  [441] = {
    [sym_command_substitution] = STATE(407),
    [sym_unary_expression] = STATE(479),
    [sym_postfix_expression] = STATE(479),
    [sym_string] = STATE(407),
    [aux_sym__literal_repeat1] = STATE(408),
    [sym_process_substitution] = STATE(407),
    [sym_parenthesized_expression] = STATE(479),
    [sym_simple_expansion] = STATE(407),
    [sym_string_expansion] = STATE(407),
    [sym__expression] = STATE(479),
    [sym_binary_expression] = STATE(479),
    [sym_concatenation] = STATE(479),
    [sym_expansion] = STATE(407),
    [sym_test_operator] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(281),
    [sym_raw_string] = ACTIONS(283),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [442] = {
    [anon_sym_BANG_EQ] = ACTIONS(982),
    [anon_sym_PLUS_EQ] = ACTIONS(982),
    [sym_test_operator] = ACTIONS(982),
    [anon_sym_PLUS_PLUS] = ACTIONS(982),
    [anon_sym_RBRACK] = ACTIONS(982),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(984),
    [anon_sym_EQ_EQ] = ACTIONS(982),
    [anon_sym_PIPE_PIPE] = ACTIONS(982),
    [anon_sym_GT_EQ] = ACTIONS(982),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(984),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(982),
    [anon_sym_DASH_DASH] = ACTIONS(982),
    [anon_sym_LT_EQ] = ACTIONS(982),
    [anon_sym_AMP_AMP] = ACTIONS(982),
    [anon_sym_DASH_EQ] = ACTIONS(982),
  },
  [443] = {
    [sym_command_substitution] = STATE(407),
    [sym_unary_expression] = STATE(479),
    [sym_postfix_expression] = STATE(479),
    [sym_string] = STATE(407),
    [aux_sym__literal_repeat1] = STATE(408),
    [sym_process_substitution] = STATE(407),
    [sym_parenthesized_expression] = STATE(479),
    [sym_simple_expansion] = STATE(407),
    [sym_string_expansion] = STATE(407),
    [sym__expression] = STATE(479),
    [sym_binary_expression] = STATE(479),
    [sym_concatenation] = STATE(479),
    [sym_expansion] = STATE(407),
    [sym_test_operator] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(281),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(295),
    [sym_regex] = ACTIONS(2089),
  },
  [444] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(988),
    [anon_sym_LT_LT] = ACTIONS(988),
    [anon_sym_PIPE_PIPE] = ACTIONS(988),
    [anon_sym_PIPE] = ACTIONS(988),
    [anon_sym_AMP] = ACTIONS(988),
    [anon_sym_LT] = ACTIONS(988),
    [anon_sym_LT_AMP] = ACTIONS(988),
    [anon_sym_GT_GT] = ACTIONS(988),
    [anon_sym_LT_LT_DASH] = ACTIONS(988),
    [anon_sym_BQUOTE] = ACTIONS(988),
    [anon_sym_LF] = ACTIONS(990),
    [anon_sym_SEMI] = ACTIONS(988),
    [anon_sym_RPAREN] = ACTIONS(988),
    [sym_file_descriptor] = ACTIONS(990),
    [anon_sym_GT] = ACTIONS(988),
    [anon_sym_AMP_GT] = ACTIONS(988),
    [anon_sym_LT_LT_LT] = ACTIONS(988),
    [anon_sym_GT_AMP] = ACTIONS(988),
    [anon_sym_esac] = ACTIONS(988),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(988),
    [anon_sym_SEMI_SEMI] = ACTIONS(988),
    [anon_sym_PIPE_AMP] = ACTIONS(988),
  },
  [445] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [446] = {
    [aux_sym_concatenation_repeat1] = STATE(1034),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [447] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [448] = {
    [aux_sym__literal_repeat1] = STATE(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(2093),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [449] = {
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LF] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [ts_builtin_sym_end] = ACTIONS(1034),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1036),
    [sym__concat] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_SEMI_SEMI] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
  },
  [450] = {
    [aux_sym__literal_repeat1] = STATE(1037),
    [anon_sym_LT_LT_DASH] = ACTIONS(1040),
    [anon_sym_AMP_GT_GT] = ACTIONS(1040),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1040),
    [anon_sym_LT_LT] = ACTIONS(1040),
    [sym_file_descriptor] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_PIPE_PIPE] = ACTIONS(1040),
    [ts_builtin_sym_end] = ACTIONS(1038),
    [anon_sym_LT_LT_LT] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_GT_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_LT_AMP] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1040),
    [anon_sym_AMP] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1040),
    [sym__special_character] = ACTIONS(1147),
    [anon_sym_SEMI_SEMI] = ACTIONS(1040),
    [anon_sym_PIPE_AMP] = ACTIONS(1040),
  },
  [451] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LF] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [ts_builtin_sym_end] = ACTIONS(1034),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_SEMI_SEMI] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
  },
  [452] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_EQ_TILDE] = ACTIONS(1042),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [453] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_LT] = ACTIONS(1099),
    [anon_sym_PIPE_PIPE] = ACTIONS(1099),
    [anon_sym_PIPE] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_LT] = ACTIONS(1099),
    [anon_sym_LT_AMP] = ACTIONS(1099),
    [anon_sym_GT_GT] = ACTIONS(1099),
    [anon_sym_LT_LT_DASH] = ACTIONS(1099),
    [anon_sym_BQUOTE] = ACTIONS(1099),
    [anon_sym_LF] = ACTIONS(1101),
    [anon_sym_SEMI] = ACTIONS(1099),
    [anon_sym_RPAREN] = ACTIONS(1099),
    [sym_file_descriptor] = ACTIONS(1101),
    [anon_sym_GT] = ACTIONS(1099),
    [anon_sym_AMP_GT] = ACTIONS(1099),
    [anon_sym_LT_LT_LT] = ACTIONS(1099),
    [anon_sym_GT_AMP] = ACTIONS(1099),
    [anon_sym_esac] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1099),
    [anon_sym_SEMI_SEMI] = ACTIONS(1099),
    [anon_sym_PIPE_AMP] = ACTIONS(1099),
  },
  [454] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [455] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_RPAREN] = ACTIONS(1103),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [456] = {
    [anon_sym_BQUOTE] = ACTIONS(1109),
    [anon_sym_LF] = ACTIONS(1107),
    [anon_sym_SEMI] = ACTIONS(1109),
    [anon_sym_AMP] = ACTIONS(1109),
    [anon_sym_esac] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1109),
    [anon_sym_SEMI_SEMI] = ACTIONS(1109),
  },
  [457] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2095),
    [anon_sym_LF] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_SEMI_SEMI] = ACTIONS(2099),
    [anon_sym_AMP] = ACTIONS(2099),
  },
  [458] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1129),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_PIPE] = ACTIONS(1129),
    [anon_sym_AMP] = ACTIONS(1129),
    [anon_sym_LT] = ACTIONS(1129),
    [anon_sym_LT_AMP] = ACTIONS(1129),
    [anon_sym_GT_GT] = ACTIONS(1129),
    [anon_sym_LT_LT_DASH] = ACTIONS(1129),
    [anon_sym_BQUOTE] = ACTIONS(1129),
    [anon_sym_LF] = ACTIONS(1131),
    [anon_sym_SEMI] = ACTIONS(1129),
    [anon_sym_RPAREN] = ACTIONS(1129),
    [sym_file_descriptor] = ACTIONS(1131),
    [anon_sym_GT] = ACTIONS(1129),
    [anon_sym_AMP_GT] = ACTIONS(1129),
    [anon_sym_LT_LT_LT] = ACTIONS(1129),
    [anon_sym_GT_AMP] = ACTIONS(1129),
    [anon_sym_esac] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_SEMI_SEMI] = ACTIONS(1129),
    [anon_sym_PIPE_AMP] = ACTIONS(1129),
  },
  [459] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [sym_file_descriptor] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [460] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(1133),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [461] = {
    [aux_sym_concatenation_repeat1] = STATE(1066),
    [anon_sym_AMP_GT_GT] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [anon_sym_PIPE_PIPE] = ACTIONS(1137),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_AMP] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_LT_LT_DASH] = ACTIONS(1137),
    [anon_sym_BQUOTE] = ACTIONS(1137),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [sym_file_descriptor] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_AMP_GT] = ACTIONS(1137),
    [anon_sym_LT_LT_LT] = ACTIONS(1137),
    [anon_sym_GT_AMP] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_PIPE_AMP] = ACTIONS(1137),
  },
  [462] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(1143),
    [anon_sym_LT_LT] = ACTIONS(1143),
    [anon_sym_PIPE_PIPE] = ACTIONS(1143),
    [anon_sym_PIPE] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_LT] = ACTIONS(1143),
    [anon_sym_LT_AMP] = ACTIONS(1143),
    [anon_sym_GT_GT] = ACTIONS(1143),
    [sym__special_character] = ACTIONS(2103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1143),
    [anon_sym_BQUOTE] = ACTIONS(1143),
    [anon_sym_LF] = ACTIONS(1145),
    [anon_sym_SEMI] = ACTIONS(1143),
    [anon_sym_RPAREN] = ACTIONS(1143),
    [sym_file_descriptor] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1143),
    [anon_sym_AMP_GT] = ACTIONS(1143),
    [anon_sym_LT_LT_LT] = ACTIONS(1143),
    [anon_sym_GT_AMP] = ACTIONS(1143),
    [anon_sym_esac] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1143),
    [anon_sym_SEMI_SEMI] = ACTIONS(1143),
    [anon_sym_PIPE_AMP] = ACTIONS(1143),
  },
  [463] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [anon_sym_PIPE_PIPE] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_LT_AMP] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_LT_LT_DASH] = ACTIONS(1137),
    [anon_sym_BQUOTE] = ACTIONS(1137),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_RPAREN] = ACTIONS(1137),
    [sym_file_descriptor] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_AMP_GT] = ACTIONS(1137),
    [anon_sym_LT_LT_LT] = ACTIONS(1137),
    [anon_sym_GT_AMP] = ACTIONS(1137),
    [anon_sym_esac] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_PIPE_AMP] = ACTIONS(1137),
  },
  [464] = {
    [sym_heredoc_redirect] = STATE(464),
    [aux_sym_redirected_statement_repeat1] = STATE(464),
    [sym_herestring_redirect] = STATE(464),
    [sym_file_redirect] = STATE(464),
    [anon_sym_AMP_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT] = ACTIONS(2108),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_AMP] = ACTIONS(1157),
    [anon_sym_LT] = ACTIONS(2105),
    [anon_sym_LT_AMP] = ACTIONS(2105),
    [anon_sym_GT_GT] = ACTIONS(2105),
    [anon_sym_LT_LT_DASH] = ACTIONS(2108),
    [anon_sym_BQUOTE] = ACTIONS(1157),
    [anon_sym_LF] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_RPAREN] = ACTIONS(1157),
    [sym_file_descriptor] = ACTIONS(2111),
    [anon_sym_GT] = ACTIONS(2105),
    [anon_sym_AMP_GT] = ACTIONS(2105),
    [anon_sym_LT_LT_LT] = ACTIONS(2114),
    [anon_sym_GT_AMP] = ACTIONS(2105),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_SEMI_SEMI] = ACTIONS(1157),
    [anon_sym_PIPE_AMP] = ACTIONS(1157),
  },
  [465] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [sym_word] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_BANG] = ACTIONS(642),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [466] = {
    [sym_heredoc_body] = STATE(491),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_RPAREN] = ACTIONS(1123),
    [anon_sym_GT] = ACTIONS(642),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [467] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(471),
    [sym_concatenation] = STATE(471),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_LT_AMP] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1990),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1165),
    [sym_raw_string] = ACTIONS(1986),
    [anon_sym_RPAREN] = ACTIONS(1165),
    [sym_file_descriptor] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP_GT] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_AMP] = ACTIONS(1165),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(405),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [sym__concat] = ACTIONS(1968),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [469] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [470] = {
    [aux_sym__literal_repeat1] = STATE(412),
    [anon_sym_AMP_GT_GT] = ACTIONS(1173),
    [anon_sym_DOLLAR] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [sym_word] = ACTIONS(1173),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_LT_AMP] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_EQ_TILDE] = ACTIONS(1173),
    [sym__special_character] = ACTIONS(1970),
    [anon_sym_LT_LT_DASH] = ACTIONS(1173),
    [anon_sym_BQUOTE] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1173),
    [sym_raw_string] = ACTIONS(1173),
    [anon_sym_RPAREN] = ACTIONS(1173),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT] = ACTIONS(1173),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_LT_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_AMP] = ACTIONS(1173),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
  },
  [471] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(471),
    [sym_concatenation] = STATE(471),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(2117),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(2120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2123),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2126),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(2129),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(2132),
    [sym__special_character] = ACTIONS(2135),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(2138),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(2129),
    [anon_sym_RPAREN] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(2132),
    [anon_sym_DQUOTE] = ACTIONS(2141),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(2120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [472] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_EQ_TILDE] = ACTIONS(1204),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [473] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [474] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [475] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_LT] = ACTIONS(1281),
    [anon_sym_PIPE_PIPE] = ACTIONS(1281),
    [anon_sym_PIPE] = ACTIONS(1281),
    [anon_sym_AMP] = ACTIONS(1281),
    [anon_sym_LT] = ACTIONS(1281),
    [anon_sym_LT_AMP] = ACTIONS(1281),
    [anon_sym_GT_GT] = ACTIONS(1281),
    [anon_sym_LT_LT_DASH] = ACTIONS(1281),
    [anon_sym_BQUOTE] = ACTIONS(1281),
    [anon_sym_LF] = ACTIONS(1283),
    [anon_sym_SEMI] = ACTIONS(1281),
    [anon_sym_RPAREN] = ACTIONS(1281),
    [sym_file_descriptor] = ACTIONS(1283),
    [anon_sym_GT] = ACTIONS(1281),
    [anon_sym_AMP_GT] = ACTIONS(1281),
    [anon_sym_LT_LT_LT] = ACTIONS(1281),
    [anon_sym_GT_AMP] = ACTIONS(1281),
    [anon_sym_esac] = ACTIONS(1281),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1281),
    [anon_sym_SEMI_SEMI] = ACTIONS(1281),
    [anon_sym_PIPE_AMP] = ACTIONS(1281),
  },
  [476] = {
    [sym_string] = STATE(403),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2144),
    [anon_sym_DASH] = ACTIONS(2144),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2146),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2146),
    [sym_raw_string] = ACTIONS(2148),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2146),
    [anon_sym_POUND] = ACTIONS(2144),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2146),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(2144),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2146),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym__] = ACTIONS(2146),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [477] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1299),
    [anon_sym_LT_LT] = ACTIONS(1299),
    [anon_sym_PIPE_PIPE] = ACTIONS(1299),
    [anon_sym_PIPE] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_LT] = ACTIONS(1299),
    [anon_sym_LT_AMP] = ACTIONS(1299),
    [anon_sym_GT_GT] = ACTIONS(1299),
    [anon_sym_LT_LT_DASH] = ACTIONS(1299),
    [anon_sym_BQUOTE] = ACTIONS(1299),
    [anon_sym_LF] = ACTIONS(1301),
    [anon_sym_SEMI] = ACTIONS(1299),
    [anon_sym_RPAREN] = ACTIONS(1299),
    [sym_file_descriptor] = ACTIONS(1301),
    [anon_sym_GT] = ACTIONS(1299),
    [anon_sym_AMP_GT] = ACTIONS(1299),
    [anon_sym_LT_LT_LT] = ACTIONS(1299),
    [anon_sym_GT_AMP] = ACTIONS(1299),
    [anon_sym_esac] = ACTIONS(1299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1299),
    [anon_sym_SEMI_SEMI] = ACTIONS(1299),
    [anon_sym_PIPE_AMP] = ACTIONS(1299),
  },
  [478] = {
    [anon_sym_BANG_EQ] = ACTIONS(1331),
    [anon_sym_PLUS_EQ] = ACTIONS(1331),
    [sym_test_operator] = ACTIONS(1331),
    [anon_sym_PLUS_PLUS] = ACTIONS(1331),
    [anon_sym_RBRACK] = ACTIONS(1331),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1331),
    [anon_sym_PIPE_PIPE] = ACTIONS(1331),
    [anon_sym_GT_EQ] = ACTIONS(1331),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1333),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1331),
    [anon_sym_DASH_DASH] = ACTIONS(1331),
    [anon_sym_LT_EQ] = ACTIONS(1331),
    [anon_sym_AMP_AMP] = ACTIONS(1331),
    [anon_sym_DASH_EQ] = ACTIONS(1331),
  },
  [479] = {
    [anon_sym_BANG_EQ] = ACTIONS(1335),
    [anon_sym_PLUS_EQ] = ACTIONS(1335),
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_RBRACK] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_GT_EQ] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_DASH_EQ] = ACTIONS(1335),
  },
  [480] = {
    [anon_sym_BANG_EQ] = ACTIONS(1335),
    [anon_sym_PLUS_EQ] = ACTIONS(1335),
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_PLUS_PLUS] = ACTIONS(1335),
    [anon_sym_RBRACK] = ACTIONS(1335),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_GT_EQ] = ACTIONS(1335),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1335),
    [anon_sym_DASH_DASH] = ACTIONS(1335),
    [anon_sym_LT_EQ] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_DASH_EQ] = ACTIONS(1335),
  },
  [481] = {
    [aux_sym_concatenation_repeat1] = STATE(1162),
    [anon_sym_BQUOTE] = ACTIONS(1343),
    [sym_raw_string] = ACTIONS(1343),
    [anon_sym_LF] = ACTIONS(1339),
    [anon_sym_SEMI] = ACTIONS(1343),
    [anon_sym_DOLLAR] = ACTIONS(1343),
    [anon_sym_GT_LPAREN] = ACTIONS(1343),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1343),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1343),
    [anon_sym_DQUOTE] = ACTIONS(1343),
    [sym_word] = ACTIONS(1343),
    [sym__concat] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(1343),
    [anon_sym_LT_LPAREN] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1343),
    [anon_sym_SEMI_SEMI] = ACTIONS(1343),
  },
  [482] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [483] = {
    [aux_sym__literal_repeat1] = STATE(1197),
    [anon_sym_BQUOTE] = ACTIONS(1351),
    [sym_raw_string] = ACTIONS(1351),
    [anon_sym_LF] = ACTIONS(1349),
    [anon_sym_SEMI] = ACTIONS(1351),
    [anon_sym_DOLLAR] = ACTIONS(1351),
    [anon_sym_GT_LPAREN] = ACTIONS(1351),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1351),
    [anon_sym_DQUOTE] = ACTIONS(1351),
    [sym_word] = ACTIONS(1351),
    [anon_sym_AMP] = ACTIONS(1351),
    [anon_sym_LT_LPAREN] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2152),
    [anon_sym_SEMI_SEMI] = ACTIONS(1351),
  },
  [484] = {
    [anon_sym_BQUOTE] = ACTIONS(1357),
    [anon_sym_SLASH] = ACTIONS(1357),
    [sym_raw_string] = ACTIONS(1357),
    [anon_sym_COLON_QMARK] = ACTIONS(2154),
    [anon_sym_DOLLAR] = ACTIONS(2154),
    [anon_sym_RBRACE] = ACTIONS(1357),
    [anon_sym_DASH] = ACTIONS(2154),
    [anon_sym_EQ] = ACTIONS(2154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1357),
    [anon_sym_PERCENT] = ACTIONS(2154),
    [anon_sym_COLON] = ACTIONS(2154),
    [anon_sym_GT_LPAREN] = ACTIONS(1357),
    [anon_sym_DQUOTE] = ACTIONS(1357),
    [sym_word] = ACTIONS(2154),
    [sym__concat] = ACTIONS(2156),
    [anon_sym_LT_LPAREN] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1357),
    [anon_sym_COLON_DASH] = ACTIONS(2154),
    [sym__special_character] = ACTIONS(2154),
  },
  [485] = {
    [anon_sym_BQUOTE] = ACTIONS(1367),
    [anon_sym_SLASH] = ACTIONS(1367),
    [sym_raw_string] = ACTIONS(1367),
    [anon_sym_COLON_QMARK] = ACTIONS(2158),
    [anon_sym_DOLLAR] = ACTIONS(2158),
    [anon_sym_RBRACE] = ACTIONS(1367),
    [anon_sym_DASH] = ACTIONS(2158),
    [anon_sym_EQ] = ACTIONS(2158),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1367),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1367),
    [anon_sym_PERCENT] = ACTIONS(2158),
    [anon_sym_COLON] = ACTIONS(2158),
    [anon_sym_GT_LPAREN] = ACTIONS(1367),
    [anon_sym_DQUOTE] = ACTIONS(1367),
    [sym_word] = ACTIONS(2158),
    [sym__concat] = ACTIONS(2160),
    [anon_sym_LT_LPAREN] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1367),
    [anon_sym_COLON_DASH] = ACTIONS(2158),
    [sym__special_character] = ACTIONS(2158),
  },
  [486] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_EQ_TILDE] = ACTIONS(1377),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [487] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_LT] = ACTIONS(1399),
    [anon_sym_PIPE_PIPE] = ACTIONS(1399),
    [anon_sym_PIPE] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_LT] = ACTIONS(1399),
    [anon_sym_LT_AMP] = ACTIONS(1399),
    [anon_sym_GT_GT] = ACTIONS(1399),
    [anon_sym_LT_LT_DASH] = ACTIONS(1399),
    [anon_sym_BQUOTE] = ACTIONS(1399),
    [anon_sym_LF] = ACTIONS(1401),
    [anon_sym_SEMI] = ACTIONS(1399),
    [anon_sym_RPAREN] = ACTIONS(1399),
    [sym_file_descriptor] = ACTIONS(1401),
    [anon_sym_GT] = ACTIONS(1399),
    [anon_sym_AMP_GT] = ACTIONS(1399),
    [anon_sym_LT_LT_LT] = ACTIONS(1399),
    [anon_sym_GT_AMP] = ACTIONS(1399),
    [anon_sym_esac] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1399),
    [anon_sym_SEMI_SEMI] = ACTIONS(1399),
    [anon_sym_PIPE_AMP] = ACTIONS(1399),
  },
  [488] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT] = ACTIONS(1407),
    [anon_sym_PIPE_PIPE] = ACTIONS(1407),
    [anon_sym_PIPE] = ACTIONS(1407),
    [anon_sym_AMP] = ACTIONS(1407),
    [anon_sym_LT] = ACTIONS(1407),
    [anon_sym_LT_AMP] = ACTIONS(1407),
    [anon_sym_GT_GT] = ACTIONS(1407),
    [anon_sym_LT_LT_DASH] = ACTIONS(1407),
    [anon_sym_BQUOTE] = ACTIONS(1407),
    [anon_sym_LF] = ACTIONS(1409),
    [anon_sym_SEMI] = ACTIONS(1407),
    [anon_sym_RPAREN] = ACTIONS(1407),
    [sym_file_descriptor] = ACTIONS(1409),
    [anon_sym_GT] = ACTIONS(1407),
    [anon_sym_AMP_GT] = ACTIONS(1407),
    [anon_sym_LT_LT_LT] = ACTIONS(1407),
    [anon_sym_GT_AMP] = ACTIONS(1407),
    [anon_sym_esac] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1407),
    [anon_sym_SEMI_SEMI] = ACTIONS(1407),
    [anon_sym_PIPE_AMP] = ACTIONS(1407),
  },
  [489] = {
    [anon_sym_BQUOTE] = ACTIONS(1421),
    [anon_sym_LF] = ACTIONS(1419),
    [anon_sym_SEMI] = ACTIONS(1421),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_esac] = ACTIONS(1421),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1421),
    [anon_sym_SEMI_SEMI] = ACTIONS(1421),
  },
  [490] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1431),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_SEMI_SEMI] = ACTIONS(1431),
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [491] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(2162),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_SEMI_SEMI] = ACTIONS(2166),
    [anon_sym_AMP] = ACTIONS(2166),
  },
  [492] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [493] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [494] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1459),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [495] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_EQ_TILDE] = ACTIONS(1463),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [496] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1469),
    [anon_sym_LT_LT] = ACTIONS(1469),
    [anon_sym_PIPE_PIPE] = ACTIONS(1469),
    [anon_sym_PIPE] = ACTIONS(1469),
    [anon_sym_AMP] = ACTIONS(1469),
    [anon_sym_LT] = ACTIONS(1469),
    [anon_sym_LT_AMP] = ACTIONS(1469),
    [anon_sym_GT_GT] = ACTIONS(1469),
    [anon_sym_LT_LT_DASH] = ACTIONS(1469),
    [anon_sym_BQUOTE] = ACTIONS(1469),
    [anon_sym_LF] = ACTIONS(1471),
    [anon_sym_SEMI] = ACTIONS(1469),
    [anon_sym_RPAREN] = ACTIONS(1469),
    [sym_file_descriptor] = ACTIONS(1471),
    [anon_sym_GT] = ACTIONS(1469),
    [anon_sym_AMP_GT] = ACTIONS(1469),
    [anon_sym_LT_LT_LT] = ACTIONS(1469),
    [anon_sym_GT_AMP] = ACTIONS(1469),
    [anon_sym_esac] = ACTIONS(1469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1469),
    [anon_sym_SEMI_SEMI] = ACTIONS(1469),
    [anon_sym_PIPE_AMP] = ACTIONS(1469),
  },
  [497] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [498] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT] = ACTIONS(1481),
    [anon_sym_PIPE_PIPE] = ACTIONS(1481),
    [anon_sym_PIPE] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_LT] = ACTIONS(1481),
    [anon_sym_LT_AMP] = ACTIONS(1481),
    [anon_sym_GT_GT] = ACTIONS(1481),
    [anon_sym_LT_LT_DASH] = ACTIONS(1481),
    [anon_sym_BQUOTE] = ACTIONS(1481),
    [anon_sym_LF] = ACTIONS(1483),
    [anon_sym_SEMI] = ACTIONS(1481),
    [anon_sym_RPAREN] = ACTIONS(1481),
    [sym_file_descriptor] = ACTIONS(1483),
    [anon_sym_GT] = ACTIONS(1481),
    [anon_sym_AMP_GT] = ACTIONS(1481),
    [anon_sym_LT_LT_LT] = ACTIONS(1481),
    [anon_sym_GT_AMP] = ACTIONS(1481),
    [anon_sym_esac] = ACTIONS(1481),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1481),
    [anon_sym_SEMI_SEMI] = ACTIONS(1481),
    [anon_sym_PIPE_AMP] = ACTIONS(1481),
  },
  [499] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1576),
    [anon_sym_LT_LT] = ACTIONS(1576),
    [anon_sym_PIPE_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_AMP] = ACTIONS(1576),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_LT_AMP] = ACTIONS(1576),
    [anon_sym_GT_GT] = ACTIONS(1576),
    [anon_sym_LT_LT_DASH] = ACTIONS(1576),
    [anon_sym_BQUOTE] = ACTIONS(1576),
    [anon_sym_LF] = ACTIONS(1578),
    [anon_sym_SEMI] = ACTIONS(1576),
    [anon_sym_RPAREN] = ACTIONS(1576),
    [sym_file_descriptor] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_AMP_GT] = ACTIONS(1576),
    [anon_sym_LT_LT_LT] = ACTIONS(1576),
    [anon_sym_GT_AMP] = ACTIONS(1576),
    [anon_sym_esac] = ACTIONS(1576),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1576),
    [anon_sym_SEMI_SEMI] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(1576),
  },
  [500] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1588),
    [anon_sym_LT_LT] = ACTIONS(1588),
    [anon_sym_PIPE_PIPE] = ACTIONS(1588),
    [anon_sym_PIPE] = ACTIONS(1588),
    [anon_sym_AMP] = ACTIONS(1588),
    [anon_sym_LT] = ACTIONS(1588),
    [anon_sym_LT_AMP] = ACTIONS(1588),
    [anon_sym_GT_GT] = ACTIONS(1588),
    [anon_sym_LT_LT_DASH] = ACTIONS(1588),
    [anon_sym_BQUOTE] = ACTIONS(1588),
    [anon_sym_LF] = ACTIONS(1590),
    [anon_sym_SEMI] = ACTIONS(1588),
    [anon_sym_RPAREN] = ACTIONS(1588),
    [sym_file_descriptor] = ACTIONS(1590),
    [anon_sym_GT] = ACTIONS(1588),
    [anon_sym_AMP_GT] = ACTIONS(1588),
    [anon_sym_LT_LT_LT] = ACTIONS(1588),
    [anon_sym_GT_AMP] = ACTIONS(1588),
    [anon_sym_esac] = ACTIONS(1588),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1588),
    [anon_sym_SEMI_SEMI] = ACTIONS(1588),
    [anon_sym_PIPE_AMP] = ACTIONS(1588),
  },
  [501] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [502] = {
    [sym_command_substitution] = STATE(481),
    [aux_sym__literal_repeat1] = STATE(483),
    [sym_string] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(502),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_concatenation] = STATE(502),
    [sym_expansion] = STATE(481),
    [anon_sym_BQUOTE] = ACTIONS(2168),
    [sym_raw_string] = ACTIONS(2171),
    [anon_sym_LF] = ACTIONS(1613),
    [anon_sym_SEMI] = ACTIONS(2174),
    [anon_sym_DOLLAR] = ACTIONS(2176),
    [anon_sym_GT_LPAREN] = ACTIONS(2179),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2182),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2185),
    [anon_sym_DQUOTE] = ACTIONS(2188),
    [sym_word] = ACTIONS(2171),
    [anon_sym_AMP] = ACTIONS(2174),
    [anon_sym_LT_LPAREN] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2191),
    [anon_sym_SEMI_SEMI] = ACTIONS(2174),
  },
  [503] = {
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(1624),
    [sym_raw_string] = ACTIONS(1624),
    [anon_sym_COLON_QMARK] = ACTIONS(2194),
    [anon_sym_DOLLAR] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_GT_LPAREN] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(1624),
    [sym_word] = ACTIONS(2194),
    [anon_sym_LT_LPAREN] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1624),
    [anon_sym_COLON_DASH] = ACTIONS(2194),
    [sym__special_character] = ACTIONS(2194),
  },
  [504] = {
    [anon_sym_BQUOTE] = ACTIONS(1624),
    [anon_sym_SLASH] = ACTIONS(1624),
    [sym_raw_string] = ACTIONS(1624),
    [anon_sym_COLON_QMARK] = ACTIONS(2194),
    [anon_sym_DOLLAR] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(1624),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2194),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1624),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1624),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_GT_LPAREN] = ACTIONS(1624),
    [anon_sym_DQUOTE] = ACTIONS(1624),
    [sym_word] = ACTIONS(2194),
    [sym__concat] = ACTIONS(2196),
    [anon_sym_LT_LPAREN] = ACTIONS(1624),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1624),
    [anon_sym_COLON_DASH] = ACTIONS(2194),
    [sym__special_character] = ACTIONS(2194),
  },
  [505] = {
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1628),
    [sym_raw_string] = ACTIONS(1628),
    [anon_sym_COLON_QMARK] = ACTIONS(2198),
    [anon_sym_DOLLAR] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1628),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_GT_LPAREN] = ACTIONS(1628),
    [anon_sym_DQUOTE] = ACTIONS(1628),
    [sym_word] = ACTIONS(2198),
    [anon_sym_LT_LPAREN] = ACTIONS(1628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_COLON_DASH] = ACTIONS(2198),
    [sym__special_character] = ACTIONS(2198),
  },
  [506] = {
    [anon_sym_BQUOTE] = ACTIONS(1628),
    [anon_sym_SLASH] = ACTIONS(1628),
    [sym_raw_string] = ACTIONS(1628),
    [anon_sym_COLON_QMARK] = ACTIONS(2198),
    [anon_sym_DOLLAR] = ACTIONS(2198),
    [anon_sym_RBRACE] = ACTIONS(1628),
    [anon_sym_DASH] = ACTIONS(2198),
    [anon_sym_EQ] = ACTIONS(2198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1628),
    [anon_sym_PERCENT] = ACTIONS(2198),
    [anon_sym_COLON] = ACTIONS(2198),
    [anon_sym_GT_LPAREN] = ACTIONS(1628),
    [anon_sym_DQUOTE] = ACTIONS(1628),
    [sym_word] = ACTIONS(2198),
    [sym__concat] = ACTIONS(2200),
    [anon_sym_LT_LPAREN] = ACTIONS(1628),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1628),
    [anon_sym_COLON_DASH] = ACTIONS(2198),
    [sym__special_character] = ACTIONS(2198),
  },
  [507] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1638),
    [anon_sym_LT_LT] = ACTIONS(1638),
    [anon_sym_PIPE_PIPE] = ACTIONS(1638),
    [anon_sym_PIPE] = ACTIONS(1638),
    [anon_sym_AMP] = ACTIONS(1638),
    [anon_sym_LT] = ACTIONS(1638),
    [anon_sym_LT_AMP] = ACTIONS(1638),
    [anon_sym_GT_GT] = ACTIONS(1638),
    [anon_sym_LT_LT_DASH] = ACTIONS(1638),
    [anon_sym_BQUOTE] = ACTIONS(1638),
    [anon_sym_LF] = ACTIONS(1640),
    [anon_sym_SEMI] = ACTIONS(1638),
    [anon_sym_RPAREN] = ACTIONS(1638),
    [sym_file_descriptor] = ACTIONS(1640),
    [anon_sym_GT] = ACTIONS(1638),
    [anon_sym_AMP_GT] = ACTIONS(1638),
    [anon_sym_LT_LT_LT] = ACTIONS(1638),
    [anon_sym_GT_AMP] = ACTIONS(1638),
    [anon_sym_esac] = ACTIONS(1638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1638),
    [anon_sym_SEMI_SEMI] = ACTIONS(1638),
    [anon_sym_PIPE_AMP] = ACTIONS(1638),
  },
  [508] = {
    [anon_sym_BQUOTE] = ACTIONS(1644),
    [anon_sym_LF] = ACTIONS(1642),
    [anon_sym_SEMI] = ACTIONS(1644),
    [anon_sym_AMP] = ACTIONS(1644),
    [anon_sym_esac] = ACTIONS(1644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1644),
  },
  [509] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1663),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_SEMI_SEMI] = ACTIONS(1663),
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_BANG] = ACTIONS(1427),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [510] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [511] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [512] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1675),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [513] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [514] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1691),
    [anon_sym_LT_LT] = ACTIONS(1691),
    [anon_sym_PIPE_PIPE] = ACTIONS(1691),
    [anon_sym_PIPE] = ACTIONS(1691),
    [anon_sym_AMP] = ACTIONS(1691),
    [anon_sym_LT] = ACTIONS(1691),
    [anon_sym_LT_AMP] = ACTIONS(1691),
    [anon_sym_GT_GT] = ACTIONS(1691),
    [anon_sym_LT_LT_DASH] = ACTIONS(1691),
    [anon_sym_BQUOTE] = ACTIONS(1691),
    [anon_sym_LF] = ACTIONS(1693),
    [anon_sym_SEMI] = ACTIONS(1691),
    [anon_sym_RPAREN] = ACTIONS(1691),
    [sym_file_descriptor] = ACTIONS(1693),
    [anon_sym_GT] = ACTIONS(1691),
    [anon_sym_AMP_GT] = ACTIONS(1691),
    [anon_sym_LT_LT_LT] = ACTIONS(1691),
    [anon_sym_GT_AMP] = ACTIONS(1691),
    [anon_sym_esac] = ACTIONS(1691),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1691),
    [anon_sym_SEMI_SEMI] = ACTIONS(1691),
    [anon_sym_PIPE_AMP] = ACTIONS(1691),
  },
  [515] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1697),
    [anon_sym_LT_LT] = ACTIONS(1697),
    [anon_sym_PIPE_PIPE] = ACTIONS(1697),
    [anon_sym_PIPE] = ACTIONS(1697),
    [anon_sym_AMP] = ACTIONS(1697),
    [anon_sym_LT] = ACTIONS(1697),
    [anon_sym_LT_AMP] = ACTIONS(1697),
    [anon_sym_GT_GT] = ACTIONS(1697),
    [anon_sym_LT_LT_DASH] = ACTIONS(1697),
    [anon_sym_BQUOTE] = ACTIONS(1697),
    [anon_sym_LF] = ACTIONS(1699),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_RPAREN] = ACTIONS(1697),
    [sym_file_descriptor] = ACTIONS(1699),
    [anon_sym_GT] = ACTIONS(1697),
    [anon_sym_AMP_GT] = ACTIONS(1697),
    [anon_sym_LT_LT_LT] = ACTIONS(1697),
    [anon_sym_GT_AMP] = ACTIONS(1697),
    [anon_sym_esac] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1697),
    [anon_sym_SEMI_SEMI] = ACTIONS(1697),
    [anon_sym_PIPE_AMP] = ACTIONS(1697),
  },
  [516] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1767),
    [anon_sym_LT_LT] = ACTIONS(1767),
    [anon_sym_PIPE_PIPE] = ACTIONS(1767),
    [anon_sym_PIPE] = ACTIONS(1767),
    [anon_sym_AMP] = ACTIONS(1767),
    [anon_sym_LT] = ACTIONS(1767),
    [anon_sym_LT_AMP] = ACTIONS(1767),
    [anon_sym_GT_GT] = ACTIONS(1767),
    [anon_sym_LT_LT_DASH] = ACTIONS(1767),
    [anon_sym_BQUOTE] = ACTIONS(1767),
    [anon_sym_LF] = ACTIONS(1769),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_RPAREN] = ACTIONS(1767),
    [sym_file_descriptor] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1767),
    [anon_sym_AMP_GT] = ACTIONS(1767),
    [anon_sym_LT_LT_LT] = ACTIONS(1767),
    [anon_sym_GT_AMP] = ACTIONS(1767),
    [anon_sym_esac] = ACTIONS(1767),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1767),
    [anon_sym_SEMI_SEMI] = ACTIONS(1767),
    [anon_sym_PIPE_AMP] = ACTIONS(1767),
  },
  [517] = {
    [anon_sym_BQUOTE] = ACTIONS(1773),
    [anon_sym_SLASH] = ACTIONS(1773),
    [sym_raw_string] = ACTIONS(1773),
    [anon_sym_COLON_QMARK] = ACTIONS(2202),
    [anon_sym_DOLLAR] = ACTIONS(2202),
    [anon_sym_RBRACE] = ACTIONS(1773),
    [anon_sym_DASH] = ACTIONS(2202),
    [anon_sym_EQ] = ACTIONS(2202),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1773),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1773),
    [anon_sym_PERCENT] = ACTIONS(2202),
    [anon_sym_COLON] = ACTIONS(2202),
    [anon_sym_GT_LPAREN] = ACTIONS(1773),
    [anon_sym_DQUOTE] = ACTIONS(1773),
    [sym_word] = ACTIONS(2202),
    [anon_sym_LT_LPAREN] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1773),
    [anon_sym_COLON_DASH] = ACTIONS(2202),
    [sym__special_character] = ACTIONS(2202),
  },
  [518] = {
    [anon_sym_BQUOTE] = ACTIONS(1775),
    [anon_sym_SLASH] = ACTIONS(1775),
    [sym_raw_string] = ACTIONS(1775),
    [anon_sym_COLON_QMARK] = ACTIONS(2204),
    [anon_sym_DOLLAR] = ACTIONS(2204),
    [anon_sym_RBRACE] = ACTIONS(1775),
    [anon_sym_DASH] = ACTIONS(2204),
    [anon_sym_EQ] = ACTIONS(2204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1775),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1775),
    [anon_sym_PERCENT] = ACTIONS(2204),
    [anon_sym_COLON] = ACTIONS(2204),
    [anon_sym_GT_LPAREN] = ACTIONS(1775),
    [anon_sym_DQUOTE] = ACTIONS(1775),
    [sym_word] = ACTIONS(2204),
    [anon_sym_LT_LPAREN] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1775),
    [anon_sym_COLON_DASH] = ACTIONS(2204),
    [sym__special_character] = ACTIONS(2204),
  },
  [519] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1777),
    [anon_sym_LT_LT] = ACTIONS(1777),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_PIPE] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_LT_AMP] = ACTIONS(1777),
    [anon_sym_GT_GT] = ACTIONS(1777),
    [anon_sym_LT_LT_DASH] = ACTIONS(1777),
    [anon_sym_BQUOTE] = ACTIONS(1777),
    [anon_sym_LF] = ACTIONS(1779),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_RPAREN] = ACTIONS(1777),
    [sym_file_descriptor] = ACTIONS(1779),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_AMP_GT] = ACTIONS(1777),
    [anon_sym_LT_LT_LT] = ACTIONS(1777),
    [anon_sym_GT_AMP] = ACTIONS(1777),
    [anon_sym_esac] = ACTIONS(1777),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(1777),
  },
  [520] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1781),
    [anon_sym_LT_LT] = ACTIONS(1781),
    [anon_sym_PIPE_PIPE] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1781),
    [anon_sym_AMP] = ACTIONS(1781),
    [anon_sym_LT] = ACTIONS(1781),
    [anon_sym_LT_AMP] = ACTIONS(1781),
    [anon_sym_GT_GT] = ACTIONS(1781),
    [anon_sym_LT_LT_DASH] = ACTIONS(1781),
    [anon_sym_BQUOTE] = ACTIONS(1781),
    [anon_sym_LF] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(1781),
    [anon_sym_RPAREN] = ACTIONS(1781),
    [sym_file_descriptor] = ACTIONS(1783),
    [anon_sym_GT] = ACTIONS(1781),
    [anon_sym_AMP_GT] = ACTIONS(1781),
    [anon_sym_LT_LT_LT] = ACTIONS(1781),
    [anon_sym_GT_AMP] = ACTIONS(1781),
    [anon_sym_esac] = ACTIONS(1781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1781),
    [anon_sym_SEMI_SEMI] = ACTIONS(1781),
    [anon_sym_PIPE_AMP] = ACTIONS(1781),
  },
  [521] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_EQ_TILDE] = ACTIONS(1789),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [522] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_EQ_TILDE] = ACTIONS(1793),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [523] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1803),
    [anon_sym_LT_LT] = ACTIONS(1803),
    [anon_sym_PIPE_PIPE] = ACTIONS(1803),
    [anon_sym_PIPE] = ACTIONS(1803),
    [anon_sym_AMP] = ACTIONS(1803),
    [anon_sym_LT] = ACTIONS(1803),
    [anon_sym_LT_AMP] = ACTIONS(1803),
    [anon_sym_GT_GT] = ACTIONS(1803),
    [anon_sym_LT_LT_DASH] = ACTIONS(1803),
    [anon_sym_BQUOTE] = ACTIONS(1803),
    [anon_sym_LF] = ACTIONS(1805),
    [anon_sym_SEMI] = ACTIONS(1803),
    [anon_sym_RPAREN] = ACTIONS(1803),
    [sym_file_descriptor] = ACTIONS(1805),
    [anon_sym_GT] = ACTIONS(1803),
    [anon_sym_AMP_GT] = ACTIONS(1803),
    [anon_sym_LT_LT_LT] = ACTIONS(1803),
    [anon_sym_GT_AMP] = ACTIONS(1803),
    [anon_sym_esac] = ACTIONS(1803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1803),
    [anon_sym_SEMI_SEMI] = ACTIONS(1803),
    [anon_sym_PIPE_AMP] = ACTIONS(1803),
  },
  [524] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1807),
    [anon_sym_LT_LT] = ACTIONS(1807),
    [anon_sym_PIPE_PIPE] = ACTIONS(1807),
    [anon_sym_PIPE] = ACTIONS(1807),
    [anon_sym_AMP] = ACTIONS(1807),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_LT_AMP] = ACTIONS(1807),
    [anon_sym_GT_GT] = ACTIONS(1807),
    [anon_sym_LT_LT_DASH] = ACTIONS(1807),
    [anon_sym_BQUOTE] = ACTIONS(1807),
    [anon_sym_LF] = ACTIONS(1809),
    [anon_sym_SEMI] = ACTIONS(1807),
    [anon_sym_RPAREN] = ACTIONS(1807),
    [sym_file_descriptor] = ACTIONS(1809),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_AMP_GT] = ACTIONS(1807),
    [anon_sym_LT_LT_LT] = ACTIONS(1807),
    [anon_sym_GT_AMP] = ACTIONS(1807),
    [anon_sym_esac] = ACTIONS(1807),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1807),
    [anon_sym_SEMI_SEMI] = ACTIONS(1807),
    [anon_sym_PIPE_AMP] = ACTIONS(1807),
  },
  [525] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1844),
    [anon_sym_LT_LT] = ACTIONS(1844),
    [anon_sym_PIPE_PIPE] = ACTIONS(1844),
    [anon_sym_PIPE] = ACTIONS(1844),
    [anon_sym_AMP] = ACTIONS(1844),
    [anon_sym_LT] = ACTIONS(1844),
    [anon_sym_LT_AMP] = ACTIONS(1844),
    [anon_sym_GT_GT] = ACTIONS(1844),
    [anon_sym_LT_LT_DASH] = ACTIONS(1844),
    [anon_sym_BQUOTE] = ACTIONS(1844),
    [anon_sym_LF] = ACTIONS(1846),
    [anon_sym_SEMI] = ACTIONS(1844),
    [anon_sym_RPAREN] = ACTIONS(1844),
    [sym_file_descriptor] = ACTIONS(1846),
    [anon_sym_GT] = ACTIONS(1844),
    [anon_sym_AMP_GT] = ACTIONS(1844),
    [anon_sym_LT_LT_LT] = ACTIONS(1844),
    [anon_sym_GT_AMP] = ACTIONS(1844),
    [anon_sym_esac] = ACTIONS(1844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1844),
    [anon_sym_SEMI_SEMI] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(1844),
  },
  [526] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1850),
    [anon_sym_LT_LT] = ACTIONS(1850),
    [anon_sym_PIPE_PIPE] = ACTIONS(1850),
    [anon_sym_PIPE] = ACTIONS(1850),
    [anon_sym_AMP] = ACTIONS(1850),
    [anon_sym_LT] = ACTIONS(1850),
    [anon_sym_LT_AMP] = ACTIONS(1850),
    [anon_sym_GT_GT] = ACTIONS(1850),
    [anon_sym_LT_LT_DASH] = ACTIONS(1850),
    [anon_sym_BQUOTE] = ACTIONS(1850),
    [anon_sym_LF] = ACTIONS(1852),
    [anon_sym_SEMI] = ACTIONS(1850),
    [anon_sym_RPAREN] = ACTIONS(1850),
    [sym_file_descriptor] = ACTIONS(1852),
    [anon_sym_GT] = ACTIONS(1850),
    [anon_sym_AMP_GT] = ACTIONS(1850),
    [anon_sym_LT_LT_LT] = ACTIONS(1850),
    [anon_sym_GT_AMP] = ACTIONS(1850),
    [anon_sym_esac] = ACTIONS(1850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1850),
    [anon_sym_SEMI_SEMI] = ACTIONS(1850),
    [anon_sym_PIPE_AMP] = ACTIONS(1850),
  },
  [527] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1858),
    [anon_sym_LT_LT] = ACTIONS(1858),
    [anon_sym_PIPE_PIPE] = ACTIONS(1858),
    [anon_sym_PIPE] = ACTIONS(1858),
    [anon_sym_AMP] = ACTIONS(1858),
    [anon_sym_LT] = ACTIONS(1858),
    [anon_sym_LT_AMP] = ACTIONS(1858),
    [anon_sym_GT_GT] = ACTIONS(1858),
    [anon_sym_LT_LT_DASH] = ACTIONS(1858),
    [anon_sym_BQUOTE] = ACTIONS(1858),
    [anon_sym_LF] = ACTIONS(1860),
    [anon_sym_SEMI] = ACTIONS(1858),
    [anon_sym_RPAREN] = ACTIONS(1858),
    [sym_file_descriptor] = ACTIONS(1860),
    [anon_sym_GT] = ACTIONS(1858),
    [anon_sym_AMP_GT] = ACTIONS(1858),
    [anon_sym_LT_LT_LT] = ACTIONS(1858),
    [anon_sym_GT_AMP] = ACTIONS(1858),
    [anon_sym_esac] = ACTIONS(1858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1858),
    [anon_sym_SEMI_SEMI] = ACTIONS(1858),
    [anon_sym_PIPE_AMP] = ACTIONS(1858),
  },
  [528] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_LT] = ACTIONS(1890),
    [anon_sym_PIPE_PIPE] = ACTIONS(1890),
    [anon_sym_PIPE] = ACTIONS(1890),
    [anon_sym_AMP] = ACTIONS(1890),
    [anon_sym_LT] = ACTIONS(1890),
    [anon_sym_LT_AMP] = ACTIONS(1890),
    [anon_sym_GT_GT] = ACTIONS(1890),
    [anon_sym_LT_LT_DASH] = ACTIONS(1890),
    [anon_sym_BQUOTE] = ACTIONS(1890),
    [anon_sym_LF] = ACTIONS(1892),
    [anon_sym_SEMI] = ACTIONS(1890),
    [anon_sym_RPAREN] = ACTIONS(1890),
    [sym_file_descriptor] = ACTIONS(1892),
    [anon_sym_GT] = ACTIONS(1890),
    [anon_sym_AMP_GT] = ACTIONS(1890),
    [anon_sym_LT_LT_LT] = ACTIONS(1890),
    [anon_sym_GT_AMP] = ACTIONS(1890),
    [anon_sym_esac] = ACTIONS(1890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1890),
    [anon_sym_SEMI_SEMI] = ACTIONS(1890),
    [anon_sym_PIPE_AMP] = ACTIONS(1890),
  },
  [529] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1894),
    [anon_sym_LT_LT] = ACTIONS(1894),
    [anon_sym_PIPE_PIPE] = ACTIONS(1894),
    [anon_sym_PIPE] = ACTIONS(1894),
    [anon_sym_AMP] = ACTIONS(1894),
    [anon_sym_LT] = ACTIONS(1894),
    [anon_sym_LT_AMP] = ACTIONS(1894),
    [anon_sym_GT_GT] = ACTIONS(1894),
    [anon_sym_LT_LT_DASH] = ACTIONS(1894),
    [anon_sym_BQUOTE] = ACTIONS(1894),
    [anon_sym_LF] = ACTIONS(1896),
    [anon_sym_SEMI] = ACTIONS(1894),
    [anon_sym_RPAREN] = ACTIONS(1894),
    [sym_file_descriptor] = ACTIONS(1896),
    [anon_sym_GT] = ACTIONS(1894),
    [anon_sym_AMP_GT] = ACTIONS(1894),
    [anon_sym_LT_LT_LT] = ACTIONS(1894),
    [anon_sym_GT_AMP] = ACTIONS(1894),
    [anon_sym_esac] = ACTIONS(1894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1894),
    [anon_sym_SEMI_SEMI] = ACTIONS(1894),
    [anon_sym_PIPE_AMP] = ACTIONS(1894),
  },
  [530] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_LT] = ACTIONS(1916),
    [anon_sym_PIPE_PIPE] = ACTIONS(1916),
    [anon_sym_PIPE] = ACTIONS(1916),
    [anon_sym_AMP] = ACTIONS(1916),
    [anon_sym_LT] = ACTIONS(1916),
    [anon_sym_LT_AMP] = ACTIONS(1916),
    [anon_sym_GT_GT] = ACTIONS(1916),
    [anon_sym_LT_LT_DASH] = ACTIONS(1916),
    [anon_sym_BQUOTE] = ACTIONS(1916),
    [anon_sym_LF] = ACTIONS(1918),
    [anon_sym_SEMI] = ACTIONS(1916),
    [anon_sym_RPAREN] = ACTIONS(1916),
    [sym_file_descriptor] = ACTIONS(1918),
    [anon_sym_GT] = ACTIONS(1916),
    [anon_sym_AMP_GT] = ACTIONS(1916),
    [anon_sym_LT_LT_LT] = ACTIONS(1916),
    [anon_sym_GT_AMP] = ACTIONS(1916),
    [anon_sym_esac] = ACTIONS(1916),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1916),
    [anon_sym_SEMI_SEMI] = ACTIONS(1916),
    [anon_sym_PIPE_AMP] = ACTIONS(1916),
  },
  [531] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_LT] = ACTIONS(1924),
    [anon_sym_PIPE_PIPE] = ACTIONS(1924),
    [anon_sym_PIPE] = ACTIONS(1924),
    [anon_sym_AMP] = ACTIONS(1924),
    [anon_sym_LT] = ACTIONS(1924),
    [anon_sym_LT_AMP] = ACTIONS(1924),
    [anon_sym_GT_GT] = ACTIONS(1924),
    [anon_sym_LT_LT_DASH] = ACTIONS(1924),
    [anon_sym_BQUOTE] = ACTIONS(1924),
    [anon_sym_LF] = ACTIONS(1926),
    [anon_sym_SEMI] = ACTIONS(1924),
    [anon_sym_RPAREN] = ACTIONS(1924),
    [sym_file_descriptor] = ACTIONS(1926),
    [anon_sym_GT] = ACTIONS(1924),
    [anon_sym_AMP_GT] = ACTIONS(1924),
    [anon_sym_LT_LT_LT] = ACTIONS(1924),
    [anon_sym_GT_AMP] = ACTIONS(1924),
    [anon_sym_esac] = ACTIONS(1924),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1924),
    [anon_sym_SEMI_SEMI] = ACTIONS(1924),
    [anon_sym_PIPE_AMP] = ACTIONS(1924),
  },
  [532] = {
    [sym_command_substitution] = STATE(396),
    [aux_sym__literal_repeat1] = STATE(397),
    [sym_string] = STATE(396),
    [aux_sym_declaration_command_repeat1] = STATE(550),
    [sym_process_substitution] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_subscript] = STATE(2464),
    [sym_string_expansion] = STATE(396),
    [sym_variable_assignment] = STATE(550),
    [sym_concatenation] = STATE(550),
    [sym_expansion] = STATE(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_GT_LPAREN] = ACTIONS(1930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1932),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [sym_word] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_AMP] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym__special_character] = ACTIONS(1940),
    [anon_sym_LT_LT_DASH] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(123),
    [anon_sym_LF] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(123),
    [sym_raw_string] = ACTIONS(1938),
    [sym_variable_name] = ACTIONS(1944),
    [sym_file_descriptor] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_AMP_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(123),
    [anon_sym_GT_AMP] = ACTIONS(123),
    [anon_sym_LT_LPAREN] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(123),
    [anon_sym_SEMI_SEMI] = ACTIONS(123),
    [anon_sym_PIPE_AMP] = ACTIONS(123),
  },
  [533] = {
    [sym_command_substitution] = STATE(399),
    [aux_sym__literal_repeat1] = STATE(400),
    [sym_string] = STATE(399),
    [aux_sym_unset_command_repeat1] = STATE(553),
    [sym_process_substitution] = STATE(399),
    [sym_simple_expansion] = STATE(399),
    [sym_string_expansion] = STATE(399),
    [sym_concatenation] = STATE(553),
    [sym_expansion] = STATE(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_LT_LT] = ACTIONS(147),
    [anon_sym_GT_LPAREN] = ACTIONS(1950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2208),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [sym_word] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(147),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(147),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(1958),
    [sym_file_descriptor] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(147),
    [anon_sym_GT_AMP] = ACTIONS(147),
    [anon_sym_LT_LPAREN] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_SEMI_SEMI] = ACTIONS(147),
    [anon_sym_PIPE_AMP] = ACTIONS(147),
  },
  [534] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(2210),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_esac] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [535] = {
    [aux_sym_concatenation_repeat1] = STATE(557),
    [anon_sym_AMP_GT_GT] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [sym_word] = ACTIONS(201),
    [sym__concat] = ACTIONS(357),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [sym__special_character] = ACTIONS(201),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [anon_sym_GT_AMP] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
  },
  [536] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [sym__concat] = ACTIONS(2210),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_esac] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [537] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [sym_test_command] = STATE(409),
    [aux_sym_command_repeat1] = STATE(543),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(543),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [sym_command] = STATE(409),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [sym_subshell] = STATE(409),
    [sym_file_redirect] = STATE(543),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [sym_word] = ACTIONS(1721),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [sym__special_character] = ACTIONS(1719),
  },
  [538] = {
    [aux_sym__literal_repeat1] = STATE(1229),
    [anon_sym_AMP_GT_GT] = ACTIONS(299),
    [anon_sym_DOLLAR] = ACTIONS(299),
    [anon_sym_LT_LT] = ACTIONS(299),
    [anon_sym_GT_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(299),
    [anon_sym_PIPE_PIPE] = ACTIONS(299),
    [sym_word] = ACTIONS(299),
    [anon_sym_PIPE] = ACTIONS(299),
    [anon_sym_AMP] = ACTIONS(299),
    [anon_sym_LT] = ACTIONS(299),
    [anon_sym_LT_AMP] = ACTIONS(299),
    [anon_sym_GT_GT] = ACTIONS(299),
    [anon_sym_EQ_TILDE] = ACTIONS(299),
    [sym__special_character] = ACTIONS(2212),
    [anon_sym_LT_LT_DASH] = ACTIONS(299),
    [anon_sym_BQUOTE] = ACTIONS(299),
    [anon_sym_LF] = ACTIONS(303),
    [anon_sym_SEMI] = ACTIONS(299),
    [sym_raw_string] = ACTIONS(299),
    [sym_file_descriptor] = ACTIONS(303),
    [anon_sym_GT] = ACTIONS(299),
    [anon_sym_AMP_GT] = ACTIONS(299),
    [anon_sym_EQ_EQ] = ACTIONS(299),
    [anon_sym_DQUOTE] = ACTIONS(299),
    [anon_sym_LT_LT_LT] = ACTIONS(299),
    [anon_sym_GT_AMP] = ACTIONS(299),
    [anon_sym_LT_LPAREN] = ACTIONS(299),
    [anon_sym_esac] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(299),
    [anon_sym_SEMI_SEMI] = ACTIONS(299),
    [anon_sym_PIPE_AMP] = ACTIONS(299),
  },
  [539] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_AMP_GT_GT] = ACTIONS(2214),
    [anon_sym_LF] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2218),
    [sym_file_descriptor] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_AMP_GT] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [anon_sym_LT_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_AMP] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_esac] = ACTIONS(1976),
    [anon_sym_LT_AMP] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
  },
  [540] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2232),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_SEMI_SEMI] = ACTIONS(2232),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
  },
  [541] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(191),
    [anon_sym_DOLLAR] = ACTIONS(191),
    [anon_sym_LT_LT] = ACTIONS(191),
    [anon_sym_GT_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(191),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(191),
    [anon_sym_PIPE_PIPE] = ACTIONS(191),
    [sym_word] = ACTIONS(191),
    [anon_sym_PIPE] = ACTIONS(191),
    [anon_sym_AMP] = ACTIONS(191),
    [anon_sym_LT] = ACTIONS(191),
    [anon_sym_LT_AMP] = ACTIONS(191),
    [anon_sym_GT_GT] = ACTIONS(191),
    [anon_sym_EQ_TILDE] = ACTIONS(191),
    [sym__special_character] = ACTIONS(191),
    [anon_sym_LT_LT_DASH] = ACTIONS(191),
    [anon_sym_BQUOTE] = ACTIONS(191),
    [anon_sym_LF] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(191),
    [sym_raw_string] = ACTIONS(191),
    [sym_file_descriptor] = ACTIONS(195),
    [anon_sym_GT] = ACTIONS(191),
    [anon_sym_AMP_GT] = ACTIONS(191),
    [anon_sym_EQ_EQ] = ACTIONS(191),
    [anon_sym_DQUOTE] = ACTIONS(191),
    [anon_sym_LT_LT_LT] = ACTIONS(191),
    [anon_sym_GT_AMP] = ACTIONS(191),
    [anon_sym_LT_LPAREN] = ACTIONS(191),
    [anon_sym_esac] = ACTIONS(191),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(191),
    [anon_sym_SEMI_SEMI] = ACTIONS(191),
    [anon_sym_PIPE_AMP] = ACTIONS(191),
  },
  [542] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(567),
    [sym_function_definition] = STATE(567),
    [sym_negated_command] = STATE(567),
    [sym_test_command] = STATE(567),
    [sym_variable_assignment] = STATE(568),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(567),
    [sym_for_statement] = STATE(567),
    [sym_compound_statement] = STATE(567),
    [sym_subshell] = STATE(567),
    [sym_declaration_command] = STATE(567),
    [sym_unset_command] = STATE(567),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym_c_style_for_statement] = STATE(567),
    [sym_while_statement] = STATE(567),
    [sym_case_statement] = STATE(567),
    [sym_pipeline] = STATE(567),
    [sym_list] = STATE(567),
    [sym_command] = STATE(567),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [543] = {
    [sym_command_substitution] = STATE(536),
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_expansion] = STATE(536),
    [sym_string] = STATE(536),
    [sym_command_name] = STATE(651),
    [sym_process_substitution] = STATE(536),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(103),
    [aux_sym_command_repeat1] = STATE(103),
    [sym_concatenation] = STATE(541),
    [sym_file_redirect] = STATE(103),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(1721),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [sym_word] = ACTIONS(1721),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2236),
  },
  [544] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(573),
    [sym_concatenation] = STATE(573),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(333),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_LT_AMP] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(333),
    [anon_sym_BQUOTE] = ACTIONS(333),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(1986),
    [sym_file_descriptor] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(333),
    [anon_sym_GT_AMP] = ACTIONS(333),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_SEMI_SEMI] = ACTIONS(333),
    [anon_sym_PIPE_AMP] = ACTIONS(333),
  },
  [545] = {
    [aux_sym_concatenation_repeat1] = STATE(1066),
    [anon_sym_AMP_GT_GT] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(355),
    [anon_sym_BQUOTE] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(355),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_LT_LT_LT] = ACTIONS(355),
    [anon_sym_GT_AMP] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
  },
  [546] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(361),
    [anon_sym_LT_LT] = ACTIONS(361),
    [anon_sym_PIPE_PIPE] = ACTIONS(361),
    [anon_sym_PIPE] = ACTIONS(361),
    [anon_sym_AMP] = ACTIONS(361),
    [anon_sym_LT] = ACTIONS(361),
    [anon_sym_LT_AMP] = ACTIONS(361),
    [anon_sym_GT_GT] = ACTIONS(361),
    [sym__special_character] = ACTIONS(2103),
    [anon_sym_LT_LT_DASH] = ACTIONS(361),
    [anon_sym_BQUOTE] = ACTIONS(361),
    [anon_sym_LF] = ACTIONS(359),
    [anon_sym_SEMI] = ACTIONS(361),
    [anon_sym_RPAREN] = ACTIONS(361),
    [sym_file_descriptor] = ACTIONS(359),
    [anon_sym_GT] = ACTIONS(361),
    [anon_sym_AMP_GT] = ACTIONS(361),
    [anon_sym_LT_LT_LT] = ACTIONS(361),
    [anon_sym_GT_AMP] = ACTIONS(361),
    [anon_sym_esac] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(361),
    [anon_sym_SEMI_SEMI] = ACTIONS(361),
    [anon_sym_PIPE_AMP] = ACTIONS(361),
  },
  [547] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(355),
    [anon_sym_LT_LT_DASH] = ACTIONS(355),
    [anon_sym_BQUOTE] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_RPAREN] = ACTIONS(355),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_LT_LT_LT] = ACTIONS(355),
    [anon_sym_GT_AMP] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
  },
  [548] = {
    [aux_sym_concatenation_repeat1] = STATE(1226),
    [anon_sym_AMP_GT_GT] = ACTIONS(365),
    [anon_sym_DOLLAR] = ACTIONS(365),
    [anon_sym_LT_LT] = ACTIONS(365),
    [anon_sym_GT_LPAREN] = ACTIONS(365),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(365),
    [aux_sym__simple_variable_name_token1] = ACTIONS(365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(365),
    [anon_sym_PIPE_PIPE] = ACTIONS(365),
    [sym_word] = ACTIONS(365),
    [anon_sym_PIPE] = ACTIONS(365),
    [anon_sym_AMP] = ACTIONS(365),
    [anon_sym_LT] = ACTIONS(365),
    [anon_sym_LT_AMP] = ACTIONS(365),
    [anon_sym_GT_GT] = ACTIONS(365),
    [sym__concat] = ACTIONS(2238),
    [sym__special_character] = ACTIONS(365),
    [anon_sym_LT_LT_DASH] = ACTIONS(365),
    [anon_sym_BQUOTE] = ACTIONS(365),
    [anon_sym_LF] = ACTIONS(369),
    [anon_sym_SEMI] = ACTIONS(365),
    [sym_raw_string] = ACTIONS(365),
    [sym_variable_name] = ACTIONS(369),
    [sym_file_descriptor] = ACTIONS(369),
    [anon_sym_GT] = ACTIONS(365),
    [anon_sym_AMP_GT] = ACTIONS(365),
    [anon_sym_DQUOTE] = ACTIONS(365),
    [anon_sym_LT_LT_LT] = ACTIONS(365),
    [anon_sym_GT_AMP] = ACTIONS(365),
    [anon_sym_LT_LPAREN] = ACTIONS(365),
    [anon_sym_esac] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(365),
    [anon_sym_SEMI_SEMI] = ACTIONS(365),
    [anon_sym_PIPE_AMP] = ACTIONS(365),
  },
  [549] = {
    [aux_sym__literal_repeat1] = STATE(1261),
    [anon_sym_AMP_GT_GT] = ACTIONS(371),
    [anon_sym_DOLLAR] = ACTIONS(371),
    [anon_sym_LT_LT] = ACTIONS(371),
    [anon_sym_GT_LPAREN] = ACTIONS(371),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(371),
    [aux_sym__simple_variable_name_token1] = ACTIONS(371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(371),
    [anon_sym_PIPE_PIPE] = ACTIONS(371),
    [sym_word] = ACTIONS(371),
    [anon_sym_PIPE] = ACTIONS(371),
    [anon_sym_AMP] = ACTIONS(371),
    [anon_sym_LT] = ACTIONS(371),
    [anon_sym_LT_AMP] = ACTIONS(371),
    [anon_sym_GT_GT] = ACTIONS(371),
    [sym__special_character] = ACTIONS(2240),
    [anon_sym_LT_LT_DASH] = ACTIONS(371),
    [anon_sym_BQUOTE] = ACTIONS(371),
    [anon_sym_LF] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(371),
    [sym_raw_string] = ACTIONS(371),
    [sym_variable_name] = ACTIONS(375),
    [sym_file_descriptor] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(371),
    [anon_sym_AMP_GT] = ACTIONS(371),
    [anon_sym_DQUOTE] = ACTIONS(371),
    [anon_sym_LT_LT_LT] = ACTIONS(371),
    [anon_sym_GT_AMP] = ACTIONS(371),
    [anon_sym_LT_LPAREN] = ACTIONS(371),
    [anon_sym_esac] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(371),
    [anon_sym_SEMI_SEMI] = ACTIONS(371),
    [anon_sym_PIPE_AMP] = ACTIONS(371),
  },
  [550] = {
    [sym_command_substitution] = STATE(396),
    [aux_sym__literal_repeat1] = STATE(397),
    [sym_string] = STATE(396),
    [aux_sym_declaration_command_repeat1] = STATE(427),
    [sym_process_substitution] = STATE(396),
    [sym_simple_expansion] = STATE(396),
    [sym_subscript] = STATE(2464),
    [sym_string_expansion] = STATE(396),
    [sym_variable_assignment] = STATE(427),
    [sym_concatenation] = STATE(427),
    [sym_expansion] = STATE(396),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_LPAREN] = ACTIONS(1930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1932),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1998),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [sym_word] = ACTIONS(1938),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [sym__special_character] = ACTIONS(1940),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(377),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(1938),
    [sym_variable_name] = ACTIONS(1944),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_LT_LT_LT] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LPAREN] = ACTIONS(1930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
  },
  [551] = {
    [aux_sym_concatenation_repeat1] = STATE(1258),
    [anon_sym_AMP_GT_GT] = ACTIONS(383),
    [anon_sym_DOLLAR] = ACTIONS(383),
    [anon_sym_LT_LT] = ACTIONS(383),
    [anon_sym_GT_LPAREN] = ACTIONS(383),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(383),
    [aux_sym__simple_variable_name_token1] = ACTIONS(383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(383),
    [anon_sym_PIPE_PIPE] = ACTIONS(383),
    [sym_word] = ACTIONS(383),
    [anon_sym_PIPE] = ACTIONS(383),
    [anon_sym_AMP] = ACTIONS(383),
    [anon_sym_LT] = ACTIONS(383),
    [anon_sym_LT_AMP] = ACTIONS(383),
    [anon_sym_GT_GT] = ACTIONS(383),
    [sym__concat] = ACTIONS(2242),
    [sym__special_character] = ACTIONS(383),
    [anon_sym_LT_LT_DASH] = ACTIONS(383),
    [anon_sym_BQUOTE] = ACTIONS(383),
    [anon_sym_LF] = ACTIONS(387),
    [anon_sym_SEMI] = ACTIONS(383),
    [sym_raw_string] = ACTIONS(383),
    [sym_file_descriptor] = ACTIONS(387),
    [anon_sym_GT] = ACTIONS(383),
    [anon_sym_AMP_GT] = ACTIONS(383),
    [anon_sym_DQUOTE] = ACTIONS(383),
    [anon_sym_LT_LT_LT] = ACTIONS(383),
    [anon_sym_GT_AMP] = ACTIONS(383),
    [anon_sym_LT_LPAREN] = ACTIONS(383),
    [anon_sym_esac] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(383),
    [anon_sym_SEMI_SEMI] = ACTIONS(383),
    [anon_sym_PIPE_AMP] = ACTIONS(383),
  },
  [552] = {
    [aux_sym__literal_repeat1] = STATE(1293),
    [anon_sym_AMP_GT_GT] = ACTIONS(389),
    [anon_sym_DOLLAR] = ACTIONS(389),
    [anon_sym_LT_LT] = ACTIONS(389),
    [anon_sym_GT_LPAREN] = ACTIONS(389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(389),
    [aux_sym__simple_variable_name_token1] = ACTIONS(389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(389),
    [anon_sym_PIPE_PIPE] = ACTIONS(389),
    [sym_word] = ACTIONS(389),
    [anon_sym_PIPE] = ACTIONS(389),
    [anon_sym_AMP] = ACTIONS(389),
    [anon_sym_LT] = ACTIONS(389),
    [anon_sym_LT_AMP] = ACTIONS(389),
    [anon_sym_GT_GT] = ACTIONS(389),
    [sym__special_character] = ACTIONS(2244),
    [anon_sym_LT_LT_DASH] = ACTIONS(389),
    [anon_sym_BQUOTE] = ACTIONS(389),
    [anon_sym_LF] = ACTIONS(393),
    [anon_sym_SEMI] = ACTIONS(389),
    [sym_raw_string] = ACTIONS(389),
    [sym_file_descriptor] = ACTIONS(393),
    [anon_sym_GT] = ACTIONS(389),
    [anon_sym_AMP_GT] = ACTIONS(389),
    [anon_sym_DQUOTE] = ACTIONS(389),
    [anon_sym_LT_LT_LT] = ACTIONS(389),
    [anon_sym_GT_AMP] = ACTIONS(389),
    [anon_sym_LT_LPAREN] = ACTIONS(389),
    [anon_sym_esac] = ACTIONS(389),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(389),
    [anon_sym_SEMI_SEMI] = ACTIONS(389),
    [anon_sym_PIPE_AMP] = ACTIONS(389),
  },
  [553] = {
    [sym_command_substitution] = STATE(399),
    [aux_sym__literal_repeat1] = STATE(400),
    [sym_string] = STATE(399),
    [aux_sym_unset_command_repeat1] = STATE(428),
    [sym_process_substitution] = STATE(399),
    [sym_simple_expansion] = STATE(399),
    [sym_string_expansion] = STATE(399),
    [sym_concatenation] = STATE(428),
    [sym_expansion] = STATE(399),
    [anon_sym_AMP_GT_GT] = ACTIONS(395),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_LT_LT] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(1950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1952),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1956),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [sym_word] = ACTIONS(1958),
    [anon_sym_PIPE] = ACTIONS(395),
    [anon_sym_AMP] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_LT_AMP] = ACTIONS(395),
    [anon_sym_GT_GT] = ACTIONS(395),
    [sym__special_character] = ACTIONS(1960),
    [anon_sym_LT_LT_DASH] = ACTIONS(395),
    [anon_sym_BQUOTE] = ACTIONS(395),
    [anon_sym_LF] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(1958),
    [sym_file_descriptor] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(395),
    [anon_sym_AMP_GT] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_LT_LT_LT] = ACTIONS(395),
    [anon_sym_GT_AMP] = ACTIONS(395),
    [anon_sym_LT_LPAREN] = ACTIONS(1950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_SEMI_SEMI] = ACTIONS(395),
    [anon_sym_PIPE_AMP] = ACTIONS(395),
  },
  [554] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(403),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(403),
    [sym_word] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(403),
    [anon_sym_GT_GT] = ACTIONS(403),
    [sym__special_character] = ACTIONS(403),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_raw_string] = ACTIONS(403),
    [sym_variable_name] = ACTIONS(403),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [anon_sym_GT_AMP] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(51),
  },
  [555] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(407),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(407),
    [sym_word] = ACTIONS(407),
    [sym__concat] = ACTIONS(407),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(407),
    [anon_sym_GT_GT] = ACTIONS(407),
    [sym__special_character] = ACTIONS(407),
    [anon_sym_BQUOTE] = ACTIONS(407),
    [sym_raw_string] = ACTIONS(407),
    [sym_variable_name] = ACTIONS(407),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [anon_sym_GT_AMP] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(407),
    [sym_comment] = ACTIONS(51),
  },
  [556] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(411),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
    [sym_word] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(411),
    [anon_sym_GT_GT] = ACTIONS(411),
    [sym__special_character] = ACTIONS(411),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_raw_string] = ACTIONS(411),
    [sym_variable_name] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_RPAREN] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [anon_sym_GT_AMP] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(411),
    [sym_comment] = ACTIONS(51),
  },
  [557] = {
    [aux_sym_concatenation_repeat1] = STATE(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(473),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(473),
    [sym_word] = ACTIONS(473),
    [sym__concat] = ACTIONS(2246),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(473),
    [anon_sym_GT_GT] = ACTIONS(473),
    [sym__special_character] = ACTIONS(473),
    [anon_sym_BQUOTE] = ACTIONS(473),
    [sym_raw_string] = ACTIONS(473),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [anon_sym_GT_AMP] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(473),
    [sym_comment] = ACTIONS(51),
  },
  [558] = {
    [aux_sym_concatenation_repeat1] = STATE(970),
    [anon_sym_BANG_EQ] = ACTIONS(521),
    [anon_sym_PLUS_EQ] = ACTIONS(521),
    [sym_test_operator] = ACTIONS(519),
    [anon_sym_LF] = ACTIONS(521),
    [anon_sym_SEMI] = ACTIONS(521),
    [anon_sym_PLUS_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_GT] = ACTIONS(521),
    [anon_sym_EQ] = ACTIONS(521),
    [anon_sym_EQ_EQ] = ACTIONS(521),
    [anon_sym_PIPE_PIPE] = ACTIONS(521),
    [anon_sym_GT_EQ] = ACTIONS(521),
    [sym__concat] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_LT] = ACTIONS(521),
    [anon_sym_AMP] = ACTIONS(521),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(521),
    [anon_sym_DASH_DASH] = ACTIONS(521),
    [anon_sym_AMP_AMP] = ACTIONS(521),
    [anon_sym_LT_EQ] = ACTIONS(521),
    [anon_sym_SEMI_SEMI] = ACTIONS(521),
    [anon_sym_DASH_EQ] = ACTIONS(521),
  },
  [559] = {
    [aux_sym__literal_repeat1] = STATE(1005),
    [anon_sym_BANG_EQ] = ACTIONS(527),
    [anon_sym_PLUS_EQ] = ACTIONS(527),
    [sym_test_operator] = ACTIONS(525),
    [sym__special_character] = ACTIONS(2250),
    [anon_sym_LF] = ACTIONS(527),
    [anon_sym_SEMI] = ACTIONS(527),
    [anon_sym_PLUS_PLUS] = ACTIONS(527),
    [anon_sym_DASH] = ACTIONS(527),
    [anon_sym_GT] = ACTIONS(527),
    [anon_sym_EQ] = ACTIONS(527),
    [anon_sym_EQ_EQ] = ACTIONS(527),
    [anon_sym_PIPE_PIPE] = ACTIONS(527),
    [anon_sym_GT_EQ] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(527),
    [anon_sym_LT] = ACTIONS(527),
    [anon_sym_AMP] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(527),
    [anon_sym_DASH_DASH] = ACTIONS(527),
    [anon_sym_AMP_AMP] = ACTIONS(527),
    [anon_sym_LT_EQ] = ACTIONS(527),
    [anon_sym_SEMI_SEMI] = ACTIONS(527),
    [anon_sym_DASH_EQ] = ACTIONS(527),
  },
  [560] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [sym__concat] = ACTIONS(585),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(585),
    [anon_sym_GT_GT] = ACTIONS(585),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [anon_sym_GT_AMP] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
  },
  [561] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [sym_word] = ACTIONS(201),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(201),
    [anon_sym_GT_GT] = ACTIONS(201),
    [sym__special_character] = ACTIONS(201),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [anon_sym_GT_AMP] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
  },
  [562] = {
    [aux_sym__literal_repeat1] = STATE(562),
    [anon_sym_AMP_GT_GT] = ACTIONS(640),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(640),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(640),
    [sym_word] = ACTIONS(640),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(640),
    [anon_sym_GT_GT] = ACTIONS(640),
    [sym__special_character] = ACTIONS(2252),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [sym_raw_string] = ACTIONS(640),
    [sym_variable_name] = ACTIONS(640),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [anon_sym_GT_AMP] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(640),
    [sym_comment] = ACTIONS(51),
  },
  [563] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(454),
    [sym_function_definition] = STATE(454),
    [sym_negated_command] = STATE(454),
    [sym_test_command] = STATE(454),
    [sym_variable_assignment] = STATE(595),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(454),
    [sym_for_statement] = STATE(454),
    [sym_compound_statement] = STATE(454),
    [sym_subshell] = STATE(454),
    [sym_declaration_command] = STATE(454),
    [sym_unset_command] = STATE(454),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym_c_style_for_statement] = STATE(454),
    [sym_while_statement] = STATE(454),
    [sym_case_statement] = STATE(454),
    [sym_pipeline] = STATE(454),
    [sym_list] = STATE(454),
    [sym_command] = STATE(454),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [564] = {
    [sym_heredoc_body] = STATE(1465),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(642),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [565] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_BQUOTE] = ACTIONS(650),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [anon_sym_case] = ACTIONS(642),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [566] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(597),
    [sym_function_definition] = STATE(597),
    [sym_negated_command] = STATE(597),
    [sym_test_command] = STATE(597),
    [sym_variable_assignment] = STATE(598),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(597),
    [sym_for_statement] = STATE(597),
    [sym_compound_statement] = STATE(597),
    [sym_subshell] = STATE(597),
    [sym_declaration_command] = STATE(597),
    [sym_unset_command] = STATE(597),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym_c_style_for_statement] = STATE(597),
    [sym_while_statement] = STATE(597),
    [sym_case_statement] = STATE(597),
    [sym_pipeline] = STATE(597),
    [sym_list] = STATE(597),
    [sym_command] = STATE(597),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [567] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
    [anon_sym_BQUOTE] = ACTIONS(2019),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2257),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(2257),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_SEMI_SEMI] = ACTIONS(2257),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [568] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(2257),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(2019),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2255),
    [anon_sym_SEMI] = ACTIONS(2257),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_SEMI_SEMI] = ACTIONS(2257),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
  },
  [569] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(601),
    [sym_concatenation] = STATE(601),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(756),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(1986),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [570] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(776),
    [anon_sym_DOLLAR] = ACTIONS(776),
    [anon_sym_LT_LT] = ACTIONS(776),
    [anon_sym_GT_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(776),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(776),
    [anon_sym_PIPE_PIPE] = ACTIONS(776),
    [sym_word] = ACTIONS(776),
    [anon_sym_PIPE] = ACTIONS(776),
    [anon_sym_AMP] = ACTIONS(776),
    [anon_sym_LT] = ACTIONS(776),
    [anon_sym_LT_AMP] = ACTIONS(776),
    [anon_sym_GT_GT] = ACTIONS(776),
    [sym__concat] = ACTIONS(2210),
    [anon_sym_EQ_TILDE] = ACTIONS(776),
    [sym__special_character] = ACTIONS(776),
    [anon_sym_LT_LT_DASH] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(776),
    [anon_sym_LF] = ACTIONS(778),
    [anon_sym_SEMI] = ACTIONS(776),
    [sym_raw_string] = ACTIONS(776),
    [sym_file_descriptor] = ACTIONS(778),
    [anon_sym_GT] = ACTIONS(776),
    [anon_sym_AMP_GT] = ACTIONS(776),
    [anon_sym_EQ_EQ] = ACTIONS(776),
    [anon_sym_DQUOTE] = ACTIONS(776),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_GT_AMP] = ACTIONS(776),
    [anon_sym_LT_LPAREN] = ACTIONS(776),
    [anon_sym_esac] = ACTIONS(776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(776),
    [anon_sym_SEMI_SEMI] = ACTIONS(776),
    [anon_sym_PIPE_AMP] = ACTIONS(776),
  },
  [571] = {
    [sym_command_substitution] = STATE(602),
    [aux_sym__literal_repeat1] = STATE(604),
    [sym_string] = STATE(602),
    [sym_process_substitution] = STATE(602),
    [sym_simple_expansion] = STATE(602),
    [sym_string_expansion] = STATE(602),
    [sym_concatenation] = STATE(603),
    [sym_expansion] = STATE(602),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [sym_word] = ACTIONS(2259),
    [sym_raw_string] = ACTIONS(2259),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [sym__special_character] = ACTIONS(2236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [sym_regex] = ACTIONS(2261),
  },
  [572] = {
    [aux_sym__literal_repeat1] = STATE(1229),
    [anon_sym_AMP_GT_GT] = ACTIONS(784),
    [anon_sym_DOLLAR] = ACTIONS(784),
    [anon_sym_LT_LT] = ACTIONS(784),
    [anon_sym_GT_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(784),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(784),
    [anon_sym_PIPE_PIPE] = ACTIONS(784),
    [sym_word] = ACTIONS(784),
    [anon_sym_PIPE] = ACTIONS(784),
    [anon_sym_AMP] = ACTIONS(784),
    [anon_sym_LT] = ACTIONS(784),
    [anon_sym_LT_AMP] = ACTIONS(784),
    [anon_sym_GT_GT] = ACTIONS(784),
    [anon_sym_EQ_TILDE] = ACTIONS(784),
    [sym__special_character] = ACTIONS(2212),
    [anon_sym_LT_LT_DASH] = ACTIONS(784),
    [anon_sym_BQUOTE] = ACTIONS(784),
    [anon_sym_LF] = ACTIONS(786),
    [anon_sym_SEMI] = ACTIONS(784),
    [sym_raw_string] = ACTIONS(784),
    [sym_file_descriptor] = ACTIONS(786),
    [anon_sym_GT] = ACTIONS(784),
    [anon_sym_AMP_GT] = ACTIONS(784),
    [anon_sym_EQ_EQ] = ACTIONS(784),
    [anon_sym_DQUOTE] = ACTIONS(784),
    [anon_sym_LT_LT_LT] = ACTIONS(784),
    [anon_sym_GT_AMP] = ACTIONS(784),
    [anon_sym_LT_LPAREN] = ACTIONS(784),
    [anon_sym_esac] = ACTIONS(784),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(784),
    [anon_sym_SEMI_SEMI] = ACTIONS(784),
    [anon_sym_PIPE_AMP] = ACTIONS(784),
  },
  [573] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(471),
    [sym_concatenation] = STATE(471),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(756),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(1986),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [574] = {
    [sym_command_substitution] = STATE(548),
    [aux_sym__literal_repeat1] = STATE(549),
    [sym_string] = STATE(548),
    [aux_sym_declaration_command_repeat1] = STATE(574),
    [sym_process_substitution] = STATE(548),
    [sym_simple_expansion] = STATE(548),
    [sym_subscript] = STATE(2482),
    [sym_string_expansion] = STATE(548),
    [sym_variable_assignment] = STATE(574),
    [sym_concatenation] = STATE(574),
    [sym_expansion] = STATE(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(792),
    [anon_sym_DOLLAR] = ACTIONS(2263),
    [anon_sym_LT_LT] = ACTIONS(792),
    [anon_sym_GT_LPAREN] = ACTIONS(2266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2269),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2275),
    [anon_sym_PIPE_PIPE] = ACTIONS(792),
    [sym_word] = ACTIONS(2278),
    [anon_sym_PIPE] = ACTIONS(792),
    [anon_sym_AMP] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_LT_AMP] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(792),
    [sym__special_character] = ACTIONS(2281),
    [anon_sym_LT_LT_DASH] = ACTIONS(792),
    [anon_sym_BQUOTE] = ACTIONS(2284),
    [anon_sym_LF] = ACTIONS(818),
    [anon_sym_SEMI] = ACTIONS(792),
    [sym_raw_string] = ACTIONS(2278),
    [sym_variable_name] = ACTIONS(2287),
    [sym_file_descriptor] = ACTIONS(818),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LT_LT] = ACTIONS(792),
    [anon_sym_GT_AMP] = ACTIONS(792),
    [anon_sym_LT_LPAREN] = ACTIONS(2266),
    [anon_sym_esac] = ACTIONS(792),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(792),
    [anon_sym_SEMI_SEMI] = ACTIONS(792),
    [anon_sym_PIPE_AMP] = ACTIONS(792),
  },
  [575] = {
    [sym_command_substitution] = STATE(551),
    [aux_sym__literal_repeat1] = STATE(552),
    [sym_string] = STATE(551),
    [aux_sym_unset_command_repeat1] = STATE(575),
    [sym_process_substitution] = STATE(551),
    [sym_simple_expansion] = STATE(551),
    [sym_string_expansion] = STATE(551),
    [sym_concatenation] = STATE(575),
    [sym_expansion] = STATE(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(826),
    [anon_sym_DOLLAR] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(826),
    [anon_sym_GT_LPAREN] = ACTIONS(2296),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2299),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2305),
    [anon_sym_PIPE_PIPE] = ACTIONS(826),
    [sym_word] = ACTIONS(2308),
    [anon_sym_PIPE] = ACTIONS(826),
    [anon_sym_AMP] = ACTIONS(826),
    [anon_sym_LT] = ACTIONS(826),
    [anon_sym_LT_AMP] = ACTIONS(826),
    [anon_sym_GT_GT] = ACTIONS(826),
    [sym__special_character] = ACTIONS(2311),
    [anon_sym_LT_LT_DASH] = ACTIONS(826),
    [anon_sym_BQUOTE] = ACTIONS(2314),
    [anon_sym_LF] = ACTIONS(852),
    [anon_sym_SEMI] = ACTIONS(826),
    [sym_raw_string] = ACTIONS(2308),
    [sym_file_descriptor] = ACTIONS(852),
    [anon_sym_GT] = ACTIONS(826),
    [anon_sym_AMP_GT] = ACTIONS(826),
    [anon_sym_DQUOTE] = ACTIONS(2317),
    [anon_sym_LT_LT_LT] = ACTIONS(826),
    [anon_sym_GT_AMP] = ACTIONS(826),
    [anon_sym_LT_LPAREN] = ACTIONS(2296),
    [anon_sym_esac] = ACTIONS(826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(826),
    [anon_sym_SEMI_SEMI] = ACTIONS(826),
    [anon_sym_PIPE_AMP] = ACTIONS(826),
  },
  [576] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(859),
    [sym_word] = ACTIONS(859),
    [sym__concat] = ACTIONS(859),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(859),
    [sym__special_character] = ACTIONS(859),
    [anon_sym_BQUOTE] = ACTIONS(859),
    [sym_raw_string] = ACTIONS(859),
    [sym_variable_name] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [anon_sym_GT_AMP] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(859),
    [sym_comment] = ACTIONS(51),
  },
  [577] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [sym_word] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [sym__special_character] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [anon_sym_GT_AMP] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
  },
  [578] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(881),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(881),
    [sym_word] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(881),
    [anon_sym_GT_GT] = ACTIONS(881),
    [sym__special_character] = ACTIONS(881),
    [anon_sym_BQUOTE] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(881),
    [sym_variable_name] = ACTIONS(881),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [anon_sym_GT_AMP] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(881),
    [sym_comment] = ACTIONS(51),
  },
  [579] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(931),
    [anon_sym_GT_GT] = ACTIONS(931),
    [sym__special_character] = ACTIONS(931),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [sym_variable_name] = ACTIONS(931),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [anon_sym_GT_AMP] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(51),
  },
  [580] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [sym__special_character] = ACTIONS(941),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_GT_AMP] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
  },
  [581] = {
    [sym_command_substitution] = STATE(580),
    [sym_string] = STATE(580),
    [sym_process_substitution] = STATE(580),
    [sym_simple_expansion] = STATE(580),
    [sym_string_expansion] = STATE(580),
    [sym_expansion] = STATE(580),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [sym_raw_string] = ACTIONS(2320),
    [anon_sym_DOLLAR] = ACTIONS(2322),
    [anon_sym_GT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_word] = ACTIONS(2320),
    [anon_sym_LT_LPAREN] = ACTIONS(113),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2320),
  },
  [582] = {
    [aux_sym_concatenation_repeat1] = STATE(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [sym__concat] = ACTIONS(2324),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [sym__special_character] = ACTIONS(941),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [anon_sym_GT_AMP] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
  },
  [583] = {
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_LF] = ACTIONS(978),
    [anon_sym_SEMI] = ACTIONS(978),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(978),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
  },
  [584] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(611),
    [sym_postfix_expression] = STATE(611),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(611),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(611),
    [sym_binary_expression] = STATE(611),
    [sym_concatenation] = STATE(611),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [sym_word] = ACTIONS(607),
    [sym_raw_string] = ACTIONS(2331),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_LT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [sym__special_character] = ACTIONS(2339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2341),
  },
  [585] = {
    [anon_sym_BANG_EQ] = ACTIONS(984),
    [anon_sym_PLUS_EQ] = ACTIONS(984),
    [sym_test_operator] = ACTIONS(982),
    [anon_sym_LF] = ACTIONS(984),
    [anon_sym_SEMI] = ACTIONS(984),
    [anon_sym_PLUS_PLUS] = ACTIONS(984),
    [anon_sym_DASH] = ACTIONS(984),
    [anon_sym_GT] = ACTIONS(984),
    [anon_sym_EQ] = ACTIONS(984),
    [anon_sym_EQ_EQ] = ACTIONS(984),
    [anon_sym_PIPE_PIPE] = ACTIONS(984),
    [anon_sym_GT_EQ] = ACTIONS(984),
    [anon_sym_PLUS] = ACTIONS(984),
    [anon_sym_LT] = ACTIONS(984),
    [anon_sym_AMP] = ACTIONS(984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(984),
    [anon_sym_DASH_DASH] = ACTIONS(984),
    [anon_sym_AMP_AMP] = ACTIONS(984),
    [anon_sym_LT_EQ] = ACTIONS(984),
    [anon_sym_SEMI_SEMI] = ACTIONS(984),
    [anon_sym_DASH_EQ] = ACTIONS(984),
  },
  [586] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(611),
    [sym_postfix_expression] = STATE(611),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(611),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(611),
    [sym_binary_expression] = STATE(611),
    [sym_concatenation] = STATE(611),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [sym_raw_string] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2341),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [sym_word] = ACTIONS(607),
    [anon_sym_LT_LPAREN] = ACTIONS(2335),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2339),
    [sym_regex] = ACTIONS(2343),
  },
  [587] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [sym_word] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(863),
    [anon_sym_GT_GT] = ACTIONS(863),
    [sym__special_character] = ACTIONS(863),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [anon_sym_GT_AMP] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
  },
  [588] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(367),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [ts_builtin_sym_end] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [589] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [ts_builtin_sym_end] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [590] = {
    [aux_sym__literal_repeat1] = STATE(644),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(373),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [ts_builtin_sym_end] = ACTIONS(1020),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [591] = {
    [aux_sym_concatenation_repeat1] = STATE(1066),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LF] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1036),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_SEMI_SEMI] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
  },
  [592] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(1040),
    [anon_sym_LT_LT] = ACTIONS(1040),
    [anon_sym_PIPE_PIPE] = ACTIONS(1040),
    [anon_sym_PIPE] = ACTIONS(1040),
    [anon_sym_AMP] = ACTIONS(1040),
    [anon_sym_LT] = ACTIONS(1040),
    [anon_sym_LT_AMP] = ACTIONS(1040),
    [anon_sym_GT_GT] = ACTIONS(1040),
    [sym__special_character] = ACTIONS(2103),
    [anon_sym_LT_LT_DASH] = ACTIONS(1040),
    [anon_sym_BQUOTE] = ACTIONS(1040),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_SEMI] = ACTIONS(1040),
    [anon_sym_RPAREN] = ACTIONS(1040),
    [sym_file_descriptor] = ACTIONS(1038),
    [anon_sym_GT] = ACTIONS(1040),
    [anon_sym_AMP_GT] = ACTIONS(1040),
    [anon_sym_LT_LT_LT] = ACTIONS(1040),
    [anon_sym_GT_AMP] = ACTIONS(1040),
    [anon_sym_esac] = ACTIONS(1040),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1040),
    [anon_sym_SEMI_SEMI] = ACTIONS(1040),
    [anon_sym_PIPE_AMP] = ACTIONS(1040),
  },
  [593] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_BQUOTE] = ACTIONS(1036),
    [anon_sym_LF] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1036),
    [anon_sym_RPAREN] = ACTIONS(1036),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_esac] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [anon_sym_SEMI_SEMI] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
  },
  [594] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1044),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1044),
    [sym_word] = ACTIONS(1044),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1044),
    [anon_sym_GT_GT] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1044),
    [anon_sym_BQUOTE] = ACTIONS(1044),
    [sym_raw_string] = ACTIONS(1044),
    [sym_variable_name] = ACTIONS(1044),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [anon_sym_GT_AMP] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1044),
    [sym_comment] = ACTIONS(51),
  },
  [595] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(1103),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [596] = {
    [anon_sym_AMP] = ACTIONS(2345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2347),
    [anon_sym_SEMI] = ACTIONS(2345),
    [anon_sym_SEMI_SEMI] = ACTIONS(2095),
    [anon_sym_esac] = ACTIONS(2095),
  },
  [597] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [sym_file_descriptor] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
  },
  [598] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2230),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
  },
  [599] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [600] = {
    [sym_heredoc_body] = STATE(1467),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(1123),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
  },
  [601] = {
    [sym_command_substitution] = STATE(422),
    [aux_sym__literal_repeat1] = STATE(424),
    [sym_string] = STATE(422),
    [sym_process_substitution] = STATE(422),
    [sym_simple_expansion] = STATE(422),
    [sym_string_expansion] = STATE(422),
    [aux_sym_command_repeat2] = STATE(471),
    [sym_concatenation] = STATE(471),
    [sym_expansion] = STATE(422),
    [anon_sym_AMP_GT_GT] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_LPAREN] = ACTIONS(1980),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1982),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1984),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [sym_word] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_LT_AMP] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_EQ_TILDE] = ACTIONS(1988),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_LT_LT_DASH] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(1165),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1165),
    [sym_raw_string] = ACTIONS(1986),
    [sym_file_descriptor] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP_GT] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_DQUOTE] = ACTIONS(1992),
    [anon_sym_LT_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_AMP] = ACTIONS(1165),
    [anon_sym_LT_LPAREN] = ACTIONS(1980),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
  },
  [602] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [sym__concat] = ACTIONS(2210),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [anon_sym_esac] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [603] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(1169),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1169),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1169),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(1169),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(1169),
    [sym__special_character] = ACTIONS(1169),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(1169),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(1169),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(1169),
    [anon_sym_DQUOTE] = ACTIONS(1169),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(1169),
    [anon_sym_esac] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [604] = {
    [aux_sym__literal_repeat1] = STATE(1229),
    [anon_sym_AMP_GT_GT] = ACTIONS(1173),
    [anon_sym_DOLLAR] = ACTIONS(1173),
    [anon_sym_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1173),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1173),
    [anon_sym_PIPE_PIPE] = ACTIONS(1173),
    [sym_word] = ACTIONS(1173),
    [anon_sym_PIPE] = ACTIONS(1173),
    [anon_sym_AMP] = ACTIONS(1173),
    [anon_sym_LT] = ACTIONS(1173),
    [anon_sym_LT_AMP] = ACTIONS(1173),
    [anon_sym_GT_GT] = ACTIONS(1173),
    [anon_sym_EQ_TILDE] = ACTIONS(1173),
    [sym__special_character] = ACTIONS(2212),
    [anon_sym_LT_LT_DASH] = ACTIONS(1173),
    [anon_sym_BQUOTE] = ACTIONS(1173),
    [anon_sym_LF] = ACTIONS(1175),
    [anon_sym_SEMI] = ACTIONS(1173),
    [sym_raw_string] = ACTIONS(1173),
    [sym_file_descriptor] = ACTIONS(1175),
    [anon_sym_GT] = ACTIONS(1173),
    [anon_sym_AMP_GT] = ACTIONS(1173),
    [anon_sym_EQ_EQ] = ACTIONS(1173),
    [anon_sym_DQUOTE] = ACTIONS(1173),
    [anon_sym_LT_LT_LT] = ACTIONS(1173),
    [anon_sym_GT_AMP] = ACTIONS(1173),
    [anon_sym_LT_LPAREN] = ACTIONS(1173),
    [anon_sym_esac] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1173),
    [anon_sym_SEMI_SEMI] = ACTIONS(1173),
    [anon_sym_PIPE_AMP] = ACTIONS(1173),
  },
  [605] = {
    [sym_command_substitution] = STATE(570),
    [aux_sym__literal_repeat1] = STATE(572),
    [sym_string] = STATE(570),
    [sym_process_substitution] = STATE(570),
    [sym_simple_expansion] = STATE(570),
    [sym_string_expansion] = STATE(570),
    [aux_sym_command_repeat2] = STATE(605),
    [sym_concatenation] = STATE(605),
    [sym_expansion] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1169),
    [anon_sym_DOLLAR] = ACTIONS(2349),
    [anon_sym_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2355),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2358),
    [anon_sym_PIPE_PIPE] = ACTIONS(1169),
    [sym_word] = ACTIONS(2361),
    [anon_sym_PIPE] = ACTIONS(1169),
    [anon_sym_AMP] = ACTIONS(1169),
    [anon_sym_LT] = ACTIONS(1169),
    [anon_sym_LT_AMP] = ACTIONS(1169),
    [anon_sym_GT_GT] = ACTIONS(1169),
    [anon_sym_EQ_TILDE] = ACTIONS(2364),
    [sym__special_character] = ACTIONS(2367),
    [anon_sym_LT_LT_DASH] = ACTIONS(1169),
    [anon_sym_BQUOTE] = ACTIONS(2370),
    [anon_sym_LF] = ACTIONS(1171),
    [anon_sym_SEMI] = ACTIONS(1169),
    [sym_raw_string] = ACTIONS(2361),
    [sym_file_descriptor] = ACTIONS(1171),
    [anon_sym_GT] = ACTIONS(1169),
    [anon_sym_AMP_GT] = ACTIONS(1169),
    [anon_sym_EQ_EQ] = ACTIONS(2364),
    [anon_sym_DQUOTE] = ACTIONS(2373),
    [anon_sym_LT_LT_LT] = ACTIONS(1169),
    [anon_sym_GT_AMP] = ACTIONS(1169),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_esac] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1169),
    [anon_sym_SEMI_SEMI] = ACTIONS(1169),
    [anon_sym_PIPE_AMP] = ACTIONS(1169),
  },
  [606] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1206),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1206),
    [sym_word] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1206),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1206),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1206),
    [sym_variable_name] = ACTIONS(1206),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [anon_sym_GT_AMP] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1206),
    [sym_comment] = ACTIONS(51),
  },
  [607] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1263),
    [anon_sym_GT_GT] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [sym_variable_name] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [anon_sym_GT_AMP] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(51),
  },
  [608] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1273),
    [sym_word] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1273),
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_raw_string] = ACTIONS(1273),
    [sym_variable_name] = ACTIONS(1273),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [anon_sym_GT_AMP] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [sym_comment] = ACTIONS(51),
  },
  [609] = {
    [sym_string] = STATE(555),
    [anon_sym_AMP_GT_GT] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_GT_LPAREN] = ACTIONS(1289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1289),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1289),
    [sym_word] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2378),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1289),
    [anon_sym_GT_GT] = ACTIONS(1289),
    [sym__special_character] = ACTIONS(1289),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2378),
    [sym_raw_string] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2376),
    [sym_variable_name] = ACTIONS(1289),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2378),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [anon_sym_GT_AMP] = ACTIONS(1289),
    [anon_sym_LT_LPAREN] = ACTIONS(1289),
    [anon_sym_AT] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2382),
    [anon_sym__] = ACTIONS(2378),
  },
  [610] = {
    [anon_sym_BANG_EQ] = ACTIONS(1333),
    [anon_sym_PLUS_EQ] = ACTIONS(1333),
    [sym_test_operator] = ACTIONS(1331),
    [anon_sym_LF] = ACTIONS(1333),
    [anon_sym_SEMI] = ACTIONS(1333),
    [anon_sym_PLUS_PLUS] = ACTIONS(1333),
    [anon_sym_DASH] = ACTIONS(1333),
    [anon_sym_GT] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(1333),
    [anon_sym_EQ_EQ] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_GT_EQ] = ACTIONS(1333),
    [anon_sym_PLUS] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(1333),
    [anon_sym_AMP] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1333),
    [anon_sym_DASH_DASH] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_LT_EQ] = ACTIONS(1333),
    [anon_sym_SEMI_SEMI] = ACTIONS(1333),
    [anon_sym_DASH_EQ] = ACTIONS(1333),
  },
  [611] = {
    [anon_sym_BANG_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_SEMI_SEMI] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
  },
  [612] = {
    [anon_sym_BANG_EQ] = ACTIONS(1337),
    [anon_sym_PLUS_EQ] = ACTIONS(1337),
    [sym_test_operator] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1337),
    [anon_sym_SEMI] = ACTIONS(1337),
    [anon_sym_PLUS_PLUS] = ACTIONS(1337),
    [anon_sym_DASH] = ACTIONS(1337),
    [anon_sym_GT] = ACTIONS(1337),
    [anon_sym_EQ] = ACTIONS(1337),
    [anon_sym_EQ_EQ] = ACTIONS(1337),
    [anon_sym_PIPE_PIPE] = ACTIONS(1337),
    [anon_sym_GT_EQ] = ACTIONS(1337),
    [anon_sym_PLUS] = ACTIONS(1337),
    [anon_sym_LT] = ACTIONS(1337),
    [anon_sym_AMP] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1337),
    [anon_sym_DASH_DASH] = ACTIONS(1337),
    [anon_sym_AMP_AMP] = ACTIONS(1337),
    [anon_sym_LT_EQ] = ACTIONS(1337),
    [anon_sym_SEMI_SEMI] = ACTIONS(1337),
    [anon_sym_DASH_EQ] = ACTIONS(1337),
  },
  [613] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [ts_builtin_sym_end] = ACTIONS(1347),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [614] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1379),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1379),
    [sym_word] = ACTIONS(1379),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1379),
    [anon_sym_GT_GT] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1379),
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_raw_string] = ACTIONS(1379),
    [sym_variable_name] = ACTIONS(1379),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [anon_sym_GT_AMP] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1379),
    [sym_comment] = ACTIONS(51),
  },
  [615] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_BQUOTE] = ACTIONS(1431),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1427),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [616] = {
    [anon_sym_AMP] = ACTIONS(2384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2386),
    [anon_sym_SEMI] = ACTIONS(2384),
    [anon_sym_SEMI_SEMI] = ACTIONS(2162),
    [anon_sym_esac] = ACTIONS(2162),
  },
  [617] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1439),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1439),
    [sym_word] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1439),
    [anon_sym_GT_GT] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1439),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [sym_raw_string] = ACTIONS(1439),
    [sym_variable_name] = ACTIONS(1439),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [anon_sym_GT_AMP] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1439),
    [sym_comment] = ACTIONS(51),
  },
  [618] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1451),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
    [sym_word] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1451),
    [anon_sym_GT_GT] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1451),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [sym_raw_string] = ACTIONS(1451),
    [sym_variable_name] = ACTIONS(1451),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [anon_sym_GT_AMP] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1451),
    [sym_comment] = ACTIONS(51),
  },
  [619] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1461),
    [sym_word] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1461),
    [anon_sym_GT_GT] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1461),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_raw_string] = ACTIONS(1461),
    [sym_variable_name] = ACTIONS(1461),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [anon_sym_GT_AMP] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1461),
    [sym_comment] = ACTIONS(51),
  },
  [620] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
    [sym_word] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1465),
    [anon_sym_GT_GT] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1465),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_raw_string] = ACTIONS(1465),
    [sym_variable_name] = ACTIONS(1465),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [anon_sym_GT_AMP] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [sym_comment] = ACTIONS(51),
  },
  [621] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [ts_builtin_sym_end] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [622] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1663),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
  },
  [623] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1667),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1667),
    [sym_word] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1667),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_raw_string] = ACTIONS(1667),
    [sym_variable_name] = ACTIONS(1667),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1667),
    [anon_sym_GT_AMP] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(51),
  },
  [624] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1673),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1673),
    [anon_sym_GT_GT] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1673),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1673),
    [sym_variable_name] = ACTIONS(1673),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [anon_sym_GT_AMP] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1673),
    [sym_comment] = ACTIONS(51),
  },
  [625] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
    [sym_word] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1677),
    [anon_sym_GT_GT] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1677),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_raw_string] = ACTIONS(1677),
    [sym_variable_name] = ACTIONS(1677),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [anon_sym_GT_AMP] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1677),
    [sym_comment] = ACTIONS(51),
  },
  [626] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1683),
    [sym_word] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1683),
    [anon_sym_GT_GT] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1683),
    [anon_sym_BQUOTE] = ACTIONS(1683),
    [sym_raw_string] = ACTIONS(1683),
    [sym_variable_name] = ACTIONS(1683),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [anon_sym_GT_AMP] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1683),
    [sym_comment] = ACTIONS(51),
  },
  [627] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1791),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1791),
    [sym_word] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1791),
    [anon_sym_GT_GT] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1791),
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1791),
    [sym_variable_name] = ACTIONS(1791),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_RPAREN] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1791),
    [anon_sym_GT_AMP] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1791),
    [sym_comment] = ACTIONS(51),
  },
  [628] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [sym_word] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1795),
    [anon_sym_GT_GT] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1795),
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [sym_raw_string] = ACTIONS(1795),
    [sym_variable_name] = ACTIONS(1795),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_RPAREN] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [anon_sym_GT_AMP] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1795),
    [sym_comment] = ACTIONS(51),
  },
  [629] = {
    [sym_command_substitution] = STATE(548),
    [aux_sym__literal_repeat1] = STATE(549),
    [sym_string] = STATE(548),
    [aux_sym_declaration_command_repeat1] = STATE(636),
    [sym_process_substitution] = STATE(548),
    [sym_simple_expansion] = STATE(548),
    [sym_subscript] = STATE(2482),
    [sym_string_expansion] = STATE(548),
    [sym_variable_assignment] = STATE(636),
    [sym_concatenation] = STATE(636),
    [sym_expansion] = STATE(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(123),
    [anon_sym_DOLLAR] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_GT_LPAREN] = ACTIONS(2390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2392),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2394),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2396),
    [anon_sym_PIPE_PIPE] = ACTIONS(123),
    [sym_word] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_AMP] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [sym__special_character] = ACTIONS(2400),
    [anon_sym_LT_LT_DASH] = ACTIONS(123),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_LF] = ACTIONS(141),
    [anon_sym_SEMI] = ACTIONS(123),
    [sym_raw_string] = ACTIONS(2398),
    [sym_variable_name] = ACTIONS(2404),
    [sym_file_descriptor] = ACTIONS(141),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_AMP_GT] = ACTIONS(123),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(123),
    [anon_sym_GT_AMP] = ACTIONS(123),
    [anon_sym_LT_LPAREN] = ACTIONS(2390),
    [anon_sym_esac] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(123),
    [anon_sym_SEMI_SEMI] = ACTIONS(123),
    [anon_sym_PIPE_AMP] = ACTIONS(123),
  },
  [630] = {
    [sym_command_substitution] = STATE(551),
    [aux_sym__literal_repeat1] = STATE(552),
    [sym_string] = STATE(551),
    [aux_sym_unset_command_repeat1] = STATE(637),
    [sym_process_substitution] = STATE(551),
    [sym_simple_expansion] = STATE(551),
    [sym_string_expansion] = STATE(551),
    [sym_concatenation] = STATE(637),
    [sym_expansion] = STATE(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(147),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [anon_sym_LT_LT] = ACTIONS(147),
    [anon_sym_GT_LPAREN] = ACTIONS(2410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2412),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2414),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(147),
    [sym_word] = ACTIONS(2418),
    [anon_sym_PIPE] = ACTIONS(147),
    [anon_sym_AMP] = ACTIONS(147),
    [anon_sym_LT] = ACTIONS(147),
    [anon_sym_LT_AMP] = ACTIONS(147),
    [anon_sym_GT_GT] = ACTIONS(147),
    [sym__special_character] = ACTIONS(2420),
    [anon_sym_LT_LT_DASH] = ACTIONS(147),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LF] = ACTIONS(165),
    [anon_sym_SEMI] = ACTIONS(147),
    [sym_raw_string] = ACTIONS(2418),
    [sym_file_descriptor] = ACTIONS(165),
    [anon_sym_GT] = ACTIONS(147),
    [anon_sym_AMP_GT] = ACTIONS(147),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_LT_LT_LT] = ACTIONS(147),
    [anon_sym_GT_AMP] = ACTIONS(147),
    [anon_sym_LT_LPAREN] = ACTIONS(2410),
    [anon_sym_esac] = ACTIONS(147),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(147),
    [anon_sym_SEMI_SEMI] = ACTIONS(147),
    [anon_sym_PIPE_AMP] = ACTIONS(147),
  },
  [631] = {
    [aux_sym_concatenation_repeat1] = STATE(641),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(367),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [632] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(1972),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [633] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2218),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_esac] = ACTIONS(1976),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
  },
  [634] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(649),
    [sym_function_definition] = STATE(649),
    [sym_negated_command] = STATE(649),
    [sym_test_command] = STATE(649),
    [sym_variable_assignment] = STATE(650),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(649),
    [sym_for_statement] = STATE(649),
    [sym_compound_statement] = STATE(649),
    [sym_subshell] = STATE(649),
    [sym_declaration_command] = STATE(649),
    [sym_unset_command] = STATE(649),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym_c_style_for_statement] = STATE(649),
    [sym_while_statement] = STATE(649),
    [sym_case_statement] = STATE(649),
    [sym_pipeline] = STATE(649),
    [sym_list] = STATE(649),
    [sym_command] = STATE(649),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [635] = {
    [sym_command_substitution] = STATE(570),
    [aux_sym__literal_repeat1] = STATE(572),
    [sym_string] = STATE(570),
    [sym_process_substitution] = STATE(570),
    [sym_simple_expansion] = STATE(570),
    [sym_string_expansion] = STATE(570),
    [aux_sym_command_repeat2] = STATE(652),
    [sym_concatenation] = STATE(652),
    [sym_expansion] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(333),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_GT_LPAREN] = ACTIONS(2428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(333),
    [sym_word] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(333),
    [anon_sym_LT_AMP] = ACTIONS(333),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_EQ_TILDE] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(333),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_LF] = ACTIONS(347),
    [anon_sym_SEMI] = ACTIONS(333),
    [sym_raw_string] = ACTIONS(2434),
    [sym_file_descriptor] = ACTIONS(347),
    [anon_sym_GT] = ACTIONS(333),
    [anon_sym_AMP_GT] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_LT_LT_LT] = ACTIONS(333),
    [anon_sym_GT_AMP] = ACTIONS(333),
    [anon_sym_LT_LPAREN] = ACTIONS(2428),
    [anon_sym_esac] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(333),
    [anon_sym_SEMI_SEMI] = ACTIONS(333),
    [anon_sym_PIPE_AMP] = ACTIONS(333),
  },
  [636] = {
    [sym_command_substitution] = STATE(548),
    [aux_sym__literal_repeat1] = STATE(549),
    [sym_string] = STATE(548),
    [aux_sym_declaration_command_repeat1] = STATE(574),
    [sym_process_substitution] = STATE(548),
    [sym_simple_expansion] = STATE(548),
    [sym_subscript] = STATE(2482),
    [sym_string_expansion] = STATE(548),
    [sym_variable_assignment] = STATE(574),
    [sym_concatenation] = STATE(574),
    [sym_expansion] = STATE(548),
    [anon_sym_AMP_GT_GT] = ACTIONS(377),
    [anon_sym_DOLLAR] = ACTIONS(2388),
    [anon_sym_LT_LT] = ACTIONS(377),
    [anon_sym_GT_LPAREN] = ACTIONS(2390),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2392),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2396),
    [anon_sym_PIPE_PIPE] = ACTIONS(377),
    [sym_word] = ACTIONS(2398),
    [anon_sym_PIPE] = ACTIONS(377),
    [anon_sym_AMP] = ACTIONS(377),
    [anon_sym_LT] = ACTIONS(377),
    [anon_sym_LT_AMP] = ACTIONS(377),
    [anon_sym_GT_GT] = ACTIONS(377),
    [sym__special_character] = ACTIONS(2400),
    [anon_sym_LT_LT_DASH] = ACTIONS(377),
    [anon_sym_BQUOTE] = ACTIONS(2402),
    [anon_sym_LF] = ACTIONS(381),
    [anon_sym_SEMI] = ACTIONS(377),
    [sym_raw_string] = ACTIONS(2398),
    [sym_variable_name] = ACTIONS(2404),
    [sym_file_descriptor] = ACTIONS(381),
    [anon_sym_GT] = ACTIONS(377),
    [anon_sym_AMP_GT] = ACTIONS(377),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(377),
    [anon_sym_GT_AMP] = ACTIONS(377),
    [anon_sym_LT_LPAREN] = ACTIONS(2390),
    [anon_sym_esac] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(377),
    [anon_sym_SEMI_SEMI] = ACTIONS(377),
    [anon_sym_PIPE_AMP] = ACTIONS(377),
  },
  [637] = {
    [sym_command_substitution] = STATE(551),
    [aux_sym__literal_repeat1] = STATE(552),
    [sym_string] = STATE(551),
    [aux_sym_unset_command_repeat1] = STATE(575),
    [sym_process_substitution] = STATE(551),
    [sym_simple_expansion] = STATE(551),
    [sym_string_expansion] = STATE(551),
    [sym_concatenation] = STATE(575),
    [sym_expansion] = STATE(551),
    [anon_sym_AMP_GT_GT] = ACTIONS(395),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [anon_sym_LT_LT] = ACTIONS(395),
    [anon_sym_GT_LPAREN] = ACTIONS(2410),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2412),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2444),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2416),
    [anon_sym_PIPE_PIPE] = ACTIONS(395),
    [sym_word] = ACTIONS(2418),
    [anon_sym_PIPE] = ACTIONS(395),
    [anon_sym_AMP] = ACTIONS(395),
    [anon_sym_LT] = ACTIONS(395),
    [anon_sym_LT_AMP] = ACTIONS(395),
    [anon_sym_GT_GT] = ACTIONS(395),
    [sym__special_character] = ACTIONS(2420),
    [anon_sym_LT_LT_DASH] = ACTIONS(395),
    [anon_sym_BQUOTE] = ACTIONS(2422),
    [anon_sym_LF] = ACTIONS(399),
    [anon_sym_SEMI] = ACTIONS(395),
    [sym_raw_string] = ACTIONS(2418),
    [sym_file_descriptor] = ACTIONS(399),
    [anon_sym_GT] = ACTIONS(395),
    [anon_sym_AMP_GT] = ACTIONS(395),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_LT_LT_LT] = ACTIONS(395),
    [anon_sym_GT_AMP] = ACTIONS(395),
    [anon_sym_LT_LPAREN] = ACTIONS(2410),
    [anon_sym_esac] = ACTIONS(395),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(395),
    [anon_sym_SEMI_SEMI] = ACTIONS(395),
    [anon_sym_PIPE_AMP] = ACTIONS(395),
  },
  [638] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [ts_builtin_sym_end] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [639] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [ts_builtin_sym_end] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [640] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [ts_builtin_sym_end] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [641] = {
    [aux_sym_concatenation_repeat1] = STATE(659),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2446),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [642] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [643] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [644] = {
    [aux_sym__literal_repeat1] = STATE(644),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2448),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [645] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(2623),
    [sym_function_definition] = STATE(2623),
    [sym_negated_command] = STATE(2623),
    [sym_test_command] = STATE(2623),
    [sym_variable_assignment] = STATE(665),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [sym_redirected_statement] = STATE(2623),
    [sym_for_statement] = STATE(2623),
    [sym_compound_statement] = STATE(2623),
    [sym_subshell] = STATE(2623),
    [sym_declaration_command] = STATE(2623),
    [sym_unset_command] = STATE(2623),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym_c_style_for_statement] = STATE(2623),
    [sym_while_statement] = STATE(2623),
    [sym_case_statement] = STATE(2623),
    [sym_pipeline] = STATE(2623),
    [sym_list] = STATE(2623),
    [sym_command] = STATE(2623),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [646] = {
    [sym_heredoc_body] = STATE(596),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [anon_sym_esac] = ACTIONS(2019),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(650),
  },
  [647] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [anon_sym_esac] = ACTIONS(2019),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(650),
  },
  [648] = {
    [aux_sym__literal_repeat1] = STATE(538),
    [sym_if_statement] = STATE(667),
    [sym_function_definition] = STATE(667),
    [sym_negated_command] = STATE(667),
    [sym_test_command] = STATE(667),
    [sym_variable_assignment] = STATE(668),
    [sym_subscript] = STATE(2473),
    [sym_concatenation] = STATE(541),
    [sym_expansion] = STATE(536),
    [sym_command_substitution] = STATE(536),
    [sym_redirected_statement] = STATE(667),
    [sym_for_statement] = STATE(667),
    [sym_compound_statement] = STATE(667),
    [sym_subshell] = STATE(667),
    [sym_declaration_command] = STATE(667),
    [sym_unset_command] = STATE(667),
    [sym_file_redirect] = STATE(543),
    [sym_string] = STATE(536),
    [sym_process_substitution] = STATE(536),
    [aux_sym_command_repeat1] = STATE(543),
    [sym_c_style_for_statement] = STATE(667),
    [sym_while_statement] = STATE(667),
    [sym_case_statement] = STATE(667),
    [sym_pipeline] = STATE(667),
    [sym_list] = STATE(667),
    [sym_command] = STATE(667),
    [sym_command_name] = STATE(635),
    [sym_simple_expansion] = STATE(536),
    [sym_string_expansion] = STATE(536),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(1705),
    [anon_sym_typeset] = ACTIONS(1705),
    [anon_sym_unsetenv] = ACTIONS(1707),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(1717),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(1705),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(1721),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_BANG] = ACTIONS(1725),
    [anon_sym_declare] = ACTIONS(1705),
    [sym_variable_name] = ACTIONS(1727),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(1705),
    [anon_sym_unset] = ACTIONS(1707),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [649] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
    [anon_sym_AMP_GT_GT] = ACTIONS(2214),
    [anon_sym_LF] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(2453),
    [sym_file_descriptor] = ACTIONS(2220),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_AMP_GT] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [anon_sym_LT_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_AMP] = ACTIONS(2214),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_esac] = ACTIONS(2019),
    [anon_sym_LT_AMP] = ACTIONS(2214),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_SEMI_SEMI] = ACTIONS(2019),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [650] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(2222),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2453),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2451),
    [anon_sym_SEMI] = ACTIONS(2453),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(2224),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_esac] = ACTIONS(2019),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2222),
    [anon_sym_SEMI_SEMI] = ACTIONS(2019),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
  },
  [651] = {
    [sym_command_substitution] = STATE(570),
    [aux_sym__literal_repeat1] = STATE(572),
    [sym_string] = STATE(570),
    [sym_process_substitution] = STATE(570),
    [sym_simple_expansion] = STATE(570),
    [sym_string_expansion] = STATE(570),
    [aux_sym_command_repeat2] = STATE(671),
    [sym_concatenation] = STATE(671),
    [sym_expansion] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(2428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(2434),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(2428),
    [anon_sym_esac] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [652] = {
    [sym_command_substitution] = STATE(570),
    [aux_sym__literal_repeat1] = STATE(572),
    [sym_string] = STATE(570),
    [sym_process_substitution] = STATE(570),
    [sym_simple_expansion] = STATE(570),
    [sym_string_expansion] = STATE(570),
    [aux_sym_command_repeat2] = STATE(605),
    [sym_concatenation] = STATE(605),
    [sym_expansion] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(756),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(756),
    [anon_sym_GT_LPAREN] = ACTIONS(2428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(756),
    [sym_word] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(756),
    [anon_sym_AMP] = ACTIONS(756),
    [anon_sym_LT] = ACTIONS(756),
    [anon_sym_LT_AMP] = ACTIONS(756),
    [anon_sym_GT_GT] = ACTIONS(756),
    [anon_sym_EQ_TILDE] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(756),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_LF] = ACTIONS(758),
    [anon_sym_SEMI] = ACTIONS(756),
    [sym_raw_string] = ACTIONS(2434),
    [sym_file_descriptor] = ACTIONS(758),
    [anon_sym_GT] = ACTIONS(756),
    [anon_sym_AMP_GT] = ACTIONS(756),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_LT_LT_LT] = ACTIONS(756),
    [anon_sym_GT_AMP] = ACTIONS(756),
    [anon_sym_LT_LPAREN] = ACTIONS(2428),
    [anon_sym_esac] = ACTIONS(756),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(756),
    [anon_sym_SEMI_SEMI] = ACTIONS(756),
    [anon_sym_PIPE_AMP] = ACTIONS(756),
  },
  [653] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [654] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [655] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [656] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [ts_builtin_sym_end] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [657] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [658] = {
    [sym_command_substitution] = STATE(657),
    [sym_simple_expansion] = STATE(657),
    [sym_string_expansion] = STATE(657),
    [sym_string] = STATE(657),
    [sym_process_substitution] = STATE(657),
    [sym_expansion] = STATE(657),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [sym_word] = ACTIONS(2459),
    [sym_raw_string] = ACTIONS(2459),
    [anon_sym_LT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR] = ACTIONS(2463),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2465),
    [sym__special_character] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
  },
  [659] = {
    [aux_sym_concatenation_repeat1] = STATE(659),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2469),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [660] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [661] = {
    [aux_sym_concatenation_repeat1] = STATE(557),
    [anon_sym_BQUOTE] = ACTIONS(1014),
    [anon_sym_AMP_GT_GT] = ACTIONS(1014),
    [sym_raw_string] = ACTIONS(1014),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1014),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_GT_LPAREN] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_word] = ACTIONS(1014),
    [anon_sym_GT_AMP] = ACTIONS(1014),
    [sym__concat] = ACTIONS(357),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1014),
    [anon_sym_GT_GT] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1014),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1014),
  },
  [662] = {
    [anon_sym_BQUOTE] = ACTIONS(1014),
    [anon_sym_AMP_GT_GT] = ACTIONS(1014),
    [sym_raw_string] = ACTIONS(1014),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1014),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_GT_LPAREN] = ACTIONS(1014),
    [anon_sym_DQUOTE] = ACTIONS(1014),
    [sym_word] = ACTIONS(1014),
    [anon_sym_GT_AMP] = ACTIONS(1014),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1014),
    [anon_sym_GT_GT] = ACTIONS(1014),
    [anon_sym_LT_LPAREN] = ACTIONS(1014),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1014),
  },
  [663] = {
    [aux_sym__literal_repeat1] = STATE(562),
    [anon_sym_BQUOTE] = ACTIONS(1020),
    [anon_sym_AMP_GT_GT] = ACTIONS(1020),
    [sym_raw_string] = ACTIONS(1020),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [sym_file_descriptor] = ACTIONS(1020),
    [sym_variable_name] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1020),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1020),
    [anon_sym_GT_LPAREN] = ACTIONS(1020),
    [anon_sym_DQUOTE] = ACTIONS(1020),
    [sym_word] = ACTIONS(1020),
    [anon_sym_GT_AMP] = ACTIONS(1020),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1020),
    [anon_sym_GT_GT] = ACTIONS(1020),
    [anon_sym_LT_LPAREN] = ACTIONS(1020),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(363),
  },
  [664] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [ts_builtin_sym_end] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [665] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_esac] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [666] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2097),
    [anon_sym_SEMI] = ACTIONS(2099),
    [anon_sym_SEMI_SEMI] = ACTIONS(2095),
    [anon_sym_AMP] = ACTIONS(2099),
  },
  [667] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_AMP_GT_GT] = ACTIONS(1133),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [sym_file_descriptor] = ACTIONS(1135),
    [anon_sym_GT] = ACTIONS(1133),
    [anon_sym_AMP_GT] = ACTIONS(1133),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_GT_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(1133),
    [anon_sym_esac] = ACTIONS(1133),
    [anon_sym_GT_GT] = ACTIONS(1133),
    [anon_sym_LT_AMP] = ACTIONS(1133),
    [anon_sym_AMP] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
  },
  [668] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(1133),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(1133),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(1133),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(1135),
    [anon_sym_SEMI] = ACTIONS(1133),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(1133),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [anon_sym_esac] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1133),
    [anon_sym_SEMI_SEMI] = ACTIONS(1133),
    [anon_sym_PIPE_AMP] = ACTIONS(2226),
  },
  [669] = {
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [anon_sym_esac] = ACTIONS(2095),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
  },
  [670] = {
    [sym_heredoc_body] = STATE(616),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [anon_sym_esac] = ACTIONS(2095),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
  },
  [671] = {
    [sym_command_substitution] = STATE(570),
    [aux_sym__literal_repeat1] = STATE(572),
    [sym_string] = STATE(570),
    [sym_process_substitution] = STATE(570),
    [sym_simple_expansion] = STATE(570),
    [sym_string_expansion] = STATE(570),
    [aux_sym_command_repeat2] = STATE(605),
    [sym_concatenation] = STATE(605),
    [sym_expansion] = STATE(570),
    [anon_sym_AMP_GT_GT] = ACTIONS(1165),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [anon_sym_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_LPAREN] = ACTIONS(2428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2432),
    [anon_sym_PIPE_PIPE] = ACTIONS(1165),
    [sym_word] = ACTIONS(2434),
    [anon_sym_PIPE] = ACTIONS(1165),
    [anon_sym_AMP] = ACTIONS(1165),
    [anon_sym_LT] = ACTIONS(1165),
    [anon_sym_LT_AMP] = ACTIONS(1165),
    [anon_sym_GT_GT] = ACTIONS(1165),
    [anon_sym_EQ_TILDE] = ACTIONS(2436),
    [sym__special_character] = ACTIONS(1719),
    [anon_sym_LT_LT_DASH] = ACTIONS(1165),
    [anon_sym_BQUOTE] = ACTIONS(2438),
    [anon_sym_LF] = ACTIONS(1167),
    [anon_sym_SEMI] = ACTIONS(1165),
    [sym_raw_string] = ACTIONS(2434),
    [sym_file_descriptor] = ACTIONS(1167),
    [anon_sym_GT] = ACTIONS(1165),
    [anon_sym_AMP_GT] = ACTIONS(1165),
    [anon_sym_EQ_EQ] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_LT_LT_LT] = ACTIONS(1165),
    [anon_sym_GT_AMP] = ACTIONS(1165),
    [anon_sym_LT_LPAREN] = ACTIONS(2428),
    [anon_sym_esac] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1165),
    [anon_sym_SEMI_SEMI] = ACTIONS(1165),
    [anon_sym_PIPE_AMP] = ACTIONS(1165),
  },
  [672] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [673] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [674] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [675] = {
    [sym_string] = STATE(639),
    [anon_sym__] = ACTIONS(2472),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2474),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2472),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2472),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2476),
    [anon_sym_BANG] = ACTIONS(2474),
    [sym_variable_name] = ACTIONS(1289),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2472),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(145),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2474),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [676] = {
    [anon_sym_BQUOTE] = ACTIONS(1347),
    [anon_sym_AMP_GT_GT] = ACTIONS(1347),
    [sym_raw_string] = ACTIONS(1347),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [sym_file_descriptor] = ACTIONS(1347),
    [sym_variable_name] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1347),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1347),
    [anon_sym_GT_LPAREN] = ACTIONS(1347),
    [anon_sym_DQUOTE] = ACTIONS(1347),
    [sym_word] = ACTIONS(1347),
    [anon_sym_GT_AMP] = ACTIONS(1347),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1347),
    [anon_sym_GT_GT] = ACTIONS(1347),
    [anon_sym_LT_LPAREN] = ACTIONS(1347),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1347),
  },
  [677] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [678] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [anon_sym_esac] = ACTIONS(2162),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
    [anon_sym_SEMI_SEMI] = ACTIONS(1431),
  },
  [679] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(2164),
    [anon_sym_SEMI] = ACTIONS(2166),
    [anon_sym_SEMI_SEMI] = ACTIONS(2162),
    [anon_sym_AMP] = ACTIONS(2166),
  },
  [680] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [681] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [682] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [683] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [684] = {
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_AMP_GT_GT] = ACTIONS(1596),
    [sym_raw_string] = ACTIONS(1596),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [sym_file_descriptor] = ACTIONS(1596),
    [sym_variable_name] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1596),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1596),
    [anon_sym_GT_LPAREN] = ACTIONS(1596),
    [anon_sym_DQUOTE] = ACTIONS(1596),
    [sym_word] = ACTIONS(1596),
    [anon_sym_GT_AMP] = ACTIONS(1596),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1596),
    [anon_sym_GT_GT] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1596),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1596),
  },
  [685] = {
    [anon_sym_LPAREN] = ACTIONS(1427),
    [anon_sym_AMP_GT_GT] = ACTIONS(1429),
    [anon_sym_local] = ACTIONS(1427),
    [anon_sym_typeset] = ACTIONS(1427),
    [anon_sym_unsetenv] = ACTIONS(1427),
    [anon_sym_DOLLAR] = ACTIONS(1427),
    [anon_sym_GT_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1429),
    [anon_sym_function] = ACTIONS(1427),
    [sym_word] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_LT_AMP] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_export] = ACTIONS(1427),
    [sym__special_character] = ACTIONS(1427),
    [anon_sym_if] = ACTIONS(1427),
    [anon_sym_case] = ACTIONS(1427),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(1429),
    [sym_raw_string] = ACTIONS(1429),
    [anon_sym_BQUOTE] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_declare] = ACTIONS(1427),
    [sym_variable_name] = ACTIONS(1429),
    [sym_file_descriptor] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1427),
    [anon_sym_AMP_GT] = ACTIONS(1427),
    [anon_sym_readonly] = ACTIONS(1427),
    [anon_sym_unset] = ACTIONS(1427),
    [anon_sym_DQUOTE] = ACTIONS(1429),
    [anon_sym_GT_AMP] = ACTIONS(1429),
    [anon_sym_LT_LPAREN] = ACTIONS(1429),
    [anon_sym_esac] = ACTIONS(2478),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(1427),
    [anon_sym_while] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(1429),
    [anon_sym_SEMI_SEMI] = ACTIONS(1663),
  },
  [686] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [687] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [ts_builtin_sym_end] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [688] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [689] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [690] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [691] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [ts_builtin_sym_end] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [692] = {
    [aux_sym_concatenation_repeat1] = STATE(697),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(385),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [693] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(1972),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(1976),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [694] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [ts_builtin_sym_end] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [695] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [ts_builtin_sym_end] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [696] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [ts_builtin_sym_end] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [697] = {
    [aux_sym_concatenation_repeat1] = STATE(709),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2480),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [698] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [699] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [700] = {
    [aux_sym__literal_repeat1] = STATE(700),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2482),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [701] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2017),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(2017),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2019),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [702] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(2017),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2485),
    [anon_sym_SEMI] = ACTIONS(2017),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2019),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [703] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [704] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [705] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [706] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [ts_builtin_sym_end] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [707] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [708] = {
    [sym_command_substitution] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_string_expansion] = STATE(707),
    [sym_string] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [sym_expansion] = STATE(707),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_word] = ACTIONS(2491),
    [sym_raw_string] = ACTIONS(2491),
    [anon_sym_LT_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR] = ACTIONS(2495),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2497),
    [sym__special_character] = ACTIONS(2491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2499),
  },
  [709] = {
    [aux_sym_concatenation_repeat1] = STATE(709),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2501),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [710] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [711] = {
    [aux_sym_concatenation_repeat1] = STATE(842),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(1994),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [712] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [anon_sym_RPAREN] = ACTIONS(1010),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [713] = {
    [aux_sym__literal_repeat1] = STATE(845),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(1996),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [anon_sym_RPAREN] = ACTIONS(1016),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [714] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [ts_builtin_sym_end] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [715] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [716] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [717] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [718] = {
    [sym_string] = STATE(695),
    [anon_sym__] = ACTIONS(2504),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2506),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2504),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2508),
    [anon_sym_BANG] = ACTIONS(2506),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2504),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(167),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2506),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [719] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [anon_sym_RPAREN] = ACTIONS(1345),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [720] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [721] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [722] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [723] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [724] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [725] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [anon_sym_RPAREN] = ACTIONS(1594),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [726] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [727] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [ts_builtin_sym_end] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [728] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [729] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [730] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [731] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [ts_builtin_sym_end] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [732] = {
    [aux_sym_concatenation_repeat1] = STATE(736),
    [sym__concat] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
  },
  [733] = {
    [anon_sym_AMP] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(403),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_in] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
  },
  [734] = {
    [anon_sym_AMP] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(407),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_in] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
  },
  [735] = {
    [anon_sym_AMP] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(411),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_in] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
  },
  [736] = {
    [aux_sym_concatenation_repeat1] = STATE(746),
    [anon_sym_AMP] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2510),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_in] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
  },
  [737] = {
    [anon_sym_AMP] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_in] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
  },
  [738] = {
    [sym__special_character] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_in] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
  },
  [739] = {
    [aux_sym__literal_repeat1] = STATE(739),
    [sym__special_character] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_in] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
  },
  [740] = {
    [anon_sym_AMP] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(859),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_in] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
  },
  [741] = {
    [anon_sym_AMP] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
  },
  [742] = {
    [anon_sym_AMP] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_in] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
  },
  [743] = {
    [anon_sym_AMP] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(931),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_in] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
  },
  [744] = {
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [745] = {
    [sym_command_substitution] = STATE(744),
    [sym_simple_expansion] = STATE(744),
    [sym_string_expansion] = STATE(744),
    [sym_string] = STATE(744),
    [sym_process_substitution] = STATE(744),
    [sym_expansion] = STATE(744),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [sym_word] = ACTIONS(2515),
    [sym_raw_string] = ACTIONS(2515),
    [anon_sym_LT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(2517),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(213),
    [sym__special_character] = ACTIONS(2515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
  },
  [746] = {
    [aux_sym_concatenation_repeat1] = STATE(746),
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(2519),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [747] = {
    [anon_sym_AMP] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_in] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
  },
  [748] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [749] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [750] = {
    [aux_sym__literal_repeat1] = STATE(1322),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(2524),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [anon_sym_esac] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [751] = {
    [anon_sym_AMP] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_in] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
  },
  [752] = {
    [anon_sym_AMP] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_in] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
  },
  [753] = {
    [anon_sym_AMP] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_in] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
  },
  [754] = {
    [anon_sym_AMP] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_in] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
  },
  [755] = {
    [sym_string] = STATE(734),
    [anon_sym_STAR] = ACTIONS(2526),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2528),
    [anon_sym_BANG] = ACTIONS(2530),
    [anon_sym_DOLLAR] = ACTIONS(2530),
    [anon_sym_0] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2530),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2526),
    [anon_sym_in] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_QMARK] = ACTIONS(2526),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2530),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym__] = ACTIONS(2526),
  },
  [756] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [anon_sym_esac] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [757] = {
    [anon_sym_AMP] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_in] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
  },
  [758] = {
    [anon_sym_AMP] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_in] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
  },
  [759] = {
    [anon_sym_AMP] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_in] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
  },
  [760] = {
    [anon_sym_AMP] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_in] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
  },
  [761] = {
    [anon_sym_AMP] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_in] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
  },
  [762] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_esac] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [763] = {
    [anon_sym_AMP] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_in] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
  },
  [764] = {
    [anon_sym_AMP] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_in] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
  },
  [765] = {
    [anon_sym_AMP] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_in] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
  },
  [766] = {
    [anon_sym_AMP] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_in] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
  },
  [767] = {
    [anon_sym_AMP] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_in] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
  },
  [768] = {
    [anon_sym_AMP] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_in] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
  },
  [769] = {
    [aux_sym_concatenation_repeat1] = STATE(773),
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(201),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(201),
    [sym__concat] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_EQ_TILDE] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(201),
  },
  [770] = {
    [sym_test_operator] = ACTIONS(403),
    [anon_sym_PLUS_EQ] = ACTIONS(403),
    [anon_sym_PLUS_PLUS] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(403),
    [anon_sym_PIPE_PIPE] = ACTIONS(403),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_EQ_TILDE] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_DASH_EQ] = ACTIONS(403),
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_GT_EQ] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(401),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(403),
  },
  [771] = {
    [sym_test_operator] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(407),
    [sym__concat] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_EQ_TILDE] = ACTIONS(407),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_DASH_EQ] = ACTIONS(407),
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(405),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(407),
  },
  [772] = {
    [sym_test_operator] = ACTIONS(411),
    [anon_sym_PLUS_EQ] = ACTIONS(411),
    [anon_sym_PLUS_PLUS] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_DASH_DASH] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(411),
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_RPAREN] = ACTIONS(409),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(409),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(411),
  },
  [773] = {
    [aux_sym_concatenation_repeat1] = STATE(783),
    [sym_test_operator] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(473),
    [sym__concat] = ACTIONS(2534),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_EQ_TILDE] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_DASH_EQ] = ACTIONS(473),
    [anon_sym_BANG_EQ] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(469),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(473),
  },
  [774] = {
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(585),
    [sym__concat] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_EQ] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [anon_sym_PLUS] = ACTIONS(583),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(585),
  },
  [775] = {
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(201),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(201),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_EQ_TILDE] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(201),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(201),
  },
  [776] = {
    [aux_sym__literal_repeat1] = STATE(776),
    [sym_test_operator] = ACTIONS(640),
    [anon_sym_PLUS_EQ] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(640),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_EQ_TILDE] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [sym__special_character] = ACTIONS(2536),
    [anon_sym_DASH_EQ] = ACTIONS(640),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(635),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(640),
  },
  [777] = {
    [sym_test_operator] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(857),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(859),
    [sym__concat] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_EQ_TILDE] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(857),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(859),
  },
  [778] = {
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_DASH_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(863),
  },
  [779] = {
    [sym_test_operator] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(881),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(881),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(881),
    [anon_sym_DASH_EQ] = ACTIONS(881),
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(881),
  },
  [780] = {
    [sym_test_operator] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_DASH_DASH] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_DASH_EQ] = ACTIONS(931),
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(929),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(931),
  },
  [781] = {
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(941),
  },
  [782] = {
    [sym_command_substitution] = STATE(781),
    [sym_string] = STATE(781),
    [sym_process_substitution] = STATE(781),
    [sym_simple_expansion] = STATE(781),
    [sym_string_expansion] = STATE(781),
    [sym_expansion] = STATE(781),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(2539),
    [anon_sym_DOLLAR] = ACTIONS(2541),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(2539),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2539),
  },
  [783] = {
    [aux_sym_concatenation_repeat1] = STATE(783),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(941),
    [sym__concat] = ACTIONS(2543),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(941),
  },
  [784] = {
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_DASH_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(863),
  },
  [785] = {
    [aux_sym_concatenation_repeat1] = STATE(1226),
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__concat] = ACTIONS(2238),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [786] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1010),
    [anon_sym_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_LPAREN] = ACTIONS(1010),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1010),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1010),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1010),
    [anon_sym_PIPE_PIPE] = ACTIONS(1010),
    [sym_word] = ACTIONS(1010),
    [anon_sym_PIPE] = ACTIONS(1010),
    [anon_sym_AMP] = ACTIONS(1010),
    [anon_sym_LT] = ACTIONS(1010),
    [anon_sym_LT_AMP] = ACTIONS(1010),
    [anon_sym_GT_GT] = ACTIONS(1010),
    [sym__special_character] = ACTIONS(1010),
    [anon_sym_LT_LT_DASH] = ACTIONS(1010),
    [anon_sym_BQUOTE] = ACTIONS(1010),
    [anon_sym_LF] = ACTIONS(1014),
    [anon_sym_SEMI] = ACTIONS(1010),
    [sym_raw_string] = ACTIONS(1010),
    [sym_variable_name] = ACTIONS(1014),
    [sym_file_descriptor] = ACTIONS(1014),
    [anon_sym_GT] = ACTIONS(1010),
    [anon_sym_AMP_GT] = ACTIONS(1010),
    [anon_sym_DQUOTE] = ACTIONS(1010),
    [anon_sym_LT_LT_LT] = ACTIONS(1010),
    [anon_sym_GT_AMP] = ACTIONS(1010),
    [anon_sym_LT_LPAREN] = ACTIONS(1010),
    [anon_sym_esac] = ACTIONS(1010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1010),
    [anon_sym_SEMI_SEMI] = ACTIONS(1010),
    [anon_sym_PIPE_AMP] = ACTIONS(1010),
  },
  [787] = {
    [aux_sym__literal_repeat1] = STATE(1261),
    [anon_sym_AMP_GT_GT] = ACTIONS(1016),
    [anon_sym_DOLLAR] = ACTIONS(1016),
    [anon_sym_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_LPAREN] = ACTIONS(1016),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1016),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1016),
    [anon_sym_PIPE_PIPE] = ACTIONS(1016),
    [sym_word] = ACTIONS(1016),
    [anon_sym_PIPE] = ACTIONS(1016),
    [anon_sym_AMP] = ACTIONS(1016),
    [anon_sym_LT] = ACTIONS(1016),
    [anon_sym_LT_AMP] = ACTIONS(1016),
    [anon_sym_GT_GT] = ACTIONS(1016),
    [sym__special_character] = ACTIONS(2240),
    [anon_sym_LT_LT_DASH] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1016),
    [anon_sym_LF] = ACTIONS(1020),
    [anon_sym_SEMI] = ACTIONS(1016),
    [sym_raw_string] = ACTIONS(1016),
    [sym_variable_name] = ACTIONS(1020),
    [sym_file_descriptor] = ACTIONS(1020),
    [anon_sym_GT] = ACTIONS(1016),
    [anon_sym_AMP_GT] = ACTIONS(1016),
    [anon_sym_DQUOTE] = ACTIONS(1016),
    [anon_sym_LT_LT_LT] = ACTIONS(1016),
    [anon_sym_GT_AMP] = ACTIONS(1016),
    [anon_sym_LT_LPAREN] = ACTIONS(1016),
    [anon_sym_esac] = ACTIONS(1016),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1016),
    [anon_sym_SEMI_SEMI] = ACTIONS(1016),
    [anon_sym_PIPE_AMP] = ACTIONS(1016),
  },
  [788] = {
    [sym_test_operator] = ACTIONS(1044),
    [anon_sym_PLUS_EQ] = ACTIONS(1044),
    [anon_sym_PLUS_PLUS] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1044),
    [anon_sym_PIPE_PIPE] = ACTIONS(1044),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1044),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1044),
    [anon_sym_LT_EQ] = ACTIONS(1044),
    [anon_sym_DASH_EQ] = ACTIONS(1044),
    [anon_sym_BANG_EQ] = ACTIONS(1044),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1044),
    [anon_sym_GT_EQ] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1042),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1044),
  },
  [789] = {
    [sym_test_operator] = ACTIONS(1206),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_EQ_TILDE] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1204),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
  },
  [790] = {
    [sym_test_operator] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1261),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
  },
  [791] = {
    [sym_test_operator] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1271),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
  },
  [792] = {
    [sym_string] = STATE(771),
    [sym_test_operator] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2548),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2550),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1289),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1289),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1289),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_DASH_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2552),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_0] = ACTIONS(2550),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym__] = ACTIONS(2550),
  },
  [793] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1345),
    [anon_sym_DOLLAR] = ACTIONS(1345),
    [anon_sym_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_LPAREN] = ACTIONS(1345),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1345),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1345),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1345),
    [anon_sym_PIPE_PIPE] = ACTIONS(1345),
    [sym_word] = ACTIONS(1345),
    [anon_sym_PIPE] = ACTIONS(1345),
    [anon_sym_AMP] = ACTIONS(1345),
    [anon_sym_LT] = ACTIONS(1345),
    [anon_sym_LT_AMP] = ACTIONS(1345),
    [anon_sym_GT_GT] = ACTIONS(1345),
    [sym__special_character] = ACTIONS(1345),
    [anon_sym_LT_LT_DASH] = ACTIONS(1345),
    [anon_sym_BQUOTE] = ACTIONS(1345),
    [anon_sym_LF] = ACTIONS(1347),
    [anon_sym_SEMI] = ACTIONS(1345),
    [sym_raw_string] = ACTIONS(1345),
    [sym_variable_name] = ACTIONS(1347),
    [sym_file_descriptor] = ACTIONS(1347),
    [anon_sym_GT] = ACTIONS(1345),
    [anon_sym_AMP_GT] = ACTIONS(1345),
    [anon_sym_DQUOTE] = ACTIONS(1345),
    [anon_sym_LT_LT_LT] = ACTIONS(1345),
    [anon_sym_GT_AMP] = ACTIONS(1345),
    [anon_sym_LT_LPAREN] = ACTIONS(1345),
    [anon_sym_esac] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1345),
    [anon_sym_SEMI_SEMI] = ACTIONS(1345),
    [anon_sym_PIPE_AMP] = ACTIONS(1345),
  },
  [794] = {
    [sym_test_operator] = ACTIONS(1379),
    [anon_sym_PLUS_EQ] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1379),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_EQ_TILDE] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_DASH_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1379),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_EQ] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1377),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
  },
  [795] = {
    [sym_test_operator] = ACTIONS(1439),
    [anon_sym_PLUS_EQ] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_EQ_TILDE] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_DASH_EQ] = ACTIONS(1439),
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1437),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
  },
  [796] = {
    [sym_test_operator] = ACTIONS(1451),
    [anon_sym_PLUS_EQ] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1451),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_EQ_TILDE] = ACTIONS(1451),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_DASH_EQ] = ACTIONS(1451),
    [anon_sym_BANG_EQ] = ACTIONS(1451),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1449),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
  },
  [797] = {
    [sym_test_operator] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1461),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1461),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1459),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1461),
  },
  [798] = {
    [sym_test_operator] = ACTIONS(1465),
    [anon_sym_PLUS_EQ] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE] = ACTIONS(1465),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_EQ_TILDE] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1465),
    [anon_sym_LT_EQ] = ACTIONS(1465),
    [anon_sym_DASH_EQ] = ACTIONS(1465),
    [anon_sym_BANG_EQ] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1465),
    [anon_sym_GT_EQ] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1463),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1465),
  },
  [799] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1594),
    [anon_sym_DOLLAR] = ACTIONS(1594),
    [anon_sym_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_LPAREN] = ACTIONS(1594),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1594),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1594),
    [anon_sym_PIPE_PIPE] = ACTIONS(1594),
    [sym_word] = ACTIONS(1594),
    [anon_sym_PIPE] = ACTIONS(1594),
    [anon_sym_AMP] = ACTIONS(1594),
    [anon_sym_LT] = ACTIONS(1594),
    [anon_sym_LT_AMP] = ACTIONS(1594),
    [anon_sym_GT_GT] = ACTIONS(1594),
    [sym__special_character] = ACTIONS(1594),
    [anon_sym_LT_LT_DASH] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1594),
    [anon_sym_LF] = ACTIONS(1596),
    [anon_sym_SEMI] = ACTIONS(1594),
    [sym_raw_string] = ACTIONS(1594),
    [sym_variable_name] = ACTIONS(1596),
    [sym_file_descriptor] = ACTIONS(1596),
    [anon_sym_GT] = ACTIONS(1594),
    [anon_sym_AMP_GT] = ACTIONS(1594),
    [anon_sym_DQUOTE] = ACTIONS(1594),
    [anon_sym_LT_LT_LT] = ACTIONS(1594),
    [anon_sym_GT_AMP] = ACTIONS(1594),
    [anon_sym_LT_LPAREN] = ACTIONS(1594),
    [anon_sym_esac] = ACTIONS(1594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1594),
    [anon_sym_SEMI_SEMI] = ACTIONS(1594),
    [anon_sym_PIPE_AMP] = ACTIONS(1594),
  },
  [800] = {
    [sym_test_operator] = ACTIONS(1667),
    [anon_sym_PLUS_EQ] = ACTIONS(1667),
    [anon_sym_PLUS_PLUS] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1667),
    [anon_sym_PIPE_PIPE] = ACTIONS(1667),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1667),
    [anon_sym_DASH_DASH] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_DASH_EQ] = ACTIONS(1667),
    [anon_sym_BANG_EQ] = ACTIONS(1667),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_PLUS] = ACTIONS(1665),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1667),
  },
  [801] = {
    [sym_test_operator] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1673),
    [anon_sym_PIPE_PIPE] = ACTIONS(1673),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_EQ_TILDE] = ACTIONS(1673),
    [anon_sym_DASH_DASH] = ACTIONS(1673),
    [anon_sym_LT_EQ] = ACTIONS(1673),
    [anon_sym_DASH_EQ] = ACTIONS(1673),
    [anon_sym_BANG_EQ] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_GT_EQ] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1671),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1673),
  },
  [802] = {
    [sym_test_operator] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [anon_sym_PLUS_PLUS] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_DASH_DASH] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_EQ] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1675),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
  },
  [803] = {
    [sym_test_operator] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1681),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
  },
  [804] = {
    [sym_test_operator] = ACTIONS(1791),
    [anon_sym_PLUS_EQ] = ACTIONS(1791),
    [anon_sym_PLUS_PLUS] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_EQ_TILDE] = ACTIONS(1791),
    [anon_sym_DASH_DASH] = ACTIONS(1791),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_DASH_EQ] = ACTIONS(1791),
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
  },
  [805] = {
    [sym_test_operator] = ACTIONS(1795),
    [anon_sym_PLUS_EQ] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(1795),
    [anon_sym_PIPE_PIPE] = ACTIONS(1795),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_EQ_TILDE] = ACTIONS(1795),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_LT_EQ] = ACTIONS(1795),
    [anon_sym_DASH_EQ] = ACTIONS(1795),
    [anon_sym_BANG_EQ] = ACTIONS(1795),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1795),
    [anon_sym_GT_EQ] = ACTIONS(1795),
    [anon_sym_PLUS] = ACTIONS(1793),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(1795),
  },
  [806] = {
    [aux_sym_concatenation_repeat1] = STATE(810),
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_RBRACK] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [sym__concat] = ACTIONS(2008),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(201),
  },
  [807] = {
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
    [sym__string_content] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(403),
  },
  [808] = {
    [anon_sym_BANG_EQ] = ACTIONS(407),
    [anon_sym_PLUS_EQ] = ACTIONS(407),
    [sym_test_operator] = ACTIONS(407),
    [anon_sym_PLUS_PLUS] = ACTIONS(407),
    [anon_sym_RBRACK] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(407),
    [anon_sym_PIPE_PIPE] = ACTIONS(407),
    [anon_sym_GT_EQ] = ACTIONS(407),
    [sym__concat] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(407),
    [anon_sym_DASH_DASH] = ACTIONS(407),
    [anon_sym_LT_EQ] = ACTIONS(407),
    [anon_sym_AMP_AMP] = ACTIONS(407),
    [anon_sym_DASH_EQ] = ACTIONS(407),
  },
  [809] = {
    [anon_sym_BQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
    [sym__string_content] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
  },
  [810] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [anon_sym_BANG_EQ] = ACTIONS(473),
    [anon_sym_PLUS_EQ] = ACTIONS(473),
    [sym_test_operator] = ACTIONS(473),
    [anon_sym_PLUS_PLUS] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(473),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(473),
    [anon_sym_PIPE_PIPE] = ACTIONS(473),
    [anon_sym_GT_EQ] = ACTIONS(473),
    [sym__concat] = ACTIONS(2556),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(473),
    [anon_sym_DASH_DASH] = ACTIONS(473),
    [anon_sym_LT_EQ] = ACTIONS(473),
    [anon_sym_AMP_AMP] = ACTIONS(473),
    [anon_sym_DASH_EQ] = ACTIONS(473),
  },
  [811] = {
    [anon_sym_BANG_EQ] = ACTIONS(585),
    [anon_sym_PLUS_EQ] = ACTIONS(585),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_PLUS_PLUS] = ACTIONS(585),
    [anon_sym_RBRACK] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_EQ] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(585),
    [anon_sym_PIPE_PIPE] = ACTIONS(585),
    [anon_sym_GT_EQ] = ACTIONS(585),
    [sym__concat] = ACTIONS(585),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(585),
    [anon_sym_DASH_DASH] = ACTIONS(585),
    [anon_sym_LT_EQ] = ACTIONS(585),
    [anon_sym_AMP_AMP] = ACTIONS(585),
    [anon_sym_DASH_EQ] = ACTIONS(585),
  },
  [812] = {
    [anon_sym_BANG_EQ] = ACTIONS(201),
    [anon_sym_PLUS_EQ] = ACTIONS(201),
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_PLUS_PLUS] = ACTIONS(201),
    [anon_sym_RBRACK] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(201),
    [anon_sym_PIPE_PIPE] = ACTIONS(201),
    [anon_sym_GT_EQ] = ACTIONS(201),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(201),
    [anon_sym_DASH_DASH] = ACTIONS(201),
    [anon_sym_LT_EQ] = ACTIONS(201),
    [anon_sym_AMP_AMP] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(201),
  },
  [813] = {
    [aux_sym__literal_repeat1] = STATE(813),
    [anon_sym_BANG_EQ] = ACTIONS(640),
    [anon_sym_PLUS_EQ] = ACTIONS(640),
    [sym_test_operator] = ACTIONS(640),
    [anon_sym_PLUS_PLUS] = ACTIONS(640),
    [anon_sym_RBRACK] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [anon_sym_GT_EQ] = ACTIONS(640),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(640),
    [anon_sym_DASH_DASH] = ACTIONS(640),
    [anon_sym_LT_EQ] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [sym__special_character] = ACTIONS(2558),
    [anon_sym_DASH_EQ] = ACTIONS(640),
  },
  [814] = {
    [anon_sym_BANG_EQ] = ACTIONS(859),
    [anon_sym_PLUS_EQ] = ACTIONS(859),
    [sym_test_operator] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(859),
    [anon_sym_RBRACK] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(859),
    [anon_sym_PIPE_PIPE] = ACTIONS(859),
    [anon_sym_GT_EQ] = ACTIONS(859),
    [sym__concat] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(859),
    [anon_sym_DASH_DASH] = ACTIONS(859),
    [anon_sym_LT_EQ] = ACTIONS(859),
    [anon_sym_AMP_AMP] = ACTIONS(859),
    [anon_sym_DASH_EQ] = ACTIONS(859),
  },
  [815] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [sym__string_content] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
  },
  [816] = {
    [anon_sym_BQUOTE] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
    [sym__string_content] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(881),
  },
  [817] = {
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [sym__string_content] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
  },
  [818] = {
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
  },
  [819] = {
    [sym_command_substitution] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_string_expansion] = STATE(818),
    [sym_string] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [sym_expansion] = STATE(818),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(1361),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(2561),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(1361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [820] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [anon_sym_BANG_EQ] = ACTIONS(941),
    [anon_sym_PLUS_EQ] = ACTIONS(941),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_PLUS_PLUS] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(941),
    [sym__concat] = ACTIONS(2563),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(941),
    [anon_sym_DASH_DASH] = ACTIONS(941),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_DASH_EQ] = ACTIONS(941),
  },
  [821] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [sym__string_content] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
  },
  [822] = {
    [anon_sym_BANG_EQ] = ACTIONS(1044),
    [anon_sym_PLUS_EQ] = ACTIONS(1044),
    [sym_test_operator] = ACTIONS(1044),
    [anon_sym_PLUS_PLUS] = ACTIONS(1044),
    [anon_sym_RBRACK] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1044),
    [anon_sym_PIPE_PIPE] = ACTIONS(1044),
    [anon_sym_GT_EQ] = ACTIONS(1044),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1044),
    [anon_sym_DASH_DASH] = ACTIONS(1044),
    [anon_sym_LT_EQ] = ACTIONS(1044),
    [anon_sym_AMP_AMP] = ACTIONS(1044),
    [anon_sym_DASH_EQ] = ACTIONS(1044),
  },
  [823] = {
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
    [sym__string_content] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1206),
  },
  [824] = {
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
    [sym__string_content] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
  },
  [825] = {
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
    [sym__string_content] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1273),
  },
  [826] = {
    [sym_string] = STATE(808),
    [sym_test_operator] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1289),
    [anon_sym_PLUS_PLUS] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2568),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2570),
    [anon_sym_PIPE_PIPE] = ACTIONS(1289),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1289),
    [anon_sym_DASH_DASH] = ACTIONS(1289),
    [anon_sym_LT_EQ] = ACTIONS(1289),
    [anon_sym_DASH_EQ] = ACTIONS(1289),
    [anon_sym_BANG_EQ] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2572),
    [sym_raw_string] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2568),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2570),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1289),
    [anon_sym_GT_EQ] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2566),
    [anon_sym_AMP_AMP] = ACTIONS(1289),
    [anon_sym__] = ACTIONS(2570),
  },
  [827] = {
    [anon_sym_BANG_EQ] = ACTIONS(1379),
    [anon_sym_PLUS_EQ] = ACTIONS(1379),
    [sym_test_operator] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_EQ] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1379),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_LT_EQ] = ACTIONS(1379),
    [anon_sym_AMP_AMP] = ACTIONS(1379),
    [anon_sym_DASH_EQ] = ACTIONS(1379),
  },
  [828] = {
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
    [sym__string_content] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1439),
  },
  [829] = {
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
    [sym__string_content] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
  },
  [830] = {
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
    [sym__string_content] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1461),
  },
  [831] = {
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
    [sym__string_content] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
  },
  [832] = {
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [anon_sym_DQUOTE] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
    [sym__string_content] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1667),
  },
  [833] = {
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
    [sym__string_content] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1673),
  },
  [834] = {
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
    [sym__string_content] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
  },
  [835] = {
    [anon_sym_BQUOTE] = ACTIONS(1683),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
    [sym__string_content] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1683),
  },
  [836] = {
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
    [sym__string_content] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1791),
  },
  [837] = {
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
    [sym__string_content] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
  },
  [838] = {
    [aux_sym_concatenation_repeat1] = STATE(842),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(1994),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [839] = {
    [anon_sym_BANG_EQ] = ACTIONS(403),
    [anon_sym_PLUS_EQ] = ACTIONS(403),
    [sym_test_operator] = ACTIONS(403),
    [anon_sym_PLUS_PLUS] = ACTIONS(403),
    [anon_sym_RBRACK] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(403),
    [anon_sym_PIPE_PIPE] = ACTIONS(403),
    [anon_sym_GT_EQ] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(403),
    [anon_sym_DASH_DASH] = ACTIONS(403),
    [anon_sym_LT_EQ] = ACTIONS(403),
    [anon_sym_AMP_AMP] = ACTIONS(403),
    [anon_sym_DASH_EQ] = ACTIONS(403),
  },
  [840] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [841] = {
    [anon_sym_BANG_EQ] = ACTIONS(411),
    [anon_sym_PLUS_EQ] = ACTIONS(411),
    [sym_test_operator] = ACTIONS(411),
    [anon_sym_PLUS_PLUS] = ACTIONS(411),
    [anon_sym_RBRACK] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(411),
    [anon_sym_PIPE_PIPE] = ACTIONS(411),
    [anon_sym_GT_EQ] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(411),
    [anon_sym_DASH_DASH] = ACTIONS(411),
    [anon_sym_LT_EQ] = ACTIONS(411),
    [anon_sym_AMP_AMP] = ACTIONS(411),
    [anon_sym_DASH_EQ] = ACTIONS(411),
  },
  [842] = {
    [aux_sym_concatenation_repeat1] = STATE(852),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2576),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [843] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [844] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [845] = {
    [aux_sym__literal_repeat1] = STATE(845),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2578),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [846] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [847] = {
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [848] = {
    [anon_sym_BANG_EQ] = ACTIONS(881),
    [anon_sym_PLUS_EQ] = ACTIONS(881),
    [sym_test_operator] = ACTIONS(881),
    [anon_sym_PLUS_PLUS] = ACTIONS(881),
    [anon_sym_RBRACK] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(881),
    [anon_sym_PIPE_PIPE] = ACTIONS(881),
    [anon_sym_GT_EQ] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(881),
    [anon_sym_DASH_DASH] = ACTIONS(881),
    [anon_sym_LT_EQ] = ACTIONS(881),
    [anon_sym_AMP_AMP] = ACTIONS(881),
    [anon_sym_DASH_EQ] = ACTIONS(881),
  },
  [849] = {
    [anon_sym_BANG_EQ] = ACTIONS(931),
    [anon_sym_PLUS_EQ] = ACTIONS(931),
    [sym_test_operator] = ACTIONS(931),
    [anon_sym_PLUS_PLUS] = ACTIONS(931),
    [anon_sym_RBRACK] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(931),
    [anon_sym_PIPE_PIPE] = ACTIONS(931),
    [anon_sym_GT_EQ] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(931),
    [anon_sym_DASH_DASH] = ACTIONS(931),
    [anon_sym_LT_EQ] = ACTIONS(931),
    [anon_sym_AMP_AMP] = ACTIONS(931),
    [anon_sym_DASH_EQ] = ACTIONS(931),
  },
  [850] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [851] = {
    [sym_command_substitution] = STATE(850),
    [sym_string] = STATE(850),
    [sym_process_substitution] = STATE(850),
    [sym_simple_expansion] = STATE(850),
    [sym_string_expansion] = STATE(850),
    [sym_expansion] = STATE(850),
    [anon_sym_BQUOTE] = ACTIONS(2581),
    [sym_raw_string] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(2585),
    [anon_sym_GT_LPAREN] = ACTIONS(2587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2593),
    [sym_word] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2587),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2583),
  },
  [852] = {
    [aux_sym_concatenation_repeat1] = STATE(852),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2595),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [853] = {
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_PLUS_EQ] = ACTIONS(863),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_PLUS_PLUS] = ACTIONS(863),
    [anon_sym_RBRACK] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_PIPE_PIPE] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(863),
    [anon_sym_DASH_DASH] = ACTIONS(863),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_AMP_AMP] = ACTIONS(863),
    [anon_sym_DASH_EQ] = ACTIONS(863),
  },
  [854] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [855] = {
    [anon_sym_BANG_EQ] = ACTIONS(1206),
    [anon_sym_PLUS_EQ] = ACTIONS(1206),
    [sym_test_operator] = ACTIONS(1206),
    [anon_sym_PLUS_PLUS] = ACTIONS(1206),
    [anon_sym_RBRACK] = ACTIONS(1206),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1206),
    [anon_sym_PIPE_PIPE] = ACTIONS(1206),
    [anon_sym_GT_EQ] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1206),
    [anon_sym_DASH_DASH] = ACTIONS(1206),
    [anon_sym_LT_EQ] = ACTIONS(1206),
    [anon_sym_AMP_AMP] = ACTIONS(1206),
    [anon_sym_DASH_EQ] = ACTIONS(1206),
  },
  [856] = {
    [anon_sym_BANG_EQ] = ACTIONS(1263),
    [anon_sym_PLUS_EQ] = ACTIONS(1263),
    [sym_test_operator] = ACTIONS(1263),
    [anon_sym_PLUS_PLUS] = ACTIONS(1263),
    [anon_sym_RBRACK] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1263),
    [anon_sym_PIPE_PIPE] = ACTIONS(1263),
    [anon_sym_GT_EQ] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1263),
    [anon_sym_DASH_DASH] = ACTIONS(1263),
    [anon_sym_LT_EQ] = ACTIONS(1263),
    [anon_sym_AMP_AMP] = ACTIONS(1263),
    [anon_sym_DASH_EQ] = ACTIONS(1263),
  },
  [857] = {
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [sym_test_operator] = ACTIONS(1273),
    [anon_sym_PLUS_PLUS] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE] = ACTIONS(1273),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_DASH_DASH] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
  },
  [858] = {
    [sym_string] = STATE(840),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2598),
    [anon_sym_DASH] = ACTIONS(2598),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2600),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2600),
    [sym_raw_string] = ACTIONS(2602),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_variable_name] = ACTIONS(1289),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1946),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2600),
    [anon_sym_POUND] = ACTIONS(2598),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2600),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(2598),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2600),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym__] = ACTIONS(2600),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [859] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [860] = {
    [anon_sym_BANG_EQ] = ACTIONS(1439),
    [anon_sym_PLUS_EQ] = ACTIONS(1439),
    [sym_test_operator] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_RBRACK] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1439),
    [anon_sym_PIPE_PIPE] = ACTIONS(1439),
    [anon_sym_GT_EQ] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_LT_EQ] = ACTIONS(1439),
    [anon_sym_AMP_AMP] = ACTIONS(1439),
    [anon_sym_DASH_EQ] = ACTIONS(1439),
  },
  [861] = {
    [anon_sym_BANG_EQ] = ACTIONS(1451),
    [anon_sym_PLUS_EQ] = ACTIONS(1451),
    [sym_test_operator] = ACTIONS(1451),
    [anon_sym_PLUS_PLUS] = ACTIONS(1451),
    [anon_sym_RBRACK] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1451),
    [anon_sym_PIPE_PIPE] = ACTIONS(1451),
    [anon_sym_GT_EQ] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1451),
    [anon_sym_DASH_DASH] = ACTIONS(1451),
    [anon_sym_LT_EQ] = ACTIONS(1451),
    [anon_sym_AMP_AMP] = ACTIONS(1451),
    [anon_sym_DASH_EQ] = ACTIONS(1451),
  },
  [862] = {
    [anon_sym_BANG_EQ] = ACTIONS(1461),
    [anon_sym_PLUS_EQ] = ACTIONS(1461),
    [sym_test_operator] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1461),
    [anon_sym_RBRACK] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1461),
    [anon_sym_PIPE_PIPE] = ACTIONS(1461),
    [anon_sym_GT_EQ] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1461),
    [anon_sym_DASH_DASH] = ACTIONS(1461),
    [anon_sym_LT_EQ] = ACTIONS(1461),
    [anon_sym_AMP_AMP] = ACTIONS(1461),
    [anon_sym_DASH_EQ] = ACTIONS(1461),
  },
  [863] = {
    [anon_sym_BANG_EQ] = ACTIONS(1465),
    [anon_sym_PLUS_EQ] = ACTIONS(1465),
    [sym_test_operator] = ACTIONS(1465),
    [anon_sym_PLUS_PLUS] = ACTIONS(1465),
    [anon_sym_RBRACK] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1465),
    [anon_sym_PIPE_PIPE] = ACTIONS(1465),
    [anon_sym_GT_EQ] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1465),
    [anon_sym_DASH_DASH] = ACTIONS(1465),
    [anon_sym_LT_EQ] = ACTIONS(1465),
    [anon_sym_AMP_AMP] = ACTIONS(1465),
    [anon_sym_DASH_EQ] = ACTIONS(1465),
  },
  [864] = {
    [anon_sym_BANG_EQ] = ACTIONS(1667),
    [anon_sym_PLUS_EQ] = ACTIONS(1667),
    [sym_test_operator] = ACTIONS(1667),
    [anon_sym_PLUS_PLUS] = ACTIONS(1667),
    [anon_sym_RBRACK] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1667),
    [anon_sym_PIPE_PIPE] = ACTIONS(1667),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_PLUS] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1667),
    [anon_sym_DASH_DASH] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_AMP_AMP] = ACTIONS(1667),
    [anon_sym_DASH_EQ] = ACTIONS(1667),
  },
  [865] = {
    [anon_sym_BANG_EQ] = ACTIONS(1673),
    [anon_sym_PLUS_EQ] = ACTIONS(1673),
    [sym_test_operator] = ACTIONS(1673),
    [anon_sym_PLUS_PLUS] = ACTIONS(1673),
    [anon_sym_RBRACK] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1673),
    [anon_sym_PIPE_PIPE] = ACTIONS(1673),
    [anon_sym_GT_EQ] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1673),
    [anon_sym_DASH_DASH] = ACTIONS(1673),
    [anon_sym_LT_EQ] = ACTIONS(1673),
    [anon_sym_AMP_AMP] = ACTIONS(1673),
    [anon_sym_DASH_EQ] = ACTIONS(1673),
  },
  [866] = {
    [anon_sym_BANG_EQ] = ACTIONS(1677),
    [anon_sym_PLUS_EQ] = ACTIONS(1677),
    [sym_test_operator] = ACTIONS(1677),
    [anon_sym_PLUS_PLUS] = ACTIONS(1677),
    [anon_sym_RBRACK] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_EQ] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1677),
    [anon_sym_PIPE_PIPE] = ACTIONS(1677),
    [anon_sym_GT_EQ] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1677),
    [anon_sym_DASH_DASH] = ACTIONS(1677),
    [anon_sym_LT_EQ] = ACTIONS(1677),
    [anon_sym_AMP_AMP] = ACTIONS(1677),
    [anon_sym_DASH_EQ] = ACTIONS(1677),
  },
  [867] = {
    [anon_sym_BANG_EQ] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(1683),
    [sym_test_operator] = ACTIONS(1683),
    [anon_sym_PLUS_PLUS] = ACTIONS(1683),
    [anon_sym_RBRACK] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1683),
    [anon_sym_PIPE_PIPE] = ACTIONS(1683),
    [anon_sym_GT_EQ] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1683),
    [anon_sym_DASH_DASH] = ACTIONS(1683),
    [anon_sym_LT_EQ] = ACTIONS(1683),
    [anon_sym_AMP_AMP] = ACTIONS(1683),
    [anon_sym_DASH_EQ] = ACTIONS(1683),
  },
  [868] = {
    [anon_sym_BANG_EQ] = ACTIONS(1791),
    [anon_sym_PLUS_EQ] = ACTIONS(1791),
    [sym_test_operator] = ACTIONS(1791),
    [anon_sym_PLUS_PLUS] = ACTIONS(1791),
    [anon_sym_RBRACK] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1791),
    [anon_sym_PIPE_PIPE] = ACTIONS(1791),
    [anon_sym_GT_EQ] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1791),
    [anon_sym_DASH_DASH] = ACTIONS(1791),
    [anon_sym_LT_EQ] = ACTIONS(1791),
    [anon_sym_AMP_AMP] = ACTIONS(1791),
    [anon_sym_DASH_EQ] = ACTIONS(1791),
  },
  [869] = {
    [anon_sym_BANG_EQ] = ACTIONS(1795),
    [anon_sym_PLUS_EQ] = ACTIONS(1795),
    [sym_test_operator] = ACTIONS(1795),
    [anon_sym_PLUS_PLUS] = ACTIONS(1795),
    [anon_sym_RBRACK] = ACTIONS(1795),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1795),
    [anon_sym_PIPE_PIPE] = ACTIONS(1795),
    [anon_sym_GT_EQ] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(1795),
    [anon_sym_DASH_DASH] = ACTIONS(1795),
    [anon_sym_LT_EQ] = ACTIONS(1795),
    [anon_sym_AMP_AMP] = ACTIONS(1795),
    [anon_sym_DASH_EQ] = ACTIONS(1795),
  },
  [870] = {
    [aux_sym_concatenation_repeat1] = STATE(874),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2000),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [871] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [872] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [873] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [874] = {
    [aux_sym_concatenation_repeat1] = STATE(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2604),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [875] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [876] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [877] = {
    [aux_sym__literal_repeat1] = STATE(877),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2606),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [878] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [879] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [880] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [881] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [882] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [883] = {
    [sym_command_substitution] = STATE(882),
    [sym_string] = STATE(882),
    [sym_process_substitution] = STATE(882),
    [sym_simple_expansion] = STATE(882),
    [sym_string_expansion] = STATE(882),
    [sym_expansion] = STATE(882),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_raw_string] = ACTIONS(2611),
    [anon_sym_DOLLAR] = ACTIONS(2613),
    [anon_sym_GT_LPAREN] = ACTIONS(2615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_word] = ACTIONS(2611),
    [anon_sym_LT_LPAREN] = ACTIONS(2615),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2611),
  },
  [884] = {
    [aux_sym_concatenation_repeat1] = STATE(884),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2623),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [885] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [886] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [887] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [888] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [889] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [890] = {
    [sym_string] = STATE(872),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2626),
    [anon_sym_DASH] = ACTIONS(2626),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2628),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2628),
    [sym_raw_string] = ACTIONS(2630),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1964),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2628),
    [anon_sym_POUND] = ACTIONS(2626),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2628),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(2626),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2628),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym__] = ACTIONS(2628),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [891] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [892] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [893] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [894] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [895] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [896] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [897] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [898] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [899] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [900] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [901] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [902] = {
    [aux_sym_concatenation_repeat1] = STATE(906),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_COLON_QMARK] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_COLON] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [sym_word] = ACTIONS(199),
    [sym__concat] = ACTIONS(877),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(201),
    [anon_sym_COLON_DASH] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
  },
  [903] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [904] = {
    [anon_sym_BQUOTE] = ACTIONS(407),
    [sym_raw_string] = ACTIONS(407),
    [anon_sym_COLON_QMARK] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_RBRACE] = ACTIONS(407),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(407),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(407),
    [anon_sym_PERCENT] = ACTIONS(405),
    [anon_sym_COLON] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_word] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(407),
    [anon_sym_COLON_DASH] = ACTIONS(405),
    [sym__special_character] = ACTIONS(405),
  },
  [905] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [906] = {
    [aux_sym_concatenation_repeat1] = STATE(916),
    [anon_sym_BQUOTE] = ACTIONS(473),
    [sym_raw_string] = ACTIONS(473),
    [anon_sym_COLON_QMARK] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_RBRACE] = ACTIONS(473),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(473),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(473),
    [anon_sym_PERCENT] = ACTIONS(469),
    [anon_sym_COLON] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [sym_word] = ACTIONS(469),
    [sym__concat] = ACTIONS(2632),
    [anon_sym_LT_LPAREN] = ACTIONS(473),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(473),
    [anon_sym_COLON_DASH] = ACTIONS(469),
    [sym__special_character] = ACTIONS(469),
  },
  [907] = {
    [anon_sym_BQUOTE] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [anon_sym_COLON_QMARK] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [anon_sym_EQ] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
    [anon_sym_PERCENT] = ACTIONS(583),
    [anon_sym_COLON] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(585),
    [anon_sym_COLON_DASH] = ACTIONS(583),
    [sym__special_character] = ACTIONS(583),
  },
  [908] = {
    [anon_sym_BQUOTE] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_COLON_QMARK] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(201),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
    [anon_sym_PERCENT] = ACTIONS(199),
    [anon_sym_COLON] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [sym_word] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(201),
    [anon_sym_COLON_DASH] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
  },
  [909] = {
    [aux_sym__literal_repeat1] = STATE(909),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [sym_raw_string] = ACTIONS(640),
    [anon_sym_COLON_QMARK] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_RBRACE] = ACTIONS(640),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(640),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(640),
    [anon_sym_PERCENT] = ACTIONS(635),
    [anon_sym_COLON] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [sym_word] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(640),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(640),
    [anon_sym_COLON_DASH] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2634),
  },
  [910] = {
    [anon_sym_BQUOTE] = ACTIONS(859),
    [sym_raw_string] = ACTIONS(859),
    [anon_sym_COLON_QMARK] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(857),
    [anon_sym_COLON] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [sym_word] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(859),
    [anon_sym_COLON_DASH] = ACTIONS(857),
    [sym__special_character] = ACTIONS(857),
  },
  [911] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [912] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [913] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [914] = {
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_COLON_QMARK] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(939),
    [anon_sym_COLON] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(941),
    [anon_sym_COLON_DASH] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
  },
  [915] = {
    [sym_command_substitution] = STATE(914),
    [sym_simple_expansion] = STATE(914),
    [sym_string_expansion] = STATE(914),
    [sym_string] = STATE(914),
    [sym_process_substitution] = STATE(914),
    [sym_expansion] = STATE(914),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(2637),
    [sym_raw_string] = ACTIONS(2637),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(2639),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [sym__special_character] = ACTIONS(2637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
  },
  [916] = {
    [aux_sym_concatenation_repeat1] = STATE(916),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [anon_sym_COLON_QMARK] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(941),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(939),
    [anon_sym_COLON] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(2641),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(941),
    [anon_sym_COLON_DASH] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
  },
  [917] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [918] = {
    [anon_sym_BQUOTE] = ACTIONS(1044),
    [sym_raw_string] = ACTIONS(1044),
    [anon_sym_COLON_QMARK] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1044),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1044),
    [anon_sym_PERCENT] = ACTIONS(1042),
    [anon_sym_COLON] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [sym_word] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1044),
    [anon_sym_COLON_DASH] = ACTIONS(1042),
    [sym__special_character] = ACTIONS(1042),
  },
  [919] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [920] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [921] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [922] = {
    [sym_string] = STATE(904),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2644),
    [sym_raw_string] = ACTIONS(2646),
    [anon_sym_COLON_QMARK] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(2648),
    [anon_sym_DOLLAR] = ACTIONS(2648),
    [anon_sym_0] = ACTIONS(2644),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(2648),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1289),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1289),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1285),
    [anon_sym_GT_LPAREN] = ACTIONS(1289),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2644),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym_LT_LPAREN] = ACTIONS(1289),
    [anon_sym_AT] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2650),
    [anon_sym_COLON_DASH] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym__] = ACTIONS(2644),
  },
  [923] = {
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [sym_raw_string] = ACTIONS(1379),
    [anon_sym_COLON_QMARK] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1379),
    [anon_sym_EQ] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1379),
    [anon_sym_PERCENT] = ACTIONS(1377),
    [anon_sym_COLON] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_word] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1379),
    [anon_sym_COLON_DASH] = ACTIONS(1377),
    [sym__special_character] = ACTIONS(1377),
  },
  [924] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [925] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [926] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [927] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [928] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [929] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [930] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [931] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [932] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [933] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [934] = {
    [aux_sym_concatenation_repeat1] = STATE(938),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(1012),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [935] = {
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_raw_string] = ACTIONS(403),
    [anon_sym_COLON_QMARK] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_RBRACE] = ACTIONS(403),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(403),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(403),
    [anon_sym_PERCENT] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_word] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(403),
    [anon_sym_COLON_DASH] = ACTIONS(401),
    [sym__special_character] = ACTIONS(401),
  },
  [936] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [ts_builtin_sym_end] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [937] = {
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_raw_string] = ACTIONS(411),
    [anon_sym_COLON_QMARK] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_RBRACE] = ACTIONS(411),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [anon_sym_EQ] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
    [anon_sym_PERCENT] = ACTIONS(409),
    [anon_sym_COLON] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_word] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(411),
    [anon_sym_COLON_DASH] = ACTIONS(409),
    [sym__special_character] = ACTIONS(409),
  },
  [938] = {
    [aux_sym_concatenation_repeat1] = STATE(948),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2652),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [939] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [940] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [941] = {
    [aux_sym__literal_repeat1] = STATE(941),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2654),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [942] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [943] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [anon_sym_COLON_QMARK] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym_word] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(863),
    [anon_sym_COLON_DASH] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
  },
  [944] = {
    [anon_sym_BQUOTE] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(881),
    [anon_sym_COLON_QMARK] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_RBRACE] = ACTIONS(881),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(881),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(881),
    [anon_sym_PERCENT] = ACTIONS(879),
    [anon_sym_COLON] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym_word] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(881),
    [anon_sym_COLON_DASH] = ACTIONS(879),
    [sym__special_character] = ACTIONS(879),
  },
  [945] = {
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [anon_sym_COLON_QMARK] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_RBRACE] = ACTIONS(931),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [anon_sym_PERCENT] = ACTIONS(929),
    [anon_sym_COLON] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_word] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(931),
    [anon_sym_COLON_DASH] = ACTIONS(929),
    [sym__special_character] = ACTIONS(929),
  },
  [946] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [947] = {
    [sym_command_substitution] = STATE(946),
    [sym_simple_expansion] = STATE(946),
    [sym_string_expansion] = STATE(946),
    [sym_string] = STATE(946),
    [sym_process_substitution] = STATE(946),
    [sym_expansion] = STATE(946),
    [anon_sym_BQUOTE] = ACTIONS(549),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(2657),
    [sym_raw_string] = ACTIONS(2657),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(2659),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [sym__special_character] = ACTIONS(2657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
  },
  [948] = {
    [aux_sym_concatenation_repeat1] = STATE(948),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2661),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [949] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [anon_sym_COLON_QMARK] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_RBRACE] = ACTIONS(863),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [anon_sym_PERCENT] = ACTIONS(861),
    [anon_sym_COLON] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym_word] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(863),
    [anon_sym_COLON_DASH] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
  },
  [950] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [ts_builtin_sym_end] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [951] = {
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1206),
    [anon_sym_COLON_QMARK] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1206),
    [anon_sym_EQ] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1206),
    [anon_sym_PERCENT] = ACTIONS(1204),
    [anon_sym_COLON] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_word] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1206),
    [anon_sym_COLON_DASH] = ACTIONS(1204),
    [sym__special_character] = ACTIONS(1204),
  },
  [952] = {
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [anon_sym_COLON_QMARK] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [anon_sym_PERCENT] = ACTIONS(1261),
    [anon_sym_COLON] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_word] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1263),
    [anon_sym_COLON_DASH] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
  },
  [953] = {
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_raw_string] = ACTIONS(1273),
    [anon_sym_COLON_QMARK] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1271),
    [anon_sym_COLON] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [sym_word] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1273),
    [anon_sym_COLON_DASH] = ACTIONS(1271),
    [sym__special_character] = ACTIONS(1271),
  },
  [954] = {
    [sym_string] = STATE(936),
    [anon_sym__] = ACTIONS(2664),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2666),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2666),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2664),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2664),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2668),
    [anon_sym_BANG] = ACTIONS(2666),
    [sym_variable_name] = ACTIONS(1289),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2664),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2670),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2666),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [955] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [956] = {
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [sym_raw_string] = ACTIONS(1439),
    [anon_sym_COLON_QMARK] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1439),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1439),
    [anon_sym_PERCENT] = ACTIONS(1437),
    [anon_sym_COLON] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_word] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1439),
    [anon_sym_COLON_DASH] = ACTIONS(1437),
    [sym__special_character] = ACTIONS(1437),
  },
  [957] = {
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [sym_raw_string] = ACTIONS(1451),
    [anon_sym_COLON_QMARK] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [anon_sym_EQ] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
    [anon_sym_PERCENT] = ACTIONS(1449),
    [anon_sym_COLON] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_word] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1451),
    [anon_sym_COLON_DASH] = ACTIONS(1449),
    [sym__special_character] = ACTIONS(1449),
  },
  [958] = {
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_raw_string] = ACTIONS(1461),
    [anon_sym_COLON_QMARK] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1461),
    [anon_sym_PERCENT] = ACTIONS(1459),
    [anon_sym_COLON] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [sym_word] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1461),
    [anon_sym_COLON_DASH] = ACTIONS(1459),
    [sym__special_character] = ACTIONS(1459),
  },
  [959] = {
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_raw_string] = ACTIONS(1465),
    [anon_sym_COLON_QMARK] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
    [anon_sym_PERCENT] = ACTIONS(1463),
    [anon_sym_COLON] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [sym_word] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1465),
    [anon_sym_COLON_DASH] = ACTIONS(1463),
    [sym__special_character] = ACTIONS(1463),
  },
  [960] = {
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_raw_string] = ACTIONS(1667),
    [anon_sym_COLON_QMARK] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1667),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1667),
    [anon_sym_PERCENT] = ACTIONS(1665),
    [anon_sym_COLON] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [anon_sym_DQUOTE] = ACTIONS(1667),
    [sym_word] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1667),
    [anon_sym_COLON_DASH] = ACTIONS(1665),
    [sym__special_character] = ACTIONS(1665),
  },
  [961] = {
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1673),
    [anon_sym_COLON_QMARK] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1673),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1673),
    [anon_sym_PERCENT] = ACTIONS(1671),
    [anon_sym_COLON] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [sym_word] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1673),
    [anon_sym_COLON_DASH] = ACTIONS(1671),
    [sym__special_character] = ACTIONS(1671),
  },
  [962] = {
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_raw_string] = ACTIONS(1677),
    [anon_sym_COLON_QMARK] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [anon_sym_EQ] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
    [anon_sym_PERCENT] = ACTIONS(1675),
    [anon_sym_COLON] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [sym_word] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1677),
    [anon_sym_COLON_DASH] = ACTIONS(1675),
    [sym__special_character] = ACTIONS(1675),
  },
  [963] = {
    [anon_sym_BQUOTE] = ACTIONS(1683),
    [sym_raw_string] = ACTIONS(1683),
    [anon_sym_COLON_QMARK] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1683),
    [anon_sym_PERCENT] = ACTIONS(1681),
    [anon_sym_COLON] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1683),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [sym_word] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1683),
    [anon_sym_COLON_DASH] = ACTIONS(1681),
    [sym__special_character] = ACTIONS(1681),
  },
  [964] = {
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1791),
    [anon_sym_COLON_QMARK] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1791),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1791),
    [anon_sym_PERCENT] = ACTIONS(1789),
    [anon_sym_COLON] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(1791),
    [sym_word] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1791),
    [anon_sym_COLON_DASH] = ACTIONS(1789),
    [sym__special_character] = ACTIONS(1789),
  },
  [965] = {
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [sym_raw_string] = ACTIONS(1795),
    [anon_sym_COLON_QMARK] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_RBRACE] = ACTIONS(1795),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1795),
    [anon_sym_EQ] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [anon_sym_PERCENT] = ACTIONS(1793),
    [anon_sym_COLON] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_word] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(1795),
    [anon_sym_COLON_DASH] = ACTIONS(1793),
    [sym__special_character] = ACTIONS(1793),
  },
  [966] = {
    [aux_sym_concatenation_repeat1] = STATE(2432),
    [anon_sym_RBRACK] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
  },
  [967] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [ts_builtin_sym_end] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [968] = {
    [anon_sym_BANG_EQ] = ACTIONS(405),
    [anon_sym_PLUS_EQ] = ACTIONS(405),
    [sym_test_operator] = ACTIONS(407),
    [anon_sym_LF] = ACTIONS(405),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_PLUS_PLUS] = ACTIONS(405),
    [anon_sym_DASH] = ACTIONS(405),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_EQ] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [anon_sym_GT_EQ] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_PLUS] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(405),
    [anon_sym_DASH_DASH] = ACTIONS(405),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_LT_EQ] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_DASH_EQ] = ACTIONS(405),
  },
  [969] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [ts_builtin_sym_end] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [970] = {
    [aux_sym_concatenation_repeat1] = STATE(980),
    [anon_sym_BANG_EQ] = ACTIONS(469),
    [anon_sym_PLUS_EQ] = ACTIONS(469),
    [sym_test_operator] = ACTIONS(473),
    [anon_sym_LF] = ACTIONS(469),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_PLUS_PLUS] = ACTIONS(469),
    [anon_sym_DASH] = ACTIONS(469),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_EQ] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_GT_EQ] = ACTIONS(469),
    [sym__concat] = ACTIONS(2672),
    [anon_sym_PLUS] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(469),
    [anon_sym_DASH_DASH] = ACTIONS(469),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_DASH_EQ] = ACTIONS(469),
  },
  [971] = {
    [anon_sym_BANG_EQ] = ACTIONS(583),
    [anon_sym_PLUS_EQ] = ACTIONS(583),
    [sym_test_operator] = ACTIONS(585),
    [anon_sym_LF] = ACTIONS(583),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_PLUS_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_EQ] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [anon_sym_GT_EQ] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(583),
    [anon_sym_DASH_DASH] = ACTIONS(583),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_LT_EQ] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_DASH_EQ] = ACTIONS(583),
  },
  [972] = {
    [anon_sym_RBRACK] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(201),
    [sym__special_character] = ACTIONS(199),
  },
  [973] = {
    [aux_sym__literal_repeat1] = STATE(973),
    [anon_sym_RBRACK] = ACTIONS(640),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(640),
    [sym__special_character] = ACTIONS(2674),
  },
  [974] = {
    [anon_sym_BANG_EQ] = ACTIONS(857),
    [anon_sym_PLUS_EQ] = ACTIONS(857),
    [sym_test_operator] = ACTIONS(859),
    [anon_sym_LF] = ACTIONS(857),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH] = ACTIONS(857),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_EQ] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_PLUS] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_LT_EQ] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_DASH_EQ] = ACTIONS(857),
  },
  [975] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [976] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [977] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [ts_builtin_sym_end] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [978] = {
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
  },
  [979] = {
    [sym_command_substitution] = STATE(978),
    [sym_simple_expansion] = STATE(978),
    [sym_string_expansion] = STATE(978),
    [sym_string] = STATE(978),
    [sym_process_substitution] = STATE(978),
    [sym_expansion] = STATE(978),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [sym_word] = ACTIONS(2677),
    [sym_raw_string] = ACTIONS(2677),
    [anon_sym_LT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR] = ACTIONS(2679),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [sym__special_character] = ACTIONS(2677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2341),
  },
  [980] = {
    [aux_sym_concatenation_repeat1] = STATE(980),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [sym_test_operator] = ACTIONS(941),
    [anon_sym_LF] = ACTIONS(939),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_PLUS_PLUS] = ACTIONS(939),
    [anon_sym_DASH] = ACTIONS(939),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [sym__concat] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_DASH_DASH] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
  },
  [981] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [982] = {
    [anon_sym_BANG_EQ] = ACTIONS(1042),
    [anon_sym_PLUS_EQ] = ACTIONS(1042),
    [sym_test_operator] = ACTIONS(1044),
    [anon_sym_LF] = ACTIONS(1042),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_PLUS_PLUS] = ACTIONS(1042),
    [anon_sym_DASH] = ACTIONS(1042),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_EQ] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [anon_sym_GT_EQ] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_PLUS] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1042),
    [anon_sym_DASH_DASH] = ACTIONS(1042),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_LT_EQ] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_DASH_EQ] = ACTIONS(1042),
  },
  [983] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [984] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [985] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [986] = {
    [sym_string] = STATE(808),
    [anon_sym_STAR] = ACTIONS(2572),
    [sym_raw_string] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_RBRACK] = ACTIONS(1289),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_0] = ACTIONS(2570),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym__concat] = ACTIONS(1289),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2566),
    [anon_sym__] = ACTIONS(2570),
  },
  [987] = {
    [anon_sym_BANG_EQ] = ACTIONS(1377),
    [anon_sym_PLUS_EQ] = ACTIONS(1377),
    [sym_test_operator] = ACTIONS(1379),
    [anon_sym_LF] = ACTIONS(1377),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_PLUS_PLUS] = ACTIONS(1377),
    [anon_sym_DASH] = ACTIONS(1377),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_EQ] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [anon_sym_GT_EQ] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_PLUS] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1377),
    [anon_sym_DASH_DASH] = ACTIONS(1377),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_LT_EQ] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_DASH_EQ] = ACTIONS(1377),
  },
  [988] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [989] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [990] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [991] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [992] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [993] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [ts_builtin_sym_end] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [994] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [995] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [996] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [997] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [ts_builtin_sym_end] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [998] = {
    [aux_sym_concatenation_repeat1] = STATE(970),
    [anon_sym_BANG_EQ] = ACTIONS(199),
    [anon_sym_PLUS_EQ] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_LF] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [anon_sym_GT_EQ] = ACTIONS(199),
    [sym__concat] = ACTIONS(2248),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [anon_sym_DASH_DASH] = ACTIONS(199),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_LT_EQ] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(199),
  },
  [999] = {
    [anon_sym_BANG_EQ] = ACTIONS(401),
    [anon_sym_PLUS_EQ] = ACTIONS(401),
    [sym_test_operator] = ACTIONS(403),
    [anon_sym_LF] = ACTIONS(401),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_PLUS_PLUS] = ACTIONS(401),
    [anon_sym_DASH] = ACTIONS(401),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_EQ] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [anon_sym_GT_EQ] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_PLUS] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(401),
    [anon_sym_DASH_DASH] = ACTIONS(401),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_LT_EQ] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_DASH_EQ] = ACTIONS(401),
  },
  [1000] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [ts_builtin_sym_end] = ACTIONS(407),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1001] = {
    [anon_sym_BANG_EQ] = ACTIONS(409),
    [anon_sym_PLUS_EQ] = ACTIONS(409),
    [sym_test_operator] = ACTIONS(411),
    [anon_sym_LF] = ACTIONS(409),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_PLUS_PLUS] = ACTIONS(409),
    [anon_sym_DASH] = ACTIONS(409),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_EQ] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [anon_sym_GT_EQ] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(409),
    [anon_sym_DASH_DASH] = ACTIONS(409),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_LT_EQ] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_DASH_EQ] = ACTIONS(409),
  },
  [1002] = {
    [aux_sym_concatenation_repeat1] = STATE(1012),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [ts_builtin_sym_end] = ACTIONS(473),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [sym__concat] = ACTIONS(2684),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1003] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [ts_builtin_sym_end] = ACTIONS(585),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1004] = {
    [anon_sym_BANG_EQ] = ACTIONS(199),
    [anon_sym_PLUS_EQ] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [sym_test_operator] = ACTIONS(201),
    [anon_sym_LF] = ACTIONS(199),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_PLUS_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_EQ] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [anon_sym_GT_EQ] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [anon_sym_DASH_DASH] = ACTIONS(199),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_LT_EQ] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_DASH_EQ] = ACTIONS(199),
  },
  [1005] = {
    [aux_sym__literal_repeat1] = STATE(1005),
    [anon_sym_BANG_EQ] = ACTIONS(635),
    [anon_sym_PLUS_EQ] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2686),
    [sym_test_operator] = ACTIONS(640),
    [anon_sym_LF] = ACTIONS(635),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_PLUS_PLUS] = ACTIONS(635),
    [anon_sym_DASH] = ACTIONS(635),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_EQ] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_GT_EQ] = ACTIONS(635),
    [anon_sym_PLUS] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(635),
    [anon_sym_DASH_DASH] = ACTIONS(635),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_LT_EQ] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_DASH_EQ] = ACTIONS(635),
  },
  [1006] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [ts_builtin_sym_end] = ACTIONS(859),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1007] = {
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
  },
  [1008] = {
    [anon_sym_BANG_EQ] = ACTIONS(879),
    [anon_sym_PLUS_EQ] = ACTIONS(879),
    [sym_test_operator] = ACTIONS(881),
    [anon_sym_LF] = ACTIONS(879),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_PLUS_PLUS] = ACTIONS(879),
    [anon_sym_DASH] = ACTIONS(879),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_EQ] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [anon_sym_GT_EQ] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_PLUS] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(879),
    [anon_sym_DASH_DASH] = ACTIONS(879),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_DASH_EQ] = ACTIONS(879),
  },
  [1009] = {
    [anon_sym_BANG_EQ] = ACTIONS(929),
    [anon_sym_PLUS_EQ] = ACTIONS(929),
    [sym_test_operator] = ACTIONS(931),
    [anon_sym_LF] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_PLUS_PLUS] = ACTIONS(929),
    [anon_sym_DASH] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(929),
    [anon_sym_DASH_DASH] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_DASH_EQ] = ACTIONS(929),
  },
  [1010] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1011] = {
    [sym_command_substitution] = STATE(1010),
    [sym_simple_expansion] = STATE(1010),
    [sym_string_expansion] = STATE(1010),
    [sym_string] = STATE(1010),
    [sym_process_substitution] = STATE(1010),
    [sym_expansion] = STATE(1010),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_word] = ACTIONS(2689),
    [sym_raw_string] = ACTIONS(2689),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(2691),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(664),
    [sym__special_character] = ACTIONS(2689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(668),
  },
  [1012] = {
    [aux_sym_concatenation_repeat1] = STATE(1012),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(941),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [sym__concat] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1013] = {
    [anon_sym_BANG_EQ] = ACTIONS(861),
    [anon_sym_PLUS_EQ] = ACTIONS(861),
    [sym_test_operator] = ACTIONS(863),
    [anon_sym_LF] = ACTIONS(861),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_PLUS_PLUS] = ACTIONS(861),
    [anon_sym_DASH] = ACTIONS(861),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_EQ] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [anon_sym_GT_EQ] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PLUS] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [anon_sym_DASH_DASH] = ACTIONS(861),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_LT_EQ] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_DASH_EQ] = ACTIONS(861),
  },
  [1014] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [ts_builtin_sym_end] = ACTIONS(1044),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1015] = {
    [anon_sym_BANG_EQ] = ACTIONS(1204),
    [anon_sym_PLUS_EQ] = ACTIONS(1204),
    [sym_test_operator] = ACTIONS(1206),
    [anon_sym_LF] = ACTIONS(1204),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_PLUS_PLUS] = ACTIONS(1204),
    [anon_sym_DASH] = ACTIONS(1204),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_EQ] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [anon_sym_GT_EQ] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_PLUS] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1204),
    [anon_sym_DASH_DASH] = ACTIONS(1204),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_LT_EQ] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_DASH_EQ] = ACTIONS(1204),
  },
  [1016] = {
    [anon_sym_BANG_EQ] = ACTIONS(1261),
    [anon_sym_PLUS_EQ] = ACTIONS(1261),
    [sym_test_operator] = ACTIONS(1263),
    [anon_sym_LF] = ACTIONS(1261),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_PLUS_PLUS] = ACTIONS(1261),
    [anon_sym_DASH] = ACTIONS(1261),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_EQ] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [anon_sym_GT_EQ] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1261),
    [anon_sym_DASH_DASH] = ACTIONS(1261),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_LT_EQ] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_DASH_EQ] = ACTIONS(1261),
  },
  [1017] = {
    [anon_sym_BANG_EQ] = ACTIONS(1271),
    [anon_sym_PLUS_EQ] = ACTIONS(1271),
    [sym_test_operator] = ACTIONS(1273),
    [anon_sym_LF] = ACTIONS(1271),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_PLUS_PLUS] = ACTIONS(1271),
    [anon_sym_DASH] = ACTIONS(1271),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_EQ] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [anon_sym_GT_EQ] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [anon_sym_DASH_DASH] = ACTIONS(1271),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_LT_EQ] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_DASH_EQ] = ACTIONS(1271),
  },
  [1018] = {
    [sym_string] = STATE(968),
    [sym_test_operator] = ACTIONS(1289),
    [anon_sym_PLUS_EQ] = ACTIONS(1285),
    [anon_sym_PLUS_PLUS] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2696),
    [anon_sym_DASH] = ACTIONS(2696),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [anon_sym_DASH_DASH] = ACTIONS(1285),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_DASH_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2698),
    [anon_sym_LF] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2700),
    [anon_sym_BANG] = ACTIONS(2696),
    [anon_sym_0] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2696),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym__] = ACTIONS(2698),
  },
  [1019] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [ts_builtin_sym_end] = ACTIONS(1379),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1020] = {
    [anon_sym_BANG_EQ] = ACTIONS(1437),
    [anon_sym_PLUS_EQ] = ACTIONS(1437),
    [sym_test_operator] = ACTIONS(1439),
    [anon_sym_LF] = ACTIONS(1437),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_PLUS_PLUS] = ACTIONS(1437),
    [anon_sym_DASH] = ACTIONS(1437),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_EQ] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [anon_sym_GT_EQ] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_PLUS] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [anon_sym_DASH_DASH] = ACTIONS(1437),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_LT_EQ] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_DASH_EQ] = ACTIONS(1437),
  },
  [1021] = {
    [anon_sym_BANG_EQ] = ACTIONS(1449),
    [anon_sym_PLUS_EQ] = ACTIONS(1449),
    [sym_test_operator] = ACTIONS(1451),
    [anon_sym_LF] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_PLUS_PLUS] = ACTIONS(1449),
    [anon_sym_DASH] = ACTIONS(1449),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [anon_sym_GT_EQ] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_PLUS] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [anon_sym_DASH_DASH] = ACTIONS(1449),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_LT_EQ] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_DASH_EQ] = ACTIONS(1449),
  },
  [1022] = {
    [anon_sym_BANG_EQ] = ACTIONS(1459),
    [anon_sym_PLUS_EQ] = ACTIONS(1459),
    [sym_test_operator] = ACTIONS(1461),
    [anon_sym_LF] = ACTIONS(1459),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH] = ACTIONS(1459),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_EQ] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [anon_sym_GT_EQ] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_PLUS] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_LT_EQ] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_DASH_EQ] = ACTIONS(1459),
  },
  [1023] = {
    [anon_sym_BANG_EQ] = ACTIONS(1463),
    [anon_sym_PLUS_EQ] = ACTIONS(1463),
    [sym_test_operator] = ACTIONS(1465),
    [anon_sym_LF] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_PLUS_PLUS] = ACTIONS(1463),
    [anon_sym_DASH] = ACTIONS(1463),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_EQ] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [anon_sym_GT_EQ] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_PLUS] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1463),
    [anon_sym_DASH_DASH] = ACTIONS(1463),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_LT_EQ] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_DASH_EQ] = ACTIONS(1463),
  },
  [1024] = {
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_PLUS_EQ] = ACTIONS(1665),
    [sym_test_operator] = ACTIONS(1667),
    [anon_sym_LF] = ACTIONS(1665),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_PLUS_PLUS] = ACTIONS(1665),
    [anon_sym_DASH] = ACTIONS(1665),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_GT_EQ] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_PLUS] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_DASH_DASH] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_DASH_EQ] = ACTIONS(1665),
  },
  [1025] = {
    [anon_sym_BANG_EQ] = ACTIONS(1671),
    [anon_sym_PLUS_EQ] = ACTIONS(1671),
    [sym_test_operator] = ACTIONS(1673),
    [anon_sym_LF] = ACTIONS(1671),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_PLUS_PLUS] = ACTIONS(1671),
    [anon_sym_DASH] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_EQ] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [anon_sym_DASH_DASH] = ACTIONS(1671),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_LT_EQ] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_DASH_EQ] = ACTIONS(1671),
  },
  [1026] = {
    [anon_sym_BANG_EQ] = ACTIONS(1675),
    [anon_sym_PLUS_EQ] = ACTIONS(1675),
    [sym_test_operator] = ACTIONS(1677),
    [anon_sym_LF] = ACTIONS(1675),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_PLUS_PLUS] = ACTIONS(1675),
    [anon_sym_DASH] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_EQ] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [anon_sym_GT_EQ] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1675),
    [anon_sym_DASH_DASH] = ACTIONS(1675),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_LT_EQ] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_DASH_EQ] = ACTIONS(1675),
  },
  [1027] = {
    [anon_sym_BANG_EQ] = ACTIONS(1681),
    [anon_sym_PLUS_EQ] = ACTIONS(1681),
    [sym_test_operator] = ACTIONS(1683),
    [anon_sym_LF] = ACTIONS(1681),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_PLUS_PLUS] = ACTIONS(1681),
    [anon_sym_DASH] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_EQ] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [anon_sym_GT_EQ] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_PLUS] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [anon_sym_DASH_DASH] = ACTIONS(1681),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_LT_EQ] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_DASH_EQ] = ACTIONS(1681),
  },
  [1028] = {
    [anon_sym_BANG_EQ] = ACTIONS(1789),
    [anon_sym_PLUS_EQ] = ACTIONS(1789),
    [sym_test_operator] = ACTIONS(1791),
    [anon_sym_LF] = ACTIONS(1789),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_PLUS_PLUS] = ACTIONS(1789),
    [anon_sym_DASH] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_EQ] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_PLUS] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1789),
    [anon_sym_DASH_DASH] = ACTIONS(1789),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_DASH_EQ] = ACTIONS(1789),
  },
  [1029] = {
    [anon_sym_BANG_EQ] = ACTIONS(1793),
    [anon_sym_PLUS_EQ] = ACTIONS(1793),
    [sym_test_operator] = ACTIONS(1795),
    [anon_sym_LF] = ACTIONS(1793),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_PLUS_PLUS] = ACTIONS(1793),
    [anon_sym_DASH] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_EQ] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [anon_sym_GT_EQ] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_PLUS] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_EQ_TILDE] = ACTIONS(1793),
    [anon_sym_DASH_DASH] = ACTIONS(1793),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_LT_EQ] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_DASH_EQ] = ACTIONS(1793),
  },
  [1030] = {
    [aux_sym_concatenation_repeat1] = STATE(1002),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym__concat] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1031] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [ts_builtin_sym_end] = ACTIONS(403),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1032] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1033] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [ts_builtin_sym_end] = ACTIONS(411),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1034] = {
    [aux_sym_concatenation_repeat1] = STATE(1044),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2702),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1035] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1036] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [ts_builtin_sym_end] = ACTIONS(201),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1037] = {
    [aux_sym__literal_repeat1] = STATE(1037),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [ts_builtin_sym_end] = ACTIONS(640),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2704),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1038] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [anon_sym_RPAREN] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1039] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1040] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [ts_builtin_sym_end] = ACTIONS(881),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1041] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [ts_builtin_sym_end] = ACTIONS(931),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1042] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1043] = {
    [sym_command_substitution] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym_process_substitution] = STATE(1042),
    [sym_simple_expansion] = STATE(1042),
    [sym_string_expansion] = STATE(1042),
    [sym_expansion] = STATE(1042),
    [anon_sym_BQUOTE] = ACTIONS(2707),
    [sym_raw_string] = ACTIONS(2709),
    [anon_sym_DOLLAR] = ACTIONS(2711),
    [anon_sym_GT_LPAREN] = ACTIONS(2713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_word] = ACTIONS(2709),
    [anon_sym_LT_LPAREN] = ACTIONS(2713),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2709),
  },
  [1044] = {
    [aux_sym_concatenation_repeat1] = STATE(1044),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2721),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1045] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [ts_builtin_sym_end] = ACTIONS(863),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1046] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1047] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [ts_builtin_sym_end] = ACTIONS(1206),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1048] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [ts_builtin_sym_end] = ACTIONS(1263),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1049] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1050] = {
    [sym_string] = STATE(1000),
    [anon_sym__] = ACTIONS(2724),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2726),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2726),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2724),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2724),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2724),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2728),
    [anon_sym_BANG] = ACTIONS(2726),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2724),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [ts_builtin_sym_end] = ACTIONS(1289),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2730),
    [anon_sym_AT] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2726),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1051] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1052] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [ts_builtin_sym_end] = ACTIONS(1439),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1053] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [ts_builtin_sym_end] = ACTIONS(1451),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1054] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [ts_builtin_sym_end] = ACTIONS(1461),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1055] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [ts_builtin_sym_end] = ACTIONS(1465),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1056] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [ts_builtin_sym_end] = ACTIONS(1667),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1057] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [ts_builtin_sym_end] = ACTIONS(1673),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1058] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [ts_builtin_sym_end] = ACTIONS(1677),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1059] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [ts_builtin_sym_end] = ACTIONS(1683),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1060] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [ts_builtin_sym_end] = ACTIONS(1791),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1061] = {
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [ts_builtin_sym_end] = ACTIONS(1795),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1062] = {
    [aux_sym_concatenation_repeat1] = STATE(1034),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2091),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1063] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1064] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_esac] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1065] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1066] = {
    [aux_sym_concatenation_repeat1] = STATE(1076),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym__concat] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1067] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1068] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1069] = {
    [aux_sym__literal_repeat1] = STATE(1069),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2734),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1070] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_esac] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1071] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1072] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [anon_sym_RPAREN] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1073] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [anon_sym_RPAREN] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1074] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1075] = {
    [sym_command_substitution] = STATE(1074),
    [sym_string] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(2741),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(2739),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2739),
  },
  [1076] = {
    [aux_sym_concatenation_repeat1] = STATE(1076),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym__concat] = ACTIONS(2751),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1077] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1078] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_esac] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1079] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1080] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1081] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1082] = {
    [sym_string] = STATE(1032),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2754),
    [anon_sym_DASH] = ACTIONS(2754),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2756),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2756),
    [sym_raw_string] = ACTIONS(2758),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_variable_name] = ACTIONS(1289),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2760),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2756),
    [anon_sym_POUND] = ACTIONS(2754),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2756),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_BANG] = ACTIONS(2754),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2756),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [sym_comment] = ACTIONS(3),
    [anon_sym__] = ACTIONS(2756),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1083] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_esac] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1084] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1085] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1086] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1087] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1088] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1089] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1090] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1091] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1092] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1093] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1094] = {
    [aux_sym_concatenation_repeat1] = STATE(1066),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1095] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_esac] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1096] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(407),
    [sym__concat] = ACTIONS(407),
  },
  [1097] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_RPAREN] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_esac] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1098] = {
    [aux_sym_concatenation_repeat1] = STATE(1108),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(473),
    [sym__concat] = ACTIONS(2762),
  },
  [1099] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(585),
    [sym__concat] = ACTIONS(585),
  },
  [1100] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1101] = {
    [aux_sym__literal_repeat1] = STATE(1101),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2764),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_esac] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1102] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(859),
    [sym__concat] = ACTIONS(859),
  },
  [1103] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1104] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_esac] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1105] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_esac] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1106] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
  },
  [1107] = {
    [sym_command_substitution] = STATE(1106),
    [sym_simple_expansion] = STATE(1106),
    [sym_string_expansion] = STATE(1106),
    [sym_string] = STATE(1106),
    [sym_process_substitution] = STATE(1106),
    [sym_expansion] = STATE(1106),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(2767),
    [sym_raw_string] = ACTIONS(2767),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(2769),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1108] = {
    [aux_sym_concatenation_repeat1] = STATE(1108),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(941),
    [sym__concat] = ACTIONS(2771),
  },
  [1109] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1110] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1044),
    [sym__concat] = ACTIONS(1044),
  },
  [1111] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_RPAREN] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_esac] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1112] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_esac] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1113] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_RPAREN] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1114] = {
    [sym_string] = STATE(1064),
    [anon_sym__] = ACTIONS(2774),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2776),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2776),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2776),
    [anon_sym_RPAREN] = ACTIONS(1285),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_0] = ACTIONS(2774),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2780),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2776),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1115] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1379),
    [sym__concat] = ACTIONS(1379),
  },
  [1116] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_esac] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1117] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_esac] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1118] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_RPAREN] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_esac] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1119] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_RPAREN] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_esac] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1120] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_esac] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1121] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1122] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_RPAREN] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_esac] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1123] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_esac] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1124] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_RPAREN] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_esac] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1125] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_esac] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1126] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(201),
    [sym__concat] = ACTIONS(1265),
    [sym__special_character] = ACTIONS(199),
  },
  [1127] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
  },
  [1128] = {
    [anon_sym_BQUOTE] = ACTIONS(407),
    [anon_sym_DQUOTE] = ACTIONS(407),
    [sym_word] = ACTIONS(407),
    [sym_raw_string] = ACTIONS(407),
    [sym__concat] = ACTIONS(407),
    [anon_sym_LT_LPAREN] = ACTIONS(407),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_RPAREN] = ACTIONS(407),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(407),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(407),
    [sym__special_character] = ACTIONS(407),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(407),
  },
  [1129] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
  },
  [1130] = {
    [aux_sym_concatenation_repeat1] = STATE(1140),
    [anon_sym_BQUOTE] = ACTIONS(473),
    [anon_sym_DQUOTE] = ACTIONS(473),
    [sym_word] = ACTIONS(473),
    [sym_raw_string] = ACTIONS(473),
    [sym__concat] = ACTIONS(2782),
    [anon_sym_LT_LPAREN] = ACTIONS(473),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_RPAREN] = ACTIONS(473),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(473),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(473),
    [sym__special_character] = ACTIONS(473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(473),
  },
  [1131] = {
    [anon_sym_BQUOTE] = ACTIONS(585),
    [anon_sym_DQUOTE] = ACTIONS(585),
    [sym_word] = ACTIONS(585),
    [sym_raw_string] = ACTIONS(585),
    [sym__concat] = ACTIONS(585),
    [anon_sym_LT_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_RPAREN] = ACTIONS(585),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(585),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(585),
    [sym__special_character] = ACTIONS(585),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(585),
  },
  [1132] = {
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_RBRACE] = ACTIONS(201),
  },
  [1133] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2784),
    [anon_sym_RBRACE] = ACTIONS(640),
  },
  [1134] = {
    [anon_sym_BQUOTE] = ACTIONS(859),
    [anon_sym_DQUOTE] = ACTIONS(859),
    [sym_word] = ACTIONS(859),
    [sym_raw_string] = ACTIONS(859),
    [sym__concat] = ACTIONS(859),
    [anon_sym_LT_LPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_RPAREN] = ACTIONS(859),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(859),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(859),
    [sym__special_character] = ACTIONS(859),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(859),
  },
  [1135] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
  },
  [1136] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
  },
  [1137] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
  },
  [1138] = {
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [sym__concat] = ACTIONS(941),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [sym__special_character] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
  },
  [1139] = {
    [sym_command_substitution] = STATE(1138),
    [sym_simple_expansion] = STATE(1138),
    [sym_string_expansion] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_process_substitution] = STATE(1138),
    [sym_expansion] = STATE(1138),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(2787),
    [sym_raw_string] = ACTIONS(2787),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(2789),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(2787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1140] = {
    [aux_sym_concatenation_repeat1] = STATE(1140),
    [anon_sym_BQUOTE] = ACTIONS(941),
    [anon_sym_DQUOTE] = ACTIONS(941),
    [sym_word] = ACTIONS(941),
    [sym_raw_string] = ACTIONS(941),
    [sym__concat] = ACTIONS(2791),
    [anon_sym_LT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(941),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(941),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(941),
    [sym__special_character] = ACTIONS(941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(941),
  },
  [1141] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
  },
  [1142] = {
    [anon_sym_BQUOTE] = ACTIONS(1044),
    [anon_sym_DQUOTE] = ACTIONS(1044),
    [sym_word] = ACTIONS(1044),
    [sym_raw_string] = ACTIONS(1044),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_LT_LPAREN] = ACTIONS(1044),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_RPAREN] = ACTIONS(1044),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1044),
  },
  [1143] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
  },
  [1144] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
  },
  [1145] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
  },
  [1146] = {
    [sym_string] = STATE(1096),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [anon_sym_QMARK] = ACTIONS(2794),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_POUND] = ACTIONS(2798),
    [anon_sym_RBRACE] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_0] = ACTIONS(2800),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2800),
    [anon_sym__] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
  },
  [1147] = {
    [anon_sym_BQUOTE] = ACTIONS(1379),
    [anon_sym_DQUOTE] = ACTIONS(1379),
    [sym_word] = ACTIONS(1379),
    [sym_raw_string] = ACTIONS(1379),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_LT_LPAREN] = ACTIONS(1379),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_RPAREN] = ACTIONS(1379),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1379),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1379),
  },
  [1148] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
  },
  [1149] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
  },
  [1150] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
  },
  [1151] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
  },
  [1152] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
  },
  [1153] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
  },
  [1154] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
  },
  [1155] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
  },
  [1156] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
  },
  [1157] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
  },
  [1158] = {
    [aux_sym_concatenation_repeat1] = STATE(1130),
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [sym_word] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [sym__concat] = ACTIONS(1341),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [sym__special_character] = ACTIONS(201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
  },
  [1159] = {
    [anon_sym_BQUOTE] = ACTIONS(403),
    [anon_sym_DQUOTE] = ACTIONS(403),
    [sym_word] = ACTIONS(403),
    [sym_raw_string] = ACTIONS(403),
    [sym__concat] = ACTIONS(403),
    [anon_sym_LT_LPAREN] = ACTIONS(403),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_RPAREN] = ACTIONS(403),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(403),
    [sym__special_character] = ACTIONS(403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(403),
  },
  [1160] = {
    [anon_sym_BQUOTE] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
  },
  [1161] = {
    [anon_sym_BQUOTE] = ACTIONS(411),
    [anon_sym_DQUOTE] = ACTIONS(411),
    [sym_word] = ACTIONS(411),
    [sym_raw_string] = ACTIONS(411),
    [sym__concat] = ACTIONS(411),
    [anon_sym_LT_LPAREN] = ACTIONS(411),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_RPAREN] = ACTIONS(411),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [sym__special_character] = ACTIONS(411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
  },
  [1162] = {
    [aux_sym_concatenation_repeat1] = STATE(1172),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [sym__concat] = ACTIONS(2802),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
  },
  [1163] = {
    [anon_sym_BQUOTE] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
  },
  [1164] = {
    [anon_sym_BQUOTE] = ACTIONS(201),
    [anon_sym_DQUOTE] = ACTIONS(201),
    [sym_word] = ACTIONS(201),
    [sym_raw_string] = ACTIONS(201),
    [anon_sym_LT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_RPAREN] = ACTIONS(201),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(201),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(201),
    [sym__special_character] = ACTIONS(201),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(201),
  },
  [1165] = {
    [aux_sym__literal_repeat1] = STATE(1165),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_DQUOTE] = ACTIONS(640),
    [sym_word] = ACTIONS(640),
    [sym_raw_string] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(640),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_RPAREN] = ACTIONS(640),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(640),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(640),
    [sym__special_character] = ACTIONS(2804),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(640),
  },
  [1166] = {
    [anon_sym_BQUOTE] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
  },
  [1167] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym_word] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [sym__special_character] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
  },
  [1168] = {
    [anon_sym_BQUOTE] = ACTIONS(881),
    [anon_sym_DQUOTE] = ACTIONS(881),
    [sym_word] = ACTIONS(881),
    [sym_raw_string] = ACTIONS(881),
    [sym__concat] = ACTIONS(881),
    [anon_sym_LT_LPAREN] = ACTIONS(881),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_RPAREN] = ACTIONS(881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(881),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(881),
    [sym__special_character] = ACTIONS(881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(881),
  },
  [1169] = {
    [anon_sym_BQUOTE] = ACTIONS(931),
    [anon_sym_DQUOTE] = ACTIONS(931),
    [sym_word] = ACTIONS(931),
    [sym_raw_string] = ACTIONS(931),
    [sym__concat] = ACTIONS(931),
    [anon_sym_LT_LPAREN] = ACTIONS(931),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_RPAREN] = ACTIONS(931),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [sym__special_character] = ACTIONS(931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
  },
  [1170] = {
    [anon_sym_BQUOTE] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [1171] = {
    [sym_command_substitution] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_string] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_word] = ACTIONS(2807),
    [sym_raw_string] = ACTIONS(2807),
    [anon_sym_LT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(2809),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [sym__special_character] = ACTIONS(2807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
  },
  [1172] = {
    [aux_sym_concatenation_repeat1] = STATE(1172),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [sym__concat] = ACTIONS(2811),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
  },
  [1173] = {
    [anon_sym_BQUOTE] = ACTIONS(863),
    [anon_sym_DQUOTE] = ACTIONS(863),
    [sym_word] = ACTIONS(863),
    [sym_raw_string] = ACTIONS(863),
    [sym__concat] = ACTIONS(863),
    [anon_sym_LT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_RPAREN] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(863),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [sym__special_character] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
  },
  [1174] = {
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
  },
  [1175] = {
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [anon_sym_DQUOTE] = ACTIONS(1206),
    [sym_word] = ACTIONS(1206),
    [sym_raw_string] = ACTIONS(1206),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_LT_LPAREN] = ACTIONS(1206),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_RPAREN] = ACTIONS(1206),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1206),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1206),
  },
  [1176] = {
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [anon_sym_DQUOTE] = ACTIONS(1263),
    [sym_word] = ACTIONS(1263),
    [sym_raw_string] = ACTIONS(1263),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_LT_LPAREN] = ACTIONS(1263),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_RPAREN] = ACTIONS(1263),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1263),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
  },
  [1177] = {
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [anon_sym_DQUOTE] = ACTIONS(1273),
    [sym_word] = ACTIONS(1273),
    [sym_raw_string] = ACTIONS(1273),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_LT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1273),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1273),
  },
  [1178] = {
    [sym_string] = STATE(1128),
    [anon_sym_BQUOTE] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(2814),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2818),
    [anon_sym_DOLLAR] = ACTIONS(2818),
    [anon_sym_RPAREN] = ACTIONS(1289),
    [anon_sym_DASH] = ACTIONS(2818),
    [anon_sym_GT_LPAREN] = ACTIONS(1289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2814),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1289),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2814),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2814),
    [anon_sym_LT_LPAREN] = ACTIONS(1289),
    [anon_sym_AT] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2820),
    [sym__special_character] = ACTIONS(1289),
    [anon_sym__] = ACTIONS(2814),
  },
  [1179] = {
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
  },
  [1180] = {
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [anon_sym_DQUOTE] = ACTIONS(1439),
    [sym_word] = ACTIONS(1439),
    [sym_raw_string] = ACTIONS(1439),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_LT_LPAREN] = ACTIONS(1439),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_RPAREN] = ACTIONS(1439),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1439),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1439),
  },
  [1181] = {
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [anon_sym_DQUOTE] = ACTIONS(1451),
    [sym_word] = ACTIONS(1451),
    [sym_raw_string] = ACTIONS(1451),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_LT_LPAREN] = ACTIONS(1451),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_RPAREN] = ACTIONS(1451),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1451),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
  },
  [1182] = {
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [anon_sym_DQUOTE] = ACTIONS(1461),
    [sym_word] = ACTIONS(1461),
    [sym_raw_string] = ACTIONS(1461),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_LT_LPAREN] = ACTIONS(1461),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_RPAREN] = ACTIONS(1461),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1461),
  },
  [1183] = {
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [anon_sym_DQUOTE] = ACTIONS(1465),
    [sym_word] = ACTIONS(1465),
    [sym_raw_string] = ACTIONS(1465),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_LT_LPAREN] = ACTIONS(1465),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_RPAREN] = ACTIONS(1465),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1465),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
  },
  [1184] = {
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [anon_sym_DQUOTE] = ACTIONS(1667),
    [sym_word] = ACTIONS(1667),
    [sym_raw_string] = ACTIONS(1667),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_LT_LPAREN] = ACTIONS(1667),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_RPAREN] = ACTIONS(1667),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1667),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1667),
  },
  [1185] = {
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [anon_sym_DQUOTE] = ACTIONS(1673),
    [sym_word] = ACTIONS(1673),
    [sym_raw_string] = ACTIONS(1673),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_LT_LPAREN] = ACTIONS(1673),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_RPAREN] = ACTIONS(1673),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1673),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1673),
  },
  [1186] = {
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [anon_sym_DQUOTE] = ACTIONS(1677),
    [sym_word] = ACTIONS(1677),
    [sym_raw_string] = ACTIONS(1677),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_LT_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_RPAREN] = ACTIONS(1677),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1677),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
  },
  [1187] = {
    [anon_sym_BQUOTE] = ACTIONS(1683),
    [anon_sym_DQUOTE] = ACTIONS(1683),
    [sym_word] = ACTIONS(1683),
    [sym_raw_string] = ACTIONS(1683),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_LT_LPAREN] = ACTIONS(1683),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_RPAREN] = ACTIONS(1683),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1683),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1683),
  },
  [1188] = {
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [anon_sym_DQUOTE] = ACTIONS(1791),
    [sym_word] = ACTIONS(1791),
    [sym_raw_string] = ACTIONS(1791),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_LT_LPAREN] = ACTIONS(1791),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_RPAREN] = ACTIONS(1791),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1791),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1791),
  },
  [1189] = {
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [anon_sym_DQUOTE] = ACTIONS(1795),
    [sym_word] = ACTIONS(1795),
    [sym_raw_string] = ACTIONS(1795),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_LT_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_RPAREN] = ACTIONS(1795),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1795),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
  },
  [1190] = {
    [aux_sym_concatenation_repeat1] = STATE(1162),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [sym__concat] = ACTIONS(2150),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
  },
  [1191] = {
    [anon_sym_BQUOTE] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
  },
  [1192] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [anon_sym_EQ_TILDE] = ACTIONS(405),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_EQ_EQ] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_esac] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1193] = {
    [anon_sym_BQUOTE] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
  },
  [1194] = {
    [aux_sym_concatenation_repeat1] = STATE(1204),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2822),
    [anon_sym_EQ_TILDE] = ACTIONS(469),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_EQ_EQ] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1195] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [anon_sym_EQ_TILDE] = ACTIONS(583),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_EQ_EQ] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1196] = {
    [anon_sym_BQUOTE] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
  },
  [1197] = {
    [aux_sym__literal_repeat1] = STATE(1197),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(2824),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
  },
  [1198] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [anon_sym_EQ_TILDE] = ACTIONS(857),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_EQ_EQ] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_esac] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1199] = {
    [anon_sym_BQUOTE] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
  },
  [1200] = {
    [anon_sym_BQUOTE] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
  },
  [1201] = {
    [anon_sym_BQUOTE] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
  },
  [1202] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1203] = {
    [sym_command_substitution] = STATE(1202),
    [sym_simple_expansion] = STATE(1202),
    [sym_string_expansion] = STATE(1202),
    [sym_string] = STATE(1202),
    [sym_process_substitution] = STATE(1202),
    [sym_expansion] = STATE(1202),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [sym_word] = ACTIONS(2827),
    [sym_raw_string] = ACTIONS(2827),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(2829),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [sym__special_character] = ACTIONS(2827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
  },
  [1204] = {
    [aux_sym_concatenation_repeat1] = STATE(1204),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2831),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1205] = {
    [anon_sym_BQUOTE] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
  },
  [1206] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [anon_sym_EQ_TILDE] = ACTIONS(1042),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_EQ_EQ] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [anon_sym_esac] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1207] = {
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
  },
  [1208] = {
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
  },
  [1209] = {
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
  },
  [1210] = {
    [sym_string] = STATE(1160),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2834),
    [sym_raw_string] = ACTIONS(2836),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [anon_sym_BANG] = ACTIONS(2838),
    [anon_sym_DOLLAR] = ACTIONS(2838),
    [anon_sym_0] = ACTIONS(2834),
    [anon_sym_DASH] = ACTIONS(2838),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_word] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2834),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2838),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym__] = ACTIONS(2834),
  },
  [1211] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [anon_sym_EQ_TILDE] = ACTIONS(1377),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [anon_sym_esac] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1212] = {
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
  },
  [1213] = {
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
  },
  [1214] = {
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
  },
  [1215] = {
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
  },
  [1216] = {
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
  },
  [1217] = {
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
  },
  [1218] = {
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
  },
  [1219] = {
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
  },
  [1220] = {
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
  },
  [1221] = {
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
  },
  [1222] = {
    [aux_sym_concatenation_repeat1] = STATE(1194),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2210),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1223] = {
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(403),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(403),
    [sym__heredoc_body_end] = ACTIONS(403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(403),
    [sym__heredoc_body_middle] = ACTIONS(403),
  },
  [1224] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_esac] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1225] = {
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(411),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(411),
    [sym__heredoc_body_end] = ACTIONS(411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(411),
    [sym__heredoc_body_middle] = ACTIONS(411),
  },
  [1226] = {
    [aux_sym_concatenation_repeat1] = STATE(1236),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2840),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1227] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1228] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_EQ_TILDE] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_EQ_EQ] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1229] = {
    [aux_sym__literal_repeat1] = STATE(1229),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [anon_sym_EQ_TILDE] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2842),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_EQ_EQ] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_esac] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1230] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_esac] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1231] = {
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [sym__heredoc_body_end] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [sym__heredoc_body_middle] = ACTIONS(863),
  },
  [1232] = {
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(881),
    [sym__heredoc_body_end] = ACTIONS(881),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(881),
    [sym__heredoc_body_middle] = ACTIONS(881),
  },
  [1233] = {
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(931),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(931),
    [sym__heredoc_body_end] = ACTIONS(931),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(931),
    [sym__heredoc_body_middle] = ACTIONS(931),
  },
  [1234] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1235] = {
    [sym_command_substitution] = STATE(1234),
    [sym_simple_expansion] = STATE(1234),
    [sym_string_expansion] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_process_substitution] = STATE(1234),
    [sym_expansion] = STATE(1234),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [sym_word] = ACTIONS(2849),
    [sym_raw_string] = ACTIONS(2849),
    [anon_sym_LT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR] = ACTIONS(2853),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [sym__special_character] = ACTIONS(2849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
  },
  [1236] = {
    [aux_sym_concatenation_repeat1] = STATE(1236),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2859),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1237] = {
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(863),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(863),
    [sym__heredoc_body_end] = ACTIONS(863),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(863),
    [sym__heredoc_body_middle] = ACTIONS(863),
  },
  [1238] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [anon_sym_esac] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1239] = {
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1206),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1206),
    [sym__heredoc_body_end] = ACTIONS(1206),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1206),
    [sym__heredoc_body_middle] = ACTIONS(1206),
  },
  [1240] = {
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1263),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1263),
    [sym__heredoc_body_end] = ACTIONS(1263),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1263),
    [sym__heredoc_body_middle] = ACTIONS(1263),
  },
  [1241] = {
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1273),
    [sym__heredoc_body_end] = ACTIONS(1273),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1273),
    [sym__heredoc_body_middle] = ACTIONS(1273),
  },
  [1242] = {
    [sym_string] = STATE(1192),
    [anon_sym__] = ACTIONS(2862),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2864),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2864),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2862),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2862),
    [anon_sym_EQ_TILDE] = ACTIONS(1285),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2862),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2864),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2862),
    [anon_sym_POUND] = ACTIONS(2864),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1243] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [anon_sym_esac] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1244] = {
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1439),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1439),
    [sym__heredoc_body_end] = ACTIONS(1439),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1439),
    [sym__heredoc_body_middle] = ACTIONS(1439),
  },
  [1245] = {
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1451),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1451),
    [sym__heredoc_body_end] = ACTIONS(1451),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1451),
    [sym__heredoc_body_middle] = ACTIONS(1451),
  },
  [1246] = {
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1461),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1461),
    [sym__heredoc_body_end] = ACTIONS(1461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1461),
    [sym__heredoc_body_middle] = ACTIONS(1461),
  },
  [1247] = {
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1465),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1465),
    [sym__heredoc_body_end] = ACTIONS(1465),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1465),
    [sym__heredoc_body_middle] = ACTIONS(1465),
  },
  [1248] = {
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1667),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1667),
    [sym__heredoc_body_end] = ACTIONS(1667),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1667),
    [sym__heredoc_body_middle] = ACTIONS(1667),
  },
  [1249] = {
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1673),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1673),
    [sym__heredoc_body_end] = ACTIONS(1673),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1673),
    [sym__heredoc_body_middle] = ACTIONS(1673),
  },
  [1250] = {
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1677),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1677),
    [sym__heredoc_body_end] = ACTIONS(1677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1677),
    [sym__heredoc_body_middle] = ACTIONS(1677),
  },
  [1251] = {
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1683),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1683),
    [sym__heredoc_body_end] = ACTIONS(1683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1683),
    [sym__heredoc_body_middle] = ACTIONS(1683),
  },
  [1252] = {
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1791),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1791),
    [sym__heredoc_body_end] = ACTIONS(1791),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1791),
    [sym__heredoc_body_middle] = ACTIONS(1791),
  },
  [1253] = {
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1795),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1795),
    [sym__heredoc_body_end] = ACTIONS(1795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1795),
    [sym__heredoc_body_middle] = ACTIONS(1795),
  },
  [1254] = {
    [aux_sym_concatenation_repeat1] = STATE(1226),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2238),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1255] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [anon_sym_EQ_TILDE] = ACTIONS(401),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_EQ_EQ] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [anon_sym_esac] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1256] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [aux_sym__simple_variable_name_token1] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_esac] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1257] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [anon_sym_EQ_TILDE] = ACTIONS(409),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_EQ_EQ] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [anon_sym_esac] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1258] = {
    [aux_sym_concatenation_repeat1] = STATE(1268),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [aux_sym__simple_variable_name_token1] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2868),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1259] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [aux_sym__simple_variable_name_token1] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1260] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1261] = {
    [aux_sym__literal_repeat1] = STATE(1261),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2870),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_esac] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1262] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [aux_sym__simple_variable_name_token1] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_esac] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1263] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1264] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [anon_sym_EQ_TILDE] = ACTIONS(879),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_EQ_EQ] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_esac] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1265] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [anon_sym_EQ_TILDE] = ACTIONS(929),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [anon_sym_esac] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1266] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1267] = {
    [sym_command_substitution] = STATE(1266),
    [sym_simple_expansion] = STATE(1266),
    [sym_string_expansion] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_process_substitution] = STATE(1266),
    [sym_expansion] = STATE(1266),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [sym_word] = ACTIONS(2877),
    [sym_raw_string] = ACTIONS(2877),
    [anon_sym_LT_LPAREN] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [sym__special_character] = ACTIONS(2877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2885),
  },
  [1268] = {
    [aux_sym_concatenation_repeat1] = STATE(1268),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [aux_sym__simple_variable_name_token1] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2887),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1269] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [anon_sym_EQ_TILDE] = ACTIONS(861),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_EQ_EQ] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1270] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [anon_sym_esac] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1271] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [anon_sym_EQ_TILDE] = ACTIONS(1204),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_EQ_EQ] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_esac] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1272] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [anon_sym_EQ_TILDE] = ACTIONS(1261),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_EQ_EQ] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_esac] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1273] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1271),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_EQ_EQ] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1274] = {
    [sym_string] = STATE(1224),
    [anon_sym__] = ACTIONS(2890),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2890),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2890),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2890),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2894),
    [anon_sym_BANG] = ACTIONS(2892),
    [sym_variable_name] = ACTIONS(1289),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2406),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2890),
    [anon_sym_POUND] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1275] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [anon_sym_esac] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1276] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [anon_sym_EQ_TILDE] = ACTIONS(1437),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_EQ_EQ] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [anon_sym_esac] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1277] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [anon_sym_EQ_TILDE] = ACTIONS(1449),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_EQ_EQ] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [anon_sym_esac] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1278] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [anon_sym_EQ_TILDE] = ACTIONS(1459),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_EQ_EQ] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_esac] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1279] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [anon_sym_EQ_TILDE] = ACTIONS(1463),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_EQ_EQ] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [anon_sym_esac] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1280] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_EQ_EQ] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [anon_sym_esac] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1281] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [anon_sym_EQ_TILDE] = ACTIONS(1671),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_EQ_EQ] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1282] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [anon_sym_EQ_TILDE] = ACTIONS(1675),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_EQ_EQ] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [anon_sym_esac] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1283] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [anon_sym_EQ_TILDE] = ACTIONS(1681),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_EQ_EQ] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [anon_sym_esac] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1284] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [anon_sym_EQ_TILDE] = ACTIONS(1789),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_EQ_EQ] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [anon_sym_esac] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1285] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [anon_sym_EQ_TILDE] = ACTIONS(1793),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_EQ_EQ] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [anon_sym_esac] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1286] = {
    [aux_sym_concatenation_repeat1] = STATE(1258),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2242),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1287] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [anon_sym_esac] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1288] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(405),
    [anon_sym_DOLLAR] = ACTIONS(405),
    [anon_sym_LT_LT] = ACTIONS(405),
    [anon_sym_GT_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(405),
    [anon_sym_PIPE_PIPE] = ACTIONS(405),
    [sym_word] = ACTIONS(405),
    [anon_sym_PIPE] = ACTIONS(405),
    [anon_sym_AMP] = ACTIONS(405),
    [anon_sym_LT] = ACTIONS(405),
    [anon_sym_LT_AMP] = ACTIONS(405),
    [anon_sym_GT_GT] = ACTIONS(405),
    [sym__concat] = ACTIONS(407),
    [sym__special_character] = ACTIONS(405),
    [anon_sym_LT_LT_DASH] = ACTIONS(405),
    [anon_sym_BQUOTE] = ACTIONS(405),
    [anon_sym_LF] = ACTIONS(407),
    [anon_sym_SEMI] = ACTIONS(405),
    [sym_raw_string] = ACTIONS(405),
    [sym_variable_name] = ACTIONS(407),
    [sym_file_descriptor] = ACTIONS(407),
    [anon_sym_GT] = ACTIONS(405),
    [anon_sym_AMP_GT] = ACTIONS(405),
    [anon_sym_DQUOTE] = ACTIONS(405),
    [anon_sym_LT_LT_LT] = ACTIONS(405),
    [anon_sym_GT_AMP] = ACTIONS(405),
    [anon_sym_LT_LPAREN] = ACTIONS(405),
    [anon_sym_esac] = ACTIONS(405),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(405),
    [anon_sym_SEMI_SEMI] = ACTIONS(405),
    [anon_sym_PIPE_AMP] = ACTIONS(405),
  },
  [1289] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [anon_sym_esac] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1290] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_DOLLAR] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [anon_sym_GT_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [sym_word] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [sym__concat] = ACTIONS(2896),
    [sym__special_character] = ACTIONS(469),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_BQUOTE] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [sym_raw_string] = ACTIONS(469),
    [sym_variable_name] = ACTIONS(473),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_DQUOTE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT_LPAREN] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [1291] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(583),
    [anon_sym_DOLLAR] = ACTIONS(583),
    [anon_sym_LT_LT] = ACTIONS(583),
    [anon_sym_GT_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(583),
    [anon_sym_PIPE_PIPE] = ACTIONS(583),
    [sym_word] = ACTIONS(583),
    [anon_sym_PIPE] = ACTIONS(583),
    [anon_sym_AMP] = ACTIONS(583),
    [anon_sym_LT] = ACTIONS(583),
    [anon_sym_LT_AMP] = ACTIONS(583),
    [anon_sym_GT_GT] = ACTIONS(583),
    [sym__concat] = ACTIONS(585),
    [sym__special_character] = ACTIONS(583),
    [anon_sym_LT_LT_DASH] = ACTIONS(583),
    [anon_sym_BQUOTE] = ACTIONS(583),
    [anon_sym_LF] = ACTIONS(585),
    [anon_sym_SEMI] = ACTIONS(583),
    [sym_raw_string] = ACTIONS(583),
    [sym_variable_name] = ACTIONS(585),
    [sym_file_descriptor] = ACTIONS(585),
    [anon_sym_GT] = ACTIONS(583),
    [anon_sym_AMP_GT] = ACTIONS(583),
    [anon_sym_DQUOTE] = ACTIONS(583),
    [anon_sym_LT_LT_LT] = ACTIONS(583),
    [anon_sym_GT_AMP] = ACTIONS(583),
    [anon_sym_LT_LPAREN] = ACTIONS(583),
    [anon_sym_esac] = ACTIONS(583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(583),
    [anon_sym_SEMI_SEMI] = ACTIONS(583),
    [anon_sym_PIPE_AMP] = ACTIONS(583),
  },
  [1292] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [aux_sym__simple_variable_name_token1] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1293] = {
    [aux_sym__literal_repeat1] = STATE(1293),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [aux_sym__simple_variable_name_token1] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2898),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_esac] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1294] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(857),
    [anon_sym_DOLLAR] = ACTIONS(857),
    [anon_sym_LT_LT] = ACTIONS(857),
    [anon_sym_GT_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(857),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(857),
    [anon_sym_PIPE_PIPE] = ACTIONS(857),
    [sym_word] = ACTIONS(857),
    [anon_sym_PIPE] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_LT] = ACTIONS(857),
    [anon_sym_LT_AMP] = ACTIONS(857),
    [anon_sym_GT_GT] = ACTIONS(857),
    [sym__concat] = ACTIONS(859),
    [sym__special_character] = ACTIONS(857),
    [anon_sym_LT_LT_DASH] = ACTIONS(857),
    [anon_sym_BQUOTE] = ACTIONS(857),
    [anon_sym_LF] = ACTIONS(859),
    [anon_sym_SEMI] = ACTIONS(857),
    [sym_raw_string] = ACTIONS(857),
    [sym_variable_name] = ACTIONS(859),
    [sym_file_descriptor] = ACTIONS(859),
    [anon_sym_GT] = ACTIONS(857),
    [anon_sym_AMP_GT] = ACTIONS(857),
    [anon_sym_DQUOTE] = ACTIONS(857),
    [anon_sym_LT_LT_LT] = ACTIONS(857),
    [anon_sym_GT_AMP] = ACTIONS(857),
    [anon_sym_LT_LPAREN] = ACTIONS(857),
    [anon_sym_esac] = ACTIONS(857),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(857),
    [anon_sym_SEMI_SEMI] = ACTIONS(857),
    [anon_sym_PIPE_AMP] = ACTIONS(857),
  },
  [1295] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1296] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_esac] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1297] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [anon_sym_esac] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1298] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(941),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1299] = {
    [sym_command_substitution] = STATE(1298),
    [sym_simple_expansion] = STATE(1298),
    [sym_string_expansion] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_process_substitution] = STATE(1298),
    [sym_expansion] = STATE(1298),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_word] = ACTIONS(2905),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(2909),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2911),
    [sym__special_character] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
  },
  [1300] = {
    [aux_sym_concatenation_repeat1] = STATE(1300),
    [anon_sym_AMP_GT_GT] = ACTIONS(939),
    [anon_sym_DOLLAR] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(939),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [sym_word] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(939),
    [anon_sym_AMP] = ACTIONS(939),
    [anon_sym_LT] = ACTIONS(939),
    [anon_sym_LT_AMP] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [sym__concat] = ACTIONS(2915),
    [sym__special_character] = ACTIONS(939),
    [anon_sym_LT_LT_DASH] = ACTIONS(939),
    [anon_sym_BQUOTE] = ACTIONS(939),
    [anon_sym_LF] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [sym_raw_string] = ACTIONS(939),
    [sym_variable_name] = ACTIONS(941),
    [sym_file_descriptor] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(939),
    [anon_sym_AMP_GT] = ACTIONS(939),
    [anon_sym_DQUOTE] = ACTIONS(939),
    [anon_sym_LT_LT_LT] = ACTIONS(939),
    [anon_sym_GT_AMP] = ACTIONS(939),
    [anon_sym_LT_LPAREN] = ACTIONS(939),
    [anon_sym_esac] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_SEMI_SEMI] = ACTIONS(939),
    [anon_sym_PIPE_AMP] = ACTIONS(939),
  },
  [1301] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1302] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1042),
    [anon_sym_DOLLAR] = ACTIONS(1042),
    [anon_sym_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1042),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1042),
    [anon_sym_PIPE_PIPE] = ACTIONS(1042),
    [sym_word] = ACTIONS(1042),
    [anon_sym_PIPE] = ACTIONS(1042),
    [anon_sym_AMP] = ACTIONS(1042),
    [anon_sym_LT] = ACTIONS(1042),
    [anon_sym_LT_AMP] = ACTIONS(1042),
    [anon_sym_GT_GT] = ACTIONS(1042),
    [sym__concat] = ACTIONS(1044),
    [sym__special_character] = ACTIONS(1042),
    [anon_sym_LT_LT_DASH] = ACTIONS(1042),
    [anon_sym_BQUOTE] = ACTIONS(1042),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_SEMI] = ACTIONS(1042),
    [sym_raw_string] = ACTIONS(1042),
    [sym_variable_name] = ACTIONS(1044),
    [sym_file_descriptor] = ACTIONS(1044),
    [anon_sym_GT] = ACTIONS(1042),
    [anon_sym_AMP_GT] = ACTIONS(1042),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [anon_sym_LT_LT_LT] = ACTIONS(1042),
    [anon_sym_GT_AMP] = ACTIONS(1042),
    [anon_sym_LT_LPAREN] = ACTIONS(1042),
    [anon_sym_esac] = ACTIONS(1042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1042),
    [anon_sym_SEMI_SEMI] = ACTIONS(1042),
    [anon_sym_PIPE_AMP] = ACTIONS(1042),
  },
  [1303] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_esac] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1304] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_esac] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1305] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1306] = {
    [sym_string] = STATE(1256),
    [anon_sym__] = ACTIONS(2918),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2920),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2920),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2918),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2918),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2922),
    [anon_sym_BANG] = ACTIONS(2920),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2918),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2918),
    [anon_sym_POUND] = ACTIONS(2920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1307] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1377),
    [anon_sym_DOLLAR] = ACTIONS(1377),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1377),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1377),
    [anon_sym_PIPE_PIPE] = ACTIONS(1377),
    [sym_word] = ACTIONS(1377),
    [anon_sym_PIPE] = ACTIONS(1377),
    [anon_sym_AMP] = ACTIONS(1377),
    [anon_sym_LT] = ACTIONS(1377),
    [anon_sym_LT_AMP] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [sym__concat] = ACTIONS(1379),
    [sym__special_character] = ACTIONS(1377),
    [anon_sym_LT_LT_DASH] = ACTIONS(1377),
    [anon_sym_BQUOTE] = ACTIONS(1377),
    [anon_sym_LF] = ACTIONS(1379),
    [anon_sym_SEMI] = ACTIONS(1377),
    [sym_raw_string] = ACTIONS(1377),
    [sym_variable_name] = ACTIONS(1379),
    [sym_file_descriptor] = ACTIONS(1379),
    [anon_sym_GT] = ACTIONS(1377),
    [anon_sym_AMP_GT] = ACTIONS(1377),
    [anon_sym_DQUOTE] = ACTIONS(1377),
    [anon_sym_LT_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_AMP] = ACTIONS(1377),
    [anon_sym_LT_LPAREN] = ACTIONS(1377),
    [anon_sym_esac] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1377),
    [anon_sym_SEMI_SEMI] = ACTIONS(1377),
    [anon_sym_PIPE_AMP] = ACTIONS(1377),
  },
  [1308] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [anon_sym_esac] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1309] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [anon_sym_esac] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1310] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_esac] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1311] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [anon_sym_esac] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1312] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [anon_sym_esac] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1313] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1314] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [anon_sym_esac] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1315] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [anon_sym_esac] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1316] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [anon_sym_esac] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1317] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [anon_sym_esac] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1318] = {
    [aux_sym_concatenation_repeat1] = STATE(1290),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__concat] = ACTIONS(2522),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1319] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [aux_sym__simple_variable_name_token1] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [anon_sym_esac] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1320] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [aux_sym__simple_variable_name_token1] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [anon_sym_esac] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1321] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_DOLLAR] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [anon_sym_GT_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(199),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [sym_word] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [anon_sym_BQUOTE] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [sym_raw_string] = ACTIONS(199),
    [sym_variable_name] = ACTIONS(201),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_DQUOTE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT_LPAREN] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [1322] = {
    [aux_sym__literal_repeat1] = STATE(1322),
    [anon_sym_AMP_GT_GT] = ACTIONS(635),
    [anon_sym_DOLLAR] = ACTIONS(635),
    [anon_sym_LT_LT] = ACTIONS(635),
    [anon_sym_GT_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(635),
    [anon_sym_PIPE_PIPE] = ACTIONS(635),
    [sym_word] = ACTIONS(635),
    [anon_sym_PIPE] = ACTIONS(635),
    [anon_sym_AMP] = ACTIONS(635),
    [anon_sym_LT] = ACTIONS(635),
    [anon_sym_LT_AMP] = ACTIONS(635),
    [anon_sym_GT_GT] = ACTIONS(635),
    [sym__special_character] = ACTIONS(2924),
    [anon_sym_LT_LT_DASH] = ACTIONS(635),
    [anon_sym_BQUOTE] = ACTIONS(635),
    [anon_sym_LF] = ACTIONS(640),
    [anon_sym_SEMI] = ACTIONS(635),
    [sym_raw_string] = ACTIONS(635),
    [sym_variable_name] = ACTIONS(640),
    [sym_file_descriptor] = ACTIONS(640),
    [anon_sym_GT] = ACTIONS(635),
    [anon_sym_AMP_GT] = ACTIONS(635),
    [anon_sym_DQUOTE] = ACTIONS(635),
    [anon_sym_LT_LT_LT] = ACTIONS(635),
    [anon_sym_GT_AMP] = ACTIONS(635),
    [anon_sym_LT_LPAREN] = ACTIONS(635),
    [anon_sym_esac] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(635),
    [anon_sym_SEMI_SEMI] = ACTIONS(635),
    [anon_sym_PIPE_AMP] = ACTIONS(635),
  },
  [1323] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1324] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [aux_sym__simple_variable_name_token1] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_esac] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1325] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [aux_sym__simple_variable_name_token1] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [anon_sym_esac] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1326] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [aux_sym__simple_variable_name_token1] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1327] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_esac] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1328] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_esac] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1329] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1330] = {
    [sym_string] = STATE(1288),
    [anon_sym__] = ACTIONS(2927),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2929),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2929),
    [anon_sym_GT_LPAREN] = ACTIONS(1285),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1285),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2927),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1285),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [sym_word] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2927),
    [sym__special_character] = ACTIONS(1285),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_BQUOTE] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2927),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2931),
    [anon_sym_BANG] = ACTIONS(2929),
    [sym_variable_name] = ACTIONS(1289),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2927),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2933),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_LT_LPAREN] = ACTIONS(1285),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2927),
    [anon_sym_POUND] = ACTIONS(2929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1331] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [anon_sym_esac] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1332] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [anon_sym_esac] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1333] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_esac] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1334] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [anon_sym_esac] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1335] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [anon_sym_esac] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1336] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1337] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [anon_sym_esac] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1338] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [anon_sym_esac] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1339] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [anon_sym_esac] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1340] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [aux_sym__simple_variable_name_token1] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [anon_sym_esac] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1341] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(401),
    [anon_sym_DOLLAR] = ACTIONS(401),
    [anon_sym_LT_LT] = ACTIONS(401),
    [anon_sym_GT_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(401),
    [anon_sym_PIPE_PIPE] = ACTIONS(401),
    [sym_word] = ACTIONS(401),
    [anon_sym_PIPE] = ACTIONS(401),
    [anon_sym_AMP] = ACTIONS(401),
    [anon_sym_LT] = ACTIONS(401),
    [anon_sym_LT_AMP] = ACTIONS(401),
    [anon_sym_GT_GT] = ACTIONS(401),
    [sym__concat] = ACTIONS(403),
    [sym__special_character] = ACTIONS(401),
    [anon_sym_LT_LT_DASH] = ACTIONS(401),
    [anon_sym_BQUOTE] = ACTIONS(401),
    [anon_sym_LF] = ACTIONS(403),
    [anon_sym_SEMI] = ACTIONS(401),
    [sym_raw_string] = ACTIONS(401),
    [sym_variable_name] = ACTIONS(403),
    [sym_file_descriptor] = ACTIONS(403),
    [anon_sym_GT] = ACTIONS(401),
    [anon_sym_AMP_GT] = ACTIONS(401),
    [anon_sym_DQUOTE] = ACTIONS(401),
    [anon_sym_LT_LT_LT] = ACTIONS(401),
    [anon_sym_GT_AMP] = ACTIONS(401),
    [anon_sym_LT_LPAREN] = ACTIONS(401),
    [anon_sym_esac] = ACTIONS(401),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(401),
    [anon_sym_SEMI_SEMI] = ACTIONS(401),
    [anon_sym_PIPE_AMP] = ACTIONS(401),
  },
  [1342] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(409),
    [anon_sym_DOLLAR] = ACTIONS(409),
    [anon_sym_LT_LT] = ACTIONS(409),
    [anon_sym_GT_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(409),
    [anon_sym_PIPE_PIPE] = ACTIONS(409),
    [sym_word] = ACTIONS(409),
    [anon_sym_PIPE] = ACTIONS(409),
    [anon_sym_AMP] = ACTIONS(409),
    [anon_sym_LT] = ACTIONS(409),
    [anon_sym_LT_AMP] = ACTIONS(409),
    [anon_sym_GT_GT] = ACTIONS(409),
    [sym__concat] = ACTIONS(411),
    [sym__special_character] = ACTIONS(409),
    [anon_sym_LT_LT_DASH] = ACTIONS(409),
    [anon_sym_BQUOTE] = ACTIONS(409),
    [anon_sym_LF] = ACTIONS(411),
    [anon_sym_SEMI] = ACTIONS(409),
    [sym_raw_string] = ACTIONS(409),
    [sym_variable_name] = ACTIONS(411),
    [sym_file_descriptor] = ACTIONS(411),
    [anon_sym_GT] = ACTIONS(409),
    [anon_sym_AMP_GT] = ACTIONS(409),
    [anon_sym_DQUOTE] = ACTIONS(409),
    [anon_sym_LT_LT_LT] = ACTIONS(409),
    [anon_sym_GT_AMP] = ACTIONS(409),
    [anon_sym_LT_LPAREN] = ACTIONS(409),
    [anon_sym_esac] = ACTIONS(409),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(409),
    [anon_sym_SEMI_SEMI] = ACTIONS(409),
    [anon_sym_PIPE_AMP] = ACTIONS(409),
  },
  [1343] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1344] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(879),
    [anon_sym_DOLLAR] = ACTIONS(879),
    [anon_sym_LT_LT] = ACTIONS(879),
    [anon_sym_GT_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(879),
    [anon_sym_PIPE_PIPE] = ACTIONS(879),
    [sym_word] = ACTIONS(879),
    [anon_sym_PIPE] = ACTIONS(879),
    [anon_sym_AMP] = ACTIONS(879),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_AMP] = ACTIONS(879),
    [anon_sym_GT_GT] = ACTIONS(879),
    [sym__concat] = ACTIONS(881),
    [sym__special_character] = ACTIONS(879),
    [anon_sym_LT_LT_DASH] = ACTIONS(879),
    [anon_sym_BQUOTE] = ACTIONS(879),
    [anon_sym_LF] = ACTIONS(881),
    [anon_sym_SEMI] = ACTIONS(879),
    [sym_raw_string] = ACTIONS(879),
    [sym_variable_name] = ACTIONS(881),
    [sym_file_descriptor] = ACTIONS(881),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_AMP_GT] = ACTIONS(879),
    [anon_sym_DQUOTE] = ACTIONS(879),
    [anon_sym_LT_LT_LT] = ACTIONS(879),
    [anon_sym_GT_AMP] = ACTIONS(879),
    [anon_sym_LT_LPAREN] = ACTIONS(879),
    [anon_sym_esac] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(879),
    [anon_sym_SEMI_SEMI] = ACTIONS(879),
    [anon_sym_PIPE_AMP] = ACTIONS(879),
  },
  [1345] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(929),
    [anon_sym_DOLLAR] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(929),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [sym_word] = ACTIONS(929),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_LT_AMP] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [sym__concat] = ACTIONS(931),
    [sym__special_character] = ACTIONS(929),
    [anon_sym_LT_LT_DASH] = ACTIONS(929),
    [anon_sym_BQUOTE] = ACTIONS(929),
    [anon_sym_LF] = ACTIONS(931),
    [anon_sym_SEMI] = ACTIONS(929),
    [sym_raw_string] = ACTIONS(929),
    [sym_variable_name] = ACTIONS(931),
    [sym_file_descriptor] = ACTIONS(931),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_AMP_GT] = ACTIONS(929),
    [anon_sym_DQUOTE] = ACTIONS(929),
    [anon_sym_LT_LT_LT] = ACTIONS(929),
    [anon_sym_GT_AMP] = ACTIONS(929),
    [anon_sym_LT_LPAREN] = ACTIONS(929),
    [anon_sym_esac] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_SEMI_SEMI] = ACTIONS(929),
    [anon_sym_PIPE_AMP] = ACTIONS(929),
  },
  [1346] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(861),
    [anon_sym_DOLLAR] = ACTIONS(861),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_GT_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(861),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(861),
    [anon_sym_PIPE_PIPE] = ACTIONS(861),
    [sym_word] = ACTIONS(861),
    [anon_sym_PIPE] = ACTIONS(861),
    [anon_sym_AMP] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(861),
    [anon_sym_LT_AMP] = ACTIONS(861),
    [anon_sym_GT_GT] = ACTIONS(861),
    [sym__concat] = ACTIONS(863),
    [sym__special_character] = ACTIONS(861),
    [anon_sym_LT_LT_DASH] = ACTIONS(861),
    [anon_sym_BQUOTE] = ACTIONS(861),
    [anon_sym_LF] = ACTIONS(863),
    [anon_sym_SEMI] = ACTIONS(861),
    [sym_raw_string] = ACTIONS(861),
    [sym_variable_name] = ACTIONS(863),
    [sym_file_descriptor] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(861),
    [anon_sym_AMP_GT] = ACTIONS(861),
    [anon_sym_DQUOTE] = ACTIONS(861),
    [anon_sym_LT_LT_LT] = ACTIONS(861),
    [anon_sym_GT_AMP] = ACTIONS(861),
    [anon_sym_LT_LPAREN] = ACTIONS(861),
    [anon_sym_esac] = ACTIONS(861),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(861),
    [anon_sym_SEMI_SEMI] = ACTIONS(861),
    [anon_sym_PIPE_AMP] = ACTIONS(861),
  },
  [1347] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1204),
    [anon_sym_DOLLAR] = ACTIONS(1204),
    [anon_sym_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1204),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1204),
    [sym_word] = ACTIONS(1204),
    [anon_sym_PIPE] = ACTIONS(1204),
    [anon_sym_AMP] = ACTIONS(1204),
    [anon_sym_LT] = ACTIONS(1204),
    [anon_sym_LT_AMP] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1204),
    [sym__concat] = ACTIONS(1206),
    [sym__special_character] = ACTIONS(1204),
    [anon_sym_LT_LT_DASH] = ACTIONS(1204),
    [anon_sym_BQUOTE] = ACTIONS(1204),
    [anon_sym_LF] = ACTIONS(1206),
    [anon_sym_SEMI] = ACTIONS(1204),
    [sym_raw_string] = ACTIONS(1204),
    [sym_variable_name] = ACTIONS(1206),
    [sym_file_descriptor] = ACTIONS(1206),
    [anon_sym_GT] = ACTIONS(1204),
    [anon_sym_AMP_GT] = ACTIONS(1204),
    [anon_sym_DQUOTE] = ACTIONS(1204),
    [anon_sym_LT_LT_LT] = ACTIONS(1204),
    [anon_sym_GT_AMP] = ACTIONS(1204),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_esac] = ACTIONS(1204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1204),
    [anon_sym_SEMI_SEMI] = ACTIONS(1204),
    [anon_sym_PIPE_AMP] = ACTIONS(1204),
  },
  [1348] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1261),
    [anon_sym_DOLLAR] = ACTIONS(1261),
    [anon_sym_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1261),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1261),
    [anon_sym_PIPE_PIPE] = ACTIONS(1261),
    [sym_word] = ACTIONS(1261),
    [anon_sym_PIPE] = ACTIONS(1261),
    [anon_sym_AMP] = ACTIONS(1261),
    [anon_sym_LT] = ACTIONS(1261),
    [anon_sym_LT_AMP] = ACTIONS(1261),
    [anon_sym_GT_GT] = ACTIONS(1261),
    [sym__concat] = ACTIONS(1263),
    [sym__special_character] = ACTIONS(1261),
    [anon_sym_LT_LT_DASH] = ACTIONS(1261),
    [anon_sym_BQUOTE] = ACTIONS(1261),
    [anon_sym_LF] = ACTIONS(1263),
    [anon_sym_SEMI] = ACTIONS(1261),
    [sym_raw_string] = ACTIONS(1261),
    [sym_variable_name] = ACTIONS(1263),
    [sym_file_descriptor] = ACTIONS(1263),
    [anon_sym_GT] = ACTIONS(1261),
    [anon_sym_AMP_GT] = ACTIONS(1261),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_LT_LT_LT] = ACTIONS(1261),
    [anon_sym_GT_AMP] = ACTIONS(1261),
    [anon_sym_LT_LPAREN] = ACTIONS(1261),
    [anon_sym_esac] = ACTIONS(1261),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1261),
    [anon_sym_SEMI_SEMI] = ACTIONS(1261),
    [anon_sym_PIPE_AMP] = ACTIONS(1261),
  },
  [1349] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1271),
    [anon_sym_DOLLAR] = ACTIONS(1271),
    [anon_sym_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1271),
    [anon_sym_PIPE_PIPE] = ACTIONS(1271),
    [sym_word] = ACTIONS(1271),
    [anon_sym_PIPE] = ACTIONS(1271),
    [anon_sym_AMP] = ACTIONS(1271),
    [anon_sym_LT] = ACTIONS(1271),
    [anon_sym_LT_AMP] = ACTIONS(1271),
    [anon_sym_GT_GT] = ACTIONS(1271),
    [sym__concat] = ACTIONS(1273),
    [sym__special_character] = ACTIONS(1271),
    [anon_sym_LT_LT_DASH] = ACTIONS(1271),
    [anon_sym_BQUOTE] = ACTIONS(1271),
    [anon_sym_LF] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1271),
    [sym_raw_string] = ACTIONS(1271),
    [sym_variable_name] = ACTIONS(1273),
    [sym_file_descriptor] = ACTIONS(1273),
    [anon_sym_GT] = ACTIONS(1271),
    [anon_sym_AMP_GT] = ACTIONS(1271),
    [anon_sym_DQUOTE] = ACTIONS(1271),
    [anon_sym_LT_LT_LT] = ACTIONS(1271),
    [anon_sym_GT_AMP] = ACTIONS(1271),
    [anon_sym_LT_LPAREN] = ACTIONS(1271),
    [anon_sym_esac] = ACTIONS(1271),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1271),
    [anon_sym_SEMI_SEMI] = ACTIONS(1271),
    [anon_sym_PIPE_AMP] = ACTIONS(1271),
  },
  [1350] = {
    [sym_string] = STATE(1064),
    [anon_sym__] = ACTIONS(2774),
    [anon_sym_AMP_GT_GT] = ACTIONS(1285),
    [anon_sym_DOLLAR] = ACTIONS(2776),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_DASH] = ACTIONS(2776),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2774),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_LT_AMP] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_QMARK] = ACTIONS(2774),
    [anon_sym_LT_LT_DASH] = ACTIONS(1285),
    [anon_sym_STAR] = ACTIONS(2774),
    [anon_sym_LF] = ACTIONS(1289),
    [anon_sym_SEMI] = ACTIONS(1285),
    [sym_raw_string] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2776),
    [sym_file_descriptor] = ACTIONS(1289),
    [anon_sym_0] = ACTIONS(2774),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_AMP_GT] = ACTIONS(1285),
    [anon_sym_DQUOTE] = ACTIONS(2780),
    [anon_sym_LT_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_AMP] = ACTIONS(1285),
    [anon_sym_esac] = ACTIONS(1285),
    [anon_sym_AT] = ACTIONS(2774),
    [anon_sym_POUND] = ACTIONS(2776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_SEMI_SEMI] = ACTIONS(1285),
    [anon_sym_PIPE_AMP] = ACTIONS(1285),
  },
  [1351] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1437),
    [anon_sym_DOLLAR] = ACTIONS(1437),
    [anon_sym_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1437),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1437),
    [anon_sym_PIPE_PIPE] = ACTIONS(1437),
    [sym_word] = ACTIONS(1437),
    [anon_sym_PIPE] = ACTIONS(1437),
    [anon_sym_AMP] = ACTIONS(1437),
    [anon_sym_LT] = ACTIONS(1437),
    [anon_sym_LT_AMP] = ACTIONS(1437),
    [anon_sym_GT_GT] = ACTIONS(1437),
    [sym__concat] = ACTIONS(1439),
    [sym__special_character] = ACTIONS(1437),
    [anon_sym_LT_LT_DASH] = ACTIONS(1437),
    [anon_sym_BQUOTE] = ACTIONS(1437),
    [anon_sym_LF] = ACTIONS(1439),
    [anon_sym_SEMI] = ACTIONS(1437),
    [sym_raw_string] = ACTIONS(1437),
    [sym_variable_name] = ACTIONS(1439),
    [sym_file_descriptor] = ACTIONS(1439),
    [anon_sym_GT] = ACTIONS(1437),
    [anon_sym_AMP_GT] = ACTIONS(1437),
    [anon_sym_DQUOTE] = ACTIONS(1437),
    [anon_sym_LT_LT_LT] = ACTIONS(1437),
    [anon_sym_GT_AMP] = ACTIONS(1437),
    [anon_sym_LT_LPAREN] = ACTIONS(1437),
    [anon_sym_esac] = ACTIONS(1437),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1437),
    [anon_sym_SEMI_SEMI] = ACTIONS(1437),
    [anon_sym_PIPE_AMP] = ACTIONS(1437),
  },
  [1352] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1449),
    [anon_sym_DOLLAR] = ACTIONS(1449),
    [anon_sym_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1449),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1449),
    [anon_sym_PIPE_PIPE] = ACTIONS(1449),
    [sym_word] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(1449),
    [anon_sym_AMP] = ACTIONS(1449),
    [anon_sym_LT] = ACTIONS(1449),
    [anon_sym_LT_AMP] = ACTIONS(1449),
    [anon_sym_GT_GT] = ACTIONS(1449),
    [sym__concat] = ACTIONS(1451),
    [sym__special_character] = ACTIONS(1449),
    [anon_sym_LT_LT_DASH] = ACTIONS(1449),
    [anon_sym_BQUOTE] = ACTIONS(1449),
    [anon_sym_LF] = ACTIONS(1451),
    [anon_sym_SEMI] = ACTIONS(1449),
    [sym_raw_string] = ACTIONS(1449),
    [sym_variable_name] = ACTIONS(1451),
    [sym_file_descriptor] = ACTIONS(1451),
    [anon_sym_GT] = ACTIONS(1449),
    [anon_sym_AMP_GT] = ACTIONS(1449),
    [anon_sym_DQUOTE] = ACTIONS(1449),
    [anon_sym_LT_LT_LT] = ACTIONS(1449),
    [anon_sym_GT_AMP] = ACTIONS(1449),
    [anon_sym_LT_LPAREN] = ACTIONS(1449),
    [anon_sym_esac] = ACTIONS(1449),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1449),
    [anon_sym_SEMI_SEMI] = ACTIONS(1449),
    [anon_sym_PIPE_AMP] = ACTIONS(1449),
  },
  [1353] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1459),
    [anon_sym_DOLLAR] = ACTIONS(1459),
    [anon_sym_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1459),
    [anon_sym_PIPE_PIPE] = ACTIONS(1459),
    [sym_word] = ACTIONS(1459),
    [anon_sym_PIPE] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_LT] = ACTIONS(1459),
    [anon_sym_LT_AMP] = ACTIONS(1459),
    [anon_sym_GT_GT] = ACTIONS(1459),
    [sym__concat] = ACTIONS(1461),
    [sym__special_character] = ACTIONS(1459),
    [anon_sym_LT_LT_DASH] = ACTIONS(1459),
    [anon_sym_BQUOTE] = ACTIONS(1459),
    [anon_sym_LF] = ACTIONS(1461),
    [anon_sym_SEMI] = ACTIONS(1459),
    [sym_raw_string] = ACTIONS(1459),
    [sym_variable_name] = ACTIONS(1461),
    [sym_file_descriptor] = ACTIONS(1461),
    [anon_sym_GT] = ACTIONS(1459),
    [anon_sym_AMP_GT] = ACTIONS(1459),
    [anon_sym_DQUOTE] = ACTIONS(1459),
    [anon_sym_LT_LT_LT] = ACTIONS(1459),
    [anon_sym_GT_AMP] = ACTIONS(1459),
    [anon_sym_LT_LPAREN] = ACTIONS(1459),
    [anon_sym_esac] = ACTIONS(1459),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1459),
    [anon_sym_SEMI_SEMI] = ACTIONS(1459),
    [anon_sym_PIPE_AMP] = ACTIONS(1459),
  },
  [1354] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1463),
    [anon_sym_DOLLAR] = ACTIONS(1463),
    [anon_sym_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1463),
    [anon_sym_PIPE_PIPE] = ACTIONS(1463),
    [sym_word] = ACTIONS(1463),
    [anon_sym_PIPE] = ACTIONS(1463),
    [anon_sym_AMP] = ACTIONS(1463),
    [anon_sym_LT] = ACTIONS(1463),
    [anon_sym_LT_AMP] = ACTIONS(1463),
    [anon_sym_GT_GT] = ACTIONS(1463),
    [sym__concat] = ACTIONS(1465),
    [sym__special_character] = ACTIONS(1463),
    [anon_sym_LT_LT_DASH] = ACTIONS(1463),
    [anon_sym_BQUOTE] = ACTIONS(1463),
    [anon_sym_LF] = ACTIONS(1465),
    [anon_sym_SEMI] = ACTIONS(1463),
    [sym_raw_string] = ACTIONS(1463),
    [sym_variable_name] = ACTIONS(1465),
    [sym_file_descriptor] = ACTIONS(1465),
    [anon_sym_GT] = ACTIONS(1463),
    [anon_sym_AMP_GT] = ACTIONS(1463),
    [anon_sym_DQUOTE] = ACTIONS(1463),
    [anon_sym_LT_LT_LT] = ACTIONS(1463),
    [anon_sym_GT_AMP] = ACTIONS(1463),
    [anon_sym_LT_LPAREN] = ACTIONS(1463),
    [anon_sym_esac] = ACTIONS(1463),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1463),
    [anon_sym_SEMI_SEMI] = ACTIONS(1463),
    [anon_sym_PIPE_AMP] = ACTIONS(1463),
  },
  [1355] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1665),
    [anon_sym_DOLLAR] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1665),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1665),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [sym_word] = ACTIONS(1665),
    [anon_sym_PIPE] = ACTIONS(1665),
    [anon_sym_AMP] = ACTIONS(1665),
    [anon_sym_LT] = ACTIONS(1665),
    [anon_sym_LT_AMP] = ACTIONS(1665),
    [anon_sym_GT_GT] = ACTIONS(1665),
    [sym__concat] = ACTIONS(1667),
    [sym__special_character] = ACTIONS(1665),
    [anon_sym_LT_LT_DASH] = ACTIONS(1665),
    [anon_sym_BQUOTE] = ACTIONS(1665),
    [anon_sym_LF] = ACTIONS(1667),
    [anon_sym_SEMI] = ACTIONS(1665),
    [sym_raw_string] = ACTIONS(1665),
    [sym_variable_name] = ACTIONS(1667),
    [sym_file_descriptor] = ACTIONS(1667),
    [anon_sym_GT] = ACTIONS(1665),
    [anon_sym_AMP_GT] = ACTIONS(1665),
    [anon_sym_DQUOTE] = ACTIONS(1665),
    [anon_sym_LT_LT_LT] = ACTIONS(1665),
    [anon_sym_GT_AMP] = ACTIONS(1665),
    [anon_sym_LT_LPAREN] = ACTIONS(1665),
    [anon_sym_esac] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_SEMI_SEMI] = ACTIONS(1665),
    [anon_sym_PIPE_AMP] = ACTIONS(1665),
  },
  [1356] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1671),
    [anon_sym_DOLLAR] = ACTIONS(1671),
    [anon_sym_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1671),
    [anon_sym_PIPE_PIPE] = ACTIONS(1671),
    [sym_word] = ACTIONS(1671),
    [anon_sym_PIPE] = ACTIONS(1671),
    [anon_sym_AMP] = ACTIONS(1671),
    [anon_sym_LT] = ACTIONS(1671),
    [anon_sym_LT_AMP] = ACTIONS(1671),
    [anon_sym_GT_GT] = ACTIONS(1671),
    [sym__concat] = ACTIONS(1673),
    [sym__special_character] = ACTIONS(1671),
    [anon_sym_LT_LT_DASH] = ACTIONS(1671),
    [anon_sym_BQUOTE] = ACTIONS(1671),
    [anon_sym_LF] = ACTIONS(1673),
    [anon_sym_SEMI] = ACTIONS(1671),
    [sym_raw_string] = ACTIONS(1671),
    [sym_variable_name] = ACTIONS(1673),
    [sym_file_descriptor] = ACTIONS(1673),
    [anon_sym_GT] = ACTIONS(1671),
    [anon_sym_AMP_GT] = ACTIONS(1671),
    [anon_sym_DQUOTE] = ACTIONS(1671),
    [anon_sym_LT_LT_LT] = ACTIONS(1671),
    [anon_sym_GT_AMP] = ACTIONS(1671),
    [anon_sym_LT_LPAREN] = ACTIONS(1671),
    [anon_sym_esac] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1671),
    [anon_sym_SEMI_SEMI] = ACTIONS(1671),
    [anon_sym_PIPE_AMP] = ACTIONS(1671),
  },
  [1357] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1675),
    [anon_sym_DOLLAR] = ACTIONS(1675),
    [anon_sym_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1675),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1675),
    [anon_sym_PIPE_PIPE] = ACTIONS(1675),
    [sym_word] = ACTIONS(1675),
    [anon_sym_PIPE] = ACTIONS(1675),
    [anon_sym_AMP] = ACTIONS(1675),
    [anon_sym_LT] = ACTIONS(1675),
    [anon_sym_LT_AMP] = ACTIONS(1675),
    [anon_sym_GT_GT] = ACTIONS(1675),
    [sym__concat] = ACTIONS(1677),
    [sym__special_character] = ACTIONS(1675),
    [anon_sym_LT_LT_DASH] = ACTIONS(1675),
    [anon_sym_BQUOTE] = ACTIONS(1675),
    [anon_sym_LF] = ACTIONS(1677),
    [anon_sym_SEMI] = ACTIONS(1675),
    [sym_raw_string] = ACTIONS(1675),
    [sym_variable_name] = ACTIONS(1677),
    [sym_file_descriptor] = ACTIONS(1677),
    [anon_sym_GT] = ACTIONS(1675),
    [anon_sym_AMP_GT] = ACTIONS(1675),
    [anon_sym_DQUOTE] = ACTIONS(1675),
    [anon_sym_LT_LT_LT] = ACTIONS(1675),
    [anon_sym_GT_AMP] = ACTIONS(1675),
    [anon_sym_LT_LPAREN] = ACTIONS(1675),
    [anon_sym_esac] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1675),
    [anon_sym_SEMI_SEMI] = ACTIONS(1675),
    [anon_sym_PIPE_AMP] = ACTIONS(1675),
  },
  [1358] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1681),
    [anon_sym_DOLLAR] = ACTIONS(1681),
    [anon_sym_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1681),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1681),
    [anon_sym_PIPE_PIPE] = ACTIONS(1681),
    [sym_word] = ACTIONS(1681),
    [anon_sym_PIPE] = ACTIONS(1681),
    [anon_sym_AMP] = ACTIONS(1681),
    [anon_sym_LT] = ACTIONS(1681),
    [anon_sym_LT_AMP] = ACTIONS(1681),
    [anon_sym_GT_GT] = ACTIONS(1681),
    [sym__concat] = ACTIONS(1683),
    [sym__special_character] = ACTIONS(1681),
    [anon_sym_LT_LT_DASH] = ACTIONS(1681),
    [anon_sym_BQUOTE] = ACTIONS(1681),
    [anon_sym_LF] = ACTIONS(1683),
    [anon_sym_SEMI] = ACTIONS(1681),
    [sym_raw_string] = ACTIONS(1681),
    [sym_variable_name] = ACTIONS(1683),
    [sym_file_descriptor] = ACTIONS(1683),
    [anon_sym_GT] = ACTIONS(1681),
    [anon_sym_AMP_GT] = ACTIONS(1681),
    [anon_sym_DQUOTE] = ACTIONS(1681),
    [anon_sym_LT_LT_LT] = ACTIONS(1681),
    [anon_sym_GT_AMP] = ACTIONS(1681),
    [anon_sym_LT_LPAREN] = ACTIONS(1681),
    [anon_sym_esac] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1681),
    [anon_sym_SEMI_SEMI] = ACTIONS(1681),
    [anon_sym_PIPE_AMP] = ACTIONS(1681),
  },
  [1359] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1789),
    [anon_sym_DOLLAR] = ACTIONS(1789),
    [anon_sym_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1789),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1789),
    [anon_sym_PIPE_PIPE] = ACTIONS(1789),
    [sym_word] = ACTIONS(1789),
    [anon_sym_PIPE] = ACTIONS(1789),
    [anon_sym_AMP] = ACTIONS(1789),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_LT_AMP] = ACTIONS(1789),
    [anon_sym_GT_GT] = ACTIONS(1789),
    [sym__concat] = ACTIONS(1791),
    [sym__special_character] = ACTIONS(1789),
    [anon_sym_LT_LT_DASH] = ACTIONS(1789),
    [anon_sym_BQUOTE] = ACTIONS(1789),
    [anon_sym_LF] = ACTIONS(1791),
    [anon_sym_SEMI] = ACTIONS(1789),
    [sym_raw_string] = ACTIONS(1789),
    [sym_variable_name] = ACTIONS(1791),
    [sym_file_descriptor] = ACTIONS(1791),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_AMP_GT] = ACTIONS(1789),
    [anon_sym_DQUOTE] = ACTIONS(1789),
    [anon_sym_LT_LT_LT] = ACTIONS(1789),
    [anon_sym_GT_AMP] = ACTIONS(1789),
    [anon_sym_LT_LPAREN] = ACTIONS(1789),
    [anon_sym_esac] = ACTIONS(1789),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1789),
    [anon_sym_SEMI_SEMI] = ACTIONS(1789),
    [anon_sym_PIPE_AMP] = ACTIONS(1789),
  },
  [1360] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(1793),
    [anon_sym_DOLLAR] = ACTIONS(1793),
    [anon_sym_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1793),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1793),
    [anon_sym_PIPE_PIPE] = ACTIONS(1793),
    [sym_word] = ACTIONS(1793),
    [anon_sym_PIPE] = ACTIONS(1793),
    [anon_sym_AMP] = ACTIONS(1793),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_LT_AMP] = ACTIONS(1793),
    [anon_sym_GT_GT] = ACTIONS(1793),
    [sym__concat] = ACTIONS(1795),
    [sym__special_character] = ACTIONS(1793),
    [anon_sym_LT_LT_DASH] = ACTIONS(1793),
    [anon_sym_BQUOTE] = ACTIONS(1793),
    [anon_sym_LF] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1793),
    [sym_raw_string] = ACTIONS(1793),
    [sym_variable_name] = ACTIONS(1795),
    [sym_file_descriptor] = ACTIONS(1795),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_AMP_GT] = ACTIONS(1793),
    [anon_sym_DQUOTE] = ACTIONS(1793),
    [anon_sym_LT_LT_LT] = ACTIONS(1793),
    [anon_sym_GT_AMP] = ACTIONS(1793),
    [anon_sym_LT_LPAREN] = ACTIONS(1793),
    [anon_sym_esac] = ACTIONS(1793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1793),
    [anon_sym_SEMI_SEMI] = ACTIONS(1793),
    [anon_sym_PIPE_AMP] = ACTIONS(1793),
  },
  [1361] = {
    [sym_command_substitution] = STATE(393),
    [aux_sym__literal_repeat1] = STATE(394),
    [sym_string] = STATE(393),
    [sym_process_substitution] = STATE(393),
    [sym_simple_expansion] = STATE(393),
    [sym_string_expansion] = STATE(393),
    [sym_concatenation] = STATE(395),
    [sym_expansion] = STATE(393),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_word] = ACTIONS(2935),
    [sym_raw_string] = ACTIONS(2935),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(664),
    [sym__special_character] = ACTIONS(666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(668),
  },
  [1362] = {
    [sym_string] = STATE(403),
    [anon_sym_STAR] = ACTIONS(2937),
    [sym_raw_string] = ACTIONS(2939),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_DOLLAR] = ACTIONS(2941),
    [anon_sym_0] = ACTIONS(2146),
    [anon_sym_DASH] = ACTIONS(2941),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2146),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_AT] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2941),
    [anon_sym__] = ACTIONS(2146),
  },
  [1363] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_negated_command] = STATE(62),
    [sym_test_command] = STATE(62),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(1375),
    [sym_redirected_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_subshell] = STATE(62),
    [sym_declaration_command] = STATE(62),
    [sym_unset_command] = STATE(62),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_pipeline] = STATE(62),
    [sym_list] = STATE(62),
    [sym_command] = STATE(62),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1364] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1382),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(2945),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1365] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2949),
  },
  [1366] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2951),
  },
  [1367] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(2953),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1368] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(2953),
  },
  [1369] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1389),
    [sym_concatenation] = STATE(1389),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(2955),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(2955),
    [anon_sym_COLON] = ACTIONS(2955),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(2957),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_EQ] = ACTIONS(2955),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2961),
    [anon_sym_COLON_DASH] = ACTIONS(2955),
  },
  [1370] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1394),
    [sym_concatenation] = STATE(1394),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(2963),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(2965),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_EQ] = ACTIONS(2963),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2969),
    [anon_sym_COLON_DASH] = ACTIONS(2963),
  },
  [1371] = {
    [sym_compound_statement] = STATE(433),
    [anon_sym_LPAREN] = ACTIONS(2971),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
  },
  [1372] = {
    [sym_command_substitution] = STATE(434),
    [sym_string] = STATE(434),
    [sym_process_substitution] = STATE(434),
    [sym_simple_expansion] = STATE(434),
    [sym_string_expansion] = STATE(434),
    [sym_expansion] = STATE(434),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [sym_raw_string] = ACTIONS(2082),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_word] = ACTIONS(2082),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2082),
  },
  [1373] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2975),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(2975),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
  },
  [1374] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_AMP_GT_GT] = ACTIONS(323),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(323),
    [anon_sym_PIPE_PIPE] = ACTIONS(491),
    [sym_word] = ACTIONS(323),
    [anon_sym_PIPE] = ACTIONS(479),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(323),
    [anon_sym_GT_GT] = ACTIONS(323),
    [sym__special_character] = ACTIONS(323),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_BQUOTE] = ACTIONS(323),
    [sym_raw_string] = ACTIONS(323),
    [anon_sym_LF] = ACTIONS(2973),
    [anon_sym_SEMI] = ACTIONS(2975),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(323),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(323),
    [anon_sym_LT_LPAREN] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(491),
    [anon_sym_SEMI_SEMI] = ACTIONS(2975),
    [anon_sym_PIPE_AMP] = ACTIONS(479),
  },
  [1375] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(62),
    [sym_function_definition] = STATE(62),
    [sym_negated_command] = STATE(62),
    [sym_test_command] = STATE(62),
    [sym_variable_assignment] = STATE(63),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(420),
    [sym_redirected_statement] = STATE(62),
    [sym_for_statement] = STATE(62),
    [sym_compound_statement] = STATE(62),
    [sym_subshell] = STATE(62),
    [sym_declaration_command] = STATE(62),
    [sym_unset_command] = STATE(62),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(62),
    [sym_while_statement] = STATE(62),
    [sym_case_statement] = STATE(62),
    [sym_pipeline] = STATE(62),
    [sym_list] = STATE(62),
    [sym_command] = STATE(62),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_RBRACE] = ACTIONS(2977),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1376] = {
    [sym_command_substitution] = STATE(407),
    [sym_unary_expression] = STATE(440),
    [sym_postfix_expression] = STATE(440),
    [sym_string] = STATE(407),
    [aux_sym__literal_repeat1] = STATE(408),
    [sym_process_substitution] = STATE(407),
    [sym_parenthesized_expression] = STATE(440),
    [sym_simple_expansion] = STATE(407),
    [sym_string_expansion] = STATE(407),
    [sym__expression] = STATE(440),
    [sym_binary_expression] = STATE(440),
    [sym_concatenation] = STATE(440),
    [sym_expansion] = STATE(407),
    [sym_test_operator] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(281),
    [sym_raw_string] = ACTIONS(283),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(295),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [1377] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [1378] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(2981),
  },
  [1379] = {
    [sym_command_substitution] = STATE(446),
    [aux_sym__literal_repeat1] = STATE(448),
    [sym_string] = STATE(446),
    [sym_array] = STATE(447),
    [sym_process_substitution] = STATE(446),
    [sym_simple_expansion] = STATE(446),
    [sym_string_expansion] = STATE(446),
    [sym_concatenation] = STATE(447),
    [sym_expansion] = STATE(446),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_BQUOTE] = ACTIONS(2707),
    [sym_raw_string] = ACTIONS(2985),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [anon_sym_GT_LPAREN] = ACTIONS(2713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_word] = ACTIONS(2985),
    [anon_sym_LT_LPAREN] = ACTIONS(2713),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2989),
    [sym__empty_value] = ACTIONS(2991),
  },
  [1380] = {
    [sym_command_substitution] = STATE(449),
    [aux_sym__literal_repeat1] = STATE(450),
    [sym_string] = STATE(449),
    [sym_process_substitution] = STATE(449),
    [sym_simple_expansion] = STATE(449),
    [sym_string_expansion] = STATE(449),
    [sym_concatenation] = STATE(451),
    [sym_expansion] = STATE(449),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_word] = ACTIONS(2993),
    [sym_raw_string] = ACTIONS(2993),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(664),
    [sym__special_character] = ACTIONS(666),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(668),
  },
  [1381] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1382] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(2997),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1383] = {
    [sym_do_group] = STATE(453),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1384] = {
    [sym_test_operator] = ACTIONS(627),
    [anon_sym_PLUS_EQ] = ACTIONS(627),
    [anon_sym_PLUS_PLUS] = ACTIONS(629),
    [anon_sym_DASH] = ACTIONS(631),
    [anon_sym_PIPE_PIPE] = ACTIONS(627),
    [anon_sym_LT] = ACTIONS(631),
    [anon_sym_EQ_TILDE] = ACTIONS(633),
    [anon_sym_DASH_DASH] = ACTIONS(629),
    [anon_sym_LT_EQ] = ACTIONS(627),
    [anon_sym_DASH_EQ] = ACTIONS(627),
    [anon_sym_BANG_EQ] = ACTIONS(627),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_GT] = ACTIONS(631),
    [anon_sym_EQ] = ACTIONS(631),
    [anon_sym_EQ_EQ] = ACTIONS(633),
    [anon_sym_GT_EQ] = ACTIONS(627),
    [anon_sym_PLUS] = ACTIONS(631),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(627),
  },
  [1385] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_RBRACK_RBRACK] = ACTIONS(2979),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [1386] = {
    [sym_heredoc_start] = ACTIONS(3001),
    [sym_comment] = ACTIONS(51),
  },
  [1387] = {
    [sym_command_substitution] = STATE(461),
    [aux_sym__literal_repeat1] = STATE(462),
    [sym_string] = STATE(461),
    [sym_process_substitution] = STATE(461),
    [sym_simple_expansion] = STATE(461),
    [sym_string_expansion] = STATE(461),
    [sym_concatenation] = STATE(463),
    [sym_expansion] = STATE(461),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(3003),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(3003),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3007),
  },
  [1388] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1407),
    [sym_concatenation] = STATE(1407),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3009),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3013),
    [anon_sym_COLON_DASH] = ACTIONS(3009),
    [sym_regex] = ACTIONS(3015),
  },
  [1389] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1390] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1407),
    [sym_concatenation] = STATE(1407),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3009),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3009),
    [anon_sym_COLON] = ACTIONS(3009),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3017),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3009),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(3009),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3013),
    [anon_sym_COLON_DASH] = ACTIONS(3009),
  },
  [1391] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1411),
    [sym_concatenation] = STATE(1411),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3019),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3019),
    [anon_sym_COLON] = ACTIONS(3019),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3021),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3019),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(3019),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3025),
    [anon_sym_COLON_DASH] = ACTIONS(3019),
  },
  [1392] = {
    [sym_command_substitution] = STATE(1412),
    [aux_sym__literal_repeat1] = STATE(1413),
    [sym_string] = STATE(1412),
    [sym_process_substitution] = STATE(1412),
    [sym_simple_expansion] = STATE(1412),
    [sym_string_expansion] = STATE(1412),
    [sym_concatenation] = STATE(1414),
    [sym_expansion] = STATE(1412),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3027),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3027),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1393] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1416),
    [sym_concatenation] = STATE(1416),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3029),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3029),
    [anon_sym_COLON] = ACTIONS(3029),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3029),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(3029),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3033),
    [anon_sym_COLON_DASH] = ACTIONS(3029),
    [sym_regex] = ACTIONS(3035),
  },
  [1394] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3031),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1395] = {
    [sym_compound_statement] = STATE(475),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
  },
  [1396] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_elif_clause] = STATE(1420),
    [sym_else_clause] = STATE(1419),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_if_statement_repeat1] = STATE(1420),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(1421),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_elif] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_fi] = ACTIONS(3037),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1397] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [1398] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1424),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1424),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3041),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1006),
  },
  [1399] = {
    [aux_sym_concatenation_repeat1] = STATE(2432),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(3045),
  },
  [1400] = {
    [aux_sym__literal_repeat1] = STATE(973),
    [anon_sym_RBRACK] = ACTIONS(3047),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(3049),
    [sym__special_character] = ACTIONS(1030),
  },
  [1401] = {
    [anon_sym_RBRACK] = ACTIONS(3043),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(3051),
  },
  [1402] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3053),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1403] = {
    [sym_do_group] = STATE(487),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1404] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(1428),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_done] = ACTIONS(3055),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1405] = {
    [sym_command_substitution] = STATE(1429),
    [sym_simple_expansion] = STATE(1429),
    [sym_expansion] = STATE(1429),
    [aux_sym_heredoc_body_repeat1] = STATE(1429),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym__heredoc_body_end] = ACTIONS(3057),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [sym__heredoc_body_middle] = ACTIONS(3059),
  },
  [1406] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1430),
    [sym_concatenation] = STATE(1430),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3061),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_COLON_DASH] = ACTIONS(3061),
  },
  [1407] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1408] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1430),
    [sym_concatenation] = STATE(1430),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3061),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3061),
    [anon_sym_COLON] = ACTIONS(3061),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3061),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_EQ] = ACTIONS(3061),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3065),
    [anon_sym_COLON_DASH] = ACTIONS(3061),
    [sym_regex] = ACTIONS(3067),
  },
  [1409] = {
    [sym_command_substitution] = STATE(1432),
    [aux_sym__literal_repeat1] = STATE(1433),
    [sym_string] = STATE(1432),
    [sym_process_substitution] = STATE(1432),
    [sym_simple_expansion] = STATE(1432),
    [sym_string_expansion] = STATE(1432),
    [sym_concatenation] = STATE(1434),
    [sym_expansion] = STATE(1432),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3069),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3069),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1410] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1436),
    [sym_concatenation] = STATE(1436),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3071),
    [anon_sym_COLON] = ACTIONS(3071),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3071),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(3071),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3075),
    [anon_sym_COLON_DASH] = ACTIONS(3071),
    [sym_regex] = ACTIONS(3077),
  },
  [1411] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3073),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1412] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3063),
    [sym__concat] = ACTIONS(1265),
  },
  [1413] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3079),
    [sym__special_character] = ACTIONS(1267),
  },
  [1414] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3063),
  },
  [1415] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1437),
    [sym_concatenation] = STATE(1437),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3081),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3081),
    [anon_sym_COLON] = ACTIONS(3081),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3081),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(3081),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3085),
    [anon_sym_COLON_DASH] = ACTIONS(3081),
  },
  [1416] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3083),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1417] = {
    [sym_compound_statement] = STATE(496),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
  },
  [1418] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3087),
    [anon_sym_SEMI] = ACTIONS(3089),
    [anon_sym_SEMI_SEMI] = ACTIONS(3089),
    [anon_sym_AMP] = ACTIONS(3089),
  },
  [1419] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3091),
  },
  [1420] = {
    [aux_sym_if_statement_repeat1] = STATE(264),
    [sym_elif_clause] = STATE(264),
    [sym_else_clause] = STATE(1438),
    [anon_sym_elif] = ACTIONS(1309),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3091),
    [anon_sym_else] = ACTIONS(1311),
  },
  [1421] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_elif_clause] = STATE(1439),
    [sym_else_clause] = STATE(1438),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_if_statement_repeat1] = STATE(1439),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_elif] = ACTIONS(960),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_fi] = ACTIONS(3093),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_else] = ACTIONS(956),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1422] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1441),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(2423),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(2423),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(3095),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [1423] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1443),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(2424),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(2424),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(3097),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [1424] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1006),
  },
  [1425] = {
    [sym_command_substitution] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_string_expansion] = STATE(818),
    [sym_string] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [sym_expansion] = STATE(818),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(1361),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_RBRACK] = ACTIONS(3101),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(1365),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [1426] = {
    [anon_sym_RBRACK] = ACTIONS(3103),
    [sym_comment] = ACTIONS(51),
  },
  [1427] = {
    [anon_sym_RBRACK] = ACTIONS(3101),
    [sym_comment] = ACTIONS(51),
  },
  [1428] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(209),
    [sym_function_definition] = STATE(209),
    [sym_negated_command] = STATE(209),
    [sym_test_command] = STATE(209),
    [sym_variable_assignment] = STATE(210),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(209),
    [sym_for_statement] = STATE(209),
    [sym_compound_statement] = STATE(209),
    [sym_subshell] = STATE(209),
    [sym_declaration_command] = STATE(209),
    [sym_unset_command] = STATE(209),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [aux_sym__statements2] = STATE(267),
    [sym_c_style_for_statement] = STATE(209),
    [sym_while_statement] = STATE(209),
    [sym_case_statement] = STATE(209),
    [sym_pipeline] = STATE(209),
    [sym_list] = STATE(209),
    [sym_command] = STATE(209),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_done] = ACTIONS(3105),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1429] = {
    [sym_command_substitution] = STATE(292),
    [sym_simple_expansion] = STATE(292),
    [sym_expansion] = STATE(292),
    [aux_sym_heredoc_body_repeat1] = STATE(292),
    [anon_sym_BQUOTE] = ACTIONS(1113),
    [sym__heredoc_body_end] = ACTIONS(3107),
    [anon_sym_DOLLAR] = ACTIONS(1111),
    [sym_comment] = ACTIONS(51),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1119),
    [sym__heredoc_body_middle] = ACTIONS(1425),
  },
  [1430] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1431] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1446),
    [sym_concatenation] = STATE(1446),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3111),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3111),
    [anon_sym_COLON] = ACTIONS(3111),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3111),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [anon_sym_EQ] = ACTIONS(3111),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3113),
    [anon_sym_COLON_DASH] = ACTIONS(3111),
  },
  [1432] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3109),
    [sym__concat] = ACTIONS(1265),
  },
  [1433] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3115),
    [sym__special_character] = ACTIONS(1267),
  },
  [1434] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3109),
  },
  [1435] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1447),
    [sym_concatenation] = STATE(1447),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3117),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3117),
    [anon_sym_COLON] = ACTIONS(3117),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3117),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(3117),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3121),
    [anon_sym_COLON_DASH] = ACTIONS(3117),
  },
  [1436] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3119),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1437] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3123),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1438] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3125),
  },
  [1439] = {
    [aux_sym_if_statement_repeat1] = STATE(264),
    [sym_elif_clause] = STATE(264),
    [sym_else_clause] = STATE(1448),
    [anon_sym_elif] = ACTIONS(1309),
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3125),
    [anon_sym_else] = ACTIONS(1311),
  },
  [1440] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1449),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(2427),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(2427),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(3127),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [1441] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3129),
  },
  [1442] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1450),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(2428),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(2428),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1319),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_esac] = ACTIONS(3131),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [1443] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3133),
  },
  [1444] = {
    [sym_do_group] = STATE(519),
    [sym_comment] = ACTIONS(51),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1445] = {
    [sym_do_group] = STATE(520),
    [sym_compound_statement] = STATE(520),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_SEMI] = ACTIONS(3135),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1446] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3137),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1447] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3139),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1448] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_fi] = ACTIONS(3141),
  },
  [1449] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3143),
  },
  [1450] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3145),
  },
  [1451] = {
    [sym_do_group] = STATE(526),
    [sym_compound_statement] = STATE(526),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1452] = {
    [sym_do_group] = STATE(526),
    [sym_compound_statement] = STATE(526),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_SEMI] = ACTIONS(3147),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1453] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3149),
  },
  [1454] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_esac] = ACTIONS(3151),
  },
  [1455] = {
    [sym_do_group] = STATE(529),
    [sym_compound_statement] = STATE(529),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1456] = {
    [sym_do_group] = STATE(529),
    [sym_compound_statement] = STATE(529),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_SEMI] = ACTIONS(3153),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1457] = {
    [sym_do_group] = STATE(530),
    [sym_compound_statement] = STATE(530),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1458] = {
    [sym_do_group] = STATE(530),
    [sym_compound_statement] = STATE(530),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_SEMI] = ACTIONS(3155),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1459] = {
    [sym_do_group] = STATE(531),
    [sym_compound_statement] = STATE(531),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_do] = ACTIONS(2999),
  },
  [1460] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [sym_test_command] = STATE(409),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(1463),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_command] = STATE(409),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [sym_subshell] = STATE(409),
    [sym_file_redirect] = STATE(1463),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_word] = ACTIONS(89),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
    [sym__special_character] = ACTIONS(81),
  },
  [1461] = {
    [sym_heredoc_redirect] = STATE(417),
    [aux_sym_redirected_statement_repeat1] = STATE(417),
    [sym_herestring_redirect] = STATE(417),
    [sym_file_redirect] = STATE(417),
    [anon_sym_SEMI_SEMI] = ACTIONS(2232),
    [anon_sym_BQUOTE] = ACTIONS(1976),
    [anon_sym_AMP_GT_GT] = ACTIONS(481),
    [anon_sym_LF] = ACTIONS(2234),
    [anon_sym_SEMI] = ACTIONS(2232),
    [sym_file_descriptor] = ACTIONS(487),
    [anon_sym_LT_LT] = ACTIONS(489),
    [anon_sym_GT] = ACTIONS(481),
    [anon_sym_AMP_GT] = ACTIONS(481),
    [anon_sym_PIPE_PIPE] = ACTIONS(2228),
    [anon_sym_LT_LT_LT] = ACTIONS(493),
    [anon_sym_GT_AMP] = ACTIONS(481),
    [anon_sym_AMP] = ACTIONS(2232),
    [anon_sym_LT] = ACTIONS(481),
    [anon_sym_LT_AMP] = ACTIONS(481),
    [anon_sym_GT_GT] = ACTIONS(481),
    [anon_sym_PIPE] = ACTIONS(2230),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(2228),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_PIPE_AMP] = ACTIONS(2230),
  },
  [1462] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(701),
    [sym_function_definition] = STATE(701),
    [sym_negated_command] = STATE(701),
    [sym_test_command] = STATE(701),
    [sym_variable_assignment] = STATE(702),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(101),
    [sym_redirected_statement] = STATE(701),
    [sym_for_statement] = STATE(701),
    [sym_compound_statement] = STATE(701),
    [sym_subshell] = STATE(701),
    [sym_declaration_command] = STATE(701),
    [sym_unset_command] = STATE(701),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(701),
    [sym_while_statement] = STATE(701),
    [sym_case_statement] = STATE(701),
    [sym_pipeline] = STATE(701),
    [sym_list] = STATE(701),
    [sym_command] = STATE(701),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [1463] = {
    [sym_command_substitution] = STATE(384),
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_expansion] = STATE(384),
    [sym_string] = STATE(384),
    [sym_command_name] = STATE(569),
    [sym_process_substitution] = STATE(384),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [sym_subscript] = STATE(2455),
    [sym_variable_assignment] = STATE(103),
    [aux_sym_command_repeat1] = STATE(103),
    [sym_concatenation] = STATE(389),
    [sym_file_redirect] = STATE(103),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [sym_raw_string] = ACTIONS(89),
    [sym_variable_name] = ACTIONS(249),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [sym_word] = ACTIONS(89),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1978),
  },
  [1464] = {
    [sym_heredoc_body] = STATE(666),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(650),
  },
  [1465] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2095),
    [anon_sym_LF] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(3159),
    [anon_sym_SEMI_SEMI] = ACTIONS(3159),
    [anon_sym_AMP] = ACTIONS(3159),
  },
  [1466] = {
    [sym_heredoc_body] = STATE(679),
    [anon_sym_LPAREN] = ACTIONS(642),
    [anon_sym_AMP_GT_GT] = ACTIONS(644),
    [anon_sym_local] = ACTIONS(642),
    [anon_sym_typeset] = ACTIONS(642),
    [anon_sym_unsetenv] = ACTIONS(642),
    [anon_sym_DOLLAR] = ACTIONS(642),
    [anon_sym_GT_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(644),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(644),
    [anon_sym_function] = ACTIONS(642),
    [sym_word] = ACTIONS(642),
    [anon_sym_LBRACE] = ACTIONS(644),
    [anon_sym_LT] = ACTIONS(642),
    [anon_sym_LT_AMP] = ACTIONS(644),
    [anon_sym_GT_GT] = ACTIONS(644),
    [anon_sym_export] = ACTIONS(642),
    [sym__simple_heredoc_body] = ACTIONS(948),
    [sym__special_character] = ACTIONS(642),
    [anon_sym_if] = ACTIONS(642),
    [anon_sym_case] = ACTIONS(642),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(644),
    [anon_sym_BQUOTE] = ACTIONS(644),
    [anon_sym_BANG] = ACTIONS(642),
    [anon_sym_declare] = ACTIONS(642),
    [sym_variable_name] = ACTIONS(644),
    [sym_file_descriptor] = ACTIONS(644),
    [sym__heredoc_body_beginning] = ACTIONS(950),
    [anon_sym_GT] = ACTIONS(642),
    [anon_sym_AMP_GT] = ACTIONS(642),
    [anon_sym_readonly] = ACTIONS(642),
    [anon_sym_unset] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_GT_AMP] = ACTIONS(644),
    [anon_sym_LT_LPAREN] = ACTIONS(644),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(642),
    [anon_sym_while] = ACTIONS(642),
    [anon_sym_LBRACK] = ACTIONS(642),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(644),
    [anon_sym_SEMI_SEMI] = ACTIONS(1123),
  },
  [1467] = {
    [sym_comment] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(2162),
    [anon_sym_LF] = ACTIONS(3161),
    [anon_sym_SEMI] = ACTIONS(3163),
    [anon_sym_SEMI_SEMI] = ACTIONS(3163),
    [anon_sym_AMP] = ACTIONS(3163),
  },
  [1468] = {
    [sym_command_substitution] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_string_expansion] = STATE(818),
    [sym_string] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [sym_expansion] = STATE(818),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(1361),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(1361),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [1469] = {
    [sym_command_substitution] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_string] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(2739),
    [sym_raw_string] = ACTIONS(2739),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(3167),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [sym__special_character] = ACTIONS(2739),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
  },
  [1470] = {
    [sym_command_substitution] = STATE(545),
    [aux_sym__literal_repeat1] = STATE(546),
    [sym_string] = STATE(545),
    [sym_process_substitution] = STATE(545),
    [sym_simple_expansion] = STATE(545),
    [sym_string_expansion] = STATE(545),
    [sym_concatenation] = STATE(547),
    [sym_expansion] = STATE(545),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(3169),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(3169),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3007),
  },
  [1471] = {
    [sym_string] = STATE(555),
    [anon_sym_STAR] = ACTIONS(3171),
    [sym_raw_string] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_DOLLAR] = ACTIONS(2382),
    [anon_sym_0] = ACTIONS(2378),
    [anon_sym_DASH] = ACTIONS(2382),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [anon_sym_QMARK] = ACTIONS(3171),
    [anon_sym_AT] = ACTIONS(3171),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2382),
    [anon_sym__] = ACTIONS(2378),
  },
  [1472] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1484),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3173),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3175),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1473] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3177),
  },
  [1474] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3179),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1475] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3179),
  },
  [1476] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1486),
    [sym_concatenation] = STATE(1486),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3181),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3181),
    [anon_sym_COLON] = ACTIONS(3181),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3183),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3181),
    [anon_sym_RBRACE] = ACTIONS(3185),
    [anon_sym_EQ] = ACTIONS(3181),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3187),
    [anon_sym_COLON_DASH] = ACTIONS(3181),
  },
  [1477] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1491),
    [sym_concatenation] = STATE(1491),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3189),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3189),
    [anon_sym_COLON] = ACTIONS(3189),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3191),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3189),
    [anon_sym_RBRACE] = ACTIONS(3193),
    [anon_sym_EQ] = ACTIONS(3189),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3195),
    [anon_sym_COLON_DASH] = ACTIONS(3189),
  },
  [1478] = {
    [sym_command_substitution] = STATE(580),
    [sym_string] = STATE(580),
    [sym_process_substitution] = STATE(580),
    [sym_simple_expansion] = STATE(580),
    [sym_string_expansion] = STATE(580),
    [sym_expansion] = STATE(580),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [sym_raw_string] = ACTIONS(2320),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [anon_sym_GT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(117),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_word] = ACTIONS(2320),
    [anon_sym_LT_LPAREN] = ACTIONS(113),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2320),
  },
  [1479] = {
    [sym_command_substitution] = STATE(558),
    [sym_unary_expression] = STATE(583),
    [sym_postfix_expression] = STATE(583),
    [sym_string] = STATE(558),
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_process_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(583),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym__expression] = STATE(583),
    [sym_binary_expression] = STATE(583),
    [sym_concatenation] = STATE(583),
    [sym_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(2327),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [sym_word] = ACTIONS(607),
    [sym_raw_string] = ACTIONS(2331),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_LT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [sym__special_character] = ACTIONS(2339),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2341),
  },
  [1480] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3197),
  },
  [1481] = {
    [sym_command_substitution] = STATE(588),
    [aux_sym__literal_repeat1] = STATE(590),
    [sym_string] = STATE(588),
    [sym_array] = STATE(589),
    [sym_process_substitution] = STATE(588),
    [sym_simple_expansion] = STATE(588),
    [sym_string_expansion] = STATE(588),
    [sym_concatenation] = STATE(589),
    [sym_expansion] = STATE(588),
    [anon_sym_LPAREN] = ACTIONS(3199),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [sym_word] = ACTIONS(3201),
    [sym_raw_string] = ACTIONS(3201),
    [anon_sym_LT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2465),
    [sym__special_character] = ACTIONS(3203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
    [sym__empty_value] = ACTIONS(3205),
  },
  [1482] = {
    [sym_command_substitution] = STATE(591),
    [aux_sym__literal_repeat1] = STATE(592),
    [sym_string] = STATE(591),
    [sym_process_substitution] = STATE(591),
    [sym_simple_expansion] = STATE(591),
    [sym_string_expansion] = STATE(591),
    [sym_concatenation] = STATE(593),
    [sym_expansion] = STATE(591),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(3207),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(3207),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3007),
  },
  [1483] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1484] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3209),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3211),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1485] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1496),
    [sym_concatenation] = STATE(1496),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3213),
    [anon_sym_COLON] = ACTIONS(3213),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3217),
    [anon_sym_COLON_DASH] = ACTIONS(3213),
    [sym_regex] = ACTIONS(3219),
  },
  [1486] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1487] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1496),
    [sym_concatenation] = STATE(1496),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3213),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3213),
    [anon_sym_COLON] = ACTIONS(3213),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3221),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3213),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_EQ] = ACTIONS(3213),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3217),
    [anon_sym_COLON_DASH] = ACTIONS(3213),
  },
  [1488] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1500),
    [sym_concatenation] = STATE(1500),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3223),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3223),
    [anon_sym_COLON] = ACTIONS(3223),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3225),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3223),
    [anon_sym_RBRACE] = ACTIONS(3227),
    [anon_sym_EQ] = ACTIONS(3223),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3229),
    [anon_sym_COLON_DASH] = ACTIONS(3223),
  },
  [1489] = {
    [sym_command_substitution] = STATE(1501),
    [aux_sym__literal_repeat1] = STATE(1502),
    [sym_string] = STATE(1501),
    [sym_process_substitution] = STATE(1501),
    [sym_simple_expansion] = STATE(1501),
    [sym_string_expansion] = STATE(1501),
    [sym_concatenation] = STATE(1503),
    [sym_expansion] = STATE(1501),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3231),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3215),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3231),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1490] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1505),
    [sym_concatenation] = STATE(1505),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3233),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3233),
    [anon_sym_COLON] = ACTIONS(3233),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3233),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_EQ] = ACTIONS(3233),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3237),
    [anon_sym_COLON_DASH] = ACTIONS(3233),
    [sym_regex] = ACTIONS(3239),
  },
  [1491] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3235),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1492] = {
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_RPAREN] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [anon_sym_LT] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_AMP_AMP] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
  },
  [1493] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1506),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1506),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3243),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1494] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3245),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1495] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1507),
    [sym_concatenation] = STATE(1507),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3247),
    [anon_sym_COLON] = ACTIONS(3247),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3251),
    [anon_sym_COLON_DASH] = ACTIONS(3247),
  },
  [1496] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1497] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1507),
    [sym_concatenation] = STATE(1507),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3247),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3247),
    [anon_sym_COLON] = ACTIONS(3247),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3247),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_EQ] = ACTIONS(3247),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3251),
    [anon_sym_COLON_DASH] = ACTIONS(3247),
    [sym_regex] = ACTIONS(3253),
  },
  [1498] = {
    [sym_command_substitution] = STATE(1509),
    [aux_sym__literal_repeat1] = STATE(1510),
    [sym_string] = STATE(1509),
    [sym_process_substitution] = STATE(1509),
    [sym_simple_expansion] = STATE(1509),
    [sym_string_expansion] = STATE(1509),
    [sym_concatenation] = STATE(1511),
    [sym_expansion] = STATE(1509),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3255),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3255),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1499] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1513),
    [sym_concatenation] = STATE(1513),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3257),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3257),
    [anon_sym_COLON] = ACTIONS(3257),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3257),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_EQ] = ACTIONS(3257),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3261),
    [anon_sym_COLON_DASH] = ACTIONS(3257),
    [sym_regex] = ACTIONS(3263),
  },
  [1500] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3259),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1501] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3249),
    [sym__concat] = ACTIONS(1265),
  },
  [1502] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3265),
    [sym__special_character] = ACTIONS(1267),
  },
  [1503] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3249),
  },
  [1504] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1514),
    [sym_concatenation] = STATE(1514),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3267),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3267),
    [anon_sym_COLON] = ACTIONS(3267),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3267),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_EQ] = ACTIONS(3267),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3271),
    [anon_sym_COLON_DASH] = ACTIONS(3267),
  },
  [1505] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3269),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1506] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3273),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1507] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1508] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1515),
    [sym_concatenation] = STATE(1515),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3277),
    [anon_sym_COLON] = ACTIONS(3277),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3277),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [anon_sym_EQ] = ACTIONS(3277),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3279),
    [anon_sym_COLON_DASH] = ACTIONS(3277),
  },
  [1509] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3275),
    [sym__concat] = ACTIONS(1265),
  },
  [1510] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3281),
    [sym__special_character] = ACTIONS(1267),
  },
  [1511] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3275),
  },
  [1512] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1516),
    [sym_concatenation] = STATE(1516),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3283),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3283),
    [anon_sym_COLON] = ACTIONS(3283),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3283),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(3283),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3287),
    [anon_sym_COLON_DASH] = ACTIONS(3283),
  },
  [1513] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3285),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1514] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3289),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1515] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3291),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1516] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3293),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1517] = {
    [sym_string] = STATE(639),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [anon_sym_STAR] = ACTIONS(3295),
    [anon_sym_QMARK] = ACTIONS(3295),
    [sym_raw_string] = ACTIONS(3297),
    [anon_sym_BANG] = ACTIONS(3299),
    [anon_sym_AT] = ACTIONS(3295),
    [anon_sym_DOLLAR] = ACTIONS(3299),
    [anon_sym_POUND] = ACTIONS(3299),
    [anon_sym_DASH] = ACTIONS(3299),
    [anon_sym_0] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2472),
    [anon_sym__] = ACTIONS(2472),
  },
  [1518] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1528),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3301),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3303),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1519] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3305),
  },
  [1520] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3307),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1521] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3307),
  },
  [1522] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1530),
    [sym_concatenation] = STATE(1530),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3309),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3311),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3313),
    [anon_sym_DASH] = ACTIONS(3311),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3311),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3311),
    [anon_sym_PERCENT] = ACTIONS(3311),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3315),
    [anon_sym_COLON_DASH] = ACTIONS(3311),
    [sym__special_character] = ACTIONS(441),
  },
  [1523] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1535),
    [sym_concatenation] = STATE(1535),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3317),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3319),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3321),
    [anon_sym_DASH] = ACTIONS(3319),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3319),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3319),
    [anon_sym_PERCENT] = ACTIONS(3319),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3323),
    [anon_sym_COLON_DASH] = ACTIONS(3319),
    [sym__special_character] = ACTIONS(441),
  },
  [1524] = {
    [sym_command_substitution] = STATE(657),
    [sym_simple_expansion] = STATE(657),
    [sym_string_expansion] = STATE(657),
    [sym_string] = STATE(657),
    [sym_process_substitution] = STATE(657),
    [sym_expansion] = STATE(657),
    [anon_sym_BQUOTE] = ACTIONS(2455),
    [anon_sym_DQUOTE] = ACTIONS(2457),
    [sym_word] = ACTIONS(2459),
    [sym_raw_string] = ACTIONS(2459),
    [anon_sym_LT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR] = ACTIONS(125),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2461),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2465),
    [sym__special_character] = ACTIONS(2459),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2467),
  },
  [1525] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3325),
  },
  [1526] = {
    [sym_command_substitution] = STATE(661),
    [aux_sym__literal_repeat1] = STATE(663),
    [sym_string] = STATE(661),
    [sym_array] = STATE(662),
    [sym_process_substitution] = STATE(661),
    [sym_simple_expansion] = STATE(661),
    [sym_string_expansion] = STATE(661),
    [sym_concatenation] = STATE(662),
    [sym_expansion] = STATE(661),
    [anon_sym_LPAREN] = ACTIONS(3327),
    [anon_sym_BQUOTE] = ACTIONS(107),
    [anon_sym_DQUOTE] = ACTIONS(119),
    [sym_word] = ACTIONS(3329),
    [sym_raw_string] = ACTIONS(3329),
    [anon_sym_LT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR] = ACTIONS(111),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(115),
    [sym__special_character] = ACTIONS(121),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(117),
    [sym__empty_value] = ACTIONS(3331),
  },
  [1527] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1528] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3335),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3333),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1529] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1539),
    [sym_concatenation] = STATE(1539),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3337),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3337),
    [anon_sym_PERCENT] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3341),
    [anon_sym_COLON_DASH] = ACTIONS(3337),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3343),
  },
  [1530] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1531] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1539),
    [sym_concatenation] = STATE(1539),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3345),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3337),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_DASH] = ACTIONS(3337),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3337),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3337),
    [anon_sym_PERCENT] = ACTIONS(3337),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3341),
    [anon_sym_COLON_DASH] = ACTIONS(3337),
    [sym__special_character] = ACTIONS(441),
  },
  [1532] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1543),
    [sym_concatenation] = STATE(1543),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3347),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3349),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3351),
    [anon_sym_DASH] = ACTIONS(3349),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3349),
    [anon_sym_PERCENT] = ACTIONS(3349),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3353),
    [anon_sym_COLON_DASH] = ACTIONS(3349),
    [sym__special_character] = ACTIONS(441),
  },
  [1533] = {
    [sym_command_substitution] = STATE(1544),
    [aux_sym__literal_repeat1] = STATE(1545),
    [sym_string] = STATE(1544),
    [sym_process_substitution] = STATE(1544),
    [sym_simple_expansion] = STATE(1544),
    [sym_string_expansion] = STATE(1544),
    [sym_concatenation] = STATE(1546),
    [sym_expansion] = STATE(1544),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3355),
    [sym_raw_string] = ACTIONS(3355),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3339),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1534] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1548),
    [sym_concatenation] = STATE(1548),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3357),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(3357),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3357),
    [anon_sym_PERCENT] = ACTIONS(3357),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3361),
    [anon_sym_COLON_DASH] = ACTIONS(3357),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3363),
  },
  [1535] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3359),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1536] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1549),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1549),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3365),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1537] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3367),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1538] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1550),
    [sym_concatenation] = STATE(1550),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3369),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3369),
    [anon_sym_PERCENT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3373),
    [anon_sym_COLON_DASH] = ACTIONS(3369),
    [sym__special_character] = ACTIONS(441),
  },
  [1539] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1540] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1550),
    [sym_concatenation] = STATE(1550),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3369),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_DASH] = ACTIONS(3369),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3369),
    [anon_sym_PERCENT] = ACTIONS(3369),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3373),
    [anon_sym_COLON_DASH] = ACTIONS(3369),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3375),
  },
  [1541] = {
    [sym_command_substitution] = STATE(1552),
    [aux_sym__literal_repeat1] = STATE(1553),
    [sym_string] = STATE(1552),
    [sym_process_substitution] = STATE(1552),
    [sym_simple_expansion] = STATE(1552),
    [sym_string_expansion] = STATE(1552),
    [sym_concatenation] = STATE(1554),
    [sym_expansion] = STATE(1552),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3377),
    [sym_raw_string] = ACTIONS(3377),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1542] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1556),
    [sym_concatenation] = STATE(1556),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3379),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(3379),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3379),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3379),
    [anon_sym_PERCENT] = ACTIONS(3379),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3383),
    [anon_sym_COLON_DASH] = ACTIONS(3379),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3385),
  },
  [1543] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3381),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1544] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3371),
    [sym__concat] = ACTIONS(1265),
  },
  [1545] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3387),
  },
  [1546] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3371),
  },
  [1547] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1557),
    [sym_concatenation] = STATE(1557),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3389),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(3389),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3389),
    [anon_sym_PERCENT] = ACTIONS(3389),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3393),
    [anon_sym_COLON_DASH] = ACTIONS(3389),
    [sym__special_character] = ACTIONS(441),
  },
  [1548] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3391),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1549] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3395),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1550] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1551] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1558),
    [sym_concatenation] = STATE(1558),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3399),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [anon_sym_DASH] = ACTIONS(3399),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3399),
    [anon_sym_PERCENT] = ACTIONS(3399),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3401),
    [anon_sym_COLON_DASH] = ACTIONS(3399),
    [sym__special_character] = ACTIONS(441),
  },
  [1552] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3397),
    [sym__concat] = ACTIONS(1265),
  },
  [1553] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3403),
  },
  [1554] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3397),
  },
  [1555] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1559),
    [sym_concatenation] = STATE(1559),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3405),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(3405),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3405),
    [anon_sym_PERCENT] = ACTIONS(3405),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3409),
    [anon_sym_COLON_DASH] = ACTIONS(3405),
    [sym__special_character] = ACTIONS(441),
  },
  [1556] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1557] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3411),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1558] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1559] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1560] = {
    [sym_string] = STATE(695),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [anon_sym_STAR] = ACTIONS(3417),
    [anon_sym_QMARK] = ACTIONS(3417),
    [sym_raw_string] = ACTIONS(3419),
    [anon_sym_BANG] = ACTIONS(3421),
    [anon_sym_AT] = ACTIONS(3417),
    [anon_sym_DOLLAR] = ACTIONS(3421),
    [anon_sym_POUND] = ACTIONS(3421),
    [anon_sym_DASH] = ACTIONS(3421),
    [anon_sym_0] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2504),
    [anon_sym__] = ACTIONS(2504),
  },
  [1561] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1571),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1562] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3427),
  },
  [1563] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1564] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3429),
  },
  [1565] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1573),
    [sym_concatenation] = STATE(1573),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3431),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3433),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3435),
    [anon_sym_DASH] = ACTIONS(3433),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3433),
    [anon_sym_PERCENT] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3437),
    [anon_sym_COLON_DASH] = ACTIONS(3433),
    [sym__special_character] = ACTIONS(441),
  },
  [1566] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1578),
    [sym_concatenation] = STATE(1578),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3439),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3441),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3443),
    [anon_sym_DASH] = ACTIONS(3441),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3441),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3441),
    [anon_sym_PERCENT] = ACTIONS(3441),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3445),
    [anon_sym_COLON_DASH] = ACTIONS(3441),
    [sym__special_character] = ACTIONS(441),
  },
  [1567] = {
    [sym_command_substitution] = STATE(707),
    [sym_simple_expansion] = STATE(707),
    [sym_string_expansion] = STATE(707),
    [sym_string] = STATE(707),
    [sym_process_substitution] = STATE(707),
    [sym_expansion] = STATE(707),
    [anon_sym_BQUOTE] = ACTIONS(2487),
    [anon_sym_DQUOTE] = ACTIONS(2489),
    [sym_word] = ACTIONS(2491),
    [sym_raw_string] = ACTIONS(2491),
    [anon_sym_LT_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR] = ACTIONS(149),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2493),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2497),
    [sym__special_character] = ACTIONS(2491),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2499),
  },
  [1568] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3447),
  },
  [1569] = {
    [sym_command_substitution] = STATE(711),
    [aux_sym__literal_repeat1] = STATE(713),
    [sym_string] = STATE(711),
    [sym_array] = STATE(712),
    [sym_process_substitution] = STATE(711),
    [sym_simple_expansion] = STATE(711),
    [sym_string_expansion] = STATE(711),
    [sym_concatenation] = STATE(712),
    [sym_expansion] = STATE(711),
    [anon_sym_LPAREN] = ACTIONS(3449),
    [anon_sym_BQUOTE] = ACTIONS(2581),
    [sym_raw_string] = ACTIONS(3451),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(2587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2593),
    [sym_word] = ACTIONS(3451),
    [anon_sym_LT_LPAREN] = ACTIONS(2587),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(3453),
    [sym__empty_value] = ACTIONS(3455),
  },
  [1570] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1571] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3459),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3457),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1572] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1582),
    [sym_concatenation] = STATE(1582),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3461),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3465),
    [anon_sym_COLON_DASH] = ACTIONS(3461),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3467),
  },
  [1573] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1574] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1582),
    [sym_concatenation] = STATE(1582),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3469),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3461),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_DASH] = ACTIONS(3461),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3461),
    [anon_sym_PERCENT] = ACTIONS(3461),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3465),
    [anon_sym_COLON_DASH] = ACTIONS(3461),
    [sym__special_character] = ACTIONS(441),
  },
  [1575] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1586),
    [sym_concatenation] = STATE(1586),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3471),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3473),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3475),
    [anon_sym_DASH] = ACTIONS(3473),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3473),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3473),
    [anon_sym_PERCENT] = ACTIONS(3473),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3477),
    [anon_sym_COLON_DASH] = ACTIONS(3473),
    [sym__special_character] = ACTIONS(441),
  },
  [1576] = {
    [sym_command_substitution] = STATE(1587),
    [aux_sym__literal_repeat1] = STATE(1588),
    [sym_string] = STATE(1587),
    [sym_process_substitution] = STATE(1587),
    [sym_simple_expansion] = STATE(1587),
    [sym_string_expansion] = STATE(1587),
    [sym_concatenation] = STATE(1589),
    [sym_expansion] = STATE(1587),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3479),
    [sym_raw_string] = ACTIONS(3479),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3463),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1577] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1591),
    [sym_concatenation] = STATE(1591),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3481),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(3481),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3481),
    [anon_sym_PERCENT] = ACTIONS(3481),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3485),
    [anon_sym_COLON_DASH] = ACTIONS(3481),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3487),
  },
  [1578] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3483),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1579] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1592),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1592),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3489),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1006),
  },
  [1580] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3491),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1581] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1593),
    [sym_concatenation] = STATE(1593),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_COLON_DASH] = ACTIONS(3493),
    [sym__special_character] = ACTIONS(441),
  },
  [1582] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1583] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1593),
    [sym_concatenation] = STATE(1593),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3493),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_DASH] = ACTIONS(3493),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3493),
    [anon_sym_PERCENT] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3497),
    [anon_sym_COLON_DASH] = ACTIONS(3493),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3499),
  },
  [1584] = {
    [sym_command_substitution] = STATE(1595),
    [aux_sym__literal_repeat1] = STATE(1596),
    [sym_string] = STATE(1595),
    [sym_process_substitution] = STATE(1595),
    [sym_simple_expansion] = STATE(1595),
    [sym_string_expansion] = STATE(1595),
    [sym_concatenation] = STATE(1597),
    [sym_expansion] = STATE(1595),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3501),
    [sym_raw_string] = ACTIONS(3501),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1585] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1599),
    [sym_concatenation] = STATE(1599),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3503),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(3503),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3503),
    [anon_sym_PERCENT] = ACTIONS(3503),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3507),
    [anon_sym_COLON_DASH] = ACTIONS(3503),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3509),
  },
  [1586] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3505),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1587] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3495),
    [sym__concat] = ACTIONS(1265),
  },
  [1588] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3511),
  },
  [1589] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3495),
  },
  [1590] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1600),
    [sym_concatenation] = STATE(1600),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3513),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(3513),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3513),
    [anon_sym_PERCENT] = ACTIONS(3513),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3517),
    [anon_sym_COLON_DASH] = ACTIONS(3513),
    [sym__special_character] = ACTIONS(441),
  },
  [1591] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3515),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1592] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3519),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1006),
  },
  [1593] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1594] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1601),
    [sym_concatenation] = STATE(1601),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3523),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [anon_sym_DASH] = ACTIONS(3523),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3523),
    [anon_sym_PERCENT] = ACTIONS(3523),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3525),
    [anon_sym_COLON_DASH] = ACTIONS(3523),
    [sym__special_character] = ACTIONS(441),
  },
  [1595] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3521),
    [sym__concat] = ACTIONS(1265),
  },
  [1596] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3527),
  },
  [1597] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3521),
  },
  [1598] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1602),
    [sym_concatenation] = STATE(1602),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3529),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(3529),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3529),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3529),
    [anon_sym_PERCENT] = ACTIONS(3529),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3533),
    [anon_sym_COLON_DASH] = ACTIONS(3529),
    [sym__special_character] = ACTIONS(441),
  },
  [1599] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3531),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1600] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3535),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1601] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3537),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1602] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3539),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1603] = {
    [sym_string] = STATE(734),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [anon_sym_STAR] = ACTIONS(3541),
    [anon_sym_QMARK] = ACTIONS(3541),
    [sym_raw_string] = ACTIONS(3543),
    [anon_sym_BANG] = ACTIONS(3545),
    [anon_sym_AT] = ACTIONS(3541),
    [anon_sym_DOLLAR] = ACTIONS(3545),
    [anon_sym_POUND] = ACTIONS(3545),
    [anon_sym_DASH] = ACTIONS(3545),
    [anon_sym_0] = ACTIONS(2526),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2526),
    [anon_sym__] = ACTIONS(2526),
  },
  [1604] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1614),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3547),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3549),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1605] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3551),
  },
  [1606] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3553),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1607] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3553),
  },
  [1608] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1616),
    [sym_concatenation] = STATE(1616),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3555),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3557),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3559),
    [anon_sym_DASH] = ACTIONS(3557),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3557),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3557),
    [anon_sym_PERCENT] = ACTIONS(3557),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3561),
    [anon_sym_COLON_DASH] = ACTIONS(3557),
    [sym__special_character] = ACTIONS(441),
  },
  [1609] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1621),
    [sym_concatenation] = STATE(1621),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3563),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3565),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3567),
    [anon_sym_DASH] = ACTIONS(3565),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_PERCENT] = ACTIONS(3565),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3569),
    [anon_sym_COLON_DASH] = ACTIONS(3565),
    [sym__special_character] = ACTIONS(441),
  },
  [1610] = {
    [sym_command_substitution] = STATE(744),
    [sym_simple_expansion] = STATE(744),
    [sym_string_expansion] = STATE(744),
    [sym_string] = STATE(744),
    [sym_process_substitution] = STATE(744),
    [sym_expansion] = STATE(744),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [sym_word] = ACTIONS(2515),
    [sym_raw_string] = ACTIONS(2515),
    [anon_sym_LT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(213),
    [sym__special_character] = ACTIONS(2515),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
  },
  [1611] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3571),
  },
  [1612] = {
    [sym_command_substitution] = STATE(748),
    [aux_sym__literal_repeat1] = STATE(750),
    [sym_string] = STATE(748),
    [sym_array] = STATE(749),
    [sym_process_substitution] = STATE(748),
    [sym_simple_expansion] = STATE(748),
    [sym_string_expansion] = STATE(748),
    [sym_concatenation] = STATE(749),
    [sym_expansion] = STATE(748),
    [anon_sym_LPAREN] = ACTIONS(3573),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_word] = ACTIONS(3575),
    [sym_raw_string] = ACTIONS(3575),
    [anon_sym_LT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2911),
    [sym__special_character] = ACTIONS(3579),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
    [sym__empty_value] = ACTIONS(3581),
  },
  [1613] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3583),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1614] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(3585),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1615] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1625),
    [sym_concatenation] = STATE(1625),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3587),
    [anon_sym_PERCENT] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3591),
    [anon_sym_COLON_DASH] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3593),
  },
  [1616] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1617] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1625),
    [sym_concatenation] = STATE(1625),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3595),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3587),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3587),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3587),
    [anon_sym_PERCENT] = ACTIONS(3587),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3591),
    [anon_sym_COLON_DASH] = ACTIONS(3587),
    [sym__special_character] = ACTIONS(441),
  },
  [1618] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1629),
    [sym_concatenation] = STATE(1629),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3597),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3599),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3601),
    [anon_sym_DASH] = ACTIONS(3599),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3599),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3599),
    [anon_sym_PERCENT] = ACTIONS(3599),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3603),
    [anon_sym_COLON_DASH] = ACTIONS(3599),
    [sym__special_character] = ACTIONS(441),
  },
  [1619] = {
    [sym_command_substitution] = STATE(1630),
    [aux_sym__literal_repeat1] = STATE(1631),
    [sym_string] = STATE(1630),
    [sym_process_substitution] = STATE(1630),
    [sym_simple_expansion] = STATE(1630),
    [sym_string_expansion] = STATE(1630),
    [sym_concatenation] = STATE(1632),
    [sym_expansion] = STATE(1630),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3605),
    [sym_raw_string] = ACTIONS(3605),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3589),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1620] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1634),
    [sym_concatenation] = STATE(1634),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3607),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(3607),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3607),
    [anon_sym_PERCENT] = ACTIONS(3607),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3611),
    [anon_sym_COLON_DASH] = ACTIONS(3607),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3613),
  },
  [1621] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3609),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1622] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1635),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1635),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3615),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1623] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(3617),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1624] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1636),
    [sym_concatenation] = STATE(1636),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3619),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3623),
    [anon_sym_COLON_DASH] = ACTIONS(3619),
    [sym__special_character] = ACTIONS(441),
  },
  [1625] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1626] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1636),
    [sym_concatenation] = STATE(1636),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3619),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_DASH] = ACTIONS(3619),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3619),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3619),
    [anon_sym_PERCENT] = ACTIONS(3619),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3623),
    [anon_sym_COLON_DASH] = ACTIONS(3619),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3625),
  },
  [1627] = {
    [sym_command_substitution] = STATE(1638),
    [aux_sym__literal_repeat1] = STATE(1639),
    [sym_string] = STATE(1638),
    [sym_process_substitution] = STATE(1638),
    [sym_simple_expansion] = STATE(1638),
    [sym_string_expansion] = STATE(1638),
    [sym_concatenation] = STATE(1640),
    [sym_expansion] = STATE(1638),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3627),
    [sym_raw_string] = ACTIONS(3627),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1628] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1642),
    [sym_concatenation] = STATE(1642),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3629),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(3629),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3629),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3629),
    [anon_sym_PERCENT] = ACTIONS(3629),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3633),
    [anon_sym_COLON_DASH] = ACTIONS(3629),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3635),
  },
  [1629] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3631),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1630] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3621),
    [sym__concat] = ACTIONS(1265),
  },
  [1631] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3637),
  },
  [1632] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3621),
  },
  [1633] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1643),
    [sym_concatenation] = STATE(1643),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3639),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(3639),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3639),
    [anon_sym_PERCENT] = ACTIONS(3639),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3643),
    [anon_sym_COLON_DASH] = ACTIONS(3639),
    [sym__special_character] = ACTIONS(441),
  },
  [1634] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3641),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1635] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3645),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1636] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1637] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1644),
    [sym_concatenation] = STATE(1644),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3649),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [anon_sym_DASH] = ACTIONS(3649),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3649),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3649),
    [anon_sym_PERCENT] = ACTIONS(3649),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3651),
    [anon_sym_COLON_DASH] = ACTIONS(3649),
    [sym__special_character] = ACTIONS(441),
  },
  [1638] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3647),
    [sym__concat] = ACTIONS(1265),
  },
  [1639] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3653),
  },
  [1640] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3647),
  },
  [1641] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1645),
    [sym_concatenation] = STATE(1645),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3655),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(3655),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3655),
    [anon_sym_PERCENT] = ACTIONS(3655),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3659),
    [anon_sym_COLON_DASH] = ACTIONS(3655),
    [sym__special_character] = ACTIONS(441),
  },
  [1642] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1643] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1644] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1645] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3665),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1646] = {
    [sym_string] = STATE(771),
    [anon_sym_STAR] = ACTIONS(2552),
    [sym_raw_string] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2546),
    [anon_sym_DOLLAR] = ACTIONS(2546),
    [anon_sym_0] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2546),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2550),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [anon_sym_QMARK] = ACTIONS(2552),
    [anon_sym_AT] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2546),
    [anon_sym__] = ACTIONS(2550),
  },
  [1647] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1657),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3667),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3669),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1648] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3671),
  },
  [1649] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3673),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1650] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3673),
  },
  [1651] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1659),
    [sym_concatenation] = STATE(1659),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3675),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3675),
    [anon_sym_COLON] = ACTIONS(3675),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3677),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3675),
    [anon_sym_RBRACE] = ACTIONS(3679),
    [anon_sym_EQ] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3681),
    [anon_sym_COLON_DASH] = ACTIONS(3675),
  },
  [1652] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1664),
    [sym_concatenation] = STATE(1664),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3683),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3683),
    [anon_sym_COLON] = ACTIONS(3683),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3685),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3683),
    [anon_sym_RBRACE] = ACTIONS(3687),
    [anon_sym_EQ] = ACTIONS(3683),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3689),
    [anon_sym_COLON_DASH] = ACTIONS(3683),
  },
  [1653] = {
    [sym_command_substitution] = STATE(781),
    [sym_string] = STATE(781),
    [sym_process_substitution] = STATE(781),
    [sym_simple_expansion] = STATE(781),
    [sym_string_expansion] = STATE(781),
    [sym_expansion] = STATE(781),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(2539),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(2539),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2539),
  },
  [1654] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3691),
  },
  [1655] = {
    [sym_command_substitution] = STATE(785),
    [aux_sym__literal_repeat1] = STATE(787),
    [sym_string] = STATE(785),
    [sym_array] = STATE(786),
    [sym_process_substitution] = STATE(785),
    [sym_simple_expansion] = STATE(785),
    [sym_string_expansion] = STATE(785),
    [sym_concatenation] = STATE(786),
    [sym_expansion] = STATE(785),
    [anon_sym_LPAREN] = ACTIONS(3693),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [sym_word] = ACTIONS(3695),
    [sym_raw_string] = ACTIONS(3695),
    [anon_sym_LT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR] = ACTIONS(2388),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [sym__special_character] = ACTIONS(3697),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
    [sym__empty_value] = ACTIONS(3699),
  },
  [1656] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1657] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3701),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3703),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1658] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1668),
    [sym_concatenation] = STATE(1668),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_COLON] = ACTIONS(3705),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3705),
    [sym_regex] = ACTIONS(3711),
  },
  [1659] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1660] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1668),
    [sym_concatenation] = STATE(1668),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3705),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3705),
    [anon_sym_COLON] = ACTIONS(3705),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3713),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3705),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_EQ] = ACTIONS(3705),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3709),
    [anon_sym_COLON_DASH] = ACTIONS(3705),
  },
  [1661] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1672),
    [sym_concatenation] = STATE(1672),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3715),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3715),
    [anon_sym_COLON] = ACTIONS(3715),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3717),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3715),
    [anon_sym_RBRACE] = ACTIONS(3719),
    [anon_sym_EQ] = ACTIONS(3715),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3721),
    [anon_sym_COLON_DASH] = ACTIONS(3715),
  },
  [1662] = {
    [sym_command_substitution] = STATE(1673),
    [aux_sym__literal_repeat1] = STATE(1674),
    [sym_string] = STATE(1673),
    [sym_process_substitution] = STATE(1673),
    [sym_simple_expansion] = STATE(1673),
    [sym_string_expansion] = STATE(1673),
    [sym_concatenation] = STATE(1675),
    [sym_expansion] = STATE(1673),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3723),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3707),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3723),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1663] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1677),
    [sym_concatenation] = STATE(1677),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3725),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3725),
    [anon_sym_COLON] = ACTIONS(3725),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3725),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(3725),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3729),
    [anon_sym_COLON_DASH] = ACTIONS(3725),
    [sym_regex] = ACTIONS(3731),
  },
  [1664] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3727),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1665] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(1678),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(1678),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3733),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1666] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3735),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1667] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1679),
    [sym_concatenation] = STATE(1679),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_COLON] = ACTIONS(3737),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3741),
    [anon_sym_COLON_DASH] = ACTIONS(3737),
  },
  [1668] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1669] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1679),
    [sym_concatenation] = STATE(1679),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3737),
    [anon_sym_COLON] = ACTIONS(3737),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3737),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_EQ] = ACTIONS(3737),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3741),
    [anon_sym_COLON_DASH] = ACTIONS(3737),
    [sym_regex] = ACTIONS(3743),
  },
  [1670] = {
    [sym_command_substitution] = STATE(1681),
    [aux_sym__literal_repeat1] = STATE(1682),
    [sym_string] = STATE(1681),
    [sym_process_substitution] = STATE(1681),
    [sym_simple_expansion] = STATE(1681),
    [sym_string_expansion] = STATE(1681),
    [sym_concatenation] = STATE(1683),
    [sym_expansion] = STATE(1681),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3745),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3745),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1671] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1685),
    [sym_concatenation] = STATE(1685),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3747),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3747),
    [anon_sym_COLON] = ACTIONS(3747),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3747),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_EQ] = ACTIONS(3747),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3751),
    [anon_sym_COLON_DASH] = ACTIONS(3747),
    [sym_regex] = ACTIONS(3753),
  },
  [1672] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3749),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1673] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3739),
    [sym__concat] = ACTIONS(1265),
  },
  [1674] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3755),
    [sym__special_character] = ACTIONS(1267),
  },
  [1675] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3739),
  },
  [1676] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1686),
    [sym_concatenation] = STATE(1686),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3757),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3757),
    [anon_sym_COLON] = ACTIONS(3757),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3757),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(3757),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3761),
    [anon_sym_COLON_DASH] = ACTIONS(3757),
  },
  [1677] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3759),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1678] = {
    [sym_command_substitution] = STATE(221),
    [aux_sym__literal_repeat1] = STATE(223),
    [sym_string] = STATE(221),
    [sym_process_substitution] = STATE(221),
    [aux_sym_for_statement_repeat1] = STATE(280),
    [sym_simple_expansion] = STATE(221),
    [sym_string_expansion] = STATE(221),
    [sym_concatenation] = STATE(280),
    [sym_expansion] = STATE(221),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(996),
    [sym_raw_string] = ACTIONS(996),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [anon_sym_RPAREN] = ACTIONS(3763),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(1006),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [1679] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1680] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1687),
    [sym_concatenation] = STATE(1687),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3767),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3767),
    [anon_sym_COLON] = ACTIONS(3767),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3767),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [anon_sym_EQ] = ACTIONS(3767),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3769),
    [anon_sym_COLON_DASH] = ACTIONS(3767),
  },
  [1681] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3765),
    [sym__concat] = ACTIONS(1265),
  },
  [1682] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3771),
    [sym__special_character] = ACTIONS(1267),
  },
  [1683] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3765),
  },
  [1684] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1688),
    [sym_concatenation] = STATE(1688),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3773),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3773),
    [anon_sym_COLON] = ACTIONS(3773),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3773),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(3773),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3777),
    [anon_sym_COLON_DASH] = ACTIONS(3773),
  },
  [1685] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3775),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1686] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3779),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1687] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3781),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1688] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3783),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1689] = {
    [sym_string] = STATE(808),
    [anon_sym_STAR] = ACTIONS(2572),
    [sym_raw_string] = ACTIONS(2574),
    [anon_sym_BANG] = ACTIONS(2566),
    [anon_sym_DOLLAR] = ACTIONS(2566),
    [anon_sym_0] = ACTIONS(2570),
    [anon_sym_DASH] = ACTIONS(2566),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2570),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [anon_sym_QMARK] = ACTIONS(2572),
    [anon_sym_AT] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(2566),
    [anon_sym__] = ACTIONS(2570),
  },
  [1690] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1699),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3785),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3787),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1691] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3789),
  },
  [1692] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3791),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1693] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3791),
  },
  [1694] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1701),
    [sym_concatenation] = STATE(1701),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3793),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3795),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3797),
    [anon_sym_DASH] = ACTIONS(3795),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3795),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3795),
    [anon_sym_PERCENT] = ACTIONS(3795),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3799),
    [anon_sym_COLON_DASH] = ACTIONS(3795),
    [sym__special_character] = ACTIONS(441),
  },
  [1695] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1706),
    [sym_concatenation] = STATE(1706),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3801),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3803),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3805),
    [anon_sym_DASH] = ACTIONS(3803),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3803),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3803),
    [anon_sym_PERCENT] = ACTIONS(3803),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3807),
    [anon_sym_COLON_DASH] = ACTIONS(3803),
    [sym__special_character] = ACTIONS(441),
  },
  [1696] = {
    [sym_command_substitution] = STATE(818),
    [sym_string] = STATE(818),
    [sym_process_substitution] = STATE(818),
    [sym_simple_expansion] = STATE(818),
    [sym_string_expansion] = STATE(818),
    [sym_expansion] = STATE(818),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(1361),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(1361),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1361),
  },
  [1697] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3809),
  },
  [1698] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3811),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1699] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3811),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1700] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1709),
    [sym_concatenation] = STATE(1709),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3815),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_PERCENT] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3819),
    [anon_sym_COLON_DASH] = ACTIONS(3815),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3821),
  },
  [1701] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1702] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1709),
    [sym_concatenation] = STATE(1709),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3823),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3815),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_DASH] = ACTIONS(3815),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3815),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3815),
    [anon_sym_PERCENT] = ACTIONS(3815),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3819),
    [anon_sym_COLON_DASH] = ACTIONS(3815),
    [sym__special_character] = ACTIONS(441),
  },
  [1703] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1713),
    [sym_concatenation] = STATE(1713),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3825),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3827),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3829),
    [anon_sym_DASH] = ACTIONS(3827),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3827),
    [anon_sym_PERCENT] = ACTIONS(3827),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3831),
    [anon_sym_COLON_DASH] = ACTIONS(3827),
    [sym__special_character] = ACTIONS(441),
  },
  [1704] = {
    [sym_command_substitution] = STATE(1714),
    [aux_sym__literal_repeat1] = STATE(1715),
    [sym_string] = STATE(1714),
    [sym_process_substitution] = STATE(1714),
    [sym_simple_expansion] = STATE(1714),
    [sym_string_expansion] = STATE(1714),
    [sym_concatenation] = STATE(1716),
    [sym_expansion] = STATE(1714),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3833),
    [sym_raw_string] = ACTIONS(3833),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3817),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1705] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1718),
    [sym_concatenation] = STATE(1718),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3835),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(3835),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3835),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3835),
    [anon_sym_PERCENT] = ACTIONS(3835),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3839),
    [anon_sym_COLON_DASH] = ACTIONS(3835),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3841),
  },
  [1706] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3837),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1707] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3843),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1708] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1719),
    [sym_concatenation] = STATE(1719),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3849),
    [anon_sym_COLON_DASH] = ACTIONS(3845),
    [sym__special_character] = ACTIONS(441),
  },
  [1709] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1710] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1719),
    [sym_concatenation] = STATE(1719),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3845),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_DASH] = ACTIONS(3845),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3845),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3845),
    [anon_sym_PERCENT] = ACTIONS(3845),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3849),
    [anon_sym_COLON_DASH] = ACTIONS(3845),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3851),
  },
  [1711] = {
    [sym_command_substitution] = STATE(1721),
    [aux_sym__literal_repeat1] = STATE(1722),
    [sym_string] = STATE(1721),
    [sym_process_substitution] = STATE(1721),
    [sym_simple_expansion] = STATE(1721),
    [sym_string_expansion] = STATE(1721),
    [sym_concatenation] = STATE(1723),
    [sym_expansion] = STATE(1721),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3853),
    [sym_raw_string] = ACTIONS(3853),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1712] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1725),
    [sym_concatenation] = STATE(1725),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3855),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(3855),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3855),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3855),
    [anon_sym_PERCENT] = ACTIONS(3855),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3859),
    [anon_sym_COLON_DASH] = ACTIONS(3855),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(3861),
  },
  [1713] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3857),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1714] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3847),
    [sym__concat] = ACTIONS(1265),
  },
  [1715] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3863),
  },
  [1716] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3847),
  },
  [1717] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1726),
    [sym_concatenation] = STATE(1726),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3865),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(3865),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3865),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3865),
    [anon_sym_PERCENT] = ACTIONS(3865),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3869),
    [anon_sym_COLON_DASH] = ACTIONS(3865),
    [sym__special_character] = ACTIONS(441),
  },
  [1718] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3867),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1719] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1720] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1727),
    [sym_concatenation] = STATE(1727),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3873),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [anon_sym_DASH] = ACTIONS(3873),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3873),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3873),
    [anon_sym_PERCENT] = ACTIONS(3873),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3875),
    [anon_sym_COLON_DASH] = ACTIONS(3873),
    [sym__special_character] = ACTIONS(441),
  },
  [1721] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3871),
    [sym__concat] = ACTIONS(1265),
  },
  [1722] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(3877),
  },
  [1723] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3871),
  },
  [1724] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1728),
    [sym_concatenation] = STATE(1728),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3879),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(3879),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(3879),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(3879),
    [anon_sym_PERCENT] = ACTIONS(3879),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3883),
    [anon_sym_COLON_DASH] = ACTIONS(3879),
    [sym__special_character] = ACTIONS(441),
  },
  [1725] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3881),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1726] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3885),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1727] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3887),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1728] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(3889),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1729] = {
    [sym_string] = STATE(840),
    [anon_sym_STAR] = ACTIONS(3891),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_BANG] = ACTIONS(3895),
    [anon_sym_DOLLAR] = ACTIONS(3895),
    [anon_sym_0] = ACTIONS(2600),
    [anon_sym_DASH] = ACTIONS(3895),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2600),
    [anon_sym_DQUOTE] = ACTIONS(2593),
    [anon_sym_QMARK] = ACTIONS(3891),
    [anon_sym_AT] = ACTIONS(3891),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3895),
    [anon_sym__] = ACTIONS(2600),
  },
  [1730] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1739),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3897),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1731] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3901),
  },
  [1732] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(3903),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1733] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(3903),
  },
  [1734] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1741),
    [sym_concatenation] = STATE(1741),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3905),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3905),
    [anon_sym_COLON] = ACTIONS(3905),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3907),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3905),
    [anon_sym_RBRACE] = ACTIONS(3909),
    [anon_sym_EQ] = ACTIONS(3905),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3911),
    [anon_sym_COLON_DASH] = ACTIONS(3905),
  },
  [1735] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1746),
    [sym_concatenation] = STATE(1746),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3913),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3913),
    [anon_sym_COLON] = ACTIONS(3913),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3915),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3913),
    [anon_sym_RBRACE] = ACTIONS(3917),
    [anon_sym_EQ] = ACTIONS(3913),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3919),
    [anon_sym_COLON_DASH] = ACTIONS(3913),
  },
  [1736] = {
    [sym_command_substitution] = STATE(850),
    [sym_string] = STATE(850),
    [sym_process_substitution] = STATE(850),
    [sym_simple_expansion] = STATE(850),
    [sym_string_expansion] = STATE(850),
    [sym_expansion] = STATE(850),
    [anon_sym_BQUOTE] = ACTIONS(2581),
    [sym_raw_string] = ACTIONS(2583),
    [anon_sym_DOLLAR] = ACTIONS(1928),
    [anon_sym_GT_LPAREN] = ACTIONS(2587),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2593),
    [sym_word] = ACTIONS(2583),
    [anon_sym_LT_LPAREN] = ACTIONS(2587),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2583),
  },
  [1737] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(3921),
  },
  [1738] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1739] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(3923),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(3925),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1740] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1749),
    [sym_concatenation] = STATE(1749),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3931),
    [anon_sym_COLON_DASH] = ACTIONS(3927),
    [sym_regex] = ACTIONS(3933),
  },
  [1741] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1742] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1749),
    [sym_concatenation] = STATE(1749),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3927),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3927),
    [anon_sym_COLON] = ACTIONS(3927),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3935),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3927),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_EQ] = ACTIONS(3927),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3931),
    [anon_sym_COLON_DASH] = ACTIONS(3927),
  },
  [1743] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1753),
    [sym_concatenation] = STATE(1753),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3937),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3937),
    [anon_sym_COLON] = ACTIONS(3937),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(3939),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3937),
    [anon_sym_RBRACE] = ACTIONS(3941),
    [anon_sym_EQ] = ACTIONS(3937),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3943),
    [anon_sym_COLON_DASH] = ACTIONS(3937),
  },
  [1744] = {
    [sym_command_substitution] = STATE(1754),
    [aux_sym__literal_repeat1] = STATE(1755),
    [sym_string] = STATE(1754),
    [sym_process_substitution] = STATE(1754),
    [sym_simple_expansion] = STATE(1754),
    [sym_string_expansion] = STATE(1754),
    [sym_concatenation] = STATE(1756),
    [sym_expansion] = STATE(1754),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3945),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3929),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3945),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1745] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1758),
    [sym_concatenation] = STATE(1758),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3947),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3947),
    [anon_sym_COLON] = ACTIONS(3947),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3947),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(3947),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3951),
    [anon_sym_COLON_DASH] = ACTIONS(3947),
    [sym_regex] = ACTIONS(3953),
  },
  [1746] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3949),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1747] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(3955),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1748] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1759),
    [sym_concatenation] = STATE(1759),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_COLON] = ACTIONS(3957),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3961),
    [anon_sym_COLON_DASH] = ACTIONS(3957),
  },
  [1749] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1750] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1759),
    [sym_concatenation] = STATE(1759),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3957),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3957),
    [anon_sym_COLON] = ACTIONS(3957),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3957),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_EQ] = ACTIONS(3957),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3961),
    [anon_sym_COLON_DASH] = ACTIONS(3957),
    [sym_regex] = ACTIONS(3963),
  },
  [1751] = {
    [sym_command_substitution] = STATE(1761),
    [aux_sym__literal_repeat1] = STATE(1762),
    [sym_string] = STATE(1761),
    [sym_process_substitution] = STATE(1761),
    [sym_simple_expansion] = STATE(1761),
    [sym_string_expansion] = STATE(1761),
    [sym_concatenation] = STATE(1763),
    [sym_expansion] = STATE(1761),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(3965),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(3965),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1752] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1765),
    [sym_concatenation] = STATE(1765),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3967),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3967),
    [anon_sym_COLON] = ACTIONS(3967),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3967),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3971),
    [anon_sym_COLON_DASH] = ACTIONS(3967),
    [sym_regex] = ACTIONS(3973),
  },
  [1753] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1754] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3959),
    [sym__concat] = ACTIONS(1265),
  },
  [1755] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3975),
    [sym__special_character] = ACTIONS(1267),
  },
  [1756] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3959),
  },
  [1757] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1766),
    [sym_concatenation] = STATE(1766),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3977),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3977),
    [anon_sym_COLON] = ACTIONS(3977),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3977),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(3977),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3981),
    [anon_sym_COLON_DASH] = ACTIONS(3977),
  },
  [1758] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3979),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1759] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1760] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1767),
    [sym_concatenation] = STATE(1767),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3985),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3985),
    [anon_sym_COLON] = ACTIONS(3985),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3985),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [anon_sym_EQ] = ACTIONS(3985),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3987),
    [anon_sym_COLON_DASH] = ACTIONS(3985),
  },
  [1761] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3983),
    [sym__concat] = ACTIONS(1265),
  },
  [1762] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3989),
    [sym__special_character] = ACTIONS(1267),
  },
  [1763] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(3983),
  },
  [1764] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1768),
    [sym_concatenation] = STATE(1768),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(3991),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(3991),
    [anon_sym_COLON] = ACTIONS(3991),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(3991),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(3991),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3995),
    [anon_sym_COLON_DASH] = ACTIONS(3991),
  },
  [1765] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3993),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1766] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3997),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1767] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3999),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1768] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1769] = {
    [sym_string] = STATE(872),
    [anon_sym_STAR] = ACTIONS(4003),
    [sym_raw_string] = ACTIONS(4005),
    [anon_sym_BANG] = ACTIONS(4007),
    [anon_sym_DOLLAR] = ACTIONS(4007),
    [anon_sym_0] = ACTIONS(2628),
    [anon_sym_DASH] = ACTIONS(4007),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2628),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [anon_sym_QMARK] = ACTIONS(4003),
    [anon_sym_AT] = ACTIONS(4003),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4007),
    [anon_sym__] = ACTIONS(2628),
  },
  [1770] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1779),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4009),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4011),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1771] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4013),
  },
  [1772] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4015),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1773] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4015),
  },
  [1774] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1781),
    [sym_concatenation] = STATE(1781),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4017),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4017),
    [anon_sym_COLON] = ACTIONS(4017),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4019),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4017),
    [anon_sym_RBRACE] = ACTIONS(4021),
    [anon_sym_EQ] = ACTIONS(4017),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4023),
    [anon_sym_COLON_DASH] = ACTIONS(4017),
  },
  [1775] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1786),
    [sym_concatenation] = STATE(1786),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4025),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4025),
    [anon_sym_COLON] = ACTIONS(4025),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4027),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4025),
    [anon_sym_RBRACE] = ACTIONS(4029),
    [anon_sym_EQ] = ACTIONS(4025),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4031),
    [anon_sym_COLON_DASH] = ACTIONS(4025),
  },
  [1776] = {
    [sym_command_substitution] = STATE(882),
    [sym_string] = STATE(882),
    [sym_process_substitution] = STATE(882),
    [sym_simple_expansion] = STATE(882),
    [sym_string_expansion] = STATE(882),
    [sym_expansion] = STATE(882),
    [anon_sym_BQUOTE] = ACTIONS(2609),
    [sym_raw_string] = ACTIONS(2611),
    [anon_sym_DOLLAR] = ACTIONS(1948),
    [anon_sym_GT_LPAREN] = ACTIONS(2615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2619),
    [anon_sym_DQUOTE] = ACTIONS(2621),
    [sym_word] = ACTIONS(2611),
    [anon_sym_LT_LPAREN] = ACTIONS(2615),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2611),
  },
  [1777] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4033),
  },
  [1778] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4035),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1779] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4035),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4037),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1780] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1789),
    [sym_concatenation] = STATE(1789),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4039),
    [anon_sym_COLON] = ACTIONS(4039),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4039),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4039),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4043),
    [anon_sym_COLON_DASH] = ACTIONS(4039),
    [sym_regex] = ACTIONS(4045),
  },
  [1781] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1782] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1789),
    [sym_concatenation] = STATE(1789),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4039),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4039),
    [anon_sym_COLON] = ACTIONS(4039),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4047),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4039),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_EQ] = ACTIONS(4039),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4043),
    [anon_sym_COLON_DASH] = ACTIONS(4039),
  },
  [1783] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1793),
    [sym_concatenation] = STATE(1793),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4049),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4049),
    [anon_sym_COLON] = ACTIONS(4049),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4051),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4049),
    [anon_sym_RBRACE] = ACTIONS(4053),
    [anon_sym_EQ] = ACTIONS(4049),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4055),
    [anon_sym_COLON_DASH] = ACTIONS(4049),
  },
  [1784] = {
    [sym_command_substitution] = STATE(1794),
    [aux_sym__literal_repeat1] = STATE(1795),
    [sym_string] = STATE(1794),
    [sym_process_substitution] = STATE(1794),
    [sym_simple_expansion] = STATE(1794),
    [sym_string_expansion] = STATE(1794),
    [sym_concatenation] = STATE(1796),
    [sym_expansion] = STATE(1794),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4057),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4041),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4057),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1785] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1798),
    [sym_concatenation] = STATE(1798),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4059),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4059),
    [anon_sym_COLON] = ACTIONS(4059),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4059),
    [anon_sym_RBRACE] = ACTIONS(4061),
    [anon_sym_EQ] = ACTIONS(4059),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4063),
    [anon_sym_COLON_DASH] = ACTIONS(4059),
    [sym_regex] = ACTIONS(4065),
  },
  [1786] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4061),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1787] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4067),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1788] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1799),
    [sym_concatenation] = STATE(1799),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4069),
    [anon_sym_COLON] = ACTIONS(4069),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4073),
    [anon_sym_COLON_DASH] = ACTIONS(4069),
  },
  [1789] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1790] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1799),
    [sym_concatenation] = STATE(1799),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4069),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4069),
    [anon_sym_COLON] = ACTIONS(4069),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4069),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(4069),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4073),
    [anon_sym_COLON_DASH] = ACTIONS(4069),
    [sym_regex] = ACTIONS(4075),
  },
  [1791] = {
    [sym_command_substitution] = STATE(1801),
    [aux_sym__literal_repeat1] = STATE(1802),
    [sym_string] = STATE(1801),
    [sym_process_substitution] = STATE(1801),
    [sym_simple_expansion] = STATE(1801),
    [sym_string_expansion] = STATE(1801),
    [sym_concatenation] = STATE(1803),
    [sym_expansion] = STATE(1801),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4077),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4077),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1792] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1805),
    [sym_concatenation] = STATE(1805),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4079),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4079),
    [anon_sym_COLON] = ACTIONS(4079),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4079),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(4079),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4083),
    [anon_sym_COLON_DASH] = ACTIONS(4079),
    [sym_regex] = ACTIONS(4085),
  },
  [1793] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4081),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1794] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [sym__concat] = ACTIONS(1265),
  },
  [1795] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4087),
    [sym__special_character] = ACTIONS(1267),
  },
  [1796] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4071),
  },
  [1797] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1806),
    [sym_concatenation] = STATE(1806),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_COLON] = ACTIONS(4089),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4089),
    [anon_sym_RBRACE] = ACTIONS(4091),
    [anon_sym_EQ] = ACTIONS(4089),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4093),
    [anon_sym_COLON_DASH] = ACTIONS(4089),
  },
  [1798] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4091),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1799] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1800] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1807),
    [sym_concatenation] = STATE(1807),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4097),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4097),
    [anon_sym_COLON] = ACTIONS(4097),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4097),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(4097),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4099),
    [anon_sym_COLON_DASH] = ACTIONS(4097),
  },
  [1801] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [sym__concat] = ACTIONS(1265),
  },
  [1802] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4101),
    [sym__special_character] = ACTIONS(1267),
  },
  [1803] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4095),
  },
  [1804] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1808),
    [sym_concatenation] = STATE(1808),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4103),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4103),
    [anon_sym_COLON] = ACTIONS(4103),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4103),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_EQ] = ACTIONS(4103),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4107),
    [anon_sym_COLON_DASH] = ACTIONS(4103),
  },
  [1805] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1806] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4109),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1807] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1808] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4113),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1809] = {
    [sym_string] = STATE(904),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_STAR] = ACTIONS(4115),
    [anon_sym_QMARK] = ACTIONS(4115),
    [sym_raw_string] = ACTIONS(2646),
    [anon_sym_BANG] = ACTIONS(2650),
    [anon_sym_AT] = ACTIONS(4115),
    [anon_sym_DOLLAR] = ACTIONS(2650),
    [anon_sym_POUND] = ACTIONS(2650),
    [anon_sym_DASH] = ACTIONS(2650),
    [anon_sym_0] = ACTIONS(2644),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2644),
    [anon_sym__] = ACTIONS(2644),
  },
  [1810] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1819),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4117),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4119),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1811] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4121),
  },
  [1812] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4123),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [1813] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4123),
  },
  [1814] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1821),
    [sym_concatenation] = STATE(1821),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4125),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4125),
    [anon_sym_COLON] = ACTIONS(4125),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4127),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4125),
    [anon_sym_RBRACE] = ACTIONS(4129),
    [anon_sym_EQ] = ACTIONS(4125),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4131),
    [anon_sym_COLON_DASH] = ACTIONS(4125),
  },
  [1815] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1826),
    [sym_concatenation] = STATE(1826),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4133),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4133),
    [anon_sym_COLON] = ACTIONS(4133),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4135),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4133),
    [anon_sym_RBRACE] = ACTIONS(4137),
    [anon_sym_EQ] = ACTIONS(4133),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4139),
    [anon_sym_COLON_DASH] = ACTIONS(4133),
  },
  [1816] = {
    [sym_command_substitution] = STATE(914),
    [sym_simple_expansion] = STATE(914),
    [sym_string_expansion] = STATE(914),
    [sym_string] = STATE(914),
    [sym_process_substitution] = STATE(914),
    [sym_expansion] = STATE(914),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(2637),
    [sym_raw_string] = ACTIONS(2637),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [sym__special_character] = ACTIONS(2637),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
  },
  [1817] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4141),
  },
  [1818] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4143),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1819] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4145),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4143),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1820] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1829),
    [sym_concatenation] = STATE(1829),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_COLON] = ACTIONS(4147),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_EQ] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4151),
    [anon_sym_COLON_DASH] = ACTIONS(4147),
    [sym_regex] = ACTIONS(4153),
  },
  [1821] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1822] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1829),
    [sym_concatenation] = STATE(1829),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4147),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4147),
    [anon_sym_COLON] = ACTIONS(4147),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4155),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_EQ] = ACTIONS(4147),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4151),
    [anon_sym_COLON_DASH] = ACTIONS(4147),
  },
  [1823] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1833),
    [sym_concatenation] = STATE(1833),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4157),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4157),
    [anon_sym_COLON] = ACTIONS(4157),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4159),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4157),
    [anon_sym_RBRACE] = ACTIONS(4161),
    [anon_sym_EQ] = ACTIONS(4157),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4163),
    [anon_sym_COLON_DASH] = ACTIONS(4157),
  },
  [1824] = {
    [sym_command_substitution] = STATE(1834),
    [aux_sym__literal_repeat1] = STATE(1835),
    [sym_string] = STATE(1834),
    [sym_process_substitution] = STATE(1834),
    [sym_simple_expansion] = STATE(1834),
    [sym_string_expansion] = STATE(1834),
    [sym_concatenation] = STATE(1836),
    [sym_expansion] = STATE(1834),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4165),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4149),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4165),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1825] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1838),
    [sym_concatenation] = STATE(1838),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4167),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4167),
    [anon_sym_COLON] = ACTIONS(4167),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4167),
    [anon_sym_RBRACE] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(4167),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4171),
    [anon_sym_COLON_DASH] = ACTIONS(4167),
    [sym_regex] = ACTIONS(4173),
  },
  [1826] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4169),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1827] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4175),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1828] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1839),
    [sym_concatenation] = STATE(1839),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4177),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4177),
    [anon_sym_COLON] = ACTIONS(4177),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4177),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(4177),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4181),
    [anon_sym_COLON_DASH] = ACTIONS(4177),
  },
  [1829] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1830] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1839),
    [sym_concatenation] = STATE(1839),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4177),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4177),
    [anon_sym_COLON] = ACTIONS(4177),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4177),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_EQ] = ACTIONS(4177),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4181),
    [anon_sym_COLON_DASH] = ACTIONS(4177),
    [sym_regex] = ACTIONS(4183),
  },
  [1831] = {
    [sym_command_substitution] = STATE(1841),
    [aux_sym__literal_repeat1] = STATE(1842),
    [sym_string] = STATE(1841),
    [sym_process_substitution] = STATE(1841),
    [sym_simple_expansion] = STATE(1841),
    [sym_string_expansion] = STATE(1841),
    [sym_concatenation] = STATE(1843),
    [sym_expansion] = STATE(1841),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4185),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4185),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [1832] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1845),
    [sym_concatenation] = STATE(1845),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4187),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4187),
    [anon_sym_COLON] = ACTIONS(4187),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4187),
    [anon_sym_RBRACE] = ACTIONS(4189),
    [anon_sym_EQ] = ACTIONS(4187),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4191),
    [anon_sym_COLON_DASH] = ACTIONS(4187),
    [sym_regex] = ACTIONS(4193),
  },
  [1833] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4189),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1834] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4179),
    [sym__concat] = ACTIONS(1265),
  },
  [1835] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4195),
    [sym__special_character] = ACTIONS(1267),
  },
  [1836] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4179),
  },
  [1837] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1846),
    [sym_concatenation] = STATE(1846),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4197),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4197),
    [anon_sym_COLON] = ACTIONS(4197),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4197),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_EQ] = ACTIONS(4197),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4201),
    [anon_sym_COLON_DASH] = ACTIONS(4197),
  },
  [1838] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4199),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1839] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4203),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1840] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1847),
    [sym_concatenation] = STATE(1847),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4205),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4205),
    [anon_sym_COLON] = ACTIONS(4205),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4205),
    [anon_sym_RBRACE] = ACTIONS(4203),
    [anon_sym_EQ] = ACTIONS(4205),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4207),
    [anon_sym_COLON_DASH] = ACTIONS(4205),
  },
  [1841] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4203),
    [sym__concat] = ACTIONS(1265),
  },
  [1842] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4209),
    [sym__special_character] = ACTIONS(1267),
  },
  [1843] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4203),
  },
  [1844] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1848),
    [sym_concatenation] = STATE(1848),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4211),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4211),
    [anon_sym_COLON] = ACTIONS(4211),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(4211),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4215),
    [anon_sym_COLON_DASH] = ACTIONS(4211),
  },
  [1845] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4213),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1846] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4217),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1847] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4219),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1848] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4221),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [1849] = {
    [sym_string] = STATE(936),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(4223),
    [anon_sym_QMARK] = ACTIONS(4223),
    [sym_raw_string] = ACTIONS(4225),
    [anon_sym_BANG] = ACTIONS(4227),
    [anon_sym_AT] = ACTIONS(4223),
    [anon_sym_DOLLAR] = ACTIONS(4227),
    [anon_sym_POUND] = ACTIONS(4227),
    [anon_sym_DASH] = ACTIONS(4227),
    [anon_sym_0] = ACTIONS(2664),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2664),
    [anon_sym__] = ACTIONS(2664),
  },
  [1850] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1859),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4229),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4231),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1851] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4233),
  },
  [1852] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4235),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1853] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4235),
  },
  [1854] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1861),
    [sym_concatenation] = STATE(1861),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4237),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4239),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4241),
    [anon_sym_DASH] = ACTIONS(4239),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4239),
    [anon_sym_PERCENT] = ACTIONS(4239),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4243),
    [anon_sym_COLON_DASH] = ACTIONS(4239),
    [sym__special_character] = ACTIONS(441),
  },
  [1855] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1866),
    [sym_concatenation] = STATE(1866),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4245),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4247),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4249),
    [anon_sym_DASH] = ACTIONS(4247),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4247),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4247),
    [anon_sym_PERCENT] = ACTIONS(4247),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4251),
    [anon_sym_COLON_DASH] = ACTIONS(4247),
    [sym__special_character] = ACTIONS(441),
  },
  [1856] = {
    [sym_command_substitution] = STATE(946),
    [sym_simple_expansion] = STATE(946),
    [sym_string_expansion] = STATE(946),
    [sym_string] = STATE(946),
    [sym_process_substitution] = STATE(946),
    [sym_expansion] = STATE(946),
    [anon_sym_BQUOTE] = ACTIONS(549),
    [anon_sym_DQUOTE] = ACTIONS(551),
    [sym_word] = ACTIONS(2657),
    [sym_raw_string] = ACTIONS(2657),
    [anon_sym_LT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR] = ACTIONS(557),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(555),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(559),
    [sym__special_character] = ACTIONS(2657),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(563),
  },
  [1857] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4253),
  },
  [1858] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4255),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1859] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4257),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4255),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1860] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1869),
    [sym_concatenation] = STATE(1869),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4259),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(4259),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4263),
    [anon_sym_COLON_DASH] = ACTIONS(4259),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4265),
  },
  [1861] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1862] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1869),
    [sym_concatenation] = STATE(1869),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4267),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4259),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4261),
    [anon_sym_DASH] = ACTIONS(4259),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4259),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4259),
    [anon_sym_PERCENT] = ACTIONS(4259),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4263),
    [anon_sym_COLON_DASH] = ACTIONS(4259),
    [sym__special_character] = ACTIONS(441),
  },
  [1863] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1873),
    [sym_concatenation] = STATE(1873),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4269),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4271),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4273),
    [anon_sym_DASH] = ACTIONS(4271),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4271),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4271),
    [anon_sym_PERCENT] = ACTIONS(4271),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4275),
    [anon_sym_COLON_DASH] = ACTIONS(4271),
    [sym__special_character] = ACTIONS(441),
  },
  [1864] = {
    [sym_command_substitution] = STATE(1874),
    [aux_sym__literal_repeat1] = STATE(1875),
    [sym_string] = STATE(1874),
    [sym_process_substitution] = STATE(1874),
    [sym_simple_expansion] = STATE(1874),
    [sym_string_expansion] = STATE(1874),
    [sym_concatenation] = STATE(1876),
    [sym_expansion] = STATE(1874),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4277),
    [sym_raw_string] = ACTIONS(4277),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4261),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1865] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1878),
    [sym_concatenation] = STATE(1878),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4279),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(4279),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4279),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4279),
    [anon_sym_PERCENT] = ACTIONS(4279),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4283),
    [anon_sym_COLON_DASH] = ACTIONS(4279),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4285),
  },
  [1866] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4281),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1867] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4287),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1868] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1879),
    [sym_concatenation] = STATE(1879),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4289),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4289),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4293),
    [anon_sym_COLON_DASH] = ACTIONS(4289),
    [sym__special_character] = ACTIONS(441),
  },
  [1869] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1870] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1879),
    [sym_concatenation] = STATE(1879),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4289),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_DASH] = ACTIONS(4289),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4289),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4289),
    [anon_sym_PERCENT] = ACTIONS(4289),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4293),
    [anon_sym_COLON_DASH] = ACTIONS(4289),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4295),
  },
  [1871] = {
    [sym_command_substitution] = STATE(1881),
    [aux_sym__literal_repeat1] = STATE(1882),
    [sym_string] = STATE(1881),
    [sym_process_substitution] = STATE(1881),
    [sym_simple_expansion] = STATE(1881),
    [sym_string_expansion] = STATE(1881),
    [sym_concatenation] = STATE(1883),
    [sym_expansion] = STATE(1881),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4297),
    [sym_raw_string] = ACTIONS(4297),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1872] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1885),
    [sym_concatenation] = STATE(1885),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4299),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4301),
    [anon_sym_DASH] = ACTIONS(4299),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4299),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4299),
    [anon_sym_PERCENT] = ACTIONS(4299),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4303),
    [anon_sym_COLON_DASH] = ACTIONS(4299),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4305),
  },
  [1873] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4301),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1874] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4291),
    [sym__concat] = ACTIONS(1265),
  },
  [1875] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4307),
  },
  [1876] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4291),
  },
  [1877] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1886),
    [sym_concatenation] = STATE(1886),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4309),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_DASH] = ACTIONS(4309),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4309),
    [anon_sym_PERCENT] = ACTIONS(4309),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4313),
    [anon_sym_COLON_DASH] = ACTIONS(4309),
    [sym__special_character] = ACTIONS(441),
  },
  [1878] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1879] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4315),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1880] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [sym_concatenation] = STATE(1887),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4317),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4315),
    [anon_sym_DASH] = ACTIONS(4317),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4317),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4317),
    [anon_sym_PERCENT] = ACTIONS(4317),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4319),
    [anon_sym_COLON_DASH] = ACTIONS(4317),
    [sym__special_character] = ACTIONS(441),
  },
  [1881] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4315),
    [sym__concat] = ACTIONS(1265),
  },
  [1882] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4321),
  },
  [1883] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4315),
  },
  [1884] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1888),
    [sym_concatenation] = STATE(1888),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4323),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_DASH] = ACTIONS(4323),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4323),
    [anon_sym_PERCENT] = ACTIONS(4323),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4327),
    [anon_sym_COLON_DASH] = ACTIONS(4323),
    [sym__special_character] = ACTIONS(441),
  },
  [1885] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1886] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1887] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1888] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4333),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1889] = {
    [sym_string] = STATE(968),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [anon_sym_STAR] = ACTIONS(4335),
    [anon_sym_QMARK] = ACTIONS(4335),
    [sym_raw_string] = ACTIONS(4337),
    [anon_sym_BANG] = ACTIONS(4339),
    [anon_sym_AT] = ACTIONS(4335),
    [anon_sym_DOLLAR] = ACTIONS(4339),
    [anon_sym_POUND] = ACTIONS(4339),
    [anon_sym_DASH] = ACTIONS(4339),
    [anon_sym_0] = ACTIONS(2698),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2698),
    [anon_sym__] = ACTIONS(2698),
  },
  [1890] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1899),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4341),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4343),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1891] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4345),
  },
  [1892] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1893] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4347),
  },
  [1894] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1901),
    [sym_concatenation] = STATE(1901),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4349),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4351),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4353),
    [anon_sym_DASH] = ACTIONS(4351),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4351),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4351),
    [anon_sym_PERCENT] = ACTIONS(4351),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4355),
    [anon_sym_COLON_DASH] = ACTIONS(4351),
    [sym__special_character] = ACTIONS(441),
  },
  [1895] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1906),
    [sym_concatenation] = STATE(1906),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4357),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4359),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4361),
    [anon_sym_DASH] = ACTIONS(4359),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4359),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4359),
    [anon_sym_PERCENT] = ACTIONS(4359),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4363),
    [anon_sym_COLON_DASH] = ACTIONS(4359),
    [sym__special_character] = ACTIONS(441),
  },
  [1896] = {
    [sym_command_substitution] = STATE(978),
    [sym_simple_expansion] = STATE(978),
    [sym_string_expansion] = STATE(978),
    [sym_string] = STATE(978),
    [sym_process_substitution] = STATE(978),
    [sym_expansion] = STATE(978),
    [anon_sym_BQUOTE] = ACTIONS(2333),
    [anon_sym_DQUOTE] = ACTIONS(2329),
    [sym_word] = ACTIONS(2677),
    [sym_raw_string] = ACTIONS(2677),
    [anon_sym_LT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2337),
    [sym__special_character] = ACTIONS(2677),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2341),
  },
  [1897] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4365),
  },
  [1898] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4367),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1899] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4369),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4367),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1900] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1909),
    [sym_concatenation] = STATE(1909),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4371),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4371),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4371),
    [anon_sym_PERCENT] = ACTIONS(4371),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4375),
    [anon_sym_COLON_DASH] = ACTIONS(4371),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4377),
  },
  [1901] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1902] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1909),
    [sym_concatenation] = STATE(1909),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4379),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4371),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_DASH] = ACTIONS(4371),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4371),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4371),
    [anon_sym_PERCENT] = ACTIONS(4371),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4375),
    [anon_sym_COLON_DASH] = ACTIONS(4371),
    [sym__special_character] = ACTIONS(441),
  },
  [1903] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1913),
    [sym_concatenation] = STATE(1913),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4381),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4383),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4385),
    [anon_sym_DASH] = ACTIONS(4383),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4383),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4383),
    [anon_sym_PERCENT] = ACTIONS(4383),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4387),
    [anon_sym_COLON_DASH] = ACTIONS(4383),
    [sym__special_character] = ACTIONS(441),
  },
  [1904] = {
    [sym_command_substitution] = STATE(1914),
    [aux_sym__literal_repeat1] = STATE(1915),
    [sym_string] = STATE(1914),
    [sym_process_substitution] = STATE(1914),
    [sym_simple_expansion] = STATE(1914),
    [sym_string_expansion] = STATE(1914),
    [sym_concatenation] = STATE(1916),
    [sym_expansion] = STATE(1914),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4389),
    [sym_raw_string] = ACTIONS(4389),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1905] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1918),
    [sym_concatenation] = STATE(1918),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4391),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4393),
    [anon_sym_DASH] = ACTIONS(4391),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4391),
    [anon_sym_PERCENT] = ACTIONS(4391),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4395),
    [anon_sym_COLON_DASH] = ACTIONS(4391),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4397),
  },
  [1906] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4393),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1907] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4399),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1908] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1919),
    [sym_concatenation] = STATE(1919),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4401),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4401),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4401),
    [anon_sym_PERCENT] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_COLON_DASH] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(441),
  },
  [1909] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1910] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1919),
    [sym_concatenation] = STATE(1919),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4401),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_DASH] = ACTIONS(4401),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4401),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4401),
    [anon_sym_PERCENT] = ACTIONS(4401),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4405),
    [anon_sym_COLON_DASH] = ACTIONS(4401),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4407),
  },
  [1911] = {
    [sym_command_substitution] = STATE(1921),
    [aux_sym__literal_repeat1] = STATE(1922),
    [sym_string] = STATE(1921),
    [sym_process_substitution] = STATE(1921),
    [sym_simple_expansion] = STATE(1921),
    [sym_string_expansion] = STATE(1921),
    [sym_concatenation] = STATE(1923),
    [sym_expansion] = STATE(1921),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4409),
    [sym_raw_string] = ACTIONS(4409),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1912] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1925),
    [sym_concatenation] = STATE(1925),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4411),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4413),
    [anon_sym_DASH] = ACTIONS(4411),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4411),
    [anon_sym_PERCENT] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4415),
    [anon_sym_COLON_DASH] = ACTIONS(4411),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4417),
  },
  [1913] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4413),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1914] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4403),
    [sym__concat] = ACTIONS(1265),
  },
  [1915] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4419),
  },
  [1916] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4403),
  },
  [1917] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1926),
    [sym_concatenation] = STATE(1926),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4421),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4423),
    [anon_sym_DASH] = ACTIONS(4421),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4421),
    [anon_sym_PERCENT] = ACTIONS(4421),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4425),
    [anon_sym_COLON_DASH] = ACTIONS(4421),
    [sym__special_character] = ACTIONS(441),
  },
  [1918] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4423),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1919] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1920] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1927),
    [sym_concatenation] = STATE(1927),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4429),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [anon_sym_DASH] = ACTIONS(4429),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4429),
    [anon_sym_PERCENT] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4431),
    [anon_sym_COLON_DASH] = ACTIONS(4429),
    [sym__special_character] = ACTIONS(441),
  },
  [1921] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4427),
    [sym__concat] = ACTIONS(1265),
  },
  [1922] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4433),
  },
  [1923] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4427),
  },
  [1924] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1928),
    [sym_concatenation] = STATE(1928),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4435),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [anon_sym_DASH] = ACTIONS(4435),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4435),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4435),
    [anon_sym_PERCENT] = ACTIONS(4435),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4439),
    [anon_sym_COLON_DASH] = ACTIONS(4435),
    [sym__special_character] = ACTIONS(441),
  },
  [1925] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1926] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4441),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1927] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4443),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1928] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4445),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1929] = {
    [sym_string] = STATE(1000),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [anon_sym_STAR] = ACTIONS(4447),
    [anon_sym_QMARK] = ACTIONS(4447),
    [sym_raw_string] = ACTIONS(4449),
    [anon_sym_BANG] = ACTIONS(4451),
    [anon_sym_AT] = ACTIONS(4447),
    [anon_sym_DOLLAR] = ACTIONS(4451),
    [anon_sym_POUND] = ACTIONS(4451),
    [anon_sym_DASH] = ACTIONS(4451),
    [anon_sym_0] = ACTIONS(2724),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2724),
    [anon_sym__] = ACTIONS(2724),
  },
  [1930] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1939),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4453),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4455),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1931] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4457),
  },
  [1932] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4459),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1933] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4459),
  },
  [1934] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1941),
    [sym_concatenation] = STATE(1941),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4461),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4463),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4465),
    [anon_sym_DASH] = ACTIONS(4463),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4463),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4463),
    [anon_sym_PERCENT] = ACTIONS(4463),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4467),
    [anon_sym_COLON_DASH] = ACTIONS(4463),
    [sym__special_character] = ACTIONS(441),
  },
  [1935] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1946),
    [sym_concatenation] = STATE(1946),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4469),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4471),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4473),
    [anon_sym_DASH] = ACTIONS(4471),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4471),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4471),
    [anon_sym_PERCENT] = ACTIONS(4471),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4475),
    [anon_sym_COLON_DASH] = ACTIONS(4471),
    [sym__special_character] = ACTIONS(441),
  },
  [1936] = {
    [sym_command_substitution] = STATE(1010),
    [sym_simple_expansion] = STATE(1010),
    [sym_string_expansion] = STATE(1010),
    [sym_string] = STATE(1010),
    [sym_process_substitution] = STATE(1010),
    [sym_expansion] = STATE(1010),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_DQUOTE] = ACTIONS(656),
    [sym_word] = ACTIONS(2689),
    [sym_raw_string] = ACTIONS(2689),
    [anon_sym_LT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR] = ACTIONS(662),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(660),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(664),
    [sym__special_character] = ACTIONS(2689),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(668),
  },
  [1937] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4477),
  },
  [1938] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4479),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1939] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4481),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4479),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [1940] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1949),
    [sym_concatenation] = STATE(1949),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4483),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4483),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4483),
    [anon_sym_PERCENT] = ACTIONS(4483),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4487),
    [anon_sym_COLON_DASH] = ACTIONS(4483),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4489),
  },
  [1941] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1942] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1949),
    [sym_concatenation] = STATE(1949),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4491),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4483),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_DASH] = ACTIONS(4483),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4483),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4483),
    [anon_sym_PERCENT] = ACTIONS(4483),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4487),
    [anon_sym_COLON_DASH] = ACTIONS(4483),
    [sym__special_character] = ACTIONS(441),
  },
  [1943] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1953),
    [sym_concatenation] = STATE(1953),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4493),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4495),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4497),
    [anon_sym_DASH] = ACTIONS(4495),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4495),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4495),
    [anon_sym_PERCENT] = ACTIONS(4495),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4499),
    [anon_sym_COLON_DASH] = ACTIONS(4495),
    [sym__special_character] = ACTIONS(441),
  },
  [1944] = {
    [sym_command_substitution] = STATE(1954),
    [aux_sym__literal_repeat1] = STATE(1955),
    [sym_string] = STATE(1954),
    [sym_process_substitution] = STATE(1954),
    [sym_simple_expansion] = STATE(1954),
    [sym_string_expansion] = STATE(1954),
    [sym_concatenation] = STATE(1956),
    [sym_expansion] = STATE(1954),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4501),
    [sym_raw_string] = ACTIONS(4501),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4485),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1945] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1958),
    [sym_concatenation] = STATE(1958),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4503),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4505),
    [anon_sym_DASH] = ACTIONS(4503),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4503),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4503),
    [anon_sym_PERCENT] = ACTIONS(4503),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4507),
    [anon_sym_COLON_DASH] = ACTIONS(4503),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4509),
  },
  [1946] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4505),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1947] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4511),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [1948] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1959),
    [sym_concatenation] = STATE(1959),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4513),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_PERCENT] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4517),
    [anon_sym_COLON_DASH] = ACTIONS(4513),
    [sym__special_character] = ACTIONS(441),
  },
  [1949] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1950] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1959),
    [sym_concatenation] = STATE(1959),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4513),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_DASH] = ACTIONS(4513),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4513),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4513),
    [anon_sym_PERCENT] = ACTIONS(4513),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4517),
    [anon_sym_COLON_DASH] = ACTIONS(4513),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4519),
  },
  [1951] = {
    [sym_command_substitution] = STATE(1961),
    [aux_sym__literal_repeat1] = STATE(1962),
    [sym_string] = STATE(1961),
    [sym_process_substitution] = STATE(1961),
    [sym_simple_expansion] = STATE(1961),
    [sym_string_expansion] = STATE(1961),
    [sym_concatenation] = STATE(1963),
    [sym_expansion] = STATE(1961),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4521),
    [sym_raw_string] = ACTIONS(4521),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1952] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1965),
    [sym_concatenation] = STATE(1965),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4523),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(4523),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4523),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4523),
    [anon_sym_PERCENT] = ACTIONS(4523),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4527),
    [anon_sym_COLON_DASH] = ACTIONS(4523),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4529),
  },
  [1953] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4525),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1954] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4515),
    [sym__concat] = ACTIONS(1265),
  },
  [1955] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4531),
  },
  [1956] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4515),
  },
  [1957] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1966),
    [sym_concatenation] = STATE(1966),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4533),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4535),
    [anon_sym_DASH] = ACTIONS(4533),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4533),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4533),
    [anon_sym_PERCENT] = ACTIONS(4533),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4537),
    [anon_sym_COLON_DASH] = ACTIONS(4533),
    [sym__special_character] = ACTIONS(441),
  },
  [1958] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4535),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1959] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4539),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1960] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1967),
    [sym_concatenation] = STATE(1967),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4541),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4539),
    [anon_sym_DASH] = ACTIONS(4541),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4541),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4541),
    [anon_sym_PERCENT] = ACTIONS(4541),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4543),
    [anon_sym_COLON_DASH] = ACTIONS(4541),
    [sym__special_character] = ACTIONS(441),
  },
  [1961] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4539),
    [sym__concat] = ACTIONS(1265),
  },
  [1962] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4545),
  },
  [1963] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4539),
  },
  [1964] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1968),
    [sym_concatenation] = STATE(1968),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4547),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4549),
    [anon_sym_DASH] = ACTIONS(4547),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4547),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4547),
    [anon_sym_PERCENT] = ACTIONS(4547),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4551),
    [anon_sym_COLON_DASH] = ACTIONS(4547),
    [sym__special_character] = ACTIONS(441),
  },
  [1965] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4549),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1966] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4553),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1967] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4555),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1968] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4557),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1969] = {
    [sym_string] = STATE(1032),
    [anon_sym_STAR] = ACTIONS(4559),
    [sym_raw_string] = ACTIONS(4561),
    [anon_sym_BANG] = ACTIONS(4563),
    [anon_sym_DOLLAR] = ACTIONS(4563),
    [anon_sym_0] = ACTIONS(2756),
    [anon_sym_DASH] = ACTIONS(4563),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2756),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [anon_sym_QMARK] = ACTIONS(4559),
    [anon_sym_AT] = ACTIONS(4559),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4563),
    [anon_sym__] = ACTIONS(2756),
  },
  [1970] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(1979),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4565),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4567),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1971] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4569),
  },
  [1972] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4571),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [1973] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4571),
  },
  [1974] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1981),
    [sym_concatenation] = STATE(1981),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4573),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4575),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4577),
    [anon_sym_DASH] = ACTIONS(4575),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4575),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4575),
    [anon_sym_PERCENT] = ACTIONS(4575),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4579),
    [anon_sym_COLON_DASH] = ACTIONS(4575),
    [sym__special_character] = ACTIONS(441),
  },
  [1975] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1986),
    [sym_concatenation] = STATE(1986),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4581),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4583),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4585),
    [anon_sym_DASH] = ACTIONS(4583),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4583),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4583),
    [anon_sym_PERCENT] = ACTIONS(4583),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4587),
    [anon_sym_COLON_DASH] = ACTIONS(4583),
    [sym__special_character] = ACTIONS(441),
  },
  [1976] = {
    [sym_command_substitution] = STATE(1042),
    [sym_string] = STATE(1042),
    [sym_process_substitution] = STATE(1042),
    [sym_simple_expansion] = STATE(1042),
    [sym_string_expansion] = STATE(1042),
    [sym_expansion] = STATE(1042),
    [anon_sym_BQUOTE] = ACTIONS(2707),
    [sym_raw_string] = ACTIONS(2709),
    [anon_sym_DOLLAR] = ACTIONS(2987),
    [anon_sym_GT_LPAREN] = ACTIONS(2713),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2715),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2717),
    [anon_sym_DQUOTE] = ACTIONS(2719),
    [sym_word] = ACTIONS(2709),
    [anon_sym_LT_LPAREN] = ACTIONS(2713),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2709),
  },
  [1977] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4589),
  },
  [1978] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4591),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1979] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4591),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4593),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [1980] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1989),
    [sym_concatenation] = STATE(1989),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4595),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_DASH] = ACTIONS(4595),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4595),
    [anon_sym_PERCENT] = ACTIONS(4595),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4599),
    [anon_sym_COLON_DASH] = ACTIONS(4595),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4601),
  },
  [1981] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1982] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1989),
    [sym_concatenation] = STATE(1989),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4603),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4595),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_DASH] = ACTIONS(4595),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4595),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4595),
    [anon_sym_PERCENT] = ACTIONS(4595),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4599),
    [anon_sym_COLON_DASH] = ACTIONS(4595),
    [sym__special_character] = ACTIONS(441),
  },
  [1983] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1993),
    [sym_concatenation] = STATE(1993),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4605),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4607),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4609),
    [anon_sym_DASH] = ACTIONS(4607),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4607),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4607),
    [anon_sym_PERCENT] = ACTIONS(4607),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4611),
    [anon_sym_COLON_DASH] = ACTIONS(4607),
    [sym__special_character] = ACTIONS(441),
  },
  [1984] = {
    [sym_command_substitution] = STATE(1994),
    [aux_sym__literal_repeat1] = STATE(1995),
    [sym_string] = STATE(1994),
    [sym_process_substitution] = STATE(1994),
    [sym_simple_expansion] = STATE(1994),
    [sym_string_expansion] = STATE(1994),
    [sym_concatenation] = STATE(1996),
    [sym_expansion] = STATE(1994),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4613),
    [sym_raw_string] = ACTIONS(4613),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4597),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1985] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1998),
    [sym_concatenation] = STATE(1998),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4615),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(4615),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4615),
    [anon_sym_PERCENT] = ACTIONS(4615),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4619),
    [anon_sym_COLON_DASH] = ACTIONS(4615),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4621),
  },
  [1986] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4617),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1987] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4623),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [1988] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1999),
    [sym_concatenation] = STATE(1999),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4625),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4629),
    [anon_sym_COLON_DASH] = ACTIONS(4625),
    [sym__special_character] = ACTIONS(441),
  },
  [1989] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1990] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(1999),
    [sym_concatenation] = STATE(1999),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4625),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_DASH] = ACTIONS(4625),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4625),
    [anon_sym_PERCENT] = ACTIONS(4625),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4629),
    [anon_sym_COLON_DASH] = ACTIONS(4625),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4631),
  },
  [1991] = {
    [sym_command_substitution] = STATE(2001),
    [aux_sym__literal_repeat1] = STATE(2002),
    [sym_string] = STATE(2001),
    [sym_process_substitution] = STATE(2001),
    [sym_simple_expansion] = STATE(2001),
    [sym_string_expansion] = STATE(2001),
    [sym_concatenation] = STATE(2003),
    [sym_expansion] = STATE(2001),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4633),
    [sym_raw_string] = ACTIONS(4633),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [1992] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2005),
    [sym_concatenation] = STATE(2005),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4635),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(4635),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4635),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4635),
    [anon_sym_PERCENT] = ACTIONS(4635),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4639),
    [anon_sym_COLON_DASH] = ACTIONS(4635),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4641),
  },
  [1993] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4637),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1994] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4627),
    [sym__concat] = ACTIONS(1265),
  },
  [1995] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4643),
  },
  [1996] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4627),
  },
  [1997] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2006),
    [sym_concatenation] = STATE(2006),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4645),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4647),
    [anon_sym_DASH] = ACTIONS(4645),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4645),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4645),
    [anon_sym_PERCENT] = ACTIONS(4645),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4649),
    [anon_sym_COLON_DASH] = ACTIONS(4645),
    [sym__special_character] = ACTIONS(441),
  },
  [1998] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4647),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [1999] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2000] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2007),
    [sym_concatenation] = STATE(2007),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4653),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [anon_sym_DASH] = ACTIONS(4653),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4653),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4653),
    [anon_sym_PERCENT] = ACTIONS(4653),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4655),
    [anon_sym_COLON_DASH] = ACTIONS(4653),
    [sym__special_character] = ACTIONS(441),
  },
  [2001] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4651),
    [sym__concat] = ACTIONS(1265),
  },
  [2002] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4657),
  },
  [2003] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4651),
  },
  [2004] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2008),
    [sym_concatenation] = STATE(2008),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4659),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [anon_sym_DASH] = ACTIONS(4659),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4659),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4659),
    [anon_sym_PERCENT] = ACTIONS(4659),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4663),
    [anon_sym_COLON_DASH] = ACTIONS(4659),
    [sym__special_character] = ACTIONS(441),
  },
  [2005] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4661),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2006] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4665),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2007] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4667),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2008] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4669),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2009] = {
    [sym_string] = STATE(1064),
    [anon_sym_STAR] = ACTIONS(4671),
    [sym_raw_string] = ACTIONS(4673),
    [anon_sym_BANG] = ACTIONS(4675),
    [anon_sym_DOLLAR] = ACTIONS(4675),
    [anon_sym_0] = ACTIONS(2774),
    [anon_sym_DASH] = ACTIONS(4675),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2774),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [anon_sym_QMARK] = ACTIONS(4671),
    [anon_sym_AT] = ACTIONS(4671),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4675),
    [anon_sym__] = ACTIONS(2774),
  },
  [2010] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2019),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4677),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4679),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [2011] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4681),
  },
  [2012] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4683),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [2013] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4683),
  },
  [2014] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2021),
    [sym_concatenation] = STATE(2021),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4685),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4685),
    [anon_sym_COLON] = ACTIONS(4685),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4687),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4685),
    [anon_sym_RBRACE] = ACTIONS(4689),
    [anon_sym_EQ] = ACTIONS(4685),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4691),
    [anon_sym_COLON_DASH] = ACTIONS(4685),
  },
  [2015] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2026),
    [sym_concatenation] = STATE(2026),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4693),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4693),
    [anon_sym_COLON] = ACTIONS(4693),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4695),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4693),
    [anon_sym_RBRACE] = ACTIONS(4697),
    [anon_sym_EQ] = ACTIONS(4693),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4699),
    [anon_sym_COLON_DASH] = ACTIONS(4693),
  },
  [2016] = {
    [sym_command_substitution] = STATE(1074),
    [sym_string] = STATE(1074),
    [sym_process_substitution] = STATE(1074),
    [sym_simple_expansion] = STATE(1074),
    [sym_string_expansion] = STATE(1074),
    [sym_expansion] = STATE(1074),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [sym_raw_string] = ACTIONS(2739),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(2739),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(2739),
  },
  [2017] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4701),
  },
  [2018] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4703),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [2019] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4703),
    [sym__string_content] = ACTIONS(269),
    [anon_sym_DOLLAR] = ACTIONS(4705),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
  },
  [2020] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2029),
    [sym_concatenation] = STATE(2029),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_COLON] = ACTIONS(4707),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4711),
    [anon_sym_COLON_DASH] = ACTIONS(4707),
    [sym_regex] = ACTIONS(4713),
  },
  [2021] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2022] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2029),
    [sym_concatenation] = STATE(2029),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4707),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4707),
    [anon_sym_COLON] = ACTIONS(4707),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4715),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4707),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_EQ] = ACTIONS(4707),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4711),
    [anon_sym_COLON_DASH] = ACTIONS(4707),
  },
  [2023] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2033),
    [sym_concatenation] = STATE(2033),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4717),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4717),
    [anon_sym_COLON] = ACTIONS(4717),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4719),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4717),
    [anon_sym_RBRACE] = ACTIONS(4721),
    [anon_sym_EQ] = ACTIONS(4717),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4723),
    [anon_sym_COLON_DASH] = ACTIONS(4717),
  },
  [2024] = {
    [sym_command_substitution] = STATE(2034),
    [aux_sym__literal_repeat1] = STATE(2035),
    [sym_string] = STATE(2034),
    [sym_process_substitution] = STATE(2034),
    [sym_simple_expansion] = STATE(2034),
    [sym_string_expansion] = STATE(2034),
    [sym_concatenation] = STATE(2036),
    [sym_expansion] = STATE(2034),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4725),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4709),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4725),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [2025] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2038),
    [sym_concatenation] = STATE(2038),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4727),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4727),
    [anon_sym_COLON] = ACTIONS(4727),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4727),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(4727),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4731),
    [anon_sym_COLON_DASH] = ACTIONS(4727),
    [sym_regex] = ACTIONS(4733),
  },
  [2026] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4729),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2027] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [sym__string_content] = ACTIONS(581),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [anon_sym_DASH] = ACTIONS(577),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym_DQUOTE] = ACTIONS(4735),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_AT] = ACTIONS(573),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym__] = ACTIONS(579),
  },
  [2028] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2039),
    [sym_concatenation] = STATE(2039),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4737),
    [anon_sym_COLON] = ACTIONS(4737),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4737),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4737),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_COLON_DASH] = ACTIONS(4737),
  },
  [2029] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2030] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2039),
    [sym_concatenation] = STATE(2039),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4737),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4737),
    [anon_sym_COLON] = ACTIONS(4737),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4737),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_EQ] = ACTIONS(4737),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4741),
    [anon_sym_COLON_DASH] = ACTIONS(4737),
    [sym_regex] = ACTIONS(4743),
  },
  [2031] = {
    [sym_command_substitution] = STATE(2041),
    [aux_sym__literal_repeat1] = STATE(2042),
    [sym_string] = STATE(2041),
    [sym_process_substitution] = STATE(2041),
    [sym_simple_expansion] = STATE(2041),
    [sym_string_expansion] = STATE(2041),
    [sym_concatenation] = STATE(2043),
    [sym_expansion] = STATE(2041),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4745),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4745),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [2032] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2045),
    [sym_concatenation] = STATE(2045),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4747),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4747),
    [anon_sym_COLON] = ACTIONS(4747),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4747),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(4747),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4751),
    [anon_sym_COLON_DASH] = ACTIONS(4747),
    [sym_regex] = ACTIONS(4753),
  },
  [2033] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4749),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2034] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4739),
    [sym__concat] = ACTIONS(1265),
  },
  [2035] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4755),
    [sym__special_character] = ACTIONS(1267),
  },
  [2036] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4739),
  },
  [2037] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2046),
    [sym_concatenation] = STATE(2046),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4757),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4757),
    [anon_sym_COLON] = ACTIONS(4757),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4757),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(4757),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4761),
    [anon_sym_COLON_DASH] = ACTIONS(4757),
  },
  [2038] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4759),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2039] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2040] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2047),
    [sym_concatenation] = STATE(2047),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4765),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4765),
    [anon_sym_COLON] = ACTIONS(4765),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4765),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [anon_sym_EQ] = ACTIONS(4765),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4767),
    [anon_sym_COLON_DASH] = ACTIONS(4765),
  },
  [2041] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4763),
    [sym__concat] = ACTIONS(1265),
  },
  [2042] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4769),
    [sym__special_character] = ACTIONS(1267),
  },
  [2043] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4763),
  },
  [2044] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2048),
    [sym_concatenation] = STATE(2048),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4771),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4771),
    [anon_sym_COLON] = ACTIONS(4771),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4771),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_EQ] = ACTIONS(4771),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4775),
    [anon_sym_COLON_DASH] = ACTIONS(4771),
  },
  [2045] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4773),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2046] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4777),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2047] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4779),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2048] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4781),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2049] = {
    [sym_string] = STATE(1096),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [anon_sym_STAR] = ACTIONS(2794),
    [anon_sym_QMARK] = ACTIONS(2794),
    [sym_raw_string] = ACTIONS(2796),
    [anon_sym_BANG] = ACTIONS(2798),
    [anon_sym_AT] = ACTIONS(2794),
    [anon_sym_DOLLAR] = ACTIONS(2798),
    [anon_sym_POUND] = ACTIONS(2798),
    [anon_sym_DASH] = ACTIONS(2798),
    [anon_sym_0] = ACTIONS(2800),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2800),
    [anon_sym__] = ACTIONS(2800),
  },
  [2050] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2059),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4783),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4785),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2051] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4787),
  },
  [2052] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [sym__special_character] = ACTIONS(325),
    [anon_sym_BQUOTE] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [sym_file_descriptor] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4789),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
  },
  [2053] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4789),
  },
  [2054] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2061),
    [sym_concatenation] = STATE(2061),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4791),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4791),
    [anon_sym_COLON] = ACTIONS(4791),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4793),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4791),
    [anon_sym_RBRACE] = ACTIONS(4795),
    [anon_sym_EQ] = ACTIONS(4791),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4797),
    [anon_sym_COLON_DASH] = ACTIONS(4791),
  },
  [2055] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [sym_concatenation] = STATE(2066),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4799),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4799),
    [anon_sym_COLON] = ACTIONS(4799),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4801),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4799),
    [anon_sym_RBRACE] = ACTIONS(4803),
    [anon_sym_EQ] = ACTIONS(4799),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4805),
    [anon_sym_COLON_DASH] = ACTIONS(4799),
  },
  [2056] = {
    [sym_command_substitution] = STATE(1106),
    [sym_simple_expansion] = STATE(1106),
    [sym_string_expansion] = STATE(1106),
    [sym_string] = STATE(1106),
    [sym_process_substitution] = STATE(1106),
    [sym_expansion] = STATE(1106),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(2767),
    [sym_raw_string] = ACTIONS(2767),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(2767),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2057] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4807),
  },
  [2058] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4809),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2059] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4811),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2060] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [sym_concatenation] = STATE(2069),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4813),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [anon_sym_COLON] = ACTIONS(4813),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4813),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_EQ] = ACTIONS(4813),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4817),
    [anon_sym_COLON_DASH] = ACTIONS(4813),
    [sym_regex] = ACTIONS(4819),
  },
  [2061] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2062] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [sym_concatenation] = STATE(2069),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4813),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4813),
    [anon_sym_COLON] = ACTIONS(4813),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4821),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4813),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_EQ] = ACTIONS(4813),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4817),
    [anon_sym_COLON_DASH] = ACTIONS(4813),
  },
  [2063] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2073),
    [sym_concatenation] = STATE(2073),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4823),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4823),
    [anon_sym_COLON] = ACTIONS(4823),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4825),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4823),
    [anon_sym_RBRACE] = ACTIONS(4827),
    [anon_sym_EQ] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4829),
    [anon_sym_COLON_DASH] = ACTIONS(4823),
  },
  [2064] = {
    [sym_command_substitution] = STATE(2074),
    [aux_sym__literal_repeat1] = STATE(2075),
    [sym_string] = STATE(2074),
    [sym_process_substitution] = STATE(2074),
    [sym_simple_expansion] = STATE(2074),
    [sym_string_expansion] = STATE(2074),
    [sym_concatenation] = STATE(2076),
    [sym_expansion] = STATE(2074),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4831),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4815),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4831),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [2065] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [sym_concatenation] = STATE(2078),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4833),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4833),
    [anon_sym_COLON] = ACTIONS(4833),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4833),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(4833),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4837),
    [anon_sym_COLON_DASH] = ACTIONS(4833),
    [sym_regex] = ACTIONS(4839),
  },
  [2066] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2067] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4841),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2068] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2079),
    [sym_concatenation] = STATE(2079),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4843),
    [anon_sym_COLON] = ACTIONS(4843),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4843),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4843),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4847),
    [anon_sym_COLON_DASH] = ACTIONS(4843),
  },
  [2069] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2070] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2079),
    [sym_concatenation] = STATE(2079),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4843),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4843),
    [anon_sym_COLON] = ACTIONS(4843),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4843),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_EQ] = ACTIONS(4843),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4847),
    [anon_sym_COLON_DASH] = ACTIONS(4843),
    [sym_regex] = ACTIONS(4849),
  },
  [2071] = {
    [sym_command_substitution] = STATE(2081),
    [aux_sym__literal_repeat1] = STATE(2082),
    [sym_string] = STATE(2081),
    [sym_process_substitution] = STATE(2081),
    [sym_simple_expansion] = STATE(2081),
    [sym_string_expansion] = STATE(2081),
    [sym_concatenation] = STATE(2083),
    [sym_expansion] = STATE(2081),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [sym_raw_string] = ACTIONS(4851),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4851),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(917),
  },
  [2072] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2085),
    [sym_concatenation] = STATE(2085),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4853),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4853),
    [anon_sym_COLON] = ACTIONS(4853),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4853),
    [anon_sym_RBRACE] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(4853),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4857),
    [anon_sym_COLON_DASH] = ACTIONS(4853),
    [sym_regex] = ACTIONS(4859),
  },
  [2073] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4855),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2074] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [sym__concat] = ACTIONS(1265),
  },
  [2075] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4861),
    [sym__special_character] = ACTIONS(1267),
  },
  [2076] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4845),
  },
  [2077] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2086),
    [sym_concatenation] = STATE(2086),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4863),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4863),
    [anon_sym_COLON] = ACTIONS(4863),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4863),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_EQ] = ACTIONS(4863),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4867),
    [anon_sym_COLON_DASH] = ACTIONS(4863),
  },
  [2078] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4865),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2079] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2080] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2087),
    [sym_concatenation] = STATE(2087),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4871),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4871),
    [anon_sym_COLON] = ACTIONS(4871),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4871),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [anon_sym_EQ] = ACTIONS(4871),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4873),
    [anon_sym_COLON_DASH] = ACTIONS(4871),
  },
  [2081] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4869),
    [sym__concat] = ACTIONS(1265),
  },
  [2082] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4875),
    [sym__special_character] = ACTIONS(1267),
  },
  [2083] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4869),
  },
  [2084] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2088),
    [sym_concatenation] = STATE(2088),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(4877),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(4877),
    [anon_sym_COLON] = ACTIONS(4877),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4877),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [anon_sym_EQ] = ACTIONS(4877),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4881),
    [anon_sym_COLON_DASH] = ACTIONS(4877),
  },
  [2085] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4879),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2086] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4883),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2087] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4885),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2088] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_COLON] = ACTIONS(889),
    [sym_word] = ACTIONS(437),
    [sym__special_character] = ACTIONS(441),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(4887),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
  },
  [2089] = {
    [sym_string] = STATE(1128),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [anon_sym_STAR] = ACTIONS(4889),
    [anon_sym_QMARK] = ACTIONS(4889),
    [sym_raw_string] = ACTIONS(2816),
    [anon_sym_BANG] = ACTIONS(2820),
    [anon_sym_AT] = ACTIONS(4889),
    [anon_sym_DOLLAR] = ACTIONS(2820),
    [anon_sym_POUND] = ACTIONS(2820),
    [anon_sym_DASH] = ACTIONS(2820),
    [anon_sym_0] = ACTIONS(2814),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2814),
    [anon_sym__] = ACTIONS(2814),
  },
  [2090] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2099),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4891),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4893),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2091] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4895),
  },
  [2092] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(4897),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2093] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(4897),
  },
  [2094] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2101),
    [sym_concatenation] = STATE(2101),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4899),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4901),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4903),
    [anon_sym_DASH] = ACTIONS(4901),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4901),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4901),
    [anon_sym_PERCENT] = ACTIONS(4901),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4905),
    [anon_sym_COLON_DASH] = ACTIONS(4901),
    [sym__special_character] = ACTIONS(441),
  },
  [2095] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2106),
    [sym_concatenation] = STATE(2106),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4907),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4909),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4911),
    [anon_sym_DASH] = ACTIONS(4909),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4909),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4909),
    [anon_sym_PERCENT] = ACTIONS(4909),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4913),
    [anon_sym_COLON_DASH] = ACTIONS(4909),
    [sym__special_character] = ACTIONS(441),
  },
  [2096] = {
    [sym_command_substitution] = STATE(1138),
    [sym_simple_expansion] = STATE(1138),
    [sym_string_expansion] = STATE(1138),
    [sym_string] = STATE(1138),
    [sym_process_substitution] = STATE(1138),
    [sym_expansion] = STATE(1138),
    [anon_sym_BQUOTE] = ACTIONS(992),
    [anon_sym_DQUOTE] = ACTIONS(994),
    [sym_word] = ACTIONS(2787),
    [sym_raw_string] = ACTIONS(2787),
    [anon_sym_LT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR] = ACTIONS(1000),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(998),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1004),
    [sym__special_character] = ACTIONS(2787),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1008),
  },
  [2097] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(4915),
  },
  [2098] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4917),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2099] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(4919),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(4917),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2100] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2109),
    [sym_concatenation] = STATE(2109),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4921),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4921),
    [anon_sym_PERCENT] = ACTIONS(4921),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4925),
    [anon_sym_COLON_DASH] = ACTIONS(4921),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4927),
  },
  [2101] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2102] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2109),
    [sym_concatenation] = STATE(2109),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4929),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4921),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_DASH] = ACTIONS(4921),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4921),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4921),
    [anon_sym_PERCENT] = ACTIONS(4921),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4925),
    [anon_sym_COLON_DASH] = ACTIONS(4921),
    [sym__special_character] = ACTIONS(441),
  },
  [2103] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2113),
    [sym_concatenation] = STATE(2113),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(4931),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4933),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4935),
    [anon_sym_DASH] = ACTIONS(4933),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4933),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4933),
    [anon_sym_PERCENT] = ACTIONS(4933),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4937),
    [anon_sym_COLON_DASH] = ACTIONS(4933),
    [sym__special_character] = ACTIONS(441),
  },
  [2104] = {
    [sym_command_substitution] = STATE(2114),
    [aux_sym__literal_repeat1] = STATE(2115),
    [sym_string] = STATE(2114),
    [sym_process_substitution] = STATE(2114),
    [sym_simple_expansion] = STATE(2114),
    [sym_string_expansion] = STATE(2114),
    [sym_concatenation] = STATE(2116),
    [sym_expansion] = STATE(2114),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4939),
    [sym_raw_string] = ACTIONS(4939),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2105] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2118),
    [sym_concatenation] = STATE(2118),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4941),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(4941),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4941),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4941),
    [anon_sym_PERCENT] = ACTIONS(4941),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4945),
    [anon_sym_COLON_DASH] = ACTIONS(4941),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4947),
  },
  [2106] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2107] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(4949),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2108] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [sym_concatenation] = STATE(2119),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4955),
    [anon_sym_COLON_DASH] = ACTIONS(4951),
    [sym__special_character] = ACTIONS(441),
  },
  [2109] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2110] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [sym_concatenation] = STATE(2119),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4951),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_DASH] = ACTIONS(4951),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4951),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4951),
    [anon_sym_PERCENT] = ACTIONS(4951),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4955),
    [anon_sym_COLON_DASH] = ACTIONS(4951),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4957),
  },
  [2111] = {
    [sym_command_substitution] = STATE(2121),
    [aux_sym__literal_repeat1] = STATE(2122),
    [sym_string] = STATE(2121),
    [sym_process_substitution] = STATE(2121),
    [sym_simple_expansion] = STATE(2121),
    [sym_string_expansion] = STATE(2121),
    [sym_concatenation] = STATE(2123),
    [sym_expansion] = STATE(2121),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(4959),
    [sym_raw_string] = ACTIONS(4959),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2112] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2125),
    [sym_concatenation] = STATE(2125),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(4961),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4961),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4961),
    [anon_sym_PERCENT] = ACTIONS(4961),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4965),
    [anon_sym_COLON_DASH] = ACTIONS(4961),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(4967),
  },
  [2113] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4963),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2114] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym__concat] = ACTIONS(1265),
  },
  [2115] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4969),
  },
  [2116] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4953),
  },
  [2117] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2126),
    [sym_concatenation] = STATE(2126),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4971),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(4971),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4971),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4971),
    [anon_sym_PERCENT] = ACTIONS(4971),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4975),
    [anon_sym_COLON_DASH] = ACTIONS(4971),
    [sym__special_character] = ACTIONS(441),
  },
  [2118] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4973),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2119] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2120] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2127),
    [sym_concatenation] = STATE(2127),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4979),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [anon_sym_DASH] = ACTIONS(4979),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4979),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4979),
    [anon_sym_PERCENT] = ACTIONS(4979),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4981),
    [anon_sym_COLON_DASH] = ACTIONS(4979),
    [sym__special_character] = ACTIONS(441),
  },
  [2121] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [sym__concat] = ACTIONS(1265),
  },
  [2122] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(4983),
  },
  [2123] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(4977),
  },
  [2124] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2128),
    [sym_concatenation] = STATE(2128),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(4985),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_DASH] = ACTIONS(4985),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(4985),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(4985),
    [anon_sym_PERCENT] = ACTIONS(4985),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(4989),
    [anon_sym_COLON_DASH] = ACTIONS(4985),
    [sym__special_character] = ACTIONS(441),
  },
  [2125] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2126] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2127] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2128] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(4995),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2129] = {
    [sym_string] = STATE(1160),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [anon_sym_STAR] = ACTIONS(4997),
    [anon_sym_QMARK] = ACTIONS(4997),
    [sym_raw_string] = ACTIONS(4999),
    [anon_sym_BANG] = ACTIONS(5001),
    [anon_sym_AT] = ACTIONS(4997),
    [anon_sym_DOLLAR] = ACTIONS(5001),
    [anon_sym_POUND] = ACTIONS(5001),
    [anon_sym_DASH] = ACTIONS(5001),
    [anon_sym_0] = ACTIONS(2834),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2834),
    [anon_sym__] = ACTIONS(2834),
  },
  [2130] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2139),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5003),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2131] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5007),
  },
  [2132] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5009),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2133] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5009),
  },
  [2134] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2141),
    [sym_concatenation] = STATE(2141),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5011),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5013),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [anon_sym_DASH] = ACTIONS(5013),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5013),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5013),
    [anon_sym_PERCENT] = ACTIONS(5013),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5017),
    [anon_sym_COLON_DASH] = ACTIONS(5013),
    [sym__special_character] = ACTIONS(441),
  },
  [2135] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2146),
    [sym_concatenation] = STATE(2146),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5019),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5021),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5023),
    [anon_sym_DASH] = ACTIONS(5021),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5021),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5021),
    [anon_sym_PERCENT] = ACTIONS(5021),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5025),
    [anon_sym_COLON_DASH] = ACTIONS(5021),
    [sym__special_character] = ACTIONS(441),
  },
  [2136] = {
    [sym_command_substitution] = STATE(1170),
    [sym_simple_expansion] = STATE(1170),
    [sym_string_expansion] = STATE(1170),
    [sym_string] = STATE(1170),
    [sym_process_substitution] = STATE(1170),
    [sym_expansion] = STATE(1170),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_word] = ACTIONS(2807),
    [sym_raw_string] = ACTIONS(2807),
    [anon_sym_LT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [sym__special_character] = ACTIONS(2807),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
  },
  [2137] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5027),
  },
  [2138] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5029),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2139] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5031),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5029),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2140] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2149),
    [sym_concatenation] = STATE(2149),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5033),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5033),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5037),
    [anon_sym_COLON_DASH] = ACTIONS(5033),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5039),
  },
  [2141] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2142] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2149),
    [sym_concatenation] = STATE(2149),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5041),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5033),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_DASH] = ACTIONS(5033),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5033),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5033),
    [anon_sym_PERCENT] = ACTIONS(5033),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5037),
    [anon_sym_COLON_DASH] = ACTIONS(5033),
    [sym__special_character] = ACTIONS(441),
  },
  [2143] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2153),
    [sym_concatenation] = STATE(2153),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5043),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5045),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5047),
    [anon_sym_DASH] = ACTIONS(5045),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5045),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5045),
    [anon_sym_PERCENT] = ACTIONS(5045),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5049),
    [anon_sym_COLON_DASH] = ACTIONS(5045),
    [sym__special_character] = ACTIONS(441),
  },
  [2144] = {
    [sym_command_substitution] = STATE(2154),
    [aux_sym__literal_repeat1] = STATE(2155),
    [sym_string] = STATE(2154),
    [sym_process_substitution] = STATE(2154),
    [sym_simple_expansion] = STATE(2154),
    [sym_string_expansion] = STATE(2154),
    [sym_concatenation] = STATE(2156),
    [sym_expansion] = STATE(2154),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5051),
    [sym_raw_string] = ACTIONS(5051),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5035),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2145] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2158),
    [sym_concatenation] = STATE(2158),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5053),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5055),
    [anon_sym_DASH] = ACTIONS(5053),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5053),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5053),
    [anon_sym_PERCENT] = ACTIONS(5053),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5057),
    [anon_sym_COLON_DASH] = ACTIONS(5053),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5059),
  },
  [2146] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5055),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2147] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5061),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2148] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2159),
    [sym_concatenation] = STATE(2159),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5063),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5063),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5067),
    [anon_sym_COLON_DASH] = ACTIONS(5063),
    [sym__special_character] = ACTIONS(441),
  },
  [2149] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2150] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2159),
    [sym_concatenation] = STATE(2159),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5063),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_DASH] = ACTIONS(5063),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5063),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5063),
    [anon_sym_PERCENT] = ACTIONS(5063),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5067),
    [anon_sym_COLON_DASH] = ACTIONS(5063),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5069),
  },
  [2151] = {
    [sym_command_substitution] = STATE(2161),
    [aux_sym__literal_repeat1] = STATE(2162),
    [sym_string] = STATE(2161),
    [sym_process_substitution] = STATE(2161),
    [sym_simple_expansion] = STATE(2161),
    [sym_string_expansion] = STATE(2161),
    [sym_concatenation] = STATE(2163),
    [sym_expansion] = STATE(2161),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5071),
    [sym_raw_string] = ACTIONS(5071),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2152] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2165),
    [sym_concatenation] = STATE(2165),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5073),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(5073),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5073),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5073),
    [anon_sym_PERCENT] = ACTIONS(5073),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5077),
    [anon_sym_COLON_DASH] = ACTIONS(5073),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5079),
  },
  [2153] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5075),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2154] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5065),
    [sym__concat] = ACTIONS(1265),
  },
  [2155] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5081),
  },
  [2156] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5065),
  },
  [2157] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2166),
    [sym_concatenation] = STATE(2166),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5083),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_DASH] = ACTIONS(5083),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5083),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5083),
    [anon_sym_PERCENT] = ACTIONS(5083),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5087),
    [anon_sym_COLON_DASH] = ACTIONS(5083),
    [sym__special_character] = ACTIONS(441),
  },
  [2158] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5085),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2159] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2160] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2167),
    [sym_concatenation] = STATE(2167),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5091),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [anon_sym_DASH] = ACTIONS(5091),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5091),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5091),
    [anon_sym_PERCENT] = ACTIONS(5091),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5093),
    [anon_sym_COLON_DASH] = ACTIONS(5091),
    [sym__special_character] = ACTIONS(441),
  },
  [2161] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5089),
    [sym__concat] = ACTIONS(1265),
  },
  [2162] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5095),
  },
  [2163] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5089),
  },
  [2164] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2168),
    [sym_concatenation] = STATE(2168),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5097),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(5097),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5097),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5097),
    [anon_sym_PERCENT] = ACTIONS(5097),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5101),
    [anon_sym_COLON_DASH] = ACTIONS(5097),
    [sym__special_character] = ACTIONS(441),
  },
  [2165] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5099),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2166] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5103),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2167] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5105),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2168] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5107),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2169] = {
    [sym_string] = STATE(1192),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [anon_sym_STAR] = ACTIONS(5109),
    [anon_sym_QMARK] = ACTIONS(5109),
    [sym_raw_string] = ACTIONS(5111),
    [anon_sym_BANG] = ACTIONS(5113),
    [anon_sym_AT] = ACTIONS(5109),
    [anon_sym_DOLLAR] = ACTIONS(5113),
    [anon_sym_POUND] = ACTIONS(5113),
    [anon_sym_DASH] = ACTIONS(5113),
    [anon_sym_0] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2862),
    [anon_sym__] = ACTIONS(2862),
  },
  [2170] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2179),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5115),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5117),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2171] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5119),
  },
  [2172] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5121),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2173] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5121),
  },
  [2174] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2181),
    [sym_concatenation] = STATE(2181),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5123),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5125),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5127),
    [anon_sym_DASH] = ACTIONS(5125),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5125),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5125),
    [anon_sym_PERCENT] = ACTIONS(5125),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5129),
    [anon_sym_COLON_DASH] = ACTIONS(5125),
    [sym__special_character] = ACTIONS(441),
  },
  [2175] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2186),
    [sym_concatenation] = STATE(2186),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5131),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5133),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5135),
    [anon_sym_DASH] = ACTIONS(5133),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5133),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5133),
    [anon_sym_PERCENT] = ACTIONS(5133),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5137),
    [anon_sym_COLON_DASH] = ACTIONS(5133),
    [sym__special_character] = ACTIONS(441),
  },
  [2176] = {
    [sym_command_substitution] = STATE(1202),
    [sym_simple_expansion] = STATE(1202),
    [sym_string_expansion] = STATE(1202),
    [sym_string] = STATE(1202),
    [sym_process_substitution] = STATE(1202),
    [sym_expansion] = STATE(1202),
    [anon_sym_BQUOTE] = ACTIONS(1723),
    [anon_sym_DQUOTE] = ACTIONS(1729),
    [sym_word] = ACTIONS(2827),
    [sym_raw_string] = ACTIONS(2827),
    [anon_sym_LT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR] = ACTIONS(1709),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(1711),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1713),
    [sym__special_character] = ACTIONS(2827),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1715),
  },
  [2177] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5139),
  },
  [2178] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5141),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2179] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5143),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5141),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2180] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2189),
    [sym_concatenation] = STATE(2189),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5145),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5149),
    [anon_sym_COLON_DASH] = ACTIONS(5145),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5151),
  },
  [2181] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2182] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2189),
    [sym_concatenation] = STATE(2189),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5153),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5145),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_DASH] = ACTIONS(5145),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5145),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5145),
    [anon_sym_PERCENT] = ACTIONS(5145),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5149),
    [anon_sym_COLON_DASH] = ACTIONS(5145),
    [sym__special_character] = ACTIONS(441),
  },
  [2183] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2193),
    [sym_concatenation] = STATE(2193),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5155),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5157),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5159),
    [anon_sym_DASH] = ACTIONS(5157),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5157),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5157),
    [anon_sym_PERCENT] = ACTIONS(5157),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5161),
    [anon_sym_COLON_DASH] = ACTIONS(5157),
    [sym__special_character] = ACTIONS(441),
  },
  [2184] = {
    [sym_command_substitution] = STATE(2194),
    [aux_sym__literal_repeat1] = STATE(2195),
    [sym_string] = STATE(2194),
    [sym_process_substitution] = STATE(2194),
    [sym_simple_expansion] = STATE(2194),
    [sym_string_expansion] = STATE(2194),
    [sym_concatenation] = STATE(2196),
    [sym_expansion] = STATE(2194),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5163),
    [sym_raw_string] = ACTIONS(5163),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5147),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2185] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2198),
    [sym_concatenation] = STATE(2198),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5165),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(5165),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5165),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5165),
    [anon_sym_PERCENT] = ACTIONS(5165),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5169),
    [anon_sym_COLON_DASH] = ACTIONS(5165),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5171),
  },
  [2186] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5167),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2187] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5173),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2188] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [sym_concatenation] = STATE(2199),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5175),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5175),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5175),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5179),
    [anon_sym_COLON_DASH] = ACTIONS(5175),
    [sym__special_character] = ACTIONS(441),
  },
  [2189] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2190] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2199),
    [sym_concatenation] = STATE(2199),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5175),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_DASH] = ACTIONS(5175),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5175),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5175),
    [anon_sym_PERCENT] = ACTIONS(5175),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5179),
    [anon_sym_COLON_DASH] = ACTIONS(5175),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5181),
  },
  [2191] = {
    [sym_command_substitution] = STATE(2201),
    [aux_sym__literal_repeat1] = STATE(2202),
    [sym_string] = STATE(2201),
    [sym_process_substitution] = STATE(2201),
    [sym_simple_expansion] = STATE(2201),
    [sym_string_expansion] = STATE(2201),
    [sym_concatenation] = STATE(2203),
    [sym_expansion] = STATE(2201),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5183),
    [sym_raw_string] = ACTIONS(5183),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2192] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2205),
    [sym_concatenation] = STATE(2205),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5185),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(5185),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5185),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5185),
    [anon_sym_PERCENT] = ACTIONS(5185),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5189),
    [anon_sym_COLON_DASH] = ACTIONS(5185),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5191),
  },
  [2193] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5187),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2194] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5177),
    [sym__concat] = ACTIONS(1265),
  },
  [2195] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5193),
  },
  [2196] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5177),
  },
  [2197] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2206),
    [sym_concatenation] = STATE(2206),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5195),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(5195),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5195),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5195),
    [anon_sym_PERCENT] = ACTIONS(5195),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5199),
    [anon_sym_COLON_DASH] = ACTIONS(5195),
    [sym__special_character] = ACTIONS(441),
  },
  [2198] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5197),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2199] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2200] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2207),
    [sym_concatenation] = STATE(2207),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5203),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [anon_sym_DASH] = ACTIONS(5203),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5203),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5203),
    [anon_sym_PERCENT] = ACTIONS(5203),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5205),
    [anon_sym_COLON_DASH] = ACTIONS(5203),
    [sym__special_character] = ACTIONS(441),
  },
  [2201] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5201),
    [sym__concat] = ACTIONS(1265),
  },
  [2202] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5207),
  },
  [2203] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5201),
  },
  [2204] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2208),
    [sym_concatenation] = STATE(2208),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5209),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_DASH] = ACTIONS(5209),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5209),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5209),
    [anon_sym_PERCENT] = ACTIONS(5209),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5213),
    [anon_sym_COLON_DASH] = ACTIONS(5209),
    [sym__special_character] = ACTIONS(441),
  },
  [2205] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5211),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2206] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5215),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2207] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5217),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2208] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5219),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2209] = {
    [sym_string] = STATE(1224),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [anon_sym_STAR] = ACTIONS(5221),
    [anon_sym_QMARK] = ACTIONS(5221),
    [sym_raw_string] = ACTIONS(5223),
    [anon_sym_BANG] = ACTIONS(5225),
    [anon_sym_AT] = ACTIONS(5221),
    [anon_sym_DOLLAR] = ACTIONS(5225),
    [anon_sym_POUND] = ACTIONS(5225),
    [anon_sym_DASH] = ACTIONS(5225),
    [anon_sym_0] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2890),
    [anon_sym__] = ACTIONS(2890),
  },
  [2210] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2219),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5227),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5229),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2211] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5231),
  },
  [2212] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5233),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2213] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5233),
  },
  [2214] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2221),
    [sym_concatenation] = STATE(2221),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5235),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5237),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5239),
    [anon_sym_DASH] = ACTIONS(5237),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5237),
    [anon_sym_PERCENT] = ACTIONS(5237),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5241),
    [anon_sym_COLON_DASH] = ACTIONS(5237),
    [sym__special_character] = ACTIONS(441),
  },
  [2215] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2226),
    [sym_concatenation] = STATE(2226),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5243),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5245),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5247),
    [anon_sym_DASH] = ACTIONS(5245),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5245),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5245),
    [anon_sym_PERCENT] = ACTIONS(5245),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5249),
    [anon_sym_COLON_DASH] = ACTIONS(5245),
    [sym__special_character] = ACTIONS(441),
  },
  [2216] = {
    [sym_command_substitution] = STATE(1234),
    [sym_simple_expansion] = STATE(1234),
    [sym_string_expansion] = STATE(1234),
    [sym_string] = STATE(1234),
    [sym_process_substitution] = STATE(1234),
    [sym_expansion] = STATE(1234),
    [anon_sym_BQUOTE] = ACTIONS(2845),
    [anon_sym_DQUOTE] = ACTIONS(2847),
    [sym_word] = ACTIONS(2849),
    [sym_raw_string] = ACTIONS(2849),
    [anon_sym_LT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR] = ACTIONS(2388),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2851),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2855),
    [sym__special_character] = ACTIONS(2849),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2857),
  },
  [2217] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5251),
  },
  [2218] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5253),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2219] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5255),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5253),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2220] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2229),
    [sym_concatenation] = STATE(2229),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5257),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5261),
    [anon_sym_COLON_DASH] = ACTIONS(5257),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5263),
  },
  [2221] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2222] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2229),
    [sym_concatenation] = STATE(2229),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5265),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5257),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5259),
    [anon_sym_DASH] = ACTIONS(5257),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5257),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5257),
    [anon_sym_PERCENT] = ACTIONS(5257),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5261),
    [anon_sym_COLON_DASH] = ACTIONS(5257),
    [sym__special_character] = ACTIONS(441),
  },
  [2223] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2233),
    [sym_concatenation] = STATE(2233),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5267),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5269),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5271),
    [anon_sym_DASH] = ACTIONS(5269),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5269),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5269),
    [anon_sym_PERCENT] = ACTIONS(5269),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5273),
    [anon_sym_COLON_DASH] = ACTIONS(5269),
    [sym__special_character] = ACTIONS(441),
  },
  [2224] = {
    [sym_command_substitution] = STATE(2234),
    [aux_sym__literal_repeat1] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym_process_substitution] = STATE(2234),
    [sym_simple_expansion] = STATE(2234),
    [sym_string_expansion] = STATE(2234),
    [sym_concatenation] = STATE(2236),
    [sym_expansion] = STATE(2234),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5275),
    [sym_raw_string] = ACTIONS(5275),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5259),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2225] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2238),
    [sym_concatenation] = STATE(2238),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5277),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_DASH] = ACTIONS(5277),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5277),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5277),
    [anon_sym_PERCENT] = ACTIONS(5277),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5281),
    [anon_sym_COLON_DASH] = ACTIONS(5277),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5283),
  },
  [2226] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5279),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2227] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5285),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2228] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2239),
    [sym_concatenation] = STATE(2239),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5287),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_DASH] = ACTIONS(5287),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_PERCENT] = ACTIONS(5287),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5291),
    [anon_sym_COLON_DASH] = ACTIONS(5287),
    [sym__special_character] = ACTIONS(441),
  },
  [2229] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2230] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2239),
    [sym_concatenation] = STATE(2239),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5287),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_DASH] = ACTIONS(5287),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5287),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5287),
    [anon_sym_PERCENT] = ACTIONS(5287),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5291),
    [anon_sym_COLON_DASH] = ACTIONS(5287),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5293),
  },
  [2231] = {
    [sym_command_substitution] = STATE(2241),
    [aux_sym__literal_repeat1] = STATE(2242),
    [sym_string] = STATE(2241),
    [sym_process_substitution] = STATE(2241),
    [sym_simple_expansion] = STATE(2241),
    [sym_string_expansion] = STATE(2241),
    [sym_concatenation] = STATE(2243),
    [sym_expansion] = STATE(2241),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5295),
    [sym_raw_string] = ACTIONS(5295),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2232] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2245),
    [sym_concatenation] = STATE(2245),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5297),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(5297),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5297),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5297),
    [anon_sym_PERCENT] = ACTIONS(5297),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5301),
    [anon_sym_COLON_DASH] = ACTIONS(5297),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5303),
  },
  [2233] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5299),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2234] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5289),
    [sym__concat] = ACTIONS(1265),
  },
  [2235] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5305),
  },
  [2236] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5289),
  },
  [2237] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2246),
    [sym_concatenation] = STATE(2246),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5307),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(5307),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5307),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5307),
    [anon_sym_PERCENT] = ACTIONS(5307),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5311),
    [anon_sym_COLON_DASH] = ACTIONS(5307),
    [sym__special_character] = ACTIONS(441),
  },
  [2238] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5309),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2239] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2240] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2247),
    [sym_concatenation] = STATE(2247),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5315),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [anon_sym_DASH] = ACTIONS(5315),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5315),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5315),
    [anon_sym_PERCENT] = ACTIONS(5315),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5317),
    [anon_sym_COLON_DASH] = ACTIONS(5315),
    [sym__special_character] = ACTIONS(441),
  },
  [2241] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5313),
    [sym__concat] = ACTIONS(1265),
  },
  [2242] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5319),
  },
  [2243] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5313),
  },
  [2244] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2248),
    [sym_concatenation] = STATE(2248),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5321),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_DASH] = ACTIONS(5321),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5321),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5321),
    [anon_sym_PERCENT] = ACTIONS(5321),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5325),
    [anon_sym_COLON_DASH] = ACTIONS(5321),
    [sym__special_character] = ACTIONS(441),
  },
  [2245] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5323),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2246] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5327),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2247] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5329),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2248] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5331),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2249] = {
    [sym_string] = STATE(1256),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [anon_sym_STAR] = ACTIONS(5333),
    [anon_sym_QMARK] = ACTIONS(5333),
    [sym_raw_string] = ACTIONS(5335),
    [anon_sym_BANG] = ACTIONS(5337),
    [anon_sym_AT] = ACTIONS(5333),
    [anon_sym_DOLLAR] = ACTIONS(5337),
    [anon_sym_POUND] = ACTIONS(5337),
    [anon_sym_DASH] = ACTIONS(5337),
    [anon_sym_0] = ACTIONS(2918),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2918),
    [anon_sym__] = ACTIONS(2918),
  },
  [2250] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2259),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5339),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5341),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2251] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5343),
  },
  [2252] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5345),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2253] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5345),
  },
  [2254] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2261),
    [sym_concatenation] = STATE(2261),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5347),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5349),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5351),
    [anon_sym_DASH] = ACTIONS(5349),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5349),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5349),
    [anon_sym_PERCENT] = ACTIONS(5349),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5353),
    [anon_sym_COLON_DASH] = ACTIONS(5349),
    [sym__special_character] = ACTIONS(441),
  },
  [2255] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2266),
    [sym_concatenation] = STATE(2266),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5355),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5357),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5359),
    [anon_sym_DASH] = ACTIONS(5357),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5357),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5357),
    [anon_sym_PERCENT] = ACTIONS(5357),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5361),
    [anon_sym_COLON_DASH] = ACTIONS(5357),
    [sym__special_character] = ACTIONS(441),
  },
  [2256] = {
    [sym_command_substitution] = STATE(1266),
    [sym_simple_expansion] = STATE(1266),
    [sym_string_expansion] = STATE(1266),
    [sym_string] = STATE(1266),
    [sym_process_substitution] = STATE(1266),
    [sym_expansion] = STATE(1266),
    [anon_sym_BQUOTE] = ACTIONS(2873),
    [anon_sym_DQUOTE] = ACTIONS(2875),
    [sym_word] = ACTIONS(2877),
    [sym_raw_string] = ACTIONS(2877),
    [anon_sym_LT_LPAREN] = ACTIONS(2879),
    [anon_sym_DOLLAR] = ACTIONS(2408),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2879),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2883),
    [sym__special_character] = ACTIONS(2877),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2885),
  },
  [2257] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5363),
  },
  [2258] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5365),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2259] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5367),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5365),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2260] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2269),
    [sym_concatenation] = STATE(2269),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5369),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_DASH] = ACTIONS(5369),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5369),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5373),
    [anon_sym_COLON_DASH] = ACTIONS(5369),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5375),
  },
  [2261] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2262] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2269),
    [sym_concatenation] = STATE(2269),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5377),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5369),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_DASH] = ACTIONS(5369),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5369),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5369),
    [anon_sym_PERCENT] = ACTIONS(5369),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5373),
    [anon_sym_COLON_DASH] = ACTIONS(5369),
    [sym__special_character] = ACTIONS(441),
  },
  [2263] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2273),
    [sym_concatenation] = STATE(2273),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5379),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5381),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5383),
    [anon_sym_DASH] = ACTIONS(5381),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5381),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5381),
    [anon_sym_PERCENT] = ACTIONS(5381),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5385),
    [anon_sym_COLON_DASH] = ACTIONS(5381),
    [sym__special_character] = ACTIONS(441),
  },
  [2264] = {
    [sym_command_substitution] = STATE(2274),
    [aux_sym__literal_repeat1] = STATE(2275),
    [sym_string] = STATE(2274),
    [sym_process_substitution] = STATE(2274),
    [sym_simple_expansion] = STATE(2274),
    [sym_string_expansion] = STATE(2274),
    [sym_concatenation] = STATE(2276),
    [sym_expansion] = STATE(2274),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5387),
    [sym_raw_string] = ACTIONS(5387),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5371),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2265] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2278),
    [sym_concatenation] = STATE(2278),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5389),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_DASH] = ACTIONS(5389),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5389),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5389),
    [anon_sym_PERCENT] = ACTIONS(5389),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5393),
    [anon_sym_COLON_DASH] = ACTIONS(5389),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5395),
  },
  [2266] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5391),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2267] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5397),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2268] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2279),
    [sym_concatenation] = STATE(2279),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5399),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5403),
    [anon_sym_COLON_DASH] = ACTIONS(5399),
    [sym__special_character] = ACTIONS(441),
  },
  [2269] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2270] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2279),
    [sym_concatenation] = STATE(2279),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5399),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_DASH] = ACTIONS(5399),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5399),
    [anon_sym_PERCENT] = ACTIONS(5399),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5403),
    [anon_sym_COLON_DASH] = ACTIONS(5399),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5405),
  },
  [2271] = {
    [sym_command_substitution] = STATE(2281),
    [aux_sym__literal_repeat1] = STATE(2282),
    [sym_string] = STATE(2281),
    [sym_process_substitution] = STATE(2281),
    [sym_simple_expansion] = STATE(2281),
    [sym_string_expansion] = STATE(2281),
    [sym_concatenation] = STATE(2283),
    [sym_expansion] = STATE(2281),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5407),
    [sym_raw_string] = ACTIONS(5407),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2272] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2285),
    [sym_concatenation] = STATE(2285),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5409),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_DASH] = ACTIONS(5409),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5409),
    [anon_sym_PERCENT] = ACTIONS(5409),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5413),
    [anon_sym_COLON_DASH] = ACTIONS(5409),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5415),
  },
  [2273] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5411),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2274] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5401),
    [sym__concat] = ACTIONS(1265),
  },
  [2275] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5417),
  },
  [2276] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5401),
  },
  [2277] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2286),
    [sym_concatenation] = STATE(2286),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5419),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(5419),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5419),
    [anon_sym_PERCENT] = ACTIONS(5419),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5423),
    [anon_sym_COLON_DASH] = ACTIONS(5419),
    [sym__special_character] = ACTIONS(441),
  },
  [2278] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5421),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2279] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2280] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2287),
    [sym_concatenation] = STATE(2287),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5427),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [anon_sym_DASH] = ACTIONS(5427),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5427),
    [anon_sym_PERCENT] = ACTIONS(5427),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5429),
    [anon_sym_COLON_DASH] = ACTIONS(5427),
    [sym__special_character] = ACTIONS(441),
  },
  [2281] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5425),
    [sym__concat] = ACTIONS(1265),
  },
  [2282] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5431),
  },
  [2283] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5425),
  },
  [2284] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2288),
    [sym_concatenation] = STATE(2288),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5433),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(5433),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5433),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5433),
    [anon_sym_PERCENT] = ACTIONS(5433),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5437),
    [anon_sym_COLON_DASH] = ACTIONS(5433),
    [sym__special_character] = ACTIONS(441),
  },
  [2285] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5435),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2286] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5439),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2287] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5441),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2288] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5443),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2289] = {
    [sym_string] = STATE(1288),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(5445),
    [anon_sym_QMARK] = ACTIONS(5445),
    [sym_raw_string] = ACTIONS(5447),
    [anon_sym_BANG] = ACTIONS(5449),
    [anon_sym_AT] = ACTIONS(5445),
    [anon_sym_DOLLAR] = ACTIONS(5449),
    [anon_sym_POUND] = ACTIONS(5449),
    [anon_sym_DASH] = ACTIONS(5449),
    [anon_sym_0] = ACTIONS(2927),
    [sym_comment] = ACTIONS(3),
    [aux_sym__simple_variable_name_token1] = ACTIONS(2927),
    [anon_sym__] = ACTIONS(2927),
  },
  [2290] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(2299),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5451),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5453),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2291] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5455),
  },
  [2292] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5457),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2293] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5457),
  },
  [2294] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2301),
    [sym_concatenation] = STATE(2301),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5459),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5461),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5463),
    [anon_sym_DASH] = ACTIONS(5461),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5461),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5461),
    [anon_sym_PERCENT] = ACTIONS(5461),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5465),
    [anon_sym_COLON_DASH] = ACTIONS(5461),
    [sym__special_character] = ACTIONS(441),
  },
  [2295] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2306),
    [sym_concatenation] = STATE(2306),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5467),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5469),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5471),
    [anon_sym_DASH] = ACTIONS(5469),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5469),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5469),
    [anon_sym_PERCENT] = ACTIONS(5469),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5473),
    [anon_sym_COLON_DASH] = ACTIONS(5469),
    [sym__special_character] = ACTIONS(441),
  },
  [2296] = {
    [sym_command_substitution] = STATE(1298),
    [sym_simple_expansion] = STATE(1298),
    [sym_string_expansion] = STATE(1298),
    [sym_string] = STATE(1298),
    [sym_process_substitution] = STATE(1298),
    [sym_expansion] = STATE(1298),
    [anon_sym_BQUOTE] = ACTIONS(2901),
    [anon_sym_DQUOTE] = ACTIONS(2903),
    [sym_word] = ACTIONS(2905),
    [sym_raw_string] = ACTIONS(2905),
    [anon_sym_LT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR] = ACTIONS(3577),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2907),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2911),
    [sym__special_character] = ACTIONS(2905),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2913),
  },
  [2297] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5475),
  },
  [2298] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5477),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2299] = {
    [sym_command_substitution] = STATE(83),
    [sym_simple_expansion] = STATE(83),
    [aux_sym_string_repeat1] = STATE(161),
    [sym_expansion] = STATE(83),
    [anon_sym_DOLLAR] = ACTIONS(5479),
    [anon_sym_BQUOTE] = ACTIONS(261),
    [anon_sym_DQUOTE] = ACTIONS(5477),
    [sym_comment] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(265),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(267),
    [sym__string_content] = ACTIONS(269),
  },
  [2300] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2309),
    [sym_concatenation] = STATE(2309),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5481),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5485),
    [anon_sym_COLON_DASH] = ACTIONS(5481),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5487),
  },
  [2301] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2302] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2309),
    [sym_concatenation] = STATE(2309),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5489),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5481),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_DASH] = ACTIONS(5481),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5481),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5481),
    [anon_sym_PERCENT] = ACTIONS(5481),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5485),
    [anon_sym_COLON_DASH] = ACTIONS(5481),
    [sym__special_character] = ACTIONS(441),
  },
  [2303] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2313),
    [sym_concatenation] = STATE(2313),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5491),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5493),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5495),
    [anon_sym_DASH] = ACTIONS(5493),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5493),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5493),
    [anon_sym_PERCENT] = ACTIONS(5493),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5497),
    [anon_sym_COLON_DASH] = ACTIONS(5493),
    [sym__special_character] = ACTIONS(441),
  },
  [2304] = {
    [sym_command_substitution] = STATE(2314),
    [aux_sym__literal_repeat1] = STATE(2315),
    [sym_string] = STATE(2314),
    [sym_process_substitution] = STATE(2314),
    [sym_simple_expansion] = STATE(2314),
    [sym_string_expansion] = STATE(2314),
    [sym_concatenation] = STATE(2316),
    [sym_expansion] = STATE(2314),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5499),
    [sym_raw_string] = ACTIONS(5499),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5483),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2305] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2318),
    [sym_concatenation] = STATE(2318),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5501),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_DASH] = ACTIONS(5501),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5501),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5501),
    [anon_sym_PERCENT] = ACTIONS(5501),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5505),
    [anon_sym_COLON_DASH] = ACTIONS(5501),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5507),
  },
  [2306] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5503),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2307] = {
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_DQUOTE] = ACTIONS(5509),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_BANG] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(573),
    [anon_sym_DOLLAR] = ACTIONS(577),
    [anon_sym_POUND] = ACTIONS(577),
    [anon_sym_DASH] = ACTIONS(577),
    [anon_sym_0] = ACTIONS(579),
    [sym__string_content] = ACTIONS(581),
    [aux_sym__simple_variable_name_token1] = ACTIONS(579),
    [anon_sym__] = ACTIONS(579),
    [sym_comment] = ACTIONS(3),
  },
  [2308] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2319),
    [sym_concatenation] = STATE(2319),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5511),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5513),
    [anon_sym_DASH] = ACTIONS(5511),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5511),
    [anon_sym_PERCENT] = ACTIONS(5511),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5515),
    [anon_sym_COLON_DASH] = ACTIONS(5511),
    [sym__special_character] = ACTIONS(441),
  },
  [2309] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5513),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2310] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2319),
    [sym_concatenation] = STATE(2319),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5511),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5513),
    [anon_sym_DASH] = ACTIONS(5511),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5511),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5511),
    [anon_sym_PERCENT] = ACTIONS(5511),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5515),
    [anon_sym_COLON_DASH] = ACTIONS(5511),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5517),
  },
  [2311] = {
    [sym_command_substitution] = STATE(2321),
    [aux_sym__literal_repeat1] = STATE(2322),
    [sym_string] = STATE(2321),
    [sym_process_substitution] = STATE(2321),
    [sym_simple_expansion] = STATE(2321),
    [sym_string_expansion] = STATE(2321),
    [sym_concatenation] = STATE(2323),
    [sym_expansion] = STATE(2321),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5519),
    [sym_raw_string] = ACTIONS(5519),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5513),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2312] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2325),
    [sym_concatenation] = STATE(2325),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5521),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_DASH] = ACTIONS(5521),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5521),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5521),
    [anon_sym_PERCENT] = ACTIONS(5521),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5525),
    [anon_sym_COLON_DASH] = ACTIONS(5521),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5527),
  },
  [2313] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5523),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2314] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5513),
    [sym__concat] = ACTIONS(1265),
  },
  [2315] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5529),
  },
  [2316] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5513),
  },
  [2317] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2326),
    [sym_concatenation] = STATE(2326),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5531),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5533),
    [anon_sym_DASH] = ACTIONS(5531),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5531),
    [anon_sym_PERCENT] = ACTIONS(5531),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5535),
    [anon_sym_COLON_DASH] = ACTIONS(5531),
    [sym__special_character] = ACTIONS(441),
  },
  [2318] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5533),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2319] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2320] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2327),
    [sym_concatenation] = STATE(2327),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5539),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [anon_sym_DASH] = ACTIONS(5539),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5539),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5539),
    [anon_sym_PERCENT] = ACTIONS(5539),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5541),
    [anon_sym_COLON_DASH] = ACTIONS(5539),
    [sym__special_character] = ACTIONS(441),
  },
  [2321] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5537),
    [sym__concat] = ACTIONS(1265),
  },
  [2322] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5543),
  },
  [2323] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5537),
  },
  [2324] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2328),
    [sym_concatenation] = STATE(2328),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5545),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(5545),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5545),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5545),
    [anon_sym_PERCENT] = ACTIONS(5545),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5549),
    [anon_sym_COLON_DASH] = ACTIONS(5545),
    [sym__special_character] = ACTIONS(441),
  },
  [2325] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5547),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2326] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5551),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2327] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5553),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2328] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5555),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2329] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5557),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2330] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5557),
  },
  [2331] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2335),
    [sym_concatenation] = STATE(2335),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5559),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5561),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5563),
    [anon_sym_DASH] = ACTIONS(5561),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5561),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5561),
    [anon_sym_PERCENT] = ACTIONS(5561),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5565),
    [anon_sym_COLON_DASH] = ACTIONS(5561),
    [sym__special_character] = ACTIONS(441),
  },
  [2332] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2340),
    [sym_concatenation] = STATE(2340),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5567),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5569),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5571),
    [anon_sym_DASH] = ACTIONS(5569),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5569),
    [anon_sym_PERCENT] = ACTIONS(5569),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5573),
    [anon_sym_COLON_DASH] = ACTIONS(5569),
    [sym__special_character] = ACTIONS(441),
  },
  [2333] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5575),
  },
  [2334] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2342),
    [sym_concatenation] = STATE(2342),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5577),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(5577),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5577),
    [anon_sym_PERCENT] = ACTIONS(5577),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5581),
    [anon_sym_COLON_DASH] = ACTIONS(5577),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5583),
  },
  [2335] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2336] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2342),
    [sym_concatenation] = STATE(2342),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5585),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5577),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_DASH] = ACTIONS(5577),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5577),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5577),
    [anon_sym_PERCENT] = ACTIONS(5577),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5581),
    [anon_sym_COLON_DASH] = ACTIONS(5577),
    [sym__special_character] = ACTIONS(441),
  },
  [2337] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2346),
    [sym_concatenation] = STATE(2346),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5587),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5589),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5591),
    [anon_sym_DASH] = ACTIONS(5589),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5589),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5589),
    [anon_sym_PERCENT] = ACTIONS(5589),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5593),
    [anon_sym_COLON_DASH] = ACTIONS(5589),
    [sym__special_character] = ACTIONS(441),
  },
  [2338] = {
    [sym_command_substitution] = STATE(2347),
    [aux_sym__literal_repeat1] = STATE(2348),
    [sym_string] = STATE(2347),
    [sym_process_substitution] = STATE(2347),
    [sym_simple_expansion] = STATE(2347),
    [sym_string_expansion] = STATE(2347),
    [sym_concatenation] = STATE(2349),
    [sym_expansion] = STATE(2347),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5595),
    [sym_raw_string] = ACTIONS(5595),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5579),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2339] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2351),
    [sym_concatenation] = STATE(2351),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5597),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(5597),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5597),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5597),
    [anon_sym_PERCENT] = ACTIONS(5597),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5601),
    [anon_sym_COLON_DASH] = ACTIONS(5597),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5603),
  },
  [2340] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5599),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2341] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2352),
    [sym_concatenation] = STATE(2352),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5605),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5609),
    [anon_sym_COLON_DASH] = ACTIONS(5605),
    [sym__special_character] = ACTIONS(441),
  },
  [2342] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2343] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2352),
    [sym_concatenation] = STATE(2352),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5605),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_DASH] = ACTIONS(5605),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5605),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5605),
    [anon_sym_PERCENT] = ACTIONS(5605),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5609),
    [anon_sym_COLON_DASH] = ACTIONS(5605),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5611),
  },
  [2344] = {
    [sym_command_substitution] = STATE(2354),
    [aux_sym__literal_repeat1] = STATE(2355),
    [sym_string] = STATE(2354),
    [sym_process_substitution] = STATE(2354),
    [sym_simple_expansion] = STATE(2354),
    [sym_string_expansion] = STATE(2354),
    [sym_concatenation] = STATE(2356),
    [sym_expansion] = STATE(2354),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5613),
    [sym_raw_string] = ACTIONS(5613),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2345] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2358),
    [sym_concatenation] = STATE(2358),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5615),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(5615),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5615),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5615),
    [anon_sym_PERCENT] = ACTIONS(5615),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5619),
    [anon_sym_COLON_DASH] = ACTIONS(5615),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5621),
  },
  [2346] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5617),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2347] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5607),
    [sym__concat] = ACTIONS(1265),
  },
  [2348] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5623),
  },
  [2349] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5607),
  },
  [2350] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2359),
    [sym_concatenation] = STATE(2359),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5625),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(5625),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5625),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5625),
    [anon_sym_PERCENT] = ACTIONS(5625),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5629),
    [anon_sym_COLON_DASH] = ACTIONS(5625),
    [sym__special_character] = ACTIONS(441),
  },
  [2351] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5627),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2352] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2353] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2360),
    [sym_concatenation] = STATE(2360),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5633),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [anon_sym_DASH] = ACTIONS(5633),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5633),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5633),
    [anon_sym_PERCENT] = ACTIONS(5633),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5635),
    [anon_sym_COLON_DASH] = ACTIONS(5633),
    [sym__special_character] = ACTIONS(441),
  },
  [2354] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5631),
    [sym__concat] = ACTIONS(1265),
  },
  [2355] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5637),
  },
  [2356] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5631),
  },
  [2357] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2361),
    [sym_concatenation] = STATE(2361),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5639),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5641),
    [anon_sym_DASH] = ACTIONS(5639),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5639),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5639),
    [anon_sym_PERCENT] = ACTIONS(5639),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5643),
    [anon_sym_COLON_DASH] = ACTIONS(5639),
    [sym__special_character] = ACTIONS(441),
  },
  [2358] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5641),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2359] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5645),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2360] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5647),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2361] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5649),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2362] = {
    [anon_sym_BQUOTE] = ACTIONS(325),
    [anon_sym_AMP_GT_GT] = ACTIONS(325),
    [sym_raw_string] = ACTIONS(325),
    [anon_sym_DOLLAR] = ACTIONS(323),
    [sym_file_descriptor] = ACTIONS(325),
    [sym_variable_name] = ACTIONS(325),
    [anon_sym_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(325),
    [anon_sym_AMP_GT] = ACTIONS(323),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(325),
    [anon_sym_GT_LPAREN] = ACTIONS(325),
    [anon_sym_RPAREN] = ACTIONS(5651),
    [anon_sym_DQUOTE] = ACTIONS(325),
    [sym_word] = ACTIONS(325),
    [anon_sym_GT_AMP] = ACTIONS(325),
    [anon_sym_LT] = ACTIONS(323),
    [anon_sym_LT_AMP] = ACTIONS(325),
    [anon_sym_GT_GT] = ACTIONS(325),
    [anon_sym_LT_LPAREN] = ACTIONS(325),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(325),
  },
  [2363] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5651),
  },
  [2364] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2368),
    [sym_concatenation] = STATE(2368),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5653),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5655),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5657),
    [anon_sym_DASH] = ACTIONS(5655),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5655),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5655),
    [anon_sym_PERCENT] = ACTIONS(5655),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5659),
    [anon_sym_COLON_DASH] = ACTIONS(5655),
    [sym__special_character] = ACTIONS(441),
  },
  [2365] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2373),
    [sym_concatenation] = STATE(2373),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5661),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5663),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5665),
    [anon_sym_DASH] = ACTIONS(5663),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5663),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5663),
    [anon_sym_PERCENT] = ACTIONS(5663),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5667),
    [anon_sym_COLON_DASH] = ACTIONS(5663),
    [sym__special_character] = ACTIONS(441),
  },
  [2366] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_BQUOTE] = ACTIONS(5669),
  },
  [2367] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2375),
    [sym_concatenation] = STATE(2375),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5671),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5673),
    [anon_sym_DASH] = ACTIONS(5671),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5671),
    [anon_sym_PERCENT] = ACTIONS(5671),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5675),
    [anon_sym_COLON_DASH] = ACTIONS(5671),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5677),
  },
  [2368] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5673),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2369] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2375),
    [sym_concatenation] = STATE(2375),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5679),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5671),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5673),
    [anon_sym_DASH] = ACTIONS(5671),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5671),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5671),
    [anon_sym_PERCENT] = ACTIONS(5671),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5675),
    [anon_sym_COLON_DASH] = ACTIONS(5671),
    [sym__special_character] = ACTIONS(441),
  },
  [2370] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2379),
    [sym_concatenation] = STATE(2379),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(5681),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5683),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5685),
    [anon_sym_DASH] = ACTIONS(5683),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5683),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5683),
    [anon_sym_PERCENT] = ACTIONS(5683),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5687),
    [anon_sym_COLON_DASH] = ACTIONS(5683),
    [sym__special_character] = ACTIONS(441),
  },
  [2371] = {
    [sym_command_substitution] = STATE(2380),
    [aux_sym__literal_repeat1] = STATE(2381),
    [sym_string] = STATE(2380),
    [sym_process_substitution] = STATE(2380),
    [sym_simple_expansion] = STATE(2380),
    [sym_string_expansion] = STATE(2380),
    [sym_concatenation] = STATE(2382),
    [sym_expansion] = STATE(2380),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5689),
    [sym_raw_string] = ACTIONS(5689),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5673),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2372] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2384),
    [sym_concatenation] = STATE(2384),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5691),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5693),
    [anon_sym_DASH] = ACTIONS(5691),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5691),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5691),
    [anon_sym_PERCENT] = ACTIONS(5691),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5695),
    [anon_sym_COLON_DASH] = ACTIONS(5691),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5697),
  },
  [2373] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5693),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2374] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2385),
    [sym_concatenation] = STATE(2385),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5699),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5699),
    [anon_sym_PERCENT] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5703),
    [anon_sym_COLON_DASH] = ACTIONS(5699),
    [sym__special_character] = ACTIONS(441),
  },
  [2375] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2376] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2385),
    [sym_concatenation] = STATE(2385),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5699),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_DASH] = ACTIONS(5699),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5699),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5699),
    [anon_sym_PERCENT] = ACTIONS(5699),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5703),
    [anon_sym_COLON_DASH] = ACTIONS(5699),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5705),
  },
  [2377] = {
    [sym_command_substitution] = STATE(2387),
    [aux_sym__literal_repeat1] = STATE(2388),
    [sym_string] = STATE(2387),
    [sym_process_substitution] = STATE(2387),
    [sym_simple_expansion] = STATE(2387),
    [sym_string_expansion] = STATE(2387),
    [sym_concatenation] = STATE(2389),
    [sym_expansion] = STATE(2387),
    [anon_sym_BQUOTE] = ACTIONS(905),
    [anon_sym_DQUOTE] = ACTIONS(907),
    [sym_word] = ACTIONS(5707),
    [sym_raw_string] = ACTIONS(5707),
    [anon_sym_LT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR] = ACTIONS(913),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [anon_sym_GT_LPAREN] = ACTIONS(911),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(915),
    [sym__special_character] = ACTIONS(917),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(919),
  },
  [2378] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2391),
    [sym_concatenation] = STATE(2391),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5709),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5711),
    [anon_sym_DASH] = ACTIONS(5709),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5709),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5709),
    [anon_sym_PERCENT] = ACTIONS(5709),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5713),
    [anon_sym_COLON_DASH] = ACTIONS(5709),
    [sym__special_character] = ACTIONS(441),
    [sym_regex] = ACTIONS(5715),
  },
  [2379] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5711),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2380] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5701),
    [sym__concat] = ACTIONS(1265),
  },
  [2381] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5717),
  },
  [2382] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5701),
  },
  [2383] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2392),
    [sym_concatenation] = STATE(2392),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5719),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(5719),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5719),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5719),
    [anon_sym_PERCENT] = ACTIONS(5719),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5723),
    [anon_sym_COLON_DASH] = ACTIONS(5719),
    [sym__special_character] = ACTIONS(441),
  },
  [2384] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5721),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2385] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2386] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2393),
    [sym_concatenation] = STATE(2393),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5727),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [anon_sym_DASH] = ACTIONS(5727),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5727),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5727),
    [anon_sym_PERCENT] = ACTIONS(5727),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5729),
    [anon_sym_COLON_DASH] = ACTIONS(5727),
    [sym__special_character] = ACTIONS(441),
  },
  [2387] = {
    [aux_sym_concatenation_repeat1] = STATE(1098),
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5725),
    [sym__concat] = ACTIONS(1265),
  },
  [2388] = {
    [aux_sym__literal_repeat1] = STATE(1133),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1267),
    [anon_sym_RBRACE] = ACTIONS(5731),
  },
  [2389] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RBRACE] = ACTIONS(5725),
  },
  [2390] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(2394),
    [sym_concatenation] = STATE(2394),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(5733),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_DASH] = ACTIONS(5733),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(5733),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(5733),
    [anon_sym_PERCENT] = ACTIONS(5733),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5737),
    [anon_sym_COLON_DASH] = ACTIONS(5733),
    [sym__special_character] = ACTIONS(441),
  },
  [2391] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5735),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2392] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5739),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2393] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5741),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2394] = {
    [sym_command_substitution] = STATE(114),
    [aux_sym__literal_repeat1] = STATE(116),
    [sym_string] = STATE(114),
    [sym_process_substitution] = STATE(114),
    [sym_simple_expansion] = STATE(114),
    [sym_string_expansion] = STATE(114),
    [aux_sym_expansion_repeat1] = STATE(190),
    [sym_concatenation] = STATE(190),
    [sym_expansion] = STATE(114),
    [anon_sym_BQUOTE] = ACTIONS(417),
    [sym_raw_string] = ACTIONS(421),
    [anon_sym_COLON_QMARK] = ACTIONS(889),
    [anon_sym_DOLLAR] = ACTIONS(425),
    [anon_sym_RBRACE] = ACTIONS(5743),
    [anon_sym_DASH] = ACTIONS(889),
    [anon_sym_GT_LPAREN] = ACTIONS(429),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(431),
    [anon_sym_EQ] = ACTIONS(889),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(433),
    [anon_sym_COLON] = ACTIONS(889),
    [anon_sym_PERCENT] = ACTIONS(889),
    [anon_sym_DQUOTE] = ACTIONS(435),
    [sym_word] = ACTIONS(437),
    [anon_sym_LT_LPAREN] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(891),
    [anon_sym_COLON_DASH] = ACTIONS(889),
    [sym__special_character] = ACTIONS(441),
  },
  [2395] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1365),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2396] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1366),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2397] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1367),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1368),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2398] = {
    [sym_subscript] = STATE(1369),
    [anon_sym_STAR] = ACTIONS(5745),
    [anon_sym_BANG] = ACTIONS(5747),
    [sym_variable_name] = ACTIONS(5749),
    [anon_sym_DOLLAR] = ACTIONS(5751),
    [anon_sym_DASH] = ACTIONS(5751),
    [anon_sym_0] = ACTIONS(5753),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5753),
    [anon_sym_QMARK] = ACTIONS(5745),
    [anon_sym_AT] = ACTIONS(5745),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5747),
    [anon_sym__] = ACTIONS(5753),
  },
  [2399] = {
    [sym_comment] = ACTIONS(51),
    [sym_word] = ACTIONS(5755),
  },
  [2400] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(1377),
    [sym_postfix_expression] = STATE(1377),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(1377),
    [sym_binary_expression] = STATE(1377),
    [sym_concatenation] = STATE(1377),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(1377),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2401] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1378),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2402] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5757),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5757),
  },
  [2403] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5759),
    [anon_sym_GT_AMP] = ACTIONS(5759),
    [anon_sym_LT] = ACTIONS(5761),
    [anon_sym_LT_AMP] = ACTIONS(5759),
    [anon_sym_GT_GT] = ACTIONS(5759),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(5761),
    [anon_sym_AMP_GT] = ACTIONS(5761),
  },
  [2404] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym__terminated_statement] = STATE(1383),
    [sym_if_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_negated_command] = STATE(66),
    [sym_test_command] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_compound_statement] = STATE(66),
    [sym_subshell] = STATE(66),
    [sym_declaration_command] = STATE(66),
    [sym_unset_command] = STATE(66),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_pipeline] = STATE(66),
    [sym_list] = STATE(66),
    [sym_command] = STATE(66),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2405] = {
    [aux_sym__literal_repeat1] = STATE(408),
    [sym_unary_expression] = STATE(1384),
    [sym_postfix_expression] = STATE(1384),
    [sym_string] = STATE(407),
    [sym_process_substitution] = STATE(407),
    [sym__expression] = STATE(1384),
    [sym_binary_expression] = STATE(1384),
    [sym_concatenation] = STATE(1384),
    [sym_expansion] = STATE(407),
    [sym_command_substitution] = STATE(407),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_simple_expansion] = STATE(407),
    [sym_string_expansion] = STATE(407),
    [sym_test_operator] = ACTIONS(275),
    [anon_sym_LPAREN] = ACTIONS(277),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [sym_raw_string] = ACTIONS(283),
    [anon_sym_BANG] = ACTIONS(287),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(281),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(295),
  },
  [2406] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(1385),
    [sym_postfix_expression] = STATE(1385),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(1385),
    [sym_binary_expression] = STATE(1385),
    [sym_concatenation] = STATE(1385),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(1385),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2407] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5757),
    [anon_sym_EQ] = ACTIONS(5757),
  },
  [2408] = {
    [sym_subscript] = STATE(1390),
    [anon_sym_STAR] = ACTIONS(5763),
    [sym_variable_name] = ACTIONS(5765),
    [anon_sym_DOLLAR] = ACTIONS(5767),
    [anon_sym_DASH] = ACTIONS(5767),
    [anon_sym_0] = ACTIONS(5769),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5769),
    [anon_sym_QMARK] = ACTIONS(5763),
    [anon_sym_AT] = ACTIONS(5763),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(5769),
  },
  [2409] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5771),
  },
  [2410] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5773),
  },
  [2411] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_then] = ACTIONS(5775),
  },
  [2412] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(1397),
    [sym_postfix_expression] = STATE(1397),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(1397),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(1397),
    [sym_binary_expression] = STATE(1397),
    [sym_concatenation] = STATE(1397),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [2413] = {
    [sym_command_substitution] = STATE(1399),
    [aux_sym__literal_repeat1] = STATE(1400),
    [sym_string] = STATE(1399),
    [sym_process_substitution] = STATE(1399),
    [sym_simple_expansion] = STATE(1399),
    [sym_string_expansion] = STATE(1399),
    [sym_concatenation] = STATE(1401),
    [sym_expansion] = STATE(1399),
    [anon_sym_BQUOTE] = ACTIONS(285),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [sym_word] = ACTIONS(5777),
    [sym_raw_string] = ACTIONS(5777),
    [anon_sym_LT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR] = ACTIONS(291),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(289),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(293),
    [sym__special_character] = ACTIONS(569),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(297),
  },
  [2414] = {
    [anon_sym_LF] = ACTIONS(5779),
    [anon_sym_AMP] = ACTIONS(5781),
    [anon_sym_SEMI] = ACTIONS(5781),
    [sym_comment] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(5783),
    [anon_sym_SEMI_SEMI] = ACTIONS(5781),
  },
  [2415] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5785),
  },
  [2416] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(5787),
  },
  [2417] = {
    [anon_sym_LF] = ACTIONS(5789),
    [anon_sym_SEMI] = ACTIONS(5791),
    [anon_sym_AMP] = ACTIONS(5791),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(5791),
  },
  [2418] = {
    [anon_sym_LF] = ACTIONS(5793),
    [anon_sym_SEMI] = ACTIONS(5795),
    [anon_sym_AMP] = ACTIONS(5795),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(5795),
  },
  [2419] = {
    [anon_sym_LF] = ACTIONS(5797),
    [anon_sym_SEMI] = ACTIONS(5799),
    [anon_sym_AMP] = ACTIONS(5799),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(5799),
  },
  [2420] = {
    [anon_sym_LF] = ACTIONS(5801),
    [anon_sym_SEMI] = ACTIONS(5803),
    [anon_sym_AMP] = ACTIONS(5803),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(5803),
  },
  [2421] = {
    [sym_command_substitution] = STATE(481),
    [aux_sym__literal_repeat1] = STATE(483),
    [sym_string] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(502),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_concatenation] = STATE(502),
    [sym_expansion] = STATE(481),
    [anon_sym_BQUOTE] = ACTIONS(1381),
    [sym_raw_string] = ACTIONS(1383),
    [anon_sym_LF] = ACTIONS(5805),
    [anon_sym_SEMI] = ACTIONS(5807),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [anon_sym_GT_LPAREN] = ACTIONS(1389),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1391),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1393),
    [anon_sym_DQUOTE] = ACTIONS(1395),
    [sym_word] = ACTIONS(1383),
    [anon_sym_AMP] = ACTIONS(5807),
    [anon_sym_LT_LPAREN] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(1397),
    [anon_sym_SEMI_SEMI] = ACTIONS(5807),
  },
  [2422] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(2425),
    [sym_postfix_expression] = STATE(2425),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(2425),
    [sym_binary_expression] = STATE(2425),
    [sym_concatenation] = STATE(2425),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(2425),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5809),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2423] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1449),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(312),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2424] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1450),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(312),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2425] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5811),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [2426] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(2429),
    [sym_postfix_expression] = STATE(2429),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(2429),
    [sym_binary_expression] = STATE(2429),
    [sym_concatenation] = STATE(2429),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(2429),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5811),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2427] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1453),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(312),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2428] = {
    [aux_sym__literal_repeat1] = STATE(271),
    [sym_string] = STATE(269),
    [sym_process_substitution] = STATE(269),
    [sym_last_case_item] = STATE(1454),
    [sym_concatenation] = STATE(274),
    [sym_expansion] = STATE(269),
    [sym_command_substitution] = STATE(269),
    [sym_case_item] = STATE(312),
    [sym_simple_expansion] = STATE(269),
    [sym_string_expansion] = STATE(269),
    [aux_sym_case_statement_repeat1] = STATE(312),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(1321),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(1321),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2429] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5813),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [2430] = {
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_unary_expression] = STATE(2431),
    [sym_postfix_expression] = STATE(2431),
    [sym_string] = STATE(73),
    [sym_process_substitution] = STATE(73),
    [sym__expression] = STATE(2431),
    [sym_binary_expression] = STATE(2431),
    [sym_concatenation] = STATE(2431),
    [sym_expansion] = STATE(73),
    [sym_command_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(2431),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5813),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(239),
  },
  [2431] = {
    [sym_test_operator] = ACTIONS(531),
    [anon_sym_PLUS_EQ] = ACTIONS(531),
    [anon_sym_PLUS_PLUS] = ACTIONS(533),
    [anon_sym_DASH] = ACTIONS(535),
    [anon_sym_RPAREN_RPAREN] = ACTIONS(5815),
    [anon_sym_PIPE_PIPE] = ACTIONS(531),
    [anon_sym_LT] = ACTIONS(535),
    [anon_sym_EQ_TILDE] = ACTIONS(537),
    [anon_sym_DASH_DASH] = ACTIONS(533),
    [anon_sym_LT_EQ] = ACTIONS(531),
    [anon_sym_DASH_EQ] = ACTIONS(531),
    [anon_sym_BANG_EQ] = ACTIONS(531),
    [anon_sym_GT] = ACTIONS(535),
    [anon_sym_EQ] = ACTIONS(535),
    [anon_sym_EQ_EQ] = ACTIONS(537),
    [anon_sym_GT_EQ] = ACTIONS(531),
    [anon_sym_PLUS] = ACTIONS(535),
    [sym_comment] = ACTIONS(51),
    [anon_sym_AMP_AMP] = ACTIONS(531),
  },
  [2432] = {
    [aux_sym_concatenation_repeat1] = STATE(820),
    [anon_sym_RBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(51),
    [sym__concat] = ACTIONS(5817),
  },
  [2433] = {
    [aux_sym_concatenation_repeat1] = STATE(1076),
    [anon_sym_LT_LT_DASH] = ACTIONS(469),
    [anon_sym_AMP_GT_GT] = ACTIONS(469),
    [anon_sym_LF] = ACTIONS(473),
    [anon_sym_SEMI] = ACTIONS(469),
    [anon_sym_LT_LT] = ACTIONS(469),
    [sym_file_descriptor] = ACTIONS(473),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_AMP_GT] = ACTIONS(469),
    [anon_sym_PIPE_PIPE] = ACTIONS(469),
    [anon_sym_LT_LT_LT] = ACTIONS(469),
    [anon_sym_PIPE] = ACTIONS(469),
    [anon_sym_GT_AMP] = ACTIONS(469),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_esac] = ACTIONS(469),
    [anon_sym_GT_GT] = ACTIONS(469),
    [anon_sym_LT_AMP] = ACTIONS(469),
    [anon_sym_AMP] = ACTIONS(469),
    [sym__concat] = ACTIONS(5819),
    [anon_sym_AMP_AMP] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(469),
    [anon_sym_PIPE_AMP] = ACTIONS(469),
  },
  [2434] = {
    [aux_sym_concatenation_repeat1] = STATE(2433),
    [anon_sym_LT_LT_DASH] = ACTIONS(199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(199),
    [anon_sym_LF] = ACTIONS(201),
    [anon_sym_SEMI] = ACTIONS(199),
    [anon_sym_LT_LT] = ACTIONS(199),
    [sym_file_descriptor] = ACTIONS(201),
    [anon_sym_GT] = ACTIONS(199),
    [anon_sym_AMP_GT] = ACTIONS(199),
    [anon_sym_PIPE_PIPE] = ACTIONS(199),
    [anon_sym_LT_LT_LT] = ACTIONS(199),
    [anon_sym_PIPE] = ACTIONS(199),
    [anon_sym_GT_AMP] = ACTIONS(199),
    [anon_sym_LT] = ACTIONS(199),
    [anon_sym_esac] = ACTIONS(199),
    [anon_sym_GT_GT] = ACTIONS(199),
    [anon_sym_LT_AMP] = ACTIONS(199),
    [anon_sym_AMP] = ACTIONS(199),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(199),
    [sym__special_character] = ACTIONS(199),
    [anon_sym_SEMI_SEMI] = ACTIONS(199),
    [anon_sym_PIPE_AMP] = ACTIONS(199),
  },
  [2435] = {
    [sym_command_substitution] = STATE(2624),
    [aux_sym__literal_repeat1] = STATE(462),
    [sym_string] = STATE(2624),
    [sym_process_substitution] = STATE(2624),
    [sym_simple_expansion] = STATE(2624),
    [sym_string_expansion] = STATE(2624),
    [sym_concatenation] = STATE(463),
    [sym_expansion] = STATE(2624),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(5821),
    [sym_raw_string] = ACTIONS(5821),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [sym__special_character] = ACTIONS(5823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
  },
  [2436] = {
    [sym_command_substitution] = STATE(2626),
    [aux_sym__literal_repeat1] = STATE(546),
    [sym_string] = STATE(2626),
    [sym_process_substitution] = STATE(2626),
    [sym_simple_expansion] = STATE(2626),
    [sym_string_expansion] = STATE(2626),
    [sym_concatenation] = STATE(547),
    [sym_expansion] = STATE(2626),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(5825),
    [sym_raw_string] = ACTIONS(5825),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [sym__special_character] = ACTIONS(5823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
  },
  [2437] = {
    [sym_command_substitution] = STATE(2627),
    [aux_sym__literal_repeat1] = STATE(592),
    [sym_string] = STATE(2627),
    [sym_process_substitution] = STATE(2627),
    [sym_simple_expansion] = STATE(2627),
    [sym_string_expansion] = STATE(2627),
    [sym_concatenation] = STATE(593),
    [sym_expansion] = STATE(2627),
    [anon_sym_BQUOTE] = ACTIONS(2737),
    [anon_sym_DQUOTE] = ACTIONS(2749),
    [sym_word] = ACTIONS(5827),
    [sym_raw_string] = ACTIONS(5827),
    [anon_sym_LT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR] = ACTIONS(3005),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(2743),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2745),
    [sym__special_character] = ACTIONS(5823),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
  },
  [2438] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1473),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2439] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1474),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1475),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2440] = {
    [sym_subscript] = STATE(1476),
    [anon_sym_STAR] = ACTIONS(5829),
    [anon_sym_BANG] = ACTIONS(5831),
    [sym_variable_name] = ACTIONS(5833),
    [anon_sym_DOLLAR] = ACTIONS(5835),
    [anon_sym_DASH] = ACTIONS(5835),
    [anon_sym_0] = ACTIONS(5837),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5837),
    [anon_sym_QMARK] = ACTIONS(5829),
    [anon_sym_AT] = ACTIONS(5829),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5831),
    [anon_sym__] = ACTIONS(5837),
  },
  [2441] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1480),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2442] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5839),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5839),
  },
  [2443] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5841),
    [anon_sym_GT_AMP] = ACTIONS(5841),
    [anon_sym_LT] = ACTIONS(5843),
    [anon_sym_LT_AMP] = ACTIONS(5841),
    [anon_sym_GT_GT] = ACTIONS(5841),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(5843),
    [anon_sym_AMP_GT] = ACTIONS(5843),
  },
  [2444] = {
    [anon_sym_EQ] = ACTIONS(5839),
    [anon_sym_PLUS_EQ] = ACTIONS(5839),
    [sym_comment] = ACTIONS(51),
  },
  [2445] = {
    [sym_subscript] = STATE(1487),
    [anon_sym_STAR] = ACTIONS(5845),
    [sym_variable_name] = ACTIONS(5847),
    [anon_sym_DOLLAR] = ACTIONS(5849),
    [anon_sym_DASH] = ACTIONS(5849),
    [anon_sym_0] = ACTIONS(5851),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5851),
    [anon_sym_QMARK] = ACTIONS(5845),
    [anon_sym_AT] = ACTIONS(5845),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(5851),
  },
  [2446] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5853),
  },
  [2447] = {
    [sym_command_substitution] = STATE(73),
    [sym_unary_expression] = STATE(1492),
    [sym_postfix_expression] = STATE(1492),
    [sym_string] = STATE(73),
    [aux_sym__literal_repeat1] = STATE(74),
    [sym_process_substitution] = STATE(73),
    [sym_parenthesized_expression] = STATE(1492),
    [sym_simple_expansion] = STATE(73),
    [sym_string_expansion] = STATE(73),
    [sym__expression] = STATE(1492),
    [sym_binary_expression] = STATE(1492),
    [sym_concatenation] = STATE(1492),
    [sym_expansion] = STATE(73),
    [sym_test_operator] = ACTIONS(219),
    [anon_sym_LPAREN] = ACTIONS(221),
    [anon_sym_DQUOTE] = ACTIONS(223),
    [sym_word] = ACTIONS(225),
    [sym_raw_string] = ACTIONS(227),
    [anon_sym_BQUOTE] = ACTIONS(229),
    [anon_sym_BANG] = ACTIONS(231),
    [anon_sym_LT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR] = ACTIONS(235),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT_LPAREN] = ACTIONS(233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(237),
    [sym__special_character] = ACTIONS(239),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(241),
  },
  [2448] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5855),
  },
  [2449] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1519),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2450] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1520),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1521),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2451] = {
    [sym_subscript] = STATE(1522),
    [anon_sym_STAR] = ACTIONS(5857),
    [anon_sym_QMARK] = ACTIONS(5857),
    [anon_sym_BANG] = ACTIONS(5859),
    [anon_sym_AT] = ACTIONS(5857),
    [sym_variable_name] = ACTIONS(5861),
    [anon_sym_DOLLAR] = ACTIONS(5863),
    [anon_sym_DASH] = ACTIONS(5863),
    [anon_sym_0] = ACTIONS(5865),
    [anon_sym_POUND] = ACTIONS(5859),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5865),
    [anon_sym__] = ACTIONS(5865),
    [sym_comment] = ACTIONS(3),
  },
  [2452] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1525),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2453] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5867),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5867),
  },
  [2454] = {
    [anon_sym_AMP_GT_GT] = ACTIONS(5869),
    [anon_sym_GT_AMP] = ACTIONS(5869),
    [anon_sym_LT] = ACTIONS(5871),
    [anon_sym_LT_AMP] = ACTIONS(5869),
    [anon_sym_GT_GT] = ACTIONS(5869),
    [sym_comment] = ACTIONS(51),
    [anon_sym_GT] = ACTIONS(5871),
    [anon_sym_AMP_GT] = ACTIONS(5871),
  },
  [2455] = {
    [anon_sym_EQ] = ACTIONS(5867),
    [anon_sym_PLUS_EQ] = ACTIONS(5867),
    [sym_comment] = ACTIONS(51),
  },
  [2456] = {
    [sym_subscript] = STATE(1531),
    [anon_sym_STAR] = ACTIONS(5873),
    [anon_sym_QMARK] = ACTIONS(5873),
    [anon_sym_AT] = ACTIONS(5873),
    [sym_variable_name] = ACTIONS(5875),
    [anon_sym_DOLLAR] = ACTIONS(5877),
    [anon_sym_DASH] = ACTIONS(5877),
    [anon_sym_0] = ACTIONS(5879),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5879),
    [anon_sym__] = ACTIONS(5879),
  },
  [2457] = {
    [anon_sym_EQ] = ACTIONS(5881),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2458] = {
    [anon_sym_EQ] = ACTIONS(5883),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2459] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1562),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2460] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1563),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1564),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2461] = {
    [sym_subscript] = STATE(1565),
    [anon_sym_STAR] = ACTIONS(5885),
    [anon_sym_QMARK] = ACTIONS(5885),
    [anon_sym_BANG] = ACTIONS(5887),
    [anon_sym_AT] = ACTIONS(5885),
    [sym_variable_name] = ACTIONS(5889),
    [anon_sym_DOLLAR] = ACTIONS(5891),
    [anon_sym_DASH] = ACTIONS(5891),
    [anon_sym_0] = ACTIONS(5893),
    [anon_sym_POUND] = ACTIONS(5887),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5893),
    [anon_sym__] = ACTIONS(5893),
    [sym_comment] = ACTIONS(3),
  },
  [2462] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1568),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2463] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5895),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5895),
  },
  [2464] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5895),
    [anon_sym_EQ] = ACTIONS(5895),
  },
  [2465] = {
    [sym_subscript] = STATE(1574),
    [anon_sym_STAR] = ACTIONS(5897),
    [anon_sym_QMARK] = ACTIONS(5897),
    [anon_sym_AT] = ACTIONS(5897),
    [sym_variable_name] = ACTIONS(5899),
    [anon_sym_DOLLAR] = ACTIONS(5901),
    [anon_sym_DASH] = ACTIONS(5901),
    [anon_sym_0] = ACTIONS(5903),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5903),
    [anon_sym__] = ACTIONS(5903),
  },
  [2466] = {
    [anon_sym_EQ] = ACTIONS(5905),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2467] = {
    [anon_sym_EQ] = ACTIONS(5907),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2468] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1605),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2469] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1606),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1607),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2470] = {
    [sym_subscript] = STATE(1608),
    [anon_sym_STAR] = ACTIONS(5909),
    [anon_sym_QMARK] = ACTIONS(5909),
    [anon_sym_BANG] = ACTIONS(5911),
    [anon_sym_AT] = ACTIONS(5909),
    [sym_variable_name] = ACTIONS(5913),
    [anon_sym_DOLLAR] = ACTIONS(5915),
    [anon_sym_DASH] = ACTIONS(5915),
    [anon_sym_0] = ACTIONS(5917),
    [anon_sym_POUND] = ACTIONS(5911),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5917),
    [anon_sym__] = ACTIONS(5917),
    [sym_comment] = ACTIONS(3),
  },
  [2471] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1611),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2472] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5919),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5919),
  },
  [2473] = {
    [anon_sym_EQ] = ACTIONS(5919),
    [anon_sym_PLUS_EQ] = ACTIONS(5919),
    [sym_comment] = ACTIONS(51),
  },
  [2474] = {
    [sym_subscript] = STATE(1617),
    [anon_sym_STAR] = ACTIONS(5921),
    [anon_sym_QMARK] = ACTIONS(5921),
    [anon_sym_AT] = ACTIONS(5921),
    [sym_variable_name] = ACTIONS(5923),
    [anon_sym_DOLLAR] = ACTIONS(5925),
    [anon_sym_DASH] = ACTIONS(5925),
    [anon_sym_0] = ACTIONS(5927),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5927),
    [anon_sym__] = ACTIONS(5927),
  },
  [2475] = {
    [anon_sym_EQ] = ACTIONS(5929),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2476] = {
    [anon_sym_EQ] = ACTIONS(5931),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2477] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1648),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2478] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1649),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1650),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2479] = {
    [sym_subscript] = STATE(1651),
    [anon_sym_STAR] = ACTIONS(5933),
    [anon_sym_BANG] = ACTIONS(5935),
    [sym_variable_name] = ACTIONS(5937),
    [anon_sym_DOLLAR] = ACTIONS(5939),
    [anon_sym_DASH] = ACTIONS(5939),
    [anon_sym_0] = ACTIONS(5941),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5941),
    [anon_sym_QMARK] = ACTIONS(5933),
    [anon_sym_AT] = ACTIONS(5933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5935),
    [anon_sym__] = ACTIONS(5941),
  },
  [2480] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1654),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2481] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_PLUS_EQ] = ACTIONS(5943),
    [anon_sym_LBRACK] = ACTIONS(253),
    [anon_sym_EQ] = ACTIONS(5943),
  },
  [2482] = {
    [anon_sym_EQ] = ACTIONS(5943),
    [anon_sym_PLUS_EQ] = ACTIONS(5943),
    [sym_comment] = ACTIONS(51),
  },
  [2483] = {
    [sym_subscript] = STATE(1660),
    [anon_sym_STAR] = ACTIONS(5945),
    [sym_variable_name] = ACTIONS(5947),
    [anon_sym_DOLLAR] = ACTIONS(5949),
    [anon_sym_DASH] = ACTIONS(5949),
    [anon_sym_0] = ACTIONS(5951),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5951),
    [anon_sym_QMARK] = ACTIONS(5945),
    [anon_sym_AT] = ACTIONS(5945),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(5951),
  },
  [2484] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5953),
  },
  [2485] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5955),
  },
  [2486] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1691),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2487] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1692),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1693),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2488] = {
    [sym_subscript] = STATE(1694),
    [anon_sym_STAR] = ACTIONS(5957),
    [anon_sym_QMARK] = ACTIONS(5957),
    [anon_sym_BANG] = ACTIONS(5959),
    [anon_sym_AT] = ACTIONS(5957),
    [sym_variable_name] = ACTIONS(5961),
    [anon_sym_DOLLAR] = ACTIONS(5963),
    [anon_sym_DASH] = ACTIONS(5963),
    [anon_sym_0] = ACTIONS(5965),
    [anon_sym_POUND] = ACTIONS(5959),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5965),
    [anon_sym__] = ACTIONS(5965),
    [sym_comment] = ACTIONS(3),
  },
  [2489] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1697),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2490] = {
    [sym_subscript] = STATE(1702),
    [anon_sym_STAR] = ACTIONS(5967),
    [anon_sym_QMARK] = ACTIONS(5967),
    [anon_sym_AT] = ACTIONS(5967),
    [sym_variable_name] = ACTIONS(5969),
    [anon_sym_DOLLAR] = ACTIONS(5971),
    [anon_sym_DASH] = ACTIONS(5971),
    [anon_sym_0] = ACTIONS(5973),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5973),
    [anon_sym__] = ACTIONS(5973),
  },
  [2491] = {
    [anon_sym_EQ] = ACTIONS(5975),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2492] = {
    [anon_sym_EQ] = ACTIONS(5977),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2493] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1731),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2494] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1732),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1733),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2495] = {
    [sym_subscript] = STATE(1734),
    [anon_sym_STAR] = ACTIONS(5979),
    [anon_sym_BANG] = ACTIONS(5981),
    [sym_variable_name] = ACTIONS(5983),
    [anon_sym_DOLLAR] = ACTIONS(5985),
    [anon_sym_DASH] = ACTIONS(5985),
    [anon_sym_0] = ACTIONS(5987),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5987),
    [anon_sym_QMARK] = ACTIONS(5979),
    [anon_sym_AT] = ACTIONS(5979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(5981),
    [anon_sym__] = ACTIONS(5987),
  },
  [2496] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1737),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2497] = {
    [sym_subscript] = STATE(1742),
    [anon_sym_STAR] = ACTIONS(5989),
    [sym_variable_name] = ACTIONS(5991),
    [anon_sym_DOLLAR] = ACTIONS(5993),
    [anon_sym_DASH] = ACTIONS(5993),
    [anon_sym_0] = ACTIONS(5995),
    [aux_sym__simple_variable_name_token1] = ACTIONS(5995),
    [anon_sym_QMARK] = ACTIONS(5989),
    [anon_sym_AT] = ACTIONS(5989),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(5995),
  },
  [2498] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5997),
  },
  [2499] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(5999),
  },
  [2500] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1771),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2501] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1772),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1773),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2502] = {
    [sym_subscript] = STATE(1774),
    [anon_sym_STAR] = ACTIONS(6001),
    [anon_sym_BANG] = ACTIONS(6003),
    [sym_variable_name] = ACTIONS(6005),
    [anon_sym_DOLLAR] = ACTIONS(6007),
    [anon_sym_DASH] = ACTIONS(6007),
    [anon_sym_0] = ACTIONS(6009),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6009),
    [anon_sym_QMARK] = ACTIONS(6001),
    [anon_sym_AT] = ACTIONS(6001),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6003),
    [anon_sym__] = ACTIONS(6009),
  },
  [2503] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1777),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2504] = {
    [sym_subscript] = STATE(1782),
    [anon_sym_STAR] = ACTIONS(6011),
    [sym_variable_name] = ACTIONS(6013),
    [anon_sym_DOLLAR] = ACTIONS(6015),
    [anon_sym_DASH] = ACTIONS(6015),
    [anon_sym_0] = ACTIONS(6017),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6017),
    [anon_sym_QMARK] = ACTIONS(6011),
    [anon_sym_AT] = ACTIONS(6011),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(6017),
  },
  [2505] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6019),
  },
  [2506] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6021),
  },
  [2507] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1811),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2508] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1812),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1813),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2509] = {
    [sym_subscript] = STATE(1814),
    [anon_sym_STAR] = ACTIONS(6023),
    [anon_sym_BANG] = ACTIONS(6025),
    [sym_variable_name] = ACTIONS(6027),
    [anon_sym_DOLLAR] = ACTIONS(6029),
    [anon_sym_DASH] = ACTIONS(6029),
    [anon_sym_0] = ACTIONS(6031),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6031),
    [anon_sym_QMARK] = ACTIONS(6023),
    [anon_sym_AT] = ACTIONS(6023),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6025),
    [anon_sym__] = ACTIONS(6031),
  },
  [2510] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1817),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2511] = {
    [sym_subscript] = STATE(1822),
    [anon_sym_STAR] = ACTIONS(6033),
    [sym_variable_name] = ACTIONS(6035),
    [anon_sym_DOLLAR] = ACTIONS(6037),
    [anon_sym_DASH] = ACTIONS(6037),
    [anon_sym_0] = ACTIONS(6039),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6039),
    [anon_sym_QMARK] = ACTIONS(6033),
    [anon_sym_AT] = ACTIONS(6033),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(6039),
  },
  [2512] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6041),
  },
  [2513] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6043),
  },
  [2514] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1851),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2515] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1852),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1853),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2516] = {
    [sym_subscript] = STATE(1854),
    [anon_sym_STAR] = ACTIONS(6045),
    [anon_sym_QMARK] = ACTIONS(6045),
    [anon_sym_BANG] = ACTIONS(6047),
    [anon_sym_AT] = ACTIONS(6045),
    [sym_variable_name] = ACTIONS(6049),
    [anon_sym_DOLLAR] = ACTIONS(6051),
    [anon_sym_DASH] = ACTIONS(6051),
    [anon_sym_0] = ACTIONS(6053),
    [anon_sym_POUND] = ACTIONS(6047),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6053),
    [anon_sym__] = ACTIONS(6053),
    [sym_comment] = ACTIONS(3),
  },
  [2517] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1857),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2518] = {
    [sym_subscript] = STATE(1862),
    [anon_sym_STAR] = ACTIONS(6055),
    [anon_sym_QMARK] = ACTIONS(6055),
    [anon_sym_AT] = ACTIONS(6055),
    [sym_variable_name] = ACTIONS(6057),
    [anon_sym_DOLLAR] = ACTIONS(6059),
    [anon_sym_DASH] = ACTIONS(6059),
    [anon_sym_0] = ACTIONS(6061),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6061),
    [anon_sym__] = ACTIONS(6061),
  },
  [2519] = {
    [anon_sym_EQ] = ACTIONS(6063),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2520] = {
    [anon_sym_EQ] = ACTIONS(6065),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2521] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1891),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2522] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1892),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1893),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2523] = {
    [sym_subscript] = STATE(1894),
    [anon_sym_STAR] = ACTIONS(6067),
    [anon_sym_QMARK] = ACTIONS(6067),
    [anon_sym_BANG] = ACTIONS(6069),
    [anon_sym_AT] = ACTIONS(6067),
    [sym_variable_name] = ACTIONS(6071),
    [anon_sym_DOLLAR] = ACTIONS(6073),
    [anon_sym_DASH] = ACTIONS(6073),
    [anon_sym_0] = ACTIONS(6075),
    [anon_sym_POUND] = ACTIONS(6069),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6075),
    [anon_sym__] = ACTIONS(6075),
    [sym_comment] = ACTIONS(3),
  },
  [2524] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1897),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2525] = {
    [sym_subscript] = STATE(1902),
    [anon_sym_STAR] = ACTIONS(6077),
    [anon_sym_QMARK] = ACTIONS(6077),
    [anon_sym_AT] = ACTIONS(6077),
    [sym_variable_name] = ACTIONS(6079),
    [anon_sym_DOLLAR] = ACTIONS(6081),
    [anon_sym_DASH] = ACTIONS(6081),
    [anon_sym_0] = ACTIONS(6083),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6083),
    [anon_sym__] = ACTIONS(6083),
  },
  [2526] = {
    [anon_sym_EQ] = ACTIONS(6085),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2527] = {
    [anon_sym_EQ] = ACTIONS(6087),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2528] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1931),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2529] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1932),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1933),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2530] = {
    [sym_subscript] = STATE(1934),
    [anon_sym_STAR] = ACTIONS(6089),
    [anon_sym_QMARK] = ACTIONS(6089),
    [anon_sym_BANG] = ACTIONS(6091),
    [anon_sym_AT] = ACTIONS(6089),
    [sym_variable_name] = ACTIONS(6093),
    [anon_sym_DOLLAR] = ACTIONS(6095),
    [anon_sym_DASH] = ACTIONS(6095),
    [anon_sym_0] = ACTIONS(6097),
    [anon_sym_POUND] = ACTIONS(6091),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6097),
    [anon_sym__] = ACTIONS(6097),
    [sym_comment] = ACTIONS(3),
  },
  [2531] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1937),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2532] = {
    [sym_subscript] = STATE(1942),
    [anon_sym_STAR] = ACTIONS(6099),
    [anon_sym_QMARK] = ACTIONS(6099),
    [anon_sym_AT] = ACTIONS(6099),
    [sym_variable_name] = ACTIONS(6101),
    [anon_sym_DOLLAR] = ACTIONS(6103),
    [anon_sym_DASH] = ACTIONS(6103),
    [anon_sym_0] = ACTIONS(6105),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6105),
    [anon_sym__] = ACTIONS(6105),
  },
  [2533] = {
    [anon_sym_EQ] = ACTIONS(6107),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2534] = {
    [anon_sym_EQ] = ACTIONS(6109),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2535] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1971),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2536] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(1972),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(1973),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2537] = {
    [sym_subscript] = STATE(1974),
    [anon_sym_STAR] = ACTIONS(6111),
    [anon_sym_QMARK] = ACTIONS(6111),
    [anon_sym_BANG] = ACTIONS(6113),
    [anon_sym_AT] = ACTIONS(6111),
    [sym_variable_name] = ACTIONS(6115),
    [anon_sym_DOLLAR] = ACTIONS(6117),
    [anon_sym_DASH] = ACTIONS(6117),
    [anon_sym_0] = ACTIONS(6119),
    [anon_sym_POUND] = ACTIONS(6113),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6119),
    [anon_sym__] = ACTIONS(6119),
    [sym_comment] = ACTIONS(3),
  },
  [2538] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(1977),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2539] = {
    [sym_subscript] = STATE(1982),
    [anon_sym_STAR] = ACTIONS(6121),
    [anon_sym_QMARK] = ACTIONS(6121),
    [anon_sym_AT] = ACTIONS(6121),
    [sym_variable_name] = ACTIONS(6123),
    [anon_sym_DOLLAR] = ACTIONS(6125),
    [anon_sym_DASH] = ACTIONS(6125),
    [anon_sym_0] = ACTIONS(6127),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6127),
    [anon_sym__] = ACTIONS(6127),
  },
  [2540] = {
    [anon_sym_EQ] = ACTIONS(6129),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2541] = {
    [anon_sym_EQ] = ACTIONS(6131),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2542] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2011),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2543] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2012),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2013),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2544] = {
    [sym_subscript] = STATE(2014),
    [anon_sym_STAR] = ACTIONS(6133),
    [anon_sym_BANG] = ACTIONS(6135),
    [sym_variable_name] = ACTIONS(6137),
    [anon_sym_DOLLAR] = ACTIONS(6139),
    [anon_sym_DASH] = ACTIONS(6139),
    [anon_sym_0] = ACTIONS(6141),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6141),
    [anon_sym_QMARK] = ACTIONS(6133),
    [anon_sym_AT] = ACTIONS(6133),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6135),
    [anon_sym__] = ACTIONS(6141),
  },
  [2545] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2017),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2546] = {
    [sym_subscript] = STATE(2022),
    [anon_sym_STAR] = ACTIONS(6143),
    [sym_variable_name] = ACTIONS(6145),
    [anon_sym_DOLLAR] = ACTIONS(6147),
    [anon_sym_DASH] = ACTIONS(6147),
    [anon_sym_0] = ACTIONS(6149),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6149),
    [anon_sym_QMARK] = ACTIONS(6143),
    [anon_sym_AT] = ACTIONS(6143),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(6149),
  },
  [2547] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6151),
  },
  [2548] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6153),
  },
  [2549] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2051),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2550] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2052),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2053),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2551] = {
    [sym_subscript] = STATE(2054),
    [anon_sym_STAR] = ACTIONS(6155),
    [anon_sym_BANG] = ACTIONS(6157),
    [sym_variable_name] = ACTIONS(6159),
    [anon_sym_DOLLAR] = ACTIONS(6161),
    [anon_sym_DASH] = ACTIONS(6161),
    [anon_sym_0] = ACTIONS(6163),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6163),
    [anon_sym_QMARK] = ACTIONS(6155),
    [anon_sym_AT] = ACTIONS(6155),
    [sym_comment] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(6157),
    [anon_sym__] = ACTIONS(6163),
  },
  [2552] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2057),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(247),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2553] = {
    [sym_subscript] = STATE(2062),
    [anon_sym_STAR] = ACTIONS(6165),
    [sym_variable_name] = ACTIONS(6167),
    [anon_sym_DOLLAR] = ACTIONS(6169),
    [anon_sym_DASH] = ACTIONS(6169),
    [anon_sym_0] = ACTIONS(6171),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6171),
    [anon_sym_QMARK] = ACTIONS(6165),
    [anon_sym_AT] = ACTIONS(6165),
    [sym_comment] = ACTIONS(51),
    [anon_sym__] = ACTIONS(6171),
  },
  [2554] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6173),
  },
  [2555] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
    [anon_sym_EQ] = ACTIONS(6175),
  },
  [2556] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2091),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2557] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2092),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2093),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2558] = {
    [sym_subscript] = STATE(2094),
    [anon_sym_STAR] = ACTIONS(6177),
    [anon_sym_QMARK] = ACTIONS(6177),
    [anon_sym_BANG] = ACTIONS(6179),
    [anon_sym_AT] = ACTIONS(6177),
    [sym_variable_name] = ACTIONS(6181),
    [anon_sym_DOLLAR] = ACTIONS(6183),
    [anon_sym_DASH] = ACTIONS(6183),
    [anon_sym_0] = ACTIONS(6185),
    [anon_sym_POUND] = ACTIONS(6179),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6185),
    [anon_sym__] = ACTIONS(6185),
    [sym_comment] = ACTIONS(3),
  },
  [2559] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2097),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2560] = {
    [sym_subscript] = STATE(2102),
    [anon_sym_STAR] = ACTIONS(6187),
    [anon_sym_QMARK] = ACTIONS(6187),
    [anon_sym_AT] = ACTIONS(6187),
    [sym_variable_name] = ACTIONS(6189),
    [anon_sym_DOLLAR] = ACTIONS(6191),
    [anon_sym_DASH] = ACTIONS(6191),
    [anon_sym_0] = ACTIONS(6193),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6193),
    [anon_sym__] = ACTIONS(6193),
  },
  [2561] = {
    [anon_sym_EQ] = ACTIONS(6195),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2562] = {
    [anon_sym_EQ] = ACTIONS(6197),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2563] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2131),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2564] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2132),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2133),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2565] = {
    [sym_subscript] = STATE(2134),
    [anon_sym_STAR] = ACTIONS(6199),
    [anon_sym_QMARK] = ACTIONS(6199),
    [anon_sym_BANG] = ACTIONS(6201),
    [anon_sym_AT] = ACTIONS(6199),
    [sym_variable_name] = ACTIONS(6203),
    [anon_sym_DOLLAR] = ACTIONS(6205),
    [anon_sym_DASH] = ACTIONS(6205),
    [anon_sym_0] = ACTIONS(6207),
    [anon_sym_POUND] = ACTIONS(6201),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6207),
    [anon_sym__] = ACTIONS(6207),
    [sym_comment] = ACTIONS(3),
  },
  [2566] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2137),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2567] = {
    [sym_subscript] = STATE(2142),
    [anon_sym_STAR] = ACTIONS(6209),
    [anon_sym_QMARK] = ACTIONS(6209),
    [anon_sym_AT] = ACTIONS(6209),
    [sym_variable_name] = ACTIONS(6211),
    [anon_sym_DOLLAR] = ACTIONS(6213),
    [anon_sym_DASH] = ACTIONS(6213),
    [anon_sym_0] = ACTIONS(6215),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6215),
    [anon_sym__] = ACTIONS(6215),
  },
  [2568] = {
    [anon_sym_EQ] = ACTIONS(6217),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2569] = {
    [anon_sym_EQ] = ACTIONS(6219),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2570] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2171),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2571] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2172),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2173),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2572] = {
    [sym_subscript] = STATE(2174),
    [anon_sym_STAR] = ACTIONS(6221),
    [anon_sym_QMARK] = ACTIONS(6221),
    [anon_sym_BANG] = ACTIONS(6223),
    [anon_sym_AT] = ACTIONS(6221),
    [sym_variable_name] = ACTIONS(6225),
    [anon_sym_DOLLAR] = ACTIONS(6227),
    [anon_sym_DASH] = ACTIONS(6227),
    [anon_sym_0] = ACTIONS(6229),
    [anon_sym_POUND] = ACTIONS(6223),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6229),
    [anon_sym__] = ACTIONS(6229),
    [sym_comment] = ACTIONS(3),
  },
  [2573] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2177),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2574] = {
    [sym_subscript] = STATE(2182),
    [anon_sym_STAR] = ACTIONS(6231),
    [anon_sym_QMARK] = ACTIONS(6231),
    [anon_sym_AT] = ACTIONS(6231),
    [sym_variable_name] = ACTIONS(6233),
    [anon_sym_DOLLAR] = ACTIONS(6235),
    [anon_sym_DASH] = ACTIONS(6235),
    [anon_sym_0] = ACTIONS(6237),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6237),
    [anon_sym__] = ACTIONS(6237),
  },
  [2575] = {
    [anon_sym_EQ] = ACTIONS(6239),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2576] = {
    [anon_sym_EQ] = ACTIONS(6241),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2577] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2211),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2578] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2212),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2213),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2579] = {
    [sym_subscript] = STATE(2214),
    [anon_sym_STAR] = ACTIONS(6243),
    [anon_sym_QMARK] = ACTIONS(6243),
    [anon_sym_BANG] = ACTIONS(6245),
    [anon_sym_AT] = ACTIONS(6243),
    [sym_variable_name] = ACTIONS(6247),
    [anon_sym_DOLLAR] = ACTIONS(6249),
    [anon_sym_DASH] = ACTIONS(6249),
    [anon_sym_0] = ACTIONS(6251),
    [anon_sym_POUND] = ACTIONS(6245),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6251),
    [anon_sym__] = ACTIONS(6251),
    [sym_comment] = ACTIONS(3),
  },
  [2580] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2217),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2581] = {
    [sym_subscript] = STATE(2222),
    [anon_sym_STAR] = ACTIONS(6253),
    [anon_sym_QMARK] = ACTIONS(6253),
    [anon_sym_AT] = ACTIONS(6253),
    [sym_variable_name] = ACTIONS(6255),
    [anon_sym_DOLLAR] = ACTIONS(6257),
    [anon_sym_DASH] = ACTIONS(6257),
    [anon_sym_0] = ACTIONS(6259),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6259),
    [anon_sym__] = ACTIONS(6259),
  },
  [2582] = {
    [anon_sym_EQ] = ACTIONS(6261),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2583] = {
    [anon_sym_EQ] = ACTIONS(6263),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2584] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2251),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2585] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2252),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2253),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2586] = {
    [sym_subscript] = STATE(2254),
    [anon_sym_STAR] = ACTIONS(6265),
    [anon_sym_QMARK] = ACTIONS(6265),
    [anon_sym_BANG] = ACTIONS(6267),
    [anon_sym_AT] = ACTIONS(6265),
    [sym_variable_name] = ACTIONS(6269),
    [anon_sym_DOLLAR] = ACTIONS(6271),
    [anon_sym_DASH] = ACTIONS(6271),
    [anon_sym_0] = ACTIONS(6273),
    [anon_sym_POUND] = ACTIONS(6267),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6273),
    [anon_sym__] = ACTIONS(6273),
    [sym_comment] = ACTIONS(3),
  },
  [2587] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2257),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2588] = {
    [sym_subscript] = STATE(2262),
    [anon_sym_STAR] = ACTIONS(6275),
    [anon_sym_QMARK] = ACTIONS(6275),
    [anon_sym_AT] = ACTIONS(6275),
    [sym_variable_name] = ACTIONS(6277),
    [anon_sym_DOLLAR] = ACTIONS(6279),
    [anon_sym_DASH] = ACTIONS(6279),
    [anon_sym_0] = ACTIONS(6281),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6281),
    [anon_sym__] = ACTIONS(6281),
  },
  [2589] = {
    [anon_sym_EQ] = ACTIONS(6283),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2590] = {
    [anon_sym_EQ] = ACTIONS(6285),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2591] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2291),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2592] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2292),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2293),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2593] = {
    [sym_subscript] = STATE(2294),
    [anon_sym_STAR] = ACTIONS(6287),
    [anon_sym_QMARK] = ACTIONS(6287),
    [anon_sym_BANG] = ACTIONS(6289),
    [anon_sym_AT] = ACTIONS(6287),
    [sym_variable_name] = ACTIONS(6291),
    [anon_sym_DOLLAR] = ACTIONS(6293),
    [anon_sym_DASH] = ACTIONS(6293),
    [anon_sym_0] = ACTIONS(6295),
    [anon_sym_POUND] = ACTIONS(6289),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6295),
    [anon_sym__] = ACTIONS(6295),
    [sym_comment] = ACTIONS(3),
  },
  [2594] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2297),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2595] = {
    [sym_subscript] = STATE(2302),
    [anon_sym_STAR] = ACTIONS(6297),
    [anon_sym_QMARK] = ACTIONS(6297),
    [anon_sym_AT] = ACTIONS(6297),
    [sym_variable_name] = ACTIONS(6299),
    [anon_sym_DOLLAR] = ACTIONS(6301),
    [anon_sym_DASH] = ACTIONS(6301),
    [anon_sym_0] = ACTIONS(6303),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6303),
    [anon_sym__] = ACTIONS(6303),
  },
  [2596] = {
    [anon_sym_EQ] = ACTIONS(6305),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2597] = {
    [anon_sym_EQ] = ACTIONS(6307),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2598] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2329),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2330),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2599] = {
    [sym_subscript] = STATE(2331),
    [anon_sym_STAR] = ACTIONS(6309),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_BANG] = ACTIONS(6311),
    [anon_sym_AT] = ACTIONS(6309),
    [sym_variable_name] = ACTIONS(6313),
    [anon_sym_DOLLAR] = ACTIONS(6315),
    [anon_sym_DASH] = ACTIONS(6315),
    [anon_sym_0] = ACTIONS(6317),
    [anon_sym_POUND] = ACTIONS(6311),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6317),
    [anon_sym__] = ACTIONS(6317),
    [sym_comment] = ACTIONS(3),
  },
  [2600] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2333),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2601] = {
    [sym_subscript] = STATE(2336),
    [anon_sym_STAR] = ACTIONS(6319),
    [anon_sym_QMARK] = ACTIONS(6319),
    [anon_sym_AT] = ACTIONS(6319),
    [sym_variable_name] = ACTIONS(6321),
    [anon_sym_DOLLAR] = ACTIONS(6323),
    [anon_sym_DASH] = ACTIONS(6323),
    [anon_sym_0] = ACTIONS(6325),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6325),
    [anon_sym__] = ACTIONS(6325),
  },
  [2602] = {
    [anon_sym_EQ] = ACTIONS(6327),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2603] = {
    [anon_sym_EQ] = ACTIONS(6329),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2604] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_negated_command] = STATE(387),
    [sym_test_command] = STATE(387),
    [sym_variable_assignment] = STATE(388),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(390),
    [sym_redirected_statement] = STATE(387),
    [sym_for_statement] = STATE(387),
    [sym_compound_statement] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_declaration_command] = STATE(387),
    [sym_unset_command] = STATE(387),
    [sym_file_redirect] = STATE(2362),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym__statements] = STATE(2363),
    [sym_c_style_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(93),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2605] = {
    [sym_subscript] = STATE(2364),
    [anon_sym_STAR] = ACTIONS(6331),
    [anon_sym_QMARK] = ACTIONS(6331),
    [anon_sym_BANG] = ACTIONS(6333),
    [anon_sym_AT] = ACTIONS(6331),
    [sym_variable_name] = ACTIONS(6335),
    [anon_sym_DOLLAR] = ACTIONS(6337),
    [anon_sym_DASH] = ACTIONS(6337),
    [anon_sym_0] = ACTIONS(6339),
    [anon_sym_POUND] = ACTIONS(6333),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6339),
    [anon_sym__] = ACTIONS(6339),
    [sym_comment] = ACTIONS(3),
  },
  [2606] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym_if_statement] = STATE(1461),
    [sym_function_definition] = STATE(1461),
    [sym_negated_command] = STATE(1461),
    [sym_test_command] = STATE(1461),
    [sym_variable_assignment] = STATE(540),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [aux_sym__statements_repeat1] = STATE(542),
    [sym_redirected_statement] = STATE(1461),
    [sym_for_statement] = STATE(1461),
    [sym_compound_statement] = STATE(1461),
    [sym_subshell] = STATE(1461),
    [sym_declaration_command] = STATE(1461),
    [sym_unset_command] = STATE(1461),
    [sym_file_redirect] = STATE(1463),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(1463),
    [sym__statements] = STATE(2366),
    [sym_c_style_for_statement] = STATE(1461),
    [sym_while_statement] = STATE(1461),
    [sym_case_statement] = STATE(1461),
    [sym_pipeline] = STATE(1461),
    [sym_list] = STATE(1461),
    [sym_command] = STATE(1461),
    [sym_command_name] = STATE(544),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_local] = ACTIONS(243),
    [anon_sym_typeset] = ACTIONS(243),
    [anon_sym_unsetenv] = ACTIONS(245),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [sym_word] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(243),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_BANG] = ACTIONS(247),
    [anon_sym_declare] = ACTIONS(243),
    [sym_variable_name] = ACTIONS(95),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_readonly] = ACTIONS(243),
    [anon_sym_unset] = ACTIONS(245),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2607] = {
    [sym_subscript] = STATE(2369),
    [anon_sym_STAR] = ACTIONS(6341),
    [anon_sym_QMARK] = ACTIONS(6341),
    [anon_sym_AT] = ACTIONS(6341),
    [sym_variable_name] = ACTIONS(6343),
    [anon_sym_DOLLAR] = ACTIONS(6345),
    [anon_sym_DASH] = ACTIONS(6345),
    [anon_sym_0] = ACTIONS(6347),
    [sym_comment] = ACTIONS(51),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6347),
    [anon_sym__] = ACTIONS(6347),
  },
  [2608] = {
    [anon_sym_EQ] = ACTIONS(6349),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2609] = {
    [anon_sym_EQ] = ACTIONS(6351),
    [sym_comment] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(453),
  },
  [2610] = {
    [aux_sym__literal_repeat1] = STATE(386),
    [sym__terminated_statement] = STATE(2411),
    [sym_if_statement] = STATE(66),
    [sym_function_definition] = STATE(66),
    [sym_negated_command] = STATE(66),
    [sym_test_command] = STATE(66),
    [sym_variable_assignment] = STATE(67),
    [sym_subscript] = STATE(2407),
    [sym_concatenation] = STATE(389),
    [sym_expansion] = STATE(384),
    [sym_command_substitution] = STATE(384),
    [sym_redirected_statement] = STATE(66),
    [sym_for_statement] = STATE(66),
    [sym_compound_statement] = STATE(66),
    [sym_subshell] = STATE(66),
    [sym_declaration_command] = STATE(66),
    [sym_unset_command] = STATE(66),
    [sym_file_redirect] = STATE(391),
    [sym_string] = STATE(384),
    [sym_process_substitution] = STATE(384),
    [aux_sym_command_repeat1] = STATE(391),
    [sym_c_style_for_statement] = STATE(66),
    [sym_while_statement] = STATE(66),
    [sym_case_statement] = STATE(66),
    [sym_pipeline] = STATE(66),
    [sym_list] = STATE(66),
    [sym_command] = STATE(66),
    [sym_command_name] = STATE(392),
    [sym_simple_expansion] = STATE(384),
    [sym_string_expansion] = STATE(384),
    [anon_sym_AMP_GT_GT] = ACTIONS(7),
    [anon_sym_typeset] = ACTIONS(63),
    [anon_sym_DOLLAR] = ACTIONS(67),
    [anon_sym_GT_LPAREN] = ACTIONS(69),
    [sym_word] = ACTIONS(77),
    [anon_sym_LT_AMP] = ACTIONS(7),
    [anon_sym_export] = ACTIONS(63),
    [sym__special_character] = ACTIONS(81),
    [anon_sym_if] = ACTIONS(83),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(87),
    [sym_raw_string] = ACTIONS(89),
    [anon_sym_declare] = ACTIONS(63),
    [sym_variable_name] = ACTIONS(95),
    [anon_sym_readonly] = ACTIONS(63),
    [anon_sym_unset] = ACTIONS(65),
    [anon_sym_DQUOTE] = ACTIONS(97),
    [anon_sym_GT_AMP] = ACTIONS(7),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(61),
    [anon_sym_local] = ACTIONS(63),
    [anon_sym_unsetenv] = ACTIONS(65),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(71),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(73),
    [anon_sym_function] = ACTIONS(75),
    [anon_sym_LBRACE] = ACTIONS(79),
    [anon_sym_LT] = ACTIONS(27),
    [anon_sym_GT_GT] = ACTIONS(7),
    [anon_sym_BQUOTE] = ACTIONS(91),
    [anon_sym_case] = ACTIONS(85),
    [anon_sym_BANG] = ACTIONS(93),
    [sym_file_descriptor] = ACTIONS(45),
    [anon_sym_GT] = ACTIONS(27),
    [anon_sym_AMP_GT] = ACTIONS(27),
    [anon_sym_LT_LPAREN] = ACTIONS(69),
    [sym_comment] = ACTIONS(51),
    [anon_sym_for] = ACTIONS(99),
    [anon_sym_LBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_LBRACK] = ACTIONS(105),
  },
  [2611] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_LPAREN_LPAREN] = ACTIONS(6353),
    [aux_sym__simple_variable_name_token1] = ACTIONS(6355),
  },
  [2612] = {
    [aux_sym_concatenation_repeat1] = STATE(736),
    [sym__concat] = ACTIONS(505),
    [anon_sym_LF] = ACTIONS(6357),
    [anon_sym_AMP] = ACTIONS(6359),
    [anon_sym_SEMI] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(6359),
    [anon_sym_in] = ACTIONS(6361),
  },
  [2613] = {
    [aux_sym__literal_repeat1] = STATE(739),
    [anon_sym_LF] = ACTIONS(6363),
    [anon_sym_SEMI] = ACTIONS(6365),
    [anon_sym_AMP] = ACTIONS(6365),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(517),
    [anon_sym_in] = ACTIONS(6367),
    [anon_sym_SEMI_SEMI] = ACTIONS(6365),
  },
  [2614] = {
    [anon_sym_LF] = ACTIONS(6357),
    [anon_sym_AMP] = ACTIONS(6359),
    [anon_sym_SEMI] = ACTIONS(6359),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(6359),
    [anon_sym_in] = ACTIONS(6361),
  },
  [2615] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(6369),
  },
  [2616] = {
    [sym_comment] = ACTIONS(51),
    [anon_sym_in] = ACTIONS(6371),
  },
  [2617] = {
    [sym_command_substitution] = STATE(481),
    [aux_sym__literal_repeat1] = STATE(483),
    [sym_string] = STATE(481),
    [sym_process_substitution] = STATE(481),
    [aux_sym_for_statement_repeat1] = STATE(2421),
    [sym_simple_expansion] = STATE(481),
    [sym_string_expansion] = STATE(481),
    [sym_concatenation] = STATE(2421),
    [sym_expansion] = STATE(481),
    [anon_sym_BQUOTE] = ACTIONS(1069),
    [sym_raw_string] = ACTIONS(1073),
    [anon_sym_DOLLAR] = ACTIONS(1077),
    [anon_sym_GT_LPAREN] = ACTIONS(1075),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1079),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1083),
    [anon_sym_DQUOTE] = ACTIONS(1071),
    [sym_word] = ACTIONS(1073),
    [anon_sym_LT_LPAREN] = ACTIONS(1075),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(1081),
  },
  [2618] = {
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_unary_expression] = STATE(2619),
    [sym_postfix_expression] = STATE(2619),
    [sym_string] = STATE(558),
    [sym_process_substitution] = STATE(558),
    [sym__expression] = STATE(2619),
    [sym_binary_expression] = STATE(2619),
    [sym_concatenation] = STATE(2619),
    [sym_expansion] = STATE(558),
    [sym_command_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(2619),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(6373),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(6373),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(6373),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(6373),
  },
  [2619] = {
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(6375),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(6375),
    [anon_sym_SEMI] = ACTIONS(6375),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(6375),
  },
  [2620] = {
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_unary_expression] = STATE(2621),
    [sym_postfix_expression] = STATE(2621),
    [sym_string] = STATE(558),
    [sym_process_substitution] = STATE(558),
    [sym__expression] = STATE(2621),
    [sym_binary_expression] = STATE(2621),
    [sym_concatenation] = STATE(2621),
    [sym_expansion] = STATE(558),
    [sym_command_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(2621),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(6375),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(6375),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(6375),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(6375),
  },
  [2621] = {
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(6377),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(6377),
    [anon_sym_SEMI] = ACTIONS(6377),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(6377),
  },
  [2622] = {
    [sym_heredoc_redirect] = STATE(2625),
    [aux_sym_redirected_statement_repeat1] = STATE(2625),
    [sym_herestring_redirect] = STATE(2625),
    [sym_file_redirect] = STATE(2625),
    [anon_sym_LT_LT_DASH] = ACTIONS(489),
    [anon_sym_AMP_GT_GT] = ACTIONS(2214),
    [anon_sym_LF] = ACTIONS(670),
    [anon_sym_SEMI] = ACTIONS(672),
    [anon_sym_LT_LT] = ACTIONS(489),
    [sym_file_descriptor] = ACTIONS(2220),
    [anon_sym_GT] = ACTIONS(2214),
    [anon_sym_AMP_GT] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(672),
    [anon_sym_LT_LT_LT] = ACTIONS(2224),
    [anon_sym_PIPE] = ACTIONS(672),
    [anon_sym_GT_AMP] = ACTIONS(2214),
    [anon_sym_LT] = ACTIONS(2214),
    [anon_sym_esac] = ACTIONS(672),
    [anon_sym_GT_GT] = ACTIONS(2214),
    [anon_sym_LT_AMP] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(672),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(672),
    [anon_sym_SEMI_SEMI] = ACTIONS(672),
    [anon_sym_PIPE_AMP] = ACTIONS(672),
  },
  [2623] = {
    [sym_heredoc_redirect] = STATE(2622),
    [aux_sym_redirected_statement_repeat1] = STATE(2622),
    [sym_herestring_redirect] = STATE(2622),
    [sym_file_redirect] = STATE(2622),
    [anon_sym_LT_LT_DASH] = ACTIONS(1103),
    [anon_sym_AMP_GT_GT] = ACTIONS(1103),
    [anon_sym_LF] = ACTIONS(1105),
    [anon_sym_SEMI] = ACTIONS(1103),
    [anon_sym_LT_LT] = ACTIONS(1103),
    [sym_file_descriptor] = ACTIONS(1105),
    [anon_sym_GT] = ACTIONS(1103),
    [anon_sym_AMP_GT] = ACTIONS(1103),
    [anon_sym_PIPE_PIPE] = ACTIONS(1103),
    [anon_sym_LT_LT_LT] = ACTIONS(1103),
    [anon_sym_PIPE] = ACTIONS(1103),
    [anon_sym_GT_AMP] = ACTIONS(1103),
    [anon_sym_LT] = ACTIONS(1103),
    [anon_sym_esac] = ACTIONS(1103),
    [anon_sym_GT_GT] = ACTIONS(1103),
    [anon_sym_LT_AMP] = ACTIONS(1103),
    [anon_sym_AMP] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1103),
    [anon_sym_SEMI_SEMI] = ACTIONS(1103),
    [anon_sym_PIPE_AMP] = ACTIONS(1103),
  },
  [2624] = {
    [aux_sym_concatenation_repeat1] = STATE(2433),
    [anon_sym_LT_LT_DASH] = ACTIONS(1137),
    [anon_sym_AMP_GT_GT] = ACTIONS(1137),
    [anon_sym_LF] = ACTIONS(1139),
    [anon_sym_SEMI] = ACTIONS(1137),
    [anon_sym_LT_LT] = ACTIONS(1137),
    [sym_file_descriptor] = ACTIONS(1139),
    [anon_sym_GT] = ACTIONS(1137),
    [anon_sym_AMP_GT] = ACTIONS(1137),
    [anon_sym_PIPE_PIPE] = ACTIONS(1137),
    [anon_sym_LT_LT_LT] = ACTIONS(1137),
    [anon_sym_PIPE] = ACTIONS(1137),
    [anon_sym_GT_AMP] = ACTIONS(1137),
    [anon_sym_LT] = ACTIONS(1137),
    [anon_sym_esac] = ACTIONS(1137),
    [anon_sym_GT_GT] = ACTIONS(1137),
    [anon_sym_LT_AMP] = ACTIONS(1137),
    [anon_sym_AMP] = ACTIONS(1137),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1137),
    [anon_sym_PIPE_AMP] = ACTIONS(1137),
  },
  [2625] = {
    [sym_heredoc_redirect] = STATE(2625),
    [aux_sym_redirected_statement_repeat1] = STATE(2625),
    [sym_herestring_redirect] = STATE(2625),
    [sym_file_redirect] = STATE(2625),
    [anon_sym_LT_LT_DASH] = ACTIONS(2108),
    [anon_sym_AMP_GT_GT] = ACTIONS(6379),
    [anon_sym_LF] = ACTIONS(1155),
    [anon_sym_SEMI] = ACTIONS(1157),
    [anon_sym_LT_LT] = ACTIONS(2108),
    [sym_file_descriptor] = ACTIONS(6382),
    [anon_sym_GT] = ACTIONS(6379),
    [anon_sym_AMP_GT] = ACTIONS(6379),
    [anon_sym_PIPE_PIPE] = ACTIONS(1157),
    [anon_sym_LT_LT_LT] = ACTIONS(6385),
    [anon_sym_PIPE] = ACTIONS(1157),
    [anon_sym_GT_AMP] = ACTIONS(6379),
    [anon_sym_LT] = ACTIONS(6379),
    [anon_sym_esac] = ACTIONS(1157),
    [anon_sym_GT_GT] = ACTIONS(6379),
    [anon_sym_LT_AMP] = ACTIONS(6379),
    [anon_sym_AMP] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1157),
    [anon_sym_SEMI_SEMI] = ACTIONS(1157),
    [anon_sym_PIPE_AMP] = ACTIONS(1157),
  },
  [2626] = {
    [aux_sym_concatenation_repeat1] = STATE(2433),
    [anon_sym_LT_LT_DASH] = ACTIONS(355),
    [anon_sym_AMP_GT_GT] = ACTIONS(355),
    [anon_sym_LF] = ACTIONS(353),
    [anon_sym_SEMI] = ACTIONS(355),
    [anon_sym_LT_LT] = ACTIONS(355),
    [sym_file_descriptor] = ACTIONS(353),
    [anon_sym_GT] = ACTIONS(355),
    [anon_sym_AMP_GT] = ACTIONS(355),
    [anon_sym_PIPE_PIPE] = ACTIONS(355),
    [anon_sym_LT_LT_LT] = ACTIONS(355),
    [anon_sym_PIPE] = ACTIONS(355),
    [anon_sym_GT_AMP] = ACTIONS(355),
    [anon_sym_LT] = ACTIONS(355),
    [anon_sym_esac] = ACTIONS(355),
    [anon_sym_GT_GT] = ACTIONS(355),
    [anon_sym_LT_AMP] = ACTIONS(355),
    [anon_sym_AMP] = ACTIONS(355),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(355),
    [anon_sym_PIPE_AMP] = ACTIONS(355),
  },
  [2627] = {
    [aux_sym_concatenation_repeat1] = STATE(2433),
    [anon_sym_LT_LT_DASH] = ACTIONS(1036),
    [anon_sym_AMP_GT_GT] = ACTIONS(1036),
    [anon_sym_LF] = ACTIONS(1034),
    [anon_sym_SEMI] = ACTIONS(1036),
    [anon_sym_LT_LT] = ACTIONS(1036),
    [sym_file_descriptor] = ACTIONS(1034),
    [anon_sym_GT] = ACTIONS(1036),
    [anon_sym_AMP_GT] = ACTIONS(1036),
    [anon_sym_PIPE_PIPE] = ACTIONS(1036),
    [anon_sym_LT_LT_LT] = ACTIONS(1036),
    [anon_sym_PIPE] = ACTIONS(1036),
    [anon_sym_GT_AMP] = ACTIONS(1036),
    [anon_sym_LT] = ACTIONS(1036),
    [anon_sym_esac] = ACTIONS(1036),
    [anon_sym_GT_GT] = ACTIONS(1036),
    [anon_sym_LT_AMP] = ACTIONS(1036),
    [anon_sym_AMP] = ACTIONS(1036),
    [sym__concat] = ACTIONS(2101),
    [anon_sym_AMP_AMP] = ACTIONS(1036),
    [sym_comment] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(1036),
    [anon_sym_PIPE_AMP] = ACTIONS(1036),
  },
  [2628] = {
    [sym_command_substitution] = STATE(2612),
    [aux_sym__literal_repeat1] = STATE(2613),
    [sym_string] = STATE(2612),
    [sym_process_substitution] = STATE(2612),
    [sym_simple_expansion] = STATE(2612),
    [sym_string_expansion] = STATE(2612),
    [sym_concatenation] = STATE(2614),
    [sym_expansion] = STATE(2612),
    [anon_sym_BQUOTE] = ACTIONS(203),
    [sym_raw_string] = ACTIONS(6388),
    [anon_sym_DOLLAR] = ACTIONS(211),
    [anon_sym_GT_LPAREN] = ACTIONS(209),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(213),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(217),
    [anon_sym_DQUOTE] = ACTIONS(205),
    [sym_word] = ACTIONS(6388),
    [anon_sym_LT_LPAREN] = ACTIONS(209),
    [sym_comment] = ACTIONS(51),
    [sym__special_character] = ACTIONS(215),
  },
  [2629] = {
    [aux_sym__literal_repeat1] = STATE(559),
    [sym_unary_expression] = STATE(2630),
    [sym_postfix_expression] = STATE(2630),
    [sym_string] = STATE(558),
    [sym_process_substitution] = STATE(558),
    [sym__expression] = STATE(2630),
    [sym_binary_expression] = STATE(2630),
    [sym_concatenation] = STATE(2630),
    [sym_expansion] = STATE(558),
    [sym_command_substitution] = STATE(558),
    [sym_parenthesized_expression] = STATE(2630),
    [sym_simple_expansion] = STATE(558),
    [sym_string_expansion] = STATE(558),
    [sym_test_operator] = ACTIONS(601),
    [anon_sym_LPAREN] = ACTIONS(603),
    [anon_sym_BQUOTE] = ACTIONS(605),
    [sym_raw_string] = ACTIONS(607),
    [anon_sym_LF] = ACTIONS(6390),
    [anon_sym_BANG] = ACTIONS(611),
    [anon_sym_SEMI] = ACTIONS(6390),
    [anon_sym_DOLLAR] = ACTIONS(613),
    [anon_sym_GT_LPAREN] = ACTIONS(615),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(617),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(619),
    [anon_sym_DQUOTE] = ACTIONS(621),
    [sym_word] = ACTIONS(607),
    [anon_sym_AMP] = ACTIONS(6390),
    [anon_sym_LT_LPAREN] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__special_character] = ACTIONS(623),
    [anon_sym_SEMI_SEMI] = ACTIONS(6390),
  },
  [2630] = {
    [sym_test_operator] = ACTIONS(1089),
    [anon_sym_PLUS_EQ] = ACTIONS(1087),
    [anon_sym_PLUS_PLUS] = ACTIONS(1093),
    [anon_sym_DASH] = ACTIONS(1087),
    [anon_sym_PIPE_PIPE] = ACTIONS(1087),
    [anon_sym_AMP] = ACTIONS(6392),
    [anon_sym_LT] = ACTIONS(1087),
    [anon_sym_EQ_TILDE] = ACTIONS(1095),
    [anon_sym_DASH_DASH] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1087),
    [anon_sym_DASH_EQ] = ACTIONS(1087),
    [anon_sym_BANG_EQ] = ACTIONS(1087),
    [anon_sym_LF] = ACTIONS(6392),
    [anon_sym_SEMI] = ACTIONS(6392),
    [anon_sym_GT] = ACTIONS(1087),
    [anon_sym_EQ] = ACTIONS(1087),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1087),
    [anon_sym_PLUS] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(1087),
    [anon_sym_SEMI_SEMI] = ACTIONS(6392),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [5] = {.count = 1, .reusable = false}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = false}, SHIFT(4),
  [11] = {.count = 1, .reusable = false}, SHIFT(5),
  [13] = {.count = 1, .reusable = false}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(9),
  [21] = {.count = 1, .reusable = false}, SHIFT(10),
  [23] = {.count = 1, .reusable = false}, SHIFT(11),
  [25] = {.count = 1, .reusable = true}, SHIFT(12),
  [27] = {.count = 1, .reusable = false}, SHIFT(3),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = true}, SHIFT(16),
  [37] = {.count = 1, .reusable = true}, SHIFT(17),
  [39] = {.count = 1, .reusable = true}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = true}, SHIFT(20),
  [45] = {.count = 1, .reusable = true}, SHIFT(21),
  [47] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [49] = {.count = 1, .reusable = true}, SHIFT(22),
  [51] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [53] = {.count = 1, .reusable = false}, SHIFT(23),
  [55] = {.count = 1, .reusable = false}, SHIFT(24),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = true}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(2395),
  [63] = {.count = 1, .reusable = false}, SHIFT(380),
  [65] = {.count = 1, .reusable = false}, SHIFT(381),
  [67] = {.count = 1, .reusable = false}, SHIFT(1362),
  [69] = {.count = 1, .reusable = true}, SHIFT(2396),
  [71] = {.count = 1, .reusable = true}, SHIFT(2397),
  [73] = {.count = 1, .reusable = true}, SHIFT(2398),
  [75] = {.count = 1, .reusable = false}, SHIFT(2399),
  [77] = {.count = 1, .reusable = false}, SHIFT(382),
  [79] = {.count = 1, .reusable = true}, SHIFT(1363),
  [81] = {.count = 1, .reusable = false}, SHIFT(383),
  [83] = {.count = 1, .reusable = false}, SHIFT(2610),
  [85] = {.count = 1, .reusable = false}, SHIFT(2628),
  [87] = {.count = 1, .reusable = true}, SHIFT(2400),
  [89] = {.count = 1, .reusable = true}, SHIFT(384),
  [91] = {.count = 1, .reusable = true}, SHIFT(2401),
  [93] = {.count = 1, .reusable = false}, SHIFT(385),
  [95] = {.count = 1, .reusable = true}, SHIFT(2402),
  [97] = {.count = 1, .reusable = true}, SHIFT(1364),
  [99] = {.count = 1, .reusable = false}, SHIFT(2611),
  [101] = {.count = 1, .reusable = false}, SHIFT(2404),
  [103] = {.count = 1, .reusable = false}, SHIFT(2405),
  [105] = {.count = 1, .reusable = true}, SHIFT(2406),
  [107] = {.count = 1, .reusable = true}, SHIFT(2441),
  [109] = {.count = 1, .reusable = true}, SHIFT(38),
  [111] = {.count = 1, .reusable = false}, SHIFT(1471),
  [113] = {.count = 1, .reusable = true}, SHIFT(2438),
  [115] = {.count = 1, .reusable = true}, SHIFT(2439),
  [117] = {.count = 1, .reusable = true}, SHIFT(2440),
  [119] = {.count = 1, .reusable = true}, SHIFT(1472),
  [121] = {.count = 1, .reusable = true}, SHIFT(535),
  [123] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 1),
  [125] = {.count = 1, .reusable = false}, SHIFT(1517),
  [127] = {.count = 1, .reusable = false}, SHIFT(2449),
  [129] = {.count = 1, .reusable = false}, SHIFT(2450),
  [131] = {.count = 1, .reusable = false}, SHIFT(43),
  [133] = {.count = 1, .reusable = false}, SHIFT(2451),
  [135] = {.count = 1, .reusable = false}, SHIFT(41),
  [137] = {.count = 1, .reusable = false}, SHIFT(631),
  [139] = {.count = 1, .reusable = false}, SHIFT(2452),
  [141] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 1),
  [143] = {.count = 1, .reusable = true}, SHIFT(2442),
  [145] = {.count = 1, .reusable = false}, SHIFT(1518),
  [147] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 1),
  [149] = {.count = 1, .reusable = false}, SHIFT(1560),
  [151] = {.count = 1, .reusable = false}, SHIFT(2459),
  [153] = {.count = 1, .reusable = false}, SHIFT(2460),
  [155] = {.count = 1, .reusable = false}, SHIFT(46),
  [157] = {.count = 1, .reusable = false}, SHIFT(2461),
  [159] = {.count = 1, .reusable = false}, SHIFT(44),
  [161] = {.count = 1, .reusable = false}, SHIFT(692),
  [163] = {.count = 1, .reusable = false}, SHIFT(2462),
  [165] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 1),
  [167] = {.count = 1, .reusable = false}, SHIFT(1561),
  [169] = {.count = 1, .reusable = true}, SHIFT(47),
  [171] = {.count = 1, .reusable = true}, SHIFT(48),
  [173] = {.count = 1, .reusable = true}, SHIFT(49),
  [175] = {.count = 1, .reusable = false}, SHIFT(47),
  [177] = {.count = 1, .reusable = true}, SHIFT(53),
  [179] = {.count = 1, .reusable = true}, SHIFT(54),
  [181] = {.count = 1, .reusable = true}, SHIFT(55),
  [183] = {.count = 1, .reusable = true}, SHIFT(56),
  [185] = {.count = 1, .reusable = false}, SHIFT(53),
  [187] = {.count = 1, .reusable = true}, SHIFT(57),
  [189] = {.count = 1, .reusable = false}, SHIFT(58),
  [191] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1),
  [193] = {.count = 1, .reusable = true}, SHIFT(59),
  [195] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1),
  [197] = {.count = 1, .reusable = true}, SHIFT(61),
  [199] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 1),
  [201] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 1),
  [203] = {.count = 1, .reusable = true}, SHIFT(2471),
  [205] = {.count = 1, .reusable = true}, SHIFT(1604),
  [207] = {.count = 1, .reusable = true}, SHIFT(68),
  [209] = {.count = 1, .reusable = true}, SHIFT(2468),
  [211] = {.count = 1, .reusable = false}, SHIFT(1603),
  [213] = {.count = 1, .reusable = true}, SHIFT(2469),
  [215] = {.count = 1, .reusable = true}, SHIFT(732),
  [217] = {.count = 1, .reusable = true}, SHIFT(2470),
  [219] = {.count = 1, .reusable = true}, SHIFT(71),
  [221] = {.count = 1, .reusable = true}, SHIFT(72),
  [223] = {.count = 1, .reusable = true}, SHIFT(1647),
  [225] = {.count = 1, .reusable = false}, SHIFT(73),
  [227] = {.count = 1, .reusable = true}, SHIFT(73),
  [229] = {.count = 1, .reusable = true}, SHIFT(2480),
  [231] = {.count = 1, .reusable = false}, SHIFT(71),
  [233] = {.count = 1, .reusable = true}, SHIFT(2477),
  [235] = {.count = 1, .reusable = false}, SHIFT(1646),
  [237] = {.count = 1, .reusable = true}, SHIFT(2478),
  [239] = {.count = 1, .reusable = true}, SHIFT(769),
  [241] = {.count = 1, .reusable = true}, SHIFT(2479),
  [243] = {.count = 1, .reusable = false}, SHIFT(532),
  [245] = {.count = 1, .reusable = false}, SHIFT(533),
  [247] = {.count = 1, .reusable = false}, SHIFT(1460),
  [249] = {.count = 1, .reusable = true}, SHIFT(2453),
  [251] = {.count = 1, .reusable = true}, SHIFT(78),
  [253] = {.count = 1, .reusable = true}, SHIFT(79),
  [255] = {.count = 1, .reusable = true}, SHIFT(80),
  [257] = {.count = 1, .reusable = false}, SHIFT(80),
  [259] = {.count = 1, .reusable = false}, SHIFT(81),
  [261] = {.count = 1, .reusable = true}, SHIFT(2489),
  [263] = {.count = 1, .reusable = true}, SHIFT(82),
  [265] = {.count = 1, .reusable = true}, SHIFT(2487),
  [267] = {.count = 1, .reusable = true}, SHIFT(2488),
  [269] = {.count = 1, .reusable = false}, SHIFT(83),
  [271] = {.count = 1, .reusable = true}, SHIFT(85),
  [273] = {.count = 1, .reusable = true}, SHIFT(86),
  [275] = {.count = 1, .reusable = true}, SHIFT(1376),
  [277] = {.count = 1, .reusable = true}, SHIFT(2412),
  [279] = {.count = 1, .reusable = true}, SHIFT(1690),
  [281] = {.count = 1, .reusable = false}, SHIFT(407),
  [283] = {.count = 1, .reusable = true}, SHIFT(407),
  [285] = {.count = 1, .reusable = true}, SHIFT(2496),
  [287] = {.count = 1, .reusable = false}, SHIFT(1376),
  [289] = {.count = 1, .reusable = true}, SHIFT(2486),
  [291] = {.count = 1, .reusable = false}, SHIFT(1689),
  [293] = {.count = 1, .reusable = true}, SHIFT(2494),
  [295] = {.count = 1, .reusable = true}, SHIFT(806),
  [297] = {.count = 1, .reusable = true}, SHIFT(2495),
  [299] = {.count = 1, .reusable = false}, REDUCE(sym_command_name, 1, .production_id = 1),
  [301] = {.count = 1, .reusable = false}, SHIFT(90),
  [303] = {.count = 1, .reusable = true}, REDUCE(sym_command_name, 1, .production_id = 1),
  [305] = {.count = 1, .reusable = false}, SHIFT(94),
  [307] = {.count = 1, .reusable = false}, SHIFT(1361),
  [309] = {.count = 1, .reusable = true}, SHIFT(93),
  [311] = {.count = 1, .reusable = true}, SHIFT(2403),
  [313] = {.count = 1, .reusable = false}, SHIFT(95),
  [315] = {.count = 1, .reusable = false}, SHIFT(96),
  [317] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [319] = {.count = 1, .reusable = false}, SHIFT(97),
  [321] = {.count = 1, .reusable = false}, SHIFT(92),
  [323] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 1),
  [325] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 1),
  [327] = {.count = 1, .reusable = true},  ACCEPT_INPUT(),
  [329] = {.count = 1, .reusable = true}, SHIFT(13),
  [331] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [333] = {.count = 1, .reusable = false}, REDUCE(sym_command, 1),
  [335] = {.count = 1, .reusable = false}, SHIFT(7),
  [337] = {.count = 1, .reusable = false}, SHIFT(8),
  [339] = {.count = 1, .reusable = false}, SHIFT(9),
  [341] = {.count = 1, .reusable = false}, SHIFT(104),
  [343] = {.count = 1, .reusable = false}, SHIFT(105),
  [345] = {.count = 1, .reusable = false}, SHIFT(18),
  [347] = {.count = 1, .reusable = true}, REDUCE(sym_command, 1),
  [349] = {.count = 1, .reusable = false}, SHIFT(22),
  [351] = {.count = 1, .reusable = true}, SHIFT(108),
  [353] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2),
  [355] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2),
  [357] = {.count = 1, .reusable = true}, SHIFT(1478),
  [359] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 2, .production_id = 2),
  [361] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 2, .production_id = 2),
  [363] = {.count = 1, .reusable = true}, SHIFT(561),
  [365] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [367] = {.count = 1, .reusable = true}, SHIFT(1524),
  [369] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [371] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .production_id = 1),
  [373] = {.count = 1, .reusable = false}, SHIFT(643),
  [375] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .production_id = 1),
  [377] = {.count = 1, .reusable = false}, REDUCE(sym_declaration_command, 2),
  [379] = {.count = 1, .reusable = false}, SHIFT(109),
  [381] = {.count = 1, .reusable = true}, REDUCE(sym_declaration_command, 2),
  [383] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [385] = {.count = 1, .reusable = true}, SHIFT(1567),
  [387] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1),
  [389] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 1, .production_id = 1),
  [391] = {.count = 1, .reusable = false}, SHIFT(699),
  [393] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 1, .production_id = 1),
  [395] = {.count = 1, .reusable = false}, REDUCE(sym_unset_command, 2),
  [397] = {.count = 1, .reusable = false}, SHIFT(110),
  [399] = {.count = 1, .reusable = true}, REDUCE(sym_unset_command, 2),
  [401] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2),
  [403] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2),
  [405] = {.count = 1, .reusable = false}, REDUCE(sym_string_expansion, 2),
  [407] = {.count = 1, .reusable = true}, REDUCE(sym_string_expansion, 2),
  [409] = {.count = 1, .reusable = false}, REDUCE(sym_simple_expansion, 2, .production_id = 3),
  [411] = {.count = 1, .reusable = true}, REDUCE(sym_simple_expansion, 2, .production_id = 3),
  [413] = {.count = 1, .reusable = true}, SHIFT(111),
  [415] = {.count = 1, .reusable = true}, SHIFT(112),
  [417] = {.count = 1, .reusable = true}, SHIFT(2517),
  [419] = {.count = 1, .reusable = true}, SHIFT(113),
  [421] = {.count = 1, .reusable = true}, SHIFT(114),
  [423] = {.count = 1, .reusable = false}, SHIFT(117),
  [425] = {.count = 1, .reusable = false}, SHIFT(1809),
  [427] = {.count = 1, .reusable = true}, SHIFT(115),
  [429] = {.count = 1, .reusable = true}, SHIFT(2507),
  [431] = {.count = 1, .reusable = true}, SHIFT(2515),
  [433] = {.count = 1, .reusable = true}, SHIFT(2516),
  [435] = {.count = 1, .reusable = true}, SHIFT(1810),
  [437] = {.count = 1, .reusable = false}, SHIFT(114),
  [439] = {.count = 1, .reusable = true}, SHIFT(117),
  [441] = {.count = 1, .reusable = false}, SHIFT(902),
  [443] = {.count = 1, .reusable = true}, SHIFT(118),
  [445] = {.count = 1, .reusable = true}, SHIFT(119),
  [447] = {.count = 1, .reusable = true}, SHIFT(120),
  [449] = {.count = 1, .reusable = false}, SHIFT(118),
  [451] = {.count = 1, .reusable = true}, SHIFT(121),
  [453] = {.count = 1, .reusable = true}, SHIFT(2413),
  [455] = {.count = 1, .reusable = true}, SHIFT(122),
  [457] = {.count = 1, .reusable = false}, SHIFT(124),
  [459] = {.count = 1, .reusable = true}, SHIFT(123),
  [461] = {.count = 1, .reusable = true}, SHIFT(124),
  [463] = {.count = 1, .reusable = true}, SHIFT(125),
  [465] = {.count = 1, .reusable = true}, SHIFT(127),
  [467] = {.count = 1, .reusable = true}, SHIFT(128),
  [469] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 2),
  [471] = {.count = 1, .reusable = true}, SHIFT(129),
  [473] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 2),
  [475] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 2),
  [477] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 2),
  [479] = {.count = 1, .reusable = false}, SHIFT(413),
  [481] = {.count = 1, .reusable = false}, SHIFT(1470),
  [483] = {.count = 1, .reusable = true}, SHIFT(132),
  [485] = {.count = 1, .reusable = false}, SHIFT(131),
  [487] = {.count = 1, .reusable = true}, SHIFT(2443),
  [489] = {.count = 1, .reusable = false}, SHIFT(1386),
  [491] = {.count = 1, .reusable = false}, SHIFT(416),
  [493] = {.count = 1, .reusable = false}, SHIFT(1387),
  [495] = {.count = 1, .reusable = true}, SHIFT(133),
  [497] = {.count = 1, .reusable = true}, SHIFT(134),
  [499] = {.count = 1, .reusable = false}, SHIFT(135),
  [501] = {.count = 1, .reusable = true}, SHIFT(135),
  [503] = {.count = 1, .reusable = false}, SHIFT(136),
  [505] = {.count = 1, .reusable = true}, SHIFT(1610),
  [507] = {.count = 1, .reusable = true}, SHIFT(136),
  [509] = {.count = 1, .reusable = false}, SHIFT(137),
  [511] = {.count = 1, .reusable = false}, SHIFT(139),
  [513] = {.count = 1, .reusable = false}, SHIFT(138),
  [515] = {.count = 1, .reusable = true}, SHIFT(138),
  [517] = {.count = 1, .reusable = false}, SHIFT(738),
  [519] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [521] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [523] = {.count = 1, .reusable = true}, SHIFT(1653),
  [525] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1, .production_id = 1),
  [527] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1, .production_id = 1),
  [529] = {.count = 1, .reusable = false}, SHIFT(775),
  [531] = {.count = 1, .reusable = true}, SHIFT(142),
  [533] = {.count = 1, .reusable = true}, SHIFT(143),
  [535] = {.count = 1, .reusable = false}, SHIFT(142),
  [537] = {.count = 1, .reusable = true}, SHIFT(144),
  [539] = {.count = 1, .reusable = true}, SHIFT(145),
  [541] = {.count = 1, .reusable = true}, SHIFT(146),
  [543] = {.count = 1, .reusable = false}, REDUCE(sym_negated_command, 2),
  [545] = {.count = 1, .reusable = true}, REDUCE(sym_negated_command, 2),
  [547] = {.count = 1, .reusable = true}, SHIFT(147),
  [549] = {.count = 1, .reusable = true}, SHIFT(2524),
  [551] = {.count = 1, .reusable = true}, SHIFT(1850),
  [553] = {.count = 1, .reusable = true}, SHIFT(148),
  [555] = {.count = 1, .reusable = true}, SHIFT(2514),
  [557] = {.count = 1, .reusable = false}, SHIFT(1849),
  [559] = {.count = 1, .reusable = true}, SHIFT(2522),
  [561] = {.count = 1, .reusable = true}, SHIFT(934),
  [563] = {.count = 1, .reusable = true}, SHIFT(2523),
  [565] = {.count = 1, .reusable = true}, SHIFT(149),
  [567] = {.count = 1, .reusable = true}, SHIFT(151),
  [569] = {.count = 1, .reusable = true}, SHIFT(966),
  [571] = {.count = 1, .reusable = true}, SHIFT(154),
  [573] = {.count = 1, .reusable = true}, SHIFT(807),
  [575] = {.count = 1, .reusable = true}, SHIFT(157),
  [577] = {.count = 1, .reusable = true}, SHIFT(809),
  [579] = {.count = 1, .reusable = false}, SHIFT(807),
  [581] = {.count = 1, .reusable = false}, SHIFT(158),
  [583] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [585] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [587] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 1),
  [589] = {.count = 1, .reusable = true}, SHIFT(159),
  [591] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 1),
  [593] = {.count = 1, .reusable = false}, SHIFT(160),
  [595] = {.count = 1, .reusable = false}, SHIFT(163),
  [597] = {.count = 1, .reusable = true}, SHIFT(163),
  [599] = {.count = 1, .reusable = false}, SHIFT(162),
  [601] = {.count = 1, .reusable = true}, SHIFT(1479),
  [603] = {.count = 1, .reusable = false}, SHIFT(2447),
  [605] = {.count = 1, .reusable = false}, SHIFT(2531),
  [607] = {.count = 1, .reusable = false}, SHIFT(558),
  [609] = {.count = 1, .reusable = false}, SHIFT(164),
  [611] = {.count = 1, .reusable = false}, SHIFT(1479),
  [613] = {.count = 1, .reusable = false}, SHIFT(1889),
  [615] = {.count = 1, .reusable = false}, SHIFT(2521),
  [617] = {.count = 1, .reusable = false}, SHIFT(2529),
  [619] = {.count = 1, .reusable = false}, SHIFT(2530),
  [621] = {.count = 1, .reusable = false}, SHIFT(1890),
  [623] = {.count = 1, .reusable = false}, SHIFT(998),
  [625] = {.count = 1, .reusable = true}, SHIFT(166),
  [627] = {.count = 1, .reusable = true}, SHIFT(441),
  [629] = {.count = 1, .reusable = true}, SHIFT(442),
  [631] = {.count = 1, .reusable = false}, SHIFT(441),
  [633] = {.count = 1, .reusable = true}, SHIFT(443),
  [635] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2),
  [637] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(90),
  [640] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2),
  [642] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2),
  [644] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [646] = {.count = 1, .reusable = true}, SHIFT(170),
  [648] = {.count = 1, .reusable = true}, SHIFT(171),
  [650] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [652] = {.count = 1, .reusable = true}, SHIFT(173),
  [654] = {.count = 1, .reusable = true}, SHIFT(2538),
  [656] = {.count = 1, .reusable = true}, SHIFT(1930),
  [658] = {.count = 1, .reusable = true}, SHIFT(176),
  [660] = {.count = 1, .reusable = true}, SHIFT(2528),
  [662] = {.count = 1, .reusable = false}, SHIFT(1929),
  [664] = {.count = 1, .reusable = true}, SHIFT(2536),
  [666] = {.count = 1, .reusable = true}, SHIFT(1030),
  [668] = {.count = 1, .reusable = true}, SHIFT(2537),
  [670] = {.count = 1, .reusable = true}, REDUCE(sym_redirected_statement, 2),
  [672] = {.count = 1, .reusable = false}, REDUCE(sym_redirected_statement, 2),
  [674] = {.count = 1, .reusable = true}, SHIFT(181),
  [676] = {.count = 1, .reusable = false}, SHIFT(180),
  [678] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2395),
  [681] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [684] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(380),
  [687] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(381),
  [690] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1362),
  [693] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2396),
  [696] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2397),
  [699] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2398),
  [702] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2399),
  [705] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(382),
  [708] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1363),
  [711] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3),
  [714] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(383),
  [717] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2610),
  [720] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2628),
  [723] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2400),
  [726] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(384),
  [729] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2401),
  [732] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(385),
  [735] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2402),
  [738] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(21),
  [741] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(1364),
  [744] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2611),
  [747] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2404),
  [750] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2405),
  [753] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(2406),
  [756] = {.count = 1, .reusable = false}, REDUCE(sym_command, 2),
  [758] = {.count = 1, .reusable = true}, REDUCE(sym_command, 2),
  [760] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2),
  [762] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [765] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2),
  [767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(21),
  [770] = {.count = 2, .reusable = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2453),
  [773] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(3),
  [776] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1),
  [778] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1),
  [780] = {.count = 1, .reusable = true}, SHIFT(183),
  [782] = {.count = 1, .reusable = true}, SHIFT(184),
  [784] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 1, .production_id = 1),
  [786] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 1, .production_id = 1),
  [788] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3),
  [790] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3),
  [792] = {.count = 1, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [794] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1517),
  [797] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2449),
  [800] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2450),
  [803] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(109),
  [806] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2451),
  [809] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(41),
  [812] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(631),
  [815] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2452),
  [818] = {.count = 1, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [820] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2442),
  [823] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1518),
  [826] = {.count = 1, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [828] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1560),
  [831] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2459),
  [834] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2460),
  [837] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(110),
  [840] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2461),
  [843] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(44),
  [846] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(692),
  [849] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2462),
  [852] = {.count = 1, .reusable = true}, REDUCE(aux_sym_unset_command_repeat1, 2),
  [854] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1561),
  [857] = {.count = 1, .reusable = false}, REDUCE(sym_process_substitution, 3),
  [859] = {.count = 1, .reusable = true}, REDUCE(sym_process_substitution, 3),
  [861] = {.count = 1, .reusable = false}, REDUCE(sym_command_substitution, 3),
  [863] = {.count = 1, .reusable = true}, REDUCE(sym_command_substitution, 3),
  [865] = {.count = 1, .reusable = false}, SHIFT(189),
  [867] = {.count = 1, .reusable = true}, SHIFT(187),
  [869] = {.count = 1, .reusable = true}, SHIFT(189),
  [871] = {.count = 1, .reusable = true}, SHIFT(188),
  [873] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [875] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [877] = {.count = 1, .reusable = true}, SHIFT(1816),
  [879] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3),
  [881] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3),
  [883] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 1, .production_id = 1),
  [885] = {.count = 1, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 1, .production_id = 1),
  [887] = {.count = 1, .reusable = false}, SHIFT(908),
  [889] = {.count = 1, .reusable = false}, SHIFT(190),
  [891] = {.count = 1, .reusable = true}, SHIFT(190),
  [893] = {.count = 1, .reusable = true}, SHIFT(191),
  [895] = {.count = 1, .reusable = true}, SHIFT(192),
  [897] = {.count = 1, .reusable = true}, SHIFT(193),
  [899] = {.count = 1, .reusable = false}, SHIFT(195),
  [901] = {.count = 1, .reusable = true}, SHIFT(194),
  [903] = {.count = 1, .reusable = true}, SHIFT(195),
  [905] = {.count = 1, .reusable = true}, SHIFT(2559),
  [907] = {.count = 1, .reusable = true}, SHIFT(2050),
  [909] = {.count = 1, .reusable = true}, SHIFT(196),
  [911] = {.count = 1, .reusable = true}, SHIFT(2549),
  [913] = {.count = 1, .reusable = false}, SHIFT(2049),
  [915] = {.count = 1, .reusable = true}, SHIFT(2557),
  [917] = {.count = 1, .reusable = false}, SHIFT(1126),
  [919] = {.count = 1, .reusable = true}, SHIFT(2558),
  [921] = {.count = 1, .reusable = false}, SHIFT(201),
  [923] = {.count = 1, .reusable = true}, SHIFT(199),
  [925] = {.count = 1, .reusable = true}, SHIFT(201),
  [927] = {.count = 1, .reusable = true}, SHIFT(200),
  [929] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 3, .production_id = 3),
  [931] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 3, .production_id = 3),
  [933] = {.count = 1, .reusable = true}, SHIFT(202),
  [935] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 3),
  [937] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 3),
  [939] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [941] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [943] = {.count = 1, .reusable = false}, SHIFT(204),
  [945] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(59),
  [948] = {.count = 1, .reusable = true}, SHIFT(456),
  [950] = {.count = 1, .reusable = true}, SHIFT(1405),
  [952] = {.count = 1, .reusable = false}, REDUCE(sym_compound_statement, 3),
  [954] = {.count = 1, .reusable = true}, REDUCE(sym_compound_statement, 3),
  [956] = {.count = 1, .reusable = false}, SHIFT(206),
  [958] = {.count = 1, .reusable = false}, SHIFT(207),
  [960] = {.count = 1, .reusable = false}, SHIFT(208),
  [962] = {.count = 1, .reusable = true}, REDUCE(sym__terminated_statement, 2),
  [964] = {.count = 1, .reusable = true}, SHIFT(214),
  [966] = {.count = 1, .reusable = true}, SHIFT(215),
  [968] = {.count = 1, .reusable = false}, SHIFT(215),
  [970] = {.count = 1, .reusable = true}, SHIFT(216),
  [972] = {.count = 1, .reusable = true}, SHIFT(217),
  [974] = {.count = 1, .reusable = false}, SHIFT(217),
  [976] = {.count = 1, .reusable = true}, REDUCE(sym_unary_expression, 2),
  [978] = {.count = 1, .reusable = false}, REDUCE(sym_unary_expression, 2),
  [980] = {.count = 1, .reusable = true}, SHIFT(218),
  [982] = {.count = 1, .reusable = true}, REDUCE(sym_postfix_expression, 2),
  [984] = {.count = 1, .reusable = false}, REDUCE(sym_postfix_expression, 2),
  [986] = {.count = 1, .reusable = true}, SHIFT(220),
  [988] = {.count = 1, .reusable = false}, REDUCE(sym_test_command, 3),
  [990] = {.count = 1, .reusable = true}, REDUCE(sym_test_command, 3),
  [992] = {.count = 1, .reusable = true}, SHIFT(2566),
  [994] = {.count = 1, .reusable = true}, SHIFT(2090),
  [996] = {.count = 1, .reusable = true}, SHIFT(221),
  [998] = {.count = 1, .reusable = true}, SHIFT(2556),
  [1000] = {.count = 1, .reusable = false}, SHIFT(2089),
  [1002] = {.count = 1, .reusable = true}, SHIFT(222),
  [1004] = {.count = 1, .reusable = true}, SHIFT(2564),
  [1006] = {.count = 1, .reusable = true}, SHIFT(1158),
  [1008] = {.count = 1, .reusable = true}, SHIFT(2565),
  [1010] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3),
  [1012] = {.count = 1, .reusable = true}, SHIFT(1856),
  [1014] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3),
  [1016] = {.count = 1, .reusable = false}, REDUCE(sym_variable_assignment, 3, .production_id = 4),
  [1018] = {.count = 1, .reusable = false}, SHIFT(940),
  [1020] = {.count = 1, .reusable = true}, REDUCE(sym_variable_assignment, 3, .production_id = 4),
  [1022] = {.count = 1, .reusable = true}, SHIFT(225),
  [1024] = {.count = 1, .reusable = true}, SHIFT(226),
  [1026] = {.count = 1, .reusable = true}, SHIFT(227),
  [1028] = {.count = 1, .reusable = true}, SHIFT(228),
  [1030] = {.count = 1, .reusable = false}, SHIFT(972),
  [1032] = {.count = 1, .reusable = true}, SHIFT(229),
  [1034] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3),
  [1036] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3),
  [1038] = {.count = 1, .reusable = true}, REDUCE(sym_file_redirect, 3, .production_id = 4),
  [1040] = {.count = 1, .reusable = false}, REDUCE(sym_file_redirect, 3, .production_id = 4),
  [1042] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1044] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1046] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1048] = {.count = 1, .reusable = true}, SHIFT(230),
  [1050] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1052] = {.count = 1, .reusable = true}, SHIFT(231),
  [1054] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(232),
  [1057] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2489),
  [1060] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2487),
  [1063] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(2488),
  [1066] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(83),
  [1069] = {.count = 1, .reusable = true}, SHIFT(2573),
  [1071] = {.count = 1, .reusable = true}, SHIFT(2130),
  [1073] = {.count = 1, .reusable = true}, SHIFT(481),
  [1075] = {.count = 1, .reusable = true}, SHIFT(2563),
  [1077] = {.count = 1, .reusable = false}, SHIFT(2129),
  [1079] = {.count = 1, .reusable = true}, SHIFT(2571),
  [1081] = {.count = 1, .reusable = true}, SHIFT(1190),
  [1083] = {.count = 1, .reusable = true}, SHIFT(2572),
  [1085] = {.count = 1, .reusable = false}, SHIFT(235),
  [1087] = {.count = 1, .reusable = false}, SHIFT(584),
  [1089] = {.count = 1, .reusable = true}, SHIFT(584),
  [1091] = {.count = 1, .reusable = false}, SHIFT(237),
  [1093] = {.count = 1, .reusable = false}, SHIFT(585),
  [1095] = {.count = 1, .reusable = false}, SHIFT(586),
  [1097] = {.count = 1, .reusable = false}, SHIFT(238),
  [1099] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 3),
  [1101] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 3),
  [1103] = {.count = 1, .reusable = false}, REDUCE(sym_pipeline, 3),
  [1105] = {.count = 1, .reusable = true}, REDUCE(sym_pipeline, 3),
  [1107] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 1),
  [1109] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 1),
  [1111] = {.count = 1, .reusable = false}, SHIFT(240),
  [1113] = {.count = 1, .reusable = true}, SHIFT(2580),
  [1115] = {.count = 1, .reusable = true}, SHIFT(2578),
  [1117] = {.count = 1, .reusable = true}, SHIFT(241),
  [1119] = {.count = 1, .reusable = true}, SHIFT(2579),
  [1121] = {.count = 1, .reusable = true}, SHIFT(242),
  [1123] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [1125] = {.count = 1, .reusable = true}, SHIFT(243),
  [1127] = {.count = 1, .reusable = false}, SHIFT(243),
  [1129] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_redirect, 2),
  [1131] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_redirect, 2),
  [1133] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1135] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1137] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2),
  [1139] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2),
  [1141] = {.count = 1, .reusable = true}, SHIFT(1936),
  [1143] = {.count = 1, .reusable = false}, REDUCE(sym_herestring_redirect, 2, .production_id = 2),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_herestring_redirect, 2, .production_id = 2),
  [1147] = {.count = 1, .reusable = false}, SHIFT(1036),
  [1149] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(95),
  [1152] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1361),
  [1155] = {.count = 1, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1157] = {.count = 1, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2),
  [1159] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2403),
  [1162] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(97),
  [1165] = {.count = 1, .reusable = false}, REDUCE(sym_command, 3),
  [1167] = {.count = 1, .reusable = true}, REDUCE(sym_command, 3),
  [1169] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2),
  [1171] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2),
  [1173] = {.count = 1, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2, .production_id = 2),
  [1175] = {.count = 1, .reusable = true}, REDUCE(aux_sym_command_repeat2, 2, .production_id = 2),
  [1177] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(6),
  [1180] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(7),
  [1183] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(8),
  [1186] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(9),
  [1189] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(104),
  [1192] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(105),
  [1195] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(13),
  [1198] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(18),
  [1201] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(22),
  [1204] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4),
  [1206] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4),
  [1208] = {.count = 1, .reusable = false}, SHIFT(246),
  [1210] = {.count = 1, .reusable = true}, SHIFT(245),
  [1212] = {.count = 1, .reusable = true}, SHIFT(246),
  [1214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(2517),
  [1217] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(114),
  [1220] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(190),
  [1223] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1809),
  [1226] = {.count = 1, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2),
  [1228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(2515),
  [1231] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(2516),
  [1234] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(2507),
  [1237] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(1810),
  [1240] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(114),
  [1243] = {.count = 2, .reusable = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(190),
  [1246] = {.count = 2, .reusable = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(902),
  [1249] = {.count = 1, .reusable = true}, SHIFT(247),
  [1251] = {.count = 1, .reusable = true}, SHIFT(248),
  [1253] = {.count = 1, .reusable = false}, SHIFT(253),
  [1255] = {.count = 1, .reusable = true}, SHIFT(251),
  [1257] = {.count = 1, .reusable = true}, SHIFT(253),
  [1259] = {.count = 1, .reusable = true}, SHIFT(252),
  [1261] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .production_id = 5),
  [1263] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .production_id = 5),
  [1265] = {.count = 1, .reusable = true}, SHIFT(2056),
  [1267] = {.count = 1, .reusable = false}, SHIFT(1132),
  [1269] = {.count = 1, .reusable = true}, SHIFT(254),
  [1271] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 4, .production_id = 3),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 4, .production_id = 3),
  [1275] = {.count = 1, .reusable = false}, SHIFT(256),
  [1277] = {.count = 1, .reusable = true}, SHIFT(255),
  [1279] = {.count = 1, .reusable = true}, SHIFT(256),
  [1281] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 4),
  [1283] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 4),
  [1285] = {.count = 1, .reusable = false}, REDUCE(sym_concatenation, 4),
  [1287] = {.count = 1, .reusable = false}, SHIFT(49),
  [1289] = {.count = 1, .reusable = true}, REDUCE(sym_concatenation, 4),
  [1291] = {.count = 1, .reusable = false}, SHIFT(48),
  [1293] = {.count = 1, .reusable = true}, SHIFT(258),
  [1295] = {.count = 1, .reusable = false}, SHIFT(258),
  [1297] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 1),
  [1299] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [1301] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [1303] = {.count = 1, .reusable = false}, SHIFT(262),
  [1305] = {.count = 1, .reusable = true}, SHIFT(261),
  [1307] = {.count = 1, .reusable = true}, SHIFT(263),
  [1309] = {.count = 1, .reusable = true}, SHIFT(208),
  [1311] = {.count = 1, .reusable = true}, SHIFT(206),
  [1313] = {.count = 1, .reusable = false}, SHIFT(263),
  [1315] = {.count = 1, .reusable = true}, SHIFT(268),
  [1317] = {.count = 1, .reusable = false}, SHIFT(268),
  [1319] = {.count = 1, .reusable = false}, SHIFT(269),
  [1321] = {.count = 1, .reusable = true}, SHIFT(269),
  [1323] = {.count = 1, .reusable = false}, SHIFT(270),
  [1325] = {.count = 1, .reusable = true}, SHIFT(275),
  [1327] = {.count = 1, .reusable = false}, SHIFT(275),
  [1329] = {.count = 1, .reusable = false}, SHIFT(276),
  [1331] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1333] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1335] = {.count = 1, .reusable = true}, REDUCE(sym_binary_expression, 3),
  [1337] = {.count = 1, .reusable = false}, REDUCE(sym_binary_expression, 3),
  [1339] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [1341] = {.count = 1, .reusable = true}, SHIFT(2096),
  [1343] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [1345] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [1347] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [1349] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .production_id = 1),
  [1351] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .production_id = 1),
  [1353] = {.count = 1, .reusable = true}, SHIFT(1164),
  [1355] = {.count = 1, .reusable = true}, SHIFT(279),
  [1357] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [1359] = {.count = 1, .reusable = true}, SHIFT(281),
  [1361] = {.count = 1, .reusable = true}, SHIFT(818),
  [1363] = {.count = 1, .reusable = true}, SHIFT(282),
  [1365] = {.count = 1, .reusable = false}, SHIFT(818),
  [1367] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4, .production_id = 4),
  [1369] = {.count = 1, .reusable = true}, SHIFT(283),
  [1371] = {.count = 1, .reusable = true}, SHIFT(284),
  [1373] = {.count = 1, .reusable = false}, REDUCE(aux_sym_string_repeat1, 3),
  [1375] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 3),
  [1377] = {.count = 1, .reusable = false}, REDUCE(sym_string, 4),
  [1379] = {.count = 1, .reusable = true}, REDUCE(sym_string, 4),
  [1381] = {.count = 1, .reusable = false}, SHIFT(2573),
  [1383] = {.count = 1, .reusable = false}, SHIFT(481),
  [1385] = {.count = 1, .reusable = true}, SHIFT(285),
  [1387] = {.count = 1, .reusable = false}, SHIFT(285),
  [1389] = {.count = 1, .reusable = false}, SHIFT(2563),
  [1391] = {.count = 1, .reusable = false}, SHIFT(2571),
  [1393] = {.count = 1, .reusable = false}, SHIFT(2572),
  [1395] = {.count = 1, .reusable = false}, SHIFT(2130),
  [1397] = {.count = 1, .reusable = false}, SHIFT(1190),
  [1399] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 4),
  [1401] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 4),
  [1403] = {.count = 1, .reusable = true}, SHIFT(286),
  [1405] = {.count = 1, .reusable = false}, SHIFT(288),
  [1407] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 2),
  [1409] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 2),
  [1411] = {.count = 1, .reusable = false}, SHIFT(290),
  [1413] = {.count = 1, .reusable = true}, SHIFT(1223),
  [1415] = {.count = 1, .reusable = true}, SHIFT(1225),
  [1417] = {.count = 1, .reusable = false}, SHIFT(1223),
  [1419] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [1421] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [1423] = {.count = 1, .reusable = true}, SHIFT(291),
  [1425] = {.count = 1, .reusable = true}, SHIFT(292),
  [1427] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements_repeat1, 4),
  [1429] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 4),
  [1431] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 4),
  [1433] = {.count = 1, .reusable = true}, SHIFT(293),
  [1435] = {.count = 1, .reusable = false}, SHIFT(293),
  [1437] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5),
  [1439] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5),
  [1441] = {.count = 1, .reusable = true}, SHIFT(294),
  [1443] = {.count = 1, .reusable = false}, SHIFT(295),
  [1445] = {.count = 1, .reusable = true}, SHIFT(295),
  [1447] = {.count = 1, .reusable = true}, SHIFT(296),
  [1449] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .production_id = 5),
  [1451] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .production_id = 5),
  [1453] = {.count = 1, .reusable = false}, SHIFT(298),
  [1455] = {.count = 1, .reusable = true}, SHIFT(297),
  [1457] = {.count = 1, .reusable = true}, SHIFT(298),
  [1459] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .production_id = 6),
  [1461] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .production_id = 6),
  [1463] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 5, .production_id = 3),
  [1465] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 5, .production_id = 3),
  [1467] = {.count = 1, .reusable = true}, SHIFT(299),
  [1469] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [1471] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [1473] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 2),
  [1475] = {.count = 1, .reusable = true}, SHIFT(300),
  [1477] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements2, 2),
  [1479] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements2, 2),
  [1481] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [1483] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [1485] = {.count = 2, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(208),
  [1488] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [1490] = {.count = 1, .reusable = true}, SHIFT(302),
  [1492] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(3),
  [1495] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(380),
  [1498] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(1362),
  [1501] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2396),
  [1504] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(382),
  [1507] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(383),
  [1510] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2610),
  [1513] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2400),
  [1516] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(384),
  [1519] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2402),
  [1522] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(381),
  [1525] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(1364),
  [1528] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2404),
  [1531] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2395),
  [1534] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2397),
  [1537] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2398),
  [1540] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2399),
  [1543] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(1363),
  [1546] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(3),
  [1549] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2401),
  [1552] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2628),
  [1555] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(385),
  [1558] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(21),
  [1561] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2611),
  [1564] = {.count = 2, .reusable = false}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2405),
  [1567] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements2, 2), SHIFT_REPEAT(2406),
  [1570] = {.count = 1, .reusable = false}, SHIFT(304),
  [1572] = {.count = 1, .reusable = true}, SHIFT(308),
  [1574] = {.count = 1, .reusable = true}, SHIFT(307),
  [1576] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5),
  [1578] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5),
  [1580] = {.count = 1, .reusable = true}, SHIFT(310),
  [1582] = {.count = 1, .reusable = true}, SHIFT(775),
  [1584] = {.count = 1, .reusable = true}, SHIFT(304),
  [1586] = {.count = 1, .reusable = false}, SHIFT(313),
  [1588] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 5, .production_id = 2),
  [1590] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 5, .production_id = 2),
  [1592] = {.count = 1, .reusable = true}, SHIFT(313),
  [1594] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [1596] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [1598] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2566),
  [1601] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2090),
  [1604] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(221),
  [1607] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2556),
  [1610] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2089),
  [1613] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1615] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2564),
  [1618] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1158),
  [1621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2565),
  [1624] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [1626] = {.count = 1, .reusable = true}, SHIFT(316),
  [1628] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5, .production_id = 4),
  [1630] = {.count = 1, .reusable = true}, SHIFT(317),
  [1632] = {.count = 1, .reusable = true}, SHIFT(319),
  [1634] = {.count = 1, .reusable = true}, SHIFT(321),
  [1636] = {.count = 1, .reusable = false}, SHIFT(323),
  [1638] = {.count = 1, .reusable = false}, REDUCE(sym_do_group, 3),
  [1640] = {.count = 1, .reusable = true}, REDUCE(sym_do_group, 3),
  [1642] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [1644] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [1646] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(240),
  [1649] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2580),
  [1652] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2578),
  [1655] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [1657] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(2579),
  [1660] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(292),
  [1663] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 5),
  [1665] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6),
  [1667] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6),
  [1669] = {.count = 1, .reusable = true}, SHIFT(324),
  [1671] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .production_id = 7),
  [1673] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .production_id = 7),
  [1675] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .production_id = 5),
  [1677] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .production_id = 5),
  [1679] = {.count = 1, .reusable = true}, SHIFT(325),
  [1681] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 6, .production_id = 3),
  [1683] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 6, .production_id = 3),
  [1685] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 3),
  [1687] = {.count = 1, .reusable = true}, SHIFT(327),
  [1689] = {.count = 1, .reusable = false}, SHIFT(327),
  [1691] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [1693] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [1695] = {.count = 1, .reusable = true}, SHIFT(328),
  [1697] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6),
  [1699] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6),
  [1701] = {.count = 1, .reusable = true}, SHIFT(329),
  [1703] = {.count = 1, .reusable = true}, SHIFT(331),
  [1705] = {.count = 1, .reusable = false}, SHIFT(629),
  [1707] = {.count = 1, .reusable = false}, SHIFT(630),
  [1709] = {.count = 1, .reusable = false}, SHIFT(2169),
  [1711] = {.count = 1, .reusable = true}, SHIFT(2570),
  [1713] = {.count = 1, .reusable = true}, SHIFT(2585),
  [1715] = {.count = 1, .reusable = true}, SHIFT(2586),
  [1717] = {.count = 1, .reusable = false}, SHIFT(534),
  [1719] = {.count = 1, .reusable = false}, SHIFT(1222),
  [1721] = {.count = 1, .reusable = true}, SHIFT(536),
  [1723] = {.count = 1, .reusable = true}, SHIFT(2587),
  [1725] = {.count = 1, .reusable = false}, SHIFT(537),
  [1727] = {.count = 1, .reusable = true}, SHIFT(2472),
  [1729] = {.count = 1, .reusable = true}, SHIFT(2170),
  [1731] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2),
  [1733] = {.count = 1, .reusable = true}, SHIFT(334),
  [1735] = {.count = 1, .reusable = true}, SHIFT(336),
  [1737] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 2, .production_id = 1),
  [1739] = {.count = 1, .reusable = true}, SHIFT(338),
  [1741] = {.count = 1, .reusable = true}, SHIFT(340),
  [1743] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2480),
  [1746] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1647),
  [1749] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(341),
  [1752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2477),
  [1755] = {.count = 2, .reusable = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1646),
  [1758] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2478),
  [1761] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(769),
  [1764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(2479),
  [1767] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 6, .production_id = 2),
  [1769] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 6, .production_id = 2),
  [1771] = {.count = 1, .reusable = true}, SHIFT(344),
  [1773] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [1775] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6, .production_id = 4),
  [1777] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [1779] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [1781] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 6),
  [1783] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 6),
  [1785] = {.count = 1, .reusable = true}, SHIFT(347),
  [1787] = {.count = 1, .reusable = true}, SHIFT(348),
  [1789] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7),
  [1791] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7),
  [1793] = {.count = 1, .reusable = false}, REDUCE(sym_expansion, 7, .production_id = 5),
  [1795] = {.count = 1, .reusable = true}, REDUCE(sym_expansion, 7, .production_id = 5),
  [1797] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [1799] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements2, 4),
  [1801] = {.count = 1, .reusable = false}, REDUCE(aux_sym__statements2, 4),
  [1803] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 7),
  [1805] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 7),
  [1807] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7),
  [1809] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7),
  [1811] = {.count = 1, .reusable = true}, SHIFT(350),
  [1813] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2),
  [1815] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2, .production_id = 2),
  [1817] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3),
  [1819] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3),
  [1821] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3),
  [1823] = {.count = 1, .reusable = true}, SHIFT(351),
  [1825] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3),
  [1827] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(307),
  [1830] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 3, .production_id = 1),
  [1832] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 3, .production_id = 1),
  [1834] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 3, .production_id = 1),
  [1836] = {.count = 1, .reusable = true}, SHIFT(353),
  [1838] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 3, .production_id = 1),
  [1840] = {.count = 1, .reusable = true}, SHIFT(355),
  [1842] = {.count = 1, .reusable = true}, SHIFT(357),
  [1844] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 7, .production_id = 2),
  [1846] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 7, .production_id = 2),
  [1848] = {.count = 1, .reusable = true}, SHIFT(359),
  [1850] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 7),
  [1852] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 7),
  [1854] = {.count = 1, .reusable = true}, SHIFT(361),
  [1856] = {.count = 1, .reusable = true}, SHIFT(362),
  [1858] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8),
  [1860] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8),
  [1862] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4),
  [1864] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4),
  [1866] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4),
  [1868] = {.count = 1, .reusable = true}, SHIFT(363),
  [1870] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4),
  [1872] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 4, .production_id = 1),
  [1874] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 4, .production_id = 1),
  [1876] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 4, .production_id = 1),
  [1878] = {.count = 1, .reusable = true}, SHIFT(364),
  [1880] = {.count = 1, .reusable = true}, REDUCE(sym_last_case_item, 4, .production_id = 1),
  [1882] = {.count = 1, .reusable = true}, SHIFT(365),
  [1884] = {.count = 1, .reusable = true}, SHIFT(367),
  [1886] = {.count = 1, .reusable = true}, SHIFT(368),
  [1888] = {.count = 1, .reusable = true}, SHIFT(370),
  [1890] = {.count = 1, .reusable = false}, REDUCE(sym_case_statement, 8, .production_id = 2),
  [1892] = {.count = 1, .reusable = true}, REDUCE(sym_case_statement, 8, .production_id = 2),
  [1894] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 8),
  [1896] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 8),
  [1898] = {.count = 1, .reusable = true}, SHIFT(372),
  [1900] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5),
  [1902] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5),
  [1904] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5),
  [1906] = {.count = 1, .reusable = true}, REDUCE(sym_case_item, 5, .production_id = 1),
  [1908] = {.count = 1, .reusable = false}, REDUCE(sym_case_item, 5, .production_id = 1),
  [1910] = {.count = 1, .reusable = false}, REDUCE(sym_last_case_item, 5, .production_id = 1),
  [1912] = {.count = 1, .reusable = true}, SHIFT(373),
  [1914] = {.count = 1, .reusable = true}, SHIFT(375),
  [1916] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 9),
  [1918] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 9),
  [1920] = {.count = 1, .reusable = true}, SHIFT(378),
  [1922] = {.count = 1, .reusable = true}, SHIFT(379),
  [1924] = {.count = 1, .reusable = false}, REDUCE(sym_c_style_for_statement, 10),
  [1926] = {.count = 1, .reusable = true}, REDUCE(sym_c_style_for_statement, 10),
  [1928] = {.count = 1, .reusable = false}, SHIFT(1729),
  [1930] = {.count = 1, .reusable = false}, SHIFT(2493),
  [1932] = {.count = 1, .reusable = false}, SHIFT(2501),
  [1934] = {.count = 1, .reusable = false}, SHIFT(398),
  [1936] = {.count = 1, .reusable = false}, SHIFT(2502),
  [1938] = {.count = 1, .reusable = false}, SHIFT(396),
  [1940] = {.count = 1, .reusable = false}, SHIFT(838),
  [1942] = {.count = 1, .reusable = false}, SHIFT(2503),
  [1944] = {.count = 1, .reusable = true}, SHIFT(2463),
  [1946] = {.count = 1, .reusable = false}, SHIFT(1730),
  [1948] = {.count = 1, .reusable = false}, SHIFT(1769),
  [1950] = {.count = 1, .reusable = false}, SHIFT(2500),
  [1952] = {.count = 1, .reusable = false}, SHIFT(2508),
  [1954] = {.count = 1, .reusable = false}, SHIFT(401),
  [1956] = {.count = 1, .reusable = false}, SHIFT(2509),
  [1958] = {.count = 1, .reusable = false}, SHIFT(399),
  [1960] = {.count = 1, .reusable = false}, SHIFT(870),
  [1962] = {.count = 1, .reusable = false}, SHIFT(2510),
  [1964] = {.count = 1, .reusable = false}, SHIFT(1770),
  [1966] = {.count = 1, .reusable = false}, SHIFT(2410),
  [1968] = {.count = 1, .reusable = true}, SHIFT(1372),
  [1970] = {.count = 1, .reusable = false}, SHIFT(411),
  [1972] = {.count = 1, .reusable = false}, SHIFT(415),
  [1974] = {.count = 1, .reusable = true}, SHIFT(414),
  [1976] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 1),
  [1978] = {.count = 1, .reusable = true}, SHIFT(383),
  [1980] = {.count = 1, .reusable = false}, SHIFT(2396),
  [1982] = {.count = 1, .reusable = false}, SHIFT(2397),
  [1984] = {.count = 1, .reusable = false}, SHIFT(2398),
  [1986] = {.count = 1, .reusable = false}, SHIFT(422),
  [1988] = {.count = 1, .reusable = false}, SHIFT(423),
  [1990] = {.count = 1, .reusable = false}, SHIFT(2401),
  [1992] = {.count = 1, .reusable = false}, SHIFT(1364),
  [1994] = {.count = 1, .reusable = true}, SHIFT(1736),
  [1996] = {.count = 1, .reusable = false}, SHIFT(844),
  [1998] = {.count = 1, .reusable = false}, SHIFT(427),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1776),
  [2002] = {.count = 1, .reusable = false}, SHIFT(876),
  [2004] = {.count = 1, .reusable = false}, SHIFT(428),
  [2006] = {.count = 1, .reusable = true}, SHIFT(435),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1696),
  [2010] = {.count = 1, .reusable = false}, SHIFT(812),
  [2012] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(411),
  [2015] = {.count = 1, .reusable = true}, SHIFT(466),
  [2017] = {.count = 1, .reusable = false}, SHIFT(465),
  [2019] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [2021] = {.count = 1, .reusable = true}, SHIFT(468),
  [2023] = {.count = 1, .reusable = true}, SHIFT(469),
  [2025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1729),
  [2028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2493),
  [2031] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2501),
  [2034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(427),
  [2037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2502),
  [2040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(396),
  [2043] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(838),
  [2046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2503),
  [2049] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2463),
  [2052] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1730),
  [2055] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1769),
  [2058] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2500),
  [2061] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2508),
  [2064] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(428),
  [2067] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2509),
  [2070] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(399),
  [2073] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(870),
  [2076] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2510),
  [2079] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1770),
  [2082] = {.count = 1, .reusable = true}, SHIFT(434),
  [2084] = {.count = 1, .reusable = false}, SHIFT(476),
  [2086] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1372),
  [2089] = {.count = 1, .reusable = true}, SHIFT(480),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1976),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1068),
  [2095] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [2097] = {.count = 1, .reusable = true}, SHIFT(490),
  [2099] = {.count = 1, .reusable = false}, SHIFT(490),
  [2101] = {.count = 1, .reusable = true}, SHIFT(2016),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2105] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1470),
  [2108] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1386),
  [2111] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2443),
  [2114] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(1387),
  [2117] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1362),
  [2120] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2396),
  [2123] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2397),
  [2126] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2398),
  [2129] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(422),
  [2132] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(423),
  [2135] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(383),
  [2138] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2401),
  [2141] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1364),
  [2144] = {.count = 1, .reusable = false}, SHIFT(404),
  [2146] = {.count = 1, .reusable = false}, SHIFT(402),
  [2148] = {.count = 1, .reusable = false}, SHIFT(403),
  [2150] = {.count = 1, .reusable = true}, SHIFT(2136),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2154] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [2156] = {.count = 1, .reusable = true}, SHIFT(503),
  [2158] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4, .production_id = 4),
  [2160] = {.count = 1, .reusable = true}, SHIFT(505),
  [2162] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 4),
  [2164] = {.count = 1, .reusable = true}, SHIFT(509),
  [2166] = {.count = 1, .reusable = false}, SHIFT(509),
  [2168] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2573),
  [2171] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(481),
  [2174] = {.count = 1, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [2176] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2129),
  [2179] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2563),
  [2182] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2571),
  [2185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2572),
  [2188] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(2130),
  [2191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(1190),
  [2194] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [2196] = {.count = 1, .reusable = true}, SHIFT(517),
  [2198] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5, .production_id = 4),
  [2200] = {.count = 1, .reusable = true}, SHIFT(518),
  [2202] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [2204] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6, .production_id = 4),
  [2206] = {.count = 1, .reusable = false}, SHIFT(550),
  [2208] = {.count = 1, .reusable = false}, SHIFT(553),
  [2210] = {.count = 1, .reusable = true}, SHIFT(2176),
  [2212] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2214] = {.count = 1, .reusable = false}, SHIFT(2436),
  [2216] = {.count = 1, .reusable = true}, SHIFT(646),
  [2218] = {.count = 1, .reusable = false}, SHIFT(647),
  [2220] = {.count = 1, .reusable = true}, SHIFT(2454),
  [2222] = {.count = 1, .reusable = false}, SHIFT(648),
  [2224] = {.count = 1, .reusable = false}, SHIFT(2435),
  [2226] = {.count = 1, .reusable = false}, SHIFT(645),
  [2228] = {.count = 1, .reusable = false}, SHIFT(566),
  [2230] = {.count = 1, .reusable = false}, SHIFT(563),
  [2232] = {.count = 1, .reusable = false}, SHIFT(565),
  [2234] = {.count = 1, .reusable = true}, SHIFT(564),
  [2236] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2238] = {.count = 1, .reusable = true}, SHIFT(2216),
  [2240] = {.count = 1, .reusable = false}, SHIFT(1260),
  [2242] = {.count = 1, .reusable = true}, SHIFT(2256),
  [2244] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2246] = {.count = 1, .reusable = true}, SHIFT(581),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1896),
  [2250] = {.count = 1, .reusable = false}, SHIFT(1004),
  [2252] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(561),
  [2255] = {.count = 1, .reusable = true}, SHIFT(600),
  [2257] = {.count = 1, .reusable = false}, SHIFT(599),
  [2259] = {.count = 1, .reusable = true}, SHIFT(602),
  [2261] = {.count = 1, .reusable = true}, SHIFT(603),
  [2263] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2209),
  [2266] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2577),
  [2269] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2592),
  [2272] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(574),
  [2275] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2593),
  [2278] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(548),
  [2281] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(1254),
  [2284] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2594),
  [2287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2481),
  [2290] = {.count = 2, .reusable = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(2210),
  [2293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2249),
  [2296] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2584),
  [2299] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2598),
  [2302] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(575),
  [2305] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2599),
  [2308] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(551),
  [2311] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(1286),
  [2314] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2600),
  [2317] = {.count = 2, .reusable = false}, REDUCE(aux_sym_unset_command_repeat1, 2), SHIFT_REPEAT(2250),
  [2320] = {.count = 1, .reusable = true}, SHIFT(580),
  [2322] = {.count = 1, .reusable = false}, SHIFT(609),
  [2324] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1478),
  [2327] = {.count = 1, .reusable = true}, SHIFT(2447),
  [2329] = {.count = 1, .reusable = true}, SHIFT(1890),
  [2331] = {.count = 1, .reusable = true}, SHIFT(558),
  [2333] = {.count = 1, .reusable = true}, SHIFT(2531),
  [2335] = {.count = 1, .reusable = true}, SHIFT(2521),
  [2337] = {.count = 1, .reusable = true}, SHIFT(2529),
  [2339] = {.count = 1, .reusable = true}, SHIFT(998),
  [2341] = {.count = 1, .reusable = true}, SHIFT(2530),
  [2343] = {.count = 1, .reusable = true}, SHIFT(612),
  [2345] = {.count = 1, .reusable = false}, SHIFT(678),
  [2347] = {.count = 1, .reusable = true}, SHIFT(678),
  [2349] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2169),
  [2352] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2570),
  [2355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2585),
  [2358] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2586),
  [2361] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(570),
  [2364] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(571),
  [2367] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(1222),
  [2370] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2587),
  [2373] = {.count = 2, .reusable = false}, REDUCE(aux_sym_command_repeat2, 2), SHIFT_REPEAT(2170),
  [2376] = {.count = 1, .reusable = false}, SHIFT(556),
  [2378] = {.count = 1, .reusable = false}, SHIFT(554),
  [2380] = {.count = 1, .reusable = true}, SHIFT(555),
  [2382] = {.count = 1, .reusable = true}, SHIFT(556),
  [2384] = {.count = 1, .reusable = false}, SHIFT(685),
  [2386] = {.count = 1, .reusable = true}, SHIFT(685),
  [2388] = {.count = 1, .reusable = false}, SHIFT(2209),
  [2390] = {.count = 1, .reusable = false}, SHIFT(2577),
  [2392] = {.count = 1, .reusable = false}, SHIFT(2592),
  [2394] = {.count = 1, .reusable = false}, SHIFT(636),
  [2396] = {.count = 1, .reusable = false}, SHIFT(2593),
  [2398] = {.count = 1, .reusable = false}, SHIFT(548),
  [2400] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2402] = {.count = 1, .reusable = false}, SHIFT(2594),
  [2404] = {.count = 1, .reusable = true}, SHIFT(2481),
  [2406] = {.count = 1, .reusable = false}, SHIFT(2210),
  [2408] = {.count = 1, .reusable = false}, SHIFT(2249),
  [2410] = {.count = 1, .reusable = false}, SHIFT(2584),
  [2412] = {.count = 1, .reusable = false}, SHIFT(2598),
  [2414] = {.count = 1, .reusable = false}, SHIFT(637),
  [2416] = {.count = 1, .reusable = false}, SHIFT(2599),
  [2418] = {.count = 1, .reusable = false}, SHIFT(551),
  [2420] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2422] = {.count = 1, .reusable = false}, SHIFT(2600),
  [2424] = {.count = 1, .reusable = false}, SHIFT(2250),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2428] = {.count = 1, .reusable = false}, SHIFT(2570),
  [2430] = {.count = 1, .reusable = false}, SHIFT(2585),
  [2432] = {.count = 1, .reusable = false}, SHIFT(2586),
  [2434] = {.count = 1, .reusable = false}, SHIFT(570),
  [2436] = {.count = 1, .reusable = false}, SHIFT(571),
  [2438] = {.count = 1, .reusable = false}, SHIFT(2587),
  [2440] = {.count = 1, .reusable = false}, SHIFT(2170),
  [2442] = {.count = 1, .reusable = false}, SHIFT(574),
  [2444] = {.count = 1, .reusable = false}, SHIFT(575),
  [2446] = {.count = 1, .reusable = true}, SHIFT(658),
  [2448] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(643),
  [2451] = {.count = 1, .reusable = true}, SHIFT(670),
  [2453] = {.count = 1, .reusable = false}, SHIFT(669),
  [2455] = {.count = 1, .reusable = true}, SHIFT(2452),
  [2457] = {.count = 1, .reusable = true}, SHIFT(1518),
  [2459] = {.count = 1, .reusable = true}, SHIFT(657),
  [2461] = {.count = 1, .reusable = true}, SHIFT(2449),
  [2463] = {.count = 1, .reusable = false}, SHIFT(675),
  [2465] = {.count = 1, .reusable = true}, SHIFT(2450),
  [2467] = {.count = 1, .reusable = true}, SHIFT(2451),
  [2469] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1524),
  [2472] = {.count = 1, .reusable = false}, SHIFT(638),
  [2474] = {.count = 1, .reusable = false}, SHIFT(640),
  [2476] = {.count = 1, .reusable = false}, SHIFT(639),
  [2478] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 5),
  [2480] = {.count = 1, .reusable = true}, SHIFT(708),
  [2482] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(699),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1466),
  [2487] = {.count = 1, .reusable = true}, SHIFT(2462),
  [2489] = {.count = 1, .reusable = true}, SHIFT(1561),
  [2491] = {.count = 1, .reusable = true}, SHIFT(707),
  [2493] = {.count = 1, .reusable = true}, SHIFT(2459),
  [2495] = {.count = 1, .reusable = false}, SHIFT(718),
  [2497] = {.count = 1, .reusable = true}, SHIFT(2460),
  [2499] = {.count = 1, .reusable = true}, SHIFT(2461),
  [2501] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1567),
  [2504] = {.count = 1, .reusable = false}, SHIFT(694),
  [2506] = {.count = 1, .reusable = false}, SHIFT(696),
  [2508] = {.count = 1, .reusable = false}, SHIFT(695),
  [2510] = {.count = 1, .reusable = true}, SHIFT(745),
  [2512] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(738),
  [2515] = {.count = 1, .reusable = true}, SHIFT(744),
  [2517] = {.count = 1, .reusable = false}, SHIFT(755),
  [2519] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1610),
  [2522] = {.count = 1, .reusable = true}, SHIFT(2296),
  [2524] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2526] = {.count = 1, .reusable = false}, SHIFT(733),
  [2528] = {.count = 1, .reusable = false}, SHIFT(734),
  [2530] = {.count = 1, .reusable = false}, SHIFT(735),
  [2532] = {.count = 1, .reusable = false}, SHIFT(1604),
  [2534] = {.count = 1, .reusable = true}, SHIFT(782),
  [2536] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(775),
  [2539] = {.count = 1, .reusable = true}, SHIFT(781),
  [2541] = {.count = 1, .reusable = false}, SHIFT(792),
  [2543] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1653),
  [2546] = {.count = 1, .reusable = true}, SHIFT(772),
  [2548] = {.count = 1, .reusable = false}, SHIFT(772),
  [2550] = {.count = 1, .reusable = false}, SHIFT(770),
  [2552] = {.count = 1, .reusable = true}, SHIFT(770),
  [2554] = {.count = 1, .reusable = true}, SHIFT(771),
  [2556] = {.count = 1, .reusable = true}, SHIFT(819),
  [2558] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(812),
  [2561] = {.count = 1, .reusable = false}, SHIFT(826),
  [2563] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1696),
  [2566] = {.count = 1, .reusable = true}, SHIFT(841),
  [2568] = {.count = 1, .reusable = false}, SHIFT(841),
  [2570] = {.count = 1, .reusable = false}, SHIFT(839),
  [2572] = {.count = 1, .reusable = true}, SHIFT(839),
  [2574] = {.count = 1, .reusable = true}, SHIFT(808),
  [2576] = {.count = 1, .reusable = true}, SHIFT(851),
  [2578] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(844),
  [2581] = {.count = 1, .reusable = true}, SHIFT(2503),
  [2583] = {.count = 1, .reusable = true}, SHIFT(850),
  [2585] = {.count = 1, .reusable = false}, SHIFT(858),
  [2587] = {.count = 1, .reusable = true}, SHIFT(2493),
  [2589] = {.count = 1, .reusable = true}, SHIFT(2501),
  [2591] = {.count = 1, .reusable = true}, SHIFT(2502),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1730),
  [2595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1736),
  [2598] = {.count = 1, .reusable = false}, SHIFT(873),
  [2600] = {.count = 1, .reusable = false}, SHIFT(871),
  [2602] = {.count = 1, .reusable = false}, SHIFT(840),
  [2604] = {.count = 1, .reusable = true}, SHIFT(883),
  [2606] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(876),
  [2609] = {.count = 1, .reusable = true}, SHIFT(2510),
  [2611] = {.count = 1, .reusable = true}, SHIFT(882),
  [2613] = {.count = 1, .reusable = false}, SHIFT(890),
  [2615] = {.count = 1, .reusable = true}, SHIFT(2500),
  [2617] = {.count = 1, .reusable = true}, SHIFT(2508),
  [2619] = {.count = 1, .reusable = true}, SHIFT(2509),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1770),
  [2623] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1776),
  [2626] = {.count = 1, .reusable = false}, SHIFT(905),
  [2628] = {.count = 1, .reusable = false}, SHIFT(903),
  [2630] = {.count = 1, .reusable = false}, SHIFT(872),
  [2632] = {.count = 1, .reusable = true}, SHIFT(915),
  [2634] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(908),
  [2637] = {.count = 1, .reusable = true}, SHIFT(914),
  [2639] = {.count = 1, .reusable = false}, SHIFT(922),
  [2641] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1816),
  [2644] = {.count = 1, .reusable = false}, SHIFT(935),
  [2646] = {.count = 1, .reusable = true}, SHIFT(904),
  [2648] = {.count = 1, .reusable = false}, SHIFT(937),
  [2650] = {.count = 1, .reusable = true}, SHIFT(937),
  [2652] = {.count = 1, .reusable = true}, SHIFT(947),
  [2654] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(940),
  [2657] = {.count = 1, .reusable = true}, SHIFT(946),
  [2659] = {.count = 1, .reusable = false}, SHIFT(954),
  [2661] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1856),
  [2664] = {.count = 1, .reusable = false}, SHIFT(967),
  [2666] = {.count = 1, .reusable = false}, SHIFT(969),
  [2668] = {.count = 1, .reusable = false}, SHIFT(936),
  [2670] = {.count = 1, .reusable = false}, SHIFT(1850),
  [2672] = {.count = 1, .reusable = true}, SHIFT(979),
  [2674] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(972),
  [2677] = {.count = 1, .reusable = true}, SHIFT(978),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1018),
  [2681] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1896),
  [2684] = {.count = 1, .reusable = true}, SHIFT(1011),
  [2686] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1004),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1010),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1050),
  [2693] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1936),
  [2696] = {.count = 1, .reusable = false}, SHIFT(1001),
  [2698] = {.count = 1, .reusable = false}, SHIFT(999),
  [2700] = {.count = 1, .reusable = false}, SHIFT(968),
  [2702] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2704] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1036),
  [2707] = {.count = 1, .reusable = true}, SHIFT(2545),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1042),
  [2711] = {.count = 1, .reusable = false}, SHIFT(1082),
  [2713] = {.count = 1, .reusable = true}, SHIFT(2535),
  [2715] = {.count = 1, .reusable = true}, SHIFT(2543),
  [2717] = {.count = 1, .reusable = true}, SHIFT(2544),
  [2719] = {.count = 1, .reusable = true}, SHIFT(1970),
  [2721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1976),
  [2724] = {.count = 1, .reusable = false}, SHIFT(1031),
  [2726] = {.count = 1, .reusable = false}, SHIFT(1033),
  [2728] = {.count = 1, .reusable = false}, SHIFT(1000),
  [2730] = {.count = 1, .reusable = false}, SHIFT(1930),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2734] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1068),
  [2737] = {.count = 1, .reusable = true}, SHIFT(2552),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2741] = {.count = 1, .reusable = false}, SHIFT(1114),
  [2743] = {.count = 1, .reusable = true}, SHIFT(2542),
  [2745] = {.count = 1, .reusable = true}, SHIFT(2550),
  [2747] = {.count = 1, .reusable = true}, SHIFT(2551),
  [2749] = {.count = 1, .reusable = true}, SHIFT(2010),
  [2751] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2016),
  [2754] = {.count = 1, .reusable = false}, SHIFT(1065),
  [2756] = {.count = 1, .reusable = false}, SHIFT(1063),
  [2758] = {.count = 1, .reusable = false}, SHIFT(1032),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1970),
  [2762] = {.count = 1, .reusable = true}, SHIFT(1107),
  [2764] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1100),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1106),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1146),
  [2771] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2056),
  [2774] = {.count = 1, .reusable = false}, SHIFT(1095),
  [2776] = {.count = 1, .reusable = false}, SHIFT(1097),
  [2778] = {.count = 1, .reusable = false}, SHIFT(1064),
  [2780] = {.count = 1, .reusable = false}, SHIFT(2010),
  [2782] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2784] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1132),
  [2787] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2789] = {.count = 1, .reusable = false}, SHIFT(1178),
  [2791] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2096),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1127),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2798] = {.count = 1, .reusable = true}, SHIFT(1129),
  [2800] = {.count = 1, .reusable = false}, SHIFT(1127),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2804] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1164),
  [2807] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2809] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2811] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2136),
  [2814] = {.count = 1, .reusable = false}, SHIFT(1159),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2818] = {.count = 1, .reusable = false}, SHIFT(1161),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1161),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2824] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1196),
  [2827] = {.count = 1, .reusable = true}, SHIFT(1202),
  [2829] = {.count = 1, .reusable = false}, SHIFT(1242),
  [2831] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2176),
  [2834] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2836] = {.count = 1, .reusable = false}, SHIFT(1160),
  [2838] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2840] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2842] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1228),
  [2845] = {.count = 1, .reusable = true}, SHIFT(2594),
  [2847] = {.count = 1, .reusable = true}, SHIFT(2210),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1234),
  [2851] = {.count = 1, .reusable = true}, SHIFT(2577),
  [2853] = {.count = 1, .reusable = false}, SHIFT(1274),
  [2855] = {.count = 1, .reusable = true}, SHIFT(2592),
  [2857] = {.count = 1, .reusable = true}, SHIFT(2593),
  [2859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2216),
  [2862] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2864] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2866] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2868] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2870] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1260),
  [2873] = {.count = 1, .reusable = true}, SHIFT(2600),
  [2875] = {.count = 1, .reusable = true}, SHIFT(2250),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2879] = {.count = 1, .reusable = true}, SHIFT(2584),
  [2881] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2883] = {.count = 1, .reusable = true}, SHIFT(2598),
  [2885] = {.count = 1, .reusable = true}, SHIFT(2599),
  [2887] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2256),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1287),
  [2892] = {.count = 1, .reusable = false}, SHIFT(1289),
  [2894] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2896] = {.count = 1, .reusable = true}, SHIFT(1299),
  [2898] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1292),
  [2901] = {.count = 1, .reusable = true}, SHIFT(2606),
  [2903] = {.count = 1, .reusable = true}, SHIFT(2290),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2907] = {.count = 1, .reusable = true}, SHIFT(2591),
  [2909] = {.count = 1, .reusable = false}, SHIFT(1330),
  [2911] = {.count = 1, .reusable = true}, SHIFT(2604),
  [2913] = {.count = 1, .reusable = true}, SHIFT(2605),
  [2915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2296),
  [2918] = {.count = 1, .reusable = false}, SHIFT(1319),
  [2920] = {.count = 1, .reusable = false}, SHIFT(1320),
  [2922] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2924] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_repeat1, 2), SHIFT_REPEAT(1321),
  [2927] = {.count = 1, .reusable = false}, SHIFT(1341),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1342),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2933] = {.count = 1, .reusable = false}, SHIFT(2290),
  [2935] = {.count = 1, .reusable = true}, SHIFT(393),
  [2937] = {.count = 1, .reusable = true}, SHIFT(402),
  [2939] = {.count = 1, .reusable = true}, SHIFT(403),
  [2941] = {.count = 1, .reusable = true}, SHIFT(404),
  [2943] = {.count = 1, .reusable = true}, SHIFT(406),
  [2945] = {.count = 1, .reusable = true}, SHIFT(410),
  [2947] = {.count = 1, .reusable = false}, SHIFT(1381),
  [2949] = {.count = 1, .reusable = true}, SHIFT(426),
  [2951] = {.count = 1, .reusable = true}, SHIFT(429),
  [2953] = {.count = 1, .reusable = true}, SHIFT(430),
  [2955] = {.count = 1, .reusable = false}, SHIFT(1389),
  [2957] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2959] = {.count = 1, .reusable = true}, SHIFT(431),
  [2961] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2963] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2965] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2967] = {.count = 1, .reusable = true}, SHIFT(432),
  [2969] = {.count = 1, .reusable = true}, SHIFT(1394),
  [2971] = {.count = 1, .reusable = true}, SHIFT(2416),
  [2973] = {.count = 1, .reusable = true}, SHIFT(438),
  [2975] = {.count = 1, .reusable = false}, SHIFT(437),
  [2977] = {.count = 1, .reusable = true}, SHIFT(439),
  [2979] = {.count = 1, .reusable = true}, SHIFT(444),
  [2981] = {.count = 1, .reusable = true}, SHIFT(445),
  [2983] = {.count = 1, .reusable = true}, SHIFT(1398),
  [2985] = {.count = 1, .reusable = true}, SHIFT(446),
  [2987] = {.count = 1, .reusable = false}, SHIFT(1969),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2991] = {.count = 1, .reusable = true}, SHIFT(447),
  [2993] = {.count = 1, .reusable = true}, SHIFT(449),
  [2995] = {.count = 1, .reusable = true}, SHIFT(452),
  [2997] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2999] = {.count = 1, .reusable = true}, SHIFT(1404),
  [3001] = {.count = 1, .reusable = true}, SHIFT(458),
  [3003] = {.count = 1, .reusable = true}, SHIFT(461),
  [3005] = {.count = 1, .reusable = false}, SHIFT(2009),
  [3007] = {.count = 1, .reusable = true}, SHIFT(1094),
  [3009] = {.count = 1, .reusable = false}, SHIFT(1407),
  [3011] = {.count = 1, .reusable = true}, SHIFT(472),
  [3013] = {.count = 1, .reusable = true}, SHIFT(1407),
  [3015] = {.count = 1, .reusable = true}, SHIFT(1406),
  [3017] = {.count = 1, .reusable = true}, SHIFT(1408),
  [3019] = {.count = 1, .reusable = false}, SHIFT(1411),
  [3021] = {.count = 1, .reusable = true}, SHIFT(1410),
  [3023] = {.count = 1, .reusable = true}, SHIFT(473),
  [3025] = {.count = 1, .reusable = true}, SHIFT(1411),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1412),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1416),
  [3031] = {.count = 1, .reusable = true}, SHIFT(474),
  [3033] = {.count = 1, .reusable = true}, SHIFT(1416),
  [3035] = {.count = 1, .reusable = true}, SHIFT(1415),
  [3037] = {.count = 1, .reusable = false}, SHIFT(477),
  [3039] = {.count = 1, .reusable = true}, SHIFT(478),
  [3041] = {.count = 1, .reusable = true}, SHIFT(482),
  [3043] = {.count = 1, .reusable = true}, SHIFT(484),
  [3045] = {.count = 1, .reusable = true}, SHIFT(1425),
  [3047] = {.count = 1, .reusable = true}, SHIFT(485),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1426),
  [3051] = {.count = 1, .reusable = true}, SHIFT(1427),
  [3053] = {.count = 1, .reusable = true}, SHIFT(486),
  [3055] = {.count = 1, .reusable = false}, SHIFT(488),
  [3057] = {.count = 1, .reusable = true}, SHIFT(489),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1429),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1430),
  [3063] = {.count = 1, .reusable = true}, SHIFT(492),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1430),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1431),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1432),
  [3071] = {.count = 1, .reusable = false}, SHIFT(1436),
  [3073] = {.count = 1, .reusable = true}, SHIFT(493),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1436),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1435),
  [3079] = {.count = 1, .reusable = true}, SHIFT(494),
  [3081] = {.count = 1, .reusable = false}, SHIFT(1437),
  [3083] = {.count = 1, .reusable = true}, SHIFT(495),
  [3085] = {.count = 1, .reusable = true}, SHIFT(1437),
  [3087] = {.count = 1, .reusable = true}, SHIFT(497),
  [3089] = {.count = 1, .reusable = false}, SHIFT(497),
  [3091] = {.count = 1, .reusable = true}, SHIFT(498),
  [3093] = {.count = 1, .reusable = false}, SHIFT(498),
  [3095] = {.count = 1, .reusable = false}, SHIFT(499),
  [3097] = {.count = 1, .reusable = false}, SHIFT(500),
  [3099] = {.count = 1, .reusable = true}, SHIFT(501),
  [3101] = {.count = 1, .reusable = true}, SHIFT(504),
  [3103] = {.count = 1, .reusable = true}, SHIFT(506),
  [3105] = {.count = 1, .reusable = false}, SHIFT(507),
  [3107] = {.count = 1, .reusable = true}, SHIFT(508),
  [3109] = {.count = 1, .reusable = true}, SHIFT(510),
  [3111] = {.count = 1, .reusable = false}, SHIFT(1446),
  [3113] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3115] = {.count = 1, .reusable = true}, SHIFT(511),
  [3117] = {.count = 1, .reusable = false}, SHIFT(1447),
  [3119] = {.count = 1, .reusable = true}, SHIFT(512),
  [3121] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3123] = {.count = 1, .reusable = true}, SHIFT(513),
  [3125] = {.count = 1, .reusable = true}, SHIFT(514),
  [3127] = {.count = 1, .reusable = false}, SHIFT(515),
  [3129] = {.count = 1, .reusable = true}, SHIFT(515),
  [3131] = {.count = 1, .reusable = false}, SHIFT(516),
  [3133] = {.count = 1, .reusable = true}, SHIFT(516),
  [3135] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3137] = {.count = 1, .reusable = true}, SHIFT(521),
  [3139] = {.count = 1, .reusable = true}, SHIFT(522),
  [3141] = {.count = 1, .reusable = true}, SHIFT(523),
  [3143] = {.count = 1, .reusable = true}, SHIFT(524),
  [3145] = {.count = 1, .reusable = true}, SHIFT(525),
  [3147] = {.count = 1, .reusable = true}, SHIFT(1455),
  [3149] = {.count = 1, .reusable = true}, SHIFT(527),
  [3151] = {.count = 1, .reusable = true}, SHIFT(528),
  [3153] = {.count = 1, .reusable = true}, SHIFT(1457),
  [3155] = {.count = 1, .reusable = true}, SHIFT(1459),
  [3157] = {.count = 1, .reusable = true}, SHIFT(615),
  [3159] = {.count = 1, .reusable = false}, SHIFT(615),
  [3161] = {.count = 1, .reusable = true}, SHIFT(622),
  [3163] = {.count = 1, .reusable = false}, SHIFT(622),
  [3165] = {.count = 1, .reusable = false}, SHIFT(986),
  [3167] = {.count = 1, .reusable = false}, SHIFT(1350),
  [3169] = {.count = 1, .reusable = true}, SHIFT(545),
  [3171] = {.count = 1, .reusable = true}, SHIFT(554),
  [3173] = {.count = 1, .reusable = true}, SHIFT(560),
  [3175] = {.count = 1, .reusable = false}, SHIFT(1483),
  [3177] = {.count = 1, .reusable = true}, SHIFT(576),
  [3179] = {.count = 1, .reusable = true}, SHIFT(577),
  [3181] = {.count = 1, .reusable = false}, SHIFT(1486),
  [3183] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3185] = {.count = 1, .reusable = true}, SHIFT(578),
  [3187] = {.count = 1, .reusable = true}, SHIFT(1486),
  [3189] = {.count = 1, .reusable = false}, SHIFT(1491),
  [3191] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3193] = {.count = 1, .reusable = true}, SHIFT(579),
  [3195] = {.count = 1, .reusable = true}, SHIFT(1491),
  [3197] = {.count = 1, .reusable = true}, SHIFT(587),
  [3199] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3201] = {.count = 1, .reusable = true}, SHIFT(588),
  [3203] = {.count = 1, .reusable = true}, SHIFT(631),
  [3205] = {.count = 1, .reusable = true}, SHIFT(589),
  [3207] = {.count = 1, .reusable = true}, SHIFT(591),
  [3209] = {.count = 1, .reusable = true}, SHIFT(594),
  [3211] = {.count = 1, .reusable = false}, SHIFT(1494),
  [3213] = {.count = 1, .reusable = false}, SHIFT(1496),
  [3215] = {.count = 1, .reusable = true}, SHIFT(606),
  [3217] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3219] = {.count = 1, .reusable = true}, SHIFT(1495),
  [3221] = {.count = 1, .reusable = true}, SHIFT(1497),
  [3223] = {.count = 1, .reusable = false}, SHIFT(1500),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1499),
  [3227] = {.count = 1, .reusable = true}, SHIFT(607),
  [3229] = {.count = 1, .reusable = true}, SHIFT(1500),
  [3231] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3233] = {.count = 1, .reusable = false}, SHIFT(1505),
  [3235] = {.count = 1, .reusable = true}, SHIFT(608),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1505),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1504),
  [3241] = {.count = 1, .reusable = true}, SHIFT(610),
  [3243] = {.count = 1, .reusable = true}, SHIFT(613),
  [3245] = {.count = 1, .reusable = true}, SHIFT(614),
  [3247] = {.count = 1, .reusable = false}, SHIFT(1507),
  [3249] = {.count = 1, .reusable = true}, SHIFT(617),
  [3251] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3253] = {.count = 1, .reusable = true}, SHIFT(1508),
  [3255] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1513),
  [3259] = {.count = 1, .reusable = true}, SHIFT(618),
  [3261] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3265] = {.count = 1, .reusable = true}, SHIFT(619),
  [3267] = {.count = 1, .reusable = false}, SHIFT(1514),
  [3269] = {.count = 1, .reusable = true}, SHIFT(620),
  [3271] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3273] = {.count = 1, .reusable = true}, SHIFT(621),
  [3275] = {.count = 1, .reusable = true}, SHIFT(623),
  [3277] = {.count = 1, .reusable = false}, SHIFT(1515),
  [3279] = {.count = 1, .reusable = true}, SHIFT(1515),
  [3281] = {.count = 1, .reusable = true}, SHIFT(624),
  [3283] = {.count = 1, .reusable = false}, SHIFT(1516),
  [3285] = {.count = 1, .reusable = true}, SHIFT(625),
  [3287] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3289] = {.count = 1, .reusable = true}, SHIFT(626),
  [3291] = {.count = 1, .reusable = true}, SHIFT(627),
  [3293] = {.count = 1, .reusable = true}, SHIFT(628),
  [3295] = {.count = 1, .reusable = true}, SHIFT(638),
  [3297] = {.count = 1, .reusable = true}, SHIFT(639),
  [3299] = {.count = 1, .reusable = true}, SHIFT(640),
  [3301] = {.count = 1, .reusable = false}, SHIFT(1527),
  [3303] = {.count = 1, .reusable = true}, SHIFT(642),
  [3305] = {.count = 1, .reusable = true}, SHIFT(653),
  [3307] = {.count = 1, .reusable = true}, SHIFT(654),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1529),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1530),
  [3313] = {.count = 1, .reusable = true}, SHIFT(655),
  [3315] = {.count = 1, .reusable = true}, SHIFT(1530),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1535),
  [3321] = {.count = 1, .reusable = true}, SHIFT(656),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3325] = {.count = 1, .reusable = true}, SHIFT(660),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3329] = {.count = 1, .reusable = true}, SHIFT(661),
  [3331] = {.count = 1, .reusable = true}, SHIFT(662),
  [3333] = {.count = 1, .reusable = true}, SHIFT(664),
  [3335] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3337] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3339] = {.count = 1, .reusable = true}, SHIFT(672),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3345] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1543),
  [3351] = {.count = 1, .reusable = true}, SHIFT(673),
  [3353] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3357] = {.count = 1, .reusable = false}, SHIFT(1548),
  [3359] = {.count = 1, .reusable = true}, SHIFT(674),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1548),
  [3363] = {.count = 1, .reusable = true}, SHIFT(1547),
  [3365] = {.count = 1, .reusable = true}, SHIFT(676),
  [3367] = {.count = 1, .reusable = true}, SHIFT(677),
  [3369] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3371] = {.count = 1, .reusable = true}, SHIFT(680),
  [3373] = {.count = 1, .reusable = true}, SHIFT(1550),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1551),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1552),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3381] = {.count = 1, .reusable = true}, SHIFT(681),
  [3383] = {.count = 1, .reusable = true}, SHIFT(1556),
  [3385] = {.count = 1, .reusable = true}, SHIFT(1555),
  [3387] = {.count = 1, .reusable = true}, SHIFT(682),
  [3389] = {.count = 1, .reusable = false}, SHIFT(1557),
  [3391] = {.count = 1, .reusable = true}, SHIFT(683),
  [3393] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3395] = {.count = 1, .reusable = true}, SHIFT(684),
  [3397] = {.count = 1, .reusable = true}, SHIFT(686),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1558),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1558),
  [3403] = {.count = 1, .reusable = true}, SHIFT(687),
  [3405] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3407] = {.count = 1, .reusable = true}, SHIFT(688),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1559),
  [3411] = {.count = 1, .reusable = true}, SHIFT(689),
  [3413] = {.count = 1, .reusable = true}, SHIFT(690),
  [3415] = {.count = 1, .reusable = true}, SHIFT(691),
  [3417] = {.count = 1, .reusable = true}, SHIFT(694),
  [3419] = {.count = 1, .reusable = true}, SHIFT(695),
  [3421] = {.count = 1, .reusable = true}, SHIFT(696),
  [3423] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3425] = {.count = 1, .reusable = true}, SHIFT(698),
  [3427] = {.count = 1, .reusable = true}, SHIFT(703),
  [3429] = {.count = 1, .reusable = true}, SHIFT(704),
  [3431] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3433] = {.count = 1, .reusable = false}, SHIFT(1573),
  [3435] = {.count = 1, .reusable = true}, SHIFT(705),
  [3437] = {.count = 1, .reusable = true}, SHIFT(1573),
  [3439] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3441] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3443] = {.count = 1, .reusable = true}, SHIFT(706),
  [3445] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3447] = {.count = 1, .reusable = true}, SHIFT(710),
  [3449] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3451] = {.count = 1, .reusable = true}, SHIFT(711),
  [3453] = {.count = 1, .reusable = true}, SHIFT(838),
  [3455] = {.count = 1, .reusable = true}, SHIFT(712),
  [3457] = {.count = 1, .reusable = true}, SHIFT(714),
  [3459] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3461] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3463] = {.count = 1, .reusable = true}, SHIFT(715),
  [3465] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3467] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3469] = {.count = 1, .reusable = true}, SHIFT(1583),
  [3471] = {.count = 1, .reusable = true}, SHIFT(1585),
  [3473] = {.count = 1, .reusable = false}, SHIFT(1586),
  [3475] = {.count = 1, .reusable = true}, SHIFT(716),
  [3477] = {.count = 1, .reusable = true}, SHIFT(1586),
  [3479] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3481] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3483] = {.count = 1, .reusable = true}, SHIFT(717),
  [3485] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3487] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3489] = {.count = 1, .reusable = true}, SHIFT(719),
  [3491] = {.count = 1, .reusable = true}, SHIFT(720),
  [3493] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3495] = {.count = 1, .reusable = true}, SHIFT(721),
  [3497] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3499] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3501] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3503] = {.count = 1, .reusable = false}, SHIFT(1599),
  [3505] = {.count = 1, .reusable = true}, SHIFT(722),
  [3507] = {.count = 1, .reusable = true}, SHIFT(1599),
  [3509] = {.count = 1, .reusable = true}, SHIFT(1598),
  [3511] = {.count = 1, .reusable = true}, SHIFT(723),
  [3513] = {.count = 1, .reusable = false}, SHIFT(1600),
  [3515] = {.count = 1, .reusable = true}, SHIFT(724),
  [3517] = {.count = 1, .reusable = true}, SHIFT(1600),
  [3519] = {.count = 1, .reusable = true}, SHIFT(725),
  [3521] = {.count = 1, .reusable = true}, SHIFT(726),
  [3523] = {.count = 1, .reusable = false}, SHIFT(1601),
  [3525] = {.count = 1, .reusable = true}, SHIFT(1601),
  [3527] = {.count = 1, .reusable = true}, SHIFT(727),
  [3529] = {.count = 1, .reusable = false}, SHIFT(1602),
  [3531] = {.count = 1, .reusable = true}, SHIFT(728),
  [3533] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3535] = {.count = 1, .reusable = true}, SHIFT(729),
  [3537] = {.count = 1, .reusable = true}, SHIFT(730),
  [3539] = {.count = 1, .reusable = true}, SHIFT(731),
  [3541] = {.count = 1, .reusable = true}, SHIFT(733),
  [3543] = {.count = 1, .reusable = true}, SHIFT(734),
  [3545] = {.count = 1, .reusable = true}, SHIFT(735),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1613),
  [3549] = {.count = 1, .reusable = true}, SHIFT(737),
  [3551] = {.count = 1, .reusable = true}, SHIFT(740),
  [3553] = {.count = 1, .reusable = true}, SHIFT(741),
  [3555] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3557] = {.count = 1, .reusable = false}, SHIFT(1616),
  [3559] = {.count = 1, .reusable = true}, SHIFT(742),
  [3561] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3565] = {.count = 1, .reusable = false}, SHIFT(1621),
  [3567] = {.count = 1, .reusable = true}, SHIFT(743),
  [3569] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3571] = {.count = 1, .reusable = true}, SHIFT(747),
  [3573] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3575] = {.count = 1, .reusable = true}, SHIFT(748),
  [3577] = {.count = 1, .reusable = false}, SHIFT(2289),
  [3579] = {.count = 1, .reusable = true}, SHIFT(1318),
  [3581] = {.count = 1, .reusable = true}, SHIFT(749),
  [3583] = {.count = 1, .reusable = true}, SHIFT(751),
  [3585] = {.count = 1, .reusable = false}, SHIFT(1623),
  [3587] = {.count = 1, .reusable = false}, SHIFT(1625),
  [3589] = {.count = 1, .reusable = true}, SHIFT(752),
  [3591] = {.count = 1, .reusable = true}, SHIFT(1625),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3595] = {.count = 1, .reusable = true}, SHIFT(1626),
  [3597] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3599] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3601] = {.count = 1, .reusable = true}, SHIFT(753),
  [3603] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3605] = {.count = 1, .reusable = true}, SHIFT(1630),
  [3607] = {.count = 1, .reusable = false}, SHIFT(1634),
  [3609] = {.count = 1, .reusable = true}, SHIFT(754),
  [3611] = {.count = 1, .reusable = true}, SHIFT(1634),
  [3613] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3615] = {.count = 1, .reusable = true}, SHIFT(756),
  [3617] = {.count = 1, .reusable = true}, SHIFT(757),
  [3619] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3621] = {.count = 1, .reusable = true}, SHIFT(758),
  [3623] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3625] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3627] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3629] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3631] = {.count = 1, .reusable = true}, SHIFT(759),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3637] = {.count = 1, .reusable = true}, SHIFT(760),
  [3639] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3641] = {.count = 1, .reusable = true}, SHIFT(761),
  [3643] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3645] = {.count = 1, .reusable = true}, SHIFT(762),
  [3647] = {.count = 1, .reusable = true}, SHIFT(763),
  [3649] = {.count = 1, .reusable = false}, SHIFT(1644),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1644),
  [3653] = {.count = 1, .reusable = true}, SHIFT(764),
  [3655] = {.count = 1, .reusable = false}, SHIFT(1645),
  [3657] = {.count = 1, .reusable = true}, SHIFT(765),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1645),
  [3661] = {.count = 1, .reusable = true}, SHIFT(766),
  [3663] = {.count = 1, .reusable = true}, SHIFT(767),
  [3665] = {.count = 1, .reusable = true}, SHIFT(768),
  [3667] = {.count = 1, .reusable = true}, SHIFT(774),
  [3669] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3671] = {.count = 1, .reusable = true}, SHIFT(777),
  [3673] = {.count = 1, .reusable = true}, SHIFT(778),
  [3675] = {.count = 1, .reusable = false}, SHIFT(1659),
  [3677] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3679] = {.count = 1, .reusable = true}, SHIFT(779),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3683] = {.count = 1, .reusable = false}, SHIFT(1664),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3687] = {.count = 1, .reusable = true}, SHIFT(780),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3691] = {.count = 1, .reusable = true}, SHIFT(784),
  [3693] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3695] = {.count = 1, .reusable = true}, SHIFT(785),
  [3697] = {.count = 1, .reusable = true}, SHIFT(1254),
  [3699] = {.count = 1, .reusable = true}, SHIFT(786),
  [3701] = {.count = 1, .reusable = true}, SHIFT(788),
  [3703] = {.count = 1, .reusable = false}, SHIFT(1666),
  [3705] = {.count = 1, .reusable = false}, SHIFT(1668),
  [3707] = {.count = 1, .reusable = true}, SHIFT(789),
  [3709] = {.count = 1, .reusable = true}, SHIFT(1668),
  [3711] = {.count = 1, .reusable = true}, SHIFT(1667),
  [3713] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3715] = {.count = 1, .reusable = false}, SHIFT(1672),
  [3717] = {.count = 1, .reusable = true}, SHIFT(1671),
  [3719] = {.count = 1, .reusable = true}, SHIFT(790),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3725] = {.count = 1, .reusable = false}, SHIFT(1677),
  [3727] = {.count = 1, .reusable = true}, SHIFT(791),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1677),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1676),
  [3733] = {.count = 1, .reusable = true}, SHIFT(793),
  [3735] = {.count = 1, .reusable = true}, SHIFT(794),
  [3737] = {.count = 1, .reusable = false}, SHIFT(1679),
  [3739] = {.count = 1, .reusable = true}, SHIFT(795),
  [3741] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3743] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3745] = {.count = 1, .reusable = true}, SHIFT(1681),
  [3747] = {.count = 1, .reusable = false}, SHIFT(1685),
  [3749] = {.count = 1, .reusable = true}, SHIFT(796),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1685),
  [3753] = {.count = 1, .reusable = true}, SHIFT(1684),
  [3755] = {.count = 1, .reusable = true}, SHIFT(797),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1686),
  [3759] = {.count = 1, .reusable = true}, SHIFT(798),
  [3761] = {.count = 1, .reusable = true}, SHIFT(1686),
  [3763] = {.count = 1, .reusable = true}, SHIFT(799),
  [3765] = {.count = 1, .reusable = true}, SHIFT(800),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1687),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3771] = {.count = 1, .reusable = true}, SHIFT(801),
  [3773] = {.count = 1, .reusable = false}, SHIFT(1688),
  [3775] = {.count = 1, .reusable = true}, SHIFT(802),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1688),
  [3779] = {.count = 1, .reusable = true}, SHIFT(803),
  [3781] = {.count = 1, .reusable = true}, SHIFT(804),
  [3783] = {.count = 1, .reusable = true}, SHIFT(805),
  [3785] = {.count = 1, .reusable = true}, SHIFT(811),
  [3787] = {.count = 1, .reusable = false}, SHIFT(1698),
  [3789] = {.count = 1, .reusable = true}, SHIFT(814),
  [3791] = {.count = 1, .reusable = true}, SHIFT(815),
  [3793] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3795] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3797] = {.count = 1, .reusable = true}, SHIFT(816),
  [3799] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3801] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3803] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3805] = {.count = 1, .reusable = true}, SHIFT(817),
  [3807] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3809] = {.count = 1, .reusable = true}, SHIFT(821),
  [3811] = {.count = 1, .reusable = true}, SHIFT(822),
  [3813] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3815] = {.count = 1, .reusable = false}, SHIFT(1709),
  [3817] = {.count = 1, .reusable = true}, SHIFT(823),
  [3819] = {.count = 1, .reusable = true}, SHIFT(1709),
  [3821] = {.count = 1, .reusable = true}, SHIFT(1708),
  [3823] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3825] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3827] = {.count = 1, .reusable = false}, SHIFT(1713),
  [3829] = {.count = 1, .reusable = true}, SHIFT(824),
  [3831] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3833] = {.count = 1, .reusable = true}, SHIFT(1714),
  [3835] = {.count = 1, .reusable = false}, SHIFT(1718),
  [3837] = {.count = 1, .reusable = true}, SHIFT(825),
  [3839] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3841] = {.count = 1, .reusable = true}, SHIFT(1717),
  [3843] = {.count = 1, .reusable = true}, SHIFT(827),
  [3845] = {.count = 1, .reusable = false}, SHIFT(1719),
  [3847] = {.count = 1, .reusable = true}, SHIFT(828),
  [3849] = {.count = 1, .reusable = true}, SHIFT(1719),
  [3851] = {.count = 1, .reusable = true}, SHIFT(1720),
  [3853] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3855] = {.count = 1, .reusable = false}, SHIFT(1725),
  [3857] = {.count = 1, .reusable = true}, SHIFT(829),
  [3859] = {.count = 1, .reusable = true}, SHIFT(1725),
  [3861] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3863] = {.count = 1, .reusable = true}, SHIFT(830),
  [3865] = {.count = 1, .reusable = false}, SHIFT(1726),
  [3867] = {.count = 1, .reusable = true}, SHIFT(831),
  [3869] = {.count = 1, .reusable = true}, SHIFT(1726),
  [3871] = {.count = 1, .reusable = true}, SHIFT(832),
  [3873] = {.count = 1, .reusable = false}, SHIFT(1727),
  [3875] = {.count = 1, .reusable = true}, SHIFT(1727),
  [3877] = {.count = 1, .reusable = true}, SHIFT(833),
  [3879] = {.count = 1, .reusable = false}, SHIFT(1728),
  [3881] = {.count = 1, .reusable = true}, SHIFT(834),
  [3883] = {.count = 1, .reusable = true}, SHIFT(1728),
  [3885] = {.count = 1, .reusable = true}, SHIFT(835),
  [3887] = {.count = 1, .reusable = true}, SHIFT(836),
  [3889] = {.count = 1, .reusable = true}, SHIFT(837),
  [3891] = {.count = 1, .reusable = true}, SHIFT(871),
  [3893] = {.count = 1, .reusable = true}, SHIFT(840),
  [3895] = {.count = 1, .reusable = true}, SHIFT(873),
  [3897] = {.count = 1, .reusable = true}, SHIFT(843),
  [3899] = {.count = 1, .reusable = false}, SHIFT(1738),
  [3901] = {.count = 1, .reusable = true}, SHIFT(846),
  [3903] = {.count = 1, .reusable = true}, SHIFT(847),
  [3905] = {.count = 1, .reusable = false}, SHIFT(1741),
  [3907] = {.count = 1, .reusable = true}, SHIFT(1740),
  [3909] = {.count = 1, .reusable = true}, SHIFT(848),
  [3911] = {.count = 1, .reusable = true}, SHIFT(1741),
  [3913] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3915] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3917] = {.count = 1, .reusable = true}, SHIFT(849),
  [3919] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3921] = {.count = 1, .reusable = true}, SHIFT(853),
  [3923] = {.count = 1, .reusable = true}, SHIFT(854),
  [3925] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3927] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3929] = {.count = 1, .reusable = true}, SHIFT(855),
  [3931] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3933] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3935] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3937] = {.count = 1, .reusable = false}, SHIFT(1753),
  [3939] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3941] = {.count = 1, .reusable = true}, SHIFT(856),
  [3943] = {.count = 1, .reusable = true}, SHIFT(1753),
  [3945] = {.count = 1, .reusable = true}, SHIFT(1754),
  [3947] = {.count = 1, .reusable = false}, SHIFT(1758),
  [3949] = {.count = 1, .reusable = true}, SHIFT(857),
  [3951] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3953] = {.count = 1, .reusable = true}, SHIFT(1757),
  [3955] = {.count = 1, .reusable = true}, SHIFT(859),
  [3957] = {.count = 1, .reusable = false}, SHIFT(1759),
  [3959] = {.count = 1, .reusable = true}, SHIFT(860),
  [3961] = {.count = 1, .reusable = true}, SHIFT(1759),
  [3963] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3965] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3967] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3969] = {.count = 1, .reusable = true}, SHIFT(861),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3975] = {.count = 1, .reusable = true}, SHIFT(862),
  [3977] = {.count = 1, .reusable = false}, SHIFT(1766),
  [3979] = {.count = 1, .reusable = true}, SHIFT(863),
  [3981] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3983] = {.count = 1, .reusable = true}, SHIFT(864),
  [3985] = {.count = 1, .reusable = false}, SHIFT(1767),
  [3987] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3989] = {.count = 1, .reusable = true}, SHIFT(865),
  [3991] = {.count = 1, .reusable = false}, SHIFT(1768),
  [3993] = {.count = 1, .reusable = true}, SHIFT(866),
  [3995] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3997] = {.count = 1, .reusable = true}, SHIFT(867),
  [3999] = {.count = 1, .reusable = true}, SHIFT(868),
  [4001] = {.count = 1, .reusable = true}, SHIFT(869),
  [4003] = {.count = 1, .reusable = true}, SHIFT(903),
  [4005] = {.count = 1, .reusable = true}, SHIFT(872),
  [4007] = {.count = 1, .reusable = true}, SHIFT(905),
  [4009] = {.count = 1, .reusable = true}, SHIFT(875),
  [4011] = {.count = 1, .reusable = false}, SHIFT(1778),
  [4013] = {.count = 1, .reusable = true}, SHIFT(878),
  [4015] = {.count = 1, .reusable = true}, SHIFT(879),
  [4017] = {.count = 1, .reusable = false}, SHIFT(1781),
  [4019] = {.count = 1, .reusable = true}, SHIFT(1780),
  [4021] = {.count = 1, .reusable = true}, SHIFT(880),
  [4023] = {.count = 1, .reusable = true}, SHIFT(1781),
  [4025] = {.count = 1, .reusable = false}, SHIFT(1786),
  [4027] = {.count = 1, .reusable = true}, SHIFT(1785),
  [4029] = {.count = 1, .reusable = true}, SHIFT(881),
  [4031] = {.count = 1, .reusable = true}, SHIFT(1786),
  [4033] = {.count = 1, .reusable = true}, SHIFT(885),
  [4035] = {.count = 1, .reusable = true}, SHIFT(886),
  [4037] = {.count = 1, .reusable = false}, SHIFT(1787),
  [4039] = {.count = 1, .reusable = false}, SHIFT(1789),
  [4041] = {.count = 1, .reusable = true}, SHIFT(887),
  [4043] = {.count = 1, .reusable = true}, SHIFT(1789),
  [4045] = {.count = 1, .reusable = true}, SHIFT(1788),
  [4047] = {.count = 1, .reusable = true}, SHIFT(1790),
  [4049] = {.count = 1, .reusable = false}, SHIFT(1793),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1792),
  [4053] = {.count = 1, .reusable = true}, SHIFT(888),
  [4055] = {.count = 1, .reusable = true}, SHIFT(1793),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1794),
  [4059] = {.count = 1, .reusable = false}, SHIFT(1798),
  [4061] = {.count = 1, .reusable = true}, SHIFT(889),
  [4063] = {.count = 1, .reusable = true}, SHIFT(1798),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1797),
  [4067] = {.count = 1, .reusable = true}, SHIFT(891),
  [4069] = {.count = 1, .reusable = false}, SHIFT(1799),
  [4071] = {.count = 1, .reusable = true}, SHIFT(892),
  [4073] = {.count = 1, .reusable = true}, SHIFT(1799),
  [4075] = {.count = 1, .reusable = true}, SHIFT(1800),
  [4077] = {.count = 1, .reusable = true}, SHIFT(1801),
  [4079] = {.count = 1, .reusable = false}, SHIFT(1805),
  [4081] = {.count = 1, .reusable = true}, SHIFT(893),
  [4083] = {.count = 1, .reusable = true}, SHIFT(1805),
  [4085] = {.count = 1, .reusable = true}, SHIFT(1804),
  [4087] = {.count = 1, .reusable = true}, SHIFT(894),
  [4089] = {.count = 1, .reusable = false}, SHIFT(1806),
  [4091] = {.count = 1, .reusable = true}, SHIFT(895),
  [4093] = {.count = 1, .reusable = true}, SHIFT(1806),
  [4095] = {.count = 1, .reusable = true}, SHIFT(896),
  [4097] = {.count = 1, .reusable = false}, SHIFT(1807),
  [4099] = {.count = 1, .reusable = true}, SHIFT(1807),
  [4101] = {.count = 1, .reusable = true}, SHIFT(897),
  [4103] = {.count = 1, .reusable = false}, SHIFT(1808),
  [4105] = {.count = 1, .reusable = true}, SHIFT(898),
  [4107] = {.count = 1, .reusable = true}, SHIFT(1808),
  [4109] = {.count = 1, .reusable = true}, SHIFT(899),
  [4111] = {.count = 1, .reusable = true}, SHIFT(900),
  [4113] = {.count = 1, .reusable = true}, SHIFT(901),
  [4115] = {.count = 1, .reusable = true}, SHIFT(935),
  [4117] = {.count = 1, .reusable = false}, SHIFT(1818),
  [4119] = {.count = 1, .reusable = true}, SHIFT(907),
  [4121] = {.count = 1, .reusable = true}, SHIFT(910),
  [4123] = {.count = 1, .reusable = true}, SHIFT(911),
  [4125] = {.count = 1, .reusable = false}, SHIFT(1821),
  [4127] = {.count = 1, .reusable = true}, SHIFT(1820),
  [4129] = {.count = 1, .reusable = true}, SHIFT(912),
  [4131] = {.count = 1, .reusable = true}, SHIFT(1821),
  [4133] = {.count = 1, .reusable = false}, SHIFT(1826),
  [4135] = {.count = 1, .reusable = true}, SHIFT(1825),
  [4137] = {.count = 1, .reusable = true}, SHIFT(913),
  [4139] = {.count = 1, .reusable = true}, SHIFT(1826),
  [4141] = {.count = 1, .reusable = true}, SHIFT(917),
  [4143] = {.count = 1, .reusable = true}, SHIFT(918),
  [4145] = {.count = 1, .reusable = false}, SHIFT(1827),
  [4147] = {.count = 1, .reusable = false}, SHIFT(1829),
  [4149] = {.count = 1, .reusable = true}, SHIFT(919),
  [4151] = {.count = 1, .reusable = true}, SHIFT(1829),
  [4153] = {.count = 1, .reusable = true}, SHIFT(1828),
  [4155] = {.count = 1, .reusable = true}, SHIFT(1830),
  [4157] = {.count = 1, .reusable = false}, SHIFT(1833),
  [4159] = {.count = 1, .reusable = true}, SHIFT(1832),
  [4161] = {.count = 1, .reusable = true}, SHIFT(920),
  [4163] = {.count = 1, .reusable = true}, SHIFT(1833),
  [4165] = {.count = 1, .reusable = true}, SHIFT(1834),
  [4167] = {.count = 1, .reusable = false}, SHIFT(1838),
  [4169] = {.count = 1, .reusable = true}, SHIFT(921),
  [4171] = {.count = 1, .reusable = true}, SHIFT(1838),
  [4173] = {.count = 1, .reusable = true}, SHIFT(1837),
  [4175] = {.count = 1, .reusable = true}, SHIFT(923),
  [4177] = {.count = 1, .reusable = false}, SHIFT(1839),
  [4179] = {.count = 1, .reusable = true}, SHIFT(924),
  [4181] = {.count = 1, .reusable = true}, SHIFT(1839),
  [4183] = {.count = 1, .reusable = true}, SHIFT(1840),
  [4185] = {.count = 1, .reusable = true}, SHIFT(1841),
  [4187] = {.count = 1, .reusable = false}, SHIFT(1845),
  [4189] = {.count = 1, .reusable = true}, SHIFT(925),
  [4191] = {.count = 1, .reusable = true}, SHIFT(1845),
  [4193] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4195] = {.count = 1, .reusable = true}, SHIFT(926),
  [4197] = {.count = 1, .reusable = false}, SHIFT(1846),
  [4199] = {.count = 1, .reusable = true}, SHIFT(927),
  [4201] = {.count = 1, .reusable = true}, SHIFT(1846),
  [4203] = {.count = 1, .reusable = true}, SHIFT(928),
  [4205] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4207] = {.count = 1, .reusable = true}, SHIFT(1847),
  [4209] = {.count = 1, .reusable = true}, SHIFT(929),
  [4211] = {.count = 1, .reusable = false}, SHIFT(1848),
  [4213] = {.count = 1, .reusable = true}, SHIFT(930),
  [4215] = {.count = 1, .reusable = true}, SHIFT(1848),
  [4217] = {.count = 1, .reusable = true}, SHIFT(931),
  [4219] = {.count = 1, .reusable = true}, SHIFT(932),
  [4221] = {.count = 1, .reusable = true}, SHIFT(933),
  [4223] = {.count = 1, .reusable = true}, SHIFT(967),
  [4225] = {.count = 1, .reusable = true}, SHIFT(936),
  [4227] = {.count = 1, .reusable = true}, SHIFT(969),
  [4229] = {.count = 1, .reusable = false}, SHIFT(1858),
  [4231] = {.count = 1, .reusable = true}, SHIFT(939),
  [4233] = {.count = 1, .reusable = true}, SHIFT(942),
  [4235] = {.count = 1, .reusable = true}, SHIFT(943),
  [4237] = {.count = 1, .reusable = true}, SHIFT(1860),
  [4239] = {.count = 1, .reusable = false}, SHIFT(1861),
  [4241] = {.count = 1, .reusable = true}, SHIFT(944),
  [4243] = {.count = 1, .reusable = true}, SHIFT(1861),
  [4245] = {.count = 1, .reusable = true}, SHIFT(1865),
  [4247] = {.count = 1, .reusable = false}, SHIFT(1866),
  [4249] = {.count = 1, .reusable = true}, SHIFT(945),
  [4251] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4253] = {.count = 1, .reusable = true}, SHIFT(949),
  [4255] = {.count = 1, .reusable = true}, SHIFT(950),
  [4257] = {.count = 1, .reusable = false}, SHIFT(1867),
  [4259] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4261] = {.count = 1, .reusable = true}, SHIFT(951),
  [4263] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4265] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4267] = {.count = 1, .reusable = true}, SHIFT(1870),
  [4269] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4271] = {.count = 1, .reusable = false}, SHIFT(1873),
  [4273] = {.count = 1, .reusable = true}, SHIFT(952),
  [4275] = {.count = 1, .reusable = true}, SHIFT(1873),
  [4277] = {.count = 1, .reusable = true}, SHIFT(1874),
  [4279] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4281] = {.count = 1, .reusable = true}, SHIFT(953),
  [4283] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4285] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4287] = {.count = 1, .reusable = true}, SHIFT(955),
  [4289] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4291] = {.count = 1, .reusable = true}, SHIFT(956),
  [4293] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4295] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4297] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4299] = {.count = 1, .reusable = false}, SHIFT(1885),
  [4301] = {.count = 1, .reusable = true}, SHIFT(957),
  [4303] = {.count = 1, .reusable = true}, SHIFT(1885),
  [4305] = {.count = 1, .reusable = true}, SHIFT(1884),
  [4307] = {.count = 1, .reusable = true}, SHIFT(958),
  [4309] = {.count = 1, .reusable = false}, SHIFT(1886),
  [4311] = {.count = 1, .reusable = true}, SHIFT(959),
  [4313] = {.count = 1, .reusable = true}, SHIFT(1886),
  [4315] = {.count = 1, .reusable = true}, SHIFT(960),
  [4317] = {.count = 1, .reusable = false}, SHIFT(1887),
  [4319] = {.count = 1, .reusable = true}, SHIFT(1887),
  [4321] = {.count = 1, .reusable = true}, SHIFT(961),
  [4323] = {.count = 1, .reusable = false}, SHIFT(1888),
  [4325] = {.count = 1, .reusable = true}, SHIFT(962),
  [4327] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4329] = {.count = 1, .reusable = true}, SHIFT(963),
  [4331] = {.count = 1, .reusable = true}, SHIFT(964),
  [4333] = {.count = 1, .reusable = true}, SHIFT(965),
  [4335] = {.count = 1, .reusable = true}, SHIFT(999),
  [4337] = {.count = 1, .reusable = true}, SHIFT(968),
  [4339] = {.count = 1, .reusable = true}, SHIFT(1001),
  [4341] = {.count = 1, .reusable = false}, SHIFT(1898),
  [4343] = {.count = 1, .reusable = true}, SHIFT(971),
  [4345] = {.count = 1, .reusable = true}, SHIFT(974),
  [4347] = {.count = 1, .reusable = true}, SHIFT(975),
  [4349] = {.count = 1, .reusable = true}, SHIFT(1900),
  [4351] = {.count = 1, .reusable = false}, SHIFT(1901),
  [4353] = {.count = 1, .reusable = true}, SHIFT(976),
  [4355] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4357] = {.count = 1, .reusable = true}, SHIFT(1905),
  [4359] = {.count = 1, .reusable = false}, SHIFT(1906),
  [4361] = {.count = 1, .reusable = true}, SHIFT(977),
  [4363] = {.count = 1, .reusable = true}, SHIFT(1906),
  [4365] = {.count = 1, .reusable = true}, SHIFT(981),
  [4367] = {.count = 1, .reusable = true}, SHIFT(982),
  [4369] = {.count = 1, .reusable = false}, SHIFT(1907),
  [4371] = {.count = 1, .reusable = false}, SHIFT(1909),
  [4373] = {.count = 1, .reusable = true}, SHIFT(983),
  [4375] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4377] = {.count = 1, .reusable = true}, SHIFT(1908),
  [4379] = {.count = 1, .reusable = true}, SHIFT(1910),
  [4381] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4383] = {.count = 1, .reusable = false}, SHIFT(1913),
  [4385] = {.count = 1, .reusable = true}, SHIFT(984),
  [4387] = {.count = 1, .reusable = true}, SHIFT(1913),
  [4389] = {.count = 1, .reusable = true}, SHIFT(1914),
  [4391] = {.count = 1, .reusable = false}, SHIFT(1918),
  [4393] = {.count = 1, .reusable = true}, SHIFT(985),
  [4395] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4397] = {.count = 1, .reusable = true}, SHIFT(1917),
  [4399] = {.count = 1, .reusable = true}, SHIFT(987),
  [4401] = {.count = 1, .reusable = false}, SHIFT(1919),
  [4403] = {.count = 1, .reusable = true}, SHIFT(988),
  [4405] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4407] = {.count = 1, .reusable = true}, SHIFT(1920),
  [4409] = {.count = 1, .reusable = true}, SHIFT(1921),
  [4411] = {.count = 1, .reusable = false}, SHIFT(1925),
  [4413] = {.count = 1, .reusable = true}, SHIFT(989),
  [4415] = {.count = 1, .reusable = true}, SHIFT(1925),
  [4417] = {.count = 1, .reusable = true}, SHIFT(1924),
  [4419] = {.count = 1, .reusable = true}, SHIFT(990),
  [4421] = {.count = 1, .reusable = false}, SHIFT(1926),
  [4423] = {.count = 1, .reusable = true}, SHIFT(991),
  [4425] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4427] = {.count = 1, .reusable = true}, SHIFT(992),
  [4429] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4431] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4433] = {.count = 1, .reusable = true}, SHIFT(993),
  [4435] = {.count = 1, .reusable = false}, SHIFT(1928),
  [4437] = {.count = 1, .reusable = true}, SHIFT(994),
  [4439] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4441] = {.count = 1, .reusable = true}, SHIFT(995),
  [4443] = {.count = 1, .reusable = true}, SHIFT(996),
  [4445] = {.count = 1, .reusable = true}, SHIFT(997),
  [4447] = {.count = 1, .reusable = true}, SHIFT(1031),
  [4449] = {.count = 1, .reusable = true}, SHIFT(1000),
  [4451] = {.count = 1, .reusable = true}, SHIFT(1033),
  [4453] = {.count = 1, .reusable = false}, SHIFT(1938),
  [4455] = {.count = 1, .reusable = true}, SHIFT(1003),
  [4457] = {.count = 1, .reusable = true}, SHIFT(1006),
  [4459] = {.count = 1, .reusable = true}, SHIFT(1007),
  [4461] = {.count = 1, .reusable = true}, SHIFT(1940),
  [4463] = {.count = 1, .reusable = false}, SHIFT(1941),
  [4465] = {.count = 1, .reusable = true}, SHIFT(1008),
  [4467] = {.count = 1, .reusable = true}, SHIFT(1941),
  [4469] = {.count = 1, .reusable = true}, SHIFT(1945),
  [4471] = {.count = 1, .reusable = false}, SHIFT(1946),
  [4473] = {.count = 1, .reusable = true}, SHIFT(1009),
  [4475] = {.count = 1, .reusable = true}, SHIFT(1946),
  [4477] = {.count = 1, .reusable = true}, SHIFT(1013),
  [4479] = {.count = 1, .reusable = true}, SHIFT(1014),
  [4481] = {.count = 1, .reusable = false}, SHIFT(1947),
  [4483] = {.count = 1, .reusable = false}, SHIFT(1949),
  [4485] = {.count = 1, .reusable = true}, SHIFT(1015),
  [4487] = {.count = 1, .reusable = true}, SHIFT(1949),
  [4489] = {.count = 1, .reusable = true}, SHIFT(1948),
  [4491] = {.count = 1, .reusable = true}, SHIFT(1950),
  [4493] = {.count = 1, .reusable = true}, SHIFT(1952),
  [4495] = {.count = 1, .reusable = false}, SHIFT(1953),
  [4497] = {.count = 1, .reusable = true}, SHIFT(1016),
  [4499] = {.count = 1, .reusable = true}, SHIFT(1953),
  [4501] = {.count = 1, .reusable = true}, SHIFT(1954),
  [4503] = {.count = 1, .reusable = false}, SHIFT(1958),
  [4505] = {.count = 1, .reusable = true}, SHIFT(1017),
  [4507] = {.count = 1, .reusable = true}, SHIFT(1958),
  [4509] = {.count = 1, .reusable = true}, SHIFT(1957),
  [4511] = {.count = 1, .reusable = true}, SHIFT(1019),
  [4513] = {.count = 1, .reusable = false}, SHIFT(1959),
  [4515] = {.count = 1, .reusable = true}, SHIFT(1020),
  [4517] = {.count = 1, .reusable = true}, SHIFT(1959),
  [4519] = {.count = 1, .reusable = true}, SHIFT(1960),
  [4521] = {.count = 1, .reusable = true}, SHIFT(1961),
  [4523] = {.count = 1, .reusable = false}, SHIFT(1965),
  [4525] = {.count = 1, .reusable = true}, SHIFT(1021),
  [4527] = {.count = 1, .reusable = true}, SHIFT(1965),
  [4529] = {.count = 1, .reusable = true}, SHIFT(1964),
  [4531] = {.count = 1, .reusable = true}, SHIFT(1022),
  [4533] = {.count = 1, .reusable = false}, SHIFT(1966),
  [4535] = {.count = 1, .reusable = true}, SHIFT(1023),
  [4537] = {.count = 1, .reusable = true}, SHIFT(1966),
  [4539] = {.count = 1, .reusable = true}, SHIFT(1024),
  [4541] = {.count = 1, .reusable = false}, SHIFT(1967),
  [4543] = {.count = 1, .reusable = true}, SHIFT(1967),
  [4545] = {.count = 1, .reusable = true}, SHIFT(1025),
  [4547] = {.count = 1, .reusable = false}, SHIFT(1968),
  [4549] = {.count = 1, .reusable = true}, SHIFT(1026),
  [4551] = {.count = 1, .reusable = true}, SHIFT(1968),
  [4553] = {.count = 1, .reusable = true}, SHIFT(1027),
  [4555] = {.count = 1, .reusable = true}, SHIFT(1028),
  [4557] = {.count = 1, .reusable = true}, SHIFT(1029),
  [4559] = {.count = 1, .reusable = true}, SHIFT(1063),
  [4561] = {.count = 1, .reusable = true}, SHIFT(1032),
  [4563] = {.count = 1, .reusable = true}, SHIFT(1065),
  [4565] = {.count = 1, .reusable = true}, SHIFT(1035),
  [4567] = {.count = 1, .reusable = false}, SHIFT(1978),
  [4569] = {.count = 1, .reusable = true}, SHIFT(1038),
  [4571] = {.count = 1, .reusable = true}, SHIFT(1039),
  [4573] = {.count = 1, .reusable = true}, SHIFT(1980),
  [4575] = {.count = 1, .reusable = false}, SHIFT(1981),
  [4577] = {.count = 1, .reusable = true}, SHIFT(1040),
  [4579] = {.count = 1, .reusable = true}, SHIFT(1981),
  [4581] = {.count = 1, .reusable = true}, SHIFT(1985),
  [4583] = {.count = 1, .reusable = false}, SHIFT(1986),
  [4585] = {.count = 1, .reusable = true}, SHIFT(1041),
  [4587] = {.count = 1, .reusable = true}, SHIFT(1986),
  [4589] = {.count = 1, .reusable = true}, SHIFT(1045),
  [4591] = {.count = 1, .reusable = true}, SHIFT(1046),
  [4593] = {.count = 1, .reusable = false}, SHIFT(1987),
  [4595] = {.count = 1, .reusable = false}, SHIFT(1989),
  [4597] = {.count = 1, .reusable = true}, SHIFT(1047),
  [4599] = {.count = 1, .reusable = true}, SHIFT(1989),
  [4601] = {.count = 1, .reusable = true}, SHIFT(1988),
  [4603] = {.count = 1, .reusable = true}, SHIFT(1990),
  [4605] = {.count = 1, .reusable = true}, SHIFT(1992),
  [4607] = {.count = 1, .reusable = false}, SHIFT(1993),
  [4609] = {.count = 1, .reusable = true}, SHIFT(1048),
  [4611] = {.count = 1, .reusable = true}, SHIFT(1993),
  [4613] = {.count = 1, .reusable = true}, SHIFT(1994),
  [4615] = {.count = 1, .reusable = false}, SHIFT(1998),
  [4617] = {.count = 1, .reusable = true}, SHIFT(1049),
  [4619] = {.count = 1, .reusable = true}, SHIFT(1998),
  [4621] = {.count = 1, .reusable = true}, SHIFT(1997),
  [4623] = {.count = 1, .reusable = true}, SHIFT(1051),
  [4625] = {.count = 1, .reusable = false}, SHIFT(1999),
  [4627] = {.count = 1, .reusable = true}, SHIFT(1052),
  [4629] = {.count = 1, .reusable = true}, SHIFT(1999),
  [4631] = {.count = 1, .reusable = true}, SHIFT(2000),
  [4633] = {.count = 1, .reusable = true}, SHIFT(2001),
  [4635] = {.count = 1, .reusable = false}, SHIFT(2005),
  [4637] = {.count = 1, .reusable = true}, SHIFT(1053),
  [4639] = {.count = 1, .reusable = true}, SHIFT(2005),
  [4641] = {.count = 1, .reusable = true}, SHIFT(2004),
  [4643] = {.count = 1, .reusable = true}, SHIFT(1054),
  [4645] = {.count = 1, .reusable = false}, SHIFT(2006),
  [4647] = {.count = 1, .reusable = true}, SHIFT(1055),
  [4649] = {.count = 1, .reusable = true}, SHIFT(2006),
  [4651] = {.count = 1, .reusable = true}, SHIFT(1056),
  [4653] = {.count = 1, .reusable = false}, SHIFT(2007),
  [4655] = {.count = 1, .reusable = true}, SHIFT(2007),
  [4657] = {.count = 1, .reusable = true}, SHIFT(1057),
  [4659] = {.count = 1, .reusable = false}, SHIFT(2008),
  [4661] = {.count = 1, .reusable = true}, SHIFT(1058),
  [4663] = {.count = 1, .reusable = true}, SHIFT(2008),
  [4665] = {.count = 1, .reusable = true}, SHIFT(1059),
  [4667] = {.count = 1, .reusable = true}, SHIFT(1060),
  [4669] = {.count = 1, .reusable = true}, SHIFT(1061),
  [4671] = {.count = 1, .reusable = true}, SHIFT(1095),
  [4673] = {.count = 1, .reusable = true}, SHIFT(1064),
  [4675] = {.count = 1, .reusable = true}, SHIFT(1097),
  [4677] = {.count = 1, .reusable = true}, SHIFT(1067),
  [4679] = {.count = 1, .reusable = false}, SHIFT(2018),
  [4681] = {.count = 1, .reusable = true}, SHIFT(1070),
  [4683] = {.count = 1, .reusable = true}, SHIFT(1071),
  [4685] = {.count = 1, .reusable = false}, SHIFT(2021),
  [4687] = {.count = 1, .reusable = true}, SHIFT(2020),
  [4689] = {.count = 1, .reusable = true}, SHIFT(1072),
  [4691] = {.count = 1, .reusable = true}, SHIFT(2021),
  [4693] = {.count = 1, .reusable = false}, SHIFT(2026),
  [4695] = {.count = 1, .reusable = true}, SHIFT(2025),
  [4697] = {.count = 1, .reusable = true}, SHIFT(1073),
  [4699] = {.count = 1, .reusable = true}, SHIFT(2026),
  [4701] = {.count = 1, .reusable = true}, SHIFT(1077),
  [4703] = {.count = 1, .reusable = true}, SHIFT(1078),
  [4705] = {.count = 1, .reusable = false}, SHIFT(2027),
  [4707] = {.count = 1, .reusable = false}, SHIFT(2029),
  [4709] = {.count = 1, .reusable = true}, SHIFT(1079),
  [4711] = {.count = 1, .reusable = true}, SHIFT(2029),
  [4713] = {.count = 1, .reusable = true}, SHIFT(2028),
  [4715] = {.count = 1, .reusable = true}, SHIFT(2030),
  [4717] = {.count = 1, .reusable = false}, SHIFT(2033),
  [4719] = {.count = 1, .reusable = true}, SHIFT(2032),
  [4721] = {.count = 1, .reusable = true}, SHIFT(1080),
  [4723] = {.count = 1, .reusable = true}, SHIFT(2033),
  [4725] = {.count = 1, .reusable = true}, SHIFT(2034),
  [4727] = {.count = 1, .reusable = false}, SHIFT(2038),
  [4729] = {.count = 1, .reusable = true}, SHIFT(1081),
  [4731] = {.count = 1, .reusable = true}, SHIFT(2038),
  [4733] = {.count = 1, .reusable = true}, SHIFT(2037),
  [4735] = {.count = 1, .reusable = true}, SHIFT(1083),
  [4737] = {.count = 1, .reusable = false}, SHIFT(2039),
  [4739] = {.count = 1, .reusable = true}, SHIFT(1084),
  [4741] = {.count = 1, .reusable = true}, SHIFT(2039),
  [4743] = {.count = 1, .reusable = true}, SHIFT(2040),
  [4745] = {.count = 1, .reusable = true}, SHIFT(2041),
  [4747] = {.count = 1, .reusable = false}, SHIFT(2045),
  [4749] = {.count = 1, .reusable = true}, SHIFT(1085),
  [4751] = {.count = 1, .reusable = true}, SHIFT(2045),
  [4753] = {.count = 1, .reusable = true}, SHIFT(2044),
  [4755] = {.count = 1, .reusable = true}, SHIFT(1086),
  [4757] = {.count = 1, .reusable = false}, SHIFT(2046),
  [4759] = {.count = 1, .reusable = true}, SHIFT(1087),
  [4761] = {.count = 1, .reusable = true}, SHIFT(2046),
  [4763] = {.count = 1, .reusable = true}, SHIFT(1088),
  [4765] = {.count = 1, .reusable = false}, SHIFT(2047),
  [4767] = {.count = 1, .reusable = true}, SHIFT(2047),
  [4769] = {.count = 1, .reusable = true}, SHIFT(1089),
  [4771] = {.count = 1, .reusable = false}, SHIFT(2048),
  [4773] = {.count = 1, .reusable = true}, SHIFT(1090),
  [4775] = {.count = 1, .reusable = true}, SHIFT(2048),
  [4777] = {.count = 1, .reusable = true}, SHIFT(1091),
  [4779] = {.count = 1, .reusable = true}, SHIFT(1092),
  [4781] = {.count = 1, .reusable = true}, SHIFT(1093),
  [4783] = {.count = 1, .reusable = false}, SHIFT(2058),
  [4785] = {.count = 1, .reusable = true}, SHIFT(1099),
  [4787] = {.count = 1, .reusable = true}, SHIFT(1102),
  [4789] = {.count = 1, .reusable = true}, SHIFT(1103),
  [4791] = {.count = 1, .reusable = false}, SHIFT(2061),
  [4793] = {.count = 1, .reusable = true}, SHIFT(2060),
  [4795] = {.count = 1, .reusable = true}, SHIFT(1104),
  [4797] = {.count = 1, .reusable = true}, SHIFT(2061),
  [4799] = {.count = 1, .reusable = false}, SHIFT(2066),
  [4801] = {.count = 1, .reusable = true}, SHIFT(2065),
  [4803] = {.count = 1, .reusable = true}, SHIFT(1105),
  [4805] = {.count = 1, .reusable = true}, SHIFT(2066),
  [4807] = {.count = 1, .reusable = true}, SHIFT(1109),
  [4809] = {.count = 1, .reusable = true}, SHIFT(1110),
  [4811] = {.count = 1, .reusable = false}, SHIFT(2067),
  [4813] = {.count = 1, .reusable = false}, SHIFT(2069),
  [4815] = {.count = 1, .reusable = true}, SHIFT(1111),
  [4817] = {.count = 1, .reusable = true}, SHIFT(2069),
  [4819] = {.count = 1, .reusable = true}, SHIFT(2068),
  [4821] = {.count = 1, .reusable = true}, SHIFT(2070),
  [4823] = {.count = 1, .reusable = false}, SHIFT(2073),
  [4825] = {.count = 1, .reusable = true}, SHIFT(2072),
  [4827] = {.count = 1, .reusable = true}, SHIFT(1112),
  [4829] = {.count = 1, .reusable = true}, SHIFT(2073),
  [4831] = {.count = 1, .reusable = true}, SHIFT(2074),
  [4833] = {.count = 1, .reusable = false}, SHIFT(2078),
  [4835] = {.count = 1, .reusable = true}, SHIFT(1113),
  [4837] = {.count = 1, .reusable = true}, SHIFT(2078),
  [4839] = {.count = 1, .reusable = true}, SHIFT(2077),
  [4841] = {.count = 1, .reusable = true}, SHIFT(1115),
  [4843] = {.count = 1, .reusable = false}, SHIFT(2079),
  [4845] = {.count = 1, .reusable = true}, SHIFT(1116),
  [4847] = {.count = 1, .reusable = true}, SHIFT(2079),
  [4849] = {.count = 1, .reusable = true}, SHIFT(2080),
  [4851] = {.count = 1, .reusable = true}, SHIFT(2081),
  [4853] = {.count = 1, .reusable = false}, SHIFT(2085),
  [4855] = {.count = 1, .reusable = true}, SHIFT(1117),
  [4857] = {.count = 1, .reusable = true}, SHIFT(2085),
  [4859] = {.count = 1, .reusable = true}, SHIFT(2084),
  [4861] = {.count = 1, .reusable = true}, SHIFT(1118),
  [4863] = {.count = 1, .reusable = false}, SHIFT(2086),
  [4865] = {.count = 1, .reusable = true}, SHIFT(1119),
  [4867] = {.count = 1, .reusable = true}, SHIFT(2086),
  [4869] = {.count = 1, .reusable = true}, SHIFT(1120),
  [4871] = {.count = 1, .reusable = false}, SHIFT(2087),
  [4873] = {.count = 1, .reusable = true}, SHIFT(2087),
  [4875] = {.count = 1, .reusable = true}, SHIFT(1121),
  [4877] = {.count = 1, .reusable = false}, SHIFT(2088),
  [4879] = {.count = 1, .reusable = true}, SHIFT(1122),
  [4881] = {.count = 1, .reusable = true}, SHIFT(2088),
  [4883] = {.count = 1, .reusable = true}, SHIFT(1123),
  [4885] = {.count = 1, .reusable = true}, SHIFT(1124),
  [4887] = {.count = 1, .reusable = true}, SHIFT(1125),
  [4889] = {.count = 1, .reusable = true}, SHIFT(1159),
  [4891] = {.count = 1, .reusable = false}, SHIFT(2098),
  [4893] = {.count = 1, .reusable = true}, SHIFT(1131),
  [4895] = {.count = 1, .reusable = true}, SHIFT(1134),
  [4897] = {.count = 1, .reusable = true}, SHIFT(1135),
  [4899] = {.count = 1, .reusable = true}, SHIFT(2100),
  [4901] = {.count = 1, .reusable = false}, SHIFT(2101),
  [4903] = {.count = 1, .reusable = true}, SHIFT(1136),
  [4905] = {.count = 1, .reusable = true}, SHIFT(2101),
  [4907] = {.count = 1, .reusable = true}, SHIFT(2105),
  [4909] = {.count = 1, .reusable = false}, SHIFT(2106),
  [4911] = {.count = 1, .reusable = true}, SHIFT(1137),
  [4913] = {.count = 1, .reusable = true}, SHIFT(2106),
  [4915] = {.count = 1, .reusable = true}, SHIFT(1141),
  [4917] = {.count = 1, .reusable = true}, SHIFT(1142),
  [4919] = {.count = 1, .reusable = false}, SHIFT(2107),
  [4921] = {.count = 1, .reusable = false}, SHIFT(2109),
  [4923] = {.count = 1, .reusable = true}, SHIFT(1143),
  [4925] = {.count = 1, .reusable = true}, SHIFT(2109),
  [4927] = {.count = 1, .reusable = true}, SHIFT(2108),
  [4929] = {.count = 1, .reusable = true}, SHIFT(2110),
  [4931] = {.count = 1, .reusable = true}, SHIFT(2112),
  [4933] = {.count = 1, .reusable = false}, SHIFT(2113),
  [4935] = {.count = 1, .reusable = true}, SHIFT(1144),
  [4937] = {.count = 1, .reusable = true}, SHIFT(2113),
  [4939] = {.count = 1, .reusable = true}, SHIFT(2114),
  [4941] = {.count = 1, .reusable = false}, SHIFT(2118),
  [4943] = {.count = 1, .reusable = true}, SHIFT(1145),
  [4945] = {.count = 1, .reusable = true}, SHIFT(2118),
  [4947] = {.count = 1, .reusable = true}, SHIFT(2117),
  [4949] = {.count = 1, .reusable = true}, SHIFT(1147),
  [4951] = {.count = 1, .reusable = false}, SHIFT(2119),
  [4953] = {.count = 1, .reusable = true}, SHIFT(1148),
  [4955] = {.count = 1, .reusable = true}, SHIFT(2119),
  [4957] = {.count = 1, .reusable = true}, SHIFT(2120),
  [4959] = {.count = 1, .reusable = true}, SHIFT(2121),
  [4961] = {.count = 1, .reusable = false}, SHIFT(2125),
  [4963] = {.count = 1, .reusable = true}, SHIFT(1149),
  [4965] = {.count = 1, .reusable = true}, SHIFT(2125),
  [4967] = {.count = 1, .reusable = true}, SHIFT(2124),
  [4969] = {.count = 1, .reusable = true}, SHIFT(1150),
  [4971] = {.count = 1, .reusable = false}, SHIFT(2126),
  [4973] = {.count = 1, .reusable = true}, SHIFT(1151),
  [4975] = {.count = 1, .reusable = true}, SHIFT(2126),
  [4977] = {.count = 1, .reusable = true}, SHIFT(1152),
  [4979] = {.count = 1, .reusable = false}, SHIFT(2127),
  [4981] = {.count = 1, .reusable = true}, SHIFT(2127),
  [4983] = {.count = 1, .reusable = true}, SHIFT(1153),
  [4985] = {.count = 1, .reusable = false}, SHIFT(2128),
  [4987] = {.count = 1, .reusable = true}, SHIFT(1154),
  [4989] = {.count = 1, .reusable = true}, SHIFT(2128),
  [4991] = {.count = 1, .reusable = true}, SHIFT(1155),
  [4993] = {.count = 1, .reusable = true}, SHIFT(1156),
  [4995] = {.count = 1, .reusable = true}, SHIFT(1157),
  [4997] = {.count = 1, .reusable = true}, SHIFT(1191),
  [4999] = {.count = 1, .reusable = true}, SHIFT(1160),
  [5001] = {.count = 1, .reusable = true}, SHIFT(1193),
  [5003] = {.count = 1, .reusable = false}, SHIFT(2138),
  [5005] = {.count = 1, .reusable = true}, SHIFT(1163),
  [5007] = {.count = 1, .reusable = true}, SHIFT(1166),
  [5009] = {.count = 1, .reusable = true}, SHIFT(1167),
  [5011] = {.count = 1, .reusable = true}, SHIFT(2140),
  [5013] = {.count = 1, .reusable = false}, SHIFT(2141),
  [5015] = {.count = 1, .reusable = true}, SHIFT(1168),
  [5017] = {.count = 1, .reusable = true}, SHIFT(2141),
  [5019] = {.count = 1, .reusable = true}, SHIFT(2145),
  [5021] = {.count = 1, .reusable = false}, SHIFT(2146),
  [5023] = {.count = 1, .reusable = true}, SHIFT(1169),
  [5025] = {.count = 1, .reusable = true}, SHIFT(2146),
  [5027] = {.count = 1, .reusable = true}, SHIFT(1173),
  [5029] = {.count = 1, .reusable = true}, SHIFT(1174),
  [5031] = {.count = 1, .reusable = false}, SHIFT(2147),
  [5033] = {.count = 1, .reusable = false}, SHIFT(2149),
  [5035] = {.count = 1, .reusable = true}, SHIFT(1175),
  [5037] = {.count = 1, .reusable = true}, SHIFT(2149),
  [5039] = {.count = 1, .reusable = true}, SHIFT(2148),
  [5041] = {.count = 1, .reusable = true}, SHIFT(2150),
  [5043] = {.count = 1, .reusable = true}, SHIFT(2152),
  [5045] = {.count = 1, .reusable = false}, SHIFT(2153),
  [5047] = {.count = 1, .reusable = true}, SHIFT(1176),
  [5049] = {.count = 1, .reusable = true}, SHIFT(2153),
  [5051] = {.count = 1, .reusable = true}, SHIFT(2154),
  [5053] = {.count = 1, .reusable = false}, SHIFT(2158),
  [5055] = {.count = 1, .reusable = true}, SHIFT(1177),
  [5057] = {.count = 1, .reusable = true}, SHIFT(2158),
  [5059] = {.count = 1, .reusable = true}, SHIFT(2157),
  [5061] = {.count = 1, .reusable = true}, SHIFT(1179),
  [5063] = {.count = 1, .reusable = false}, SHIFT(2159),
  [5065] = {.count = 1, .reusable = true}, SHIFT(1180),
  [5067] = {.count = 1, .reusable = true}, SHIFT(2159),
  [5069] = {.count = 1, .reusable = true}, SHIFT(2160),
  [5071] = {.count = 1, .reusable = true}, SHIFT(2161),
  [5073] = {.count = 1, .reusable = false}, SHIFT(2165),
  [5075] = {.count = 1, .reusable = true}, SHIFT(1181),
  [5077] = {.count = 1, .reusable = true}, SHIFT(2165),
  [5079] = {.count = 1, .reusable = true}, SHIFT(2164),
  [5081] = {.count = 1, .reusable = true}, SHIFT(1182),
  [5083] = {.count = 1, .reusable = false}, SHIFT(2166),
  [5085] = {.count = 1, .reusable = true}, SHIFT(1183),
  [5087] = {.count = 1, .reusable = true}, SHIFT(2166),
  [5089] = {.count = 1, .reusable = true}, SHIFT(1184),
  [5091] = {.count = 1, .reusable = false}, SHIFT(2167),
  [5093] = {.count = 1, .reusable = true}, SHIFT(2167),
  [5095] = {.count = 1, .reusable = true}, SHIFT(1185),
  [5097] = {.count = 1, .reusable = false}, SHIFT(2168),
  [5099] = {.count = 1, .reusable = true}, SHIFT(1186),
  [5101] = {.count = 1, .reusable = true}, SHIFT(2168),
  [5103] = {.count = 1, .reusable = true}, SHIFT(1187),
  [5105] = {.count = 1, .reusable = true}, SHIFT(1188),
  [5107] = {.count = 1, .reusable = true}, SHIFT(1189),
  [5109] = {.count = 1, .reusable = true}, SHIFT(1255),
  [5111] = {.count = 1, .reusable = true}, SHIFT(1192),
  [5113] = {.count = 1, .reusable = true}, SHIFT(1257),
  [5115] = {.count = 1, .reusable = false}, SHIFT(2178),
  [5117] = {.count = 1, .reusable = true}, SHIFT(1195),
  [5119] = {.count = 1, .reusable = true}, SHIFT(1198),
  [5121] = {.count = 1, .reusable = true}, SHIFT(1199),
  [5123] = {.count = 1, .reusable = true}, SHIFT(2180),
  [5125] = {.count = 1, .reusable = false}, SHIFT(2181),
  [5127] = {.count = 1, .reusable = true}, SHIFT(1200),
  [5129] = {.count = 1, .reusable = true}, SHIFT(2181),
  [5131] = {.count = 1, .reusable = true}, SHIFT(2185),
  [5133] = {.count = 1, .reusable = false}, SHIFT(2186),
  [5135] = {.count = 1, .reusable = true}, SHIFT(1201),
  [5137] = {.count = 1, .reusable = true}, SHIFT(2186),
  [5139] = {.count = 1, .reusable = true}, SHIFT(1205),
  [5141] = {.count = 1, .reusable = true}, SHIFT(1206),
  [5143] = {.count = 1, .reusable = false}, SHIFT(2187),
  [5145] = {.count = 1, .reusable = false}, SHIFT(2189),
  [5147] = {.count = 1, .reusable = true}, SHIFT(1207),
  [5149] = {.count = 1, .reusable = true}, SHIFT(2189),
  [5151] = {.count = 1, .reusable = true}, SHIFT(2188),
  [5153] = {.count = 1, .reusable = true}, SHIFT(2190),
  [5155] = {.count = 1, .reusable = true}, SHIFT(2192),
  [5157] = {.count = 1, .reusable = false}, SHIFT(2193),
  [5159] = {.count = 1, .reusable = true}, SHIFT(1208),
  [5161] = {.count = 1, .reusable = true}, SHIFT(2193),
  [5163] = {.count = 1, .reusable = true}, SHIFT(2194),
  [5165] = {.count = 1, .reusable = false}, SHIFT(2198),
  [5167] = {.count = 1, .reusable = true}, SHIFT(1209),
  [5169] = {.count = 1, .reusable = true}, SHIFT(2198),
  [5171] = {.count = 1, .reusable = true}, SHIFT(2197),
  [5173] = {.count = 1, .reusable = true}, SHIFT(1211),
  [5175] = {.count = 1, .reusable = false}, SHIFT(2199),
  [5177] = {.count = 1, .reusable = true}, SHIFT(1212),
  [5179] = {.count = 1, .reusable = true}, SHIFT(2199),
  [5181] = {.count = 1, .reusable = true}, SHIFT(2200),
  [5183] = {.count = 1, .reusable = true}, SHIFT(2201),
  [5185] = {.count = 1, .reusable = false}, SHIFT(2205),
  [5187] = {.count = 1, .reusable = true}, SHIFT(1213),
  [5189] = {.count = 1, .reusable = true}, SHIFT(2205),
  [5191] = {.count = 1, .reusable = true}, SHIFT(2204),
  [5193] = {.count = 1, .reusable = true}, SHIFT(1214),
  [5195] = {.count = 1, .reusable = false}, SHIFT(2206),
  [5197] = {.count = 1, .reusable = true}, SHIFT(1215),
  [5199] = {.count = 1, .reusable = true}, SHIFT(2206),
  [5201] = {.count = 1, .reusable = true}, SHIFT(1216),
  [5203] = {.count = 1, .reusable = false}, SHIFT(2207),
  [5205] = {.count = 1, .reusable = true}, SHIFT(2207),
  [5207] = {.count = 1, .reusable = true}, SHIFT(1217),
  [5209] = {.count = 1, .reusable = false}, SHIFT(2208),
  [5211] = {.count = 1, .reusable = true}, SHIFT(1218),
  [5213] = {.count = 1, .reusable = true}, SHIFT(2208),
  [5215] = {.count = 1, .reusable = true}, SHIFT(1219),
  [5217] = {.count = 1, .reusable = true}, SHIFT(1220),
  [5219] = {.count = 1, .reusable = true}, SHIFT(1221),
  [5221] = {.count = 1, .reusable = true}, SHIFT(1287),
  [5223] = {.count = 1, .reusable = true}, SHIFT(1224),
  [5225] = {.count = 1, .reusable = true}, SHIFT(1289),
  [5227] = {.count = 1, .reusable = false}, SHIFT(2218),
  [5229] = {.count = 1, .reusable = true}, SHIFT(1227),
  [5231] = {.count = 1, .reusable = true}, SHIFT(1230),
  [5233] = {.count = 1, .reusable = true}, SHIFT(1231),
  [5235] = {.count = 1, .reusable = true}, SHIFT(2220),
  [5237] = {.count = 1, .reusable = false}, SHIFT(2221),
  [5239] = {.count = 1, .reusable = true}, SHIFT(1232),
  [5241] = {.count = 1, .reusable = true}, SHIFT(2221),
  [5243] = {.count = 1, .reusable = true}, SHIFT(2225),
  [5245] = {.count = 1, .reusable = false}, SHIFT(2226),
  [5247] = {.count = 1, .reusable = true}, SHIFT(1233),
  [5249] = {.count = 1, .reusable = true}, SHIFT(2226),
  [5251] = {.count = 1, .reusable = true}, SHIFT(1237),
  [5253] = {.count = 1, .reusable = true}, SHIFT(1238),
  [5255] = {.count = 1, .reusable = false}, SHIFT(2227),
  [5257] = {.count = 1, .reusable = false}, SHIFT(2229),
  [5259] = {.count = 1, .reusable = true}, SHIFT(1239),
  [5261] = {.count = 1, .reusable = true}, SHIFT(2229),
  [5263] = {.count = 1, .reusable = true}, SHIFT(2228),
  [5265] = {.count = 1, .reusable = true}, SHIFT(2230),
  [5267] = {.count = 1, .reusable = true}, SHIFT(2232),
  [5269] = {.count = 1, .reusable = false}, SHIFT(2233),
  [5271] = {.count = 1, .reusable = true}, SHIFT(1240),
  [5273] = {.count = 1, .reusable = true}, SHIFT(2233),
  [5275] = {.count = 1, .reusable = true}, SHIFT(2234),
  [5277] = {.count = 1, .reusable = false}, SHIFT(2238),
  [5279] = {.count = 1, .reusable = true}, SHIFT(1241),
  [5281] = {.count = 1, .reusable = true}, SHIFT(2238),
  [5283] = {.count = 1, .reusable = true}, SHIFT(2237),
  [5285] = {.count = 1, .reusable = true}, SHIFT(1243),
  [5287] = {.count = 1, .reusable = false}, SHIFT(2239),
  [5289] = {.count = 1, .reusable = true}, SHIFT(1244),
  [5291] = {.count = 1, .reusable = true}, SHIFT(2239),
  [5293] = {.count = 1, .reusable = true}, SHIFT(2240),
  [5295] = {.count = 1, .reusable = true}, SHIFT(2241),
  [5297] = {.count = 1, .reusable = false}, SHIFT(2245),
  [5299] = {.count = 1, .reusable = true}, SHIFT(1245),
  [5301] = {.count = 1, .reusable = true}, SHIFT(2245),
  [5303] = {.count = 1, .reusable = true}, SHIFT(2244),
  [5305] = {.count = 1, .reusable = true}, SHIFT(1246),
  [5307] = {.count = 1, .reusable = false}, SHIFT(2246),
  [5309] = {.count = 1, .reusable = true}, SHIFT(1247),
  [5311] = {.count = 1, .reusable = true}, SHIFT(2246),
  [5313] = {.count = 1, .reusable = true}, SHIFT(1248),
  [5315] = {.count = 1, .reusable = false}, SHIFT(2247),
  [5317] = {.count = 1, .reusable = true}, SHIFT(2247),
  [5319] = {.count = 1, .reusable = true}, SHIFT(1249),
  [5321] = {.count = 1, .reusable = false}, SHIFT(2248),
  [5323] = {.count = 1, .reusable = true}, SHIFT(1250),
  [5325] = {.count = 1, .reusable = true}, SHIFT(2248),
  [5327] = {.count = 1, .reusable = true}, SHIFT(1251),
  [5329] = {.count = 1, .reusable = true}, SHIFT(1252),
  [5331] = {.count = 1, .reusable = true}, SHIFT(1253),
  [5333] = {.count = 1, .reusable = true}, SHIFT(1319),
  [5335] = {.count = 1, .reusable = true}, SHIFT(1256),
  [5337] = {.count = 1, .reusable = true}, SHIFT(1320),
  [5339] = {.count = 1, .reusable = false}, SHIFT(2258),
  [5341] = {.count = 1, .reusable = true}, SHIFT(1259),
  [5343] = {.count = 1, .reusable = true}, SHIFT(1262),
  [5345] = {.count = 1, .reusable = true}, SHIFT(1263),
  [5347] = {.count = 1, .reusable = true}, SHIFT(2260),
  [5349] = {.count = 1, .reusable = false}, SHIFT(2261),
  [5351] = {.count = 1, .reusable = true}, SHIFT(1264),
  [5353] = {.count = 1, .reusable = true}, SHIFT(2261),
  [5355] = {.count = 1, .reusable = true}, SHIFT(2265),
  [5357] = {.count = 1, .reusable = false}, SHIFT(2266),
  [5359] = {.count = 1, .reusable = true}, SHIFT(1265),
  [5361] = {.count = 1, .reusable = true}, SHIFT(2266),
  [5363] = {.count = 1, .reusable = true}, SHIFT(1269),
  [5365] = {.count = 1, .reusable = true}, SHIFT(1270),
  [5367] = {.count = 1, .reusable = false}, SHIFT(2267),
  [5369] = {.count = 1, .reusable = false}, SHIFT(2269),
  [5371] = {.count = 1, .reusable = true}, SHIFT(1271),
  [5373] = {.count = 1, .reusable = true}, SHIFT(2269),
  [5375] = {.count = 1, .reusable = true}, SHIFT(2268),
  [5377] = {.count = 1, .reusable = true}, SHIFT(2270),
  [5379] = {.count = 1, .reusable = true}, SHIFT(2272),
  [5381] = {.count = 1, .reusable = false}, SHIFT(2273),
  [5383] = {.count = 1, .reusable = true}, SHIFT(1272),
  [5385] = {.count = 1, .reusable = true}, SHIFT(2273),
  [5387] = {.count = 1, .reusable = true}, SHIFT(2274),
  [5389] = {.count = 1, .reusable = false}, SHIFT(2278),
  [5391] = {.count = 1, .reusable = true}, SHIFT(1273),
  [5393] = {.count = 1, .reusable = true}, SHIFT(2278),
  [5395] = {.count = 1, .reusable = true}, SHIFT(2277),
  [5397] = {.count = 1, .reusable = true}, SHIFT(1275),
  [5399] = {.count = 1, .reusable = false}, SHIFT(2279),
  [5401] = {.count = 1, .reusable = true}, SHIFT(1276),
  [5403] = {.count = 1, .reusable = true}, SHIFT(2279),
  [5405] = {.count = 1, .reusable = true}, SHIFT(2280),
  [5407] = {.count = 1, .reusable = true}, SHIFT(2281),
  [5409] = {.count = 1, .reusable = false}, SHIFT(2285),
  [5411] = {.count = 1, .reusable = true}, SHIFT(1277),
  [5413] = {.count = 1, .reusable = true}, SHIFT(2285),
  [5415] = {.count = 1, .reusable = true}, SHIFT(2284),
  [5417] = {.count = 1, .reusable = true}, SHIFT(1278),
  [5419] = {.count = 1, .reusable = false}, SHIFT(2286),
  [5421] = {.count = 1, .reusable = true}, SHIFT(1279),
  [5423] = {.count = 1, .reusable = true}, SHIFT(2286),
  [5425] = {.count = 1, .reusable = true}, SHIFT(1280),
  [5427] = {.count = 1, .reusable = false}, SHIFT(2287),
  [5429] = {.count = 1, .reusable = true}, SHIFT(2287),
  [5431] = {.count = 1, .reusable = true}, SHIFT(1281),
  [5433] = {.count = 1, .reusable = false}, SHIFT(2288),
  [5435] = {.count = 1, .reusable = true}, SHIFT(1282),
  [5437] = {.count = 1, .reusable = true}, SHIFT(2288),
  [5439] = {.count = 1, .reusable = true}, SHIFT(1283),
  [5441] = {.count = 1, .reusable = true}, SHIFT(1284),
  [5443] = {.count = 1, .reusable = true}, SHIFT(1285),
  [5445] = {.count = 1, .reusable = true}, SHIFT(1341),
  [5447] = {.count = 1, .reusable = true}, SHIFT(1288),
  [5449] = {.count = 1, .reusable = true}, SHIFT(1342),
  [5451] = {.count = 1, .reusable = false}, SHIFT(2298),
  [5453] = {.count = 1, .reusable = true}, SHIFT(1291),
  [5455] = {.count = 1, .reusable = true}, SHIFT(1294),
  [5457] = {.count = 1, .reusable = true}, SHIFT(1295),
  [5459] = {.count = 1, .reusable = true}, SHIFT(2300),
  [5461] = {.count = 1, .reusable = false}, SHIFT(2301),
  [5463] = {.count = 1, .reusable = true}, SHIFT(1296),
  [5465] = {.count = 1, .reusable = true}, SHIFT(2301),
  [5467] = {.count = 1, .reusable = true}, SHIFT(2305),
  [5469] = {.count = 1, .reusable = false}, SHIFT(2306),
  [5471] = {.count = 1, .reusable = true}, SHIFT(1297),
  [5473] = {.count = 1, .reusable = true}, SHIFT(2306),
  [5475] = {.count = 1, .reusable = true}, SHIFT(1301),
  [5477] = {.count = 1, .reusable = true}, SHIFT(1302),
  [5479] = {.count = 1, .reusable = false}, SHIFT(2307),
  [5481] = {.count = 1, .reusable = false}, SHIFT(2309),
  [5483] = {.count = 1, .reusable = true}, SHIFT(1303),
  [5485] = {.count = 1, .reusable = true}, SHIFT(2309),
  [5487] = {.count = 1, .reusable = true}, SHIFT(2308),
  [5489] = {.count = 1, .reusable = true}, SHIFT(2310),
  [5491] = {.count = 1, .reusable = true}, SHIFT(2312),
  [5493] = {.count = 1, .reusable = false}, SHIFT(2313),
  [5495] = {.count = 1, .reusable = true}, SHIFT(1304),
  [5497] = {.count = 1, .reusable = true}, SHIFT(2313),
  [5499] = {.count = 1, .reusable = true}, SHIFT(2314),
  [5501] = {.count = 1, .reusable = false}, SHIFT(2318),
  [5503] = {.count = 1, .reusable = true}, SHIFT(1305),
  [5505] = {.count = 1, .reusable = true}, SHIFT(2318),
  [5507] = {.count = 1, .reusable = true}, SHIFT(2317),
  [5509] = {.count = 1, .reusable = true}, SHIFT(1307),
  [5511] = {.count = 1, .reusable = false}, SHIFT(2319),
  [5513] = {.count = 1, .reusable = true}, SHIFT(1308),
  [5515] = {.count = 1, .reusable = true}, SHIFT(2319),
  [5517] = {.count = 1, .reusable = true}, SHIFT(2320),
  [5519] = {.count = 1, .reusable = true}, SHIFT(2321),
  [5521] = {.count = 1, .reusable = false}, SHIFT(2325),
  [5523] = {.count = 1, .reusable = true}, SHIFT(1309),
  [5525] = {.count = 1, .reusable = true}, SHIFT(2325),
  [5527] = {.count = 1, .reusable = true}, SHIFT(2324),
  [5529] = {.count = 1, .reusable = true}, SHIFT(1310),
  [5531] = {.count = 1, .reusable = false}, SHIFT(2326),
  [5533] = {.count = 1, .reusable = true}, SHIFT(1311),
  [5535] = {.count = 1, .reusable = true}, SHIFT(2326),
  [5537] = {.count = 1, .reusable = true}, SHIFT(1312),
  [5539] = {.count = 1, .reusable = false}, SHIFT(2327),
  [5541] = {.count = 1, .reusable = true}, SHIFT(2327),
  [5543] = {.count = 1, .reusable = true}, SHIFT(1313),
  [5545] = {.count = 1, .reusable = false}, SHIFT(2328),
  [5547] = {.count = 1, .reusable = true}, SHIFT(1314),
  [5549] = {.count = 1, .reusable = true}, SHIFT(2328),
  [5551] = {.count = 1, .reusable = true}, SHIFT(1315),
  [5553] = {.count = 1, .reusable = true}, SHIFT(1316),
  [5555] = {.count = 1, .reusable = true}, SHIFT(1317),
  [5557] = {.count = 1, .reusable = true}, SHIFT(1323),
  [5559] = {.count = 1, .reusable = true}, SHIFT(2334),
  [5561] = {.count = 1, .reusable = false}, SHIFT(2335),
  [5563] = {.count = 1, .reusable = true}, SHIFT(1324),
  [5565] = {.count = 1, .reusable = true}, SHIFT(2335),
  [5567] = {.count = 1, .reusable = true}, SHIFT(2339),
  [5569] = {.count = 1, .reusable = false}, SHIFT(2340),
  [5571] = {.count = 1, .reusable = true}, SHIFT(1325),
  [5573] = {.count = 1, .reusable = true}, SHIFT(2340),
  [5575] = {.count = 1, .reusable = true}, SHIFT(1326),
  [5577] = {.count = 1, .reusable = false}, SHIFT(2342),
  [5579] = {.count = 1, .reusable = true}, SHIFT(1327),
  [5581] = {.count = 1, .reusable = true}, SHIFT(2342),
  [5583] = {.count = 1, .reusable = true}, SHIFT(2341),
  [5585] = {.count = 1, .reusable = true}, SHIFT(2343),
  [5587] = {.count = 1, .reusable = true}, SHIFT(2345),
  [5589] = {.count = 1, .reusable = false}, SHIFT(2346),
  [5591] = {.count = 1, .reusable = true}, SHIFT(1328),
  [5593] = {.count = 1, .reusable = true}, SHIFT(2346),
  [5595] = {.count = 1, .reusable = true}, SHIFT(2347),
  [5597] = {.count = 1, .reusable = false}, SHIFT(2351),
  [5599] = {.count = 1, .reusable = true}, SHIFT(1329),
  [5601] = {.count = 1, .reusable = true}, SHIFT(2351),
  [5603] = {.count = 1, .reusable = true}, SHIFT(2350),
  [5605] = {.count = 1, .reusable = false}, SHIFT(2352),
  [5607] = {.count = 1, .reusable = true}, SHIFT(1331),
  [5609] = {.count = 1, .reusable = true}, SHIFT(2352),
  [5611] = {.count = 1, .reusable = true}, SHIFT(2353),
  [5613] = {.count = 1, .reusable = true}, SHIFT(2354),
  [5615] = {.count = 1, .reusable = false}, SHIFT(2358),
  [5617] = {.count = 1, .reusable = true}, SHIFT(1332),
  [5619] = {.count = 1, .reusable = true}, SHIFT(2358),
  [5621] = {.count = 1, .reusable = true}, SHIFT(2357),
  [5623] = {.count = 1, .reusable = true}, SHIFT(1333),
  [5625] = {.count = 1, .reusable = false}, SHIFT(2359),
  [5627] = {.count = 1, .reusable = true}, SHIFT(1334),
  [5629] = {.count = 1, .reusable = true}, SHIFT(2359),
  [5631] = {.count = 1, .reusable = true}, SHIFT(1335),
  [5633] = {.count = 1, .reusable = false}, SHIFT(2360),
  [5635] = {.count = 1, .reusable = true}, SHIFT(2360),
  [5637] = {.count = 1, .reusable = true}, SHIFT(1336),
  [5639] = {.count = 1, .reusable = false}, SHIFT(2361),
  [5641] = {.count = 1, .reusable = true}, SHIFT(1337),
  [5643] = {.count = 1, .reusable = true}, SHIFT(2361),
  [5645] = {.count = 1, .reusable = true}, SHIFT(1338),
  [5647] = {.count = 1, .reusable = true}, SHIFT(1339),
  [5649] = {.count = 1, .reusable = true}, SHIFT(1340),
  [5651] = {.count = 1, .reusable = true}, SHIFT(1343),
  [5653] = {.count = 1, .reusable = true}, SHIFT(2367),
  [5655] = {.count = 1, .reusable = false}, SHIFT(2368),
  [5657] = {.count = 1, .reusable = true}, SHIFT(1344),
  [5659] = {.count = 1, .reusable = true}, SHIFT(2368),
  [5661] = {.count = 1, .reusable = true}, SHIFT(2372),
  [5663] = {.count = 1, .reusable = false}, SHIFT(2373),
  [5665] = {.count = 1, .reusable = true}, SHIFT(1345),
  [5667] = {.count = 1, .reusable = true}, SHIFT(2373),
  [5669] = {.count = 1, .reusable = true}, SHIFT(1346),
  [5671] = {.count = 1, .reusable = false}, SHIFT(2375),
  [5673] = {.count = 1, .reusable = true}, SHIFT(1347),
  [5675] = {.count = 1, .reusable = true}, SHIFT(2375),
  [5677] = {.count = 1, .reusable = true}, SHIFT(2374),
  [5679] = {.count = 1, .reusable = true}, SHIFT(2376),
  [5681] = {.count = 1, .reusable = true}, SHIFT(2378),
  [5683] = {.count = 1, .reusable = false}, SHIFT(2379),
  [5685] = {.count = 1, .reusable = true}, SHIFT(1348),
  [5687] = {.count = 1, .reusable = true}, SHIFT(2379),
  [5689] = {.count = 1, .reusable = true}, SHIFT(2380),
  [5691] = {.count = 1, .reusable = false}, SHIFT(2384),
  [5693] = {.count = 1, .reusable = true}, SHIFT(1349),
  [5695] = {.count = 1, .reusable = true}, SHIFT(2384),
  [5697] = {.count = 1, .reusable = true}, SHIFT(2383),
  [5699] = {.count = 1, .reusable = false}, SHIFT(2385),
  [5701] = {.count = 1, .reusable = true}, SHIFT(1351),
  [5703] = {.count = 1, .reusable = true}, SHIFT(2385),
  [5705] = {.count = 1, .reusable = true}, SHIFT(2386),
  [5707] = {.count = 1, .reusable = true}, SHIFT(2387),
  [5709] = {.count = 1, .reusable = false}, SHIFT(2391),
  [5711] = {.count = 1, .reusable = true}, SHIFT(1352),
  [5713] = {.count = 1, .reusable = true}, SHIFT(2391),
  [5715] = {.count = 1, .reusable = true}, SHIFT(2390),
  [5717] = {.count = 1, .reusable = true}, SHIFT(1353),
  [5719] = {.count = 1, .reusable = false}, SHIFT(2392),
  [5721] = {.count = 1, .reusable = true}, SHIFT(1354),
  [5723] = {.count = 1, .reusable = true}, SHIFT(2392),
  [5725] = {.count = 1, .reusable = true}, SHIFT(1355),
  [5727] = {.count = 1, .reusable = false}, SHIFT(2393),
  [5729] = {.count = 1, .reusable = true}, SHIFT(2393),
  [5731] = {.count = 1, .reusable = true}, SHIFT(1356),
  [5733] = {.count = 1, .reusable = false}, SHIFT(2394),
  [5735] = {.count = 1, .reusable = true}, SHIFT(1357),
  [5737] = {.count = 1, .reusable = true}, SHIFT(2394),
  [5739] = {.count = 1, .reusable = true}, SHIFT(1358),
  [5741] = {.count = 1, .reusable = true}, SHIFT(1359),
  [5743] = {.count = 1, .reusable = true}, SHIFT(1360),
  [5745] = {.count = 1, .reusable = true}, SHIFT(1369),
  [5747] = {.count = 1, .reusable = true}, SHIFT(2408),
  [5749] = {.count = 1, .reusable = true}, SHIFT(2409),
  [5751] = {.count = 1, .reusable = true}, SHIFT(1370),
  [5753] = {.count = 1, .reusable = false}, SHIFT(1369),
  [5755] = {.count = 1, .reusable = true}, SHIFT(1371),
  [5757] = {.count = 1, .reusable = true}, SHIFT(1379),
  [5759] = {.count = 1, .reusable = true}, SHIFT(1380),
  [5761] = {.count = 1, .reusable = false}, SHIFT(1380),
  [5763] = {.count = 1, .reusable = true}, SHIFT(1390),
  [5765] = {.count = 1, .reusable = true}, SHIFT(2415),
  [5767] = {.count = 1, .reusable = true}, SHIFT(1391),
  [5769] = {.count = 1, .reusable = false}, SHIFT(1390),
  [5771] = {.count = 1, .reusable = true}, SHIFT(1392),
  [5773] = {.count = 1, .reusable = true}, SHIFT(1395),
  [5775] = {.count = 1, .reusable = true}, SHIFT(1396),
  [5777] = {.count = 1, .reusable = true}, SHIFT(1399),
  [5779] = {.count = 1, .reusable = true}, SHIFT(1403),
  [5781] = {.count = 1, .reusable = false}, SHIFT(1403),
  [5783] = {.count = 1, .reusable = false}, SHIFT(2617),
  [5785] = {.count = 1, .reusable = true}, SHIFT(1409),
  [5787] = {.count = 1, .reusable = true}, SHIFT(1417),
  [5789] = {.count = 1, .reusable = true}, SHIFT(1422),
  [5791] = {.count = 1, .reusable = false}, SHIFT(1422),
  [5793] = {.count = 1, .reusable = true}, SHIFT(1423),
  [5795] = {.count = 1, .reusable = false}, SHIFT(1423),
  [5797] = {.count = 1, .reusable = true}, SHIFT(1440),
  [5799] = {.count = 1, .reusable = false}, SHIFT(1440),
  [5801] = {.count = 1, .reusable = true}, SHIFT(1442),
  [5803] = {.count = 1, .reusable = false}, SHIFT(1442),
  [5805] = {.count = 1, .reusable = true}, SHIFT(1444),
  [5807] = {.count = 1, .reusable = false}, SHIFT(1444),
  [5809] = {.count = 1, .reusable = true}, SHIFT(1445),
  [5811] = {.count = 1, .reusable = true}, SHIFT(1452),
  [5813] = {.count = 1, .reusable = true}, SHIFT(1456),
  [5815] = {.count = 1, .reusable = true}, SHIFT(1458),
  [5817] = {.count = 1, .reusable = true}, SHIFT(1468),
  [5819] = {.count = 1, .reusable = true}, SHIFT(1469),
  [5821] = {.count = 1, .reusable = true}, SHIFT(2624),
  [5823] = {.count = 1, .reusable = true}, SHIFT(2434),
  [5825] = {.count = 1, .reusable = true}, SHIFT(2626),
  [5827] = {.count = 1, .reusable = true}, SHIFT(2627),
  [5829] = {.count = 1, .reusable = true}, SHIFT(1476),
  [5831] = {.count = 1, .reusable = true}, SHIFT(2445),
  [5833] = {.count = 1, .reusable = true}, SHIFT(2446),
  [5835] = {.count = 1, .reusable = true}, SHIFT(1477),
  [5837] = {.count = 1, .reusable = false}, SHIFT(1476),
  [5839] = {.count = 1, .reusable = true}, SHIFT(1481),
  [5841] = {.count = 1, .reusable = true}, SHIFT(1482),
  [5843] = {.count = 1, .reusable = false}, SHIFT(1482),
  [5845] = {.count = 1, .reusable = true}, SHIFT(1487),
  [5847] = {.count = 1, .reusable = true}, SHIFT(2448),
  [5849] = {.count = 1, .reusable = true}, SHIFT(1488),
  [5851] = {.count = 1, .reusable = false}, SHIFT(1487),
  [5853] = {.count = 1, .reusable = true}, SHIFT(1489),
  [5855] = {.count = 1, .reusable = true}, SHIFT(1498),
  [5857] = {.count = 1, .reusable = true}, SHIFT(1522),
  [5859] = {.count = 1, .reusable = true}, SHIFT(2456),
  [5861] = {.count = 1, .reusable = true}, SHIFT(2457),
  [5863] = {.count = 1, .reusable = true}, SHIFT(1523),
  [5865] = {.count = 1, .reusable = false}, SHIFT(1522),
  [5867] = {.count = 1, .reusable = true}, SHIFT(1526),
  [5869] = {.count = 1, .reusable = true}, SHIFT(2437),
  [5871] = {.count = 1, .reusable = false}, SHIFT(2437),
  [5873] = {.count = 1, .reusable = true}, SHIFT(1531),
  [5875] = {.count = 1, .reusable = true}, SHIFT(2458),
  [5877] = {.count = 1, .reusable = true}, SHIFT(1532),
  [5879] = {.count = 1, .reusable = false}, SHIFT(1531),
  [5881] = {.count = 1, .reusable = true}, SHIFT(1533),
  [5883] = {.count = 1, .reusable = true}, SHIFT(1541),
  [5885] = {.count = 1, .reusable = true}, SHIFT(1565),
  [5887] = {.count = 1, .reusable = true}, SHIFT(2465),
  [5889] = {.count = 1, .reusable = true}, SHIFT(2466),
  [5891] = {.count = 1, .reusable = true}, SHIFT(1566),
  [5893] = {.count = 1, .reusable = false}, SHIFT(1565),
  [5895] = {.count = 1, .reusable = true}, SHIFT(1569),
  [5897] = {.count = 1, .reusable = true}, SHIFT(1574),
  [5899] = {.count = 1, .reusable = true}, SHIFT(2467),
  [5901] = {.count = 1, .reusable = true}, SHIFT(1575),
  [5903] = {.count = 1, .reusable = false}, SHIFT(1574),
  [5905] = {.count = 1, .reusable = true}, SHIFT(1576),
  [5907] = {.count = 1, .reusable = true}, SHIFT(1584),
  [5909] = {.count = 1, .reusable = true}, SHIFT(1608),
  [5911] = {.count = 1, .reusable = true}, SHIFT(2474),
  [5913] = {.count = 1, .reusable = true}, SHIFT(2475),
  [5915] = {.count = 1, .reusable = true}, SHIFT(1609),
  [5917] = {.count = 1, .reusable = false}, SHIFT(1608),
  [5919] = {.count = 1, .reusable = true}, SHIFT(1612),
  [5921] = {.count = 1, .reusable = true}, SHIFT(1617),
  [5923] = {.count = 1, .reusable = true}, SHIFT(2476),
  [5925] = {.count = 1, .reusable = true}, SHIFT(1618),
  [5927] = {.count = 1, .reusable = false}, SHIFT(1617),
  [5929] = {.count = 1, .reusable = true}, SHIFT(1619),
  [5931] = {.count = 1, .reusable = true}, SHIFT(1627),
  [5933] = {.count = 1, .reusable = true}, SHIFT(1651),
  [5935] = {.count = 1, .reusable = true}, SHIFT(2483),
  [5937] = {.count = 1, .reusable = true}, SHIFT(2484),
  [5939] = {.count = 1, .reusable = true}, SHIFT(1652),
  [5941] = {.count = 1, .reusable = false}, SHIFT(1651),
  [5943] = {.count = 1, .reusable = true}, SHIFT(1655),
  [5945] = {.count = 1, .reusable = true}, SHIFT(1660),
  [5947] = {.count = 1, .reusable = true}, SHIFT(2485),
  [5949] = {.count = 1, .reusable = true}, SHIFT(1661),
  [5951] = {.count = 1, .reusable = false}, SHIFT(1660),
  [5953] = {.count = 1, .reusable = true}, SHIFT(1662),
  [5955] = {.count = 1, .reusable = true}, SHIFT(1670),
  [5957] = {.count = 1, .reusable = true}, SHIFT(1694),
  [5959] = {.count = 1, .reusable = true}, SHIFT(2490),
  [5961] = {.count = 1, .reusable = true}, SHIFT(2491),
  [5963] = {.count = 1, .reusable = true}, SHIFT(1695),
  [5965] = {.count = 1, .reusable = false}, SHIFT(1694),
  [5967] = {.count = 1, .reusable = true}, SHIFT(1702),
  [5969] = {.count = 1, .reusable = true}, SHIFT(2492),
  [5971] = {.count = 1, .reusable = true}, SHIFT(1703),
  [5973] = {.count = 1, .reusable = false}, SHIFT(1702),
  [5975] = {.count = 1, .reusable = true}, SHIFT(1704),
  [5977] = {.count = 1, .reusable = true}, SHIFT(1711),
  [5979] = {.count = 1, .reusable = true}, SHIFT(1734),
  [5981] = {.count = 1, .reusable = true}, SHIFT(2497),
  [5983] = {.count = 1, .reusable = true}, SHIFT(2498),
  [5985] = {.count = 1, .reusable = true}, SHIFT(1735),
  [5987] = {.count = 1, .reusable = false}, SHIFT(1734),
  [5989] = {.count = 1, .reusable = true}, SHIFT(1742),
  [5991] = {.count = 1, .reusable = true}, SHIFT(2499),
  [5993] = {.count = 1, .reusable = true}, SHIFT(1743),
  [5995] = {.count = 1, .reusable = false}, SHIFT(1742),
  [5997] = {.count = 1, .reusable = true}, SHIFT(1744),
  [5999] = {.count = 1, .reusable = true}, SHIFT(1751),
  [6001] = {.count = 1, .reusable = true}, SHIFT(1774),
  [6003] = {.count = 1, .reusable = true}, SHIFT(2504),
  [6005] = {.count = 1, .reusable = true}, SHIFT(2505),
  [6007] = {.count = 1, .reusable = true}, SHIFT(1775),
  [6009] = {.count = 1, .reusable = false}, SHIFT(1774),
  [6011] = {.count = 1, .reusable = true}, SHIFT(1782),
  [6013] = {.count = 1, .reusable = true}, SHIFT(2506),
  [6015] = {.count = 1, .reusable = true}, SHIFT(1783),
  [6017] = {.count = 1, .reusable = false}, SHIFT(1782),
  [6019] = {.count = 1, .reusable = true}, SHIFT(1784),
  [6021] = {.count = 1, .reusable = true}, SHIFT(1791),
  [6023] = {.count = 1, .reusable = true}, SHIFT(1814),
  [6025] = {.count = 1, .reusable = true}, SHIFT(2511),
  [6027] = {.count = 1, .reusable = true}, SHIFT(2512),
  [6029] = {.count = 1, .reusable = true}, SHIFT(1815),
  [6031] = {.count = 1, .reusable = false}, SHIFT(1814),
  [6033] = {.count = 1, .reusable = true}, SHIFT(1822),
  [6035] = {.count = 1, .reusable = true}, SHIFT(2513),
  [6037] = {.count = 1, .reusable = true}, SHIFT(1823),
  [6039] = {.count = 1, .reusable = false}, SHIFT(1822),
  [6041] = {.count = 1, .reusable = true}, SHIFT(1824),
  [6043] = {.count = 1, .reusable = true}, SHIFT(1831),
  [6045] = {.count = 1, .reusable = true}, SHIFT(1854),
  [6047] = {.count = 1, .reusable = true}, SHIFT(2518),
  [6049] = {.count = 1, .reusable = true}, SHIFT(2519),
  [6051] = {.count = 1, .reusable = true}, SHIFT(1855),
  [6053] = {.count = 1, .reusable = false}, SHIFT(1854),
  [6055] = {.count = 1, .reusable = true}, SHIFT(1862),
  [6057] = {.count = 1, .reusable = true}, SHIFT(2520),
  [6059] = {.count = 1, .reusable = true}, SHIFT(1863),
  [6061] = {.count = 1, .reusable = false}, SHIFT(1862),
  [6063] = {.count = 1, .reusable = true}, SHIFT(1864),
  [6065] = {.count = 1, .reusable = true}, SHIFT(1871),
  [6067] = {.count = 1, .reusable = true}, SHIFT(1894),
  [6069] = {.count = 1, .reusable = true}, SHIFT(2525),
  [6071] = {.count = 1, .reusable = true}, SHIFT(2526),
  [6073] = {.count = 1, .reusable = true}, SHIFT(1895),
  [6075] = {.count = 1, .reusable = false}, SHIFT(1894),
  [6077] = {.count = 1, .reusable = true}, SHIFT(1902),
  [6079] = {.count = 1, .reusable = true}, SHIFT(2527),
  [6081] = {.count = 1, .reusable = true}, SHIFT(1903),
  [6083] = {.count = 1, .reusable = false}, SHIFT(1902),
  [6085] = {.count = 1, .reusable = true}, SHIFT(1904),
  [6087] = {.count = 1, .reusable = true}, SHIFT(1911),
  [6089] = {.count = 1, .reusable = true}, SHIFT(1934),
  [6091] = {.count = 1, .reusable = true}, SHIFT(2532),
  [6093] = {.count = 1, .reusable = true}, SHIFT(2533),
  [6095] = {.count = 1, .reusable = true}, SHIFT(1935),
  [6097] = {.count = 1, .reusable = false}, SHIFT(1934),
  [6099] = {.count = 1, .reusable = true}, SHIFT(1942),
  [6101] = {.count = 1, .reusable = true}, SHIFT(2534),
  [6103] = {.count = 1, .reusable = true}, SHIFT(1943),
  [6105] = {.count = 1, .reusable = false}, SHIFT(1942),
  [6107] = {.count = 1, .reusable = true}, SHIFT(1944),
  [6109] = {.count = 1, .reusable = true}, SHIFT(1951),
  [6111] = {.count = 1, .reusable = true}, SHIFT(1974),
  [6113] = {.count = 1, .reusable = true}, SHIFT(2539),
  [6115] = {.count = 1, .reusable = true}, SHIFT(2540),
  [6117] = {.count = 1, .reusable = true}, SHIFT(1975),
  [6119] = {.count = 1, .reusable = false}, SHIFT(1974),
  [6121] = {.count = 1, .reusable = true}, SHIFT(1982),
  [6123] = {.count = 1, .reusable = true}, SHIFT(2541),
  [6125] = {.count = 1, .reusable = true}, SHIFT(1983),
  [6127] = {.count = 1, .reusable = false}, SHIFT(1982),
  [6129] = {.count = 1, .reusable = true}, SHIFT(1984),
  [6131] = {.count = 1, .reusable = true}, SHIFT(1991),
  [6133] = {.count = 1, .reusable = true}, SHIFT(2014),
  [6135] = {.count = 1, .reusable = true}, SHIFT(2546),
  [6137] = {.count = 1, .reusable = true}, SHIFT(2547),
  [6139] = {.count = 1, .reusable = true}, SHIFT(2015),
  [6141] = {.count = 1, .reusable = false}, SHIFT(2014),
  [6143] = {.count = 1, .reusable = true}, SHIFT(2022),
  [6145] = {.count = 1, .reusable = true}, SHIFT(2548),
  [6147] = {.count = 1, .reusable = true}, SHIFT(2023),
  [6149] = {.count = 1, .reusable = false}, SHIFT(2022),
  [6151] = {.count = 1, .reusable = true}, SHIFT(2024),
  [6153] = {.count = 1, .reusable = true}, SHIFT(2031),
  [6155] = {.count = 1, .reusable = true}, SHIFT(2054),
  [6157] = {.count = 1, .reusable = true}, SHIFT(2553),
  [6159] = {.count = 1, .reusable = true}, SHIFT(2554),
  [6161] = {.count = 1, .reusable = true}, SHIFT(2055),
  [6163] = {.count = 1, .reusable = false}, SHIFT(2054),
  [6165] = {.count = 1, .reusable = true}, SHIFT(2062),
  [6167] = {.count = 1, .reusable = true}, SHIFT(2555),
  [6169] = {.count = 1, .reusable = true}, SHIFT(2063),
  [6171] = {.count = 1, .reusable = false}, SHIFT(2062),
  [6173] = {.count = 1, .reusable = true}, SHIFT(2064),
  [6175] = {.count = 1, .reusable = true}, SHIFT(2071),
  [6177] = {.count = 1, .reusable = true}, SHIFT(2094),
  [6179] = {.count = 1, .reusable = true}, SHIFT(2560),
  [6181] = {.count = 1, .reusable = true}, SHIFT(2561),
  [6183] = {.count = 1, .reusable = true}, SHIFT(2095),
  [6185] = {.count = 1, .reusable = false}, SHIFT(2094),
  [6187] = {.count = 1, .reusable = true}, SHIFT(2102),
  [6189] = {.count = 1, .reusable = true}, SHIFT(2562),
  [6191] = {.count = 1, .reusable = true}, SHIFT(2103),
  [6193] = {.count = 1, .reusable = false}, SHIFT(2102),
  [6195] = {.count = 1, .reusable = true}, SHIFT(2104),
  [6197] = {.count = 1, .reusable = true}, SHIFT(2111),
  [6199] = {.count = 1, .reusable = true}, SHIFT(2134),
  [6201] = {.count = 1, .reusable = true}, SHIFT(2567),
  [6203] = {.count = 1, .reusable = true}, SHIFT(2568),
  [6205] = {.count = 1, .reusable = true}, SHIFT(2135),
  [6207] = {.count = 1, .reusable = false}, SHIFT(2134),
  [6209] = {.count = 1, .reusable = true}, SHIFT(2142),
  [6211] = {.count = 1, .reusable = true}, SHIFT(2569),
  [6213] = {.count = 1, .reusable = true}, SHIFT(2143),
  [6215] = {.count = 1, .reusable = false}, SHIFT(2142),
  [6217] = {.count = 1, .reusable = true}, SHIFT(2144),
  [6219] = {.count = 1, .reusable = true}, SHIFT(2151),
  [6221] = {.count = 1, .reusable = true}, SHIFT(2174),
  [6223] = {.count = 1, .reusable = true}, SHIFT(2574),
  [6225] = {.count = 1, .reusable = true}, SHIFT(2575),
  [6227] = {.count = 1, .reusable = true}, SHIFT(2175),
  [6229] = {.count = 1, .reusable = false}, SHIFT(2174),
  [6231] = {.count = 1, .reusable = true}, SHIFT(2182),
  [6233] = {.count = 1, .reusable = true}, SHIFT(2576),
  [6235] = {.count = 1, .reusable = true}, SHIFT(2183),
  [6237] = {.count = 1, .reusable = false}, SHIFT(2182),
  [6239] = {.count = 1, .reusable = true}, SHIFT(2184),
  [6241] = {.count = 1, .reusable = true}, SHIFT(2191),
  [6243] = {.count = 1, .reusable = true}, SHIFT(2214),
  [6245] = {.count = 1, .reusable = true}, SHIFT(2581),
  [6247] = {.count = 1, .reusable = true}, SHIFT(2582),
  [6249] = {.count = 1, .reusable = true}, SHIFT(2215),
  [6251] = {.count = 1, .reusable = false}, SHIFT(2214),
  [6253] = {.count = 1, .reusable = true}, SHIFT(2222),
  [6255] = {.count = 1, .reusable = true}, SHIFT(2583),
  [6257] = {.count = 1, .reusable = true}, SHIFT(2223),
  [6259] = {.count = 1, .reusable = false}, SHIFT(2222),
  [6261] = {.count = 1, .reusable = true}, SHIFT(2224),
  [6263] = {.count = 1, .reusable = true}, SHIFT(2231),
  [6265] = {.count = 1, .reusable = true}, SHIFT(2254),
  [6267] = {.count = 1, .reusable = true}, SHIFT(2588),
  [6269] = {.count = 1, .reusable = true}, SHIFT(2589),
  [6271] = {.count = 1, .reusable = true}, SHIFT(2255),
  [6273] = {.count = 1, .reusable = false}, SHIFT(2254),
  [6275] = {.count = 1, .reusable = true}, SHIFT(2262),
  [6277] = {.count = 1, .reusable = true}, SHIFT(2590),
  [6279] = {.count = 1, .reusable = true}, SHIFT(2263),
  [6281] = {.count = 1, .reusable = false}, SHIFT(2262),
  [6283] = {.count = 1, .reusable = true}, SHIFT(2264),
  [6285] = {.count = 1, .reusable = true}, SHIFT(2271),
  [6287] = {.count = 1, .reusable = true}, SHIFT(2294),
  [6289] = {.count = 1, .reusable = true}, SHIFT(2595),
  [6291] = {.count = 1, .reusable = true}, SHIFT(2596),
  [6293] = {.count = 1, .reusable = true}, SHIFT(2295),
  [6295] = {.count = 1, .reusable = false}, SHIFT(2294),
  [6297] = {.count = 1, .reusable = true}, SHIFT(2302),
  [6299] = {.count = 1, .reusable = true}, SHIFT(2597),
  [6301] = {.count = 1, .reusable = true}, SHIFT(2303),
  [6303] = {.count = 1, .reusable = false}, SHIFT(2302),
  [6305] = {.count = 1, .reusable = true}, SHIFT(2304),
  [6307] = {.count = 1, .reusable = true}, SHIFT(2311),
  [6309] = {.count = 1, .reusable = true}, SHIFT(2331),
  [6311] = {.count = 1, .reusable = true}, SHIFT(2601),
  [6313] = {.count = 1, .reusable = true}, SHIFT(2602),
  [6315] = {.count = 1, .reusable = true}, SHIFT(2332),
  [6317] = {.count = 1, .reusable = false}, SHIFT(2331),
  [6319] = {.count = 1, .reusable = true}, SHIFT(2336),
  [6321] = {.count = 1, .reusable = true}, SHIFT(2603),
  [6323] = {.count = 1, .reusable = true}, SHIFT(2337),
  [6325] = {.count = 1, .reusable = false}, SHIFT(2336),
  [6327] = {.count = 1, .reusable = true}, SHIFT(2338),
  [6329] = {.count = 1, .reusable = true}, SHIFT(2344),
  [6331] = {.count = 1, .reusable = true}, SHIFT(2364),
  [6333] = {.count = 1, .reusable = true}, SHIFT(2607),
  [6335] = {.count = 1, .reusable = true}, SHIFT(2608),
  [6337] = {.count = 1, .reusable = true}, SHIFT(2365),
  [6339] = {.count = 1, .reusable = false}, SHIFT(2364),
  [6341] = {.count = 1, .reusable = true}, SHIFT(2369),
  [6343] = {.count = 1, .reusable = true}, SHIFT(2609),
  [6345] = {.count = 1, .reusable = true}, SHIFT(2370),
  [6347] = {.count = 1, .reusable = false}, SHIFT(2369),
  [6349] = {.count = 1, .reusable = true}, SHIFT(2371),
  [6351] = {.count = 1, .reusable = true}, SHIFT(2377),
  [6353] = {.count = 1, .reusable = true}, SHIFT(2629),
  [6355] = {.count = 1, .reusable = true}, SHIFT(2414),
  [6357] = {.count = 1, .reusable = true}, SHIFT(2615),
  [6359] = {.count = 1, .reusable = false}, SHIFT(2615),
  [6361] = {.count = 1, .reusable = false}, SHIFT(2417),
  [6363] = {.count = 1, .reusable = true}, SHIFT(2616),
  [6365] = {.count = 1, .reusable = false}, SHIFT(2616),
  [6367] = {.count = 1, .reusable = false}, SHIFT(2418),
  [6369] = {.count = 1, .reusable = true}, SHIFT(2419),
  [6371] = {.count = 1, .reusable = true}, SHIFT(2420),
  [6373] = {.count = 1, .reusable = false}, SHIFT(2422),
  [6375] = {.count = 1, .reusable = false}, SHIFT(2426),
  [6377] = {.count = 1, .reusable = false}, SHIFT(2430),
  [6379] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2436),
  [6382] = {.count = 2, .reusable = true}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2454),
  [6385] = {.count = 2, .reusable = false}, REDUCE(aux_sym_redirected_statement_repeat1, 2), SHIFT_REPEAT(2435),
  [6388] = {.count = 1, .reusable = true}, SHIFT(2612),
  [6390] = {.count = 1, .reusable = false}, SHIFT(2618),
  [6392] = {.count = 1, .reusable = false}, SHIFT(2620),
};

void *tree_sitter_bash_external_scanner_create(void);
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash(void) {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_word,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
